Package: bio3d
Title: Biological Structure Analysis
Version: 2.4-5
Authors@R: c(person("Barry", "Grant", role=c("aut", "cre"),
                     email="bjgrant@ucsd.edu"),
             person("Xin-Qiu", "Yao", role="aut"),
             person("Lars", "Skjaerven", role="aut"), 
             person("Julien", "Ide", role="aut"))
Author: Barry Grant [aut, cre],
  Xin-Qiu Yao [aut],
  Lars Skjaerven [aut],
  Julien Ide [aut]
VignetteBuilder: knitr
LinkingTo: Rcpp
Imports: Rcpp, parallel, grid, graphics, grDevices, stats, utils
Suggests: XML, RCurl, lattice, ncdf4, igraph, bigmemory, knitr,
        rmarkdown, testthat (>= 0.9.1), httr, msa, Biostrings
Depends: R (>= 3.1.0)
LazyData: yes
Description: Utilities to process, organize and explore protein structure,
    sequence and dynamics data. Features include the ability to read and write
    structure, sequence and dynamic trajectory data, perform sequence and structure
    database searches, data summaries, atom selection, alignment, superposition,
    rigid core identification, clustering, torsion analysis, distance matrix
    analysis, structure and sequence conservation analysis, normal mode analysis,
    principal component analysis of heterogeneous structure data, and correlation
    network analysis from normal mode and molecular dynamics data. In addition,
    various utility functions are provided to enable the statistical and graphical
    power of the R environment to work with biological sequence and structural data.
    Please refer to the URLs below for more information.
Maintainer: Barry Grant <bjgrant@ucsd.edu>
License: GPL (>= 2)
URL: http://thegrantlab.org/bio3d/,
        https://bitbucket.org/Grantlab/bio3d/
RoxygenNote: 7.1.1
NeedsCompilation: yes
Packaged: 2024-10-29 13:53:45 UTC; xyao
Repository: CRAN
Date/Publication: 2024-10-29 23:40:10 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 16:18:43 UTC; unix
Archs: bio3d.so.dSYM

Package: bio3d
Title: Biological Structure Analysis
Version: 2.4-5
Authors@R: c(person("Barry", "Grant", role=c("aut", "cre"),
                     email="bjgrant@ucsd.edu"),
             person("Xin-Qiu", "Yao", role="aut"),
             person("Lars", "Skjaerven", role="aut"), 
             person("Julien", "Ide", role="aut"))
Author: Barry Grant [aut, cre],
  Xin-Qiu Yao [aut],
  Lars Skjaerven [aut],
  Julien Ide [aut]
VignetteBuilder: knitr
LinkingTo: Rcpp
Imports: Rcpp, parallel, grid, graphics, grDevices, stats, utils
Suggests: XML, RCurl, lattice, ncdf4, igraph, bigmemory, knitr,
        rmarkdown, testthat (>= 0.9.1), httr, msa, Biostrings
Depends: R (>= 3.1.0)
LazyData: yes
Description: Utilities to process, organize and explore protein structure,
    sequence and dynamics data. Features include the ability to read and write
    structure, sequence and dynamic trajectory data, perform sequence and structure
    database searches, data summaries, atom selection, alignment, superposition,
    rigid core identification, clustering, torsion analysis, distance matrix
    analysis, structure and sequence conservation analysis, normal mode analysis,
    principal component analysis of heterogeneous structure data, and correlation
    network analysis from normal mode and molecular dynamics data. In addition,
    various utility functions are provided to enable the statistical and graphical
    power of the R environment to work with biological sequence and structural data.
    Please refer to the URLs below for more information.
Maintainer: Barry Grant <bjgrant@ucsd.edu>
License: GPL (>= 2)
URL: http://thegrantlab.org/bio3d/,
        https://bitbucket.org/Grantlab/bio3d/
RoxygenNote: 7.1.1
NeedsCompilation: yes
Packaged: 2024-10-29 13:53:45 UTC; xyao
Repository: CRAN
Date/Publication: 2024-10-29 23:40:10 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 10:32:45 UTC; unix
Archs: bio3d.so.dSYM

#exportPattern("^[[:alpha:]]+")
exportPattern("^[^\\.]")
useDynLib(bio3d)
import("graphics")
import("grDevices")
import("stats")
import("utils")
import(parallel, grid, Rcpp)
S3method(as.pdb, default)
S3method(as.pdb, mol2)
S3method(as.pdb, prmtop)
S3method(atom2ele, default)
S3method(atom2ele, pdb)
S3method(atom2mass, default)
S3method(atom2mass, pdb)
S3method(atom.select, pdb)
S3method(atom.select, mol2)
S3method(atom.select, prmtop)
S3method(atom.select, pdbs)
S3method(bhattacharyya, array)
S3method(bhattacharyya, enma)
S3method(bhattacharyya, matrix)
S3method(bhattacharyya, nma)
S3method(bhattacharyya, pca)
S3method(cmap, default)
S3method(cmap, pdb)
S3method(cmap, pdbs)
S3method(cmap, xyz)
S3method(cna, dccm)
S3method(cna, ensmb)
S3method(com, pdb)
S3method(com, xyz)
S3method(core.find, default)
S3method(core.find, pdb)
S3method(core.find, pdbs)
S3method(covsoverlap, enma)
S3method(covsoverlap, nma)
S3method(dccm, enma)
S3method(dccm, nma)
S3method(dccm, pca)
S3method(dccm, xyz)
S3method(dccm, gnm)
S3method(dccm, egnm)
S3method(dm, pdb)
S3method(dm, xyz)
S3method(dm, pdbs)
S3method(dssp, pdb)
S3method(dssp, pdbs)
S3method(dssp, xyz)
S3method(geostas, default)
S3method(geostas, enma)
S3method(geostas, nma)
S3method(geostas, pdb)
S3method(geostas, pdbs)
S3method(geostas, xyz)
S3method(pdbfit, pdb)
S3method(pdbfit, pdbs)
S3method(identify, cna)
S3method(mktrj, enma)
S3method(mktrj, nma)
S3method(mktrj, pca)
S3method(nma, pdb)
S3method(nma, pdbs)
S3method(aanma, pdb)
S3method(aanma, pdbs)
S3method(gnm, pdb)
S3method(gnm, pdbs)
S3method(pca, array)
S3method(pca, pdbs)
S3method(pca, tor)
S3method(pca, xyz)
S3method(plot, bio3d)
S3method(plot, blast)
S3method(plot, cmap)
S3method(plot, cna)
S3method(plot, ecna)
S3method(plot, cnapath)
S3method(plot, ecnapath)
S3method(plot, core)
S3method(plot, dccm)
S3method(plot, dmat)
S3method(plot, enma)
S3method(plot, fasta)
S3method(plot, fluct)
S3method(plot, geostas)
S3method(plot, hmmer)
S3method(plot, nma)
S3method(plot, pca)
S3method(plot, pca.loadings)
S3method(plot, pca.score)
S3method(plot, pca.scree)
S3method(plot, rmsip)
S3method(plot, matrix.loadings)
S3method(print, core)
S3method(print, enma)
S3method(print, fasta)
S3method(print, nma)
S3method(print, pca)
S3method(print, pdb)
S3method(print, rle2)
S3method(print, select)
S3method(print, sse)
S3method(print, xyz)
S3method(print, cna)
S3method(print, cnapath)
S3method(print, geostas)
S3method(print, mol2)
S3method(print, prmtop)
S3method(read.crd, amber)
S3method(read.crd, charmm)
S3method(rmsip, default)
S3method(rmsip, enma)
S3method(sip, default)
S3method(sip, enma)
S3method(sip, nma)
S3method(summary, pdb)
S3method(summary, cna)
S3method(summary, cnapath)
S3method(trim, pdb)
S3method(trim, mol2)
S3method(trim, pdbs)
S3method(trim, xyz)
S3method(pymol, dccm)
S3method(pymol, modes)
S3method(pymol, nma)
S3method(pymol, pca)
S3method(pymol, pdbs)
S3method(mask, dccm)
S3method(vmd, cna)
S3method(vmd, ecna)
S3method(vmd, cnapath)
S3method(vmd, ecnapath)

# Documentation

The Bio3D package for structural bioinformatics consists of sets of functions for:

- <a href="#Input/Output:">input/output</a>,
- <a href="#Sequence Analysis:">sequence analysis</a>, 
- <a href="#Structure Analysis:">structure analysis</a>,
- <a href="#Trajectory Analysis:">simulation analysis</a>,
- <a href="#Normal Mode Analysis:">normal mode analysis</a>, 
- <a href="#Correlation Network Analysis:"> correlation network analysis</a>,
- <a href="#Utilities:">format conversion and data manipulation</a>, and 
- <a href="#Graphics:">graphics and visualization.</a>. 
 
Major functions are listed below with links to further documentation that includes example code and results. 

Note that you can also get help on any particular function by using the command `?function` or `help(function)` (e.g. `help(read.pdb)`) and directly execute the example code for a given function with the command `example(function)` from within R itself. 

We also distribute a number of extended **Bio3D vignettes** that provide worked examples of using Bio3D to perform a particular type of analysis. Currently available vignettes include:

- [Installing Bio3D](http://thegrantlab.org/bio3d/articles/online/install_vignette/Bio3D_install.html)

- [Getting started with Bio3D](http://thegrantlab.org/bio3d/articles/online/intro_vignette/Bio3D_introduction.html)

- [PDB structure manipulation and analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/pdb_vignette/Bio3D_pdb.html)

- [Beginning trajectory analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/traj_vignette/Bio3D_md.html)

- [Enhanced methods for Normal Mode Analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/nma_vignette/Bio3D_nma.html)

- [Comparative sequence and structure analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/pca_vignette/Bio3D_pca.html)

- [Ensemble NMA of E.coli DHFR structures](http://thegrantlab.org/bio3d/articles/online/enma_vignettes/Bio3D_nma-dhfr-partI.html)

- [Ensemble NMA across multiple species of DHFR](http://thegrantlab.org/bio3d/articles/online/enma_vignettes/Bio3D_nma-dhfr-partII.html)

- [Protein structure network analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/cna_vignette/cna_vignette.spin.html)

- [Introduction to Ensemble Difference Distance Matrix (eDDM) Analysis](http://thegrantlab.org/bio3d/articles/online/eddm_vignette/Bio3D_eddm.spin.html)

- Online protein structure analysis with the Bio3D WebApp ( [PDF](http://thegrantlab.org/bio3d_v2/download/webapp-tutorials?download=22:bio3d-webapp-pca))

- Online Normal Mode Analysis with Bio3D WebApps ( PDF | HTML )

There is also extensive [on-line documentation](http://thegrantlab.org/bio3d/reference/) with worked examples (and their output) for all functions and a package manual (in [PDF](https://CRAN.R-project.org/package=bio3d/bio3d.pdf) format) that is a concatenation of each functions documentation (without example output). 

Note that for information on Bio3D development status or to report a bug, please refer to: https://bitbucket.org/Grantlab/bio3d 

##"io"
sd_section("Input/Output:",
           "Read and Write Common Biomolecular Data Types",
  c(
    "read.pdb",
    "read.fasta",
    "read.fasta.pdb",
    "read.ncdf",        
    "read.dcd",
    "read.crd",
    "read.pqr", 
    "read.mol2",     
    "read.all",
    "read.pdcBD",
    "read.cif",
    "read.crd.amber",
    "read.crd.charmm",
    "read.prmtop",
    "aln2html",
    "get.pdb",
    "get.seq",
    "load.enmff",
    "write.pdb", 
    "write.crd",
    "write.fasta",
    "write.ncdf",
    "write.pqr",
    "write.pir",
    "write.mol2",
    "mktrj.nma",
    "mktrj.pca",    
    "mktrj.enma",    
    "pymol",
    "vmd"
  )
)

##"sequence"
sd_section("Sequence Analysis:",
           "Do Interesting Things with Protein Sequence",
  c(    
    "consensus",
    "conserv",
    "blast.pdb",
    "hmmer",
    "pfam",
    "uniprot",
    "entropy",
    "filter.identity",
    "seqidentity",
    "motif.find",
    "pdbaln",
    "seq2aln",
    "seqaln",
    "seqaln.pair",
    "seqbind"
    )   
)

##"structure"
sd_section("Structure Analysis:",
           "Do Interesting Things with Protein Structure",
  c(    
    "angle.xyz",
    "biounit",
    "blast.pdb",
    "get.blast",
    "atom.select",
    "combine.select",
    "cmap",
    "filter.cmap",
    "core.find",
    "core.cmap",
    "com",
    "dccm",
    "filter.dccm",
    "dist.xyz",
    "dm",
    "dssp",
    "dssp.pdbs",
    "geostas",
    "mustang",
    "fit.xyz",
    "binding.site",
    "mktrj",
    "mktrj.pca",
    "overlap",
    "pca",
    "pca.xyz",
    "pca.pdbs",
    "pca.array", 
    "pca.tor",
    "dccm.pca",
    "project.pca",
    "pdbaln",
    "pdb.annotate",
    "pdb2aln",
    "pdb2aln.ind",
    "pdb2sse",
    "pdbs2sse",
    "pdbfit",
    "chain.pdb",
    "convert.pdb",
    "rgyr",
    "rmsd",
    "filter.rmsd",
    "rmsf",
    "rmsip",
    "struct.aln",
    "torsion.pdb",
    "torsion.xyz",
    "wrap.tor",
    "aa2mass",
    "aa.table",
    "atom.index",
    "atom2mass",
    "atom2ele",
    "cov.nma",
    "dccm.enma",
    "dccm.nma",
    "dccm.xyz",
    "deformation.nma",
    "fluct.nma",
    "inner.prod",
    "load.enmff",
    "mktrj.nma",
    "nma", 
    "nma.pdb",
    "nma.pdbs",
    "normalize.vector",
    "pdbs2pdb",
    "plot.enma",
    "plot.nma",
    "plot.rmsip",
    "sdENM",
    "sse.bridges",
    "view.dccm",
    "view.modes",
    "var.xyz",
    "inspect.connectivity"
    )
)


##"trajectory"
sd_section("Trajectory Analysis:",
           "Do Interesting Things with Simulation Data",
  c(    
    "angle.xyz",
    "cmap",
    "filter.cmap",
    "core.find",
    "core.map",
    "dccm",
    "dccm.pca",
    "filter.dccm",
#    "lmi",
    "dist.xyz",
    "dm",
    "dssp.xyz",
    "geostas",
    "fit.xyz",
    "mktrj",
    "mktrj.pca",
    "overlap",
    "project.pca",
    "pca.tor",
    "pca.xyz",
    "pdbaln",
    "rgyr",
    "rmsd",
    "filter.rmsd",
    "rmsf",
    "rmsip",
    "torsion.pdb",
    "torsion.xyz",
    "wrap.tor"
    )
)

##"nma"
sd_section("Normal Mode Analysis:",
           "Probe Large-Scale Protein Motions",
  c(    
    "aa2mass",
    "aa.table",
    "atom.index",
    "atom2mass",
    "atom2ele",
    "bhattacharyya",
    "cov.nma",
    "covsoverlap",
    "dccm.enma",
    "dccm.nma",
    "dccm.xyz",
    "deformation.nma",
    "geostas",
    "fluct.nma",
    "inner.prod",
    "load.enmff",
    "mktrj",
    "mktrj.nma",
    "mktrj.enma",
    "nma", 
    "nma.pdb",
    "nma.pdbs",
    "aanma",
    "aanma.pdbs",
    "gnm",
    "dccm.gnm",
    "normalize.vector",
    "pdbs2pdb",
    "plot.enma",
    "plot.nma",
    "plot.rmsip",
    "sdENM",
    "sse.bridges",
    "sip",
    "var.xyz",
    "var.pdbs",
    "view.dccm",
    "view.modes"
    )   
)

##"cna"
 sd_section("Correlation Network Analysis:",
            "Network analysis of dynamic coupling", 
  c(
      "cna",
      "cnapath",
#      "cov2dccm",
      "dccm",
#      "lmi",
      "filter.dccm",
      "cmap",
      "community.tree",
      "network.amendment",
      "view.cna",
      "view.dccm",
      "view.cnapath",
      "plot.cna",
      "print.cna",
      "identify.cna",
      "layout.cna",
      "prune.cna",
      "community.aln"
   )
 )

##"graphics"
 sd_section("Graphics:",
           "Plotting and Graphic Display",
  c(
    "bwr.colors",
    "vmd_colors",
    "mono.colors",
    "plot.bio3d",
    "plot.blast",
    "plot.cmap",
    "plot.core",
    "plot.dccm",
    "plot.dmat",
    "plot.fluct",
    "plot.geostas",
    "plot.pca",
    "plot.pca.loadings",
    "hclustplot",
    "plot.cna",
    "plot.fasta",
    "plot.hmmer",
    "plot.matrix.loadings"
    )
)

##"util"
sd_section("Utilities:",
           "Convert and Manipulate Data",
  c(
    "aa.index",
    "aa123",
    "aa2index",
    "aln2html",
    "as.fasta",
    "as.pdb",
    "as.select",
    "as.xyz",
    "atom.select",
    "combine.select",
    "atom2xyz",
    "basename.pdb",
    "bio3d-package",
    "biounit",
    "bounds",
    "bounds.sse",
    "cat.pdb",
    "check.utility",
    "clean.pdb",
    "chain.pdb",
    "convert.pdb",
    "diag.ind",
    "difference.vector",
    "gap.inspect",
    "get.blast",
    "inspect.connectivity",
    "filter.identity",
    "is.gap",
    "is.pdb",
    "is.select",
    "is.xyz",
    "is.pdbs",
    "is.mol2",
    "lbio3d",
    "mask",
    "orient.pdb",
    "pairwise",
    "plot.bio3d",
    "print.core",
    "print.cna",
    "print.fasta",
    "print.xyz",
    "print.cnapath",
    "print.enma",
    "print.geostas",
    "print.mol2",
    "print.nma",
    "print.pca",
    "print.pdb",
    "print.prmtop",
    "print.rle2",
    "print.select",
    "print.sse",
    "rle2",
    "filter.rmsd",
    "pdbseq",
    "seqbind",
    "pdbsplit",
    "store.atom",
    "trim",
    "trim.mol2",
    "trim.pdbs",
    "trim.xyz",
    "unbound",
    "vec2resno",
    "setup.ncore",
    "elements",
    "formula2mass"
    )
)

##"example"
sd_section("Example Data:",
           "Bio3d Example Data",
  c("example.data")
)
#sd_icon("Some title:",
#        "some sub-text",
#        c("pants")
#        )

###
### Example of basic molecular dynamics trajectory analysis
###
### Authors Xin-Qiu Yao
###         Lars Skjaerven
###         Barry J Grant
###
require(bio3d); require(graphics);

pause <- function() {
  cat("Press ENTER/RETURN/NEWLINE to continue.")
  readLines(n=1)
  invisible()
}

#############################################
##                                          #
## Basic analysis of HIVpr trajectory data  #
##                                          #
#############################################
pause()

# Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

# Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

# Whats in the new pdb object
print(pdb)

pause()

# How many rows (frames) and columns (coords) present in trj
dim(trj)
ncol(trj) == length(pdb$xyz)
pause()

# Trajectory Frame Superposition on Calpha atoms
ca.inds <- atom.select(pdb, elety = "CA")
xyz <- fit.xyz(fixed = pdb$xyz, mobile = trj, 
	           fixed.inds = ca.inds$xyz, 
	           mobile.inds = ca.inds$xyz)

# Root Mean Square Deviation (RMSD)
rd <- rmsd(xyz[1, ca.inds$xyz], xyz[, ca.inds$xyz])
plot(rd, typ = "l", ylab = "RMSD", xlab = "Frame No.")
points(lowess(rd), typ = "l", col = "red", lty = 2, lwd = 2)

summary(rd)
pause()

# Root Mean Squared Fluctuations (RMSF)
rf <- rmsf(xyz[, ca.inds$xyz])
plot(rf, ylab = "RMSF", xlab = "Residue Position", typ="l")

pause()

# Principal Component Analysis
pc <- pca.xyz(xyz[, ca.inds$xyz])
plot(pc, col = bwr.colors(nrow(xyz)))

pause()

# Cluster in PC space
hc <- hclust(dist(pc$z[, 1:2]))
grps <- cutree(hc, k = 2)
plot(pc, col = grps)

pause()

# Cross-Correlation Analysis
cij <- dccm(xyz[, ca.inds$xyz])
plot(cij)
## view.dccm(cij, pdb, launch = TRUE)

###
### Examples from NMA Vignette
###
### Authors Lars Skjaerven
###         Xin-Qiu Yao
###         Barry J Grant
###
require(bio3d); require(graphics);

pause <- function() {
  cat("Press ENTER/RETURN/NEWLINE to continue.")
  readLines(n=1)
  invisible()
}

#############################################
##                                          #
## Basic usage                              #
##                                          #
#############################################

### Read PDB and Calculate Normal Modes
pdb <- read.pdb("1hel")
modes <- nma(pdb)

pause()

### Print a summary
print(modes)

pause()

### Plot the nma object for a quick overview
plot(modes)

pause()

### Calculate cross-correlations
cm <- dccm(modes)

pause()

### Plot correlation map
plot(cm, sse=pdb)

pause()

### Calculate modes with force field ANM
modes.anm <- nma(pdb, ff="anm")

pause()

### Investigate modes similarity with RMSIP
r <- rmsip(modes, modes.anm)

pause()

### Plot RMSIP results
plot(r, xlab="ANM", ylab="C-alpha FF")

pause()

################################################
##                                             #
## Ensemble NMA                                #
## (requires the 'muscle' program installed)   #
##                                             #
################################################

pause()

### Set temp dir to store PDB files
tmp.dir <- tempdir()

### Download a set of DHFR structures 
ids <- c("1rx2_A", "1rx4_A", "1rg7_A", 
         "3fyv_X", "3sgy_B")



### Download and split by chain ID
raw.files <- get.pdb(ids, path=tmp.dir)

pause()

### Split PDB files by chain ID
files <- pdbsplit( raw.files, ids, path=tmp.dir)

pause()

### Align structures
pdbs <- pdbaln(files)

pause()

### View sequence identity
summary( c(seqidentity(pdbs)) )

pause()

### Calculate modes of aligned proteins
modes <- nma(pdbs)

pause()

## Print a summary
print(modes)

pause()

### Plot fluctuations
plot(modes, pdbs)

pause()

### Cluster Modes simiarlity
heatmap(1-modes$rmsip, labCol=ids)

unlink(tmp.dir)

###
### Example of PCA on a collection of PKA structures
###    and a large collection of transducin structure
###
### Authors Xin-Qiu Yao
###         Lars Skjaerven
###         Barry J Grant
###
require(bio3d); require(graphics);

pause <- function() {
  cat("Press ENTER/RETURN/NEWLINE to continue.")
  readLines(n=1)
  invisible()
}

################################################
##                                             #
## Basic PCA of related X-ray structures       #
## (requires the 'muscle' program installed)   #
##                                             #
################################################

pause()

### Set temp dir to store PDB files
tmp.dir <- tempdir()

## Specify PDB identifiers
ids <- c("1cdk_A", "3agm_A", "1cmk_E",
         "3dnd_A", "1q8w_A")

## Download PDBs
raw.files <- get.pdb(ids, path=tmp.dir)

pause()

## Split PDBs by chain ID
files <- pdbsplit(raw.files, ids, path=tmp.dir)

pause()

## Sequence/structure alignment
pdbs <- pdbaln(files)

pause()

## Find invariant core
core <- core.find(pdbs)

pause()

## Fit structures to core region
xyz <- pdbfit(pdbs, inds=core$c1A.xyz)
           ## outpath="core_fit/", full.pdbs=T, het2atom=T)

pause()

## Locate gap containing positions
gaps.pos <- gap.inspect(pdbs$xyz)

## Perform PCA on non-gap containing positions
pc.xray <- pca.xyz(xyz[,gaps.pos$f.inds])

pause()

## Plot x-ray results
plot(pc.xray)

pause()

#############################################
##                                          #
## Larger transducin example                #
##                                          #
#############################################

data(transducin)
attach(transducin, warn.conflicts=FALSE)

## data 'transducin' contains objects
## - pdbs:       aligned C-alpha coordinates for 53 transducin 
##               structures from the PDB
## - annotation: annotation of the 53 PDBs

## Note that this data can be generated from scratch by following the
## Comparative Structure Analysis with Bio3D Vignette available both
## on-line and from within the Bio3D package.

pdbs <- transducin$pdbs
annotation <- transducin$annotation

pause()

## Inspect gaps
gaps.pos <- gap.inspect(pdbs$xyz)

## Previously fitted coordinates invariance core
xyz <- pdbs$xyz

## Do PCA
pc.xray <- pca.xyz(xyz[, gaps.pos$f.inds])

pause()


## Plot overview
plot(pc.xray, col=annotation[, "color"])

## Plot atom wise loadings
plot.bio3d(pc.xray$au[,1], ylab="PC1 (A)")

pause()

unlink(tmp.dir)

###
### Example of PDB file manipulation, searching, alignment etc.
###
### Authors Xin-Qiu Yao
###         Lars Skjaerven
###         Barry J Grant
###
require(bio3d); require(graphics);

pause <- function() {
  cat("Press ENTER/RETURN/NEWLINE to continue.")
  readLines(n=1)
  invisible()
}

#############################################
##                                          #
## Basic PDB file reading and manipulation  #
##                                          #
#############################################
pause()

# Read an online RCSB Protein Data Bank structure
pdb <- read.pdb("4q21")

# Whats in the new pdb object
print(pdb)

pause()

# Most bio3d functions, including read.pdb(), return list objects
attributes(pdb)

pdb$atom[1:3, c("resno", "resid", "elety", "x", "y", "z")]

pause()

# Selection of substructure regions with 'atom.select()'' function
inds <- atom.select(pdb, elety = c("N","CA","C"), resno=4:6)

pdb$atom[inds$atom,]

pause()

# Simple B-factor plot
ca.inds <- atom.select(pdb, "calpha")
plot.bio3d( pdb$atom[ca.inds$atom,"b"], sse=pdb, ylab="B-factor")


###################################
##                                #
## Search for similar structures  #
##                                #
###################################

# Use sequence
aa <- pdbseq(pdb)
aa

pause()

# Blast the RCSB PDB to find similar sequences 
blast <- blast.pdb(aa)
head(blast$hit.tbl)

pause()

# Plot results
top.hits <- plot(blast)
head(top.hits$hits)

pause()

## Download and and analyze further ....
## raw.files <- get.pdb(top.hits$pdb.id, path="raw_hits")
## files <- pdbsplit(raw.files, top.hits$hits, path="top_hits")
## pdbs <- pdbaln(files)
## ...<ETC>...

"read.crd" <- function(file, ...) {
  ## from tools package:
  pos <- regexpr("\\.([[:alnum:]]+)$", file)
  ext <- ifelse(pos > -1L, substring(file, pos + 1L), "")

  if(ext %in% c("crd")) {
    class(file)=c("character", "charmm")
  }

  if(ext %in% c("inpcrd", "rst")) {
    class(file)=c("character", "amber")
  }

  UseMethod("read.crd", file)
}

"formula2mass" <-
  function(form, sum.mass=TRUE) {
    
    errmsg <- paste("error while parsing formula. \n",
                    " provide input on the form: 'C3 H5 N O1'")
    
    if(!is.character(form) || missing(form))
      stop(errmsg)
    
    eles <- unlist(strsplit(form, " "))
    
    mass <- c()
    for ( i in 1:length(eles) ) {
      ele <- unlist(strsplit(eles[i], ""))
      
      inds.a <- grep("[0-9]", ele)
      inds.b <- grep("[A-z]", ele)
      
      num <- paste(ele[inds.a], collapse="")
      char <- paste(ele[inds.b], collapse="")
    
      if(nchar(num)==0)
        num <- 1
      if(length(inds.a)==0)
        inds.a <- 0
      
      if(length(inds.b)==0)
        stop(errmsg)
      if(nrow(bounds(inds.a))>1 || nrow(bounds(inds.b))>1 )
        stop(errmsg)
      
      mass <- c(mass, atom2mass(char) * as.numeric(num))
    }
    
    if(sum.mass)
      mass <- sum(mass)
    
    return(mass)
  }

context("Testing atom mass functions")


test_that("atom to mass tests", {

  ## Simple test
  atom.names <- c("CA", "O", "N", "OXT")
  ##masses <- c(12.01, 16.00, 14.01, 16.00)
  masses <- c(12.0107, 15.9994, 14.0067, 15.9994)
  expect_that(atom2mass(atom.names), equals(masses, tolerance=1e-6))

  ##masses <- c(42.02, 16.00)
  masses <- c(42.0168, 15.9994)
  expect_that(as.numeric(atom2mass(atom.names, grpby=c(1,1,1,2))), 
              equals(masses, tolerance=1e-6))
  
  ## Should end with error  
  atom.names <- c("CA", "O", "N", "OXT", "CL2", "PT1")
  expect_that(atom2mass(atom.names, rescue=FALSE), throws_error())
  expect_that(atom2mass(atom.names, rescue=TRUE), gives_warning())


  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))
  
  invisible(capture.output(prot.inds <- atom.select(pdb, "protein")))
  invisible(capture.output(pdb.prot <- trim.pdb(pdb, prot.inds)))

  eletys <- pdb$atom$elety[ pdb$atom$type=="ATOM" ]
  expect_that(sum(atom2mass( eletys )), equals(13346.39, tolerance=1e-6))
  expect_that(sum(atom2mass( eletys )), equals(sum(atom2mass(pdb.prot), tolerance=1e-6)))
  expect_that(sum(atom2mass( pdb.prot )), equals(13346.39, tolerance=1e-6))
  
  ## Try center of mass at the same go
  coma <- c(-0.4991111, 20.5858389, 19.2604674)
  expect_that(c(com(pdb.prot)), equals(coma, tolerance=1e-6))
  
#  coma <- c(-0.5829897, 20.5306061, 19.1081465)
#  expect_that(com(pdb), equals(coma, tolerance=1e-6))
  
  ## Add custom masses
  atom.names <- c("CA", "O", "N", "OXT", "CL2", "PT1")
  masses <- c(12.0107, 15.9994, 14.0067, 15.9994, 35.4530, 195.0780)

  elety.cust <- data.frame(name = c("CL2","PT1"), symb = c("Cl","Pt"))
  ##mass.cust  <- data.frame(symb = c("Cl","Pt"), mass = c(35.45, 195.08))
  
  expect_that(atom2mass(atom.names, elety.custom=elety.cust),  equals(masses, tolerance=1e-6))
  
  ## mass from formula
  form <- "C5 H6 N O3"
  masses <- c(60.050,  6.048, 14.010, 48.000)
  masses <- c(60.05350, 6.04764, 14.00670, 47.99820)
  expect_that(formula2mass(form, sum.mass=FALSE),
              equals(masses, tolerance=1e-6))

  form <- "C5H6"
  expect_that(formula2mass(form), throws_error())

}
          )

"plot.nma" <-
  function(x, pch = 16, col = par("col"), cex = 0.8,
           mar = c(6, 4, 2, 2), ...) {
    
    opar <- par(no.readonly = TRUE)
    on.exit(par(opar))
    
    par(cex = cex, mar = mar)
    layout(matrix(c(1,2,3,3), 2, 2, byrow = TRUE))
    
    if(!is.null(x$frequencies)) {
      freqs <- x$frequencies
      main <- "Frequencies"
    }
    else {
      freqs <- x$force.constants
      main <- "Force constants"
    }

    if(length(freqs)>=100)
      n <- 100
    else
      n <- length(freqs)
    
    plot(x$L[1:n], type = "h", pch = pch, xlab = "Mode index",
         ylab = "", main = "Eigenvalues", col = col)

    plot(freqs[1:n], type = "h", pch = pch, xlab = "Mode index",
         ylab = "", main = main, col = col) 
    
    plot.bio3d(x$fluctuations, pch = pch, xlab = "Residue index",
         ylab = "", main = "Fluctuations", col = col, ...)
  }

filter.rmsd <- function(xyz=NULL, rmsd.mat=NULL, cutoff=0.5, fit=TRUE, verbose=TRUE,
                        inds=NULL, method="complete", ...) {

  # k<-filter.rmsd(xyz=pdbs$xyz, cutoff=0.5)
  # k<-filter.rmsd(rmsd.mat=k$rmsd.mat, cutoff=2.0)
  
  if(is.null(rmsd.mat)) {
    if(is.null(xyz))
      stop("Must provide either a 'xyz' matrix or RMSD matrix 'rmsd.mat'")
    if(is.list(xyz))
      xyz=xyz$xyz
    if(is.null(inds)) {
       gaps <- gap.inspect(xyz)
       inds <- gaps$f.inds
    }
    rmsd.mat <- rmsd( xyz, a.inds=inds, fit=fit, ... )
  }
  
  r.d  <- as.dist(rmsd.mat)
  tree <- hclust(r.d, method=method)

  h <- cutoff
  n <- nrow(tree$merge) + 1
  k <- integer(length(h))
  k <- n + 1 - apply(outer(c(tree$height, Inf), h, ">"),2, which.max)

  if(verbose)
    cat("filter.rmsd(): N clusters @ cutoff = ", k, "\n")
  
  #ans <- as.vector(.Call("R_cutree", tree$merge, k, PACKAGE = "stats"))
  ans <- as.vector(cutree(tree, k))
  
  cluster.rep <- NULL
  for(i in 1:k) {
    ind <- which(ans==i)
    if (length(ind) == 1) {
      cluster.rep <- c(cluster.rep, ind)
    } else {
      cluster.rep <- c(cluster.rep,
                     ind[ which.min( colSums(rmsd.mat[ind,ind]) ) ])
    }
  }

  return(list(ind=cluster.rep, tree=tree, rmsd.mat=rmsd.mat))
}

`pdbsplit` <-
function(pdb.files, ids=NULL, path="split_chain", overwrite=TRUE, verbose=FALSE, mk4=FALSE, ncore=1, progress=NULL, ...) {
  
  toread <- file.exists(pdb.files)
  toread[substr(pdb.files, 1, 4) == "http"] <- TRUE
  if (all(!toread)) 
    stop("No corresponding PDB files found")
  if (any(!toread)) {
    warning(paste("Missing files:\n\t",
                  paste(pdb.files[!toread], 
                        collapse = "\n\t"), sep = ""))
    pdb.files <- pdb.files[toread]
  }

  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore, bigmem = FALSE)

  if(ncore>1) {
    mylapply <- mclapply
    prev.warn <- getOption("warn")
    options(warn=1)
  }
  else
    mylapply <- lapply

  ## Faster method to fetch chain IDs in a PDB file
  "quickscan" <- function(pdbfile) {
    fi <- readLines(pdbfile)
    fi = fi[ grep("^ATOM", fi) ]
    chains <- unique(substr(fi, 22,22))
    chains[chains == " "] <- NA
    return(chains)
  }

  if(!verbose)
    ## Initialize progress bar
    pb <- .init.pb(ncore, min=0, max=length(pdb.files))

  if(!file.exists(path)) 
     dir.create(path)
  
  "splitOnePdb" <- function(i, pdb.files, ids, path, overwrite, verbose, ...) {

    ## edit for shiny version
    if(!is.null(progress)) {
      progress$inc(1/length(pdb.files))
    }
    ## edit end

    out <- c(); skipped <- c(); unused <- NULL;
    if(!overwrite && !verbose) {
      chains <- quickscan(pdb.files[i])
    }
    else if(overwrite && !verbose) {
      invisible(capture.output( pdb <- read.pdb(pdb.files[i], verbose=verbose, ...) ))
      chains <- unique(pdb$atom[, "chain"])
    }
    else {
      pdb <- read.pdb(pdb.files[i], verbose=verbose, ...)
      chains <- unique(pdb$atom[, "chain"])
    }
    
    if(!is.null(ids)) {
      ids <- unique(ids)
      
      ## Match 'ids' with 'pdbId_chainId' combinations
      tmp.names <- paste0(basename.pdb(pdb.files[i], mk4=mk4), "_", chains)

      tmp.inds <- unique(unlist(lapply(ids, grep, tmp.names)))
      if(length(tmp.inds)==0) {
        ## Skip pdb file if no match were found
        unused <- basename.pdb(pdb.files[i], mk4=mk4)

        chains <- c()
      }
      else {
        chains <- chains[tmp.inds]
      }
    }

    if(!overwrite && !verbose) {
      tmp.names <- paste0(basename.pdb(pdb.files[i], mk4=mk4),"_", chains, ".pdb") 

      new.name <- file.path(path, tmp.names)
      if(all(file.exists(new.name))) {
        out <- c(out, new.name)
        skipped <- paste(basename(pdb.files[i]), " (",
                       paste(chains, collapse=","), ")", sep="")
        return( list(out=out, unused=unused, skipped=skipped) )
      }
      else {
        if(!verbose)
          invisible(capture.output( pdb <- read.pdb(pdb.files[i], verbose=verbose, ...) ))
        else
          pdb <- read.pdb(pdb.files[i], verbose=verbose, ...)
      }
    }
    
    if (length(chains) > 0) {
      for (j in 1:length(chains)) {
        if(!verbose)
          .update.pb(pb, step=1/length(chains))
        
        ##if (!is.na(chains[j])) {
          new.pdb <- NULL
          
          sel <- atom.select(pdb, chain=chains[j], verbose=verbose) #====
          new.pdb <- trim.pdb(pdb, sel, sse=TRUE)

          ## Multi-model records
          if (nrow(pdb$xyz)>1) {
            for ( k in 1:nrow(pdb$xyz) ) {
              
              str.len <- nchar(nrow(pdb$xyz))
              new.name <- paste(basename.pdb(pdb.files[i], mk4=mk4), 
                                "_", chains[j], ".", 
                                formatC(k, width=str.len, format="d", flag="0"),
                                ".pdb", sep = "")
              new.name <- file.path(path, new.name)
              
              xyz <- pdb$xyz[k, sel$xyz]

              if(length(new.pdb$xyz) > 0) {
                write.pdb(new.pdb, file = new.name, xyz=xyz, sse=TRUE)
                out <- c(out, new.name)
              }
              else {
                warning(paste0(basename(new.name), " has 'xyz' of length zero"))
              }
            }
          }
          else {
            new.name <- paste0(basename.pdb(pdb.files[i], mk4=mk4), "_", chains[j], ".pdb") 
            new.name <- file.path(path, new.name)

            if(length(new.pdb$xyz) > 0) {
              if(!file.exists(new.name) | overwrite )
                write.pdb(new.pdb, file = new.name, sse=TRUE)
              
              out <- c(out, new.name)
            }
            else {
              warning(paste0(basename(new.name), " has 'xyz' of length zero"))
            }
          }
        ##}
      }
    }
    else {
      if(!verbose) .update.pb(pb, step=1)
    }

    gc()
    return( list(out=out, unused=unused, skipped=skipped) )
  }
  
  outdata <- mylapply(1:length(pdb.files), splitOnePdb,
                      pdb.files, ids, path, overwrite, verbose, ...)

  if(ncore>1)
    options(warn=prev.warn)
  
  ##### Collect data #####
  outfiles <- c()
  unused <- c(); skipped <- c();
  for(i in 1:length(outdata)) {
    tmp.out <- outdata[[i]]
    outfiles <- c(outfiles, tmp.out$out)
    unused <- c(unused, tmp.out$unused)
    skipped <- c(skipped, tmp.out$skipped)
  }

  if(!verbose) {
    .update.pb(pb)
    .close.pb(pb)
  }
 
  if(!is.null(ids)) {
    ids.used <- NULL; nonmatch <- NULL
    if(length(outfiles)>0) {
      ids.used <- sub(".pdb$", "", basename(outfiles))
      tmp.fun <- function(x, y) { ifelse(length(grep(x,y))>0, TRUE, FALSE) }
      tmp.inds <- unlist(lapply(ids, tmp.fun, ids.used))
      nonmatch <- ids[!tmp.inds]
    }

    ## Elements of 'pdb.files' not in use
    if(length(unused)>0) {
      unused <- paste(unused, collapse=", ")
      warning(paste("unmatched pdb files:", unused))
    }

    ## Elements of 'ids' not in use
    if(length(nonmatch)>0) {
      nonmatch <- paste(nonmatch, collapse=", ")
      warning(paste("unmatched ids:", nonmatch))
    }
  }

  if(length(skipped)>0) {
    warning(paste(skipped, collapse=", "))
  }

  return(outfiles)
}

context("Testing pdbsplit()")


test_that("pdbsplit works", {
  skip_on_cran()
  skip_on_travis()
  
  path <- tempdir()
  invisible(capture.output(
    capture.output(rawfiles <- get.pdb("3R1C", path=path), type="message")
  ))
  invisible(capture.output(files <- pdbsplit(rawfiles, ids=NULL, path=path)))
  
  expected <- c('3R1C_A.pdb', '3R1C_B.pdb', '3R1C_C.pdb', '3R1C_D.pdb',
                '3R1C_E.pdb', '3R1C_F.pdb', '3R1C_G.pdb', '3R1C_H.pdb',
                '3R1C_I.pdb', '3R1C_J.pdb', '3R1C_K.pdb', '3R1C_L.pdb',
                '3R1C_M.pdb', '3R1C_N.pdb', '3R1C_O.pdb', '3R1C_P.pdb',
                '3R1C_Q.pdb', '3R1C_R.pdb', '3R1C_S.pdb', '3R1C_Y.pdb',
                '3R1C_T.pdb', '3R1C_U.pdb', '3R1C_W.pdb', '3R1C_X.pdb',
                '3R1C_V.pdb', '3R1C_Z.pdb', '3R1C_a.pdb', '3R1C_b.pdb',
                '3R1C_c.pdb', '3R1C_d.pdb', '3R1C_e.pdb', '3R1C_f.pdb',
                '3R1C_g.pdb', '3R1C_h.pdb', '3R1C_i.pdb', '3R1C_j.pdb')
  expect_that(expected, equals(basename(files)))
  
  ids <- c('3R1C')
  invisible(capture.output(files <- pdbsplit(rawfiles, ids=ids , path=path)))
  expect_that(expected, equals(basename(files)))
  
  ids <- c('3R1C_e', '3R1C_E')
  invisible(capture.output(files <- pdbsplit(rawfiles, ids=ids , path=path)))
  expected <- c("3R1C_e.pdb", "3R1C_E.pdb")
  expect_that(expected, equals(basename(files)))

  ## ID does not exist - expect warning
  ids <- c('3R1C_XX')
  expect_warning(capture.output(files <- pdbsplit(rawfiles, ids=ids , path=path)))
  expected <- NULL
  expect_that(expected, equals(files))

  ## multi=TRUE
  invisible(capture.output(
    capture.output(rawfiles <- get.pdb("1UD7", path=path), type="message")
  ))
  invisible(capture.output(files <- pdbsplit(rawfiles, ids=NULL, path=path, multi=TRUE)))
  expected <- c('1UD7_A.01.pdb', '1UD7_A.02.pdb', '1UD7_A.03.pdb', '1UD7_A.04.pdb',
                '1UD7_A.05.pdb', '1UD7_A.06.pdb', '1UD7_A.07.pdb', '1UD7_A.08.pdb',
                '1UD7_A.09.pdb', '1UD7_A.10.pdb', '1UD7_A.11.pdb', '1UD7_A.12.pdb',
                '1UD7_A.13.pdb', '1UD7_A.14.pdb', '1UD7_A.15.pdb', '1UD7_A.16.pdb',
                '1UD7_A.17.pdb', '1UD7_A.18.pdb', '1UD7_A.19.pdb', '1UD7_A.20.pdb')
  expect_that(expected, equals(basename(files)))
  
  
  pdb <- read.pdb(files[1])
  expect_that(nrow(pdb$atom), equals(1230))


  ## non standard amino acids:
  invisible(capture.output(
    capture.output(rawfiles <- get.pdb("1cdk", path=path), type="message")
  ))
  invisible(capture.output(files <- pdbsplit(rawfiles, path=path)))
  invisible(capture.output(pdb <- read.pdb(files[1])))
  invisible(capture.output(inds <- atom.select(pdb, resno=197)$atom))

  inds.expected <- c(1568, 1569, 1570, 1571, 1572,
                     1573, 1574, 1575, 1576, 1577, 1578)
  expect_that(inds, equals(inds.expected))
  
}
          )

".nma.args" <- function(pfc.fun=NULL, ...) {

    ## Arguments to functions build.hessian and aa2mass
    bh.names <- names(formals( build.hessian ))
    am.names <- names(formals( aa2mass ))
    #rtb.names <- names(formals( rtb ))

    dots <- list(...)
    bh.args <- dots[names(dots) %in% bh.names]
    bh.args <- bh.args[ !('pfc.fun' %in% names(bh.args)) ]
    am.args <- dots[names(dots) %in% am.names]
    #rtb.args <- dots[names(dots) %in% rtb.names]

    ## Check for optional arguments to pfc.fun
    ff.names <- names(formals( pfc.fun ))
    ff.args  <- dots[names(dots) %in% ff.names]

    ## Redirect them to build.hessian
    bh.args  <- c(bh.args, ff.args)

    ## Arguments without destination
    all.names <- unique(c(bh.names, am.names, ff.names))
    if(!all(names(dots) %in% all.names)) {
      oops <- names(dots)[!(names(dots) %in% all.names)]
      stop(paste("argument mismatch:", oops))
    }

    if(length(bh.args)==0)
      bh.args=NULL
    if(length(am.args)==0)
      am.args=NULL
    #if(length(rtb.args)==0)
    #    rtb.args=NULL

    out <- list(bh.args=bh.args, am.args=am.args) #, rtb.args=rtb.args)
    return(out)
  }

## extract effective hessian for RTB approach
.nma.trim.hessian.rtb <- function(hessian, inc.inds=NULL, pdb=NULL, nmer=1) {

    if(!is.matrix(hessian))
      stop("hessian must be a matrix")
    if(is.null(inc.inds))
      return(hessian)

    if(nrow(hessian) == length(inc.inds$xyz))
      return(hessian)

    cat(" Extracting effective Hessian with RTB..")
    ptm <- proc.time()

    exc.inds <- combine.select(atom.select(pdb),
                               inc.inds, operator='-', verbose=FALSE)
    pdb <- trim(pdb, exc.inds)

    inc.inds <- inc.inds$xyz
    kaa <- hessian[inc.inds, inc.inds]
    ei <- rtb(hessian[-inc.inds, -inc.inds], pdb=pdb, mass=FALSE, nmer=nmer,
              verbose=FALSE)

    if(any(ei$values<=0)) {
      warning("Not all eigenvalues are positive!")
    }
    inds <- which(ei$values > 0)

    kaq     <- hessian[inc.inds, -inc.inds]
    kqa     <- t(kaq)
    ukqa <- crossprod(ei$vectors[, inds], kqa)
    k <- kaa - crossprod(ukqa * (1/ei$values[inds]), ukqa)

    t <- proc.time() - ptm
    cat("\tDone in", t[[3]], "seconds.\n")

    return(k)
}


## extract effective hessian
".nma.trim.hessian" <- function(hessian, inc.inds=NULL) {

  if(!is.matrix(hessian))
    stop("hessian must be a matrix")
  if(is.null(inc.inds))
    return(hessian)

  if(nrow(hessian) == length(inc.inds$xyz))
    return(hessian)

  ptm <- proc.time()
  cat(" Extracting effective Hessian..")
  inc.inds <- inc.inds$xyz

  kaa    <- hessian[inc.inds, inc.inds]
  ##kqq.inv <- solve(hessian[-inc.inds, -inc.inds])
  kqq.inv <- chol2inv(chol(hessian[-inc.inds, -inc.inds]))
  kaq     <- hessian[inc.inds, -inc.inds]
  kqa     <- t(kaq)
  ##k <- kaa - ((kaq %*% kqq.inv) %*% kqa)
  k <- kaa - crossprod(crossprod(kqq.inv, kqa), kqa)

  t <- proc.time() - ptm
  cat("\tDone in", t[[3]], "seconds.\n")
  return(k)
}

## mass-weight hessian
".nma.mwhessian" <- function(hessian, masses=NULL) {
  if(!is.matrix(hessian))
    stop("hessian must be a matrix")
  if(is.null(masses))
    stop("masses must be provided")

  #cat(" Mass weighting Hessian...")
  #ptm <- proc.time()

  dims <- dim(hessian)
  natoms <- dims[1] / 3

  if(length(masses)!=natoms)
    stop("dimension mismatch")

  masses <- sqrt(masses)
  inds <- rep(1:natoms, each=3)
  col.inds <- seq(1, ncol(hessian), by=3)

  for ( i in 1:natoms ) {
    m <- col.inds[i]
    hessian[,m:(m+2)] <- hessian[,m:(m+2)] * (1/masses[i])
    hessian[,m:(m+2)] <- hessian[,m:(m+2)] * (1/masses[inds])
  }

  #t <- proc.time() - ptm
  #cat("\tDone in", t[[3]], "seconds.\n")

  return(hessian)
}


## wrapper for generating the hessian matrix
".nma.hess" <- function(xyz, pfc.fun, args=NULL,
                        hessian=NULL, pdb=NULL) {

  natoms <- ncol(as.xyz(xyz))/3
  if(nrow(xyz)>1)
    xyz=xyz[1,,drop=FALSE]

  ## Build the Hessian Matrix
  if(is.null(hessian)) {
    cat(" Building Hessian...")
    ptm <- proc.time()
    H <- do.call('build.hessian',
                 c(list(xyz=xyz, pfc.fun=pfc.fun, pdb=pdb), args$bh.args))
    t <- proc.time() - ptm
    cat("\t\tDone in", t[[3]], "seconds.\n")
  }
  else {
    H <- hessian
  }
  return(H)
}


## diagonalize hessian
".nma.diag" <- function(H, symmetric=TRUE) {

  ## Diagonalize matrix
  cat(" Diagonalizing Hessian...")
  ptm <- proc.time()
  ei <- eigen(H, symmetric=symmetric)
  t <- proc.time() - ptm
  cat("\tDone in", t[[3]], "seconds.\n")
  return(ei)
}

## build a NMA object
".nma.finalize" <- function(ei, xyz, temp, masses, natoms, keep, call) {
  if(length(masses)>0)
    mass <- TRUE
  else
    mass <- FALSE

  xyz=as.xyz(xyz)
  dims <- dim(ei$vectors)
  dimchecks <- c(ncol(xyz)/3==natoms,
                 ifelse(mass, length(masses)==natoms, TRUE),
                 dims[1]/3==natoms)
                 #dims[2]/3==natoms)

  if(!all(dimchecks))
    stop(paste("dimension mismatch when generating nma object\n",
               paste(dimchecks, collapse=", ")))

  ## Raw eigenvalues
  ei$values <- round(ei$values, 6)

  ## Trivial modes first - sort on abs(ei$values)
  sort.inds  <- order(abs(ei$values))
  ei$values  <- ei$values[sort.inds]
  ei$vectors <- ei$vectors[, sort.inds]

  ## hard code 6 trivial modes
  triv.modes <- seq(1, 6)

  ## keep only a subset of modes - including trivial modes
   if(!is.null(keep)) {
    if(keep>ncol(ei$vectors))
      keep <- ncol(ei$vectors)
    keep.inds <- seq(1, keep)
    ei$vectors <- ei$vectors[,keep.inds]
    ei$values <- ei$values[keep.inds]
  }

    ## Frequencies are given by
    if (mass)  {
      pi <- 3.14159265359
      freq <- sqrt(abs(ei$values)) / (2 * pi)
      force.constants <- NULL
    } else {
      freq <- NULL
      force.constants <- ei$values
    }

    ## Raw unmodified eigenvectors:
    ## ei$vectors

    ## V holds the eigenvectors converted to unweighted Cartesian coords:
    V <- ei$vectors

    ## Change to non-mass-weighted eigenvectors
    if(mass) {
      wts.sqrt <- sqrt(masses)
      tri.inds <- rep(1:natoms, each=3)
      V <- apply(V, 2, '*', 1 / wts.sqrt[tri.inds])
    }

    ## Temperature scaling
    kb <- 0.00831447086363271
    if ( !is.null(temp) ) {
      if (!is.null(freq)) {
        amplitudes <- sqrt(2* temp * kb) / (2* pi * freq[ -triv.modes ])
        amplitudes <- c(rep(1,length(triv.modes)), amplitudes)
      }
      else if(!is.null(force.constants)) {
        amplitudes <- sqrt((2* temp * kb) /
                           force.constants[ -triv.modes ])
        amplitudes <- c(rep(1,length(triv.modes)), amplitudes)
      }
    } else {
      amplitudes <- rep(1, times=3*natoms)
    }

    ## Temperature scaling of eigenvectors
    for ( i in (length(triv.modes)+1):ncol(V) ) {
      V[,i] <- (V[,i] * amplitudes[i])
    }

    ## Check if first modes are zero-modes
    if(any(ei$values<0)) {
      warning("Negative eigenvalue(s) detected! \
              This can be an indication of an unphysical input structure.")
    }

    ## Output to class "nma"
    nma <- list(modes=V,
                frequencies=NULL,
                force.constants=NULL,
                fluctuations=NULL,
                U=ei$vectors, L=ei$values,

                xyz=xyz,
                mass=masses,
                temp=temp,
                triv.modes=length(triv.modes),
                natoms=natoms,
                call=call)

    if(mass) {
      class(nma) <- c("VibrationalModes", "nma")
      nma$frequencies <- freq
    }
    else {
      class(nma) <- c("EnergeticModes", "nma")
      nma$force.constants <- force.constants
    }

    ## Calculate mode fluctuations
    nma$fluctuations <- fluct.nma(nma, mode.inds=NULL)

    ## Notes:
    ## U are the raw unmodified eigenvectors
    ## These mode vectors are in mass-weighted coordinates and not
    ## scaled by the thermal amplitudes, so they are orthonormal.

    ## V holds the eigenvectors converted to unweighted Cartesian
    ## coordinates.  Unless you set temp=NULL, the modes are
    ## also scaled by the thermal fluctuation amplitudes.

    return(nma)
  }


.inds2ids <- function(pdb, inds=NULL) {
    if(!is.null(inds)) {
        paste(pdb$atom$chain[inds$atom],
              pdb$atom$resno[inds$atom],
              pdb$atom$elety[inds$atom],
              pdb$atom$insert[inds$atom], sep="_")
    }
    else {
        paste(pdb$atom$chain,
              pdb$atom$resno,
              pdb$atom$elety,
              pdb$atom$insert, sep="_")
    }
}

".match.sel" <- function(a, b, inds) {
  ## a= original pdb
  ## b= trimmed pdb
  ## inds= indices of pdb 'a' to keep
  ## find corresponding atoms in b

  ids.a <- .inds2ids(a, inds)
  ids.b <- .inds2ids(b)

  inds <- which(ids.b %in% ids.a)
  return(as.select(inds))
}


".nma.reduce.pdb" <- function(pdb) {

    pdb$atom$resid <- aa123(aa321(pdb$atom$resid))

    ## Selected side chain atoms
    ## Using whatever is furthest away from CA, including N and O atoms.
    aa.elety <- list(
        ARG = c("NH1", "NH2"),
        HIS = c("CE1", "CG"),
        LYS = c("NZ"),
        ASP = c("OD1", "OD2"),
        GLU = c("OE1", "OE2"),
        SER = c("OG"),
        THR = c("CG2", "OG1"), ## "OG1"
        ASN = c("OD1", "ND2"),
        GLN = c("NE2", "OE1"),
        CYS = c("SG"),
        ##GLY = c(),
        PRO = c("CG"),
        ALA = c("CB"),
        VAL = c("CG1", "CG2"),
        ILE = c("CD1", "CG2"),
        LEU = c("CD1", "CD2"),
        MET = c("CE"),
        PHE = c("CZ"),
        TYR = c("OH"),
        TRP = c("CH2", "NE1")
        )

    pdb <- trim(pdb, "noh")
    sele <- atom.select(pdb, elety=c("N", "CA", "C"))

    for(i in 1:length(aa.elety)) {
        resid = names(aa.elety)[i]
        elety = aa.elety[[i]]
        sele2 <- atom.select(pdb, resid = resid, elety = elety)

        if(length(sele2$atom)>0) {
            sele <- combine.select(sele, sele2, operator="OR", verbose=FALSE)
        }
    }

    #return(sele)
    return(trim(pdb, sele))

}

`blast.pdb` <-
function(seq, database="pdb", time.out=NULL, chain.single=TRUE) {
  if(inherits(seq, "fasta")) {
    if(is.matrix(seq$ali)) {
      if(nrow(seq$ali)>1)
        warning("Multiple sequences detected - using only the first sequence in input object")
      seq <- as.vector(seq$ali[1,])
    }
    else {
      seq <- as.vector(seq$ali)
    }
  }

  ## Extract sequence 'seq' from possible pdb input
  if(is.pdb(seq)) {
    seq <- pdbseq(seq)
  }

  ## Run NCBI blastp on a given 'seq' sequence against a given 'database'
  if(!is.vector(seq)) {
    stop("Input 'seq' should be a single sequence as a single or multi element character vector (as obtained from the pdbseq() function)")
  }
  seq <- paste(seq, collapse="")
  
  if( !(database %in% c("pdb", "nr", "swissprot")) )
    stop("Option database should be one of pdb, nr or swissprot")

  ##- Submit
  if(nchar(seq)>30) {
     urlput <- paste("https://blast.ncbi.nlm.nih.gov/Blast.cgi?CMD=Put&DATABASE=",
                     database,"&HITLIST_SIZE=20000&PROGRAM=blastp&CLIENT=web&QUERY=",
                     paste(seq,collapse=""),
                     sep="")
  }
  else {
    # mimic the 'Automatically adjust parameters for short input sequences' option on NCBI
    urlput <- paste("https://blast.ncbi.nlm.nih.gov/Blast.cgi?CMD=Put&DATABASE=",
                    database,"&HITLIST_SIZE=500&PROGRAM=blastp&CLIENT=web&",
                    "MATRIX=PAM30&MATRIX_NAME=PAM30&EXPECT=200000&",
                    "WORD_SIZE=2&GAPCOSTS=9 1&", "THRESHOLD=11&", 
                    "COMPOSITION_BASED_STATISTICS=0&QUERY=",
                    paste(seq,collapse=""),
                    sep="")    
  }
  
  txt <- scan(urlput, what="raw", sep="\n", quiet=TRUE)
  rid <- sub("^.*RID = " ,"",txt[ grep("RID =",txt) ])

  urlget <- paste("https://blast.ncbi.nlm.nih.gov/Blast.cgi?CMD=Get",
                  "&FORMAT_OBJECT=Alignment",
                  "&ALIGNMENT_VIEW=Tabular",
                  "&RESULTS_FILE=on",
                  "&FORMAT_TYPE=CSV",
                  "&ALIGNMENTS=20000",
                  "&DESCRIPTIONS=20000",
                  "&RID=",rid, sep="")

  blast <- get.blast(urlget, time.out = time.out, chain.single=chain.single)
  return(blast)
}

"torsion.pdb" <-
function(pdb) {

  
  colpaste <- function(x,col.names=colnames(x)) { 
    apply(x, 1, function(row) paste(row[col.names], collapse="."))
  }
  getinds <- function(atoms,ref=atom.names) {
    sort(atom2xyz(charmatch(atoms, ref)))
  }
  repadd <- function(num, nrep=nres, toadd=nxyz) {
    c(num, rep(num, (nrep-1)) +
      rep(cumsum(rep(toadd, (nrep-1))), each=length(num)))
  }

  ##-- List atoms form each residue of each chain
  atom.data <- colpaste(pdb$atom,c("elety","resno","chain"))
  atom.list <- matrix(unlist(strsplit(atom.data,"\\.")), ncol=3, byrow=TRUE)
  res.data  <- colpaste(pdb$atom,c("resno","chain", "resid", "insert"))
  res.data  <- sub(".NA", "", res.data)
  res.list  <- unique(res.data)

  atom.names <- c("N","CA","C","O","CB", "*G","*G1","*G2","*D","*D1",
                  "*D2","*E","*E1","*E2","*Z", "NH1","NH2")

  atom.greek <- c("N","CA","C","O","CB", "G","G1","G2","D","D1",
                   "D2", "E","E1","E2", "Z", "*","*")

  coords <- NULL; blank <- matrix(NA, nrow=3, ncol=length(atom.names))

  ##-- Store coords as a 3 x Natm x Nres = [xyz,atm,res] matrix
  for(i in 1:length(res.list)) {
    res.blank <- blank
    res.ind <- which(res.list[i]==res.data)

### --- Start Edit: Wed Dec  8 18:30:07 PST 2010
###    blank.ind <- charmatch(atom.list[res.ind,1], atom.names, nomatch=0) +
###      charmatch(substr(atom.list[res.ind,1],2,4), atom.greek, nomatch=0)
###
### Bug Fix for NMR structures: make sure we have no Hydrogens 
    atoms.noh <- atom.list[res.ind,1]
    atoms.noh[ grep("H",atoms.noh) ] = "H"
    
    blank.ind <- charmatch(atoms.noh, atom.names, nomatch=0) +
      charmatch(substr(atoms.noh,2,4), atom.greek, nomatch=0)
### --- End Edit
    
    res.blank[,blank.ind[blank.ind!=0]] <-
      matrix(pdb$xyz[atom2xyz(res.ind[blank.ind!=0])], nrow=3)
    coords <- cbind(coords,res.blank)
  }
  
  natm <- length(atom.names);
  nxyz <- 3*natm
  nres <- length(coords)/(nxyz)
  dim(coords) <- c(3, natm, nres)
  dimnames(coords)=list(xyz=c("x","y","z"), atm=atom.names, res=res.list)

  ##-- Torsions for selected atoms
  co <- c(coords)
  chi1  <- torsion.xyz( co[ repadd( getinds( c("N","CA","CB","*G") )) ] )
  chi11 <- torsion.xyz( co[ repadd( getinds( c("N","CA","CB","*G1") )) ])
  ###chi12 <- torsion.xyz( co[ repadd( getinds( c("N","CA","CB","*G2") )) ])

  chi2  <- torsion.xyz( co[ repadd( getinds( c("CA","CB","*G","*D") )) ])
  chi21 <- torsion.xyz( co[ repadd( getinds( c("CA","CB","*G","*D1") )) ])
  ###chi22 <- torsion.xyz( co[ repadd( getinds( c("CA","CB","*G","*D2") )) ])
  ## New catch for atom name CG1 of ILE residues 
  chi2.ILE <- torsion.xyz( co[ repadd( getinds( c("CA","CB","*G1","*D1") )) ])

  chi3  <- torsion.xyz( co[ repadd( getinds( c("CB","*G","*D","*E") )) ])
  chi31 <- torsion.xyz( co[ repadd( getinds( c("CB","*G","*D","*E1") )) ])
  ##chi32 <- torsion.xyz( co[ repadd( getinds( c("CB","*G","*D","*E2") )) ])

  chi4  <- torsion.xyz( co[ repadd( getinds( c("*G","*D","*E","*Z") )) ])

  chi51 <- torsion.xyz( co[ repadd( getinds( c("*D","*E","*Z", "NH1") )) ])
  ###chi52 <- torsion.xyz( co[ repadd( getinds( c("*D","*E","*Z", "NH2") )) ])
  
  omega <- torsion.xyz( co[ repadd( c(4:9, 52:57) ) ])
  alpha <- c(NA, torsion.xyz( co[ repadd( c(4:6,55:57,106:108,157:159) ) ]))
  phi   <- c(NA, torsion.xyz( co[ repadd( c(7:9,52:60) ) ]))
  psi   <- torsion.xyz( co[ repadd( c(1:9,52:54) ) ])
  ## alpha c("CA","CA","CA","CA")
  ## omega c("CA","C","N","CA")
  ## phi   c("C","N","CA","C")
  ## psi   c("N","CA","C","N")


##- Old Output with redundent angles (e.g. chi22 etc.).
###  out <- list(psi=psi, phi=phi[-(nres+1)], omega=omega,
###              chi1=chi1, chi11=chi11, chi12=chi12,
###              chi2=chi2, chi21=chi21, chi22=chi22,
###              chi3=chi3, chi31=chi31, chi32=chi32,
###              chi4=chi4,
###              chi51=chi51, chi52=chi52,
###              alpha=alpha[-(nres+1)], coords=coords)


  ##- New reduced output with only one chi per sidechain position  
  tor.collapse <- function(a1, a11) {
    a <- a1
    got.a11 <- !(is.na(a11))
    a[got.a11] <- a11[got.a11]
    return(a)
  }

  chi1.F <- tor.collapse(chi1, chi11)
  chi2.F <- tor.collapse(chi2, chi21)
  chi2.F <- tor.collapse(chi2.F, chi2.ILE)
  chi3.F <- tor.collapse(chi3, chi31)
  
  ## New table/matrix for output
  tbl=cbind(phi[-(nres+1)], psi, chi1.F, chi2.F, chi3.F, chi4, chi51)
  colnames(tbl) <- c("phi", "psi", "chi1", "chi2", "chi3", "chi4", "chi5")
  rownames(tbl) <- res.list
  
  out <- list(psi=psi, phi=phi[-(nres+1)], omega=omega,
              chi1=chi1.F, ##chi11=chi11, chi12=chi12,
              chi2=chi2.F, ##chi21=chi21, chi22=chi22,
              chi3=chi3.F, ##chi31=chi31, chi32=chi32,
              chi4=chi4,
              chi5=chi51, ##chi51=chi51, chi52=chi52,
              alpha=alpha[-(nres+1)], coords=coords,
              tbl=tbl )
  
}

"aa2index" <-
function (aa, index = "KYTJ820101", window = 1) {
    if (!is.vector(aa)) 
        stop("aa2index: non vector argument")
    if (!is.numeric(window) || window < 1) 
        stop("aa2index: 'window' must be numeric and positive")
    if (window >= length(aa)) 
        stop("aa2index: 'window' must be smaller than the sequence length")
     # Use LazyData to import data - changed Jul 23, 2013
#    if (!exists("aa.index")) 
#        data(aa.index)
    aa.index = bio3d::aa.index
    if (is.numeric(index)) {
        if (index > length(names(aa.index))) {
            stop("aa2index: 'index' number does not exist")
        }
    } else {
        if (!is.element(index, names(aa.index))) {
            stop("aa2index: 'index' name does not exist")
        }
    }
    x <- aa.index[[index]]$I[aa]
    if (window == 1) {
        y <- x
    } else {
        n <- length(x)
        y <- rep(NA, n)
        w <- ceiling(window/2)
        
        if ( (window %% 2) == 0 ) {
          from <- w
          to <- n - w
          y[from:to] <- sapply(from:to, function(i)
                               mean(x[(i - (w-1)):(i+w)], na.rm=TRUE))
          if (from-1 > 0) {
            y[1:(from-1)] <- sapply(1:(from-1), function(i)
                                    mean(x[1: (i + w)], na.rm=TRUE))
          }
          y[(to+1):n] <- sapply((to+1):n, function(i)
                                mean(x[(i- (w-1)): n], na.rm=TRUE))
        } else {
          from <- w
          to <- n - (w-1)
          y[from:to] <- sapply(from:to, function(i)
                               mean(x[(i - (w-1)):(i + (w-1))], na.rm=TRUE))
          y[1:(from-1)] <- sapply(1:(from-1), function(i)
                                  mean(x[1: (i + (w-1))], na.rm=TRUE))   
          y[(to+1):n] <- sapply((to+1):n, function(i)
                                mean(x[(i - (w-1)): n], na.rm=TRUE))
        }
        y <- round(y,2)
        names(y) <- aa
    }
    return(y)
}

mask <- function(...)
  UseMethod("mask")

mask.dccm <- function(dccm, pdb=NULL, a.inds=NULL, b.inds=NULL, ...) {
    x <- dccm
    dims <- dim(x)

    if(is.null(a.inds))
        stop("'a.inds' must be provided")

    if(is.null(b.inds))
        b.inds <- 1:nrow(dccm)

    if(!is.null(pdb)) {
        if(!is.pdb(pdb))
            stop("If provided, 'pdb' must be a pdb object as obtained from 'read.pdb'")

        if(nrow(pdb$atom) != dims[1])
            stop("If provided, 'pdb' must match the dimensions of 'x'")

        if(!all(pdb$atom$elety == "CA"))
            warning("Non all-CA pdb detected. Ensure that provided 'pdb' match 'x'")

        if(is.select(a.inds))
            a.inds = a.inds$atom

        if(is.select(b.inds))
            b.inds = b.inds$atom

    }
    else {
        if(is.select(a.inds) | is.select(b.inds))
            stop("a.inds/b.inds should only be a 'select' object(s) when 'pdb' is provided")
    }

    if(!is.null(a.inds)) {
        tmp <- x
        tmp[ a.inds, b.inds ] = 666
        tmp[ b.inds, a.inds ] = 666
        inds.rm <- which(tmp != 666)

        x[inds.rm] = 0
    }

    return(x)
}

basename.pdb <- function(x, mk4=FALSE, ext=".pdb") {
	##
	##- Extract PDB basename/identifier from filenames
	##   like "basename()" for PDB files
	##  E.g.:
	##       basename.pdb("/somedir/somewhere/1bg2_myfile.pdb")
	##  Will give: 1bg2_myfile
	##       basename.pdb("/somedir/somewhere/1bg2_myfile.pdb", TRUE)
        ##  Will give: 1bg2

  	y <- sub(paste0("\\", ext, "$"),"", basename(x))
  	if(mk4) { y <- substr(y,1,4) } 
	names(y) <- x
	return(y)
}

context("Testing fitting functions")


test_that("Fitting still works", {

  ## Test fit.xyz / gap.inspect 

  attach(transducin)
  inds <- unlist(lapply(c("1TAG", "1AS0", "1AS2"), grep, pdbs$id))
  pdbs <- trim.pdbs(pdbs, row.inds=inds)
  
  gaps <- gap.inspect(pdbs$xyz)

  rmsd.mat <- matrix(c(0.000, 1.792, 1.903,
                       1.792, 0.000, 1.881,
                       1.903, 1.881, 0.000),
                     ncol=3, byrow=TRUE)
  rownames(rmsd.mat) <- basename.pdb(pdbs$id)
  colnames(rmsd.mat) <- basename.pdb(pdbs$id)
  
  ## Test rmsd()
  expect_that(suppressWarnings(rmsd( pdbs )),
              equals(rmsd.mat, tolerance  = 1e-6))

  ## Test fit.xyz()
  xyz <- fit.xyz( fixed  = pdbs$xyz[1,],
                 mobile = pdbs$xyz,
                 fixed.inds  = gaps$f.inds,
                 mobile.inds = gaps$f.inds )

  x1.expected <- c(29.72513, 64.03389, 42.98273, 30.15516, 67.73641, 43.70090)
  x2.expected <- c(NA,       NA,       NA, 29.28225, 67.23703, 43.05571)
  x3.expected <- c(NA,       NA,       NA, 30.17547, 67.15645, 43.46491)
  expect_that(head(xyz[1,]), equals(x1.expected, tolerance  = 1e-6))
  expect_that(head(xyz[2,]), equals(x2.expected, tolerance  = 1e-6))
  expect_that(head(xyz[3,]), equals(x3.expected, tolerance  = 1e-6))

  
  rmsd.mat <- matrix(c(0.000, 1.659, 1.814,
                       1.659, 0.000, 1.697,
                       1.814, 1.697, 0.000),
                     ncol=3, byrow=TRUE)
  rownames(rmsd.mat) <- basename.pdb(pdbs$id)
  colnames(rmsd.mat) <- basename.pdb(pdbs$id)

  expect_that(suppressWarnings(rmsd( xyz[, gaps$f.inds] )),
              equals(rmsd.mat, tolerance  = 1e-6))

  expect_that(suppressWarnings(rmsd( pdbs, fit=TRUE )),
              equals(rmsd.mat, tolerance  = 1e-6))

  xyz2 <- fit.xyz( fixed  = pdbs$xyz[1,],
                  mobile = pdbs,
                  fixed.inds  = gaps$f.inds,
                  mobile.inds = gaps$f.inds )
  expect_that(xyz2, equals(xyz))

  detach(transducin)
}
)


test_that("struct.aln still works", {
  skip_on_cran()
  skip_on_travis()

  if(!check.utility('muscle')) {
     skip('Need MUSCLE installed to run this test')
  }

  ## Simple test with PDB ID 1HEL
  file.a <- system.file("examples/1hel.pdb",package="bio3d")
  file.b <- system.file("examples/1dpx.pdb",package="bio3d")
  invisible(capture.output(pdb.a <- read.pdb(file.a)))
  invisible(capture.output(pdb.b <- read.pdb(file.b)))
  
  invisible(capture.output(aln <- struct.aln(pdb.a, pdb.b, write.pdbs=FALSE,
                                            cutoff=0.1, max.cycles=2, extra.args="-quiet")))
  rmsda <- c(0.293, 0.229, 0.200)
  
  expect_that(aln$rmsd, equals(rmsda, tolerance  = 1e-6))
  expect_that(length(aln$a.inds$atom), equals(112))
  expect_that(length(aln$b.inds$atom), equals(112))
  expect_that(length(aln$b.inds$xyz), equals(112*3))
  expect_that(length(aln$b.inds$xyz), equals(112*3))
}
)

# A little bit more tests...
test_that("fit.xyz() gets the same results as VMD", {
   skip_on_cran()
   skip_on_travis()

   if(!check.utility('muscle')) {
      skip('Need MUSCLE installed to run this test')
   }

   invisible(capture.output(
     capture.output(pdbs <- pdbaln(c("1tag", "1as0")), type="message"))
   )
   inds <- gap.inspect(pdbs$xyz)$f.inds

   expect_error(fit.xyz("string", pdbs$xyz, inds, inds)) 
   expect_error(fit.xyz(pdbs$xyz, pdbs$xyz, inds, inds))
   expect_error(fit.xyz(pdbs$xyz[1,], pdbs$xyz, inds, 1:4))

   xyz <- fit.xyz(pdbs$xyz[1,], pdbs$xyz[2,], inds, inds)
   xyz <- xyz[!is.na(xyz)]
   xyz0 <- c(41.063, 15.667, 58.826, 43.041, 17.479, 56.113,
             44.826, 15.317, 53.571) # VMD results

   expect_equal(round(xyz[1:9], 3), xyz0)
})

test_that("fit.xyz() with ncore>1 works properly", {
   skip_on_cran()
   skip_on_travis()

   attach(transducin)
   inds <- unlist(lapply(c("1TAG", "1AS0", "1AS2"), grep, pdbs$id))
   pdbs <- trim.pdbs(pdbs, row.inds=inds)
   
   #invisible(capture.output(pdbs <- pdbaln(c("1tag", "1as0", "1as2"))))
   #inds <- gap.inspect(pdbs$xyz)$f.inds

   # check if ncore > 1 is really faster 
   time1 <- system.time(xyz1 <- fit.xyz(pdbs$xyz[1,], pdbs$xyz, inds, inds, ncore=1))
   time2 <- system.time(xyz2 <- fit.xyz(pdbs$xyz[1,], pdbs$xyz, inds, inds, ncore=NULL))
   time1 <- time1["elapsed"]
   time2 <- time2["elapsed"]

   expect_equivalent(xyz1, xyz2)

#   cat("Speed up by", round((time1-time2)/time2, 1)*100, "%", sep="")
#   if(getOption("cores") > 1)
#      expect_true(time1 > time2)

   detach(transducin)
})

"pca.xyz" <-
function(xyz, subset = rep(TRUE, nrow(as.matrix(xyz))), use.svd = FALSE,
         rm.gaps=FALSE, mass = NULL, ...) {
  ## Performs principal components analysis on the given "xyz" numeric data
  ## matrix and return the results as an object of class "pca.xyz"

  ## Log the call
  cl <- match.call()
  xyz <- as.xyz(xyz)

  if (any(!is.finite(xyz))) {
    ## Check for GAP positions in input
    if(rm.gaps) {
       gapC <- colSums(is.na(xyz)) == 0
      if (sum(gapC) > 3) {
        xyz <- xyz[,gapC]
        cat(paste("NOTE: Removing", sum(!gapC)/3, "gap positions with missing coordinate data\n",
            "     retaining", sum(gapC)/3, "non-gap positions for analysis.\n"))
      } else {
        stop("No non-gap containing positions (cols) available for analysis.")
      }
    } else {
       stop( paste("  Infinite or missing values in 'xyz' input.",
      "\t Likely solution is to remove gap positions (cols) with rm.gaps=TRUE",
      "\t or remove gap containing structures (rows) from input.", sep="\n") )
    }
  }

  dx <- dim(xyz)
  n <- dx[1]; p <- dx[2]
  if (!n || !p)
    stop("0 extent dimensions")
 
  # for mass-weighted PCA
  if(!is.null(mass)) {
     if(is.pdb(mass)) mass = aa2mass(mass)
     if(length(mass) != ncol(xyz)/3)
        stop("Input mass vector does not match xyz")
     q = t( t(xyz) * rep(sqrt(mass), each=3) )  # mass weighted xyz

     # re-do fitting: iteratively fit to the mean
     mean <- colMeans(q[subset, ])
     tolerance = 1.0 # convergence check
     maxiter = 10    # maximum number of iteration
     iter = 0
     repeat {
        q <- fit.xyz(mean, q, 1:ncol(q), 1:ncol(q), ...)
        mean.now <- colMeans(q[subset, ])
        mean.diff <- rmsd(mean, mean.now, 1:ncol(q), 1:ncol(q))
        mean = mean.now
        iter = iter + 1
        if(iter >= maxiter || mean.diff <= tolerance) break
     }
     if(mean.diff > tolerance) warning("Iteration stops before convergent")
     xyz <- q
  }
 
#  mean <- apply(xyz[subset,],2,mean) ## mean structure
  mean <- colMeans(xyz[subset,]) ## Faster
  n <- sum(subset) 
  
  # Check number of columns
  if(p > 3000 && n <= 0.4*p && !use.svd) {
     cat("NOTE: In input xyz (MxN),  N > 3000 and M < N\n",
         "     Singular Value Decomposition (SVD) approach is faster\n",
         "     and is recommended (set 'use.svd = TRUE')\n\n", sep=" ")
     flush(stdout())
  }
     
  if(!use.svd) {   
     S    <- var(xyz[subset,])          ## coverance matrix
   
     ## eigenvectors ("U") & eigenvalues ("L"): [ U'SU=L ]
     prj  <- eigen(S, symmetric = TRUE)
     L <- prj$values
     U <- prj$vectors
  } else {
     if(n < p)
        warning(paste("In input xyz (MxN), M < N:\n",
           "   Only",n,"eigenvalues and eigenvectors are returned!\n\n"))

     ## S = Q'Q, Q = UDV'
     Q <- t(t(xyz[subset,]) - mean) / sqrt(n-1)
     prj <- svd(Q)
     L <- prj$d^2
     U <- prj$v
  }

  ## fix negative eigenvalues
  ## (these are very small numbers and should be zero)
  L[L<0]<-0
  sdev <- sqrt(L)

  ## scores of "xyz" on the pc's [ z=U'[x-x.mean] ]
  z <- sweep(xyz,2,mean) %*% (U)

  ## atom-wise loadings (norm of xyz eigenvectors)
  ## Skip the calculation if the input is not xyz coordinates,
  ## e.g. for PCA over correlaiton matrices (see pca.array()).
  if(ncol(U) %% 3 == 0) { 
     au <- apply(U, 2, function(x) {
       sqrt(colSums(matrix(x^2, nrow=3))) })
  } else {
     au <- NULL
  }
  
  class(U)="pca.loadings"

  if(!is.null(mass)) {
     mean = mean / sqrt(rep(mass, each=3))
     out <- list(L=L, U=U, z=z, au=au,
              sdev=sdev, mean=mean, mass=mass, call=cl)
  }
  else
     out <- list(L=L, U=U, z=z, au=au,
              sdev=sdev, mean=mean, call=cl)

  class(out)="pca"; out
}

context("Testing dccm functions")


test_that("Correlation matrix from NMA", {

  ## Calculate correl mat on a small protein
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))

  invisible(capture.output(modes <- nma(pdb)))
  invisible(capture.output(cm <- dccm.nma(modes, ncore=1)))
  
  expect_that(cm[1,1], equals(1,           tolerance=1e-6))
  expect_that(cm[1,2], equals(0.4380029,  tolerance=1e-6))
  expect_that(cm[1,3], equals(0.1407395, tolerance=1e-6))
  expect_that(cm[1,3], equals(cm[3,1]))
  expect_that(sum(cm), equals(57.71768, tolerance=1e-6))

  ## Check multicore DCCM  
  invisible(capture.output(cm.mc <- dccm.nma(modes, ncore=NULL)))
  expect_that(cm, equals(cm.mc, tolerance=1e-6))
  
}
          )

test_that("Correlation matrix from XYZ (dccm.xyz)", {
  skip_on_cran()
  ## Calculate correl mat on a short HIV protease simulation
  trjfile <- system.file("examples/hivp.dcd", package="bio3d")
  invisible(capture.output(trj <- read.dcd(trjfile)))
  invisible(capture.output(cm <- dccm(trj, ncore=1)))
  
  expect_that(cm[1,1], equals(1,           tolerance=1e-6))
  expect_that(cm[1,2], equals(0.997,  tolerance=1e-3))
  expect_that(cm[1,3], equals(0.992, tolerance=1e-3))
  expect_that(cm[1,3], equals(cm[3,1]))

  ## Check multicore DCCM
  skip_on_travis()

  invisible(capture.output(cm.mc <- dccm(trj, ncore=NULL)))
  expect_that(cm, equals(cm.mc, tolerance=1e-6))
  
})

test_that("Correlation matrix from PCA (dccm.pca)", {
  skip_on_cran()
  ## Calculate correl mat on a short HIV protease simulation
  trjfile <- system.file("examples/hivp.dcd", package="bio3d")
  invisible(capture.output(trj <- read.dcd(trjfile)))
  invisible(capture.output(xyz <- fit.xyz(trj[1, ], trj[1:20, ], 1:ncol(trj), 1:ncol(trj)) )) 
  invisible(capture.output(pca <- pca.xyz(xyz)))
  invisible(capture.output(cm <- dccm(pca, ncore = 1)))
  pca$z <- NULL
  invisible(capture.output(cm2 <- dccm(pca, ncore = 1)))
   
  expect_that(cm[1,1], equals(1,           tolerance=1e-6))
  expect_that(cm[1,2], equals(0.627,  tolerance=1e-3))
  expect_that(cm[1,3], equals(0.632, tolerance=1e-3))
  expect_that(cm[1,3], equals(cm[3,1]))
  expect_that(cm, equals(cm2, tolerance=1e-6))

  ## Check multicore DCCM
  skip_on_travis()

  invisible(capture.output(cm.mc <- dccm(pca, ncore=NULL)))
  expect_that(cm, equals(cm.mc, tolerance=1e-6))
  
})

"entropy" <-
function(alignment) {
  # Calculate the Shannon entropy score for each position
  # in an alignment

  if(is.list(alignment)) alignment=alignment$ali

  aa <- c("V","I","L","M",  "F","W","Y",  "S","T",
          "N","Q",  "H","K","R",  "D","E",
          "A","G",  "P",  "C",  "-","X")

  composition <- table(alignment)
  unk <- composition[!names( composition  ) %in% aa]
  if(length(unk) > 0) {
    warning(paste("non standard residue code:",names(unk),"mapped to X\n  "))
    for(i in 1:length(unk))
      alignment[alignment==names(unk[i])]="X"
  }

  len <- ncol(alignment)
  freq.22 <- matrix(0, nrow = 22, ncol = ncol(alignment),
                    dimnames = list(aa,seq(1:len)))

  freq.10 <- matrix(0, nrow = 10, ncol = ncol(alignment),
                    dimnames = list(c(1:10),c(1:len)))

  for (i in 1:len) {
    freq.22[names(summary((as.factor(toupper(alignment[,i]))))), i] <-
      (summary(as.factor(toupper(alignment[,i])))/length(alignment[,i]))

    freq.10[1,i]  <- sum(freq.22[1:4,i])   # Hydrophobic, Aliphatic
    freq.10[2,i]  <- sum(freq.22[5:7,i])   # Aromatic
    freq.10[3,i]  <- sum(freq.22[8:9,i])   # Ser/Thr
    freq.10[4,i]  <- sum(freq.22[10:11,i]) # Polar
    freq.10[5,i]  <- sum(freq.22[12:14,i]) # Positive
    freq.10[6,i]  <- sum(freq.22[15:16,i]) # Negative
    freq.10[7,i]  <- sum(freq.22[17:18,i]) # Tiny
    freq.10[8,i]  <- sum(freq.22[19,i])    # Proline
    freq.10[9,i]  <- sum(freq.22[20,i])    # Cysteine
    freq.10[10,i] <- sum(freq.22[21:22,i]) # Gaps

  }

  entropy.22 <- vector(length = len)
  entropy.10 <- entropy.22

  for (i in 1:len) {
  #   entropy_i = sum[i] (P(X_i)log2(P(X_i)))
    entropy.22[i]  <- -1*sum(freq.22[freq.22[, i] != 0, i] *
                               log2(freq.22[freq.22[, i] != 0, i]))

    entropy.10[i] <- -1*sum(freq.10[freq.10[, i] != 0, i] *
                            log2(freq.10[freq.10[, i] != 0, i]))
  }

  out <- list(H=entropy.22, H.10=entropy.10,
              H.norm=1-(if(max(entropy.22)==0) entropy.22 else (entropy.22/max(entropy.22))),
              H.10.norm=1-(if(max(entropy.10)==0) entropy.10 else (entropy.10/max(entropy.10))),
              freq=freq.22)
}

"plot.enma" <-
  function(x,
           pdbs=NULL,
           xlab=NULL, ylab="Fluctuations",
           ...) {

    if(!(inherits(x, "enma")))
        stop("provide a enma object as obtained from 'nma.pdbs'")

      yval <- x$fluctuations


      ## SSE information
      sse.aln <- NULL
      dots <- list(...)

      ## reference structure for SSE and resno
      if("ind" %in% names(dots)) {
          ref.ind <- dots[["ind"]]
          dots[["ind"]] <- NULL

          ## Note - plot.fluct use plotb3(yval[1,]) for base plotting
          ## Lines 54-61 checks for NAs in yval[1,] to trim SSE
          ## SSE must therefore correspond to yval[1,]
          ## ref.ind != 1 might give wrong sse annotation in plot
          
          warning("reference structure can not be set")
          ref.ind <- 1
      }
      else {
          ref.ind <- 1
      }

      ## use first non-NA in col as ref.ind
      if("col" %in% names(dots)) {
          col <- dots[["col"]]

          if(length(col) != nrow(yval))
              stop("length of col doesn't match dimension of x")
          
          if(any(is.na(col))) {
              ref.ind <- which(!is.na(col))[1]
          }
      }

  
    ## check for gaps
    gaps <- gap.inspect(yval)
    if(any(gaps$col>0))
      rm.gaps <- FALSE
    else
      rm.gaps <- TRUE


    ## check if pdbs match enma object
    gaps.pdbs <- NULL
    if(!is.null(pdbs)) {
      if(!inherits(pdbs, "pdbs")) {
        warning("argument 'pdbs' is not a 'pdbs' object (as obtained from pdbaln())")
        pdbs <- NULL
      }
      else {
        gaps.pdbs <- gap.inspect(pdbs$ali)

        if(rm.gaps)
          dims.pdbs <- dim(pdbs$ali[, gaps.pdbs$f.inds, drop=FALSE])
        else
          dims.pdbs <- dim(pdbs$ali)

        if(!identical(dim(yval), dims.pdbs)) {
          warning("dimenension mismatch between modes and pdbs object")
          pdbs <- NULL
        }
      }
    }

    ## trim pdbs object if rm.gaps=TRUE
    if(!is.null(pdbs)) {
        if(rm.gaps)
            pdbs <- trim(pdbs, col.inds=gaps.pdbs$f.inds)
    }

      if(!is.null(pdbs)) {
        resno <- pdbs$resno[ref.ind, ]

        if(is.null(xlab)) {
            xlab <- paste0('Residue number (reference PDB: ',
                           basename.pdb(pdbs$id[ref.ind]), ')')
        }
    }
    else {
        resno <- NULL

        if(is.null(xlab))
            xlab <- "Alignment Position"
    }

      
    if( "sse" %in% names(dots) ) {
        sse.aln <- dots$sse
        dots$sse <- NULL
    }
      
    if(!is.null(pdbs) & is.null(sse.aln)) {
        sse.aln <- pdbs2sse(pdbs, ind=ref.ind, rm.gaps=rm.gaps, resno=TRUE)
        sse.aln$sse[ is.na(yval[ref.ind,]) ] <- NA
        ## see lines 54-61 in plotb3.R
    }

    if( "rm.gaps" %in% names(dots) ) {
        warning("'rm.gaps=TRUE' might result in incorrect SSE annotation")
    }

    ## Plot fluctuations
    do.call('plot.fluct', c(list(x=yval,
                                 resno=resno, sse=sse.aln,
                                 xlab=xlab, ylab=ylab),
                            dots))

}

read.prmtop <- function(file) {
  cl <- match.call()

  if(missing(file)) {
    stop("read.pdb: please specify a PDB 'file' for reading")
  }
  
  ##- Check if file exists locally or on-line
  if(!file.exists(file)) {
    stop("No input PDB file found: check filename")
  }
  
  ## parse PRMTOP file with cpp function
  prmtop <- .read_prmtop(file)
  if(!is.null(prmtop$error))
    stop(paste("Could not read", file))
  else
    class(prmtop) <- c("amber", "prmtop")
  
  prmtop$call <- cl
  
  ## finished
  return(prmtop)
}

"mktrj.pca" <- function(pca=NULL,   # pca data structure
                        pc=1,       # which pc to move along
                        mag=1,      # magnification factor
                        step=0.125, # step size
                        file=NULL,  # output pdb file
                        pdb=NULL,   # reference pdb object
                        rock=TRUE,
                        ... ) {     # args for write.pdb

  ## make a trjactory of atomic displacments along a given pc
  if(!inherits(pca, "pca")) {
    stop("input should be a list object of class 'pca' (from 'pca.xyz')")
  }

  if(is.null(file))
    file <- paste("pc_", pc, ".pdb", sep="")
 
  if(!is.null(pdb)) {
     if(is.pdbs(pdb)) 
        pdb <- pdbs2pdb(pdb, inds=1, rm.gaps=TRUE)[[1]] 
     if(!is.pdb(pdb)) {
        warning("Unrecognized 'pdb' object. Ignored")
        pdb <- NULL
     }
  }
 
  nstep <- c(seq(step, to=mag, by=step))
  zcoor  <- cbind(sqrt(pca$L[pc])) %*% nstep

  ##- Bug fix: Fri Jun 15 14:49:24 EDT 2012
  ##  plus  <- apply(zcoor, 2, pca.z2xyz, pca)
  ##  minus <- apply( (-(zcoor)), 2, pca.z2xyz, pca)

  scor  <- function(x,u,m) { return(x*u+m) }
  plus  <- sapply(c(zcoor), scor, u=pca$U[,pc], m=pca$mean)
  minus <- sapply(c(-zcoor), scor, u=pca$U[,pc], m=pca$mean)

  if(rock) {
    coor  <- cbind(pca$mean,
                   plus,  plus[,rev(1:ncol(plus))],
                   pca$mean,
                   minus, minus[,rev(1:ncol(minus))])
  }
  else {
    coor  <- cbind(plus[,rev(1:ncol(plus))],
                   pca$mean,
                   minus)
  }
  coor <- as.xyz(t(coor))
  write.pdb(xyz=coor, file=file, pdb=pdb, ...)
  invisible(coor)
}

"get.pdb" <-
  function (ids, path = ".", URLonly = FALSE, overwrite = FALSE, gzip = FALSE, split = FALSE, 
            format = "pdb", verbose = TRUE, ncore = 1, ... ) 
{
    if(.Platform$OS.type=="windows")
      gzip <- FALSE

    # Parallelized by parallel package (Tue Oct 15 15:23:36 EDT 2013)
    ncore <- setup.ncore(ncore)
    if(ncore > 1) {
       # To avoid too frequent access to PDB server
       if(!split) {
          warning("Multiple-core access to PDB server is not allowed. Reset ncore=1")
          ncore <- setup.ncore(ncore = 1)
       } else {
          setup.ncore(ncore = 1)
       }
    }

    if(!tolower(format) %in% c("pdb", "cif")) {
        stop("'format' must be either 'pdb' or 'cif'")
    }

    if(inherits(ids, "blast")) ids = ids$pdb.id

    if (any(nchar(ids) < 4))
      stop("ids should be standard 4 character PDB-IDs or 6 character PDB-ID_Chain-IDs")

    ids4 = ids
    if (any(nchar(ids) > 4)) {
      ids4 <- unlist(lapply(strsplit(ids, "_"), function(x) x[1]))
      
      if (any(nchar(ids4) > 4))
        warning("ids should be standard 4 character PDB-IDs: trying first 4 characters...")

      ids4 <- substr(basename(ids), 1, 4)
    }
    ids4 <- unique(ids4)
    pdb.files <- paste(ids4, ".", format, ifelse(gzip, ".gz", ""), sep = "")
    get.files <- file.path("https://files.rcsb.org/download", pdb.files)
    if (URLonly) 
        return(get.files)
    put.files <- file.path(path, pdb.files)

    if(!file.exists(path))
       dir.create(path)
    rtn <- rep(NA, length(pdb.files))

    if(ncore > 1) {
       rtn <- unlist(mclapply(1:length(pdb.files), function(k) {
          if (!file.exists(sub(".gz$", "", put.files[k])) | overwrite ) {
            rtn <- try(download.file(get.files[k], put.files[k], quiet = !verbose), silent = TRUE)
            if(inherits(rtn, "try-error")) {
               rtn <- 1
               file.remove(put.files[k])
            } else if(gzip) {
               cmd <- paste("gunzip -f", put.files[k])
               system(cmd)
            }
          }
          else {
            rtn <- put.files[k]
            warning(paste(put.files[k], " exists. Skipping download"))
          }
          return(rtn)
       }))
    } else {
       for (k in 1:length(pdb.files)) {
         if (!file.exists(sub(".gz$", "", put.files[k])) | overwrite ) {
           rt <- try(download.file(get.files[k], put.files[k], quiet = !verbose), silent=TRUE)
           rtn[k] <- rt
           if(inherits(rt, "try-error")) {
              rtn[k] <- 1
              file.remove(put.files[k])
           } else if(gzip) {
              cmd <- paste("gunzip -f", put.files[k])
              system(cmd)
           }
         }
         else {
           rtn[k] <- put.files[k]
           warning(paste(put.files[k], " exists. Skipping download"))
         }
         gc()
       }
    }
   
    rtn <- as.character(rtn) 
    names(rtn) <- file.path(path, paste(ids4, ".", format, sep = ""))
    if (any(rtn == '1')) {
        warning("Some files could not be downloaded, check returned value")
        return(rtn)
    } else {
        if(split) {
           rtn = pdbsplit(pdb.files = names(rtn), ids = ids, path = file.path(path, "split_chain"), ncore = ncore, ...)
           return(rtn)
        } else { 
           return(names(rtn))
        }
    }
}

context("Testing basic PDB structure operation")

test_that("read.pdb() reads a normal pdb file", {

  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1dpx.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))
  
  expect_is(pdb$atom, "data.frame")
  expect_true(inherits(pdb, "pdb"))
  expect_true(inherits(pdb$xyz, "xyz"))

  expect_equal(nrow(pdb$atom), 1177)
  expect_equal(sum(pdb$calpha), 129)

  expect_equal(sum(pdb$atom$resid=="HOH"), 177)
  expect_equal(sum(pdb$atom$resid=="CL"), 2)
  expect_that(sum(pdb$xyz), equals(44657.12, tolerance=1e-6))

  expect_equal(sum(pdb$atom$type=="ATOM"), 998)
  expect_equal(sum(pdb$atom$type=="HETATM"), 179)

  expect_equal(pdb$remark$biomat$num, 1)
  expect_equal(pdb$remark$biomat$chain[[1]], "A")
  true_mat <- matrix(c(1.0, 0.0, 0.0, 0.0,
                       0.0, 1.0, 0.0, 0.0,
                       0.0, 0.0, 1.0, 0.0), nrow=3, byrow=TRUE)
  expect_equivalent(pdb$remark$biomat$mat[[1]][[1]], true_mat)

  invisible(capture.output(spdb <- read.pdb(file, ATOM.only=TRUE)))
  expect_equal(spdb$atom, pdb$atom)
  expect_equal(spdb$xyz, pdb$xyz)
  expect_equal(spdb$calpha, pdb$calpha)
  expect_true(is.null(spdb$helix)) 
  expect_true(is.null(spdb$sheet)) 
  expect_true(is.null(spdb$seqres))
  expect_true(is.null(spdb$remark))
  
})


test_that("read.pdb() reads and stores data properly", {
  skip_on_cran()
  skip_on_travis()
  
  datdir <- tempdir()
  suppressWarnings(
    invisible(capture.output(get.pdb(c("3DRC", "1P3Q", "1SVK", "1L2Y"), path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  )
  
   # "3DRC" example PDB has a CA calcium ion and a CA containing ligand. 
   expect_error(read.pdb("nothing"))
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "3DRC.pdb"))))

   expect_equal(nrow(pdb$atom), 2954)
   expect_equal(sum(pdb$calpha), 318)
#   expect_equivalent(aa321(pdb$seqres), pdbseq(pdb))
   expect_equal(pdb$xyz[1:6], c(24.317, 59.447, 4.079, 25.000, 58.475, 4.908), tolerance=1e-6)
   expect_equal(length(pdb$helix$start), 8)
   expect_equal(length(pdb$sheet$start), 16)
    
   # "1SVK" example PDB has alternate location indicator 
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "1SVK.pdb"))))
   expect_equal(sum(pdb$calpha), 313)
   expect_equal(sum(pdb$atom$resno==47), 6)
   expect_equal(sum(pdb$atom$resid=="GDP"), 28)
    
   # multi-model structure
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "1L2Y.pdb"), multi=TRUE)))
   expect_equal(dim(pdb$xyz), c(38, 912))
   expect_equal(pdb$xyz[20, 1:6], c(-8.559, 6.374, -1.226, -7.539, 6.170, -0.168), tolerance=1e-6)

   # one atom
   cat("ATOM      1  N   SER Q 398      48.435  21.981  -6.393  1.00 56.10           N\n",
      file=file.path(datdir, "t1a.pdb"))
   pdb <- read.pdb(file.path(datdir, "t1a.pdb"))
   expect_is(pdb$atom, "data.frame") 



  ### write.pdb()
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "3DRC.pdb"))))
   write.pdb(pdb, file=file.path(datdir, "t1.pdb"))
   invisible(capture.output(pdb1 <- read.pdb(file.path(datdir, "t1.pdb"))))
   expect_identical(pdb$atom, pdb1$atom)
   expect_identical(pdb$xyz, pdb1$xyz)
   expect_identical(pdb$calpha, pdb1$calpha)
 
   # multi-model structure
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "1L2Y.pdb"), multi=TRUE)))
   write.pdb(pdb, file=file.path(datdir, "t2.pdb"))
   invisible(capture.output(pdb2 <- read.pdb(file.path(datdir, "t2.pdb"), multi=TRUE)))
   # SSE, SEQRES, and REMARK missing in write.pdb()
   pdb[c("seqres", "helix", "sheet", "remark", "call")] <- NULL
   pdb2[c("seqres", "helix", "sheet", "remark", "call")] <- NULL
   expect_identical(pdb, pdb2)
  


  ### trim.pdb() 
   invisible(capture.output(pdb <- read.pdb(file.path(datdir, "1P3Q.pdb"))))
   pdb1 <- trim.pdb(pdb, inds = atom.select(pdb, "calpha", verbose=FALSE))
   expect_is(pdb1, "pdb")
   expect_equal(nrow(pdb1$atom), 228)
   expect_equal(sum(pdb1$calpha), 228)
   expect_equivalent(pdb1$helix$start, pdb$helix$start)
   expect_equivalent(sort(pdb1$sheet$end), sort(pdb$sheet$end))

   pdb2 <- trim.pdb(pdb, inds = atom.select(pdb, "protein", chain="U", verbose=FALSE))
   expect_equal(nrow(pdb2$atom), 593)
   expect_equal(sum(pdb2$calpha), 74)
   expect_equivalent(pdb2$helix, list(start=c(22, 37, 56), end=c(35, 39, 60), 
       chain=rep("U",3), type=c("1", "5", "5")))
   expect_equivalent(pdb2$sheet, list(start=c(12,2,66,41,48), end=c(16,7,71,45,49), 
       chain=rep("U",5), sense=c("0","-1","1","-1","-1")))
})


test_that("read.pdb() reads PDB with ' in atom names", {
  skip_on_cran()
  skip_on_travis()

  datdir <- tempdir()
  invisible(capture.output(get.pdb("1H5T", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  
  invisible(capture.output(pdb <- read.pdb(file.path(datdir, "1H5T.pdb"))))
  sele <- atom.select(pdb, "notprotein")
  expected <- c("TYD", "DAU", "SO4", "HOH")
  expect_equal(unique(pdb$atom$resid[sele$atom]), expected)

  sele <- atom.select(pdb, elety="C1'")
  expected <- "C1'"
  expect_equal(unique(pdb$atom$elety[sele$atom]), expected)
})



test_that("read.pdb() (cpp) gives the same results as read.pdb2() (old R version)", {
  skip_on_cran()
  skip_on_travis()

  datdir <- tempdir()

  suppressWarnings(
   invisible(capture.output(get.pdb("1H5T", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  )
  
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1H5T.pdb"))))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1H5T.pdb"))))
  expect_equal(pdb0$atom, pdb1$atom)
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$sheet, pdb1$sheet)
  expect_equal(pdb0$helix, pdb1$helix)
  expect_equal(pdb0$calpha, pdb1$calpha)
  expect_equal(pdb0$seqres, pdb1$seqres)
  expect_equal(pdb0$remark, pdb1$remark)

  ## 1TOH - more remarks 
  suppressWarnings(
     invisible(capture.output(get.pdb("2TOH", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  )
  
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "2TOH.pdb"))))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "2TOH.pdb"))))
  expect_equal(pdb0$atom, pdb1$atom)
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$sheet, pdb1$sheet)
  expect_equal(pdb0$helix, pdb1$helix)
  expect_equal(pdb0$calpha, pdb1$calpha)
  expect_equal(pdb0$seqres, pdb1$seqres)
  expect_equal(pdb0$remark, pdb1$remark)

  ## multi = TRUE
  invisible(capture.output(get.pdb("2EYB", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "2EYB.pdb"), multi=TRUE)))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "2EYB.pdb"), multi=TRUE)))
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$atom, pdb1$atom)
  
  ## rm.insert = TRUE
  suppressWarnings(
    invisible(capture.output(get.pdb("1FUJ", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  )
  
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1FUJ.pdb"), rm.insert=TRUE)))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1FUJ.pdb"), rm.insert=TRUE)))
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$atom, pdb1$atom)

  ## rm.alt = TRUE/FALSE
  invisible(capture.output(get.pdb("1RX2", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1RX2.pdb"), rm.alt=TRUE)))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1RX2.pdb"), rm.alt=TRUE)))
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$atom, pdb1$atom)

  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1RX2.pdb"), rm.alt=FALSE)))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1RX2.pdb"), rm.alt=FALSE)))
  expect_equal(pdb0$xyz, pdb1$xyz)
  expect_equal(pdb0$atom, pdb1$atom)

  ## ATOM.only = TRUE
  if(FALSE) {
      suppressWarnings(
        invisible(capture.output(get.pdb("1FUJ", path=datdir,
                                       overwrite = FALSE, verbose = FALSE)))
      )
    
      invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1FUJ.pdb"), ATOM.only=TRUE)))
      invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1FUJ.pdb"), ATOM.only=TRUE)))
      expect_equal(attributes(pdb0), attributes(pdb1))
  }

  ## read PDB with 'insert'
  suppressWarnings(
     invisible(capture.output(get.pdb("1FUJ", path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  )
  invisible(capture.output(pdb0 <- read.pdb(file.path(datdir, "1FUJ.pdb"))))
  invisible(capture.output(pdb1 <- read.pdb2(file.path(datdir, "1FUJ.pdb"))))
  for(i in names(pdb1)) {
    if(i != 'call') {
      expect_equal(pdb0[[i]], pdb1[[i]]) 
    }
  } 
})

context("Testing relationship between read.cif and read.pdb")

test_that("read.cif() reads a normal pdb file", {

  skip_on_cran()
  skip_on_travis()
    
  ## Simple testing 
  file <- system.file("examples/1dpx.pdb",package="bio3d")
  invisible(capture.output(p1 <- read.pdb(file)))

  datdir <- tempdir()
  invisible(capture.output(get.pdb("1dpx", path=datdir, format="cif",
                                   overwrite = FALSE, verbose = FALSE)))
  
  suppressWarnings(
    invisible(capture.output(p2 <- read.cif(file.path(datdir, "1dpx.cif"))))
  )
  
  expect_is(p2$atom, "data.frame")
  expect_true(inherits(p2, "pdb"))
  expect_true(inherits(p2$xyz, "xyz"))
  expect_identical(p2$xyz, p1$xyz)

  expect_equal(nrow(p2$atom), nrow(p1$atom))
  expect_equal(sum(p2$calpha), sum(p1$calpha))
  expect_identical(p2$xyz, p1$xyz)
  expect_identical(p2$atom$type, p1$atom$type)
  ## offset for eleno between pdb and cif format
  #expect_identical(p2$atom$eleno, p1$atom$eleno)
  expect_identical(p2$atom$resid, p1$atom$resid)
  expect_identical(p2$atom$resno, p1$atom$resno)
  expect_identical(p2$atom$o, p1$atom$o)
  expect_identical(p2$atom$b, p1$atom$b)
  
  expect_equal(sum(p2$atom$resid=="HOH"), sum(p1$atom$resid=="HOH"))
  expect_equal(sum(p2$atom$resid=="CL"), sum(p1$atom$resid=="CL"))
  expect_that(sum(p2$xyz), equals(44657.12, tolerance=1e-6))

  expect_equal(sum(p2$atom$type=="ATOM"), sum(p1$atom$type=="ATOM"))
  expect_equal(sum(p2$atom$type=="HETATM"), sum(p1$atom$type=="HETATM"))

  
})


test_that("read.cif() on a multimodel object", {
    
  skip_on_cran()
  skip_on_travis()
  
  datdir <- tempdir()
  invisible(capture.output(get.pdb(c("1L2Y"), path=datdir,
                                   overwrite = FALSE, verbose = FALSE)))
  invisible(capture.output(get.pdb(c("1L2Y"), path=datdir, format="cif",
                                   overwrite = FALSE, verbose = FALSE)))
  # multi-model structure
  invisible(capture.output(p1 <- read.pdb(file.path(datdir, "1L2Y.pdb"), multi=TRUE)))
  suppressWarnings(
    invisible(capture.output(p2 <- read.cif(file.path(datdir, "1L2Y.cif"), multi=TRUE)))
  )
  
  expect_identical(dim(p1$xyz), dim(p2$xyz))
  expect_identical(p1$atom$x, p2$atom$x)
  expect_identical(p1$atom$y, p2$atom$y)
  expect_identical(p1$atom$z, p2$atom$z)
})

context("Test reading aligned PDB structures")

test_that("read.all() reads all/select PDB atoms properly", {

  ## Internet access required - test skipped
  skip_on_cran()
  skip_on_travis()

  ## Test with 4 G-alpha PDB structures  
  pdbdir <- tempdir()
  suppressWarnings(
    invisible( capture.output(pdbfiles <- get.pdb(c("1TND_A", "1TAG", "1AS0", "1AS2"), path=pdbdir, split=TRUE)) )
  )
  invisible( capture.output(aln <- pdbaln(pdbfiles)) )

  ## read with default options
  invisible( capture.output(pdbs <- read.all(aln, ncore=1)) )

  expect_is(pdbs, "pdbs")
  expect_true(inherits(pdbs, "fasta"))
  expect_is(pdbs$xyz, "xyz")
  expect_is(pdbs$all, "xyz")
  expect_equal(length(pdbs$all.hetatm), 4)
  expect_is(pdbs$all.hetatm[[1]], 'pdb')
  expect_equal(nrow(pdbs$all.hetatm[[1]]$atom), 35)

  xyz0 <- rbind(c(30.074,  64.434, 42.910, 30.390, 68.173, 43.382),
                c(38.552,  16.715, 60.576, 41.952, 15.364, 59.564),
                c(NA,      NA,     NA,     8.994, -26.463, 7.153),
                c(NA,      NA,     NA,     55.761, 11.671, 39.809))
  expect_equivalent(xyz0, pdbs$xyz[, 1:6])

  all0 <- rbind(c(30.848,  63.431,  43.718, 30.074,  64.434,  42.910),
                c(38.238,  18.018,  61.225, 38.552,  16.715,  60.576), 
                c(NA,      NA,     NA,     NA,   NA,   NA),
                c(NA,      NA,     NA,     NA,   NA,   NA))
  expect_equivalent(all0, pdbs$all[, 1:6])

  resno0 <- rbind(c(27, 28, 29, 30, 31, 32),
                  c(27, 28, 29, 30, 31, 32),
                  c(NA, 32, 33, 34, 35, 36),
                  c(NA, 32, 33, 34, 35, 36))
  expect_equivalent(resno0, pdbs$resno[, 1:6])

  b0 <- rbind(c(48.05, 40.48, 38.06, 29.55, 25.63, 23.82), 
              c(40.32, 31.04, 23.50, 15.42, 13.10, 13.73),
              c(NA,    51.59, 45.39, 31.58, 29.26, 22.08),
              c(NA,    88.56, 65.25, 44.64, 35.89, 25.72))
  expect_equivalent(b0, pdbs$b[, 1:6])

  chain0 <- rbind(rep('A', 6), rep('A', 6),
                  c(NA, rep('A', 5)), c(NA, rep('A', 5)))
  expect_equivalent(chain0, pdbs$chain[, 1:6])

  ali0 <- rbind(c('A', 'R', 'T', 'V', 'K', 'L'), 
                c('A', 'R', 'T', 'V', 'K', 'L'),
                c('-', 'R', 'E', 'V', 'K', 'L'), 
                c('-', 'R', 'E', 'V', 'K', 'L'))
  expect_equivalent(ali0, pdbs$ali[, 1:6])

  sse0 <- rbind(c(' ', ' ', ' ', 'E', 'E', 'E'),
                c(' ', ' ', ' ', 'E', 'E', 'E'),
                c(NA,  ' ', 'E', 'E', 'E', 'E'),
                c(NA,  ' ', 'E', 'E', 'E', 'E'))
  expect_equivalent(sse0, pdbs$sse[, 1:6])

  all.elety0 <- rbind(c('N', 'CA', 'C', 'O', 'CB', 'N'),
                      c('N', 'CA', 'C', 'O', 'CB', 'N'),
                      c(NA,  NA,   NA,  NA,  NA,  'N'),
                      c(NA,  NA,   NA,  NA,  NA,  'N'))
  expect_equivalent(all.elety0, pdbs$all.elety[, 1:6])
 
  all.grpby0 <- c(rep(1, 5), 2)
  expect_equivalent(all.grpby0, pdbs$all.grpby[1:6])

  all.hetatm.xyz0 <- c(8.943,  83.379,  38.955, 2.309,  67.529,  27.056)
  expect_equivalent(all.hetatm.xyz0, pdbs$all.hetatm[[1]]$xyz[, 1:6])

  ## read with multicore
  invisible( capture.output(pdbs.mc <- read.all(aln, ncore=NULL)) )
  expect_equal(pdbs[!names(pdbs) %in% 'call'], pdbs.mc[!names(pdbs.mc) %in% 'call'])

  ## read protein only
  invisible( capture.output(pdbs.prot <- read.all(aln, rm.ligand=TRUE, ncore=NULL)) )
  expect_true(is.null(pdbs.prot$all.hetatm))
  expect_equal(pdbs[!names(pdbs) %in% c('call', 'all.hetatm')],
               pdbs.prot[!names(pdbs.prot) %in% c('call', 'all.hetatm')])
  
  ## read with select atoms
  invisible( capture.output(pdbs.sel <- read.all(aln, sel=c('N', 'CA', 'C'), 
                                             rm.ligand=TRUE, ncore=NULL)) )
  all.elety0 <- rbind(c('N', 'CA', 'C', 'N', 'CA', 'C'),
                      c('N', 'CA', 'C', 'N', 'CA', 'C'),
                      c(NA,  NA,   NA,  'N', 'CA', 'C'),
                      c(NA,  NA,   NA,  'N', 'CA', 'C'))
  expect_equivalent(all.elety0, pdbs.sel$all.elety[, 1:6])

  ## Error handling
  expect_error(read.all('pdb_file_name_is_not_supported'))
  
  ## If one structure is not readable, print warning (ncore=1) and write NAs 
  ## for the missing structure.
  taln <- aln; taln$id[1] <- 'dummy'
  expect_warning(capture.output(pdbs.missing <- read.all(taln, ncore=1)))
  expect_true(all(is.na(pdbs.missing$all[1,])))

  ## If mismatch between structure and alignment, print proper error message
  taln <- aln; taln$ali[1, 16] <- 'A'
  expect_error(capture.output(read.all(taln, ncore=1)))
})

context("Testing get.pdb()")

test_that("get.pdb() works properly", {
  skip_on_cran()
  skip_on_travis()
  
   ids <- c("1tag", "1tnd")  # Gt
   tmp <- tempdir()
   suppressWarnings(
     capture.output(files <- get.pdb(ids, tmp, verbose=FALSE))
   )
   expect_identical(files, paste(tmp, "/", ids, ".pdb", sep=""))
   expect_warning(get.pdb("3c7kxxx", tmp, verbose=FALSE))
   expect_warning(get.pdb("1tag", tmp, verbose=FALSE))
   
   suppressWarnings(
     capture.output(files <- get.pdb("1as0", tmp, verbose=FALSE, gzip=TRUE))
   )
   expect_identical(files, paste(tmp, "/1as0.pdb", sep=""))
#   expect_error(get.pdb("aaaa", tmp, verbose=FALSE))
})

test_that("get.pdb() with ncore>1 works properly", {
  skip_on_cran()
  skip_on_travis()
     
   ids <- c("1tag", "1tnd", "3v00", "1got")
   tmp1 <- paste(tempdir(), "1", sep="")
   tmp2 <- paste(tempdir(), "2", sep="")
   time1 <- system.time(r1 <- get.pdb(ids, tmp1, ncore=1, verbose=FALSE))["elapsed"]
   time2 <- system.time(r2 <- get.pdb(ids, tmp2, ncore=NULL, verbose=FALSE))["elapsed"]
   expect_identical(r2, paste(tmp2, "/", ids, ".pdb", sep=""))
   expect_identical(list.files(tmp1), list.files(tmp2))
#   cat("Speed up by ", round((time1-time2)/time2*100, 1), "%", sep="")
#   if(getOption("cores") > 1)
#      expect_true(time1 > time2)
   unlink(tmp1, recursive=TRUE)
   unlink(tmp2, recursive=TRUE)
})

"inner.prod" <-
  function(x,y,mass=NULL) {
    x <- as.matrix(x); y <- as.matrix(y);
    dx <- dim(x); dy <- dim(y);
    
    if(dx[1]!=dy[1])
      stop("inner.prod: unequal vector lengths")
    
    if(dx[2]>1 && dy[2]>1) {
      if(dx[2]!=dy[2])
        stop("inner.prod: unequal vector lengths")
    }
    
    if(dx[2]==1)
      x <- as.numeric(x)
    if(dy[2]==1)
      y <- as.numeric(y)
    
    if(!is.null(mass)) {
      if (dx[1] != (length(mass)*3)) 
        stop("inner.prod: incorrect length of mass")
    }
    
    if(is.null(mass))
      mass <- 1
    else
      mass <- rep(mass,each=3)
    
    if(is.matrix(x) || is.matrix(y))
      return(colSums((x*y)*mass^2))
    else
      return(sum(x*y*mass^2))
  }

context("Testing vector functions")


test_that("Vector functions", {

  ## vector normalization
  x <- 1:3
  x.norm <- c(0.2672612, 0.5345225, 0.8017837)
  expect_that(normalize.vector(x), equals(x.norm, tolerance  = 1e-6))

  y <- matrix(1:9, ncol = 3, nrow = 3)
  y.norm <- matrix(c(x.norm,
                     0.4558423, 0.5698029, 0.6837635,
                     0.5025707, 0.5743665, 0.6461623), ncol=3, byrow=F)

  expect_that(normalize.vector(y), equals(y.norm, tolerance  = 1e-6))


  
  ## Inner product
  x <- 1:3
  y <- diag(x)
  z <- matrix(1:9, ncol = 3, nrow = 3)

  xy <- c(1, 4, 9)
  yz <- c(1, 10, 27)
  
  expect_that(inner.prod(x,y), equals(xy))
  expect_that(inner.prod(y,z), equals(yz))
    
}
          )

"print.sse" <-
  function(x, ...) {

    cn <- class(x)

    cat("\n")
    cat("Call:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
        "\n\n", sep = "")

    cat("Class:\n  ", cn, "\n\n", sep = "")

    cat("Helices: ", length(x$helix$start), "")
    if(length(x$helix$start)>0) {
      j <- 0
      for(i in 1:length(x$helix$start)) {
        if(j%%5==0)
          cat("\n  ")
        
        tmpout <- paste(x$helix$start[i], "-", x$helix$end[i],
                        " (", x$helix$chain[i], ")", sep="")
        cat(format(tmpout, justify="right", width=15))
        j <- j+1
      }
    }

    cat("\n\n")
    cat("Sheets:  ", length(x$sheet$start), "")
    if(length(x$sheet$start)>0) {
      j <- 0
      for(i in 1:length(x$sheet$start)) {
        if(j%%5==0)
          cat("\n  ")
        
        tmpout <- paste(x$sheet$start[i], "-", x$sheet$end[i],
                      " (", x$sheet$chain[i], ")", sep="")
        cat(format(tmpout, justify="right", width=15))
        j <- j+1
      }
    }
    
    cat("\n\n")
    cat("Turns:  ", length(x$turn$start), "")
    if(length(x$turn$start)>0) {
      j <- 0
      for(i in 1:length(x$turn$start)) {
        if(j%%5==0)
          cat("\n  ")
        
        tmpout <- paste(x$turn$start[i], "-", x$turn$end[i],
                      " (", x$turn$chain[i], ")", sep="")
        cat(format(tmpout, justify="right", width=15))
        j <- j+1
      }
    }

    cat("\n\n")

    if(is.null(x$call$resno))
      resno <- TRUE
    else if(x$call$resno=="T" || x$call$resno=="TRUE")
      resno <- TRUE
    else
      resno <- FALSE

    if(resno)
      cat("Output is provided in residue numbers")
    else
      cat("Output is provided in residue (sequential) identifiers")

    cat("\n\n")
    invisible(x)
  }

atom.select.pdbs <- function(pdbs,
                             string = NULL, 
                             resno = NULL, chain = NULL, resid = NULL,
                             operator="AND", inverse = FALSE,
                             value = FALSE, verbose=FALSE,  ...) {

    ## verbose message output
    if(verbose) cat("\n")
    .verboseout <- function(M, type) {
        cat(" .. ", sprintf("%08s", length(which(M))), " atom(s) from '", type, "' selection \n", sep="")
    }
    
    ## combine logical vectors
    .combinelv <- function(L, M, operator) {
        if(operator=="AND") M <- L & M
        if(operator=="OR") M <- L | M
        return(M)
    }
    
    cl <- match.call()
    if(operator=="AND")
        M <- rep(TRUE, ncol(pdbs$ali))
    if(operator=="OR")
        M <- rep(FALSE, nrow(pdbs$ali))


    if(!is.null(string)) {
        gaps <- gap.inspect(pdbs$ali)
        M <- switch(string,
                    all         =  M <- rep(TRUE, ncol(pdbs$ali)),
                    gap         =  apply(pdbs$ali, 2, function(x) any(x %in% "-")),
                    gaps        =  apply(pdbs$ali, 2, function(x) any(x %in% "-")),
                    nongap      = !apply(pdbs$ali, 2, function(x) any(x %in% "-")),
                    allgap      =  apply(pdbs$ali, 2, function(x) all(x %in% "-"))
                    )

        if(verbose) {
            .verboseout(M, 'string')
        }
    }
    
    if(!is.null(resno)) {
        L <- apply(pdbs$resno, 2, function(x) any(x %in% resno))
        if(verbose) .verboseout(L, 'resno')
        M <- .combinelv(L, M, operator)
    }

    if(!is.null(chain)) {
        L <- apply(pdbs$chain, 2, function(x) any(x %in% chain))
        if(verbose) .verboseout(L, 'chain')
        M <- .combinelv(L, M, operator)
    }

    if(!is.null(resid)) {
        L <- apply(pdbs$resid, 2, function(x) any(x %in% resid))
        if(verbose) .verboseout(L, 'resid')
        M <- .combinelv(L, M, operator)
    }
    
    if(inverse) {
        if(verbose) {
            cat(" ..", sprintf("%08s", length(which(!M))), "atom(s) in inversed selection \n")
        }
        sele <- as.select(which(!M))
    }
    else
        sele <- as.select(which(M))
    
    sele$call <- cl
    if(verbose) cat("\n")
    
    if(value)
        return(trim(pdbs, col.inds=sele$atom))
    else
        return(sele)
}

# ensemble CNA calculation optimized with multicore
cna.ensmb <- function(cij, ..., ncore = NULL) {
   ncore <- setup.ncore(ncore)

   cijs <- cij 
   if("all.dccm" %in% names(cijs)) cijs <- cijs$all.dccm 
   if(is.array(cijs) && length(dim(cijs))==3)
      cijs <- do.call("c", apply(cijs, 3, list))
   if(is.list(cijs)) {
      net <- mclapply(cijs, cna.dccm, ...)
      class(net) <- c("ecna", class(net))
   } else {
      warning("cijs should be matrix, array(dim=3), or list")
      net <- NULL 
   }
   return(net)
}

dssp.xyz <- function(xyz, pdb, ...) {
  if(!is.pdb(pdb))
    stop("provide a pdb object as obtained from function 'read.pdb'")

  if(!is.xyz(xyz) && !is.matrix(xyz))
    stop("provide an xyz object containing the trajectory coordinates")

  sse.mat <- NULL
  dims <- dim(xyz)
  for (i in 1:dims[1L]) {
    pdb.tmp     <- pdb
    pdb.tmp$xyz <- as.xyz(xyz[i,])
    sse     <- dssp.pdb(pdb.tmp, ...)$sse
    sse.mat <- rbind(sse.mat, sse)
  }

  ##sse.mat[ sse.mat==" " ] <- "-"
  return(sse.mat)
}

"nma.pdb" <- function(pdb, inds=NULL, ff='calpha', pfc.fun=NULL, mass=TRUE,
                      temp=300.0, keep=NULL, hessian=NULL, outmodes=NULL, ... ) {

  ## Log the call
  cl <- match.call()

  if(!is.pdb(pdb))
    stop("please provide a 'pdb' object as obtained from 'read.pdb()'")

  if(!is.null(outmodes) & !is.select(outmodes))
    stop("provide 'outmodes' as obtained from function atom.select()")

  ## Prepare PDB
  ## Take only first frame of multi model PDB files
  if(nrow(pdb$xyz)>1) {
    warning("multimodel PDB file detected - using only first frame")
    pdb$xyz=pdb$xyz[1,, drop=FALSE]
  }

  ## Trim to only CA atoms
  if(is.null(inds)) {
    ca.inds <- atom.select(pdb, "calpha", verbose=FALSE)
    pdb.in <- trim.pdb(pdb, ca.inds)
  }

  ## or to user selection
  else {
    pdb.in <- trim.pdb(pdb, inds)
    if(!all(pdb.in$atom$elety=="CA"))
      stop("non-CA atoms detected")
  }

  ## Indices for effective hessian
  if(is.select(outmodes)) {
    ## re-select since outmodes indices are based on input PDB
    inc.inds <- .match.sel(pdb, pdb.in, outmodes)
    pdb.out <- trim.pdb(pdb.in, inc.inds)
  }
  else {
    pdb.out <- pdb.in
    inc.inds <- atom.select(pdb.in, "all", verbose=FALSE)
  }

  ## fetch number of atoms and sequence
  natoms.in  <- ncol(pdb.in$xyz)/3
  natoms.out <- ncol(pdb.out$xyz)/3
  sequ <- pdb.in$atom$resid

  if (natoms.in<3)
    stop("nma: insufficient number of atoms")

  ## check structure connectivity
  conn <- inspect.connectivity(pdb.in$xyz)
  if(!conn) {
    warning("Possible multi-chain structure or missing in-structure residue(s) present\n",
            "  Fluctuations at neighboring positions may be affected.")
  }

  ## Define force field
  if (is.null(pfc.fun)) {
      pfc.fun <- load.enmff(ff)
  }
  else {
      ## Use customized force field
      if(!is.function(pfc.fun))
          stop("'pfc.fun' must be a function")
  }

  ## Process input arguments
  args <- .nma.args(pfc.fun=pfc.fun, ...)

  ## Use aa2mass to fetch residue mass
  if (mass) {
    masses.in <- do.call('aa2mass', c(list(pdb=sequ, inds=NULL), args$am.args))
    masses.out <- masses.in[ inc.inds$atom ]
  }

  ## No mass-weighting
  else {
    masses.out <- NULL;
  }

  ## NMA hessian
  hessian <- .nma.hess(pdb.in$xyz, pfc.fun, args=args,
                       hessian=hessian, pdb=pdb.in)

  ## effective hessian
  hessian <- .nma.trim.hessian(hessian, inc.inds)

  ## mass weight hessian
  if(!is.null(masses.out))
    hessian <- .nma.mwhessian(hessian, masses=masses.out)

  ## diagaonalize - get eigenvectors
  ei <- .nma.diag(hessian)

  ## make a NMA object
  m <- .nma.finalize(ei, xyz=pdb.out$xyz, temp=temp, masses=masses.out,
                        natoms=natoms.out, keep=keep, call=cl)
  return(m)
}

"difference.vector" <-
  function(xyz, xyz.inds=NULL, normalize=FALSE) {

  xyz <- as.matrix(xyz)
  if (dim(xyz)[1L] < 2)
    stop("xyz must be a matrix with two rows")
  if (dim(xyz)[2L] < 6)
    stop("xyz does not contain sufficient coordinates")
  if (dim(xyz)[1L] > 2) {
    xyz <- xyz[1:2,]
    warning("xyz has more than two rows - using only the two first")
  }
  
  if ( is.null(xyz.inds) )
    xyz.inds <- seq(1, ncol(xyz))
  
  if ( length(which(is.na(xyz[,xyz.inds]))) > 0 )
    stop("xyz has NA values")
  
  a <- xyz[1, xyz.inds]
  b <- xyz[2, xyz.inds]

  if (length(a)!=length(b))
    stop("unequal lengths of the two coordinate sets")

  diff <- b-a
  if(normalize)
    diff <- normalize.vector(diff)
  
  return( diff )
}

context("Testing overlap functions")


test_that("Overlap functions", {

  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb.a <- read.pdb(file)))

  file <- system.file("examples/1dpx.pdb",package="bio3d")
  invisible(capture.output(pdb.b <- read.pdb(file)))
  
  ## Calculate modes with default arguments
  invisible(capture.output(modes <- nma(pdb.a, inds=NULL, ff='calpha',
                                        mass=FALSE, temp=300.0)))

  ca.inds.a <- atom.select(pdb.a, "calpha", verbose=FALSE)
  ca.inds.b <- atom.select(pdb.b, "calpha", verbose=FALSE)

  ## Set new coordinates of pdb.b
  xyz.b <- fit.xyz(pdb.a$xyz, pdb.b$xyz,
                   fixed.inds=ca.inds.a$xyz,
                   mobile.inds=ca.inds.b$xyz)
  pdb.b$xyz <- xyz.b
  
  ## difference vector
  dv <- difference.vector(rbind(pdb.a$xyz[ca.inds.a$xyz],
                                pdb.b$xyz[ca.inds.b$xyz]))
  
  o1 <- overlap(modes, dv, nmodes=(modes$natoms*3)-6)
  expect_that(o1$overlap.cum[(modes$natoms*3)-6],
              equals(1, tolerance=1e-6))
  
  expect_that(o1$overlap.cum[1], equals(0.2786508, tolerance=1e-6))

  o2 <- overlap(modes$U[,7:26], dv)
  expect_that(all((round(o1$overlap[1:20] - o2$overlap, 10)==0)),
              equals(TRUE))

  ## Calculate modes with default arguments
  invisible(capture.output(modes.b <- nma(pdb.b, inds=NULL, ff='calpha',
                                          mass=FALSE, temp=300.0)))

  r <- rmsip(modes, modes.b)
  expect_that(r$overlap[1,1], equals(0.704, tolerance=1e-6))
  expect_that(r$overlap[1,2], equals(0.286, tolerance=1e-6))
  expect_that(r$overlap[2,1], equals(0.289, tolerance=1e-6))
 
}
          )

`read.pqr` <-
function (file, maxlines=-1, multi=FALSE,
          rm.insert=FALSE, rm.alt=TRUE, verbose=TRUE) {

  if(missing(file)) {
    stop("read.pqr: please specify a PQR 'file' for reading")
  }
  if(!is.numeric(maxlines)) {
    stop("read.pqr: 'maxlines' must be numeric")
  }
  if(!is.logical(multi)) {
    stop("read.pqr: 'multi' must be logical TRUE/FALSE")
  }
 
  cl <- match.call()

  ## PDB FORMAT v3.3:    colpos, datatype,   name,       description
  atom.format <- matrix(c(6,    'character', "type",     # type(ATOM)
                          5,     'numeric',   "eleno",   # atom_no
                         -1,     NA,          NA,        # (blank)
                          4,     'character', "elety",   # atom_ty
                          1,     'character', "alt",     # alt_loc
                          4,     'character', "resid",   # res_na 
                          1,     'character', "chain",   # chain_id 
                          4,     'numeric',   "resno",   # res_no
                          1,     'character', "insert",  # ins_code
                         -3,     NA,           NA,       # (blank)
                          8,     'numeric',   "x",       # x
                          8,     'numeric',   "y",       # y
                          8,     'numeric',   "z",       # z
                          8,     'numeric',   "o",       # o  ### 6 for pdb
                          8,     'numeric',   "b",       # b  ### 6 for pdb
                         -6,     NA,           NA,       # (blank)
                          4,     'character', "segid",   # seg_id
                          2,     'character', "elesy",   # element symbol
                          2,     'character', "charge"   # atom_charge (should be 'numeric']
                         ), ncol=3, byrow=TRUE,
                       dimnames = list(c(1:19), c("widths","what","name")) )

  trim <- function(s) {
    ##- Remove leading and trailing spaces from character strings
    s <- sub("^ +", "", s)
    s <- sub(" +$", "", s)
    s[(s=="")]<-""
    s
  }

  split.fields <- function(x) {
     ##- Split a character string for data.frame fwf reading
     ##  First splits a string 'x' according to 'first' and 'last'
     ##  then re-combines to new string with ";" as separator 
     x <- trim( substring(x, first, last) )
     paste(x,collapse=";")
  }

  is.character0 <- function(x){length(x)==0 & is.character(x)}


  ##- Find first and last (substr) positions for each field
  widths <-  as.numeric(atom.format[,"widths"]) # fixed-width spec
  drop.ind <- (widths < 0) # cols to ignore (i.e. -ve)
  widths <- abs(widths)    # absolute vales for later
  st <- c(1, 1 + cumsum( widths ))
  first <- st[-length(st)][!drop.ind] # substr start
  last <- cumsum( widths )[!drop.ind] # substr end
  names(first) = na.omit(atom.format[,"name"])
  names(last) = names(first)

  ##- Read 'n' lines of PDB file
  raw.lines  <- readLines(file, n = maxlines)
  type <- substring(raw.lines, first["type"], last["type"])


  ##- Check number of END/ENDMDL records
  raw.end <- sort(c(which(type == "END"),
                    which(type == "ENDMDL")))

  ## Check if we want to store multiple model data
  if (length(raw.end) > 1) {
    print("PDB has multiple END/ENDMDL records")
    if (!multi) {
      print("multi=FALSE: taking first record only")
    } else {
      print("multi=TRUE: 'read.dcd/read.ncdf' will be quicker!")
      raw.lines.multi <- raw.lines
      type.multi <- type
    }
    raw.lines <- raw.lines[ (1:raw.end[1]) ]
    type <- type[ (1:raw.end[1]) ]
  }

  ##- Check for 'n' smaller than total lines in PDB file
  if ( length(raw.end) !=1 ) {
    if (length(raw.lines) == maxlines) {
      print("You may need to increase 'maxlines'")
      print("check you have all data in $atom")
    }
  }

  ##- Split input lines by record type
  raw.header <- raw.lines[type == "HEADER"]
  raw.seqres <- raw.lines[type == "SEQRES"]
  raw.helix  <- raw.lines[type == "HELIX "]
  raw.sheet  <- raw.lines[type == "SHEET "]
  raw.atom   <- raw.lines[type %in% c("ATOM  ","HETATM")]

  if (verbose) {
    if (!is.character0(raw.header)) { cat(" ", raw.header, "\n") }
  }

  ## Edit from Baoqiang Cao <bqcao@ices.utexas.edu> Nov 29, 2009
  ## Old version:
  ##  seqres <- unlist(strsplit( trim(substring(raw.seqres,19,80))," +"))
  ## New version
  seqres <- unlist(strsplit( trim(substring(raw.seqres,19,80))," +"))
  if(!is.null(seqres)) {
    seqres.ch <- substring(raw.seqres, 12, 12)
    seqres.ln <- substring(raw.seqres, 13, 17)
    seqres.in <- ( !duplicated(seqres.ch) )
    names(seqres) <- rep(seqres.ch[seqres.in], times=seqres.ln[seqres.in])
  }
  ## End Edit from Baoqiang:

  ##- Secondary structure
  helix  <- list(start = as.numeric(substring(raw.helix,22,25)),
                 end   = as.numeric(substring(raw.helix,34,37)),
                 chain = trim(substring(raw.helix,20,20)),
                 type  = trim(substring(raw.helix,39,40)))

  sheet  <- list(start = as.numeric(substring(raw.sheet,23,26)),
                 end   = as.numeric(substring(raw.sheet,34,37)),
                 chain = trim(substring(raw.sheet,22,22)),
                 sense = trim(substring(raw.sheet,39,40)))


 ## 2014-04-23
 ## Update to use single data.frame for ATOM and HETATM records
 ## file="2RGF"; multi=TRUE; 
 ## file="./4q21.pdb"; maxlines=-1; multi=FALSE; 
 ## rm.insert=FALSE; rm.alt=TRUE; het2atom=FALSE; verbose=TRUE

  atom <- read.table(text=sapply(raw.atom, split.fields),
                    stringsAsFactors=FALSE, sep=";", quote='',
                    colClasses=unname(atom.format[!drop.ind,"what"]),
                    col.names=atom.format[!drop.ind,"name"],
                    comment.char="", na.strings="")

  ##-- End data.frame update


  ##- Coordinates only object
  ###xyz.models <- c(t(atom[,c("x","y","z")]))
  xyz.models <- matrix(as.numeric(c(t(atom[,c("x","y","z")]))), nrow=1)

  ##- Multi-model coordinate extraction 
  if (length(raw.end) > 1 && multi) {
      raw.atom  <- raw.lines.multi[ type.multi %in% c("ATOM  ","HETATM") ]

    if( (length(raw.atom)/length(raw.end)) ==nrow(atom) ){
      ## Only work with models with the same number of atoms)
      tmp.xyz=( rbind( substr(raw.atom, first["x"],last["x"]),
            substr(raw.atom, first["y"],last["y"]),
            substr(raw.atom, first["z"],last["z"]) ) )

      ## Extract coords to nrow/frame * ncol/xyz matrix
      xyz.models <- matrix( as.numeric(tmp.xyz), ncol=nrow(atom)*3,
                            nrow=length(raw.end), byrow=TRUE)
      rownames(xyz.models) = NULL

    } else {
      warning(paste("Unequal number of atoms in multi-model records:", file))
    }
    rm(raw.lines.multi)
  }
  rm(raw.lines, raw.atom)


  ##- Possibly remove 'Alt records' (m[,"alt"] != NA)
  if (rm.alt) {
    if ( sum( !is.na(atom[,"alt"]) ) > 0 ) {
      first.alt <- sort( unique(na.omit(atom[,"alt"])) )[1]
      cat(paste("   PDB has ALT records, taking",first.alt,"only, rm.alt=TRUE\n"))
      alt.inds <- which( (atom[,"alt"] != first.alt) ) # take first alt only
      if(length(alt.inds)>0) {
        atom <- atom[-alt.inds,]
        xyz.models <- xyz.models[ ,-atom2xyz(alt.inds), drop=FALSE ]
      }
    }
  }

  ##- Possibly remove 'Insert records'
  if (rm.insert) {
    if ( sum( !is.na(atom[,"insert"]) ) > 0 ) {
      cat("   PDB has INSERT records, removing, rm.insert=TRUE\n")
      insert.inds <- which(!is.na(atom[,"insert"])) # rm insert positions
      atom <- atom[-insert.inds,]
      xyz.models <- xyz.models[ ,-atom2xyz(insert.inds), drop=FALSE ]
    }
  }
  ##- Vector of Calpha positions 
  ##  check for calcium resid and restrict to ATOM records only
#  calpha = (atom[,"elety"]=="CA") & (atom[,"resid"]!="CA") & (atom[,"type"]=="ATOM")
  
  output<-list(atom=atom,
               #het=atom[atom$type=="HETATM",],
               helix=helix,
               sheet=sheet,
               seqres=seqres,
               xyz=as.xyz(xyz.models),
               calpha = NULL, call=cl)

  class(output) <- c("pdb", "sse")  
  ca.inds <-  atom.select.pdb(output, string="calpha", verbose=FALSE)
  output$calpha <- seq(1, nrow(atom)) %in% ca.inds$atom

  return(output)

}

"consensus" <-
function(alignment, cutoff=0.6) {
  #  Determine the consensus sequence for a given alignment

  if(is.list(alignment)) alignment=alignment$ali

  aa <- c("V","I","L","M",  "F","W","Y",  "S","T",
          "N","Q",  "H","K","R",  "D","E",
          "A","G",  "P","C",  "-","X")
  
  composition <- table(alignment)
  unk <- composition[!names( composition  ) %in% aa]
  if(length(unk) > 0) {
    warning(paste("\nnon standard residue code:",names(unk),"maped to X"))
    for(i in 1:length(unk))
      alignment[alignment==names(unk[i])]="X"
  }


  len <- ncol(alignment)

  freq <- matrix(0, nrow = 22, ncol = ncol(alignment),
                 dimnames = list(aa,seq(1:len)))

  for (i in 1:len) { 
    freq[names(summary((as.factor(toupper(alignment[,i]))))), i] <-
      (summary(as.factor(toupper(alignment[,i])))/length(alignment[,i]))
  }

  cons.freq <- apply(freq[1:20,], 2, max)
  cons.tmp  <- aa[apply(freq[1:20,], 2, which.max)]
  cons.tmp[cons.freq <= cutoff] = "-"

  return(list(seq=cons.tmp,
              freq=freq,
              seq.freq=cons.freq,
              cutoff=cutoff))
}

`dccm` <-
function(x, ...) {
  if(inherits(x, "matrix")) {
    class(x) <- c("matrix", "xyz")
    UseMethod("dccm", x)
  }
  else if(inherits(x, "array")) {
   class(x) <- c("matrix", "mean")
   UseMethod("dccm", x)
 }
  else 
    UseMethod("dccm")
}

context("Testing correlation network analysis")

test_that("cna() and cnapath() work properly", {

  skip_on_cran()

  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     skip('Need igraph installed to run this test')
  }

  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  capture.output(pdb <- read.pdb(file))
 
  ## Normal modes and cross-correlation matrix 
  capture.output(modes <- nma(pdb))
  capture.output(cij <- dccm(modes))

  ## network construction
  capture.output(cm <- cmap(pdb, dcut=4.5, scut=1))
  suppressWarnings(
    capture.output(net <- cna(cij, cm=cm, cutoff.cij=0))
  )
  
  expect_equal(net$communities$vcount, 129)
  expect_equal(igraph::ecount(net$network), 608)
  expect_equal(max(net$communities$membership), 5)
  expect_equal(igraph::ecount(net$community.network), 9)
 
  ## and path analysis
  capture.output(pa <- cnapath(net, from=3, to=53, k=20, collapse=TRUE, ncore=1))

  expect_equal(length(pa$path), 20)
  expect_equal(pa$path[[1]], c(3, 2, 39, 54, 53))
  expect_equal(pa$path[[20]], c(3,  2, 39, 40, 84, 53))
  expect_equal(pa$dist[1:6], c(3.427, 3.521, 3.821, 3.847, 3.868, 3.965), tolerance=1e-3)
  expect_equal(pa$epath[[10]], c(9,  13, 245, 253, 320))

  ndg0 <- matrix(c(0.65, 1, 0.35, 0.8, 0.45, 0.1, 0.3,  1, 0.5, 0.35), nrow=1,
                 dimnames = list(1, c(2, 3, 38, 39, 40, 41, 42, 53, 54, 55)) )
  capture.output(ndg <- summary(pa)$degeneracy)
  expect_equal(ndg, ndg0)

  skip_on_travis()

  capture.output(pa2 <- cnapath(net, from=3, to=53, k=20, collapse=TRUE, ncore=NULL))
  expect_equal(pa, pa2)
})

"write.fasta" <-
function(alignment=NULL,
         ids=NULL,
         seqs=alignment$ali,
         gap=TRUE,
         file,
         append = FALSE) {
  
  if (is.null(seqs))
    stop("write.fasta: please provide a 'seqs' or 'alignment' input object")
  
  if (!is.null(alignment)) {
    if (is.null(alignment$id) | is.null(alignment$ali)) {
      stop("write.fasta: 'alignment' should be a list with '$id' and '$ali'components")
    }
    if (is.null(ids)) {
      ids=alignment$id
    }
  } else {
    if (is.null(ids)) {
      n.ids <- nrow(seqs)
      if(is.null(n.ids)) { n.ids=1 }
      ids=seq( 1, length=n.ids )
    }
  } 

  if(!gap) {
     seqs[is.gap(seqs)] <- ""
  }

  if (!append) {
    ##file.remove(file, showWarnings = FALSE)
    suppressWarnings( file.remove(file) )
  }
  nseqs <- length(ids)
  if (nseqs == 1) {
     # change for shortening lines (<=60) - Xinqiu
    cat(">", ids, "\n", file = file, append = TRUE, sep = "")
    cat(seqs, file = file, append = TRUE, sep = "", fill = 60)
#    cat(">", ids, "\n", seqs, "\n", file = file,
#        append = TRUE, sep = "")
  }
  else {
    for (i in 1:nseqs) {
       cat(">", ids[i], "\n", file = file, append = TRUE, sep = "")
       cat(seqs[i,], file = file, append = TRUE, sep = "", fill = 60)
#      cat(">", ids[i], "\n", seqs[i,],
#          "\n", file = file, append = TRUE, sep = "")
    }
  }
}

cna.dccm <-  function(cij, cutoff.cij=0.4, cm=NULL,  vnames=colnames(cij),
                  cluster.method="btwn", collapse.method="max", 
                  cols=vmd_colors(), minus.log=TRUE, ...){

    
  ## Check for presence of igraph package
 oops <- requireNamespace("igraph", quietly = TRUE)
 if (!oops) {
    stop("igraph package missing: Please install, see: ?install.packages")
 }

  if (dim(cij)[1] != dim(cij)[2]) {
    stop("Input 'cij' should be a square matrix as obtained from the 'dccm()' function")
  }

  ## Check vnames/colnames if present. These are used to name nodes
  if( is.null( vnames ) ) {
    vnames <- 1:ncol(cij)
  }
  if( length(vnames) != ncol(cij) ) {
    stop("Length of input 'vnames' and number of cols in input 'cij' do not match")
  }
  colnames(cij) <- vnames
  
  ## Check 'cm' contact map if present.
  if(!is.null(cm)){
    if (dim(cm)[1] != dim(cm)[2]) {
      stop("Input 'cm' should be a square contact matrix as obtained from the 'cmap()' function")
    }
    if (any(range(cm, na.rm=T) != c(0,1))) {
      stop("Input 'cm' should be a binary contact matrix as obtained from the 'cmap()' function")
    }
    if (dim(cm)[1] != dim(cij)[1]) {
      stop("Inputs 'cij' and 'cm' should have the same dimensions")
    }
    # convert NAs to 0
    cm[is.na(cm)] = 0
  }

  
  ##-- Functions for later
  cluster.network <- function(network, cluster.method="btwn", ...){
    
    ## Passing arguments to different community detection functions
    btwn.names <- names(formals( igraph::edge.betweenness.community ))
    walk.names <- names(formals( igraph::walktrap.community ))
    greed.names <- names(formals( igraph::fastgreedy.community ))
    infomap.names <- names(formals( igraph::infomap.community ))

    dots <- list(...)
    btwn.args <- dots[names(dots) %in% btwn.names]
    walk.args <- dots[names(dots) %in% walk.names]
    greed.args <- dots[names(dots) %in% greed.names]
    infomap.args <- dots[names(dots) %in% infomap.names]

    btwn.args$directed <- FALSE

    ## Function to define community clusters from network,
    ##  cluster methods can be one of of 'cluster.options'
    cluster.options=c("btwn", "walk", "greed", "infomap")
    cluster.method <- match.arg(tolower(cluster.method), cluster.options)
    comms <- switch( cluster.method,
              btwn = do.call(igraph::edge.betweenness.community, c(list(network), btwn.args)),
              walk = do.call(igraph::walktrap.community, c(list(network), walk.args)), 
              greed = do.call(igraph::fastgreedy.community, c(list(network), greed.args)),
              infomap = do.call(igraph::infomap.community, c(list(network), infomap.args)) )
    
    names(comms$membership) <- igraph::V(network)$name
    return(comms)
  }

  contract.matrix <- function(cij.network, membership,## membership=comms$membership,
                              collapse.method="max", minus.log=minus.log){  ## Changed from minus.log=TRUE
    
    ## Function to collapse a NxN matrix to an mxm matrix
    ##  where m is the communities of N. The collapse method
    ##  can be one of the 'collapse.options' below

    ## convert to the original cij values if "-log" was used
    
    if(minus.log){
      cij.network[cij.network>0] <- exp(-cij.network[cij.network>0])
    }
    
    collapse.options=c("max", "median", "mean", "trimmed")
    collapse.method <- match.arg(tolower(collapse.method), collapse.options)

    ## Fill a 'collapse.cij' nxn community by community matrix
    node.num <- max(membership)
    if(node.num > 1){
      collapse.cij <- matrix(0, nrow=node.num, ncol=node.num)
      inds <- pairwise(node.num)

      for(i in 1:nrow(inds)) {
        comms.1.inds <- which(membership==inds[i,1])
        comms.2.inds <- which(membership==inds[i,2])
        submatrix <- cij.network[comms.1.inds, comms.2.inds]

        ## Use specified "collapse.method" to define community couplings
        collapse.cij[ inds[i,1], inds[i,2] ] = switch(collapse.method,
                    max = max(submatrix),
                    median = median(submatrix),
                    mean = mean(submatrix),
                    trimmed = mean(submatrix, trim = 0.1))
      }
      
      if(minus.log){
        collapse.cij[collapse.cij>0] <- -log(collapse.cij[collapse.cij>0])
      }
      
      ## Copy values to lower triangle of matrix and set colnames
      collapse.cij[ inds[,c(2,1)] ] = collapse.cij[ inds ]
      colnames(collapse.cij) <- 1:ncol(collapse.cij)
    }
    else{
      warning("There is only one community in the $communities object.
               $community.cij object will be set to 0 in the 
               contract.matrix() function.")

      collapse.cij <- 0
    }

    class(collapse.cij) <- c("dccm", "matrix")
    return(collapse.cij)
  }
  
  ## Store the command used to submit the calculation
  cl <- match.call()
  
  ##- Take absolute value of 'cij'
  cij.abs <- abs(cij)

  ## Filter: set to 0 all values below the cutoff
  cij.abs[cij.abs < cutoff.cij] = 0

  if(minus.log){
    ##-- Calculate the -log of cij
    ## change cij >= 0.9999 to 0.9999 to avoid numerical problems 
    ##   (-log is too close to zero)

    cij.network <- cij.abs
    cij.network[cij.network >= 0.9999] = 0.9999
    cij.network <- -log(cij.network)
    ## remove infinite values
    cij.network[is.infinite(cij.network)] = 0
  }
  else{
    cij.network <- cij.abs
  }

  if(!is.null(cm)){  
    ##-- Filter cij by contact map
    cij.network <- cij.network * cm
  }

  ##  cij.network contains either the -log(abs.cij) or just abs.cij. 
  ##   (the default is minus.log=TRUE)
  
  ##-- Make an igraph network object
  network <- igraph::graph.adjacency(cij.network,
                             mode="undirected",
                             weighted=TRUE,
                             diag=FALSE)
  
  ##-- Calculate the first set of communities
  communities <- cluster.network(network, cluster.method, ...)

  ##-- Coarse grain the cij matrix to a new cluster/community matrix
  community.cij <- contract.matrix(cij.network, communities$membership, 
                                   collapse.method, minus.log)

  ##-- Generate a coarse grained network --##
  if(sum(community.cij)>0){
    community.network <-  igraph::graph.adjacency(community.cij,
                               mode="undirected",
                               weighted=TRUE,
                               diag=FALSE)

    ##-- Cluster the community network to obtain super-communities -- OLD VERSION
    ## clustered.communities <- cluster.network(community.network, cluster.method)

    ##-- Annotate the two networks with community information
    ## Check for duplicated colors
    if(max(communities$membership) > length(unique(cols)) ) {
      warning("The number of communities is larger than the number of unique 
              'colors' provided as input. Colors will be recycled")
    }
  
    ## Set node colors
    igraph::V(network)$color <- cols[communities$membership]
    igraph::V(community.network)$color <- cols[ 1:max(communities$membership)]
  
    ## Set node sizes
    igraph::V(network)$size <- 1
    igraph::V(community.network)$size <- table(communities$membership)

  } else{
    warning("The $communities structure does not allow a second clustering 
            (i.e. the collapsed community.cij matrix contains only 0). 
            'community.network' object will be set to NA")
      
    community.network <- NA
    clustered.communities <- NA
      
    if(max(communities$membership) > length(unique(cols)) ) {
      warning("The number of communities is larger than the number of unique 
              'colors' provided as input. Colors will be recycled")
    }
  
    ## Set node colors
    igraph::V(network)$color <- cols[communities$membership]

    ## Set node sizes
    igraph::V(network)$size <- 1
  }
  
  ## Output
  output <- list("network"=network,
                 "communities"=communities,
                 "community.network"=community.network,
                 "community.cij"=community.cij,
                 "cij"=cij.network,
                 call = cl)

  class(output)="cna"

  return(output)
}
  

"print.geostas" <- function(x, ...) {
    
  cn <- class(x)
  ndoms <- length(unique(x$grps))
  dims <- dim(x$amsm)
  
  cat("\nCall:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  
  cat("Class:\n  ", cn, "\n\n", sep = "")

  cat("Dimensions of AMSM:\n  ", dims[1], "x", dims[2], "\n\n", sep="")
  
  cat("Number of domains:\n  ", ndoms, "\n\n", sep="")

  cat("Domain size:\n")
  for(i in 1:ndoms) {
    cat("  #", i, ": ", length(x$inds[[i]]$atom), " atoms \n", sep="")
  }

  cat("\n")
  
  i <- paste( attributes(x)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")

  invisible(x)
}

#' All Atom Normal Mode Analysis
#'
#' Perform all-atom elastic network model normal modes calculation of a protein
#' structure.
#'
#' @details This function builds an elastic network model (ENM) based on all
#' heavy atoms of input \code{pdb}, and performs subsequent normal mode
#' analysis (NMA) in various manners. By default, the \sQuote{aaenm2} force
#' field (defining of the spring constants between atoms) is used, which was
#' obtained by fitting to a local energy minimum of a crambin model
#' derived from the AMBER99SB force field. It employs a pair force constant
#' function which falls as r^-6, and specific force constants for
#' covalent and intra-residue atom pairs. See also \code{\link{load.enmff}}
#' for other force field options.
#'
#' The \code{outmodes} argument controls the type of output modes. There are
#' two standard types of output modes: \sQuote{noh} and \sQuote{calpha}.
#' \code{outmodes='noh'} invokes regular all-atom based ENM-NMA. When
#' \code{outmodes='calpha'}, an effective Hessian with respect to all C-alpha
#' atoms will be first calculated using the same formula as in Hinsen et al.
#' NMA is then performed on this effective C-alpha based Hessian. In addition,
#' users can provide their own atom selection (see \code{\link{atom.select}})
#' as the value of \code{outmodes} for customized output modes generation.
#'
#' When \code{reduced=TRUE}, only a selection of all heavy atoms is used
#' to build the ENM. More specifically, three to five atoms per residue
#' constitute the model. Here the N, CA, C atoms represent the protein
#' backbone, and zero to two selected side chain atoms represent the side chain
#' (selected based on side chain size and the distance to CA). This
#' coarse-grained ENM has significantly improved computational efficiency and
#' similar prediction accuracy with respect to the all-atom ENM.
#'
#' When \code{rtb=TRUE}, rotation-translation block (RTB) based approximate
#' modes will be calculated. In this method, each residue is assumed to be a
#' rigid body (or \sQuote{block}) that has only rotational and translational
#' degrees of freedom. Intra-residue deformation is thus ignored.
#' (See Durand et al 1994 and Tama et al. 2000 for more details). N residues per
#' block is also supported, where N=1, 2, 3, etc. (See argument \code{nmer}).
#' The RTB method has significantly improved computational efficiency and
#' similar prediction accuracy with respect to the all-atom ENM.
#'
#' By default the function will diagonalize the mass-weighted Hessian matrix.
#' The resulting mode vectors are moreover scaled by the thermal fluctuation
#' amplitudes.
#'
#' @param pdb an object of class \code{pdb} as obtained from function
#'    \code{\link{read.pdb}}.
#' @param pfc.fun customized pair force constant (\sQuote{pfc}) function. The
#'    provided function should take a vector of distances as an argument to
#'    return a vector of force constants. If NULL, the default function
#'    \sQuote{aaenm2} will be employed. (See details below).
#' @param mass logical, if TRUE the Hessian will be mass-weighted.
#' @param temp numerical, temperature for which the amplitudes for scaling the
#'    atomic displacement vectors are calculated. Set \sQuote{temp=NULL} to
#'    avoid scaling.
#' @param keep numerical, final number of modes to be stored. Note that all
#'    subsequent analyses are limited to this subset of modes. This option is
#'    useful for very large structures and cases where memory may be limited.
#' @param hessian hessian matrix as obtained from \code{\link{build.hessian}}.
#'    For internal purposes and generally not intended for public use.
#' @param outmodes either a character (\sQuote{calpha} or \sQuote{noh}) or atom
#'    indices as obtained from \code{\link{atom.select}} specifying the atoms to
#'    include in the resulting mode object. (See details below).
#' @param rm.wat logical, if TRUE water molecules will be removed before
#'    calculation.
#' @param reduced logical, if TRUE the coarse-grained (\sQuote{4-bead}) ENM will
#'    be employed. (See details below).
#' @param rtb logical, if TRUE the rotation-translation block based
#'    approximate modes will be calculated. (See details below).
#' @param nmer numerical, defines the number of residues per block (used only
#'     when \code{rtb=TRUE}).
#' @param ... additional arguments to \code{\link{build.hessian}} and
#'    \code{\link{aa2mass}}. One useful option here for dealing with
#'    unconventional residues is \sQuote{mass.custom}, see the
#'    \code{\link{aa2mass}} function for details.
#'
#' @return Returns an object of class \sQuote{nma} with the following
#'    components:
#'    \item{modes}{ numeric matrix with columns containing the normal mode
#'       vectors. Mode vectors are converted to unweighted Cartesian
#'       coordinates  when \code{mass=TRUE}. Note that the 6 first trivial
#'       eigenvectos appear in columns one to six. }
#'    \item{frequencies}{ numeric vector containing the vibrational
#'       frequencies corresponding to each mode (for \code{mass=TRUE}). }
#'    \item{force.constants}{ numeric vector containing the force constants
#'       corresponding to each mode (for \code{mass=FALSE)}). }
#'    \item{fluctuations}{ numeric vector of atomic fluctuations. }
#'    \item{U}{ numeric matrix with columns containing the raw
#'       eigenvectors. Equals to the \code{modes} component when
#'      \code{mass=FALSE} and \code{temp=NULL}. }
#'    \item{L}{ numeric vector containing the raw eigenvalues. }
#'    \item{xyz}{ numeric matrix of class \code{xyz} containing the
#'      Cartesian coordinates in which the calculation was performed. }
#'    \item{mass}{ numeric vector containing the residue masses used for the
#'      mass-weighting. }
#'    \item{temp}{ numerical, temperature for which the amplitudes for
#'      scaling the atomic displacement vectors are calculated. }
#'    \item{triv.modes}{ number of trivial modes. }
#'    \item{natoms}{ number of C-alpha atoms. }
#'    \item{call}{ the matched call. }
#'
#' @seealso
#'    \code{\link{nma.pdb}} for C-alpha based NMA, \code{\link{aanma.pdbs}} for
#'    ensemble all-atom NMA, \code{\link{load.enmff}} for available ENM force
#'    fields, and \code{\link{fluct.nma}}, \code{\link{mktrj.nma}}, and
#'    \code{\link{dccm.nma}} for various post-NMA calculations.
#'
#' @author Lars Skjaerven & Xin-Qiu Yao
#'
#' @references
#'    Hinsen, K. et al. (2000) \emph{Chem. Phys.} \bold{261}, 25.
#'    Durand, P. et al. (1994) \emph{Biopolymers} \bold{34}, 759.
#'    Tama, F. et al. (2000) \emph{Proteins} \bold{41}, 1.
#'
#' @examples
#' \dontrun{
#'    # All-atom NMA takes relatively long time - Don't run by default.
#'
#'    ## Fetch stucture
#'    pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
#'
#'    ## Calculate all-atom normal modes
#'    modes.aa <- aanma(pdb, outmodes='noh')
#'
#'    ## Calculate all-atom normal modes with RTB approximation
#'    modes.aa.rtb <- aanma(pdb, outmodes='noh', rtb=TRUE)
#'
#'    ## Compare the two modes
#'    rmsip(modes.aa, modes.aa.rtb)
#'
#'    ## Calculate C-alpha normal modes.
#'    modes <- aanma(pdb)
#'
#'    ## Calculate C-alpha normal modes with reduced ENM.
#'    modes.cg <- aanma(pdb, reduced=TRUE)
#'
#'    ## Calculate C-alpha normal modes with RTB approximation
#'    modes.rtb <- aanma(pdb, rtb=TRUE)
#'
#'    ## Compare modes
#'    rmsip(modes, modes.cg)
#'    rmsip(modes, modes.rtb)
#'
#'    ## Print modes
#'    print(modes)
#'
#'    ## Plot modes
#'    plot(modes)
#'
#'    ## Visualize modes
#'    #m7 <- mktrj.nma(modes, mode=7, file="mode_7.pdb", pdb=pdb)
#' }

"aanma.pdb" <- function(pdb, pfc.fun=NULL, mass=TRUE,
                    temp=300.0, keep=NULL, hessian=NULL, outmodes='calpha',
                    rm.wat=TRUE, reduced=FALSE, rtb=FALSE, nmer=1, ... ) {

  ## Log the call
  cl <- match.call()

  if(!is.select(outmodes) && !outmodes %in% c("calpha", "noh"))
    stop("outmodes must be 'calpha', 'noh', or an atom selection by 'atom.select()'")

  if(!is.pdb(pdb))
    stop("please provide a 'pdb' object as obtained from 'read.pdb()'")

  ## store the original input PDB
  pdb0 <- pdb

  ## Define force field
  if (is.null(pfc.fun)) {
      pfc.fun <- load.enmff("aaenm2")
  }
  else {
      ## Use customized force field
      if(!is.function(pfc.fun))
          stop("'pfc.fun' must be a function")
  }

  ## Parse additional arguments
  args <- .nma.args(pfc.fun=pfc.fun, ...)

  ## check and prepare input PDB
  if(!is.null(hessian)) {
    pdb.in <- pdb
    dims <- dim(hessian)
    if(dims[1]!=dims[2] | dims[1]!=length(pdb.in$xyz))
      stop("dimension mismatch")
  }
  else {
    if(rm.wat)
      pdb <- trim.pdb(pdb, "notwater", verbose=FALSE)

    pdb.in <- trim.pdb(pdb, "noh", verbose=FALSE)

    lig.inds <- atom.select(pdb.in, "ligand")
    if(length(lig.inds$atom)>0) {
      ligs <- paste(unique(pdb.in$atom$resid[ lig.inds$atom ]), sep=", ")
      warning(paste("ligands", paste(ligs, collapse=", "), "included in normal modes calculation"))
    }
  }

  ## reduced aaENM
  if(reduced) {
      pdb.in <- .nma.reduce.pdb(pdb.in)
  }

  ## Indices for effective hessian
  ## (selection, calphas, or all (noh) atoms)
  if(!is.select(outmodes)) {
      if(outmodes=="calpha") {
          outmodes <- atom.select(pdb0, "calpha")
      }
      else if(outmodes=="noh") {
          outmodes <- atom.select(pdb0, "noh")
      }
  }

  if(is.select(outmodes)) {
    ## since pdb might have changed, we need to re-select 'outmodes'
    ## outmodes points to original input 'pdb' object
    ## inc.inds points to modified 'pdb.in' object
    inc.inds <- .match.sel(pdb0, pdb.in, outmodes)
    pdb.out <- trim(pdb.in, inc.inds)
  }

  natoms.in <- nrow(pdb.in$atom)
  natoms.out <- nrow(pdb.out$atom)

  if (natoms.in<3 | natoms.out<3)
    stop("aanma: insufficient number of atoms")

  ## Masses for weighting the hessian
  ## Note that mass weighting is done in rtb() for rtb=TRUE,
  ## and in .nma.mwhessian() when rtb=FALSE
  if (mass) {
      masses.in <-  atom2mass(pdb.in)

      ## for residue mass
      resids <- paste(pdb.in$atom$resno,
                      pdb.in$atom$chain,
                      pdb.in$atom$insert, sep="_")

      ## group masses if outmodes contains only one atom per residue
      if(!any(duplicated(resids[ inc.inds$atom ]))) {
          masses.out <- unlist(lapply(split(masses.in, resids), sum))
          masses.out <- masses.out[ resids[ inc.inds$atom ] ]
      }
      ## else, use indivdual atom masses
      else {
          if(length(resids[ inc.inds$atom]) == length(masses.in)) {
              masses.out <- masses.in
          }
          else {
              warning("mass weighting could not be grouped by residues")
                masses.out <- masses.in[ inc.inds$atom ]
          }
      }
  }
  else {
    ## No mass-weighting
    masses.out <- NULL;
  }

  ## build full hessian
  H <- .nma.hess(pdb.in$xyz, pfc.fun=pfc.fun, args=args,
                 hessian=hessian, pdb=pdb.in)

  ## extract effective hessian and diagonalize
  if(rtb) {
      ## effective hessian
      H <- .nma.trim.hessian.rtb(H, inc.inds=inc.inds, pdb=pdb.in, nmer=nmer)

      ## mass weighting + diagonalize using RTB
      ei <- rtb(H, pdb=pdb.out, mass=masses.out, nmer=nmer)
  }
  else {
      ## effective hessian
      H <- .nma.trim.hessian(H, inc.inds=inc.inds)

      ## mass weight hessian
      if(!is.null(masses.out))
          H <- .nma.mwhessian(H, masses=masses.out)

      ## diagaonalize and obtain eigenvectors
      ei <- .nma.diag(H)
  }

  ## make NMA object
  m <- .nma.finalize(ei, xyz=pdb.out$xyz, temp=temp, masses=masses.out,
                             natoms=natoms.out, keep=keep, call=cl)
  return(m)
}

pdbfit <- function(...)
  UseMethod("pdbfit")

pdbfit.pdb <- function(pdb, inds=NULL, ...) {
  if(!is.pdb(pdb))
    stop("Input 'pdb' should be of class 'pdb', e.g. from read.pdb()")

  if(nrow(pdb$xyz)<2)
    stop("nothing to fit. < 2 frames in pdb object")

  if(is.null(inds)) {
    inds <- atom.select(pdb, "calpha")
    cat("  no indices provided. using all", length(inds$atom), "calpha atoms\n")
  }

  if(length(inds$xyz)<3)
    stop("insufficent atoms to superimpose")

  return(fit.xyz( fixed=pdb$xyz[1,], mobile=pdb$xyz,
                 fixed.inds=inds$xyz, mobile.inds=inds$xyz))
  
}

pdbfit.pdbs <- function(pdbs, inds=NULL, outpath=NULL, ...) {
  ##
  ## Quick Fit Fitter for PDBs
  ##  was called 'fit.pdbs()' in model.R
  ##
  if(!inherits(pdbs, "pdbs")) {
    stop("Input 'pdbs' should be of class 'pdbs', e.g. from pdbaln() or read.fasta.pdb()")
  }
  full <- ifelse(is.null(outpath), FALSE, TRUE)
  if(is.null(inds)) {    inds <-gap.inspect(pdbs$xyz)$f.inds  }
  if(is.list(inds)){ inds=inds$xyz }
  invisible( fit.xyz( fixed=pdbs$xyz[1,], mobile=pdbs, fixed.inds=inds,
                  mobile.inds=inds, outpath=outpath,
                  full.pdbs=full, ... ))
}

.arg.filter <- function(new.args, FUN=NULL, ...) {
  ##-- Simple list filtering for duplicate 
  ##    function input argument removal and validation.
  ##
  ## new.args = The new default args that can be overwritten 
  ##              by those in 'dots' (i.e. user supplied "...") 
  ##               E.G. "new.args=list(col=mydefualtcol, lwd=3)"
  ##
  ## FUN      = Function name from which allowed arguments are checked
  ##              and used to limit output of this function.
  ##              This is typically only required if there are multiple 
  ##              (sub)functions to be called each with other specific  
  ##              things in /dots.
  ##               E.G. allowed=names(formals( mysubfunction2call ))
  ##
  ## dots     = Full user supplied updated values typically 
  ##               this is the extra /dots values, i.e. list(...) 
  ##    
  ##   sse.default <- list(coil="gray", helix="purple", sheet="yellow")
  ##   sse.args <- arg.filter( sse.default, FUN=sse.vector )
  ##   col <- do.call('sse.vector', c(list(pdb=pdb), sse.args) )
  ##
  ## Returns entries of 'dots' updated with those in 'new.args'
  ##   that intersect with allowed FUN input args.
  
  dots <- list(...)
  ans <- c(dots, new.args[!names(new.args) %in% names(dots)])
  if(!is.null(FUN)) { ans <- ans[names(ans) %in% names(formals(FUN))] }
  return(ans)
}

"pca.tor" <-
function(data, ... ) {

  data[data < 0]    <- data[data < 0] + 360
  data[data < -180] <- data[data < -180] + 360
  data[data >  180] <- data[data >  180] - 360
  ##cat("Rescaled (-180 to 180) and corrected for periodicity\n")
  data <- wrap.tor(data)
  return( pca.xyz(data, ...) )
}

`motif.find` <-
function(motif, sequence) {
  ## return indices of motif within sequence
  position <- regexpr( paste(motif, collapse=""), paste(sequence,collapse=""))
  inds <- c(position):c(position+attr(position, "match.length")-1)
  return(inds)
}

print.prmtop <- function(x, printseq=TRUE, ...) {
  if(!is.null(x$SOLVENT_POINTER))
    sbox <- TRUE
  else
    sbox <- FALSE
  
  cn <- class(x)
  natom <-  x$POINTERS[1]
  ##nca <- length(which(x$ATOM_NAME=="CA" & x$AMBER_ATOM_TYPE=="CX"))
  
  if(sbox) {
    nres.total <- x$POINTERS[12]
    nres.solute <- x$SOLVENT_POINTER[1]

    nmol.total <- x$SOLVENT_POINTER[2]
    nmol.solute <- x$SOLVENT_POINTER[3]-1

    natom.per.mol <- x$ATOMS_PER_MOLECULE[1:nmol.solute]
    box.dim <- x$BOX_DIMENSIONS
  }
  else {
    nres.total <- x$POINTERS[12]
    nres.solute <- nres.total

    nmol.total <- length(which(x$ATOM_NAME=="OXT"))
    nmol.solute <- nmol.total
  }

  
  cat("\n Call:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  
  cat(" Class:\n  ", paste(cn, collapse=", "),
      "\n\n", sep = "")

  cat(" System information:", "\n")
  cat("      Total number of atoms:  ", natom, "\n", sep="")

  if(nres.solute!=nres.total) {
    cat("      Solute residues:  ", nres.solute, " (of ", nres.total, ")\n", sep="")
    cat("      Solute molecules:  ", nmol.solute, " (of ", nmol.total, ")\n", sep="")
  }
  else {
    cat("      Solute residues:  ", nres.solute, "\n", sep="")
    cat("      Solute molecules:  ", nmol.solute, "\n", sep="")
  }

  if(sbox)
    cat("      Box dimensions:  ", paste(round(box.dim,2), collapse=" x "), "\n", sep="")


  if(printseq) {
    aa <- aa321(x$RESIDUE_LABEL[1:nres.solute])
    if(nres.solute > 225) {
      ## Trim long sequences before output
      aa <- c(aa[1:225], "...<cut>...", aa[(nres.solute-3):nres.solute])
    }
    aa <- paste("     ",  gsub(" ","", 
            strwrap( paste(aa,collapse=" "), 
            width=120, exdent=0) ), collapse="\n")
    cat("\n")
    cat(" Sequence:\n", aa, "\n", sep="")


    ## other residues
    if(nres.total>nres.solute) {
      unq.res <- unique(x$RESIDUE_LABEL[(nres.solute+1):length(x$RESIDUE_LABEL)])
      unq.res <- paste("     ",  gsub(" ","", 
                       strwrap( paste(unq.res,collapse=" "), 
                        width=120, exdent=0) ), collapse="\n")
      cat("\n")
      cat(" Residues in solvent:\n", unq.res, "\n", sep="")
    }

  }

  

  cat("\n")

  #i <- paste( attributes(x)$names, collapse=", ")
  #cat(strwrap(paste(" + attr:",i,"\n"),width=45, exdent=8), sep="\n")

  invisible( c(natom=natom, nres=nres.total, nres.solute=nres.solute,
               nmol=nmol.total, nmol.solute=nmol.solute) )
}

read.cif <- function(file, maxlines = -1, multi=FALSE,
                     rm.insert=FALSE, rm.alt=TRUE, verbose=TRUE) {

    cl <- match.call()
    warning("beta version of `read.cif`. please use with caution")
    warning("helix/sheet records could not be parsed")
    
    if(missing(file)) {
        stop("read.cif: please specify a CIF 'file' for reading")
    }
    
    if(!is.logical(multi)) {
        stop("read.cif: 'multi' must be logical TRUE/FALSE")
    }
    
    ##- Check if file exists locally or on-line
    putfile <- NULL
    if(substr(file,1,4)=="http") {
        ## cpp function can not read from http
        putfile <- tempfile(fileext=".cif")
        rt <- try(download.file(file, putfile, quiet = !verbose), silent=TRUE)
        if(inherits(rt, "try-error")) {
            file.remove(putfile)
            stop("File not found at provided URL")
        }
        else {
            file <- putfile
        }
    }
    
    toread <- file.exists(file)
    if(toread & basename(file) != file) {
        file <- normalizePath(file)
    }

    ## Check for 4 letter code and possible on-line file
    if(!toread) {
        if(nchar(file)==4) {
            cat("  Note: Accessing on-line CIF file\n")
            file <- get.pdb(file, path=tempdir(), quiet=TRUE, format="cif")
        }
        else {
            stop("No input CIF file found: check filename")
        }
    }
    
    ## parse CIF file with cpp function
    pdb <- .read_cif(file, maxlines=maxlines, multi=multi)
    
    ## remove temp file if we downloaded it above
    if(!is.null(putfile)) {
        file.remove(putfile)
    }

    #if(verbose)
    #    cat(" ", pdb$header, "\n")
    #pdb$header <- NULL
    
    if(!is.null(pdb$error))
        stop(paste("Error in reading CIF file", file))
    else
        class(pdb) <- c("pdb") ## this should be cif perhaps?
    
    if(pdb$models > 1)
        pdb$xyz <- matrix(pdb$xyz, nrow=pdb$models, byrow=TRUE)
    
    pdb$xyz <- as.xyz(pdb$xyz)
    
    ## set empty strings to NA
    pdb$atom[pdb$atom==""] <- NA
    pdb$atom[pdb$atom=="?"] <- NA
    pdb$atom[pdb$atom=="."] <- NA
    pdb$models <- NULL


    ## Remove 'Alt records'
    if (rm.alt) {
        if ( sum( !is.na(pdb$atom$alt) ) > 0 ) {
            first.alt <- sort( unique(na.omit(pdb$atom$alt)) )[1]
            cat(paste("   PDB has ALT records, taking",first.alt,"only, rm.alt=TRUE\n"))
            alt.inds <- which( (pdb$atom$alt != first.alt) ) # take first alt only
            if(length(alt.inds)>0) {
                pdb$atom <- pdb$atom[-alt.inds,]
                pdb$xyz <- trim.xyz(pdb$xyz, col.inds=-atom2xyz(alt.inds))
            }
        }
    }
    
    ## Remove 'Insert records'
    if (rm.insert) {
        if ( sum( !is.na(pdb$atom$insert) ) > 0 ) {
            cat("   PDB has INSERT records, removing, rm.insert=TRUE\n")
            insert.inds <- which(!is.na(pdb$atom$insert)) # rm insert positions
            pdb$atom <- pdb$atom[-insert.inds,]
            pdb$xyz <- trim.xyz(pdb$xyz, col.inds=-atom2xyz(insert.inds))
        }
    }
    
    if(any(duplicated(pdb$atom$eleno)))
        warning("duplicated element numbers ('eleno') detected")
    
    ## construct c-alpha attribute
    ca.inds <-  atom.select.pdb(pdb, string="calpha", verbose=FALSE)
    pdb$calpha <- seq(1, nrow(pdb$atom)) %in% ca.inds$atom
    
    ## set call
    pdb$call <- cl
    
    return(pdb)
}

"print.nma" <-
  function(x, nmodes=6, ...) {

    cn <- class(x)
    
    cat("\nCall:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
        "\n\n", sep = "")
    
    cat("Class:\n  ", cn[1], " (",  cn[2], ")",
        "\n\n", sep = "")
    
    cat("Number of modes:\n  ", length(x$L), " (", x$triv.modes, " trivial)",
        "\n\n", sep="")

    inds <- (x$triv.modes+1):(x$triv.modes+nmodes)
    if(!is.null(x$frequencies)) {
      freqs <- round(x$frequencies[inds], 3)
      cat("Frequencies:\n", sep="")
    }
    else {
      freqs <- round(x$force.constants[inds], 3)
      cat("Force constants:\n", sep="")
    }
    
    i <- x$triv.modes
    for ( f in freqs ) {
      i <- i+1
      cat("  Mode ", i, ": \t", f,  "\n", sep="")
    }
    
    cat("\n")

  i <- paste( attributes(x)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")

    invisible(x)
  }

"read.all" <-
function(aln, prefix="", pdbext="", sel=NULL, rm.wat=TRUE, rm.ligand=FALSE, 
             compact=TRUE, ncore=NULL, ...) {

  ## Usage:
  ## sel <- c("N", "CA", "C", "O", "CB", "*G", "*D",  "*E", "*Z")
  ## pdbs.all <- read.all(aln, sel=sel)

  if(!inherits(aln, 'fasta')) 
      stop( paste("input 'aln' should be a list object as obtained from ", 
                  "'seqaln()', 'pdbaln()', or 'read.fasta.pdb()'") )

  dots <- list(...)
  if(!'verbose' %in% names(dots)) dots$verbose = FALSE

  ## Log the call
  cl <- match.call()

  ncore <- setup.ncore(ncore)
 
  files  <- paste(prefix, aln$id, pdbext,sep="")

  ##cat(files,sep="\n")
  toread <- file.exists(files)

  ## check for online files
  toread[ substr(files,1,4)=="http" ] <- TRUE


  if(all(!toread))
    stop("No corresponding PDB files found")

  ## Avoid multi-thread downloading
  if(any(substr(files,1,4) == "http")) {
     ncore = 1
  }

  if(ncore>1) {
    prev.warn <- getOption("warn")
    options(warn=1)
    on.exit(options(warn=prev.warn))
  }

  ## make default selection
  if(is.null(sel)) sel <- store.atom()

  blank <- rep(NA, ncol(aln$ali))
  blank.all <- rep(NA, ncol(aln$ali)*length(sel))

#  for (i in 1:length(aln$id)) {
  rtn <- mclapply(1:length(aln$id), function(i) {

    cat(paste("pdb/seq:",i,"  name:", aln$id[i]),"\n")

    if(!toread[i]) {
      warning(paste("No PDB file found for seq", aln$id[i],
              ": (with filename) ",files[i]), call.=FALSE)
      coords <- rep(blank,3)
      res.nu <- blank
      res.bf <- blank
      res.ch <- blank
      res.id <- blank
      res.ss <- blank
      res.in <- blank
      ## all atom data
      coords.all <- rep(blank.all, 3)
      elety.all <- blank.all
      resid.all <- blank.all 
      resno.all <- blank.all
      hetatm <- NULL
      ##
      ##coords.all
      ##
    } else {
      pdb <- do.call(read.pdb, c(list(files[i]), dots) )

      ## Always remove hydrogen
      pdb <- atom.select(pdb, 'noh', value=TRUE, verbose=FALSE)

      hetatm <- atom.select(pdb, 'protein', inverse=TRUE, value=TRUE, verbose=FALSE)

      if(rm.wat)
        hetatm <- trim(hetatm, 'water', inverse=TRUE, verbose=FALSE)

      if(rm.ligand)
        hetatm <- trim(hetatm, 'ligand', inverse=TRUE, verbose=FALSE)

      if(nrow(hetatm$atom)==0) hetatm <- NULL

      ## Following works on protein only
      pdb <- atom.select(pdb, 'protein', value=TRUE, verbose=FALSE)

      ca.inds <- atom.select(pdb, "calpha", verbose=FALSE)
      pdbseq  <- pdbseq(pdb)
      aliseq  <- toupper(aln$ali[i,])
      tomatch <- gsub("X","[A-Z]",aliseq[!is.gap(aliseq)])

      if(length(pdbseq)<1)
        stop(paste(basename(aln$id[i]), ": insufficent Calpha's in PDB"), call.=FALSE)
      
      ##-- Search for ali residues (1:15) in pdb
      start.num <- regexpr(pattern = paste(c(na.omit(tomatch[1:15])),collapse=""),
                           text = paste(pdbseq,collapse=""))[1]
      if (start.num == -1) {
        stop("Starting residues of sequence not found in PDB")
      }

      ##-- Numeric vec, 'nseq', for mapping aln to pdb
      nseq <- rep(NA,length(aliseq))
      ali.res.ind <- which(!is.gap(aliseq))
      if( length(ali.res.ind) > (length(pdbseq) - start.num + 1) ) {
        warning(paste(aln$id[i],
         ": sequence has more residues than PDB has Calpha's"), call.=FALSE)
        ali.res.ind <- ali.res.ind[1:(length(pdbseq)-start.num+1)] ## exclude extra
        tomatch <-  tomatch[1:(length(pdbseq)-start.num+1)]        ## terminal residues
      }
      nseq[ali.res.ind] = start.num:((start.num - 1) + length(tomatch))

      ##-- Check for miss-matches
      match <- aliseq != pdbseq[nseq] 
      if ( sum(match, na.rm=TRUE) >= 1 ) {
        mismatch.ind <- which(match)
        mismatch <- cbind(aliseq, pdbseq[nseq])[mismatch.ind,]
        n.miss <- length(mismatch.ind)

        if(sum(mismatch=="X") != n.miss) { ## ignore masked X res        
          details <- rbind(aliseq, !match,
                           pdbseq[nseq],
                           pdb$atom[pdb$calpha,"resno"][nseq] )
                           #### calpha[,"resno"][nseq] ) ###- typo??
          details <- seqbind(aliseq, pdbseq[nseq])
          details$ali[is.na(details$ali)] <- "-"
          rownames(details$ali) <- c("aliseq","pdbseq")
          details$id <- c("aliseq","pdbseq")
          
          resmatch <- which(!apply(details$ali, 2, function(x) x[1]==x[2]))
          
          resid <- paste(pdb$atom$resid[ca.inds$atom][nseq][resmatch][1], "-",
                         pdb$atom$resno[ca.inds$atom][nseq][resmatch][1],
                         " (", pdb$atom$chain[ca.inds$atom][nseq][resmatch][1], ")", sep="")
          
          cat("\n ERROR   Alignment mismatch. See alignment below for further details\n")
          cat("         (row ", i, " of aln and sequence of '", aln$id[i], "').\n", sep="")
          cat("         First mismatch residue in PDB is:", resid, "\n")
          cat("         occurring at alignment position:", which(match)[1], "\n\n")
          .print.fasta.ali(details)
          
          msg <- paste(basename.pdb(aln$id[i]),
                       " alignment and PDB sequence miss-match\n",
                       "       beginning at position ",
                       which(match)[1], " (PDB RESNO ", resid, ")", sep="")
          stop(msg, call.=FALSE)

        }
      }
      
      ##-- Store nseq justified PDB data
      ca.ali <- pdb$atom[pdb$calpha,][nseq,]
      coords <- as.numeric( t(ca.ali[,c("x","y","z")]) )
      res.nu <- ca.ali[, "resno"]
      res.bf <- as.numeric( ca.ali[,"b"] )
      res.ch <- ca.ali[, "chain"]
      res.id <- ca.ali[, "resid"]
      res.in <- ca.ali[, "insert"]
      
      sse <- pdb2sse(pdb, verbose = FALSE)
      if(!is.null(sse)) 
        res.ss <- sse[nseq]
      else
        res.ss <- blank

      raw <- store.atom(pdb)
      coords.all <- as.numeric( raw[c("x","y","z"), sel, nseq] )
      elety.all <- c(raw[c("elety"),sel,nseq])
      resid.all <- c(raw[c("resid"),sel,nseq])
      resno.all <- c(raw[c("resno"),sel,nseq])

##      raw <- store.main(pdb)
##      b <- cbind(b, raw[,,nseq])

    } # end else 
    list(coords=coords, coords.all=coords.all, res.nu=res.nu, res.bf=res.bf,
         res.ch=res.ch, res.id=res.id, res.in=res.in, res.ss=res.ss, elety.all=elety.all, 
         resid.all=resid.all, resno.all=resno.all, hetatm=hetatm)
  }, mc.cores=ncore, mc.allow.recursive=FALSE) # end for

  tryerr <- which(sapply(rtn, inherits, 'try-error'))
  if(length(tryerr)>0) {
    stop(as.character(rtn[[tryerr[1]]]))
  }

  coords <- do.call( rbind, unname(sapply(rtn, '[', 'coords')) )
  res.nu <- do.call( rbind, unname(sapply(rtn, '[', 'res.nu')) )
  res.bf <- do.call( rbind, unname(sapply(rtn, '[', 'res.bf')) )
  res.ch <- do.call( rbind, unname(sapply(rtn, '[', 'res.ch')) )
  res.id <- do.call( rbind, unname(sapply(rtn, '[', 'res.id')) )
  res.ss <- do.call( rbind, unname(sapply(rtn, '[', 'res.ss')) )
  res.in <- do.call( rbind, unname(sapply(rtn, '[', 'res.in')) )
  
  if( all(is.na(res.ss)) ) res.ss <- NULL
  if( all(is.na(res.in)) ) {
    res.in <- NULL
  } else {
    res.in[is.na(res.in)] <- ''
  }
  
  coords.all <- do.call( rbind, unname(sapply(rtn, '[', 'coords.all')) )
  elety.all <- do.call( rbind,  unname(sapply(rtn, '[', 'elety.all')) )
  resid.all <- do.call( rbind,  unname(sapply(rtn, '[', 'resid.all')) )
  resno.all <- do.call( rbind,  unname(sapply(rtn, '[', 'resno.all')) )
  hetatm.all <- unname(sapply(rtn, '[', 'hetatm'))

  if(all(sapply(hetatm.all, is.null))) hetatm.all <- NULL

  rownames(aln$ali) <- aln$id
  rownames(coords) <- aln$id
  rownames(res.nu) <- aln$id
  rownames(res.bf) <- aln$id
  rownames(res.ch) <- aln$id
  rownames(res.id) <- aln$id
  if(!is.null(res.ss)) rownames(res.ss) <- aln$id
  if(!is.null(res.in)) rownames(res.in) <- aln$id
  
  rownames(coords.all) <- aln$id
  rownames(elety.all) <- aln$id
  rownames(resid.all) <- aln$id
  rownames(resno.all) <- aln$id
  if(!is.null(hetatm.all)) names(hetatm.all) <- aln$id

  atm <- rep( rep(sel,each=3), ncol(aln$ali))
  colnames(coords.all) = atm
  atm <- rep( sel, ncol(aln$ali))
  colnames(elety.all) = atm
  colnames(resid.all) = atm
  colnames(resno.all) = atm

  coords <- as.xyz(coords)
  coords.all <- as.xyz(coords.all)

  width <- ncol(elety.all) / ncol(aln$ali)
  grpby <- rep(1:ncol(aln$ali), each=width)
  if(compact) {
    # remove columns that have NA in all rows
    rm.inds <- which(apply(elety.all, 2, function(x) all(is.na(x))))
    if(length(rm.inds) > 0) {
      coords.all <- as.xyz(coords.all[, -atom2xyz(rm.inds)])
      elety.all <- elety.all[, -rm.inds, drop=FALSE]
      resid.all <- resid.all[, -rm.inds, drop=FALSE]
      resno.all <- resno.all[, -rm.inds, drop=FALSE]
      grpby <- grpby[-rm.inds]
    } 
  } 

  out<-list(xyz=coords, all=coords.all, resno=res.nu, insert=res.in, b=res.bf,
            chain = res.ch, id=aln$id, ali=aln$ali, resid=res.id, sse=res.ss,
            all.elety=elety.all, all.resid=resid.all, all.resno=resno.all,
            all.grpby=grpby, all.hetatm=hetatm.all, call = cl)

  class(out)=c("pdbs", "fasta")
  return(out)
  
}

"seqidentity" <-
function( alignment , normalize=TRUE, similarity=FALSE, ncore=1, nseg.scale=1) {

  # Parallelized by parallel package (Sun Jul  7 17:35:38 EDT 2013)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }

  ## set labels for output seqide matrix
  ids <- NULL
  if(inherits(alignment, c("fasta", "pdbs"))) {
    ids <- basename.pdb(as.character(alignment$id))
  }
  if(is.matrix(alignment) & !is.null(rownames(alignment))) {
    ids <- basename.pdb(as.character(rownames(alignment)))
  }

  ## continue with ali matrix only
  if(inherits(alignment, c("fasta", "pdbs"))) {
    alignment <- alignment$ali
  }
  
  ## calculate similarity instead of identity?
  if(similarity) {
    alnTo10 <- function(x) {
      new <- rep(NA, length(x))
      aa <- c("V","I","L","M",  "F","W","Y",  "S","T",
              "N","Q",  "H","K","R",  "D","E",
              "A","G",  "P",  "C",  "-","X")
      
      new[ x %in% aa[1:4] ]   = "V"   # Hydrophobic, Aliphatic
      new[ x %in% aa[5:7] ]   = "F"   # Aromatic
      new[ x %in% aa[8:9] ]   = "S"   # Ser/Thr
      new[ x %in% aa[10:11] ] = "N"   # Polar
      new[ x %in% aa[12:14] ] = "R"   # Positive
      new[ x %in% aa[15:16] ] = "D"   # Negative
      new[ x %in% aa[17:18] ] = "A"   # Tiny
      new[ x %in% aa[19] ]    = "P"   # Proline
      new[ x %in% aa[20] ]    = "C"   # Cysteine
      new[ x %in% aa[21:22] ] = "-"   # Gaps
      
      return(matrix(new, nrow=1))
    }
    alignment <- t(apply(alignment, 1, alnTo10) )
  }
  alignment[is.gap(alignment)] = NA

  ide <- function(x, y) {
#### Edit by Heiko Strathmann
#### Wed Aug  4 10:48:16 PDT 2010
#### Fix for bug with all gap sequences
    r <- sum(x==y, na.rm=TRUE)
    t <- sum(complete.cases(cbind(x,y)))
    if (normalize && t != 0) {
      r <- r/t
    }
##################################
    return( round(r, 3) )
  }

  nseq <- nrow(alignment)
  inds <- pairwise( nseq )
  ni <- nrow(inds)

  if(ncore > 1) {
     RLIMIT = R_NCELL_LIMIT
     nDataSeg = floor((ni-1)/RLIMIT) + 1
     nDataSeg = floor(nDataSeg * nseg.scale)
     lenSeg = floor(ni/nDataSeg)
     s = NULL
     for(i in 1:nDataSeg) {
        istart = (i-1)*lenSeg + 1
        iend = if(i<nDataSeg) i*lenSeg else ni
        s <- c(s, mclapply(istart:iend, function(j) {
           ide(alignment[inds[j,1],], alignment[inds[j,2],])
          }) )
     }
     s <- unlist(s)
  } else {
     s <- rep(NA, ni)
   
     for(i in 1:ni) {
       s[i]<-ide(alignment[inds[i,1],], alignment[inds[i,2],])
     }
  }
  ## make 's' into matrix 'sm'
  sm <- matrix(1, ncol=nseq,nrow=nseq)
  sm[inds]<-s
  if(nseq==2) {
    sm[inds[,2], inds[,1]]<-s
  } else {
    sm[inds[,c(2,1)]]<-s 
  }

  if(!is.null(ids)) {
    rownames(sm) <- ids
    colnames(sm) <- ids
  }
  return(sm) # ide matrix
}

"deformation.nma" <- function(nma, mode.inds=NULL, pfc.fun=NULL, ncore=NULL) {
  if(!inherits(nma, "nma"))
    stop("provide input of class 'nma' as obtained from function 'nma'")
  
  if(is.null(mode.inds)) {
    nmodes <- 20
    if(length(nma$L) < (nmodes+nma$triv.modes))
      nmodes <- length(nma$L) - nma$triv.modes
    mode.inds <- seq(nma$triv.modes+1, nma$triv.modes+nmodes)
  }
  else {
    if(length(nma$L) < (length(mode.inds)+nma$triv.modes)) {
      nmodes <- length(nma$L) - nma$triv.modes
      mode.inds <- seq(nma$triv.modes+1, nma$triv.modes+nmodes)
      warning("'mode.inds' was modified to include all modes")
    }
  }
    
  ## Check for multiple cores
  ncore <- setup.ncore(ncore)

  ## calcualte deformation energies for a specific mode
  def.mode <- function(mode.id, nma, xyz, ff, natoms) {
    mode.vec <- nma$modes[,mode.id]

    ## for normalization
    norm <- sqrt(sum(mode.vec**2) / natoms)

    ## better work with a matrix 
    mode.vec <- matrix(mode.vec, ncol=3, byrow=T)
  
    def.e <- rep(0, length=natoms)
    for ( i in 1:(natoms)) {
      
      ## distance vectors between a and b
      rs <- t(apply(xyz, 1, "-", xyz[i,]))
      
      ## differences mode vectors
      vs <- t(apply(mode.vec, 1, "-", mode.vec[i,]))
      
      ##rl <- apply(rs, 1, function(x) sqrt(sum(x^2)))
      rsq <- rowSums(rs^2)
      rl <- sqrt(rsq)
      
      ##l <- inner.prod(t(rs), t(vs)) / norm
      l <- colSums(t(rs)*t(vs)) / norm
            
      k <- ff(rl)
      l2 <- k*l*l / rsq
      
      l2[i] <- 0
      
      def.e <- def.e + (0.5*l2)
    }
    return(def.e)
  }

  if(is.null(pfc.fun))
    ff     <- load.enmff("calpha")
  else {
    if (!is.function(pfc.fun))
      stop("'pfc.fun' must be a function")
    ff <- pfc.fun
  }

  natoms <- length(nma$xyz)/3      
  xyz    <- matrix(nma$xyz, ncol=3, byrow=T)
  
  if(ncore>1)
    hm <- mclapply(mode.inds, def.mode, nma, xyz, ff, natoms, mc.cores=ncore)
  else
    hm <- lapply(mode.inds, def.mode, nma, xyz, ff, natoms)

  ## Collect results and make a matrix to store results
  hm <- t(do.call(rbind, hm))
  sums <- colSums(hm)

  out <- list(ei=hm, sums=sums)
  return(out)
}

filter.identity <- function(aln=NULL, ide=NULL, cutoff=0.6, verbose=TRUE, ...) {
                            
  
 #k<-filter.identity(aln,cutoff=0.4)
 #aln$id[k$ind]
 #k<-filter.identity(ide=k$ide,cutoff=0.6)
 #plot(k$tree, axes = FALSE, ylab="%identity")
 #axis(2,labels =c(1,0.8,0.6,0.4))
 #abline(h=0.6)

  if(is.null(ide)) {
    if(is.null(aln)) 
      stop("Must provide either an alignment 'aln' or identity matrix 'ide'")
    ide  <- seqidentity(aln, ...)
  }
  i.d  <- as.dist(1-ide)
  tree <- hclust(i.d)

  h <- 1 - cutoff
  n <- nrow(tree$merge) + 1
  k <- integer(length(h))
  k <- n + 1 - apply(outer(c(tree$height, Inf), h, ">"),2, which.max)
  if(verbose)
    cat("filter.identity(): N clusters @ cutoff = ", k, "\n")
  
  #ans <- as.vector(.Call("R_cutree", tree$merge, k, PACKAGE = "stats"))
  ans <- as.vector(cutree(tree, k))

  cluster.rep <- NULL
  for(i in 1:k) {
    ind <- which(ans==i)
    if (length(ind) == 1) {
      cluster.rep <- c(cluster.rep, ind)
    } else {
      cluster.rep <- c(cluster.rep,
                     ind[ which.max( colSums(ide[ind,ind]) ) ]) # max similarity
    }
  }
  return(list(ind=cluster.rep, tree=tree, ide=ide))
}

"write.pir" <-
function(alignment = NULL,
         ids = NULL,
         seqs = alignment$ali,
         pdb.file = NULL,
         chain.first = NULL,
         resno.first = NULL,
         chain.last = NULL, 
         resno.last = NULL, 
         file,
         append = FALSE) {
  
  if (is.null(seqs))
    stop("write.pir: please provide a 'seqs' or 'alignment' input object")
  
  if (!is.null(alignment)) {
    if (is.null(alignment$id) | is.null(alignment$ali)) {
      stop("write.pir: 'alignment' should be a list with '$id' and '$ali'components")
    }
    if (is.null(ids)) {
      ids=alignment$id
    }
  } else {
    if (is.null(ids)) {
      n.ids <- nrow(seqs)
      if(is.null(n.ids)) { n.ids=1 }
      ids=seq( 1, length=n.ids )
    }
  } 

  if(is.null(pdb.file)) pdb.file = rep("", nrow(seqs))
  if(is.null(chain.first)) chain.first = rep("", nrow(seqs))
  if(is.null(resno.first)) resno.first = rep("", nrow(seqs))
  if(is.null(chain.last)) chain.last = rep("", nrow(seqs))
  if(is.null(resno.last)) resno.last = rep("", nrow(seqs))

  if (!append) {
    ##file.remove(file, showWarnings = FALSE)
    suppressWarnings( file.remove(file) )
  }
  nseqs <- length(ids)
  if (nseqs == 1) {
    head = "sequence"
    if(pdb.file!="") {
       head = "structureX"
       if(chain.first == "") chain.first = "@"
       if(resno.first == "") resno.first = "FIRST"
       if(resno.last == "") resno.last = paste("+", sum(!is.gap(seqs)), sep="") 
    }
    head = paste(head, pdb.file, resno.first, chain.first,
            resno.last, chain.last, "", "", "", "", sep=":")
 
    # change for shortening lines (<=60) - Xinqiu
    cat(">P1;", ids, "\n", file = file, append = TRUE, sep = "")
    cat(head, "\n", file = file, append = TRUE)
    cat(seqs, "*", file = file, append = TRUE, sep = "", fill = 60)
  }
  else {
    for (i in 1:nseqs) {
       head = "sequence"
       if(pdb.file[i]!="") {
          head = "structureX"
          if(chain.first[i] == "") chain.first[i] = "@"
          if(resno.first[i] == "") resno.first[i] = "FIRST"
          if(resno.last[i] == "") resno.last[i] = paste("+", sum(!is.gap(seqs[i,])), sep="") 
       }
       head = paste(head, pdb.file[i], resno.first[i], chain.first[i],
               resno.last[i], chain.last[i], "", "", "", "", sep=":")
 
       cat(">P1;", ids[i], "\n", file = file, append = TRUE, sep = "")
       cat(head, "\n", file = file, append = TRUE)
       cat(seqs[i,], "*", file = file, append = TRUE, sep = "", fill = 60)
    }
  }
}

"mustang" <- function(files, exefile="mustang", outfile="aln.mustang.fa",
                      cleanpdb=FALSE, cleandir="mustangpdbs", verbose=TRUE) {
  ## Check if the program is executable
  os1 <- .Platform$OS.type
  status <- system(paste(exefile, "--version"),
                   ignore.stderr = TRUE, ignore.stdout = TRUE)
  
  if(!(status %in% c(0,1)))
    stop(paste("Launching external program failed\n",
               "  make sure '", exefile, "' is in your search path", sep=""))
  
  if(!all(file.exists(files)))
    stop(paste("Missing files:", paste(files[ !file.exists(files) ], collapse=", ")))

  ## produce cleaned CA pdb files for mustang
  if(cleanpdb) {
    if(!file.exists(cleandir))
      dir.create(cleandir)
    newfiles <- c()
    for(i in 1:length(files)) {
      tmpout <- paste(cleandir, basename(files[i]), sep="/")
      pdb     <- read.pdb(files[i])
      sele    <- atom.select(pdb, "calpha", verbose=verbose)
      new     <- trim.pdb(pdb, sele)
      seq1    <- aa321(new$atom$resid)
      seq3     <- aa123(seq1)
      new$atom$type  <- "ATOM"
      new$atom$resid <- seq3
      write.pdb(new, file=tmpout)
      newfiles <- c(newfiles, tmpout)
    }
    files <- newfiles
  }
  
  infile <- tempfile()
  tmpout <- tempfile()
  dirn <- unique(dirname(files))

  if(length(dirn)>1)
    stop("All files must be in one directory")
  
  files <- basename(files)

  rawlines <- NULL
  rawlines <- c(rawlines, paste(">", dirn))

  for ( i in 1:length(files) )
    rawlines <- c(rawlines, paste("+", files[i], sep=""))
  
  write.table(rawlines, file=infile, quote=FALSE,
              row.names=FALSE, col.names=FALSE)
  
  cmd <- paste(exefile, "-f", infile, "-o", tmpout, "-F fasta")

  if(verbose)
    cat("Running command\n", cmd, "\n")
  
  if (os1 == "windows")
    success <- shell(shQuote(cmd), ignore.stderr = !verbose, ignore.stdout = !verbose)
  else
    success <- system(cmd, ignore.stderr = !verbose, ignore.stdout = !verbose)

  if(success!=0)
    stop(paste("An error occurred while running command\n '",
               exefile, "'", sep=""))
  
  aln <- read.fasta(paste(tmpout, ".afasta", sep=""))
  rownames(aln$ali) <- paste(dirn, rownames(aln$ali), sep="/")
  aln$id <- rownames(aln$ali)

  unlink(infile); unlink(tmpout);

  if(!is.null(outfile))
    write.fasta(aln, file=outfile)
  
  return(aln)
}

`read.ncdf` <-
function(trjfile, headonly = FALSE, verbose = TRUE, time=FALSE,
         first = NULL, last= NULL, stride = 1, cell = FALSE,
         at.sel = NULL){
  # Adding option 'at.sel' to select a subset of the structure using
  # an object of class 'select'
 
  # Currently file open in SHARE mode is not supported by NCDF package.
  # Multicore support is suppressed
#  ncore = 1

  ##- Load ncdf4 package
  oops <- requireNamespace("ncdf4", quietly = TRUE)
  if(!oops)
    stop("Please install the ncdf4 package from CRAN")
  
  # open files 
  nc <- lapply(trjfile, function (fnm) {

     nc <- ncdf4::nc_open(fnm, readunlim=FALSE)
     conv <- ncdf4::ncatt_get( nc, varid=0, "Conventions")$value
     if(conv!="AMBER")
        warning(paste("File conventions is not set to AMBER",
                  fnm, sep=": "))
     return(nc)
  })

  # set first and last frame no for each file
  # used for time/frame range selection
  flen <- unlist(lapply(nc, function(n) return(n$dim$frame$len)))
  frange <- matrix(c(1, cumsum(flen[-length(nc)])+1, cumsum(flen)), 
                 nrow=length(nc))

  if(verbose) {
    if(length(trjfile)>1)
       print(paste("Reading ", length(trjfile), "files"))
    else
       print(paste("Reading file", trjfile))
    print(paste("Produced by program:",
      ncdf4::ncatt_get( nc[[1]], varid=0, "program")$value))
    print(paste("File conventions",
      ncdf4::ncatt_get( nc[[1]], varid=0, "Conventions")$value, "version",
      ncdf4::ncatt_get( nc[[1]], varid=0, "ConventionVersion")$value))
    print(paste("Frames:", sum(flen)))
    print(paste("Atoms:", nc[[1]]$dim$atom$len))
  }
 
  # read heads, cell, or coordinates
  retval <- lapply(seq_along(nc), function (inc) {
    first.atom <-  1
    count.atom <- -1
    if(!is.null(at.sel)) {
      if(!is.select(at.sel)) stop("'at.sel' must be an object of class 'select'. See 'atom.select'.")
      atom.ind <- xyz2atom(at.sel$xyz)
      first.atom <- min(atom.ind)
      count.atom <- diff(range(atom.ind)) + 1
    }
    
     nc <- nc[[inc]]  
     frange <- frange[inc,]
     ss = 1
     ee = nc$dim$frame$len
     if (!is.null(c(first, last))) {

        #check frame No or time
        if(time) {
           btime <- ncdf4::ncvar_get(nc, "time", 1, 1)
           etime <- ncdf4::ncvar_get(nc, "time", nc$dim$frame$len, 1)
        } else {
           btime = frange[1]
           etime = frange[2]
        }

        if((!is.null(first) && (etime < first)) || 
              (!is.null(last) && last >=0 && btime > last) ||
             (!is.null(first) && !is.null(last) && last >=0 && last < first) ) {
#           if(verbose) print(paste("Skip file", nc$filename))
           ncdf4::nc_close(nc)
           return()
        } 
        if(!headonly) {
           timeall <- btime:etime
           if(time) timeall <- ncdf4::ncvar_get(nc, "time")

           ss <- if(is.null(first)) 1 else which((timeall - first) >=0 )[1]
           if(is.null(last) || last < 0 || last > etime) {
              ee = nc$dim$frame$len
           } else {
              ee <- which((timeall - last) <= 0) 
              ee <- ee[length(ee)]
           }
        }
     }
     tlen = ee - ss + 1
     conv <- ncdf4::ncatt_get( nc, varid=0, "Conventions")$value
     if(headonly) {
       ## Report only header information
       return(list("file"=nc$filename,
                   "conv"=conv,
                   "frames"=nc$dim$frame$len,
                   "atoms"=nc$dim$atom$len))
     ##time  <- ncdf4::ncvar_get(nc,"time")
     }
     if(cell) {
        celldata <- ncdf4::ncvar_get(nc, "cell_lengths", c(1, ss), 
                             c(-1, tlen))
        celldata <- t( rbind(celldata, ncdf4::ncvar_get(nc, "cell_angles", 
                         c(1, ss), c(-1, tlen))) )
        if(time)
           rownames(celldata) <- ncdf4::ncvar_get(nc, "time", ss, tlen)
        ncdf4::nc_close(nc)
        return( celldata )
     }
     if(count.atom < 0) count.atom = nc$dim$atom$len

     # To solve 32-bit limitation problem with large trajectory file
     .check <- (3 * count.atom * tlen) / (2^31 - 1)
     if(.check > 1) {
        .nb <- floor(.check) + 1
        .nn <- floor(tlen / .nb)
        .ss <- seq(ss, ss + tlen - 1, .nn)
        .tlen <- rep(.nn, length(.ss) - 1)
        .tlen <- c(.tlen, tlen - sum(.tlen))
        coords <- sapply(1:length(.ss), function(i) 
            ncdf4::ncvar_get(nc, "coordinates", c(1, first.atom, .ss[i]), 
                          c(-1, count.atom, .tlen[i]), collapse_degen=FALSE))
     } else {    
        coords <- ncdf4::ncvar_get(nc, "coordinates", c(1, first.atom, ss), 
                          c(-1, count.atom, tlen), collapse_degen=FALSE)
     }
     if(!is.null(at.sel)) coords <- coords[,atom.ind - first.atom + 1,]
     coords <- matrix( coords, ncol=(dim(coords)[2]*3), byrow=TRUE )
     if(time)
        rownames(coords) <- ncdf4::ncvar_get(nc, "time", ss, tlen)
     ncdf4::nc_close(nc)
     return( coords )
  } )

  if(headonly) {
    retval <- do.call("c", retval)
  }
  else if(cell) {
    retval <- do.call(rbind, retval)
    ##retval <- as.data.frame(retval, stringsAsFactors=FALSE)
  }
  else {
    retval <- do.call(rbind, retval)

    ## take every "stride" frame
    retval <- as.xyz(subset(retval, (1:nrow(retval)) %in% seq(1, nrow(retval), stride)))
  }

  return( retval )
}

context("Testing basic operation with NetCDF trajectory")

test_that("read.ncdf() and write.ncdf() works properly", {
   skip_on_cran()
   
   ##- Prepare files
   trjfile <- tempfile()
   file <- system.file("examples/hivp.dcd", package="bio3d")
   invisible(capture.output(trj0 <- read.dcd(file)))
   time0 <- sort(round(runif(nrow(trj0), 0, 1000), digit=3))
   cell0 <- matrix(rep(runif(6, 0, 100), nrow(trj0)), ncol=6, byrow=TRUE)
   rownames(trj0) <- time0

   ##- Write
   out <- try(write.ncdf(trj0, trjfile, cell = cell0))
   expect_false(inherits(out, "try-error"))

   ##- Read
   trj <- read.ncdf(trjfile, headonly = TRUE, verbose = FALSE)
   expect_output(str(trj), "frames: int 117" )
   expect_output(str(trj), "atoms : int 198" )

   trj <- read.ncdf(trjfile, cell = TRUE, verbose = FALSE)
   ##expect_equal(trj, as.data.frame(cell0, stringsAsFactors=FALSE), tolerance = 1e-6)
   expect_equal(trj, cell0, tolerance = 1e-6)

   trj <- read.ncdf(trjfile, verbose = FALSE, time = TRUE)
   expect_equal(as.numeric(rownames(trj)), time0, tolerance = 1e-6)
   expect_equivalent(trj, trj0)

   pdb <- read.pdb(system.file("examples/hivp.pdb", package="bio3d"))
   inds <- atom.select(pdb, chain="A", verbose=FALSE)
   trj <- read.ncdf(trjfile, verbose = FALSE, first=10, last=20, stride=2,
      at.sel = inds)
   expect_equivalent(trj, as.xyz(trj0[seq(10, 20, 2), inds$xyz]))

   # read single frame 
   trj <- read.ncdf(trjfile, verbose = FALSE, first=1, last=1,
      at.sel = inds)
   expect_equivalent(trj, as.xyz(trj0[1, inds$xyz]))

   # multiple files
   files <- rep(trjfile, 4)
   txt <- capture.output(trj <- read.ncdf(files, headonly = TRUE))
   expect_output(print(txt), "Frames: 468")
   expect_output(print(txt), "Atoms: 198")
})

`dccm.xyz` <-
function(x, reference=NULL, grpby=NULL, method=c("pearson", "lmi"), 
         ncore=1, nseg.scale=1, ... ) {
  
  method = match.arg(method)
  
  xyz <- x
  # Parallelized by parallel package (Wed Dec 12 18:36:39 EST 2012)
  ncore <- setup.ncore(ncore)

  if(is.null(reference)) {
     ref = colMeans(xyz)
  } 
  else {
     ref = reference
  }
  dxyz  <- sweep(xyz, 2, ref)

  covmat <- cov(dxyz)
  
  if(!is.null(reference)) {
     # moment instead of covariance
     mxyz <- colMeans(dxyz)
     covmat <- covmat + outer(mxyz, mxyz)
  }

  ccmat <- .cov2dccm(covmat, method = method, ncore = ncore)
 
  if(is.null(grpby)) {
    return(ccmat)
  } else {
    ##- Group by concetive numbers in 'grpby'
    if( ncol(xyz) != (length(grpby)*3) )
      stop("dimension miss-match in 'xyz' and 'grpby', check lengths")
    
    ##- Bounds of 'grpby' numbers
    inds <- bounds(grpby, dup.inds=TRUE)
    nres <- nrow(inds)

    ##- Per-residue matrix
    m <- matrix(, ncol=nres, nrow=nres)
    ij <- pairwise(nres)

    ##- Max (absolute value) per residue
    for(k in 1 : nrow(ij) ) {
      m[ij[k,1],ij[k,2]] <-
        min( ccmat[ (inds[ij[k,1],"start"]:inds[ij[k,1],"end"]),
                  (inds[ij[k,2],"start"]:inds[ij[k,2],"end"])],
            na.rm=TRUE )
      tmax <- max( ccmat[ (inds[ij[k,1],"start"]:inds[ij[k,1],"end"]),
                  (inds[ij[k,2],"start"]:inds[ij[k,2],"end"])],
            na.rm=TRUE )
      if(tmax > abs(m[ij[k,1],ij[k,2]])) m[ij[k,1],ij[k,2]] = tmax 
    }
#    if( !mask.lower )
    m[lower.tri(m)] = t(m)[lower.tri(m)]
    diag(m) <- 1

    class(m)=c("dccm","matrix")
    return(m)
  }
}

# This internal function calculates the N-by-N cross-correlation matrix 
# directly from a 3N-by-3N variance-covariance matrix. 
.cov2dccm <- function(vcov, method = c("pearson", "lmi"), ncore = NULL) {
  method = match.arg(method)
  
  ncore = setup.ncore(ncore)
  if(ncore == 1) mclapply = lapply
  
  x <- vcov
  ccmat = switch(method, 
                 pearson = {
                   n <- nrow(x)
                   np <- pairwise(n/3)
                   
                   d <- sqrt(colSums(matrix(diag(x), nrow=3)))
                   
                   ltv <- mclapply(1:nrow(np), function(i) {
                     i1 <- (np[i, 2] - 1) * 3 + 1
                     i2 <- (np[i, 1] - 1) * 3 + 1
                     sum(diag(x[i1:(i1+2), i2:(i2+2)]))/ # sum of diagnol of submatrix
                       (d[np[i, 2]] * d[np[i, 1]])   # divided by product of standard deviations
                   } )
                   
                   ccmat <- matrix(0, n/3, n/3)
                   ccmat[lower.tri(ccmat)] <- unlist(ltv)
                   
                   # make full matrix
                   ccmat <- ccmat + t(ccmat)
                   diag(ccmat) <- 1
                   ccmat
                 },
                 lmi = {
                   # rm:r-value matrix
                   cm <- x
                   l <- dim(cm)[1]/3
                   rm <- matrix(nrow=l, ncol=l)
                   d <- 3
                   ij <- pairwise(l)
                   
                   # list1: marginal-covariance 
                   list1 <- mclapply(1:l, function(i) det(cm[(3*i-2):(3*i), (3*i-2):(3*i)]) )
                   dm <- unlist(list1)
                   
                   # list2: pair-covariance
                   list2 <- mclapply(1:nrow(ij), function(i) {
                     x <- det(cm[c((3*ij[i,1]-2):(3*ij[i,1]),(3*ij[i,2]-2):(3*ij[i,2])), c((3*ij[i,1]-2):(3*ij[i,1]),(3*ij[i,2]-2):(3*ij[i,2]))])
                     y <- 1/2 * (log(dm[ij[i,1]]) + log(dm[ij[i,2]]) - log(x))
                     (1 - exp(-2 * y / d))^(1/2)
                   }
                   )
                   list2 <- unlist(list2)
                   
                   for (k in 1:nrow(ij)) {
                     rm[ij[k, 1], ij[k, 2]] <- list2[k]
                   }
                   rm[lower.tri(rm)] = t(rm)[lower.tri(rm)]
                   diag(rm) <- 1
                   rm
                 } )
  class(ccmat)=c("dccm","matrix")
  return(ccmat)
}

combine.select <-
 function(sel1=NULL, sel2=NULL, ..., operator="AND", verbose=TRUE) {
   cl <- match.call()
   sels <- list(sel1, sel2, ...)

   if(any(sapply(sels, function(x) !is.null(x) && !inherits(x, "select"))))
      stop("Invalid atom select(s)")

   rm.inds = sapply(sels, is.null)
   sels = sels[!rm.inds]

   if(length(sels) == 0)
      return(NULL)
   else if(length(sels) == 1)
      return(sels[[1]])

   op.tbl <- c(rep("AND",3), rep("OR",4), rep("NOT",4))
   operator <- op.tbl[match(operator, c("AND","and","&","OR","or","|","+","NOT","not","!","-"))]

   # Print message
   if(verbose) {
      msg <- switch(operator,
        AND = " Intersect of selects",
        OR  = " Union of selects",
        NOT = " Select 2 (, 3, ...) is subtracted from select 1",
        stop("Unknown operation") )
      cat(msg, "\n", sep="")
   }

   sel <- sels[[1]]$atom
   for(i in 2:length(sels)) {
      sel <-
         switch(operator,
         "AND" = intersect(sel, sels[[i]]$atom),
         "OR"  = sort(union(sel, sels[[i]]$atom)),
         "NOT" = setdiff(sel, sels[[i]]$atom),
         stop("Unknown operation") )
   }
   sel <- list(atom = sel, xyz = atom2xyz(sel), call=cl)
   if(verbose) { cat(paste(" *  Selected a total of:", length(sel$atom), "atoms  *\n")) }

   class(sel) = "select"
   return(sel)
}

pdbaln <-
function(files, fit=FALSE, pqr=FALSE, ncore=1, nseg.scale=1, progress=NULL, ...) {

  ## Log the call
  cl <- match.call()

  ##- Quick and dirty alignment of pdb sequences
  ##   pdbs <- pdbaln(files)
  ##
  ##
  ## 'files' should be a character vector of input PDB file names
  ## '...' extra arguments for seqaln
  ##
  ## Improvements to include 'atom.select' arguments (chain
  ## spliting etc), formalisation of 'pdb.list' into a specific
  ## bio3d object of multiple structures like 'pdbs'.
  ##
  ## pdb.list[[1]]$atom[1:3,]

  # Parallelized by parallel package (Fri Apr 26 19:24:18 EDT 2013)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }
  
  if(!is.list(files)) {
    ## Check if input PDB files exist localy or online
    toread.local <- file.exists(files)
    toread.online <- (substr(files,1,4)=="http")
    toread.id <- rep(FALSE, length(files))
    toread <- as.logical(toread.local + toread.online)
    
    ## Check for 4 letter code and possible online file
    if(any(!toread)) {
      toread.id <- ((nchar(files)==4) + (!toread) == 2)
      files[toread.id] <-  get.pdb(files[toread.id], URLonly=TRUE)
      cat("  Note: Accessing online PDB files using 4 letter PDBID\n")
    }
    
    ## Exit if we still have missing files
    missing <- !as.logical(toread + toread.id)
    if(any(missing)) {
      stop(paste(" ** Missing files: check filenames\n",
                 paste( files[c(missing)], collapse="\n"),"\n",sep="") )
    }
    
    ## Avoid multi-thread downloading
    if(any(toread.online | toread.id)) {
      ncore = 1
#      options(cores = ncore)
    }
    cat("Reading PDB files:",files, sep="\n")
    
    pdb.list <- mclapply(1:length(files), function(i) {
      if(pqr) {
        pdb <- read.pqr(files[i])
      } else {
        pdb <- read.pdb(files[i])
      }
      cat(".")

      ## edit for shiny version
      if(!is.null(progress)) {
        progress$inc(1/length(files)/2)
      }
      ## edit end

      return( pdb )
    } , mc.cores = ncore)
  }
  else {
    if(!all(sapply(files, is.pdb)))
      stop("'files' must be a vector of file names, or a list of pdb objects")
    pdb.list <- files
    #ids <- sapply(files, function(x) x$call$file)
    #print(ids)
  }

  cat("\n\nExtracting sequences\n")
  s <- mclapply(pdb.list, pdbseq, mc.cores=ncore)

  ## check for NULL in pdbseq output
  ## (this would indicate no amino acid sequence in PDB)
  tmpcheck <- unlist(lapply(s, is.null))
  if(any(tmpcheck)) {
    if(!is.list(files)) {
      err <- paste(
        "Could not align PDBs due to missing amino acid sequence in files:\n ",
        paste(files[tmpcheck], collapse=", ")
        )
    }
    else {
      err <- paste(
        "Could not align PDBs due to missing amino acid sequence in PDB:\n ",
        paste(tmpcheck, collapse=", ")
        )
    }
    stop(err)
  }

  s <- t(sapply(s, `[`, 1:max(sapply(s, length))))
  s[is.na(s)] <- "-"
  
  if(!is.list(files)) {
    s <- seqaln(s, id=files, ...)
    files <- NULL
  }
  else {
    id <- unlist(lapply(files, function(x) {
      if(!is.null(x$call$file))
        x$call$file
      else
        NA
    }))
    
    if(!is.character(id)) id <- rep(NA, length(id))

    nams <- paste("seq", 1:length(id), sep="")
    id[is.na(id)] <- nams[is.na(id)]
    
    if(any(duplicated(id)))
      id <- NULL
    
    s <- seqaln(s, id=id, ...)
  }

  cat("\n")
  ## added progress argument for shiny version
  s <- read.fasta.pdb(s, prefix = "", pdbext = "", pdblist=files,
                      ncore=ncore, nseg.scale=nseg.scale,
                      progress=progress)
  ## edit end
  s$call=cl
  
  if(fit)
    s$xyz <- pdbfit(s)
  return(s)
}

atom2ele <- function(...)
  UseMethod("atom2ele")

atom2ele.default <- function(x, elety.custom=NULL, rescue=TRUE, ...){
  if(!is.null(elety.custom)) {
    if(!all(c("name","symb") %in% names(elety.custom)))
      stop("'elety.custom' must contains 'name' and 'symb' components")
    inds <- unlist(lapply(elety.custom, is.factor))
    elety.custom[inds] <- lapply(elety.custom[inds], as.character)
  }
  atom.index <- rbind(elety.custom[,c("name","symb")], bio3d::atom.index[,c("name","symb")])
  # Why atom names starting by "H" are directly converted to "H" as follow?
  # x[substr(x,1,1) == "H"] <- "H"
  symb <- atom.index[match(x, atom.index[,"name"]), "symb"]
  is.unknown <- is.na(symb)
  if(any(is.unknown)) {
    if(rescue) {
        ## vector of unknown elements
        unknowns <- unique(x[is.unknown])
        symb2 <- rep(NA, length(unknowns))
        names(symb2) <- unknowns

        ## format element names before matching
        spl <- strsplit(unknowns, "")
        totest <- lapply(spl, function(b) {
            ## remove numbering from atom name (e.g. FE2, C4A)
            inds <- grep("[^0-9]", b)
            if(length(inds) == 0) return(b)
            j <- bounds(inds)[1, c("start", "end")]
            b <- b[j[1]:j[2]]

            ## First char to upper, remaining to lower case
            new <- NULL
            for(i in 1:length(b)){
                new <- c(new, ifelse(i==1, toupper(b[i]), tolower(b[i])))
            }
            return(paste(new, collapse=""))
        })

        ## match with bio3d::elements$symb
        totest <- unlist(totest)
        if(any(totest %in% bio3d::elements$symb)) {
            symb2[unknowns[totest %in% bio3d::elements$symb]] <-
                totest[totest %in% bio3d::elements$symb]
        }

        ## try with first character to see if it matches elements$symb
        if(any(is.na(symb2))) {
            na.inds <- which(is.na(symb2))
            totest <- toupper(substr(names(symb2[na.inds]), 1, 1))

            if(any(totest %in% bio3d::elements$symb)) {
                rplc <- names(symb2[na.inds])[totest %in% bio3d::elements$symb]
                symb2[rplc] <- totest[totest %in% bio3d::elements$symb]
            }
        }
        
        ## stop with error in case of un-mapped elements
        if(any(is.na(symb2))) {
            stop("\telements could not be determined for: ",
                 paste(names(symb2)[is.na(symb2)], collapse=", "))
        }

        ## inform user on mapped elements
        warning(paste("\n\tmapped element ", names(symb2), " to ", symb2, sep=""))
        
        ## include matched elements to original symbol vector
        symb[is.unknown] <- symb2[ x[is.unknown] ]
    }
    else {
      stop("\telements could not be determined for: ",
           paste(unique(x[is.unknown]), collapse=", "))
    }
  }
  symb <- unlist(symb)
  return(symb)
}

atom2ele.pdb <- function(pdb, inds=NULL, ...){
  if(!is.null(inds))
    pdb <- trim(pdb, inds)
  atom.names <- pdb$atom[,"elety"]
  return(atom2ele.default(atom.names, ...))
}

filter.dccm <- function(x, cutoff.cij = NULL, cmap = NULL, xyz = NULL, fac = NULL, 
                        cutoff.sims = NULL, collapse = TRUE, extra.filter = NULL, ...) {

   # check cij format
   cij <- x
   if("all.dccm" %in% names(cij)) {
      cij <- cij$all.dccm
   } else if(is.list(cij)) {
      cij <- array(unlist(cij), dim = c(dim(cij[[1]]), length(cij)))
   } else if(is.matrix(cij)) {
      cij <- array(cij, dim = c(dim(cij), 1))
   } else if(!is.array(cij)) {
      stop("Input x should be an array/list containing correlation matrices")
   }

   ## Check input is built of simmetric matrices
   if (dim(cij)[1] != dim(cij)[2]) {
     stop("Input 'x' should contain symmetric matrices.")
   }

   ## Check xyz and set cmap   
   if(is.null(cmap)) {
      if(is.null(xyz)) cmap = FALSE
      else cmap = TRUE
   }

   ## Check dimension if cmap is matrix
   if(is.matrix(cmap) && !all.equal(dim(cmap), dim(cij)[1L:2L]))
      stop("Input 'cmap' does not match x")

   ## Check cutoff.cij
   if(is.null(cutoff.cij)) {
      cutoff.cij <- .cij.cutoff.guess(cij, p = 0.95)
   }

   ## Inspect cij values with respect to cutoff.cij and contact map
   if(is.matrix(cmap) || isTRUE(cmap)) {

      # check factor vector for multiple networks construction
      if(!is.null(fac)) {
         if(!is.factor(fac)) fac = as.factor(fac)
      } else {
         fac = factor(rep("a", dim(cij)[3L])) 
      } 
  
      # check for calculating cmap 
      if(isTRUE(cmap)) {
         if(is.null(xyz))
            stop("xyz coordinates or a 'pdbs' object must be provided for contact map calculation")

         cmap.args <- list(...)

         if(inherits(xyz, "pdbs")) {
            gaps.pos <- gap.inspect(xyz$xyz)
            xyz <- xyz$xyz[, gaps.pos$f.inds]
            cmap.default <- list(dcut=10.0)
            cmap.args <- .arg.filter(cmap.default, cmap.xyz, ...)
         }
         if(nrow(xyz) != dim(cij)[3L] && nlevels(fac) > 1)
            stop(paste("Input 'xyz' doesn't match 'x'", 
              "\tSet fac=NULL for single network construction", sep='\n'))
      }

      # convert cij to upper.tri matrix for internal use
      pcij <- apply(cij, 3, function(x) x[upper.tri(x)])
 
      ncij <- tapply(1:dim(cij)[3L], fac, function(i) {
        
         # contact map
         if(isTRUE(cmap)) { 
            if(nlevels(fac) > 1)
                cm <- do.call("cmap.xyz", c(list(xyz=xyz[i, ]), cmap.args))
            else
                cm <- do.call("cmap.xyz", c(list(xyz=xyz), cmap.args)) 
         } else {
            cm <- cmap
         }

         cm[is.na(cm)] <- 0
 
         cij.min = apply(abs(pcij[, i, drop=FALSE]), 1, min)
         cij.max = apply(abs(pcij[, i, drop=FALSE]), 1, max)
   
         filter <- (cij.min >= cutoff.cij) | (cij.max >= cutoff.cij & cm[upper.tri(cm)]==1)
         
         if(!is.null(extra.filter))
            filter <- filter * extra.filter[upper.tri(extra.filter)] 
         
         ncij <- array(NA, dim=c(dim(cij[,,1]), length(i)))
         for(j in 1:dim(ncij)[3L]) {
            tcij <- cij[,,i[j]]
            tcij[upper.tri(tcij)] <- pcij[, i[j]] * filter
            tcij[lower.tri(tcij)] <- t(tcij)[lower.tri(tcij)]
            ncij[,,j] <- tcij
         }
#         if(length(i) == 1) ncij <- ncij[,,1]
         return(ncij)
      } )
     
      if(collapse) ncij <- lapply(ncij, rowMeans, dims = 2) 
      if(nlevels(fac)==1) ncij <- ncij[[1]]
      if(is.matrix(ncij)) class(ncij) = c("dccm", "matrix")
      if(is.list(ncij)) {
         ncij <- lapply(ncij, function(x) {
            class(x) <- c("dccm", "matrix")
            x
         })
      }

      return(ncij)

   } else {

      # Filter cijs with cutoff.sims and return mean dccm (dccm.mean())

      if(is.null(cutoff.sims)) cutoff.sims = dim(cij)[3L]
   
      if (cutoff.sims > dim(cij)[3L] || cutoff.sims < 0) {
        stop("The cutoff.sims should be a number between 0 and N, where N is the the number of simulations in the input matrix")
      }

      ## Filter by cutoff.cij and sum across simulations
      cut.cij.inds <- (abs(cij) < cutoff.cij)
      count <- array(NA, dim = dim(cij))
      count[!cut.cij.inds] = 1
      cij.sum <- apply(count, c(1:2), sum, na.rm = TRUE)
    
      ## Mask cij values below cutoff and average across simulations
      cij[cut.cij.inds] = NA
      cij.ave <- apply(cij, c(1:2), mean, na.rm = TRUE)
    
      ## Mask average values if below cutoff.sims
      cut.sims.inds <- (cij.sum < cutoff.sims)
      cij.ave[cut.sims.inds] = 0 ## Could use NA here

      if(!is.null(extra.filter))
         cij.ave <- cij.ave * extra.filter
    
      class(cij.ave) = c("dccm", "matrix")
      return(cij.ave)
   }
}

# Estimate cij.cutoff as quantile Pr(cij<=cij.cutoff) = p
.cij.cutoff.guess <- function(cij, p = NULL, cmap = NULL, collapse = TRUE, collapse.method=c('max', 'median', 'mean')) {

   collapse.method <- match.arg(collapse.method)

   if(is.null(p)) p = seq(0.900, 0.995, 0.005)
      
   cijs <- cij
   if("all.dccm" %in% names(cijs)) cijs <- cijs$all.dccm
   if(is.array(cijs)) {
      if(length(dim(cijs))==3)
         cijs <- do.call("c", apply(cijs, 3, list))
      else
         cijs <- list(cijs)
   }
   if(!is.list(cijs))
      stop("cijs should be matrix, array(dim=3), or list")
   
   if(!is.null(cmap)) {
       cijs <- lapply(cijs, function(x) x*cmap)
   }

   # return quantile Pr(cij <= cij.cutoff) = p
   out <- sapply(cijs, function(x)
       quantile(abs(x[upper.tri(x)]), probs = p))
   out <- matrix(out, ncol=length(cijs))

   c0 <- seq(0, 1, 0.05)
   if(collapse) {
      out <- switch(collapse.method, 
        'mean' = 
#           sapply(rowMeans(out), function(x) c0[which.min(abs(x-c0))]) ,
           sapply(rowMeans(out), function(x) c0[sum(x>=c0)]),
        'median' = 
           sapply(apply(out, 1, median), function(x) c0[sum(x>=c0)]),
#           sapply(apply(out, 1, median), function(x) c0[which.min(abs(x-c0))]),
        'max' = 
           sapply(apply(out, 1, max), function(x) c0[sum(x>=c0)])
#           sapply(apply(out, 1, max), function(x) c0[which.min(abs(x-c0))])
      )
      names(out) <- paste("Cutoff (p=", round(p, digits=3), ")", sep="")
   } else {
      dimnames(out) <- list(paste("Cutoff (p=", round(p, digits=3), ")", sep=""),
                            paste("Matrix", 1:length(cijs)))
   }

   return(out) 
}

"bwr.colors" <-
function (n) {

  # Derived from the function colorpanel
  # by Gregory R. Warnes

  if(n<3)
    warning("not sensible to ask for less than 3 colors")
  
  odd = FALSE
  
  if (n != as.integer(n/2) *2) {
    n   <- n + 1
    odd = TRUE
  }
  low  <- col2rgb("blue")
  mid  <- col2rgb("white")
  high <- col2rgb("red")
  
  lower <- floor(n/2)
  upper <- n - lower
  
  red   <- c(seq(low[1, 1], mid[1, 1], length = lower),
             seq(mid[1,1], high[1, 1], length = upper))/255
  
  green <- c(seq(low[3, 1], mid[3, 1], length = lower),
             seq(mid[3, 1], high[3, 1], length = upper))/255
  
  blue  <- c(seq(low[2, 1], mid[2, 1], length = lower),
             seq(mid[2, 1], high[2, 1], length = upper))/255
    
  if (odd) {
    red   <- red[-(lower + 1)]
    green <- green[-(lower + 1)]
    blue  <- blue[-(lower + 1)]
  }
  rgb(red, blue, green)
}

plotb3 <- function(x, resno=NULL, rm.gaps = FALSE, type="h",
                       main="", sub="",
                       xlim=NULL, ylim=NULL, ylim2zero=TRUE,
                       xlab = "Residue", ylab = NULL, 
                       axes=TRUE, ann=par("ann"),
                       col=par("col"),
                       sse=NULL, sse.type="classic", sse.min.length=5,
                       top=TRUE, bot=TRUE,
                       helix.col="gray20", sheet.col="gray80",
                       sse.border=FALSE, 
                       ...) {
   
  ## Check for gap positions 
  gaps.pos = gap.inspect(x)
  if(rm.gaps && length(gaps.pos$f.inds)==0)
     stop('No data to plot (all positions of "x" have gaps).')

  if(is.matrix(x)) x = x[1, ]   ## should support matrix in future
  if(!is.vector(x))
    stop('Input x should be a numeric vector')

  if(!is.null(resno)) {
    if(is.pdb(resno)) {
      ## Take Calpha residue numbers from PDB input
      ca.inds <- atom.select(resno, "calpha", verbose = FALSE)
      resno <- resno$atom$resno[ca.inds$atom]
    }

    ## Allow "gapped resno" input
    if(any(is.na(resno))) 
      resno <- resno[!is.na(resno)]

    if(any(is.na(x))) {
      tmp.resno <- rep(NA, length(x))
      tmp.resno[!is.na(x)] = resno
      resno = tmp.resno
    }
    
    if(length(resno) != length(x)) {
      warning("Length of input 'resno' does not equal the length of input 'x'; Ignoring 'resno'")
      resno=NULL
    }
  }
  if(!is.null(sse)) {	
    ## Obtain SSE vector from PDB or DSSP results input
    if(is.pdb(sse) || inherits(sse, 'sse')) {
      if(is.pdb(sse)) 
        sse <- pdb2sse(sse)
      else
        sse <- sse$sse
    }

    ## Allow "gapped sse" input
    if(any(is.na(sse))) 
      sse <- sse[!is.na(sse)]

    if(any(is.na(x))) {
      tmp.sse = rep(' ', length(x))
      tmp.sse[!is.na(x)] <- sse
      sse <- tmp.sse
    }

    if(length(sse) != length(x)) {
      warning("Length of input 'sse' does not equal the length of input 'x'; Ignoring 'sse'")
      sse=NULL
    }
  }
 
  if(rm.gaps) {
     xy <- xy.coords(x[gaps.pos$f.inds])
     if(!is.null(resno)) resno <- resno[gaps.pos$f.inds]
     if(!is.null(sse)) sse <- sse[gaps.pos$f.inds]
  }
  else 
     xy <- xy.coords(x)

  if (is.null(xlim))
    xlim <- range(xy$x[is.finite(xy$x)])
  if (is.null(ylim))
    ylim <- range(xy$y[is.finite(xy$y)])
  if(ylim2zero) ylim[1]=0
  
  plot.new()
  plot.window(xlim, ylim, ...)
  points(xy$x, xy$y, col=col, type=type, ...)
  

  if(!is.null(sse)) {
  
    h <- bounds( which(sse == "H") )
    e <- bounds( which(sse == "E") )
    
    ## Remove short h and e elements that can crowd plots
    if(length(h) > 0) {
      h <- h[h[,"length"] >= sse.min.length,,drop=FALSE]
    } else { h <- NULL }
    if(length(e) > 0) {
      e <- e[e[,"length"] >= sse.min.length,,drop=FALSE]
    } else { e <- NULL }

    if(sse.type != "classic")
      warning("Only sse.type='classic' is currently available, 'fancy' coming soon")
    
    if(top) {
      ## Determine bottom and top of margin region 
      bo <- max(ylim) + (diff(ylim)*0.001) # 0.1% 
      to <- max(ylim) + (diff(ylim)*0.04) # 4%
      
      if(length(h) > 0)
        rect(xleft=h[,"start"], xright=h[,"end"],
             ybottom=bo, ytop=to, col=helix.col, border=sse.border)
      
      if(length(e) > 0)
        rect(xleft=e[,"start"], xright=e[,"end"],
             ybottom=bo, ytop=to, col=sheet.col, border=sse.border)
    }
    if(bot){
      	to <- min(ylim) - (diff(ylim)*0.001)
      	bo <- min(ylim) - (diff(ylim)*0.04)
        
      	if(length(h) > 0)
          rect(xleft=h[,"start"], xright=h[,"end"],
               ybottom=bo, ytop=to, col=helix.col, border=sse.border)
        
      	if(length(e) > 0)
          rect(xleft=e[,"start"], xright=e[,"end"],
               ybottom=bo, ytop=to, col=sheet.col, border=sse.border)
    }
  }

  if(axes) {
    axis(2)
    box()
    at <- axTicks(1); at[1] = 1
    if(is.null(resno)) {
      axis(1, at)
    } else {
      labels <- resno[at]
      labels[is.na(labels)] <- "" # for gaps, no label
      axis(1, at=at, labels=labels)
    }
  }
  if(ann) {
    if(is.null(xlab))  xlab=xy$xlab
    if(is.null(ylab))  ylab=xy$ylab
    title(main=main, sub=sub, 
          xlab=xlab, ylab=ylab, ...)
  }
}

plot.bio3d <- function(...) { plotb3(...) }

"read.dcd" <-
function(trjfile, big=FALSE, verbose=TRUE, cell = FALSE){

  # Version 0.2 ... Tue Jan 18 14:20:12 PST 2011
  # Version 0.1 ... Thu Mar  9 21:18:54 PST 2005
  #
  # Description:
  #  Reads a CHARMM or X-PLOR/NAMD binary
  #  trajectory file with either big- or
  #  little-endian storage formats
  #
  # Details:
  #  Reading is accomplished with two different
  #  functions.
  #   1. 'dcd.header' which reads headder info
  #   2. 'dcd.frame' takes the header info and
  #         reads frame by frame producing a 
  #         nframes/natom*3 matrix of cartisean
  #         coordinates



#===DCD=FORMAT==============================================
#HDR  NSET  ISTRT NSAVC 5-ZEROS NATOM-NFREAT DELTA   9-ZEROS
#CORD files step1 step  zeroes  (zero)      timestep  zeroes
#C*4  INT   INT   INT    5INT    INT         DOUBLE   9INT
#  [CHARACTER*20]
#===========================================================
#NTITLE   TITLE
#INT      C*MAXTITL
#C*2      C*80
#===========================================================
#NATOM
#INT
#===========================================================
#CELL(I), I=1,6          (DOUBLE)
#===========================================================
#X(I), I=1,NATOM         (SINGLE)
#Y(I), I=1,NATOM         
#Z(I), I=1,NATOM         
#===========================================================


  dcd.header <- function(trj,...) {
    
    # Read DCD Header section
    
    end = .Platform$endian   # Check endianism
    check <- readBin(trj,"integer",1,endian=end)
    # first thing in file should be an '84' header
    if (check != 84) {
      # if not we have the wrong endianism
      if (end == "little") { end="big" } else { end="little" }
      check <- readBin(writeBin(check, raw()), "integer", 1, endian = end)

      if (check != 84) {
        close(trj)
        stop("PROBLEM with endian detection")
      }
    }

    hdr <- readChar(trj, nchars=4) # data => CORD or VELD

    # how big is the file 'end.pos'
    cur.pos <- seek(trj, where=1, origin = "end") # pos ?
    end.pos <- seek(trj, where=cur.pos, origin= "start")
  
    icntrl <- readBin(trj,"integer", 20, endian=end) # data => header info

    # header information:
    nframe = icntrl[1]  # number of frames
    first  = icntrl[2]  # number of previous steps 
    step   = icntrl[3]  # frequency of saving
    nstep  = icntrl[4]  # total number of steps
    nfile <- nstep/step  # number of files
    last  <- first + (step * nframe) # last step
    # 5 zeros
    ndegf  = icntrl[8]  # number of degrees of freedom
    nfixed = icntrl[9]  # number of fixed atoms 
    delta  = icntrl[10] # coded time step
    cryst  = icntrl[11] # crystallographic group
    block  = icntrl[12] # extra block?
    # 9 zeros
    vers     = icntrl[20]

    # flush to end of line
    a<-readBin(trj,"integer",1, endian=end) # should be '84' line tail
  ## cur.pos<-seek(trj, where=92, origin= "start") # position 92
    rm(icntrl)  # tidy up

  
    # Are we CHARMM or X-PLOR format
    charmm=FALSE; extrablock=FALSE; four.dims=FALSE
    if (vers != 0) {
      charmm=TRUE # charmm version number
      if (cryst == 1) { # check for
        extrablock = TRUE  # extra free 
      }                 # atom block &
      if (block == 1) { # extra four
        four.dims=TRUE     # dimensions 
      }
    } else {
      # re-read X-PLOR delta as a double
      cur.pos <- seek(trj, where=44, origin= "start")
      delta  = readBin(trj,"double", 1, endian=end)
      seek(trj, where=cur.pos, origin= "start")
    }
  

    #=======#
    # Title #
    a<-readBin(trj,"integer",1, endian=end)        # flush FORTRAN header 
    ntitle <- readBin(trj,"integer",1, endian=end) # data => Num title lines
    title<-NULL                                    # store title & date

    cur.pos <- seek(trj, where=NA)  ## 100
    for (i in 1:ntitle) {
### ==> !!!nasty hack due to invalid UTF-8 input (Jun 5th 07) !!! <=== ###    
      ll<-try(title<-c( title, suppressWarnings(readChar(trj,80)) ),silent=TRUE)
    }
    # OR: title<- readChar(trj, (ntitle*80))

    if(inherits(ll, "try-error")) {
      warning("Check DCD header data is correct, particulary natom")
      ##cur.pos <- seek(trj, where=260, origin= "start") # pos 260
      cur.pos <- seek(trj, where=(80*ntitle+cur.pos), origin= "start")
    }
### == end hack
    a<-readBin(trj,"integer",1, endian=end)         # flush FORTRAN tail

    
    #=======#
    # Natom #
    a<-readBin(trj,"integer",1, endian=end)        # flush FORTRAN header 
    natom <- readBin(trj,"integer",1, endian=end)  # number of atoms
    a<-readBin(trj,"integer",1, endian=end)        # flush FORTRAN tail

  ##cur.pos <- seek(trj, where=276, origin= "start") # pos 276


    #=============#
    # Freeindexes #
    if (nfixed != 0) {
      # Free (movable) atom indexes if nfixed > 0
      a <- readBin(trj,"integer",1, endian=end)        # flush FORTRAN header 
      free.ind <- readBin(trj,"integer", (natom-nfixed), endian=end )
      a <- readBin(trj,"integer",1, endian=end)        # flush FORTRAN tail
      print("FIXED ATOMS IN SIMULATION => CAN'T READ YET")
    }
  

  
    if (verbose) {
## EDIT ## R version 2.11.0 does not like "\0", just remove for now - Apr 12 2010   
##      cat( sub(" +$","",gsub(pattern="\0", replacement="", x=title)),sep="\n" )
      cat(" NATOM =",natom,"\n")
      cat(" NFRAME=",nframe,"\n")
      cat(" ISTART=",first,"\n")
      cat(" last  =",last,"\n")
      cat(" nstep =",nstep,"\n")
      cat(" nfile =",nfile,"\n")
      cat(" NSAVE =",step,"\n")
      cat(" NDEGF =",ndegf,"\n")
      cat(" version",vers,"\n")
    }

    
    # Done with Header :-)
    header <- list(natom=natom,
                   nframe=nframe,
                   first=first,
                   last=last,
                   nstep=nstep,
                   nfile=nfile,
                   step=step,
                   ndegf=ndegf,
                   nfixed=nfixed,
                   charmm=charmm,
                   extrablock=extrablock,
                   four.dims=four.dims,
                   end.pos=end.pos,
                   end=end)

  }


  
  dcd.frame <- function(trj, head, cell) {
    
    # DCD step/frame data
    #  read one frame from the current conection 'trj'
    #  which should have been already through
    #  'dcd.header' so the "where" position is at
    #  the start of the cooedinate section

    #============#
    # Free atoms #
    # Uncomment the next two lines if reading cell
    # parameters only works with CHARMM DCD files
#     if(!head$charmm && cell)
#       stop("Cell parameters can only be read from CHARMM dcd files.")
    if ( head$charmm &&  head$extrablock) {
      # CHARMM files may contain lattice parameters
      a <- readBin(trj,"integer",1, endian=head$end)  # flush FORTRAN header 
      u <- readBin(trj, "numeric", size = 8, n = (a/8),endian = head$end)
      a <- readBin(trj,"integer",1, endian=head$end)  # flush FORTRAN tail
    }

    ##cur.pos <- seek(trj, where=332, origin= "start") # pos 332
  
    #========#
    # Coords #
    if (head$nfixed == 0) {
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN header 
      x <- readBin(trj,"numeric",                    # read x coords
                   size=4, n=(a/4), endian=head$end)
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN tail

      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN header 
      y <- readBin(trj,"numeric",       # read y coords
                   size=4, n=(a/4), endian=head$end)
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN tail
    
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN header 
      z <- readBin(trj,"numeric",       # read z coords
                   size=4, n=(a/4), endian=head$end)
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN tail

    } else {
      # not implemented yet! => cant cope with fixed atoms
    }

    #===============#
    # 4th dimension #
    if (head$charmm && head$four.dims) {
      # CHARMM files may contain an extra block?
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN header 
      seek(trj, where=a, origin= "current") # skip this block 
      a <- readBin(trj,"integer",1, endian=head$end) # flush FORTRAN tail    
    }

    # Done with coord frame :-)
    
    #coords <- list(x=x,
    #               y=y,
    #               z=z)

    if(cell) to.return <- c( u[c(1,3,6)], (180/pi)*acos(u[c(5,4,2)]))
    else to.return <- as.vector(rbind(x,y,z))
    class(to.return) = "xyz"
    return(to.return)
  }
  
  # Check if file exists
  if( !file.exists(trjfile) ) {
    stop(paste("No input DCD file found with name:", trjfile))
  }
  
  # Open file conection
  trj <- file(trjfile, "rb")
  #verbose=T
  head<-dcd.header(trj,verbose)

  nframes = head$nframe 
  natoms  = head$natom

  # blank xyz data structures
  # format: rows => nframes, cols => natoms
### ==> !!! Insert to read big dcd files (Sep 29th 08) !!! <=== ###    
  ###xyz <- matrix(NA, nrow=nframes,ncol=natoms*3)
  if(!big) {
    if(cell) to.return <- matrix(NA, nrow=nframes,ncol=6)
    else to.return <- matrix(NA, nrow=nframes,ncol=natoms*3)
  } else {
    ##-! Insert to read big dcd files (Sep 29th 08)
    oops <- requireNamespace("bigmemory", quietly = TRUE)  
    if(!oops) 
        stop("Please install the bigmemory package from CRAN")

    if(cell) to.return <- bigmemory::big.matrix(nrow=nframes,ncol=6, init = NA, type = "double")
    else to.return <- bigmemory::big.matrix(nrow=nframes,ncol=natoms*3, init = NA, type = "double")
  }
### ==> !!! end big.matrix insert
  
  if(verbose){ cat("Reading (x100)") }
  store <- NULL
  
  # fill xyz with frame coords
  if(verbose) pb <- txtProgressBar(1, nframes, style=3)
  for(i in 1:nframes) {
    curr.pos <- seek(trj, where=0, origin= "current")
    if (curr.pos <= head$end.pos) {
      to.return[i,]<- as.vector( dcd.frame(trj,head,cell) )
      if (verbose) {
        setTxtProgressBar(pb, i)
#        if(i %% 100==0) { cat(".") }
      }
#      print(paste("frame:",i,"pos:",curr.pos))
      store<-cbind(store,curr.pos)
    } else {
      print("Premature end of file")
      print(paste("  last frame:",i,
                  "nframe:",head$nframe ))
      break
    }
  }
#  if(verbose) { cat("done",sep="\n") }
  if(verbose)
    cat("\n")
  close(trj)

  ##class(to.return) = "xyz"
  if(big) {
     warning("Returned a 'big.memory' matrix that is not fully supported by some Bio3D functions.")
     return(to.return)
  }
  else {
     return( as.xyz(to.return) )
  }
}

context("Testing cmap function")


test_that("cmap() works properly", {
  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))
 
  ## Calculate contact map on a small protein
  invisible(capture.output(inds <- atom.select(pdb, "protein")))
  invisible(capture.output(cm <- cmap(pdb$xyz[, inds$xyz],
                                      grpby=pdb$atom[inds$atom, "resno"], ncore=1)))
  
  expect_equal(length(which(cm==1)), 285)
  expect_true(all(is.na(cm[1,1:3])))
  expect_equal(cm[1,4], 0)
  expect_equal(cm[13,129], 1)

  ## Check multicore cmap 
  skip_on_cran()
  skip_on_travis()
  trjfile <- system.file("examples/hivp.dcd", package="bio3d")
  invisible(capture.output(trj <- read.dcd(trjfile)))
  invisible(capture.output(cm <- cmap(trj, dcut=6, ncore=1)))
  invisible(capture.output(cm.mc <- cmap(trj, dcut=6, ncore=NULL)))
  expect_that(cm, equals(cm.mc, tolerance=1e-6))
})

`write.ncdf` <-
function(x, trjfile="R.ncdf", cell=NULL){

  ##- Load ncdf4 package
  oops <- requireNamespace("ncdf4", quietly = TRUE)
  if(!oops)
    stop("Please install the ncdf4 package from CRAN")

  ## Error checking
  if(!is.matrix(x))
    stop("input x should be a natom by nframe numeric matrix of coordinates")
  
  if(!is.null(cell)) {
     if(!is.matrix(cell))
       stop("input cell should be a 6 by nframe numeric matrix")
  }

  nframe <- nrow(x)
  natom <- ncol(x)/3

  ## Define dimensions
  frame <- ncdf4::ncdim_def(name="frame", units="", vals=c(1:nframe),
                        unlim=TRUE, create_dimvar=FALSE)

  spatial <- ncdf4::ncdim_def(name="spatial", units="", vals=1:3, #c(1:3),#"xyz",
                          unlim=FALSE, create_dimvar=TRUE)

  atom <- ncdf4::ncdim_def(name="atom", units="", vals=c(1:natom),
                       unlim=FALSE, create_dimvar=FALSE)

  if(!is.null(cell)) {
     label <- ncdf4::ncdim_def(name="label", units="", vals=1:5, 
             unlim=FALSE, create_dimvar=FALSE)
     cell_spatial <- ncdf4::ncdim_def(name="cell_spatial", units="", 
            vals=1:3, unlim=FALSE, create_dimvar=TRUE)
     cell_angular <- ncdf4::ncdim_def(name="cell_angular", units="", 
            vals=1:3, unlim=FALSE, create_dimvar=TRUE)
  }
     

##  label <- dim.def.ncdf(name="label", units="", vals=1:5, ##???
##                        unlim=FALSE, create_dimvar=FALSE)

##  cells <- dim.def.ncdf(name="cell_spatial", units="", vals=1:3,# "abc",
##                        unlim=FALSE, create_dimvar=TRUE)

##  cella <- dim.def.ncdf(name="cell_angular", units="", vals=1:3,
##                        #vals=c("alpha", "beta", "gamma"),
##                        unlim=FALSE, create_dimvar=TRUE)

  ## Define variables
  time <- ncdf4::ncvar_def(name="time", units="picosecond", dim=frame,
                       missval=1e+30, prec="float") #"single" float
  coor <- ncdf4::ncvar_def(name="coordinates", units="angstrom", missval=1e+30,
                       dim=list(spatial,atom,frame), prec="float")#"single" float
  if(!is.null(cell)) {
    cell_lengths <- ncdf4::ncvar_def(name="cell_lengths", units="angstrom", 
                 missval=1e+30, dim=list(cell_spatial, frame), prec="double")
    cell_angles <- ncdf4::ncvar_def(name="cell_angles", units="degree",
                 missval=1e+30, dim=list(cell_angular, frame), prec="double")
  }
##  cell.len <- var.def.ncdf(name="cell_lengths", units="angstrom", missval=1e+30,
##                           dim=list(cells,frame),  prec="double")
##  cell.ang <- var.def.ncdf(name="cell_angles", units="degrees", missval=1e+30,
##                           dim=list(cella,frame),  prec="double")
  
  ## Create the file
  if(!is.null(cell)) {
     ncw <- ncdf4::nc_create( trjfile, list(time, coor, cell_lengths, cell_angles))
  } else {
     ncw <- ncdf4::nc_create( trjfile, list(time, coor))#, cell.len, cell.ang) )
  }

  ## Write data to file
  if(is.null(rownames(x)))
     ncdf4::ncvar_put(ncw, time, c(1:nframe), start=1, count=nframe)
  else
     ncdf4::ncvar_put(ncw, time, as.numeric(rownames(x)), start=1, count=nframe)
  ncdf4::ncvar_put( ncw, coor, t(x), start=c(1,1,1), count=c(3,natom,nframe))
  if(!is.null(cell)) {
     ncdf4::ncvar_put( ncw, cell_lengths, t(cell[,1:3]), start=c(1,1), count=c(3,nframe))
     ncdf4::ncvar_put( ncw, cell_angles, t(cell[,4:6]), start=c(1,1), count=c(3,nframe))
  }

  ## Define Required Attributes
  ncdf4::ncatt_put(ncw, varid=0, attname="Conventions", attval="AMBER")
  ncdf4::ncatt_put(ncw, varid=0, attname="ConventionVersion", attval="1.0")
  ncdf4::ncatt_put(ncw, varid=0, attname="program",attval="bio3d")
  ncdf4::ncatt_put(ncw, varid=0, attname="programVersion", attval="1.2")
  null <- ncdf4::nc_close(ncw)
}

trim.mol2 <- function(mol, ..., inds=NULL) {

    if(!is.mol2(mol))
        stop("input should be of class 'mol2' as obtained by 'read.mol2'")
    
    cl <- match.call()
    extra.args <- list(...)
    
    if(length(extra.args)>0) {
      if(!is.null(inds))
          warning("Multiple atom selection terms provided. Using only argument 'inds'")
      else if(is.select(extra.args[[1]]))
          ## to be back-compatible with the habit calling trim.pdb(pdb, inds)
          inds = extra.args[[1]]
      else
          inds = atom.select(mol, ...)
    }

    if(is.null(inds))
        stop("no selection indices provided")
    
    if(!is.list(inds))
      stop("selection indices must be provided i.e. from 'atom.select'")
    
    if(is.null(inds$atom) || is.null(inds$xyz))
        stop("selection indices must be provided i.e. from 'atom.select'")
    

    new <- mol
    rownames(new$atom) <- new$atom$eleno
    new$atom <- new$atom[inds$atom,,drop=FALSE]
    new$atom$eleno <- 1:nrow(new$atom)
    new$bond <- mol$bond[inds$bond, ]
    
    xyz <- as.xyz(mol$xyz)
    new$xyz <- as.xyz(mol$xyz[, inds$xyz, drop=FALSE])
    
    new$info[1] <- nrow(new$atom)
    new$info[2] <- nrow(new$bond)
    new$info[3] <- length(unique(new$atom$resid))

    new$bond$origin = new$atom[ as.character(new$bond$origin), "eleno" ]
    new$bond$target = new$atom[ as.character(new$bond$target), "eleno" ]

    ## substrucutre
    if(!is.null(mol$substructure)) {
        new$substructure <- mol$substructure[ mol$substructure$root_atom %in% mol$atom$eleno[ inds$atom], ]
        
        if(nrow(new$substructure) > 0) {
            new$substructure$root_atom <- new$atom[ as.character(new$substructure$root_atom), "eleno" ]
            new$substructure$id <- 1:nrow(new$substructure)
        }
    }

    ## new ids and rownames
    new$bond$id <- 1:nrow(new$bond)
    rownames(new$bond) <- 1:nrow(new$bond)
    rownames(new$atom) <- 1:nrow(new$atom)
 
    return(new)
 }

    

summary.pdb <- function(object, printseq=FALSE, ...) {

  ## Print a summary of basic PDB object features

  if( !is.pdb(object) ) {
    stop("Input should be a pdb object, as obtained from 'read.pdb()'")
  }

  ## Multi-model check and total atom count
  nmodel <- nrow(object$xyz)
  if( is.null(nmodel) ) {
    ntotal <- length(object$xyz)/3
    nmodel = 1
  } else {
    ntotal <- length(object$xyz[1,])/3
  }

  nxyz <- length(object$xyz)
  nres <- sum(object$calpha)
  chains <- unique(object$atom[,"chain"])

  all.inds <- atom.select(object, "all", verbose=FALSE)$atom
  prot.inds <- atom.select(object, "protein", verbose=FALSE)$atom
  nuc.inds <- atom.select(object, "nucleic", verbose=FALSE)$atom
  other.inds <- all.inds[! (all.inds %in% c(prot.inds, nuc.inds)) ]
  
  nprot <-length(prot.inds)
  nnuc <-length(nuc.inds)
  nresnuc <- length(unique(
    paste(object$atom$chain[nuc.inds], object$atom$insert[nuc.inds], object$atom$resno[nuc.inds], sep="-")))
                                                
  het <- object$atom[other.inds,]
  nhet.atom <- nrow(het)
  
  if(is.null(nhet.atom) | nhet.atom==0) {
    nhet.atom <- 0
    nhet.res <- 0
    hetres <- "none"
  } else { 
  	hetres.resno <- apply(het[,c("chain","resno","resid")], 1, paste, collapse=".")
  	nhet.res <- length(unique(hetres.resno))
	hetres.nres <- table(het[,c("resid")][!duplicated(hetres.resno)])
  	hetres <- paste( paste0( names(hetres.nres), " (",hetres.nres, ")"), collapse=", ")
  }

  if((nprot+nnuc+nhet.atom) != ntotal)
    warning("nPROTEIN + nNUCLEIC + nNON-PROTEIN + nNON-NUCLEIC != nTotal")

 
  cat("\n Call:  ", paste(deparse(object$call), sep = "\n", collapse = "\n"),
        "\n", sep = "")

  s <- paste0("\n   Total Models#: ", nmodel, 
  			  "\n     Total Atoms#: ", ntotal, ",  XYZs#: ", nxyz, 
  			  "  Chains#: ", length(chains),
  			  "  (values: ", paste(chains, collapse=" "),")",

             "\n\n     Protein Atoms#: ", nprot,
              "  (residues/Calpha atoms#: ", nres,")",
              
              "\n     Nucleic acid Atoms#: ", nnuc,
              "  (residues/phosphate atoms#: ", nresnuc,")",

             "\n\n     Non-protein/nucleic Atoms#: ", nhet.atom,
             "  (residues: ", nhet.res, ")",
             "\n     Non-protein/nucleic resid values: [ ", hetres," ]",
             "\n\n")
              
  cat(s)

  if(printseq) {
    ##protein
    if(nres>0) {
      prot.pdb <- trim.pdb(object, as.select(prot.inds))
      aa <- pdbseq(prot.pdb)
      if(!is.null(aa)) {
        if(nres > 225) {
          ## Trim long sequences before output
          aa <- c(aa[1:225], "...<cut>...", aa[(nres-3):nres])
        }
        aa <- paste("     ",  gsub(" ","", 
                                   strwrap( paste(aa,collapse=" "), 
                                           width=120, exdent=0) ), collapse="\n")
        cat("   Protein sequence:\n", aa, "\n\n", sep="")
      }
    }
    
    ## nucleic
    if(nresnuc>0) {
      na.pdb <- trim.pdb(object, as.select(nuc.inds))
      aa <- paste(object$atom$chain[nuc.inds], object$atom$insert[nuc.inds],
                  object$atom$resno[nuc.inds], object$atom$resid[nuc.inds],
                  sep="-")
      aa <- aa[!duplicated(aa)]
      aa <- unlist(lapply(strsplit(aa, "-"), function(x) x[4]))
      aa <- .aa321.na(aa)
      if(nresnuc > 225) {
        ## Trim long sequences before output
        aa <- c(aa[1:225], "...<cut>...", aa[(nresnuc-3):nresnuc])
      }
      aa <- paste("     ",  gsub(" ","", 
                                 strwrap( paste(aa,collapse=" "), 
                                         width=120, exdent=0) ), collapse="\n")
      cat("   Nucleic acid sequence:\n", aa, "\n\n", sep="")
    }
  }
    
  i <- paste( attributes(object)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=45, exdent=8), sep="\n")

  invisible( c(nmodel=nmodel, natom=ntotal, nxyz=nxyz, nchains=length(chains),  
               nprot=nprot, nprot.res=nres, nother=nhet.atom, nother.res=nhet.res) )

}

"pdbs2sse" <- function(pdbs, ind=NULL, rm.gaps=TRUE, resno=TRUE, pdb=FALSE, ...) {
  ## Log the call
  cl <- match.call()
  by.resno <- resno

  if(is.null(ind))
    ind <- 1:length(pdbs$id)

  gaps.res <- gap.inspect(pdbs$ali)

  ## Use SSE information from pdbs object
  if(!is.null(pdbs$sse) & !pdb) {
      message("Extracting SSE from pdbs$sse attribute")
      
      if(rm.gaps) {
          sse <- pdbs$sse[ind, gaps.res$f.inds, drop=FALSE]
          resno <- pdbs$resno[ind[1], gaps.res$f.inds]
          chain <- pdbs$chain[ind[1], gaps.res$f.inds]
      }
      else {
          sse <- pdbs$sse[ind,, drop=FALSE]
          resno <- pdbs$resno[ind[1], ]
          chain <- pdbs$chain[ind[1], ]
      }

      if(nrow(sse) > 1) {
          h.inds <- which(apply(sse, 2, function(x) sum(x=="H")) == length(ind))
          e.inds <- which(apply(sse, 2, function(x) sum(x=="E")) == length(ind))
      }
      else {
          h.inds <- which(sse == "H")
          e.inds <- which(sse == "E")
      }
      
      if(by.resno) {
          h <- bounds( resno[h.inds], pre.sort=FALSE )
          e <- bounds( resno[e.inds], pre.sort=FALSE )
      }
      else {
          h <- bounds( h.inds, pre.sort=FALSE )
          e <- bounds( e.inds, pre.sort=FALSE )
      }

      sse2 <- rep(NA, ncol(sse))
      if(length(h.inds)>0) sse2[ h.inds ] <- "H"
      if(length(e.inds)>0) sse2[ e.inds ] <- "E"
      sse2[ is.na(sse2) ] <- " "
      names(sse2) <- paste(resno, chain, sep="_")
      
      out <- list()
      out$sse <- sse2
      
      if(length(h.inds)>0) {
        out$helix$start <- h[, "start"]
        out$helix$end <- h[, "end"]
        out$helix$length <- h[, "length"]
        out$helix$chain <- chain[ bounds(h.inds)[, "start"] ]
      } else {
        out$helix$start <- NULL
        out$helix$end <- NULL
        out$helix$length <- NULL
        out$helix$chain <- NULL
      }

      if(length(e.inds)>0) {
        out$sheet$start <- e[, "start"]
        out$sheet$end <- e[, "end"]
        out$sheet$length <- e[, "length"]
        out$sheet$chain <- chain[ bounds(e.inds)[, "start"] ]
      } else {
        out$sheet$start <- NULL
        out$sheet$end <- NULL
        out$sheet$length <- NULL
        out$sheet$chain <- NULL
      }

      out$call <- cl
      class(out) <- "sse"
      return(out)
  }

  ind <- ind[1]
  message(paste("Re-reading PDB (", basename.pdb(pdbs$id[ind]), ") to extract SSE", sep=""))
    
  if(file.exists(pdbs$id[ind]))
    id <- pdbs$id[ind]

  sse.aln <- NULL
  pdb.ref <- try(read.pdb(id), silent=TRUE)

  if(inherits(pdb.ref, "try-error"))
    pdb.ref <- try(read.pdb(substr(basename(id), 1, 4)), silent=TRUE)

  sse.ref <- NULL
  if(!inherits(pdb.ref, "try-error"))
    sse.ref <- try(dssp(pdb.ref, ...), silent=TRUE)

  if(!inherits(sse.ref, "try-error") & !inherits(pdb.ref, "try-error")) {
    if(rm.gaps) {
      resno <- pdbs$resno[ind, gaps.res$f.inds]
      chain <- pdbs$chain[ind, gaps.res$f.inds]
    }
    else {
      resno <- pdbs$resno[ind, ]
      chain <- pdbs$chain[ind, ]
    }

    resid <- paste0(resno, chain)
    resid[ resid == "NANA" ] = NA

    ## Helices
    if(length(sse.ref$helix$start) > 0) {
      resid.helix <- unbound(sse.ref$helix$start, sse.ref$helix$end)
      resid.helix <- paste0(resid.helix, rep(sse.ref$helix$chain, sse.ref$helix$length))
      h.inds      <- which(resid %in% resid.helix)

      ## inds points to the position in the alignment where the helices are
      if(by.resno) {
          resno.sse <- resno[ h.inds ]
          new.sse <- bounds(resno.sse, pre.sort=FALSE)
      }
      else {
          sids <- 1:length(resid)
          resno.sse <- sids[h.inds]
          new.sse <- bounds(resno.sse, pre.sort=FALSE)
      }
      chain.sse <- chain[ bounds(h.inds, pre.sort=FALSE)[, "start"] ]

      if(length(new.sse) > 0) {
        sse.aln$helix$start  <- new.sse[,"start"]
        sse.aln$helix$end    <- new.sse[,"end"]
        sse.aln$helix$length <- new.sse[,"length"]
        sse.aln$helix$chain <- chain.sse
      }
    } else {
        h.inds <- NULL
        sse.aln$helix$start  <- NULL
        sse.aln$helix$end    <- NULL
        sse.aln$helix$length <- NULL
        sse.aln$helix$chain <- NULL
    }

    ## Sheets
    if(length(sse.ref$sheet$start) > 0) {
      resid.sheet <- unbound(sse.ref$sheet$start, sse.ref$sheet$end)
      resid.sheet <- paste0(resid.sheet, rep(sse.ref$sheet$chain, sse.ref$sheet$length))
      e.inds      <- which(resid %in% resid.sheet)

      if(by.resno) {
          resno.sse <- resno[ e.inds ]
          new.sse <- bounds(resno.sse, pre.sort=FALSE)
      }
      else {
          sids <- 1:length(resid)
          resno.sse <- sids[e.inds]
          new.sse <- bounds(resno.sse, pre.sort=FALSE)
      }
      chain.sse <- chain[ bounds(e.inds, pre.sort=FALSE)[, "start"] ]

      if(length(new.sse) > 0) {
        sse.aln$sheet$start  <- new.sse[,"start"]
        sse.aln$sheet$end    <- new.sse[,"end"]
        sse.aln$sheet$length <- new.sse[,"length"]
        sse.aln$sheet$chain <- chain.sse
      }
    } else {
        e.inds <- NULL
        sse.aln$sheet$start  <- NULL
        sse.aln$sheet$end    <- NULL
        sse.aln$sheet$length <- NULL
        sse.aln$sheet$chain <- NULL
    }

    ## SSE vector
    sse2 <- rep(NA, length(resid))
    names(sse2) <- resid
    if(length(h.inds)>0) sse2[ h.inds ] <- "H"
    if(length(e.inds)>0) sse2[ e.inds ] <- "E"
    sse2[ is.na(sse2) ] <- " "
    sse.aln$sse <- sse2
  }
  else {
    msg <- NULL
    if(inherits(pdb.ref, "try-error"))
      msg = c(msg, paste("File not found:", pdbs$id[1]))
    if(inherits(sse.ref, "try-error"))
      msg = c(msg, "Launching external program 'DSSP' failed")

    warning(paste("SSE failed, ", msg, sep="\n  "))
  }

  sse.aln$call <- cl
  class(sse.aln) <- "sse"
  return(sse.aln)
}

"seqaln" <-
function(aln, id=NULL, profile=NULL,
                   exefile = "muscle",
                   outfile = "aln.fa",
                   protein = TRUE,
                   seqgroup = FALSE,
                   refine = FALSE,
                   extra.args = "",
                   verbose = FALSE,
                   web.args = list(),
                   ... ) {

  ## Log the call
  cl <- match.call()

  ## alignment to fasta object
  aln <- as.fasta(aln, id=id)

  ## nothing to align?
  if(!nrow(aln$ali) > 1 && is.null(profile)) {
    warning("nothing to align")
    aln$ali <- aln$ali[ , !is.gap(aln$ali), drop=FALSE]
    colnames(aln$ali) <- NULL
    return(aln)
  }
  
  if(!is.null(profile) & !inherits(profile, "fasta"))
      stop("profile must be of class 'fasta'")

  ## determine path to exefile
  test <- try( .get.exepath(exefile), silent=TRUE )
  if(inherits(test, 'try-error')) {
    success <- FALSE
  } else {
    exefile <- test
    success <- TRUE
    if(verbose)
      message(exefile)
  }
  
  if(grepl("clustalo", tolower(exefile))) {
    prg <- "clustalo"
    ##ver <- "--version"
    
    if(!is.null(profile))
      args <- c("", "--profile1", "--in", "--out")
    else
      args <- c("--in", "--out")

    extra.args <- paste(extra.args,"--force")
    if(seqgroup)
      extra.args <- paste(extra.args, "--output-order=tree-order")
    else
      extra.args <- paste(extra.args, "--output-order=input-order")
    
    if(verbose)
      extra.args <- paste(extra.args,"--verbose")

    if(!is.null(profile) && length(grep("dealign", extra.args))==0)
      warning("profile alignment with clustalo: consider using extra.args='--dealign'")
      
    #if(protein)
    #  extra.args <- paste(extra.args,"--seqtype Protein")
    #else
    #  extra.args <- paste(extra.args,"--seqtype DNA")
  }
  else if(grepl("msa", tolower(exefile))) {
    # Use bioconductor MSA package for alignment!
    
    if( !requireNamespace("msa", quietly=TRUE) ) { 
      stop("msa package missing: Please install it from Bioconductor, see: ?BiocManager::install")
    }
    if( !requireNamespace("Biostrings", quietly=TRUE) ) {
      stop("Biostrings package missing: Please install it from Bioconductor, see: ?BiocManager::install")
    }
   
    if(!is.null(profile)) {
       stop("Currently profile based alignment is not supported by 'msa'")
    }

    if(refine) {
       warning("Currently 'refine=TRUE' is not supported by 'msa'. Ignored")
    }

    # Write a temporary FASTA file to disc
    tf <- tempfile(pattern = "bio3d_aln",fileext = ".fasta")
    write.fasta(aln, gap=FALSE, file=tf)
  
    if(protein) {
       inputSeqs <- Biostrings::readAAStringSet(tf)
    } else {
       inputSeqs <- Biostrings::readDNAStringSet(tf)
    }
  
    # Alignmnet and conversion for Bio3D
    if(seqgroup) {
       order <- "aligned"
    } else {
       order <- "input"
    }

    res <- msa::msaMuscle(inputSeqs, order=order, ...)#type="protein", order="input"

    #res <- msa::msaMuscle(tf, type="protein",...)
    naln <- msa::msaConvert(res, type="bio3d::fasta")
    if(!is.null(outfile)) write.fasta(naln, file=outfile)
    
    naln$call=cl
    return(naln)
  }
  else {
    prg <- "muscle"
    ##ver <- "-version"
    
    if(!is.null(profile))
      args <- c("-profile", "-in1", "-in2", "-out")
    else
      args <- c("-in", "-out")

    if(refine)
      extra.args <- paste(extra.args,"-refine")
    if(protein)
      extra.args <- paste(extra.args,"-seqtype protein")
    else
      extra.args <- paste(extra.args,"-seqtype dna")
  }
  
  ## Check if the program is executable
  if(success) {
    os1 <- Sys.info()["sysname"]
    success <- .test.exefile(exefile)
  }
  
  if(!success) {
    if(length(web.args)==0) {
      stop(paste("You do not have ", prg, " installed/working locally on your machine.\n", 
        "  We can attempt to use the EBI webserver if you provide an email address (required by the EBI).\n",
        "  Please note that the EBI states (see their Terms of Use):\n",
        "     'Using fake e-mail address may result in your jobs being killed and your IP, Organisation or entire domain being black-listed.'\n", 
        sep=""))
    }
    cat('\n\nWill try to align sequences online...\n\n')
    
    default.web.args <- list(email='', title='', timeout=90)
    vnames <- names(web.args)
    vnames <- vnames[nzchar(vnames)]
    for(v in vnames) default.web.args[v] <- web.args[v]
    web.args <- default.web.args

    if(!is.null(profile))
      stop('Sequence-profile alignment is not supported by online web service.')
    if(!grepl('@', web.args$email))
      stop('A valid E-Mail address is required to use EMBL-EBI Web Service')
    
    naln <- .ebi_msa(aln, email=web.args$email, method=prg, protein=protein, 
                     title=web.args$title, timeout=web.args$timeout)
    if(!is.null(outfile)) write.fasta(naln, file=outfile)

  } else {

    ## Generate temporary files
    toaln <- tempfile()  
    write.fasta(aln, file=toaln)

    profilealn <- NULL
    if(!is.null(profile)) {
      profilealn <- tempfile()  
      write.fasta(profile, file=profilealn)
    }
    
    if(is.null(outfile))
      fa <- tempfile() 
    else
      fa <- outfile

    ## Build command to external program
    if(is.null(profile)) {
      cmd <- paste(args[1], toaln, args[2],
                   fa, extra.args, sep=" ")
    }
    else {
      cmd <- paste(args[1], args[2], profilealn, args[3], toaln, args[4],
                   fa, extra.args, sep=" ")
    }

    if(verbose)
      cat(paste("Running command:\n ", paste(exefile, cmd), "\n"))
    
    ## Run command
    if (os1 == "Windows") {
        status <- shell(paste(shQuote(exefile), cmd),
                        ignore.stderr = !verbose, ignore.stdout = !verbose)
    }
    else {
        status <- system(paste(exefile, cmd),
                         ignore.stderr = !verbose, ignore.stdout = !verbose)
    }

    if(!(status %in% c(0,1))) {
        stop(paste("An error occurred while running command\n '",
                   exefile, "'", sep=""))
    }
  
    naln <- read.fasta(fa, rm.dup=FALSE)

    ## Delete temporary files
    if(!is.null(profile))
      unlink(profilealn)
    unlink(toaln)
    if(is.null(outfile)) unlink(fa)
  }

  ## Re-group sequences to initial alignment order
  ## (muscle groups similar sequences by default)
  if(!seqgroup) {
    if(is.null(profile)) {
      ord <- match(aln$id, naln$id)
      naln$id <- naln$id[ord]
      naln$ali <- naln$ali[ord,]
    }
  }

  naln$call=cl
  return(naln)
}

## A client for EMBL-EBI multiple sequence alignment (MSA) Web Service.
## - 'x' must be a 'fasta' object.
## - 'email' must be a valid E-Mail address.
.ebi_msa <- function(x, email, method=c('muscle', 'clustalo'), protein=TRUE, title='', timeout=90) {
  method <- match.arg(method)

  oops <- requireNamespace("httr", quietly = TRUE)
  if(!oops)
    stop("Please install the httr package from CRAN")

#  oops <- requireNamespace("XML", quietly = TRUE)
#  if(!oops)
#    stop("Please install the XML package from CRAN")

  # Check number of sequences
  if(length(x$id)>500)
    stop("Number of sequences exceeds 500.") 

  baseUrl <- paste('http://www.ebi.ac.uk/Tools/services/rest/', method, sep='')

  # check if API works
  url <- paste(baseUrl, '/parameters', sep='')
  resp <- httr::GET(url)
  if(httr::http_error(resp))
    stop('EMBL-EBI msa-API request failed.')

  # submit a job
  url <- paste(baseUrl, '/run', sep='')
  seqs <- paste(paste('>', x$id, sep=''), apply(x$ali, 1, paste, collapse=''), 
                 sep='\n', collapse='\n')
  format <- switch(method, muscle='fasta', clustalo='fa')
  resp <- switch(method, 
    muscle = {
       httr::POST(url, body=list(email=email, title=title, format=format, 
             tree='none', order='aligned', sequence=seqs), encode='form')
       },
    clustalo = {
        httr::POST(url, body=list(email=email, title=title, 
          stype=ifelse(protein, 'protein', 'dna'),
          outfmt=format, dealign='true', sequence=seqs), encode='form')
    } )
  # check for errors
  if(httr::http_error(resp))
    stop('EMBL-EBI msa-API job submission failed.')

  # get job id 
  jobid <- httr::content(resp, 'text')
  cat('Job successfully submited (job ID: ', jobid, ')\n',
      'Waiting for job to finish...', sep='')
  
  # poll job status every 3s; stop if "error" obtained 3 times.
  # will also stopped if time out.
  url <- paste(baseUrl, '/status/', jobid, sep='')
  checkInterval = 3
  errorCount=0
  time = 0
  status <- 'PENDING'
  while((status %in% c('RUNNING', 'PENDING')) || 
        (status == 'ERROR' && errorCount < 2)) {
    status <- httr::content(httr::GET(url), 'text')
    if(status == 'ERROR') {
      errorCount <- errorCount + 1
    } else {
      if(errorCount > 0)
        errorCount <- errorCount - 1
    }
    if(status %in% c('RUNNING', 'PENDING', 'ERROR'))
      Sys.sleep(checkInterval)

    time <- time + checkInterval
    if(time >= timeout)
      stop(paste('\nConnection time out. Check your results from following URL:\n', 
        baseUrl, '/result/', jobid, '/aln-fasta', sep=''))
  }
  if(status != 'FINISHED') 
    stop('\nJob failed. Check your E-Mails for more information')

  cat('Done.\n')

  # check result type
  url <- paste(baseUrl, '/resulttypes/', jobid, sep='')
  resp <- httr::GET(url)
#  types <- XML::xmlToDataFrame(XML::xmlParse(httr::content(resp, 'text')), stringsAsFactors=FALSE)
  types <- httr::content(resp)
  types <- as.data.frame(t(sapply(types[[1]], function(x) x)), stringsAsFactors=FALSE)
  if(!any(grepl('fasta', types$identifier)))
    stop('Returned results do not contain FASTA format.')

  # get the results
  type <- types$identifier[grep('fasta', types$identifier)]
  url <- paste(baseUrl, '/result/', jobid, '/', type, sep='')
  resp <- httr::content(httr::GET(url), 'text')
  tfile <- tempfile()
  cat(resp, sep='', file=tfile)
  aln <- read.fasta(tfile)

  unlink(tfile)
  return(aln)
}

context("Testing seqaln")


test_that("seqaln works", {
  skip_on_cran()
  skip_on_travis()

  ## seqaln with one sequence. should remove gaps
  seqs <- c("X", "-", "-", "A", "C", "A", "G", "K", "-")
  suppressWarnings( aln <- seqaln(seqs) )
  expected <- c("X", "A", "C", "A", "G", "K")
  expect_identical(c(aln$ali), expected)
  

  ## align two sequences
  seqs <- seqbind(seqs,
                c("C", "A", "G", "G", "A", "G", "K"))
  aln <- seqaln(seqs)
  expected <- seqbind(c("-", "X", "A", "C", "A", "G", "K"),
                      c("C", "A", "G", "G", "A", "G", "K"))
  expect_identical(aln$ali, expected$ali)

    
  ## add a sequence to the (profile) alignment
  seq <- c("G", "A", "G", "K", "-")
  aln <- seqaln(seq, profile=aln)
  rownames(aln$ali) <- paste0("seq", 1:3)
  expected <- seqbind(c("-", "X", "A", "C", "A", "G", "K", "-"),
                      c("C", "A", "G", "G", "A", "G", "K", "-"),
                      c("-", "-", "-", "G", "A", "G", "K", "-"))
  expect_identical(aln$ali, expected$ali)

  ## test 'msa' option
  if( requireNamespace("msa", quietly=TRUE) ) { 
     capture.output( seqs <- get.seq(c("4q21_A", "1ftn_A"), outfile=tempfile()) )
     aln <- seqaln(seqs, outfile=tempfile())
     aln2 <- seqaln(seqs, outfile=tempfile(), exefile="msa")
     aln$call <- NULL; aln2$call <- NULL
     expect_identical(aln, aln2)
  }
})

  
  

"torsion.xyz" <-
function(xyz, atm.inc=4) {

  if(!is.vector(xyz) || !is.numeric(xyz))
    stop("input 'xyz' should be a numeric vector") 
  natm  <- length(xyz)/3
  if(natm < 4)
    stop("Need at least four atoms to define a dihedral")
  if(natm %% 1 != 0)
    stop("There should be three 'xyz' elements per atom")

  m.xyz <- matrix(xyz, nrow=3)
  atm.inds <- c(1:4); out<-NULL
  while(atm.inds[4] <= natm) {
    if( any(is.na( m.xyz[,atm.inds] )) ) {
      torp <- NA
    } else {
      d1 <- m.xyz[,atm.inds[2]] - m.xyz[,atm.inds[1]]
      d2 <- m.xyz[,atm.inds[3]] - m.xyz[,atm.inds[2]]
      d3 <- m.xyz[,atm.inds[4]] - m.xyz[,atm.inds[3]]

      u1 <- (d1[c(2,3,1)] * d2[c(3,1,2)]) - (d2[c(2,3,1)] * d1[c(3,1,2)])
      u2 <- (d2[c(2,3,1)] * d3[c(3,1,2)]) - (d3[c(2,3,1)] * d2[c(3,1,2)])

      ctor <- sum(u1*u2)/sqrt( sum(u1*u1) * sum(u2*u2) )
      ctor[ctor > 1] <- 1; ctor[ctor < -1] <- -1
      torp <- matrix(acos(ctor)*(180/pi),ncol=1)

      if( sum(u1 * ((u2[c(2,3,1)] * d2[c(3,1,2)]) -
                    (u2[c(3,1,2)] * d2[c(2,3,1)]))) < 0)
        torp <- -torp
    }
    out <- c(out, torp)
    atm.inds <- atm.inds + atm.inc
  }
  if(atm.inc == 1 & natm > 4) out <- c(NA, out, NA, NA)
  return(out)
}

"plot.pca.loadings" <-
function(x, resnums= seq(1,(length(x[,1])/3), 25), ... ) {

  # Plot residue loadings along PC1 to PC3 if given an xyz
  # C-alpha matrix of "loadings" (e.g. as returned from
  # 'pca.xyz' such a 'pca.trj$loadings')
  # For more info see 'pca.res.loadings'
  #
  # To Do: add gap.cols options

  if(is.list(x))  x=x$U
  
  pos <- resnums*3
  op <- par(no.readonly=TRUE)
  on.exit(par(op))
  par(mfrow=c(3,1), mar=c(4,4,2,2))

  plot(abs(x[,1]),main="",type="h",
       axes=FALSE, xlab="Index Number", ylab="PC1")
  axis(1, at=pos, labels=resnums)
  axis(2)
  box()

  plot(abs(x[,2]),main="",type="h",
       axes=FALSE,xlab="Index Number",ylab="PC2")
  axis(1, at=pos,labels=(pos)/3)
  axis(2)
  box()

  plot(abs(x[,3]),main="",type="h",
       axes=FALSE,xlab="Index Number",ylab="PC3")
  axis(1, at=pos,labels=(pos)/3)
  axis(2)
  box()
}

trim <- function(...)
  UseMethod("trim")

"trim.pdb" <- function(pdb, ..., inds=NULL, sse=TRUE) {

  if(!is.pdb(pdb))
    stop("input 'pdb' must be a PDB list object as returned from 'read.pdb'")

  cl <- match.call()
  extra.args <- list(...)

  if(length(extra.args)>0) {
    if(!is.null(inds))
      warning("Multiple atom selection terms provided. Using only argument 'inds'")
    else if(is.select(extra.args[[1]]))
      # to be back-compatible with the habit calling trim.pdb(pdb, inds)
      inds = extra.args[[1]]
    else
      inds = atom.select(pdb, ...)
  }

  if(is.null(inds))
    stop("no selection indices provided")

  if(!is.list(inds))
    stop("selection indices must be provided i.e. from 'atom.select'")

  if(is.null(inds$atom) || is.null(inds$xyz))
    stop("selection indices must be provided i.e. from 'atom.select'")

  ## Trim atom components
  atom <- pdb$atom[inds$atom,]

  ## Add calpha indices if non-existing
  if(is.null(pdb$calpha)) {
    ca.inds <- atom.select(pdb, "calpha")
    pdb$calpha <- rep(FALSE, nrow(pdb$atom))
    pdb$calpha[ca.inds$atom] <- TRUE
  }

  ## Trim calpha indices
  calpha <- pdb$calpha[inds$atom]

  ## Trim xyz components
  xyz <- trim.xyz(pdb$xyz, col.inds = inds$xyz)

  ## Trim SSE components
  helix <- NULL; sheet <- NULL;
  if(sse) {
    ss <- pdb2sse(pdb, verbose = FALSE)

    ##- Trim sse vector
    calpha2 <- which(pdb$calpha) %in% inds$atom
    ss <- ss[calpha2]

    ##- New sse
    new.sse <- bounds.sse(ss)

    helix <- new.sse$helix
    if(length(helix$start) > 0) {
       ##- add back other components
       add <- pdb$helix[!names(pdb$helix) %in% names(new.sse$helix)]
       ##- match sse number in case some sse are completely removed
       add <- lapply(add, function(x) x[new.sse$helix$id])
       helix <- c(helix, add)
    }

    sheet <- new.sse$sheet
    if(length(sheet$start) > 0) {
       ##- add back other components
       add <- pdb$sheet[!names(pdb$sheet) %in% names(new.sse$sheet)]
       ##- match sse number in case some sse are completely removed
       add <- lapply(add, function(x) x[new.sse$sheet$id])
       sheet <- c(sheet, add)
    }

    ##- remove 'id'; Maybe we don't need it?
    helix$id <- NULL
    sheet$id <- NULL
  }

  output <- list(atom   = atom,
                 helix  = helix,
                 sheet  = sheet,
                 seqres = pdb$seqres, ## return unmodified
                 xyz    = xyz,
                 calpha = calpha, 
                 call   = cl)

  class(output) <- class(pdb)
  return(output)
}

rle2 <- function (x) {
  ## This is a modified version of base function "rle()"
  if (!is.vector(x) && !is.list(x)) 
    stop("'x' must be an atomic vector")
  n <- length(x)
  if (n == 0L) 
    return(structure(list(lengths = integer(), values = x, inds=integer), class = "rle2"))
  y <- x[-1L] != x[-n]
  i <- c(which(y | is.na(y)), n)
  structure(list(lengths = diff(c(0L, i)), values = x[i], inds=i), class = "rle2")
}

print.rle2 <- function(x, digits = getOption("digits"), prefix = "", ...) {
  if (is.null(digits)) 
    digits <- getOption("digits")
  cat("", "Run Length Encoding\n", "  lengths:", sep = prefix)
  utils::str(x$lengths)
  cat("", "  values :", sep = prefix)
  utils::str(x$values, digits.d = digits)
  cat("", "  indices:", sep = prefix)
  utils::str(x$inds, digits.d = digits)
  invisible(x)
}

"pca.array" <- function(x, use.svd=TRUE, rm.gaps=TRUE, ...) {
  if(!is.array(x))
    stop("provide an array of matrices")
  
  ## Log the call
  cl <- match.call()
  
  ## Construct the input matrix for PCA
  x <- t(apply(x, 3, function(y) y[upper.tri(y)]))

  if (any(!is.finite(x))) {
    ## Check for GAP positions in input
    if(rm.gaps) {
       gapC <- colSums(is.na(x)) == 0
      if (sum(gapC) > 1) {
        x <- x[,gapC]
        cat(paste("NOTE: Removing", sum(!gapC), "upper triangular gap cells with missing data\n",
            "     retaining", sum(gapC), "upper triangular non-gap cells for analysis.\n"))
      } else {
        stop("No non-gap containing cell available for analysis.")
      }
    } else {
       stop( paste("  Infinite or missing values in 'x' input.",
      "\t Likely solution is to remove gap cells with rm.gaps=TRUE",
      "\t or remove gap containing matrices from input.", sep="\n") )
    }
  }

  dx <- dim(x)
  n <- dx[1]; p <- dx[2]
  mean <- colMeans(x)
  
  if(!use.svd) {
    ## coverance matrix
    S    <- var(x)          
    
    ## eigenvectors ("U") & eigenvalues ("L"): [ U'SU=L ]
    prj  <- eigen(S, symmetric = TRUE)
    L <- prj$values
    U <- prj$vectors
  }
  else {
    ## S = Q'Q, Q = UDV'
    Q <- t(t(x) - mean) / sqrt(n-1)
    prj <- svd(Q)
    L <- prj$d^2
    U <- prj$v
  }
  
  ## fix negative eigenvalues
  ## (these are very small numbers and should be zero)
  L[L<0]<-0
  sdev <- sqrt(L)
  
  ## scores of "xyz" on the pc's [ z=U'[x-x.mean] ]
  z <- sweep(x,2,mean) %*% (U)
  class(U)="pca.loadings"
  
  out <- list(L=L, U=U, z=z,
              sdev=sdev, mean=mean, call=cl)
  
  class(out)="pca"
  return(out)
}

"rmsd" <-
function(a, b=NULL,
                 a.inds=NULL,
                 b.inds=NULL,
                 fit=FALSE,
                 ncore=1,
                 nseg.scale=1) {

  # Calculate the RMSD between all rows of 'a' or between
  # the single structure 'a' and the one or more structures
  # contained in 'b'
   
  # Parallelized by parallel package -Wed Dec 12 11:15:20 EST 2012
  # nseg.scale - to resolve the memory problem of using multicore
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE
  
     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }

  ## from 'select' object to indices
  if(is.select(a.inds)) a.inds <- a.inds$xyz
  if(is.select(b.inds)) b.inds <- b.inds$xyz

  ## function to fetch xyz and ids from input
  getxyz <- function(x) {
      xyz <- NULL; ids <- NULL;
      
      if(is.pdbs(x)) {
          ids <- basename.pdb(as.character(x$id))
          xyz <- x$xyz
      }
      
      if(is.pdb(x)) {
          xyz <- x$xyz
          if(!is.null(rownames(xyz)))
              ids <- rownames(xyz)
      }
      
      if(is.matrix(x) | is.vector(x)) {
          xyz <- x
          if(!is.null(rownames(xyz)))
              ids <- basename.pdb(as.character(rownames(xyz)))
      }
      
      return(list(xyz=xyz, ids=ids))
  }
    
  ## set xyz and ids for a
  ax <- getxyz(a)
  a=ax$xyz; ids <- ax$ids;

  ## set xyz and ids for a
  if(!is.null(b)) {
      bx <- getxyz(b)
      b=bx$xyz; ids <- bx$ids;
  }

  if( is.null(a.inds) && is.null(b.inds) ) {
    a.inds <- gap.inspect(a)$f.inds

    if(!is.null(b)) { 
      a.inds <- intersect(a.inds, gap.inspect(b)$f.inds)
    }
    b.inds <- a.inds
    if(length(a.inds) != length(a)) {
      warning(paste("No indices provided, using the",
                  length(a.inds)/3,  "non NA positions\n"))
    }
  }

  if (is.null(a.inds)) a.inds <- gap.inspect(a)$f.inds
  if (is.null(b.inds) && !is.null(b)) b.inds <- gap.inspect(b)$f.inds

  if(is.vector(a) || nrow(a)==1) {
    if(is.null(b)) {
      stop("No comparison can be made, input was only a single vector 'a'")
    }
  } else {
    if(is.null(b)) {
      # Pair Wise Matrix 'a'
      if( any(is.na(a[,a.inds])) ) {
        stop("error: NA elements present in selected set")
      }
      nseq=nrow(a)
      inds=pairwise(nseq)
      ni <- nrow(inds)

      if(ncore > 1){          # Parallelized
         RLIMIT = R_NCELL_LIMIT
         nDataSeg = floor((ni-1)/RLIMIT)+1
         nDataSeg = floor(nDataSeg * nseg.scale)
         lenSeg = floor(ni/nDataSeg)
         s = vector("list", nDataSeg)
         for(i in 1:nDataSeg) {
            istart = (i-1)*lenSeg + 1
            iend = if(i<nDataSeg) i*lenSeg else ni 
            s[[i]] <- mclapply(istart:iend, function(j) {
                 x <- a[inds[j,1],a.inds]
                 y <- a[inds[j,2],a.inds]
                 if(fit) {
                   y <- fit.xyz(fixed=x, mobile=y, fixed.inds=1:length(x))
                 }
                 sqrt(sum((x-y)^2)/(length(a.inds)/3))
               },
               mc.preschedule=TRUE)
         }
         s <- unlist(s)
      } else {               # Single version
         s <- rep(NA, ni)
         for(i in 1:ni) {
           x <- a[inds[i,1],a.inds]
           y <- a[inds[i,2],a.inds]
           if(fit) {
             y <- fit.xyz(fixed=x, mobile=y, fixed.inds=1:length(x))
           }
           s[i]<-sqrt(sum((x-y)^2)/(length(a.inds)/3))
         }
      }

      sm <- matrix(0, ncol=nseq,nrow=nseq)
      sm[inds]<-s
      if(nseq==2) {
        sm[inds[,2], inds[,1]]<-s
      } else {
        sm[inds[,c(2,1)]]<-s
      }

      if(!is.null(ids)) {
          rownames(sm) <- ids
          colnames(sm) <- ids
      }
      return(round(sm,3))

    } else {
      stop("input 'b' supplied:
              Therefore 'a' should be a single vector for comparison with 'b'.
               Not a matrix or list")
    }
  }

  if(is.vector(b) || nrow(b)==1) {
    if (length(a.inds) != length(b.inds)) {
      stop("dimension mismatch:
              a[a.inds] and b[b.inds] should be the same length")
    }
    if( any(is.na(a[a.inds])) ||
       any(is.na(b[b.inds])) ) {
      stop("error: NA elements present in selected set")
    }

    if(fit) {
      b <- fit.xyz(fixed=a,mobile=b,fixed.inds=a.inds,mobile.inds=b.inds)
    }

    irmsd <- sqrt(sum((a[a.inds] - b[b.inds])^2)/(length(a[a.inds])/3) )
    return(round(irmsd,3))

  } else {
    if(is.matrix(b) && (nrow(b) > 1)) {
      if (length(a.inds) != length(b.inds)) {
          stop("dimension mismatch:
                  a[a.inds] and b[,b.inds] should be the same length")
      }
      if( any(is.na(a[a.inds])) ||
         any(is.na(b[,b.inds])) ) {
        stop("error: NA elements present in selected set")
      }
      if(fit) {
         # Parallelized / single version
         b <- fit.xyz(fixed=a, mobile=b,
                     fixed.inds=a.inds, mobile.inds=b.inds, 
                     ncore=ncore, nseg.scale=nseg.scale)
      }

      if(ncore > 1){            # Parallelized
         RLIMIT = R_NCELL_LIMIT
         nDataSeg = floor((nrow(b)-1)/RLIMIT)+1
         nDataSeg = floor(nDataSeg * nseg.scale)
         lenSeg = floor(nrow(b)/nDataSeg)
         irmsd = vector("list", nDataSeg)
         for(i in 1:nDataSeg) {
            istart = (i-1)*lenSeg + 1
            iend = if(i<nDataSeg) i*lenSeg else nrow(b)
            irmsd[[i]] <- mclapply(istart:iend, function(j) 
                  sqrt( sum((b[j,b.inds]-a[a.inds])^2)/(length(a[a.inds])/3) ),
               mc.preschedule=TRUE)
         }
         irmsd <- unlist(irmsd)
         if(!is.null(ids)) names(irmsd) <- ids
      } else {                  # Single version
         irmsd <- sqrt( apply((apply(b[,b.inds],1,"-",a[a.inds])^2),2,sum)/(length(a[a.inds])/3) )
         if(!is.null(ids)) names(irmsd) <- ids
      }
      return(round(irmsd,3))
    }
  }
}

context("Testing RMSD function")

test_that("rmsd() gets the same results as PyMOL", {
  file <- system.file(c("examples/1hel.pdb", "examples/1dpx.pdb"), package="bio3d")

   invisible(capture.output(pdb.a <- read.pdb(file[1])))
   invisible(capture.output(pdb.b <- read.pdb(file[2])))

   invisible(capture.output(inds.a <- atom.select(pdb.a, "calpha")))
   invisible(capture.output(inds.b <- atom.select(pdb.b, "calpha")))

  rd1 <- rmsd(a=pdb.a$xyz, b=pdb.b$xyz, a.inds=inds.a$xyz, b.inds=inds.b$xyz, fit=FALSE)
  rd2 <- rmsd(a=pdb.a$xyz, b=pdb.b$xyz, a.inds=inds.a$xyz, b.inds=inds.b$xyz, fit=TRUE)
  
  ## with pymol "pair_fit 1hel and name CA, 1dpx and name CA" = 0.293
  rmsd1 <- 1.386
  rmsd2 <- 0.293

  expect_equal(round(rd1, 3), rmsd1)
  expect_equal(round(rd2, 3), rmsd2)
})

test_that("rmsd() with ncore>1 works properly", {

  file <- system.file(c("examples/1hel.pdb", "examples/1dpx.pdb"), package="bio3d")
  invisible(capture.output(pdb.a <- read.pdb(file[1])))
  invisible(capture.output(pdb.b <- read.pdb(file[2])))
  
  invisible(capture.output(inds.a <- atom.select(pdb.a, "calpha")))
  invisible(capture.output(inds.b <- atom.select(pdb.b, "calpha")))
     
  ## check if ncore > 1 is really faster 
  time1 <- system.time(rmsd1 <- rmsd(a=pdb.a$xyz, b=pdb.b$xyz, a.inds=inds.a$xyz, b.inds=inds.b$xyz, fit=TRUE, ncore=1))
  time2 <- system.time(rmsd2 <- rmsd(a=pdb.a$xyz, b=pdb.b$xyz, a.inds=inds.a$xyz, b.inds=inds.b$xyz, fit=TRUE, ncore=NULL))
  
  ##time1 <- time1["elapsed"]
  ##time2 <- time2["elapsed"]
  
#  expect_equivalent(rmsd1, rmsd2)
  expect_equal(rmsd1, rmsd2, tolerance=1e-6)
  
#   cat("Speed up by", round((time1-time2)/time2, 1)*100, "%", sep="")
#   if(getOption("cores") > 1)
#      expect_true(time1 > time2)
})

"as.select" <- function(x, ...) {
  cl <- match.call()
  
  if(is.select(x)) {
    return(x)
  }
  else {
    if(!is.vector(x))
      stop("provide a numeric vector of atom indices")
    
    if(all(is.logical(x)))
      x <- which(x)
    if(!all(is.numeric(x)))
      stop("provide a numeric vector of atom indices")
    
    sele <- NULL
    sele$atom <- x
    sele$xyz <- atom2xyz(x)
    sele$call <- cl
    class(sele) <- "select"
    return(sele)
  }
}

"dssp.pdbs" <- function(pdbs, ...) {
  if(!is.pdbs(pdbs))
    stop("provide a pdbs object as obtained from pdbaln()")
  
  dots <- list(...)
  if(any(c("resno", "full") %in% names(dots)))
    stop("arguments resno and full not allowed in dssp.pdbs()")
  
  gaps.res <- gap.inspect(pdbs$ali)
  sse <- matrix(NA, ncol=ncol(pdbs$resno), nrow=nrow(pdbs$resno))
  
  for ( i in 1:length(pdbs$id) ) {
    ##- Check for local and/or online PDB file to run dssp on
    file <- pdbs$id[i]
    toread <- file.exists(file)
    if ((substr(file, 1, 4) == "http") | (nchar(file) == 4)) {
      toread <- TRUE
    }
    if (!toread) {
      stop(paste("Corresponding PDB file could not be found for entry:\n\t-", pdbs$id[i]))
    }
 
    tmp.pdb = read.pdb(pdbs$id[i])
    tmp.sse = dssp.pdb(tmp.pdb, resno=FALSE, full=FALSE, ...)

    ##sse[i,  which(gaps.res$bin[i,]==0)] = tmp.sse$sse

    ##- this old way (line 30) will have problems if alignment contains 
    ##  only a portion of the full PDB structure read on line 27 above. 
    ##  Thus the edit below uses residue number and chain id from the 
    ##  alignment (ali.names) as a reference to populate the sse matrix 
    ##  from the PDB dssp result (pdb.names) 

    ali.names <- paste(pdbs$resno[i,], pdbs$chain[i,], sep="_")

    pdb.names <- paste(tmp.pdb$atom$resno[tmp.pdb$calpha],
                       tmp.pdb$atom$chain[tmp.pdb$calpha], sep="_")
    names(tmp.sse$sse) <- pdb.names
        
    sse[i,] <- tmp.sse$sse[ ali.names ]
  }

  return(sse)
}

"read.fasta.pdb" <-
  function(aln, prefix="", pdbext="", fix.ali = FALSE, pdblist=NULL, 
           ncore=1, nseg.scale=1, progress=NULL, ...) {

  ## Log the call
  cl <- match.call()
  
  # Parallelized by parallel package (Fri Apr 26 17:58:26 EDT 2013)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }
  
  if(is.null(pdblist)) {
    files  <- paste(prefix, aln$id, pdbext,sep="")
    
    ##cat(files,sep="\n")
    toread <- file.exists(files)

    ## check for online files
    toread[ substr(files,1,4)=="http" ] <- TRUE
    
    if(all(!toread))
      stop("No corresponding PDB files found")

    ## Avoid multi-thread downloading
    if(any(substr(files,1,4) == "http")) {
      ncore = 1
#      options(cores = ncore)
    }
  }
  else {
    toread <- rep(FALSE, length(pdblist))
    files <- rep(NA, length(pdblist))
  }
  

  blank <- rep(NA, ncol(aln$ali))
 
  retval <- mclapply(1:length(aln$id), function(i) {
    coords <- NULL; res.nu <- NULL
    res.bf <- NULL; res.ch <- NULL
    res.id <- NULL; res.ss <- NULL

    ## edit for shiny version
    if(!is.null(progress)) {
      progress$inc(1/length(aln$id)/2)
    }
    ## edit end

    cat(paste("pdb/seq:",i,"  name:", aln$id[i]),"\n")

    if(!toread[i] & is.null(pdblist)) {
      warning(paste("No PDB file found for seq", aln$id[i],
              ": (with filename) ",files[i]), call.=FALSE)
      coords <- rbind(coords, rep(blank,3))
      res.nu <- rbind(res.nu, blank)
      res.bf <- rbind(res.bf, blank)
      res.ch <- rbind(res.ch, blank)
      res.id <- rbind(res.id, blank)
      res.ss <- rbind(res.ss, blank)
      
    } else {
      if(is.null(pdblist))
        pdb <- read.pdb( files[i], verbose=FALSE, ... )
      else
        pdb <- pdblist[[i]]
      ca.inds <- atom.select(pdb, "calpha", verbose=FALSE)
      pdbseq  <- aa321(pdb$atom$resid[ca.inds$atom])
      aliseq  <- toupper(aln$ali[i,])
      tomatch <- gsub("X","[A-Z]",aliseq[!is.gap(aliseq)])
      
      if(length(pdbseq)<1)
        stop(paste(basename(aln$id[i]), ": insufficent Calpha's in PDB"), call.=FALSE)
      
      ##-- Search for ali residues (1:15) in pdb
      start.num <- regexpr(pattern = paste(c(na.omit(tomatch[1:15])),collapse=""),
                           text = paste(pdbseq,collapse=""))[1]
            
      if (start.num == -1) {
        start.num <- 1
        ##stop(paste(basename(aln$id[i]), ": starting residues of sequence does not match starting residues in PDB"), call.=FALSE)
      }

      ##-- Numeric vec, 'nseq', for mapping aln to pdb
      nseq <- rep(NA,length(aliseq))
      ali.res.ind <- which(!is.gap(aliseq))
      if( length(ali.res.ind) > (length(pdbseq) - start.num + 1) ) {
        warning(paste(aln$id[i],
         ": sequence has more residues than PDB has Calpha's"), call.=FALSE)
        ali.res.ind <- ali.res.ind[1:(length(pdbseq)-start.num+1)] ## exclude extra
        tomatch <-  tomatch[1:(length(pdbseq)-start.num+1)]        ## terminal residues
      }
      nseq[ali.res.ind] = start.num:((start.num - 1) + length(tomatch))

      ##-- Check for miss-matches
      match <- aliseq != pdbseq[nseq] 
      if ( sum(match, na.rm=TRUE) >= 1 ) {
        mismatch.ind <- which(match)
        mismatch <- cbind(aliseq, pdbseq[nseq])[mismatch.ind,]
        n.miss <- length(mismatch.ind)

        if(sum(mismatch=="X") != n.miss) { ## ignore masked X res        
          details <- seqbind(aliseq, pdbseq[nseq])
          details$ali[is.na(details$ali)] <- "-"
          rownames(details$ali) <- c("aliseq","pdbseq")
          details$id <- c("aliseq","pdbseq")
          
          resmatch <- which(!apply(details$ali, 2, function(x) x[1]==x[2]))
          
          resid <- paste(pdb$atom$resid[ca.inds$atom][nseq][resmatch][1], "-",
                         pdb$atom$resno[ca.inds$atom][nseq][resmatch][1],
                         " (", pdb$atom$chain[ca.inds$atom][nseq][resmatch][1], ")", sep="")
          
          cat("\n ERROR   Alignment mismatch. See alignment below for further details\n")
          cat("         (row ", i, " of aln and sequence of '", aln$id[i], "').\n", sep="")
          cat("         First mismatch residue in PDB is:", resid, "\n")
          cat("         occurring at alignment position:", which(match)[1], "\n\n")
          .print.fasta.ali(details)
          
          msg <- paste(basename.pdb(aln$id[i]),
                       " alignment and PDB sequence miss-match\n",
                       "       beginning at position ",
                       which(match)[1], " (PDB RESNO ", resid, ")", sep="")
          stop(msg, call.=FALSE)
        }
      }
      
      ##-- Store nseq justified/aligned PDB data
      ca.ali <- pdb$atom[ca.inds$atom,][nseq,]
      coords <- rbind(coords, as.numeric( t(ca.ali[,c("x","y","z")]) ))
      res.nu <- rbind(res.nu, ca.ali[, "resno"])
      res.bf <- rbind(res.bf, as.numeric( ca.ali[,"b"] ))
      res.ch <- rbind(res.ch, ca.ali[, "chain"])
      res.id <- rbind(res.id, ca.ali[, "resid"])

      sse <- pdb2sse(pdb, verbose = FALSE)
      res.ss <- rbind(res.ss, sse[nseq])
    } ## end else for (non)missing PDB file
    return (list(coords=coords, res.nu=res.nu, res.bf=res.bf, res.ch=res.ch, res.id=res.id, res.ss=res.ss))
  } , mc.cores=ncore) ## end mylapply

  retval <- do.call(rbind, retval)
  coords <- matrix(unlist(retval[, "coords"]), nrow=length(aln$id), byrow=TRUE)
  res.nu <- matrix(unlist(retval[, "res.nu"]), nrow=length(aln$id), byrow=TRUE)
  res.bf <- matrix(unlist(retval[, "res.bf"]), nrow=length(aln$id), byrow=TRUE)
  res.ch <- matrix(unlist(retval[, "res.ch"]), nrow=length(aln$id), byrow=TRUE)
  res.id <- matrix(unlist(retval[, "res.id"]), nrow=length(aln$id), byrow=TRUE)
 
  if( any(sapply(retval[, "res.ss"], is.null)) ) {
     res.ss <- NULL
  }
  else {
     res.ss <- matrix(unlist(retval[, "res.ss"]), nrow=length(aln$id), byrow=TRUE)
     rownames(res.ss) <- aln$id
  }

  rownames(aln$ali) <- aln$id
  rownames(coords) <- aln$id
  rownames(res.nu) <- aln$id
  rownames(res.bf) <- aln$id
  rownames(res.ch) <- aln$id
  rownames(res.id) <- aln$id
 
  if(fix.ali) {
     i1 <- which(is.na(res.nu))
     i2 <- which(is.gap(aln$ali))
     if(!identical(i1, i2)) {
        aln$ali[i1] <- aln$ali[i2[1]]
        warning("$ali component is modified to match $resno")
     }
  }

  out<-list(xyz=coords, resno=res.nu, b=res.bf,
            chain = res.ch, id=aln$id, ali=aln$ali, resid=res.id, sse=res.ss,
            call = cl)
  class(out)=c("pdbs","fasta")
  class(out$xyz) = "xyz"

  return(out)
}

#' Obtain An SSE Sequence Vector From A PDB Object
#'
#' Results are similar to that returned by stride(pdb)$sse and dssp(pdb)$sse. 
#'
#' @details call for its effects.
#' 
#' @param pdb an object of class \code{pdb} as obtained from
#'    function \code{\link{read.pdb}}. 
#' @param verbose logical, if TRUE warnings and other messages will be printed.
#'
#' @return a character vector indicating SSE elements for each amino acide residue.
#'    The 'names' attribute of the vector contains 'resno', 'chain', 'insert', and
#'    'SSE segment number', seperated by the character '_'.
#'
#' @seealso \code{\link{dssp}}, \code{\link{stride}}, \code{\link{bounds.sse}}
#'
#' @author Barry Grant & Xin-Qiu Yao
#' 
#' @examples
#' \donttest{
#'    #PDB server connection required - testing excluded
#'
#'    pdb <- read.pdb("1a7l")
#'    sse <- pdb2sse(pdb)
#'    sse
#' } 
pdb2sse <- function(pdb, verbose = TRUE) {
  ##- Function to obtain an SSE sequence vector from a PDB object
  ##   Result similar to that returned by stride(pdb)$sse and dssp(pdb)$sse
  ##   This could be incorporated into read.pdb() if found to be more generally useful
  ##

  if(is.null(pdb$helix) & is.null(pdb$sheet)) {
    if(verbose) 
       warning("No helix and sheet defined in input 'sse' PDB object: try using dssp()")
    ##ss <- try(dssp(pdb)$sse)
    ## Probably best to get user to do this separately due to possible 'exefile' problems etc..
    return(NULL)
  }

  ## An empty full length SSE vector
  ref <- pdb$atom[pdb$calpha, c("resno", "chain", "insert")]
  ref <- paste(ref$resno, ref$chain, ref$insert, sep="_")
  ss <- rep(" ", length(ref))
  names(ss) <- ref
 
  ## loop over 'Helix' and 'Sheet'
  symbol <- c(helix="H", sheet="E")
  for(i in names(symbol)) {

     sse <- pdb[[i]]

     if(length(sse$start) > 0) {
        for(j in 1:length(sse$start)) {
           chain <- ifelse(sse$chain[j]=="", NA, sse$chain[j])
           insert0 <- ifelse(names(sse$start[j])=="", NA, names(sse$start[j]))
           sse.ref0 <- paste(sse$start[j], chain, insert0, sep = "_")

           insert1 <- ifelse(names(sse$end[j])=="", NA, names(sse$end[j]))
           sse.ref1 <- paste(sse$end[j], chain, insert1, sep = "_")
        
           ii <- match(sse.ref0, ref); jj <- match(sse.ref1, ref)
           if(any(is.na(c(ii, jj)))) {
              if(verbose) 
                  warning(paste("The", i, "No.", j, 
                     "start/end with non-protein residue."))
           } else {
              inds <- seq(ii, jj)
              ss[inds] <- symbol[i]
              names(ss)[inds] <- paste(names(ss)[inds], "_", j, sep="")
           }
        }
     } 
  }
  return(ss)
}

context("Testing the utility function clean.pdb()")

test_that("clean.pdb() does nothing for 'clean' pdb by default", {

  file <- system.file("examples/1dpx.pdb", package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))

  suppressWarnings(
    invisible(capture.output(npdb <- clean.pdb(pdb)))
  )
 
  expect_true(is.null(npdb$log))

  npdb$call <- NULL
  npdb$log <- NULL
  pdb$call <- NULL
  expect_equal(pdb, npdb)

})


test_that("clean.pdb() does renumbering properly", {

  skip_on_cran()
  skip_on_travis()

  suppressWarnings(
    invisible(capture.output(pdb <- read.pdb("1tag")))
  )
  invisible(capture.output(npdb <- clean.pdb(pdb, force.renumber = TRUE)))

  resno <- npdb$atom[npdb$calpha, "resno"]
  expect_equal(resno[1:10], 1:10)

  # A PDB with 'insert' residues: Should do automatic renumbering
  invisible(capture.output(pdb <- read.pdb("1a7l")))
  invisible(capture.output(npdb <- clean.pdb(pdb)))
  
  resno <- npdb$atom[npdb$calpha, "resno"]
  expect_equal(resno[1:10], 1:10)

  # Renumbering for each chain
  invisible(capture.output(npdb <- clean.pdb(pdb, consecutive = FALSE)))

  resno <- npdb$atom[npdb$calpha, "resno"]
  chain <- npdb$atom[npdb$calpha, "chain"]
  expect_equal(resno[chain=="B"][1:10], 1:10)
 
  # Is SSE update correct?
  invisible(capture.output(ss <- pdb2sse(pdb)))
  invisible(capture.output(nss <- pdb2sse(npdb)))

  expect_equal(as.character(ss), as.character(nss))
 
} )


test_that("clean.pdb() relabels chains properly (fix.chain = TRUE)", {

  file <- system.file("examples/1dpx.pdb", package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))

  # remove chain ID
  pdb$atom[, "chain"] <- as.character(NA)
  pdb$helix$chain <- "" 
  pdb$sheet$chain <- "" 

  suppressWarnings(
    invisible(capture.output(npdb <- clean.pdb(pdb, fix.chain = TRUE)))
  )
  
  expect_equal(npdb$atom[npdb$calpha, "chain"], rep("A", sum(npdb$calpha)))

  # A case with wrong chain labels but consecutive residue numbering
  file <- system.file("examples/hivp.pdb", package="bio3d")
  invisible(capture.output(pdb0 <- read.pdb(file)))

  # Manually renumbering all residues
  pdb <- pdb0
  pdb$atom[, "resno"] <- vec2resno(1:sum(pdb$calpha), 
                  paste(pdb$atom[, "resno"], pdb$atom[, "chain"], sep = "_") ) 

  # Label both chains as "A" 
  pdb$atom[, "chain"] <- "A"
  
  # Update SSE 
  pdb$helix$start[pdb$helix$chain=='B'] <- pdb$helix$start[pdb$helix$chain=='B'] + 99
  pdb$helix$end[pdb$helix$chain=='B'] <- pdb$helix$end[pdb$helix$chain=='B'] + 99
  pdb$sheet$start[pdb$sheet$chain=='B'] <- pdb$sheet$start[pdb$sheet$chain=='B'] + 99
  pdb$sheet$end[pdb$sheet$chain=='B'] <- pdb$sheet$end[pdb$sheet$chain=='B'] + 99
  pdb$helix$chain[] <- 'A'
  pdb$sheet$chain[] <- 'A'
 
  suppressWarnings(
    invisible(capture.output(npdb <- clean.pdb(pdb, consecutive = FALSE, force.renumber = TRUE, fix.chain = TRUE)))
  )
  
  pdb0$call <- NULL
  npdb$call <- NULL
  npdb$log <- NULL
  expect_equal(pdb0, npdb)
 
} )

print.cna <- function(x, ...) {

  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }
  
  ## y <- summary.cna(x, ...)

  l1 <- paste( "\n - NETWORK NODES#:  ", x$communities$vcount,
              "\tEDGES#:", igraph::ecount(x$network))
 
  l2 <- paste( "\n - COMMUNITY NODES#:", max(x$communities$membership),
              "\tEDGES#:", igraph::ecount(x$community.network))

  cat("\nCall:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"), "\n", sep = "")
  cat("\nStructure:",l1,l2,"\n\n ")
  
  i <- paste( attributes(x)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")
  #print.igraph(x$network)
  #print.igraph(x$community.network)
}

`write.pqr` <-
function (pdb = NULL,
          xyz = pdb$xyz,
          resno = NULL,
          resid = NULL,
          eleno = NULL,
          elety = NULL,
          chain = NULL,
          o = NULL,
          b = NULL,
          append = FALSE,
          verbose =FALSE,
          chainter = FALSE,
          file = "R.pdb") {

## For Testing:
## resno = NULL; resid = NULL;eleno = NULL;elety = NULL;chain = NULL;o = NULL;b = NULL; het = FALSE;append = FALSE;verbose =FALSE;chainter = FALSE
## pdb=mt; eleno=eleno.new; resno=resno.new; file="t3.pqr"
    
  if(is.null(xyz) || !is.numeric(xyz))
    stop("write.pqr: please provide a 'pdb' object or numeric 'xyz' vector")

  if(any(is.na(xyz)))
    stop("write.pqr: 'xyz' coordinates must have no NA's.")

  xyz <- as.xyz(xyz)
  xyz <- trim(xyz, row.inds=1)
  natom <- ncol(xyz)/3
  nfile <- 1
        
  if (nrow(xyz)>1) {
      warning("write.pqr: no multimodel PQR support")
      xyz <- trim(xyz, row.inds=1)
      ##natom <- ncol(xyz)/3 
      ##nfile <- nrow(xyz)
      ##if (verbose) {
      ##  cat("Multiple 'xyz' rows will be interperted as multimodels/frames\n")
  }
  
  card <- rep('ATOM', natom)
  
  if(!is.null(pdb)) {
#    if(natom == 1)
      ## make sure we are a matrix
#      pdb$atom <- t(as.matrix(pdb$atom))

    card <- pdb$atom$type

    if (is.null(resno))
      resno = pdb$atom[, "resno"]
    
    if (is.null(resid))
      resid = pdb$atom[, "resid"]
    
    if (is.null(eleno))
      eleno = pdb$atom[, "eleno"]
    
    if (is.null(elety))
      elety = pdb$atom[, "elety"]
   
    if (is.null(chain)) {
      chain = pdb$atom[, "chain"]
    }
    else {
      if(length(chain)==1) chain=rep(chain, natom)
    }

    if (is.null(o))
      o = pdb$atom[, "o"]
    
    if (is.null(b))
      b = pdb$atom[, "b"]
    
    if (any(is.na(o))) {      o = rep("0.00", natom) }
    if (any(is.na(b))) {      b = rep("1.00", natom) }
    #if (any(is.na(chain))) { chain = rep(" ", natom) }
    chain[is.na(chain)]= ""
    
  } else {
    if (is.null(resno)) resno = c(1:natom)
    if (is.null(resid)) resid = rep("ALA", natom)
    if (is.null(eleno)) eleno = c(1:natom)
    if (is.null(elety)) elety = rep("CA", natom)
    if (is.null(chain)) {
      chain = rep("", natom)
    }
    else {
      if (length(chain) == 1) chain = rep(chain, natom)
    }
    if (is.null(o))         o = rep("0.00",natom)
    if (is.null(b))         b = rep("1.00", natom)

    chain[is.na(chain)]= ""
  }

  
  if (!is.logical(append)) 
    stop("write.pqr: 'append' must be logical TRUE/FALSE")
  
  if (length(as.vector(xyz))%%3 != 0) {
    stop("write.pqr: 'length(xyz)' must be divisable by 3.")
  }
  check.lengths <- sum(length(resno), length(resid), length(eleno),
                       length(elety), length(o), length(b))
  if (check.lengths%%natom != 0) {
    stop("write.pqr: the lengths of all input vectors != 'length(xyz)/3'.")
  }

  
  o <- as.numeric(o)
  b <- as.numeric(b)
  eleno <- as.character(eleno)
  resno <- as.character(resno)
  ## Inserted Jul 8th 2008 for adding TER between chains
  ter.lines <- (which(!duplicated(chain))[-1] - 1)

####  
####  ## Edit: Sat Aug  1 14:48:48 PDT 2009
####  ## for speed imporvment and for 
####  ## implementing 6 character atom numbers 
####
  
  if(nfile==1) {
    coords <- matrix(round(as.numeric(xyz), 3), ncol = 3, byrow = TRUE)
    if (verbose) {
      cat(paste("Writing 1 frame with",natom,"atoms "))
    }
    
    coords <- matrix(round(as.numeric(xyz), 3), ncol = 3, byrow = TRUE)
    lines <- matrix(, ncol=1, nrow=natom)

    ## Four format otions: regular; elety > 3; eleno > 5; eleno > 5 & elety > 3
    ## cases  nchar(elety) > 3; nchar(eleno) > 5
    cases <- matrix(1,ncol=2,nrow=natom)
    cases[(nchar(eleno) > 5) ,1] = 3
    cases[(nchar(elety) < 4) ,2] = 0
    cases <- rowSums(cases)
    
    ind.1 <- which(cases==1)
    ind.2 <- which(cases==2)
    ind.3 <- which(cases==3)
    ind.4 <- which(cases==4)

    atom.print.1 <- function(card = "ATOM", eleno, elety, alt = "",
        resid, chain = "", resno, insert = "", x, y, z, o = "0.00",
        b = "1.00", segid = "") {

      format <- "%-6s%5s  %-3s%1s%-4s%1s%4s%1s%3s%8.3f%8.3f%8.3f%8.4f%8.3f%6s%4s"
      sprintf(format, card, eleno, elety, alt, resid, chain,
              resno, insert, "", x, y, z, o, b, "", segid)
    } 

    atom.print.2 <- function(card = "ATOM", eleno, elety, alt = "",
        resid, chain = "", resno, insert = "", x, y, z, o = "0.00",
        b = "1.00", segid = "") {

      format <- "%-6s%5s %-4s%1s%-4s%1s%4s%1s%3s%8.3f%8.3f%8.3f%8.4f%8.3f%6s%4s"
      sprintf(format, card, eleno, elety, alt, resid, chain,
              resno, insert, "", x, y, z, o, b, "", segid)
    } 

    atom.print.3 <- function(card = "ATOM", eleno, elety, alt = "",
        resid, chain = "", resno, insert = "", x, y, z, o = "0.00",
        b = "1.00", segid = "") {

      format <- "%-4s%7s  %-3s%1s%-4s%1s%4s%1s%3s%8.3f%8.3f%8.3f%8.4f%8.3f%6s%4s"
      sprintf(format, card, eleno, elety, alt, resid, chain,
              resno, insert, "", x, y, z, o, b, "", segid)
    } 
  
    atom.print.4 <- function(card = "ATOM", eleno, elety, alt = "",
        resid, chain = "", resno, insert = "", x, y, z, o = "0.00",
        b = "1.00", segid = "") {

      format <- "%-4s%7s %-4s%1s%-4s%1s%4s%1s%3s%8.3f%8.3f%8.3f%8.4f%8.3f%6s%4s"
      sprintf(format, card, eleno, elety, alt, resid, chain,
              resno, insert, "", x, y, z, o, b, "", segid)
    } 


  
    if(length(ind.1)>0) {
      lines[ind.1,] <- atom.print.1( card = card[ind.1],
                                    eleno = eleno[ind.1],
                                    elety = elety[ind.1],
                                    resid = resid[ind.1],
                                    chain = chain[ind.1],
                                    resno = resno[ind.1],
                                    x = coords[ind.1, 1],
                                    y = coords[ind.1, 2],
                                    z = coords[ind.1, 3],
                                    o = o[ind.1], b = b[ind.1] )
    }
    if(length(ind.2)>0) {
      lines[ind.2,] <- atom.print.2( card = card[ind.2],
                                    eleno = eleno[ind.2],
                                    elety = elety[ind.2],
                                    resid = resid[ind.2],
                                    chain = chain[ind.2],
                                    resno = resno[ind.2],
                                    x = coords[ind.2, 1],
                                    y = coords[ind.2, 2],
                                    z = coords[ind.2, 3],
                                    o = o[ind.2], b = b[ind.2] )
    }
    if(length(ind.3)>0) {
      lines[ind.3,] <- atom.print.3( card = card[ind.3],
                                    eleno = eleno[ind.3],
                                    elety = elety[ind.3],
                                    resid = resid[ind.3],
                                    chain = chain[ind.3],
                                    resno = resno[ind.3],
                                    x = coords[ind.3, 1],
                                    y = coords[ind.3, 2],
                                    z = coords[ind.3, 3],
                                    o = o[ind.3], b = b[ind.3] )
    }
    if(length(ind.4)>0) {
      lines[ind.4,] <- atom.print.4( card = card[ind.4],
                                    eleno = eleno[ind.4],
                                    elety = elety[ind.4],
                                    resid = resid[ind.4],
                                    chain = chain[ind.4],
                                    resno = resno[ind.4],
                                    x = coords[ind.4, 1],
                                    y = coords[ind.4, 2],
                                    z = coords[ind.4, 3],
                                    o = o[ind.4], b = b[ind.4] )
    }
    
    write.table(lines, file=file, quote=FALSE,
                row.names=FALSE, col.names=FALSE, append=append)
    
####
#### End of Edit: removed big chunks of old code
####    
    
  } else {
    if (verbose) {
      cat(paste("Writing",nfile,"frames with",natom,"atoms"),"\n")
      cat("Frame Progress (x50) ")
    }
    stop("REMOVED code for multimodel PQR as these files dont have much support")
  }
  if (verbose) cat(" DONE","\n")
}

#' Biological Units Construction
#'
#' Construct biological assemblies/units based on a 'pdb' object.
#'
#' @details
#' A valid structural/simulation study should be performed on the biological 
#' unit of a protein system. For example, the alpha2-beta2 tetramer form of
#' hemoglobin. However, canonical PDB files usually contain the asymmetric unit of 
#' the crystal cell, which can be:
#' \enumerate{
#'      \item One biological unit 
#'      \item A portion of a biological unit 
#'      \item Multiple biological units
#' }
#' The function performs symmetry operations to the coordinates based on the 
#' transformation matrices stored in a 'pdb' object returned by 
#' \code{\link{read.pdb}}, and returns biological units stored as a list of
#' \code{pdb} objects.
#'
#' @param pdb an object of class \code{pdb} as obtained from
#'    function \code{\link{read.pdb}}.
#' @param biomat a list object as returned by \code{read.pdb} 
#'    (pdb$remark$biomat), containing matrices for 
#'    symmetry operation on individual chains to build biological units.
#'    It will override the matrices stored in \code{pdb}.
#' @param multi logical, if TRUE the biological unit is returned as a 
#'    'multi-model' \code{pdb} object with each symmetric copy a distinct
#'    structural 'MODEL'. Otherwise, all copies are represented 
#'    as separated chains.
#' @param ncore number of CPU cores used to do the calculation. By default
#'          (\code{ncore=NULL}), use all available CPU cores.
#'
#' @return 
#'    a list of \code{pdb} objects with each representing an individual 
#'    biological unit.
#'
#' @seealso \code{\link{read.pdb}}
#'
#' @author Xin-Qiu Yao
#'
#' @examples
#' \donttest{
#'    # PDB server connection required - testing excluded
#'
#'    pdb <- read.pdb("2dn1")
#'    biounit <- biounit(pdb)
#'    pdb
#'    biounit
#' }
#' \dontrun{
#'    biounit <- biounit(read.pdb("2bfu"), multi=TRUE)
#'    write.pdb(biounit[[1]], file="biounit.pdb")
#'    # open the pdb file in VMD to have a look on the biological unit
#' } 
biounit <- function(pdb, biomat = NULL, multi = FALSE, ncore = NULL) {

    if(!is.pdb(pdb)) 
       stop("Please provide a 'pdb' object as obtained from 'read.pdb()'")

    if(!is.null(biomat)) 
       remarks <- biomat
    else
       remarks <- pdb$remark$biomat
   
    if(is.null(remarks))
       stop("Can't find 'remark' records for building biological units")

    ncore = setup.ncore(ncore) 

    cl <- match.call()

    if(!is.null(remarks)) { 

       # check max number of copies
       ncopy.max <- max(sapply(remarks$mat, length))

       if(!multi && ncopy.max > 10)
          cat("It is slow to represent many symmetric copies as separated chains\n Try multi = TRUE\n")

       # Are chains treated differently?
       nn <- sapply(remarks$mat, function(x) length(unique(names(x))))

       if(any(nn > 1) && multi)
          stop("Can't store as multiple models as separated symmetry operations are performed on distinct chains within one biological unit")
 
       biounits <- lapply(1:remarks$num, function(i) {
          # the transformation matrices
          mats <- remarks$mat[[i]]

          # applied to the chains
          chain <- remarks$chain[[i]]
 
          # number of copies
          ncopy <- length(mats)
  
          if(!multi) {    
             ## save copies as individual chains 

             # The original copy stored as spearated chains
             biounit0 <- lapply(chain, function(x) trim.pdb(pdb, chain=x, verbose=FALSE) )
             # available chain ID repository
             chains0 <- setdiff(c(LETTERS, letters, 0:9), chain)
             
             jch <- 1
             used.chain <- NULL
             biounit <- NULL
             for(j in 1:ncopy) {
                mt <- mats[[j]]
                chs <- strsplit(names(mats)[j], split=" ")[[1]]
                for(k in chs) {
                   bio <- biounit0[[match(k, chain)]]
                   xyz <- rbind(matrix(bio$xyz, nrow=3), 1)
                   xyz <- matrix(mt %*% xyz, nrow = 1)
                   if(! k %in% used.chain) {
                      ch <- k
                      used.chain <- c(used.chain, k)
                   } else {
                      ch <- chains0[jch]
                      jch = jch + 1
                   }
                   bio$xyz <- xyz
                   bio$atom[, "chain"] <- ch
                   bio$atom[, c("x", "y", "z")] <- round(matrix(xyz, ncol=3, byrow=TRUE), digits=3)
                   
                   biounit <- c(biounit, list(bio))
                }
             } 
             biounit <- do.call(cat.pdb, c(biounit, list(rechain = FALSE)))

#             # temporarily write the pdb of biounit and re-read it
#             tmpf <- tempfile()
#             write.pdb(biounit, file=tmpf)
#             biounit = read.pdb(tmpf, verbose=FALSE)
          } 
          else {
             ## save copies as multi-models

             # The original copy
             biounit <- trim.pdb(pdb, chain=chain, verbose=FALSE)

             xyz = rbind(matrix(biounit$xyz, nrow=3), 1)
             ll <- mclapply(2:ncopy, function(j) {

                mt <- mats[[j]]
                xyz = matrix(mt %*% xyz, nrow=1)
                xyz
             }, mc.cores = ncore )
             biounit$xyz <- rbind(biounit$xyz, do.call(rbind, ll))
             class(biounit$xyz) <- "xyz"
          }
          
          biounit$call <- cl
          return(biounit)
       } ) # end of lapply(1:remarks$num)

       ## multimeric state
       nchs <- sapply(biounits, function(x) length(unique(x$atom[, "chain"])) * nrow(x$xyz))
       mer <- c("monomer", "dimer", "trimer", "tetramer", "multimer")
       names(biounits) <- paste(remarks$method, ".determined.", 
            mer[ifelse(nchs>5, 5, nchs)], " (",  nchs, " chains)", sep="") 
#       if(length(biounits) == 1) biounits = biounits[[1]]  
    }

    return(biounits)
}

summary.cnapath <- function(object, ..., pdb = NULL, label = NULL, col = NULL,
                            plot = FALSE, concise = FALSE, cutoff = 0.1, 
                            normalize = TRUE, weight = FALSE) {
   
   pa <- list(object, ...)
   if(!all(sapply(pa, inherits, "cnapath")))
      stop("Input should be object(s) of the 'cnapath' class")
   
   if(is.null(label)) label = 1:length(pa)
   if(is.null(col)) col = 1:length(pa)

   out <- list()
   
   # store node degeneracy 
   if(weight) {
      node.deg <- lapply(pa, function(x) {
         wt <- exp(-x$dist)
         uniq.nodes <- sort(unique(unlist(x$path)))
         tbl <- rep(0, length(uniq.nodes))
         names(tbl) <- uniq.nodes
         for(i in 1:length(x$path)) {
            tbl[as.character(x$path[[i]])] <-  
                tbl[as.character(x$path[[i]])] + wt[i]
         }
         tbl
      } )
   } else {
      # read node numbers on paths
      y <- lapply(pa, function(x) unlist(x$path))
      node.deg <- lapply(y, table)
   }

   num.paths <- sapply(pa, function(x) length(x$path))
   
   if(normalize) {
#      node.deg <- lapply(node.deg, function(x) x/max(x))
      node.deg <- lapply(1:length(node.deg), function(i) {
        x <- node.deg[[i]]
        x/num.paths[i]
      })
   }

   # find on-path node by the cutoff
   yy <- lapply(node.deg, function(x) x[x >= cutoff])
   onpath.node <- unique(names(unlist(yy)))
   i <- as.numeric(onpath.node)
   onpath.node <- onpath.node[order(i)]

   # generate the node degeneracy table
   o <- lapply(node.deg, function(x) {
      x <- x[match(onpath.node, names(x))]
      x[is.na(x)] <- 0
      names(x) <- onpath.node 
      x 
   } )

   # replace node id with pdb resid and resno
   if(!is.null(pdb)) {
      ca.inds <- atom.select(pdb, elety="CA", verbose = FALSE)
      resno <- pdb$atom[ca.inds$atom, "resno"]
      resid <- pdb$atom[ca.inds$atom, "resid"]
      chain <- pdb$atom[ca.inds$atom, "chain"]
      lig.inds <- atom.select(pdb, "ligand", verbose = FALSE)
      islig <- paste(chain, resno, sep="_") %in% 
           paste(pdb$atom[lig.inds$atom, "chain"], 
                 pdb$atom[lig.inds$atom, "resno"], sep="_")
      resid[!islig] <- aa321(resid[!islig])

      o <- lapply(o, function(x) {
         node <- as.numeric(names(x))

         if(length(unique(pdb$atom[, "chain"])) > 1)
            n <- paste(chain[node], paste(resid[node], resno[node], sep=""), sep="_")
         else
            n <- paste(resid[node], resno[node], sep="")

         names(x) <- n
         x 
      } )
   }

   names(o) <- label
   out$network <- label
   out$num.paths <- num.paths
   out$hist <- lapply(pa, function(x) table(cut(x$dist, breaks=5, include.lowest = TRUE)))
   if(length(out$hist)==1) out$hist = out$hist[[1]]
   out$degeneracy <- do.call(rbind, o)
   if(normalize) out$degeneracy <- round(out$degeneracy, digits=2)
   
   if(plot) {
     
      opar <- par(no.readonly = TRUE)
      on.exit(par(opar))
 
      layout(matrix(1:2, nrow=1), respect = TRUE)

      rgbcolors <- sapply(col, col2rgb) / 255
      rgbcolors <- rbind(rgbcolors, alpha = 0.6)
      
      ##- for path length distribution
      y1 <- lapply(pa, function(x) 
         hist(x$dist, breaks = 20, plot = FALSE) )

      par(mar=c(4, 4, 1, 1)) 
      plot(y1[[1]], freq = FALSE, col = do.call(rgb, as.list(rgbcolors[,1])), 
        border = col[1], main = "Path Length Distribution", 
        xlim = range(unlist(lapply(y1, "[[", "breaks"))),
        ylim = c(0, max(unlist(lapply(y1, "[[", "density")))), 
        xlab = "Path length", ylab = "Probability density")
      box()

      if(length(y1) > 1) 
         for(i in 2:length(y1))  {
            plot(y1[[i]], freq = FALSE, col = do.call(rgb, as.list(rgbcolors[,i])), 
            border = col[i], add = TRUE)
      }  
      legend("topleft", legend = label, bty = "n", text.col = col)

      ##- for node degeneracy 
      y2 <- lapply(pa, function(x) unlist(x$path))
      if(!is.null(pdb)) y2 <- lapply(y2, function(x) resno[x])
      if(concise) { 
         # re-number node to get more concise plot
         ii <- sort(unique(unlist(y2)))
         y2 <- lapply(y2, match, ii)
      }
      y2 <- lapply(y2, function(x)
         hist(x, breaks = c(seq(min(x), max(x), 1) - 0.5, max(x) + 0.5),
            plot = FALSE) )

      par(mar=c(4, 4, 1, 1))
      plot(y2[[1]], freq = TRUE, col = do.call(rgb, as.list(rgbcolors[,1])), 
        lty = 0, main = "Node Degeneracy", 
        xlim = range(unlist(lapply(y2, "[[", "breaks"))),
        ylim = c(0, max(unlist(lapply(y2, "[[", "counts")))), 
        xlab = "Node no", ylab = "Number of paths")
      box()
      
      if(length(y2) > 1) 
         for(i in 2:length(y2)) 
            plot(y2[[i]], freq = TRUE, col = do.call(rgb, as.list(rgbcolors[,i])), 
            lty = 0, add = TRUE)
        
   } 

   return(out)
}

print.cnapath <- function(x, ...) {
   dots = list(...)

   if(is.list(x) && all(sapply(x, inherits, "cnapath"))) {
      if(!"label" %in% names(dots) || is.null(dots$label)) dots$label = names(x)
      names(x) <- NULL
      args = c(x, dots)
      o <- do.call(summary, args)
   } else {
      o <- summary(x, ...)
   }

   if("plot" %in% names(dots)) plot = dots$plot
   else plot = FALSE

   if(!plot) {
      if("normalize" %in% names(dots)) normalize = dots$normalize
      else normalize = TRUE
   
      if(length(o$network) > 1) {   
         cat("Number of networks: ", length(o$network), "(", 
             paste(o$network, collapse=", "), ")\n")
      }
   
      cat("Number of paths in network(s):\n")
      if(length(o$network) > 1) {
          cat(paste("   ", o$network, ": ", o$num.paths, sep="", collapse="\n"), sep="\n")
          cat("\n")
      } else {
          cat("    ", o$num.paths, "\n\n")
      }
   
      cat("Path length distribution: \n")
      if(length(o$network) > 1) {   
         for(i in 1:length(o$network)) {
             cat("   --- ", o$network[i], " ---")
             print(o$hist[[i]])
             cat("\n")
         }
      } else {
         print(o$hist)
         cat("\n")
      }
   
      cat("Node degeneracy table: \n\n")
      if(length(o$network) == 1) rownames(o$degeneracy) = ""
      if(normalize)
         print(format(o$degeneracy, nsmall=2), quote=FALSE)
      else 
         print(o$degeneracy)
   }
}
plot.cnapath <- function(x, ...) {
   arg.default <- list(plot=TRUE)
   args <- .arg.filter(arg.default, ...)
   do.call(print.cnapath, c(list(x=x), args))
}
plot.ecnapath <- function(x, ...) {
   if(!inherits(x, "ecnapath")) {
      stop("The input 'x' must be an object of class 'ecnapath'.")
   }
   plot.cnapath(x, ...)
}

`dist.xyz` <-
function(a, b=NULL, all.pairs=TRUE, ncore=1, nseg.scale=1){

  ## if 'a' is a vector (or matrix) and 
  ## 'b' is a matrix
  ## compare (each row of) 'a' to all rows in 'b'

  ## if 'a' is a matrix and 'b' is NULL
  ## call 'dist' on 'a'

  ## if 'a' is a vector and 'b' is NULL
  ## make 'a' a 3 col matrix and call 'dist' 

  # Parallelized by parallel package (Fri Jul  5 19:58:32 EDT 2013)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }

  if(is.xyz(a) && nrow(a)==1) a <- as.vector(a)
  if(is.xyz(b) && nrow(b)==1) b <- as.vector(b)

  if(is.vector(a)) {
    a <- matrix(a, ncol=3, byrow=TRUE)
  } else {
    a <- as.matrix(a)
  }
  if(ncol(a) != 3) 
    message(paste('ncol(a) is not 3.\n',
       'General n-dimension Euclidean distance ',
       'between rows will be calculated.', sep=''))
 
  if(is.null(b)) {
    return(as.matrix(dist(a)))
  } else {
    if(is.vector(b)) {
      b <- matrix(b, ncol=3, byrow=TRUE)
    } else {
      b <- as.matrix(b)
    }
  }

  dima <- ncol(a)
  dimb <- ncol(b)
  if(dima != dimb)
    stop("Dimension miss-match of input 'a' and 'b'")
    
  if(dima != 3) {
    warning(paste("input does not have three columns: assuming you want",
                  dima, "dimensional distances")) 
  }

  if(!all.pairs) {
    ## distance between coresponding rows
    d <- rep( NA, max(nrow(a), nrow(b)) )
    ind <- 1:min(nrow(a), nrow(b))
    d[ind] <- sqrt( rowSums((a[ind,] - b[ind,])^2) )
    ##    return( sqrt( rowSums((a - b)^2) ) )
    return(d)
  } else {
    
    if(ncore > 1) {
       RLIMIT = floor(R_NCELL_LIMIT / nrow(b))
       nDataSeg = floor((nrow(a)-1)/RLIMIT) + 1
       nDataSeg = floor(nDataSeg * nseg.scale)
       lenSeg = floor(nrow(a)/nDataSeg)
       d.l <- NULL
       for(i in 1:nDataSeg) {
          istart = (i-1)*lenSeg + 1
          iend = if(i<nDataSeg) i*lenSeg else nrow(a)
          d.l <- c(d.l, mclapply(istart:iend, function(j) {
             sqrt(colSums((a[j,] - t(b))^2)) } ) )
       }   
       d <- do.call(rbind, d.l)
    } else {
       d <- matrix(0, nrow=nrow(a), ncol=nrow(b))
       for(i in 1:nrow(a)){
         d[i,] <- sqrt(colSums((a[i,] - t(b))^2))
       }
    }
    return(d)
  }
}

"plot.fasta" <- function(x, hc = TRUE, labels = x$id, cex.lab = 0.7,
                         xlab = "Alignment index",
                         main = "Sequence Alignment Overview",
                         mar4 = 4, ... ) {

  if(!(inherits(x, "fasta") | inherits(x, "pdbs")))
    stop("input 'x' should be a list object as obtained from 'read.fasta'")

  if(is.logical(hc)) {
    if(hc) {
      ide <- seqidentity(x)
      hc <- hclust(as.dist(1-ide))
    }
    else {
      hc <- NULL
    }
  }
  else {
    if(!is.null(hc)) {
      if(!inherits(hc, "hclust"))
        stop("'hc' must be logical, NULL or a 'hclust' object.")
    }
  }

  ##- Setup plot arangment
  opar <- par(no.readonly = TRUE)
  on.exit(par(opar))

  if(!is.null(hc)) {
    layout(matrix(c(4,2,3,1), ncol=2),
           heights = c(.1, 1),
           widths = c(0.3, 1))
    par(mar=c(4, 0.1, 0.1, mar4))
  }
  else {
    layout(matrix(c(2, 1), nrow=2),
           heights = c(.1, 1))
    par(mar=c(4, 2, 0.1, mar4))
  }

  ## 1: gap, 0: non-gap
  gaps <- gap.inspect(x$ali)

  mat <- gaps$bin
  if(any(mat==1)) {
    mat[ mat == 1 ] <- -1
    mat[ mat == 0 ] <- 1
    mat[ mat == -1 ] <- 0
  }
  else {
    mat <- mat+1
  }

  ## re-order matrix
  if(!is.null(hc)) 
    mat <- mat[ hc$order, ]
  else
    mat <- mat[ seq(nrow(mat), 1), ]

  if(any(mat==0))
    col <- c("#FFFFFF", "#9F9F9F")
  else
    col <- c("#9F9F9F")

  image(t(mat), col = col, axes=FALSE)

  by <- pretty(0:ncol(x$ali), n = 6)
  by <- by[2]

  labs.x <- seq(0, ncol(x$ali), by=by)
  labs.x[1] <- 1

  at <- labs.x / labs.x[length(labs.x)]
  at[1] <- 0

  axis(1, at=at, labels=labs.x)
  mtext(xlab, 1, line=2.5, cex=1.0)
  at <- seq(0, 1, length.out=length(x$id))

  #labs <- x$id
  if(!is.null(hc)) 
    labels <- labels[hc$order]

  mtext(labels, side=4, line=2-1.25, at=at, cex=cex.lab, las=2)


  ## cluster dendrogram
  if(!is.null(hc)) {
    par(mar=c(4, 0.1, 0.1, 0.1))
    ddr <- as.dendrogram(hc)
    plot(ddr, horiz = TRUE, axes = FALSE, yaxs = "i", leaflab = "none")
  }

  ## conservation bar on top of alignment
  cons <- conserv(x$ali)
  ng <- rep(0, length(cons))
  ng[gaps$f.inds] <- 1

  if(!is.null(hc))
    par(mar=c(.1, 0.1, 2, mar4))
  else
    par(mar=c(.1, 2, 2, mar4))

  #if(all(c(0,1) %in% cons))
  #  col <- c("#FFFFFF", "#FF0000")
  #else
  col <- colorRampPalette(c("white", "red"))( 10 )

  image(as.matrix(cons), col = col, axes=FALSE)

  #if(!is.null(hc))
  #  at <- 0.4
  #else

  at <- NA
  mtext(main, side = 3, line = 0.5, cex = 1.25, at=at)
}

`pdbseq` <-
function(pdb, inds=NULL, aa1=TRUE) {
  ## b.inds <- atom.select(pdb, "//B////CA/")
  ## seq.pdb(pdb, b.inds)

  if(is.null(inds))
    inds <- atom.select(pdb, "calpha", verbose=FALSE)
#    inds <- which(pdb$calpha)
#    inds <- atom.select(pdb, "//////CA/", verbose=FALSE)$atom

  if(is.list(inds))
    inds <- inds$atom

  if(aa1) {
    aa <- aa321(pdb$atom[inds,"resid"])
  } else {
    aa <- pdb$atom[inds,"resid"]
  }
  if(length(aa) > 0) {
    names(aa) <- pdb$atom[inds,"resno"]
  }
  return(aa)
}

"write.pdb" <-
function (pdb = NULL,
          file = "R.pdb",
          xyz = pdb$xyz,
          type = NULL,
          resno = NULL,
          resid = NULL,
          eleno = NULL,
          elety = NULL,
          chain = NULL,
          insert= NULL,
          alt = NULL,
          o = NULL,
          b = NULL,
          segid = NULL,
          elesy = NULL,
          charge = NULL,
          append = FALSE,
          verbose =FALSE,
          chainter = FALSE,
          end = TRUE, 
          sse = FALSE,
          print.segid = FALSE) {

  if(is.null(xyz) || !is.numeric(xyz))
    stop("write.pdb: please provide a 'pdb' object or numeric 'xyz' coordinates")

  if(any(is.na(xyz)))
    stop("write.pdb: 'xyz' coordinates must have no NA's.")
  
  if ( is.null(nrow(xyz)) ) {
    natom <- length(xyz)/3
    nfile <- 1
  } else if (is.matrix(xyz)) {
    natom <- ncol(xyz)/3 
    nfile <- nrow(xyz)
    if (verbose) {
      cat("Multiple rows in 'xyz' will be interperted as multimodels/frames\n")
    }
  } else {
    stop("write.pdb: 'xyz' or 'pdb$xyz' must be either a vector or matrix")
  }

#  card <- rep("ATOM", natom)
  card <- type
  
  if (!is.null(pdb)) {
    if (is.null(card)) card <- pdb$atom$type
    else if(length(card) == 1) card = rep(card, natom)
    if (is.null(resno)) resno = pdb$atom[, "resno"]
    if (is.null(resid)) resid = pdb$atom[, "resid"]
    if (is.null(eleno)) eleno = pdb$atom[, "eleno"]
    if (is.null(elety)) elety = pdb$atom[, "elety"]
    if (is.null(chain)) chain = pdb$atom[, "chain"]
    else if(length(chain) == 1) chain = rep(chain, natom)
    if (is.null(insert)) insert = pdb$atom[, "insert"]
    if (is.null(alt)) alt = pdb$atom[, "alt"]
    if (is.null(o)) o = pdb$atom[, "o"]
    if (is.null(b)) b = pdb$atom[, "b"]

    if (any(is.na(o))) {      o = rep("1.00", natom) }
    if (any(is.na(b))) {      b = rep("0.00", natom) }
    #if (any(is.na(chain))) { chain = rep(" ", natom) }
    chain[is.na(chain)]= ""
    insert[is.na(insert)] = ""
    alt[is.na(alt)] = ""
    
    if (is.null(segid)) segid = pdb$atom[, "segid"]
    segid[is.na(segid)] = ""
 
    if (is.null(elesy)) elesy = pdb$atom[, "elesy"]
    elesy[is.na(elesy)] = ""
   
    if (is.null(charge)) charge = pdb$atom[, "charge"]
  } else {
    if (is.null(card)) card = rep("ATOM", natom)
    else if(length(card) == 1) card = rep(card, natom)
    if (is.null(resno)) resno = c(1:natom)
    if (is.null(resid)) resid = rep("ALA", natom)
    if (is.null(eleno)) eleno = c(1:natom)
    if (is.null(elety)) elety = rep("CA", natom)
    if (is.null(chain)) chain = rep("", natom)
    else if (length(chain) == 1) chain = rep(chain, natom)
    ##if(any(is.na(chain))) chain[is.na(chain)]= ""
    if (is.null(insert)) insert=rep("", natom)
    if (is.null(alt)) alt=rep("", natom)
    if (is.null(o))         o = rep("1.00",natom)
    if (is.null(b))         b = rep("0.00", natom)
    if (is.null(segid)) segid = rep("", natom)
    if (is.null(elesy)) elesy = rep("", natom)
    if (is.null(charge)) charge = rep("", natom)

    chain[is.na(chain)]= ""
    insert[is.na(insert)] = ""
    alt[is.na(alt)] = ""
  }

  if (!is.logical(append)) 
    stop("write.pdb: 'append' must be logical TRUE/FALSE")
  
  if (length(as.vector(xyz))%%3 != 0) {
    stop("write.pdb: 'length(xyz)' must be divisable by 3.")
  }
  check.lengths <- sum(length(card), length(resno), length(resid), 
                       length(eleno), length(elety), length(chain), 
                       length(insert), length(alt), length(o), length(b), 
                       length(segid), length(elesy), length(charge))
  if (check.lengths%%natom != 0) {
    stop("write.pdb: the lengths of all input vectors != 'length(xyz)/3'.")
  }

  
  o <- as.numeric(o)
  b <- as.numeric(b)
  eleno <- as.character(eleno)
  resno <- as.character(resno)
  charge <- as.character(charge)
  charge[is.na(charge)] = ""
  if(!print.segid) segid = rep("", natom)
  ## Inserted Jul 8th 2008 for adding TER between chains
  ter.lines <- (which(!duplicated(chain))[-1] - 1)


  
  atom.print <- function(card = "ATOM", eleno, elety, alt = "",
        resid, chain = "", resno, insert = "", x, y, z, o = "1.00",
        b = "0.00", segid = "", elesy = "", charge = "") {
    
    format <- "%-6s%5s  %-3s%1s%3s %1s%4s%1s%3s%8.3f%8.3f%8.3f%6.2f%6.2f%6s%-4s%2s%2s"
    if (nchar(elety) > 3 || (is.character(elesy) && nchar(elesy)>1)) {
#    if (nchar(elety) >= 3) {
#      if ((substr(elety, 2, 2) == "H") | (substr(elety, 1, 1) == "H")) {
        format <- "%-6s%5s %-4s%1s%3s %1s%4s%1s%3s%8.3f%8.3f%8.3f%6.2f%6.2f%6s%-4s%2s%2s"
#      }
    }
    sprintf(format, card, eleno, elety, alt, resid, chain,
            resno, insert, "", x, y, z, o, b, "", segid, elesy, charge)
  } 

  ##### To write SSE annotations #####
  format.sse <- function(pdb) {
    # format 'sse' component in a pdb object to include resid and length
    lapply(c(helix='helix', sheet='sheet'), function(x) {
       sse <- pdb[[x]]
       if(length(sse$start) > 0) {
         ref <- pdb$atom[pdb$calpha, c("resno", "chain", "insert", "resid")]
         refkey <- paste(ref$resno, ref$chain, ref$insert, sep = "_")
         insert <- sub(' +', '', names(sse$start))
         insert[insert == ''] <- NA
         skey <- paste(sse$start, sse$chain, insert, sep="_")
         insert <- sub(' +', '', names(sse$end))
         insert[insert == ''] <- NA
         ekey <- paste(sse$end, sse$chain, insert, sep="_")
         resno = data.frame(start = sse$start, end = sse$end)
         resid = data.frame(start = ref$resid[match(skey, refkey)], 
                              end = ref$resid[match(ekey, refkey)])
         insert = data.frame(start= names(sse$start), end = names(sse$end))
         type = ifelse(x=='helix', 'type', 'sense')
         length = match(ekey, refkey) - match(skey, refkey) + 1
         return(list(resno=resno, resid=resid, chain=sse$chain, insert=insert,
                     type=sse[[type]], length=length))
       } else {
         return (NULL)
       }
     } )
  }

  if(!is.null(pdb) && sse) {
    lines <- NULL
    new.sse <- format.sse(pdb)
    if(!is.null(new.sse$helix)) {
       xx <- new.sse$helix
       format <- "%-6s %3d %3s %3s %1s %4d%1s %3s %1s %4d%1s%2s%30s %5d"
       for(i in 1:nrow(xx$resno))
         lines <- rbind(lines, sprintf(format, 'HELIX', i, i, xx$resid$start[i],
               xx$chain[i], xx$resno$start[i], xx$insert$start[i],
               xx$resid$end[i], xx$chain[i], xx$resno$end[i],
               xx$insert$end[i], xx$type[i], '', xx$length[i])) 
    }
    if(!is.null(new.sse$sheet)) {
       xx <- new.sse$sheet
       format <- "%-6s %3d %3s%2d %3s %1s%4d%1s %3s %1s%4d%1s%2s"
       for(i in 1:nrow(xx$resno))
         lines <- rbind(lines, sprintf(format, 'SHEET', i, 'S1', nrow(xx$resno), 
               xx$resid$start[i], xx$chain[i], xx$resno$start[i], 
               xx$insert$start[i], xx$resid$end[i], xx$chain[i], 
               xx$resno$end[i], xx$insert$end[i], xx$type[i]) )
    }
    if(!is.null(lines)) {
       write.table(lines, file = file, quote = FALSE, row.names = FALSE, col.names = FALSE, append = append)
       if(!append) append = TRUE
    }
  }
  ##################################### 

  if(nfile==1) {
    coords <- matrix(round(as.numeric(xyz), 3), ncol = 3, byrow = TRUE)
    if (verbose) {
      cat(paste("Writing 1 frame with",natom,"atoms "))
    }
    lines <- NULL
    ii = 0
    teleno <- as.numeric(eleno)
    for (i in 1:natom) {
       
      lines <- rbind(lines, atom.print( card = card[i],
                                       eleno = as.character(teleno[i] + ii),
                                       elety = elety[i],
                                       alt = alt[i],
                                       resid = resid[i],
                                       chain = chain[i],
                                       resno = resno[i],
                                       insert = insert[i],
                                       x = coords[i, 1],
                                       y = coords[i, 2],
                                       z = coords[i, 3],
                                       o = o[i], b = b[i],
                                       segid = segid[i],
                                       elesy = elesy[i],
                                       charge = charge[i]))
      
      ## Inserted Jul 8th 2008 for adding TER between chains 
      ## Modified to be consistent to PDB format v3.3
      if(chainter) {
        if(i %in% ter.lines) {
#          lines <- rbind(lines, "TER   ")
          ii = ii + 1
          lines <- rbind(lines, sprintf("%-6s%5s%6s%3s%1s%1s%4s%1s", 
               "TER", as.character(teleno[i] + ii), "", resid[i], "", chain[i], resno[i], insert[i]))
        }
      }
          
    }
    ## Changed cat() for write.table() as sugested by Joao Martins <joao.martins@env.ethz.ch>
    ##cat(lines, file = file, sep = "\n", append = append)
    write.table(lines, file = file, quote = FALSE, row.names = FALSE, col.names = FALSE, append = append)
    if(chainter) {
          ii = ii + 1
          cat(sprintf("%-6s%5s%6s%3s%1s%1s%4s%1s\n", "TER", as.character(teleno[i] + ii), "", 
              resid[i], "", chain[i], resno[i], insert[i]), file = file, append = TRUE)
    }
    if(end) {
      cat("END   \n", file = file, append = TRUE)
    }
    
  } else {
    if (verbose) {
      cat(paste("Writing",nfile,"frames with",natom,"atoms"),"\n")
      cat("Frame Progress (x50) ")
    }
    if(!append) unlink(file) 
    for (j in 1:nfile) {
      coords <- matrix(round(as.numeric(xyz[j,]), 3), ncol = 3, byrow = TRUE)
      lines <- NULL
      ii = 0
      teleno <- as.numeric(eleno)
      for (i in 1:natom) {
        lines <- rbind(lines, atom.print( eleno = as.character(teleno[i] + ii),
                                         elety = elety[i],
                                         alt = alt[i],
                                         resid = resid[i],
                                         chain = chain[i],
                                         resno = resno[i],
                                         insert = insert[i],
                                         x = coords[i, 1],
                                         y = coords[i, 2],
                                         z = coords[i, 3],
                                         o = o[i], b = b[i],
                                         segid = segid[i],
                                         elesy = elesy[i],
                                         charge = charge[i]))

        ## Inserted Jul 8th 2008 for adding TER between chains (untested) 
        ## Modified to be consistent to PDB format v3.3
        if(chainter) {
          if(i  %in% ter.lines) {
#            lines <- rbind(lines, "TER   ")
            ii = ii + 1
            lines <- rbind(lines, sprintf("%-6s%5s%6s%3s%1s%1s%4s%1s", 
               "TER", as.character(teleno[i] + ii), "", resid[i], "", chain[i], resno[i], insert[i]))
          }
        }
        
      }
      if (verbose) {
        if (j%%50 == 0) cat(".")
      }
      ##cat(lines, file = file, sep = "\n", append = TRUE)
      cat(sprintf("%-6s%4s%4d\n", "MODEL", " ", j), file = file, append = TRUE)
      write.table(lines, file = file, quote = FALSE, row.names = FALSE, col.names = FALSE, append = TRUE)
      if(chainter) {
         ii = ii + 1
         cat(sprintf("%-6s%5s%6s%3s%1s%1s%4s%1s\n", "TER", as.character(teleno[i] + ii), "", 
              resid[i], "", chain[i], resno[i], insert[i]), file=file, append=TRUE)
      }
      cat(sprintf("%-6s\n", "ENDMDL"), file = file, append = TRUE)
    }
    if(end) {
      cat("END   \n", file = file,  append = TRUE)
    }

  }
  if (verbose) cat(" DONE","\n")
}

.get.exepath <- function(prg) {
    
    paths <- list(

        pymol = list(
            
            Linux = c("/usr/bin/pymol",
                      "/usr/local/bin/pymol"),
            
            Darwin = c("/Applications/MacPyMOL.app/Contents/MacOS/MacPyMOL",
                       "/usr/bin/pymol",
                       "/usr/local/bin/pymol"),
            
            Windows = c("C:/python27/PyMOL/pymol.exe",
                        "C:/Program Files/PyMOL/PyMOL/PymolWin.exe",
                        "C:/Program Files/PyMOL/PymolWin.exe"),

            ver = "-cq"
        ),


        muscle = list(

            Linux = c("/usr/bin/muscle",
                      "/usr/local/bin/muscle"),
            
            Darwin = c("/usr/bin/muscle",
                       "/usr/local/bin/muscle"),
            
            Windows = c("C:/Program Files/muscle.exe",
                        "C:/Program Files/muscle3.8.31_i86win32.exe",
                        "C:/Program Files/muscle/muscle.exe",
                        "C:/Program Files/Muscle/muscle.exe",
                        "C:/Program Files/seaview/muscle.exe",
                        "C:/Program Files/seaview4/muscle.exe"),

            ver = "-version"
        ),

        clustalo = list(

            Linux = c("/usr/bin/clustalo",
                      "/usr/local/bin/clustalo"),
            
            Darwin = c("/usr/bin/clustalo",
                       "/usr/local/bin/clustalo"),
            
            Windows = c("C:/Program Files/clustalo.exe", 
                        "C:/Program Files/clustalo/clustalo.exe",
                        "C:/Program Files/Clustalo/clustalo.exe",
                        "C:/Program Files/seaview/clustalo.exe",
                        "C:/Program Files/seaview4/clustalo.exe"),

            ver = "--version"
        ), 
        
        dssp = list(

            Linux = c("/usr/bin/dssp",
                      "/usr/local/bin/dssp"),
            
            Darwin = c("/usr/bin/dssp",
                       "/usr/local/bin/dssp",
                       "/usr/bin/mkdssp",
                       "/usr/local/bin/mkdssp"),
            
            Windows = c("C:/Program Files/dssp.exe",
                        "C:/Program Files/dssp-2.0.4-win32.exe",
                        "C:/Program Files/dssp/dssp.exe",
                        "C:/Program Files/Dssp/dssp.exe"),
            
            ver = "--version"
        )
 
    )

    ## user provided full path
    if(file.exists(prg) & !dir.exists(prg)) {
        return(prg)
    }
    
    ## try to automatically determine path
    exefile <- Sys.which(prg)

    if(nchar(exefile) == 0) {

        if(prg %in% c("pymol", "muscle", "clustalo", "dssp")) {
            ## determine os
            os1 <- Sys.info()["sysname"]
            
            ## use guess-paths defined above
            exefiles <- paths[[prg]][[os1]]
            fe <- file.exists(exefiles)
            
            if(any(fe)) {
                exefile <- exefiles[which(fe)[1]]
            }
            else {
                exefile <- NULL
            }
        }
        else {
            exefile <- NULL
        }
    }
    
    if(is.null(exefile)) {
        stop(paste0("could not determine path to '", prg, "'"))
    }
    return(exefile)
}

.test.exefile <- function(exefile) {
    prg <- tolower(basename(exefile))

    if(grepl("muscle", prg)) {
        ver <- "-version"
    }
    if(grepl("pymol", prg)) {
        ver <- "-cq"
    }
    if(grepl("clustalo", prg)) {
        ver <- "--version"
    }
    if(grepl("dssp", prg)) {
        ver <- "--version"
    }

    
    os1 <- Sys.info()["sysname"]
    if (os1 == "Windows") {
        success <- shell(paste(shQuote(exefile), ver))
    }
    else {
        success <- system(paste(exefile, ver),
                          ignore.stderr = TRUE, ignore.stdout = TRUE)
    }
    
    if(!(success %in% c(0,1))) {
        return(FALSE)
    }
    else {
        return(TRUE)
    }
}
    

#' Align communities from two or more networks
#'
#' Find equivalent communities from two or more networks and re-assign colors
#' to them in a consistent way across networks. A \sQuote{new.membership} vector is
#' also generated for each network, which maps nodes to community IDs that are 
#' renumbered according to the community equivalency.
#'
#' This function facilitates the inspection on the variance of the community
#' partition in a group of similar networks. The original community numbering
#' (and so the colors of communities in the output of \code{plot.cna} and 
#' \code{vmd.cna}) can be inconsistent across networks, i.e. equivalent 
#' communities may display different colors, impeding network comparison. 
#' The function calculates the dissimilarity between all communities and 
#' clusters communities with \sQuote{hclust} funciton. In each cluster, 0 or
#' 1 community per network is included. The color attribute of communities is 
#' then re-assigned according to the clusters through all networks. In addition,
#' a \sQuote{new.membership} vector is generated for each network, which mapps 
#' nodes to new community IDs that are numbered consistently across networks. 
#'
#' @param x,... two or more objects of class \code{cna} (if the numbers of
#'    nodes are different, an alignment \sQuote{fasta} object is required for 
#'    the \code{aln} argument; See below) as obtained from function \code{\link{cna}}. 
#'    Alternatively, a list of \code{cna} objects can be given to \code{x}.
#' @param aln alignment for comparing networks with different numbers of nodes.
#' 
#' @return Returns a list of updated \code{cna} objects.
#'
#' @seealso \code{\link{cna}}, \code{\link{plot.cna}}, \code{\link{vmd.cna}}
#'
#' @examples
#' \donttest{
#'   # Needs MUSCLE installed - testing excluded
#'   if(check.utility("muscle")) {
#'
#'     if (!requireNamespace("igraph", quietly = TRUE)) {
#'       message('Need igraph installed to run this example')
#'     } else {
#'
#'     ## Fetch PDB files and split to chain A only PDB files
#'     ids <- c("1tnd_A", "1tag_A")
#'     files <- get.pdb(ids, split = TRUE, path = tempdir())
#'     
#'     ## Sequence Alignement
#'     pdbs <- pdbaln(files, outfile = tempfile())
#'     
#'     ## Normal mode analysis on aligned data
#'     modes <- nma(pdbs, rm.gaps=TRUE)
#'     
#'     ## Dynamic Cross Correlation Matrix
#'     cijs <- dccm(modes)$all.dccm
#'  
#'     ## Correlation Network
#'     nets <- cna(cijs, cutoff.cij=0.3)
#'
#'     ## Align network communities
#'     nets.aln <- community.aln(nets)
#'
#'     ## plot all-residue and coarse-grained (community) networks
#'     pdb <- pdbs2pdb(pdbs, inds=1, rm.gaps=TRUE)[[1]]
#'     op <- par(no.readonly=TRUE)
#'
#'     # before alignment
#'     par(mar=c(0.1, 0.1, 0.1, 0.1), mfrow=c(2,2))
#'     invisible( lapply(nets, function(x) 
#'        plot(x, layout=layout.cna(x, pdb=pdb, k=3, full=TRUE)[, 1:2], 
#'                full=TRUE)) )
#'     invisible( lapply(nets, function(x) 
#'        plot(x, layout=layout.cna(x, pdb=pdb, k=3)[, 1:2])) )
#'
#'     # after alignment
#'     par(mar=c(0.1, 0.1, 0.1, 0.1), mfrow=c(2,2))
#'     invisible( lapply(nets.aln, function(x) 
#'        plot(x, layout=layout.cna(x, pdb=pdb, k=3, full=TRUE)[, 1:2], 
#'                full=TRUE)) )
#'     invisible( lapply(nets.aln, function(x) 
#'        plot(x, layout=layout.cna(x, pdb=pdb, k=3)[, 1:2])) )
#'
#'     par(op)     
#'
#'     }
#'   }
#' }
#' @keywords analysis
community.aln <- function(x, ..., aln=NULL) {
    
   ## Check for presence of igraph package
   oops <- requireNamespace("igraph", quietly = TRUE)
   if (!oops) {
      stop("igraph package missing: Please install from CRAN")
   }

   dots <- list(...)
   if(inherits(x, 'cna')) x <- list(x)
   nets <- c(x, dots)
 
   if(length(nets)==1)
     stop('Provide at least two networks.')

   ## Construct dissimilarity matrix
   raw.mat <- lapply(1:length(nets), function(j, aln) {
     net <- nets[[j]]
     ids <- unique(net$communities$membership)
     mat <- NULL
     for(i in ids) {
       r <- t(as.numeric(net$communities$membership==i))
       if(inherits(aln, "fasta")) {
         r2 <- rep(0, ncol(aln$ali))
         r2[!is.gap(aln$ali[j, ])] <- r
         mat <- rbind(mat, r2)
       }
       else {
         mat <- rbind(mat, r)
       }
     }
     rownames(mat) <- ids
     return(mat)
   }, aln)
   
   raw.mat <- do.call(rbind, raw.mat)
   
   ncomms <- sapply(nets, function(net) 
     length(unique(net$communities$membership)))
   r <- rep(1:length(nets), ncomms)
   rownames(raw.mat) <- paste(r, ".", rownames(raw.mat), sep="")
   
   dismat <- dist(raw.mat, method="binary")
   
   ## Clustering
   hc <- hclust(dismat)
   grps <- cutree(hc, h=0.99)
   #plot(hc)

   str <- strsplit(names(grps), "\\.")

   ## check if two or more communities from the same network are in one cluster
   chk <- tapply(str, grps, function(x) sum(duplicated(sapply(x, '[', 1)))>0)
   if(any(unlist(chk))) 
     stop('Two or more communities from the same network are in one cluster.')

   ## rename grps to make sure the group number is assigned based on the rank of
   ## the network in the network list in which the group appears for the first time. 
   ni <- as.numeric(sapply(str, "[[", 1))
   ci <- as.numeric(sapply(str, "[[", 2))
   minc <- tapply(1:length(grps), grps, function(i){
     ind <- order(ni[i], ci[i])[1]
     c(ni[i[ind]], ci[i[ind]])
   }, simplify=FALSE)
   minc <- do.call(rbind, minc)
   inds <- order(minc[, 1], minc[, 2])
   rl <- rle(grps)
   rl$values[] <- match(rl$values, inds)
   grps <- inverse.rle(rl)
   
   
   ## Renumber communities and update 'nets'
   col <- vmd_colors() ## use vmd colors
   for(i in 1:length(nets)) {
     net <- nets[[i]]
     inds <- which(sapply(str, '[[', 1) %in% i)
     mycommid <- as.numeric(sapply(str, '[[', 2))[ inds ]
     mygrps <- grps[inds]
     names(mygrps) <- mycommid
     mygrps <- mygrps[order(mycommid)] # sort new grps according to old commun id

     # update node color
     membership <- as.character(net$communities$membership)
     igraph::V(net$network)$color[] <- as.character(col[mygrps[membership]])

     # generate renumbered membership
     new.membership <- as.numeric(mygrps[membership])
     names(new.membership) <- names(net$communities$membership)
     net$new.membership <- new.membership

     # update community network
     if(!is.null(net$community.network)) {
#       community.cij <- net$community.cij
#       rownames(community.cij) <- mygrps
#       colnames(community.cij) <- mygrps
##       community.cij <- community.cij[order(mygrps), order(mygrps)]
#       community.network <-  igraph::graph.adjacency(community.cij,
#                               mode="undirected",
#                               weighted=TRUE,
#                               diag=FALSE)
       igraph::V(net$community.network)$color <- col[mygrps]
#       igraph::V(community.network)$size <- table(net$communities$membership)
#       net$community.cij <- community.cij
#       net$community.network <- community.network
     }
     nets[[i]] <- net
   }
#   return(list(dismat=dismat, hc=hc, grps=grps, nets=new.nets))

   return( nets )
}

print.fasta <- function(x, alignment=TRUE, ...) {
  
  if ( (inherits(x, "fasta") | inherits(x, "pdbs")) ){ 
    id <- x$id
    ali <- as.matrix(x$ali)
    call <- paste(deparse(x$call), sep = "\n", collapse = "\n")
  } else {
    ali <- as.matrix(x)
    id <- rownames(ali)
    call <- NA
  }

  if(inherits(x, "pdbs"))
    row.desc <- "structures"
  else
    row.desc <- "sequences"
  
  cn      <- class(x)
  nstruct <- length(id)
  dims    <- dim(ali)
  
  gaps <- gap.inspect(ali)
  dims.nongap <- dim(ali[, gaps$f.inds, drop=FALSE])
  dims.gap <- dim(ali[, gaps$t.inds, drop=FALSE])

  if(alignment)
    .print.fasta.ali(ali, id=id, ...)
                     #width=width, 
                     #col.inds=col.inds, numbers=numbers)
  else
    cat("\n")

  if(!is.na(call)) {
    cat("Call:\n  ", call,
        "\n\n", sep = "")
    
    cat("Class:\n  ", paste(cn, collapse=", "),
        "\n\n", sep = "")
  }
  
  ##cat("Number of ", row.desc, ":\n  ", nstruct,
  ##    "\n\n", sep="")
  
  cat("Alignment dimensions:\n  ",
      dims[1L], " sequence rows; ",
      dims[2L], " position columns",
      " (", dims.nongap[2L], " non-gap, ", dims.gap[2L], " gap) ", 
      "\n", sep="")
  
  cat("\n")

 
  ## Attribute summary
  j <- paste(attributes(x)$names, collapse = ", ")
  cat(strwrap(paste(" + attr:",j,"\n"),width=60, exdent=8), sep="\n")

}

.print.fasta.ali <- function(x, ##limit.out=NULL,
                             width=NULL, col.inds=NULL,
                             numbers=TRUE, conservation=TRUE, ...) {
  ##-- Print sequence alignment in a nice formated way
  ##    source("print.aln.R")
  ##    x<-read.fasta("poo.fa")
  ##    print.aln(x)
  ##
  ##    file <- system.file("examples/kif1a.fa",package="bio3d")
  ##    aln  <- read.fasta(file)
  ##    print.aln(aln, width=40)
  ##    print.aln(aln, width=60)
  ##    print.aln(aln, col=c(10,12,14,22,90:100), numbers=F)
  ## ToDo:
  ##   Does not work if alignment contains only one position (one seq?)
  ##     y=x; y$ali=x$ali[,1]

  if ( (inherits(x, "fasta") | inherits(x, "pdbs")) ){ 
    id <- x$id
    ali <- as.matrix(x$ali)
  } else {
    ali <- as.matrix(x)
    id <- rownames(x)
  }

  ## remove any NA values
  ali[is.na(ali)] <- "-"
  
  ##- Trim to 'col.inds' if provided 
  if(!is.null(col.inds)) {
    ali <- ali[,col.inds, drop=FALSE]
  }

  if(nrow(ali)<2)
    conservation <- FALSE
  
  ##- conservation
  cons <- NULL
  if(conservation) {
    tmp1 <- conserv(ali, method="entropy10")
    tmp2 <- conserv(ali, method="identity")
    cons <- rep(" ", ncol(ali))
    cons[ tmp1==1 ] <- "^"
    cons[ tmp2==1 ] <- "*"
  }
  
  ## Check and truncate possilbe long ids
  if(any(nchar(id) > 20)) {
    id <- basename(id)
    if(any(nchar(id) > 17)) {
        id <- substr(id,1,10)
    }
    id <-paste0("[Truncated_Name:", 1:length(id),"]",id)
  }

  ##- Format sequence identifiers
  ids.nchar <- max(nchar(id))+3 ## with a gap of 3 spaces btwn id and sequence
  ids.format <- paste0("%-",ids.nchar,"s")
  ids <- sprintf(ids.format, id)
  
  ## Format for annotation printing (see below)
  pad.format <- paste0("%+",(ids.nchar+1),"s")

  ## Format for conservation annotation printing (see below)
  pad.format2 <- paste0("%+",(ids.nchar),"s")
  
  ##- Scale 'width' of output if not specified in input call
  tput.col <- 85  ## typical terminal width from system("tput cols")
  if(is.null(width)) {
    width <- tput.col - ids.nchar - 4
  }
  
  ## Make sure we end on a 10 block
  width <- floor(width/10)*10
  
  ##- Work out sequence block widths
  nseq <- length(ids)
  nres <- ncol(ali)
  
  block.start <- seq(1, nres, by=width)
  if(nres < width) {
    block.end <- nres
  } else {
    block.end <- unique(c( seq(width, nres, by=width), nres))
  }
  nblocks <- length(block.start)
  
  block.annot  <- rep(" ", width)
  block.annot[ c(1,seq(10, width, by=10)) ] = "."
    
  blocks <- matrix(NA, ncol=nblocks, nrow=nseq) 
  for(i in 1:nblocks) {
    ##- Sequence block
    positions <- block.start[i]:block.end[i]
    blocks[,i] <- paste0(ids, apply(ali[, positions, drop=FALSE], 1, paste, collapse=""))
    
    ##-- Formated Printing of annotations (numbers & ticks) and sequence blocks
    if(numbers) {
      ##- Annotations for each sequence block
      annot = block.annot[1:length(positions)]
      annot[length(annot)] = block.end[i]
      annot[1] = sprintf(pad.format, block.start[i])
      cat(paste(annot, collapse=""),"\n")
    }
    
    ##- Sequence block
    cat(blocks[,i], sep="\n")

    ##- Formated Printing of conservation (stars for conserved columns)
    if(conservation) {
      annot2 <- c("", cons[positions])
      annot2[1] = sprintf(pad.format2, "")
      cat(paste(annot2, collapse=""),"\n")
    }
    
    ##- Ticks + numbers again
    if(numbers) {
      cat(paste(annot, collapse=""),"\n\n")
    } else{ cat("\n") }
  }
  
  ##invisible(blocks) ## Can be useful for plot.fasta() later!!
}

seq2aln <-
function(seq2add, aln, id="seq", file = "aln.fa", ...) {
  ##- Add a sequence 'seq2add' to an existing alignment 'aln'
  ##  Adds at the bottom of alignment
  cl <- match.call()
   
  if(!inherits(aln, "fasta")) 
     stop("Input 'aln' should be a 'fasta' object")

  tmp.seq = as.fasta(seq2add)
  if(nrow(tmp.seq$ali) > 1)
     warning("Multiple sequences in 'seq2add' should be pre-aligned")

  dots = list(...)
  # fixed arguments
  dots$profile = aln
  dots$outfile = file
    
  args = c(list(aln=seq2add, id=id), dots)
  naln = do.call(seqaln, args)

  naln$call = cl
  return(naln)
}

"as.xyz" <- function(x) {
  if(is.vector(x))
    x = matrix(x, nrow=1)
  
  dims <- dim(x)
  if(!(dims[2L]%%3==0))
    warning("number of cartesian coordinates not a multiple of 3")
  
  class(x) <- c("xyz", "matrix")
  return(x)
}

plot.cmap <- function(x, col=2, pch=16, 
                      main="Contact map", sub="",
                      xlim=NULL, ylim=NULL, 
                      xlab = "Residue index", ylab = xlab, 
                      axes=TRUE, ann=par("ann"),
                      sse=NULL, sse.type="classic", sse.min.length=5,
                      bot=TRUE, left=TRUE,
                      helix.col="gray20", sheet.col="gray80",
                      sse.border=FALSE, add=FALSE,
                      ...) {
  dims <- dim(x)

  if(is.null(xlim))
    xlim <- c(1, dims[1])
  if(is.null(ylim))
    ylim <- c(1, dims[2])

  if(!add) {
    plot.new()
  }
  else {
    axes <- FALSE
    xlab <- NA; ylab <- NA;
    main <- NA; sub <- NA;
    sse <- NULL;
  }
  plot.window(xlim=xlim, ylim=ylim, ...)
  
  inds <- which(x==1, arr.ind=TRUE)
  points(inds, pch=pch, col=col)
  
  if(!is.null(sse)) {
    ## Obtain SSE vector from PDB input 'sse'
    if(is.pdb(sse)) 
      sse$sse <- pdb2sse(sse)
    
    h <- bounds( which(sse$sse == "H") )
    e <- bounds( which(sse$sse == "E") )

    ## Remove short h and e elements that can crowd plots
    if(length(h) > 0) {
      inds <- which(h[,"length"]>=sse.min.length)
      h <- h[inds,,drop=FALSE]
    } else { h <- NULL }
    if(length(e) > 0) {
      inds <- which(e[,"length"]>=sse.min.length)
      e <- e[inds,,drop=FALSE]
    } else { e <- NULL }
    
    if(sse.type != "classic")
      warning("Only sse.type='classic' is currently available, 'fancy' coming soon")

    off <- c(0.006, 0.039)
    if(left) {
      ## Determine bottom and top of margin region 
      bo <- min(xlim) - (diff(xlim)*off[1]) 
      to <- min(xlim) - (diff(xlim)*off[2]) 

      
      if(length(h) > 0)
        rect(xleft=bo, xright=to, 
             ybottom=h[,"start"], ytop=h[,"end"],
             col=helix.col, border=sse.border)
      
      if(length(e) > 0)
        rect(xleft=bo, xright=to, 
             ybottom=e[,"start"], ytop=e[,"end"],           
             col=sheet.col, border=sse.border)
    }
    if(bot){
      	to <- min(ylim) - (diff(ylim)*off[1])
      	bo <- min(ylim) - (diff(ylim)*off[2])
        
      	if(length(h) > 0)
          rect(xleft=h[,"start"], xright=h[,"end"],
               ybottom=bo, ytop=to, col=helix.col, border=sse.border)
        
      	if(length(e) > 0)
          rect(xleft=e[,"start"], xright=e[,"end"],
               ybottom=bo, ytop=to, col=sheet.col, border=sse.border)
    }
  }

  if(axes) {
    box()
    at <- axTicks(1); at[1] = 1
    axis(1, at)
    axis(2, at)
  }
  
  if(ann) {
#    if(is.null(xlab))  xlab=xy$xlab
#    if(is.null(ylab))  ylab=xy$ylab
    title(main=main, sub=sub, 
          xlab=xlab, ylab=ylab, ...)
  }
  
}

`is.gap` <-
function(x, gap.char=c("-",".")) {
	if(is.pdbs(x) || inherits(x, "fasta")) {
		return( colSums( matrix( as.logical(is.na(x$ali)+(x$ali %in% gap.char)), 
			ncol=ncol(x$ali)) ) > 0 )
	} else { 
	  return( as.logical( is.na(x) + (x %in% gap.char) ) )
	}
}

`plot.core` <-
function(x, y=NULL, type="h",
         main="", sub="",
         xlim=NULL, ylim=NULL,
         xlab = "Core Size (Number of Residues)",
         ylab = "Total Ellipsoid Volume (Angstrom^3)", 
         axes=TRUE, ann=par("ann"),
         col=par("col"),
         ...) {


  if(is.list(x)) {
    len <- x$length ## hack!! fix later
    x <- x$volume
  } else{ len <- rev(1:length(x)) }
  
  xy <- xy.coords(x, y)
  if (is.null(xlim))
    xlim <- range(xy$x[is.finite(xy$x)])
  if (is.null(ylim))
    ylim <- range(xy$y[is.finite(xy$y)])
##  opar <- par(no.readonly=TRUE)
##  on.exit(par(opar))

  plot.new()
  plot.window(xlim, ylim, ...)
  points(xy$x, xy$y, col=col, type=type, ...)

  if (axes) {
    ax.ind <- c(1,seq(10,length(x),by=10))
    axis(1, at=ax.ind, labels = len[ax.ind])
    axis(2)
    box()
  }
  if (ann) {
    if(is.null(xlab))  xlab=xy$xlab
    if(is.null(ylab))  ylab=xy$ylab
    title(main=main, sub=sub, 
          xlab=xlab, ylab=ylab, ...)
  }

}

"overlap" <-
  function(modes, dv, nmodes=20) {
    if(missing(modes))
      stop("overlap: 'modes' must be prodivded")
    if(missing(dv))
      stop("overlap: 'dv' must be prodivded")

    if ("pca" %in% class(modes)) {
      ev <- modes$U
      mass <- NULL
      first.mode <- 1
    }
    else if("nma" %in% class(modes)) {
      ev <- modes$modes
      mass <- modes$mass
      first.mode <- modes$triv.modes+1
      nmodes <- modes$triv.modes + nmodes
    }
    else {
      if(!inherits(modes, c("matrix", "pca.loadings")))
        stop("overlap: 'modes' must be an object of type 'pca', 'nma', or 'matrix'")
      ev <- modes
      mass <- NULL
      first.mode <- 1
    }

    if (nrow(ev)!=length(dv))
      stop("overlap: unequal vector lengths")
    
    if ( ncol(ev) < nmodes ) {
      nmodes <- dim(ev)[2L]
      warning("nmodes larger than dimensions of 'modes'")
    }

    inds <- seq(first.mode, nmodes)
    ev <- ev[,inds]

    ## Normalize vectors - mass-weighted if normal modes are
    ev <- normalize.vector(ev, mass)
    dvn <- normalize.vector(dv, mass)
    
    overlap.values <- inner.prod(ev, dvn, mass)**2
    cum <- cumsum(overlap.values)
    
    out <- list(overlap=overlap.values, overlap.cum=cum)
    
    return(out)
  }

#' Obtain A SSE Object From An SSE Sequence Vector
#'
#' Inverse process of the funciton \code{\link{pdb2sse}}.
#'
#' @details call for its effects.
#'
#' @param x a character vector indicating SSE for each amino acid residue.
#' @param pdb an object of class \code{pdb} as obtained from
#'    function \code{\link{read.pdb}}. Can be ignored if \code{x} has 'names'
#'    attribute for residue labels.
#'
#' @return a 'sse' object. 
#'
#' @note In both \code{$helix} and \code{$sheet}, an additional 
#'    \code{$id} component is added to indicate the original numbering of the sse.
#'    This is particularly useful in e.g. \code{trim.pdb()} function.
#'
#' @seealso \code{\link{pdb2sse}}
#'
#' @author Xin-Qiu Yao & Barry Grant
#' 
#' @examples
#' \donttest{
#'    # PDB server connection required - testing excluded
#'
#'    pdb <- read.pdb("1a7l")
#'    sse <- pdb2sse(pdb)
#'    sse.ind <- bounds.sse(sse)
#'    sse.ind 
#' } 
bounds.sse <- function(x, pdb=NULL) {

  if(length(x) == 0) return (NULL)
  
  strings <- names(x) 
  if(is.null(strings)) {
    if(!is.null(pdb)) {
       strings <- paste(pdb$atom[pdb$calpha, "resno"], pdb$atom[pdb$calpha, "chain"], 
                        pdb$atom[pdb$calpha, "insert"], sep = "_")
       if(length(strings) != length(x)) 
          stop("pdb doesn't match x")
    } else {
       strings <- paste(seq_along(x), NA, NA, sep="_")
    }
  } else {
    if(!is.null(pdb)) {
      warning("The x has 'names' attributes. The pdb is ignored")
    }
  }
   
  lstrings <- strsplit(strings, split="_")
  resno <- as.numeric(sapply(lstrings, "[", 1))
  chain <- sapply(lstrings, "[", 2)
  chain[chain == "NA"] <- ""
  insert <- sapply(lstrings, "[", 3)
  insert[insert == "NA"] <- ""
  id <- as.numeric(sapply(lstrings, "[", 4))

  sse.string <- paste(x, chain, id, sep="_")

# bounds doesn't work, use rle2 instead
  rl <- rle2(sse.string)
  inds <- cbind(seq_along(rl$inds), 
                start = c(1, rl$inds[-length(rl$inds)]+1), 
                end = rl$inds, length = rl$lengths )
#  inds <- bounds(sse.string, dup.inds=TRUE, pre.sort=FALSE) 

  # sort segments based on sse id (i.e. keep the original order of sse)
  ind.order <- order(id[inds[, "start"]])
  inds <- inds[ind.order, , drop = FALSE]

  # helix
  h.inds <- which(x[inds[, "start"]] %in% c("H", "G"))
  if(length(h.inds) > 0) {

     h.id <- id[inds[h.inds, "start"]]
     if(any(is.na(h.id))) h.id <- seq_along(h.id)
 
     h <- list(start = resno[inds[h.inds, "start"]], end = resno[inds[h.inds, "end"]], 
        chain = chain[inds[h.inds, "start"]], id = h.id)
     names(h$start) <- insert[inds[h.inds, "start"]]
     names(h$end) <- insert[inds[h.inds, "end"]]
  } else {
     h <- list(start=NULL, end=NULL, chain=NULL, id=NULL)
  }

  # sheet
  e.inds <- which(x[inds[, "start"]] == "E")
  if(length(e.inds) > 0) {

     e.id <- id[inds[e.inds, "start"]]
     if(any(is.na(e.id))) e.id <- seq_along(e.id)
 
     e <- list(start = resno[inds[e.inds, "start"]], end = resno[inds[e.inds, "end"]], 
        chain = chain[inds[e.inds, "start"]], id = e.id)
     names(e$start) <- insert[inds[e.inds, "start"]]
     names(e$end) <- insert[inds[e.inds, "end"]]
  } else {
     e <- list(start=NULL, end=NULL, chain=NULL, id=NULL)
  }
 
  sse <- list(helix = h, sheet = e)
  class(sse) <- 'sse'  
  return( sse )
}

"hclustplot" <- function(hc, k=NULL, h=NULL, colors=NULL,
                           labels=NULL, fillbox=FALSE, 
                           heights = c(1, .3), mar = c(1, 1, 0, 1), ...) {

  if(!inherits(hc, "hclust"))
    stop("hc must be of type 'hclust'")
  if(is.null(k) & is.null(h) & is.null(colors))
    stop("provide either k or h to function 'cutree', or colors for manual coloring")
  
  mtext.names <- names(formals( mtext ))
  plot.dendrogram <- get("plot.dendrogram", envir = getNamespace("stats"))
  plot.names <- c(names(formals( plot.dendrogram )),
                  names(formals( plot.default )))
  
  dots <- list(...)
  mtext.args <- dots[names(dots) %in% mtext.names]
  plot.args <- dots[names(dots) %in% plot.names]
  par.args <- dots[!(names(dots) %in% unique(c(names(mtext.args), names(plot.args))))]

  mtext.args <- c(mtext.args, par.args)
  plot.args <- c(plot.args, par.args)

  ## set default and allowed mtext arguments
  if(!any(names(mtext.args)=="line")) {
    if( fillbox )
      mtext.args$line <- 0.5
    else
      mtext.args$line <- -0.25
  }
  if(!any(names(mtext.args)=="side"))
    mtext.args$side <- 1
  if(!any(names(mtext.args)=="las"))
    mtext.args$las <- 2
  if(any(names(mtext.args)=="col"))
    mtext.args$col <- NULL
  if(any(names(mtext.args)=="at"))
    mtext.args$at <- NULL

  ## set default and allowed plot.dendrogram arguments
  if(any(names(plot.args)=="axes")) {
    axes <- plot.args$axes
    plot.args$axes <- NULL
  }
  else {
    axes <- TRUE
  }
  if(any(names(plot.args)=="xaxs"))
    plot.args$xaxs <- NULL
  if(any(names(plot.args)=="leaflab"))
    plot.args$leaflab <- NULL
  if(any(names(plot.args)=="xlab"))
    plot.args$xlab <- NULL
  if(any(names(plot.args)=="horiz"))
    plot.args$horiz <- NULL
  
  ## print(mtext.args)
  ## print(par.args)
  ## print(plot.args)

  plot.labels <- TRUE
  if(is.logical(labels)) {
    if(labels)
      plot.labels <- TRUE
    else
      plot.labels <- FALSE
    labels <- NULL
  }
    
  if(is.null(labels)) {
    labels <- hc$labels
    if(is.null(labels))
      labels <- seq(1, length(hc$order))
  }
  else {
    if( length(hc$order) != length(labels) )
      stop("labels must be of same length as hc")
  }
  
  if(!is.null(colors)) {
    unq.cols <- unique(colors)
    grps <- unlist(lapply(colors, function(x) which(x==unq.cols)))
    labelColors <- unq.cols
  }
  else {
    grps <- cutree(hc, k=k, h=h)
    labelColors <- seq(1, length(unique(grps)))
  }
  	
  hcd         <- as.dendrogram(hc)
  cols <- labelColors[grps][hc$order]

  ## set margins
  mar.default <- c(1, 1, 0, 1)
  if(all(mar==mar.default)) {
    mar <- mar.default
    mar[1] <- mar[1] + ifelse(plot.labels, 3, 0)
    mar[1] <- mar[1] + ifelse(fillbox, 2, 0)
    mar[2] <- mar[2] + ifelse(!is.null(plot.args$ylab), 2, 0)
    mar[2] <- mar[2] + ifelse(axes, 2, 0)
    mar[3] <- ifelse(!is.null(plot.args$ylab), 4, 2)
  }

  ## colored filled boxes below the dendrogram
  if( fillbox ) { ##| plot.labels ) { 
    layout(as.matrix(c(2,1)), heights = heights)
  
    dev.hold()
    on.exit(dev.flush())
    op <- par(no.readonly = TRUE)
    on.exit(par(op), add = TRUE)
    
    par(mar=c(mar[1], mar[2], 0, mar[4]))
    
    if( fillbox )
      image(cbind(1:length(grps)), col = cols, axes = FALSE)
    else
      frame()

    
    if(plot.labels) {
      do.call('mtext', c(list(text=labels[ hc$order ],
                              at=seq(0, 1, length.out=length(grps)),
                              col=cols),
                         mtext.args))
    }
  }

  else {
    layout(1)
  }

  ## dendrogram
  par(mar = c(ifelse(fillbox, 0, mar[1]),
        mar[2], mar[3], mar[4]))
  do.call('plot',  c(list(x=hcd, axes=FALSE, leaflab="none", xaxs="i"),
                     plot.args))
  if(axes)
    axis(2)

  ## labels when filled boxes are not drawn
  if(plot.labels & !fillbox ) {
    do.call('mtext', c(list(text=labels[ hc$order ],
                            at=seq(1, length(grps)),
                            col=cols),
                       mtext.args))
  }

  ##if(!is.null(sub)) {
  ##  mtext(sub, side=3, line=-0.5)
  ##}
  
}

`plot.pca.scree` <-
function(x, y=NULL, type="o", pch=18,
         main="", sub="",
         xlim=c(0,20), ylim=NULL, 
         ylab="Proportion of Variance (%)",
         xlab="Eigenvalue Rank",
         axes=TRUE, ann=par("ann"),
         col=par("col"), lab=TRUE,
         ...) {

  if(is.list(x))  x=x$L # output from pca.xyz()
  
  PC <- c(1:length(x))
  percent <- (x/sum(x))*100
  cumv<-cumsum(percent)

  #xy <- xy.coords(x, y)
  xy <- xy.coords(percent, y=NULL)
  if (is.null(xlim))
    xlim <- range(xy$x[is.finite(xy$x)])
  if (is.null(ylim))
    ylim <- range(xy$y[is.finite(xy$y)])
  
  opar <- par(no.readonly=TRUE)
  on.exit(par(opar))
  
  plot.new()
  plot.window(xlim, ylim)#, ...)
  points(xy$x, xy$y, col=col, type=type, pch=pch)#, ...)


  if (axes) {
    axis(1, at=c(1:8,max(xlim)))
    axis(2, at=c(round(percent[c(1:5)],1),0))
    ##axis(1)
    ##axis(2)
    box()
  }
  if(lab) {
    text(c(1:4), percent[c(1:4)], labels=round(cumv[c(1:4)],1), pos=4)
    text(c(8,20), percent[c(8,20)], labels=round(cumv[c(8,20)],1), pos=3)
  }
  if (ann) {
    if(is.null(xlab))  xlab=xy$xlab
    if(is.null(ylab))  ylab=xy$ylab
    title(main=main, sub=sub, 
          xlab=xlab, ylab=ylab, ...)
  }
  out<-list(pc=PC,percent=percent,cumv=cumv)
}

"plot.fluct" <-
  function(x, col = NULL, label = rownames(x), signif = FALSE, p.cutoff = 0.005,
           q.cutoff = 0.04, s.cutoff = 5, n.cutoff = 2, mean = FALSE, polygon = FALSE, spread=FALSE, offset=1,
           ncore = NULL, ...) {

    ## check input data
    if(is.vector(x))
      x = matrix(x, nrow=1)
    if(!is.matrix(x) || !is.numeric(x))
      stop("provide a numeric matrix or vector")

    ## check colors, which also define groups of input data if signif=TRUE
    if(is.null(col))
      col <- seq(1, nrow(x))
    if(length(col) != nrow(x))
       stop("length of col doesn't match dimension of x")
    if(any(is.na(col))) {
       x = x[!is.na(col), ]
       col = col[!is.na(col)]
    }

    ## check for significance calculation
    if(signif) {
       ns <- table(col)
       inds.signif <- which(ns >= s.cutoff)
       if(length(inds.signif) < 2) {
         warning("Insufficient samples to calculate significance")
         signif = FALSE
      }
    }

    ## extract some values from '...' since we still do some plots here
    ## These could be removed after merging this function with plot.bio3d()
    dots = list(...)
    if("rm.gaps" %in% names(dots)) rm.gaps = dots$rm.gaps
    else rm.gaps = formals(plotb3)$rm.gaps

    ## gaps positions
    gaps.pos <- gap.inspect(x)

    if(rm.gaps) yvals = x[, gaps.pos$f.inds, drop=FALSE]
    else yvals = x

    if("ylim2zero" %in% names(dots)) ylim2zero = dots$ylim2zero
    else ylim2zero = formals(plotb3)$ylim2zero

    if("xlim" %in% names(dots)) xlim = dots$xlim
    else xlim = c(1, ncol(yvals))

    if("ylim" %in% names(dots)) ylim = dots$ylim
    else ylim = range(yvals, na.rm = TRUE)

    if(spread) {
        ylim[2] = ylim[2] + (offset * (length(unique(col))-1))
    }

    if(ylim2zero) ylim[1] = 0

    if(! "ylab" %in% names(dots)) dots$ylab = "Fluctuation"
    dots$xlim = xlim
    dots$ylim = ylim
    #####################################################################

    if(signif) {

      ncore = setup.ncore(ncore)

#      op = par(no.readonly = TRUE)
      op = par()$new
      on.exit(par(new=op))

      pairs <- pairwise(length(inds.signif))

      ## get p-value and q-value for each non-gap position
      p.all <- mclapply(gaps.pos$f.inds, function(i) {
         p.i <- apply(pairs, 1, function(j) {
            inds1 <- which(col == names(ns)[inds.signif[j[1]]])
            inds2 <- which(col == names(ns)[inds.signif[j[2]]])
            p = t.test(x[inds1, i], x[inds2,i], alternative="two.sided")$p.value
            q <- abs(mean(x[inds1, i]) - mean(x[inds2, i]))
            c(p, q)
         })
         c(p=min(p.i[1, ]), q=p.i[2, which.min(p.i[1,])])
      })

      ## p-values with gaps inserted
      pvalue <- rep(NA, ncol(x))
      pvalue[gaps.pos$f.inds] <- sapply(p.all, "[", "p")

      ## q-values, i.e. difference of mean values, with gaps inserted
      qvalue <- rep(NA, ncol(x))
      qvalue[gaps.pos$f.inds] <- sapply(p.all, "[", "q")

      if(rm.gaps){
         pvalue = pvalue[gaps.pos$f.inds]
         qvalue = qvalue[gaps.pos$f.inds]
      }

      sig <- which(pvalue<=p.cutoff & qvalue >= q.cutoff)

      ## - start plotting
      if(length(sig) > 0) {
         ## Plot significance as shaded blocks
         bds <- bounds(sig)
         ii <- which(bds[, "length"] >= n.cutoff)

         if(length(ii) > 0) {

            plot.new()
            plot.window(xlim=xlim, ylim=ylim)

            ## to show bricks for single site significance
            adjust = 0.1
            rect(bds[ii,1]-adjust, rep(ylim[1], length(ii)), bds[ii,2]+adjust,
                 rep(ylim[2], length(ii)),
                 col=rep("lightblue", length(ii)), border=NA)

            ## add this for plot.bio3d on the same device
            par(new=TRUE)
         }
      }
    }

    if(mean) {
       # calculate mean values and replace
       yvals = apply(x, 2, tapply, col, mean, na.rm=TRUE)
       col = unique(col)
       if(!is.null(label)) label = unique(label)

       if(!is.matrix(yvals))
          yvals = matrix(yvals, nrow=1)
       else
          yvals = yvals[col, , drop=FALSE]  # correct order change due to tapply

       # still keep the same gaps in first row
       # this will help plot SSE in plot.bio3d()
       yvals[1, is.na(x[1, ])] = NA

       x = yvals
       if(rm.gaps)
          yvals = x[, gaps.pos$f.inds, drop=FALSE]

       # trick to leave gap position unchanged.
       # Won't affect plot because plot.bio3d() only picks up the first row
       # All plots in this function should be done with yvals!!
       x = rbind(x, gap.mark=rep(0, ncol(x)))
       x["gap.mark", gaps.pos$t.inds] = NA
    }


    ## Plot fluctuations
    if(polygon) {
       spread <- FALSE
       dots$type = "n"
       do.call(plot.bio3d,  c(list(x=x), dots))

       xx = yvals[1, ]
       ylim2 = range(xx, na.rm = TRUE)
       if(ylim2zero) ylim2[1] = 0

       n = bounds(which(is.na(xx)))
       if(length(n)>0) xx[n[, 1:2]] = ylim2[1]

       # color for polygon
       n.col = do.call(rgb, c(as.list(col2rgb(col[1])/255), list(alpha=0.4)))

       polygon(c(1, seq_along(xx), length(xx)), c(ylim2[1], xx, ylim2[1]),
          col = n.col, border=NA)
    }
    else {
        do.call(plot.bio3d, c(list(x=x), dots))
    }

    if(!spread) {
        ## Plot all lines
        for(i in 1:nrow(yvals))
            lines(yvals[i, ], col=col[i], lwd=2)
    }
    else {
        unq.col <- unique(col)
        for(i in 1:length(unq.col)) {
            tmp.col <- unq.col[i]
            grp.inds <- which(col==tmp.col)
            off <- ((i-1)* offset)
            for(j in 1:length(grp.inds))
                lines(yvals[grp.inds[j], ] + off, col=tmp.col)
        }
    }

    ## legend
    if(!is.null(label))
       legend('topright', legend=label, text.col=col, bty='n')

    if(signif)
       out <- list(signif=sig)
    else
       out <- NULL
    invisible(out)
  }

"angle.xyz" <-
function(xyz, atm.inc=3) {
  if(!is.vector(xyz) || !is.numeric(xyz))
    stop("input 'xyz' should be a numeric vector")
  natm  <- length(xyz)/3
  if(natm < 3)
    stop("Need at least three atoms to define an angle")
  if(natm %% 1 != 0)
    stop("There should be three 'xyz' elements per atom")

  m.xyz <- matrix(xyz, nrow=3)
  atm.inds <- c(1:3); out <- NULL
  while(atm.inds[3] <= natm) {
    if( any(is.na( m.xyz[,atm.inds] )) ) {
      ang <- NA
    } else {
      d1 <- m.xyz[,atm.inds[1]] - m.xyz[,atm.inds[2]]
      d2 <- m.xyz[,atm.inds[3]] - m.xyz[,atm.inds[2]]
      ang <- sum(d1*d2) / (sqrt(sum(d1^2)) * sqrt(sum(d2^2)) )
      ang[ang > 1] <- 1; ang[ang < -1] <- -1
      ang <- acos(ang) * (180/pi)
    }
    out <- c(out, ang)
    atm.inds <- atm.inds + atm.inc
  }
  return(out)
}

"pdb.annotate" <- function(ids, anno.terms=NULL, unique=FALSE, verbose=FALSE, 
                           extra.terms=NULL) {
  
  oops <- !requireNamespace("httr", quietly = TRUE)
  if(oops) {
    stop("Please install the httr package from CRAN")
  }
  
  if(!is.null(extra.terms)) {
    message("Currently 'extra.terms' is not supported")
    extra.terms <- NULL
  }
  
  if(inherits(ids, "blast")) ids = ids$pdb.id
  
  if(!is.vector(ids)) {
    stop("Input argument 'ids' should be a vector of PDB identifiers/accession codes")
  }
  
  ## Basic annotation terms (note 'citation' is a meta term)
  anno.basicterms <- c("structureId", "chainId", "macromoleculeType",
                       "chainLength", "experimentalTechnique",  "resolution", 
                       "scopDomain", "pfam", "ligandId", "ligandName",
                       "source", "structureTitle", "citation", "rObserved",
                       "rFree", "rWork", "spaceGroup")  
  if(is.null(anno.terms)) {
    anno.terms <- anno.basicterms
  } 
  else {
    anno.terms <- match.arg(anno.terms, anno.basicterms, several.ok=TRUE)
    anno.terms <- unique(anno.terms)
  }
  anno.terms.input <- anno.terms
  
  ## Check if we have any valid terms remaining
  if( length(anno.terms) == 0 ) {
    stop( paste("No valid anno.terms specified. Please select from:\n\t ",
                paste(anno.basicterms, collapse=", ")) )
  }
  
  ## force the structureId and chainId terms to be present
  req.terms <- c("structureId", "chainId")
  
  if(any(c("ligandId", "ligandName") %in% anno.terms)) {
    ## force ligandChainId
    req.terms <- c(req.terms, "ligandChainId")
  }
  
  inds <- req.terms %in% anno.terms

  if(!all(inds)) {
    anno.terms <- c(req.terms[!inds], anno.terms)
  }
  
  if (missing(ids)) {
    stop("please specify PDB ids for annotating")
  }
  
  if (any(nchar(ids) != 4)) {
#    warning("ids should be standard 4 character PDB-IDs: trying first 4 characters...")

#    if(unique) {
#      ids <- unique(substr(basename(ids), 1, 4))
#    }
    
    ## first 4 chars should be upper
    ## any chainId should remain untouched - see e.g. PDB ID 3R1C
    mysplit <- function(x) {
      str <- unlist(strsplit(x, "_"))
      if(length(str)>1) {
        paste(toupper(str[1]), "_", str[2], sep="")
      }
      else {
        toupper(str[1])
      }
    }
  
    ids <- unlist(lapply(ids, mysplit))
  } else {
    ids <- toupper(ids)
  }
  ids.short <- unique( substr(basename(ids), 1, 4) )

  ## prepare query
  baseurl <- "https://data.rcsb.org/graphql"

  anno.terms.new <- unlist(sapply(anno.terms, .map_terms))
  anno.terms.new <- c(anno.terms.new, extra.terms)
  
  query <- "query($id: [String!]!){
     entries(entry_ids: $id){
  "
  query <- paste(query, 
    paste( sapply(anno.terms.new, .string2json), collapse="\n"), 
    "\n}}", sep="")

  resp <- httr::POST(baseurl,
                     httr::accept_json(),
                     body = list(query=query,
                                 variables=list(id=ids.short)), 
                     encode="json")
  
  if(httr::http_error(resp)) {
    stop('Access to PDB server failed')
  }
  else {
    ret <- httr::content(resp)
  }
  
  if("error" %in% names(ret)) {
    stop('Retrieving data from PDB failed')
  }

  if((!"data" %in% names(ret)) || (length(ret$data$entries)==0)) {
    stop("No data retrieved")
  }
  
  ## Generate a formatted table
  ## Also taking care of merging data for unique structureId, 
  ##   excluding non-requested chain IDs, formatting citation, etc.
  data <- .format_tbl(ret, ids, anno.terms, unique=unique)
  
  if(unique) {
    rownames(data) <- data$structureId
  } 
  else {
    rownames(data) <- paste(data$structureId, data$chainId, sep="_")
  }
  
  ## include only requested terms 
  ## (NOTE: need to modify for future support of 'extra.terms')
  col.inds <- which(colnames(data) %in% anno.terms.input)
  data <- data[, col.inds, drop=FALSE]

  return(data)
}

## map a string to JSON-like input parameters
.string2json <- function(x) {
  x <- strsplit(x, split="\\.")[[1]]
  if(length(x)>1) {
    paste( paste(x, collapse="{"), paste(rep("}", length(x)-1), collapse=""), sep="")
  }
  else if(length(x)==0) {
    ""
  }
  else {
    x
  }
}

## map from old terms to the new ones
.map_terms <- function(x) {
  switch(x,
         "structureId" = "entry.id",
         "chainId" = "polymer_entities.polymer_entity_instances.rcsb_polymer_entity_instance_container_identifiers.auth_asym_id",
         "macromoleculeType" = "polymer_entities.polymer_entity_instances.polymer_entity.entity_poly.rcsb_entity_polymer_type",
         "chainLength" = "polymer_entities.polymer_entity_instances.polymer_entity.entity_poly.rcsb_sample_sequence_length",
         "experimentalTechnique" = "rcsb_entry_info.experimental_method",
         "resolution" = "rcsb_entry_info.resolution_combined",
         "scopDomain" = paste(
           "polymer_entities.polymer_entity_instances.rcsb_polymer_instance_feature", 
           c("name", "type"), 
           sep="."),
         "pfam" = paste(
           "polymer_entities.polymer_entity_instances.polymer_entity.rcsb_polymer_entity_annotation", 
           c("annotation_id", "name", "type"), 
           sep="."),
         "ligandChainId" = "nonpolymer_entities.nonpolymer_entity_instances.rcsb_nonpolymer_entity_instance_container_identifiers.auth_asym_id",
         "ligandId" = "nonpolymer_entities.nonpolymer_entity_instances.nonpolymer_entity.nonpolymer_comp.chem_comp.id",
         "ligandName" = "nonpolymer_entities.nonpolymer_entity_instances.nonpolymer_entity.nonpolymer_comp.chem_comp.name",
         "source" = "polymer_entities.polymer_entity_instances.polymer_entity.rcsb_entity_source_organism.ncbi_scientific_name", 
         "structureTitle" = "struct.title",
         "citation" = paste("rcsb_primary_citation", 
                            c( "rcsb_authors",
                               "rcsb_journal_abbrev",
                               "year"), 
                            sep="."),
         "rObserved" = "refine.ls_R_factor_obs", 
         "rFree" = "refine.ls_R_factor_R_free", 
         "rWork" = "refine.ls_R_factor_R_work",
         "spaceGroup" = "symmetry.space_group_name_H_M"
  )
}

## Return a formatted table/data.frame
.format_tbl <- function(x, query.ids, anno.terms, unique=FALSE) {
  x <- x$data$entries
  pdb.ids <- sapply(x, function(x) x$entry$id)
  chain.ids <- lapply(x, function(x) {
    lapply(x$polymer_entities, function(y) {
      sapply(y$polymer_entity_instances, function(z) {
        id <- z$rcsb_polymer_entity_instance_container_identifiers$auth_asym_id
        if(is.null(id)) {
          id<- as.character(NA)
        }
        id
      })
    })
  })
  nchains <- sapply(chain.ids, function(x) length(unlist(x)))
  nchains.entity <- sapply(chain.ids, sapply, length)
#  ids <- paste(rep(pdb.ids, nchains), unlist(chain.ids), sep="_")
  
  ids <- rep(pdb.ids, nchains)
  chainId <- unlist(chain.ids)
  out <- data.frame(structureId=ids, chainId=chainId, stringsAsFactors=FALSE)


  if("chainLength" %in% anno.terms) {
    cl <- lapply(x, function(x) {
      lapply(x$polymer_entities, function(y) {
        sapply(y$polymer_entity_instances, function(z) {
           cl <- z$polymer_entity$entity_poly$rcsb_sample_sequence_length
           if(is.null(cl)) {
              cl <- as.integer(NA)
           }
           cl
        })
      })
    })

    #    cl <- rep(unlist(cl), unlist(nchains.entity))
    cl <- unlist(cl)
    out$chainLength <- cl
  }
  
  if("experimentalTechnique" %in% anno.terms) {
    em <- sapply(x, function(x) {
      em <- x$rcsb_entry_info$experimental_method
      if(is.null(em)) {
        em <- as.character(NA)
      }
      em
    })
    em <- rep(em, nchains)
    out$experimentalTechnique <- em
  }
  
  if("resolution" %in% anno.terms) {
    reso <- sapply(x, function(x) {
      reso <- x$rcsb_entry_info$resolution_combined[[1]]
      if(is.null(reso)) {
        reso <- as.numeric(NA)
      }
      reso
    })
    reso <- rep(reso, nchains)
    out$resolution <- reso
  }
  
  if("macromoleculeType" %in% anno.terms) {
    moltype <- lapply(x, function(x) {
      lapply(x$polymer_entities, function(y) {
        sapply(y$polymer_entity_instances, function(z) {
           typ <- z$polymer_entity$entity_poly$rcsb_entity_polymer_type
           if(is.null(typ)) {
              typ <- as.character(NA)
           }
           typ
        })
      })
    })
    #    moltype <- rep(unlist(moltype), unlist(nchains.entity))
    moltype <- unlist(moltype)
    out$macromoleculeType <- moltype
  }
  
  if("scopDomain" %in% anno.terms) {
    scop <- lapply(x, function(x) {
      lapply(x$polymer_entities, function(y) {
        sapply(y$polymer_entity_instances, function(z) {
          types <- sapply(z$rcsb_polymer_instance_feature, "[[", "type")
          s <- z$rcsb_polymer_instance_feature[[which(types=="SCOP")[1]]]$name
          if(is.null(s)) {
            s <- as.character(NA)
          }
          s
        })
      })
    })
    scop <- unlist(scop)
    out$scopDomain <- scop
  }
  
  if("pfam" %in% anno.terms) {
    pfam <- lapply(x, function(x) {
      lapply(x$polymer_entities, function(y) {
        sapply(y$polymer_entity_instances, function(z) {
          types <- sapply(z$polymer_entity$rcsb_polymer_entity_annotation, "[[", "type")
          p <- z$polymer_entity$rcsb_polymer_entity_annotation[[which(types=="Pfam")[1]]]$name
          if(is.null(p)) {
            p <- as.character(NA)
          }
          p
        })
      })
    })
    pfam <- unlist(pfam)
    out$pfam <- pfam
  }
  
  if("ligandChainId" %in% anno.terms) {
    lch <- lapply(x, function(x) {
      unlist( lapply(x$nonpolymer_entities, function(y) {
        sapply(y$nonpolymer_entity_instances, function(z) {
          id <- z$rcsb_nonpolymer_entity_instance_container_identifiers$auth_asym_id
          if(is.null(id)) {
             id <- as.character(NA)
          }
          id
        })
      }) )
    })
  }
  
  if("ligandId" %in% anno.terms) {
    lid <- lapply(1:length(x), function(i) {
      x <- x[[i]]
      lch <- lch[[i]]
      chain.ids <- unlist(chain.ids[[i]])
      if(!is.null(x$nonpolymer_entities)) {
        id <- unlist( lapply(x$nonpolymer_entities, function(y) {
          sapply(y$nonpolymer_entity_instances, function(z) {
            id <- z$nonpolymer_entity$nonpolymer_comp$chem_comp$id
            if(is.null(id)) {
              id <- as.character(NA)
            }
            id
          })
        }) )
        id <- tapply(id, lch, function(x) {
          count <- table(x)
          x <- unique(x)
          count <- count[x]
          x[count>1] <- paste(x[count>1], " (", count[count>1], ")", sep="")
          paste(x, collapse=",")
        })
        id <- id[chain.ids]
      }
      else {
        id <- rep(as.character(NA), length(chain.ids))
      }
    })
    lid <- unlist(lid)
    out$ligandId <- lid
  }
  
  if("ligandName" %in% anno.terms) {
    lname <- lapply(1:length(x), function(i) {
      x <- x[[i]]
      lch <- lch[[i]]
      chain.ids <- unlist(chain.ids[[i]])
      if(!is.null(x$nonpolymer_entities)) {
        nam <- unlist( lapply(x$nonpolymer_entities, function(y) {
          sapply(y$nonpolymer_entity_instances, function(z) {
            nam <- z$nonpolymer_entity$nonpolymer_comp$chem_comp$name
            if(is.null(nam)) {
              nam <- as.character(NA)
            }
            nam
          })
        }) )
        nam <- tapply(nam, lch, function(x) {
          count <- table(x)
          x <- unique(x)
          count <- count[x]
          x[count>1] <- paste(x[count>1], " (", count[count>1], ")", sep="")
          paste(x, collapse=",")
        })
        nam <- nam[chain.ids]
      }
      else {
        nam <- rep(as.character(NA), length(chain.ids))
      }
    })
    lname <- unlist(lname)
    out$ligandName <- lname  
  }
  
  if("source" %in% anno.terms) {
    src <- lapply(x, function(x) {
      lapply(x$polymer_entities, function(y) {
        sapply(y$polymer_entity_instances, function(z) {
           src <- sapply(z$polymer_entity$rcsb_entity_source_organism, function(z2) {
              src <- z2$ncbi_scientific_name
              if(is.null(src)) {
                 src <- as.character(NA)
              }
              src
           })
           if(length(src)>1) {
             src <- paste(unique(src), collapse="/")
           }
           else {
             if(length(src)==0) {
                src <- as.character(NA)
             }
           }
           src
        })
      })
    })
    #    src <- rep(unlist(src), unlist(nchains.entity))
    src <- unlist(src)
    out$source <- src
  } 
  
  if("structureTitle" %in% anno.terms) {
    title <- sapply(x, function(x) {
      title <- x$struct$title
      if(is.null(title)) {
        title <- as.character(NA)
      }
      title
    })
    title <- rep(title, nchains)
    out$structureTitle <- title
  }
  
  if("citation" %in% anno.terms) {
    citation <- sapply(x, function(x) {
      aut <- x$rcsb_primary_citation$rcsb_authors
      if(!is.null(aut) && length(aut)>1) {
        aut <- paste(aut[[1]], ", et al.", sep="")
      }
      jrnl <- x$rcsb_primary_citation$rcsb_journal_abbrev
      year <- x$rcsb_primary_citation$year
      if(!is.null(year)) {
        year <- paste("(", year, ")", sep="")
      }
      citation <- paste(aut, jrnl, year)
      if(length(citation)==0) {
        citation <- as.character(NA)
      }
      citation
    })
    citation <- rep(citation, nchains)
    out$citation <- citation
  }
  
  if("rObserved" %in% anno.terms) {
    robs <- sapply(x, function(x) {
      robs <- x$refine[[1]]$ls_R_factor_obs
      if(is.null(robs)) {
        robs <- as.numeric(NA)
      }
      robs
    })
    robs <- rep(robs, nchains)
    out$rObserved <- robs    
  }
  
  if("rFree" %in% anno.terms) {
    rfree <- sapply(x, function(x) {
      rfree <- x$refine[[1]]$ls_R_factor_R_free
      if(is.null(rfree)) {
        rfree <- as.numeric(NA)
      }
      rfree
    })
    rfree <- rep(rfree, nchains)
    out$rFree <- rfree       
  }
  
  if("rWork" %in% anno.terms) {
    rwork <- sapply(x, function(x) {
      rwork <- x$refine[[1]]$ls_R_factor_R_work
      if(is.null(rwork)) {
        rwork <- as.numeric(NA)
      }
      rwork
    })
    rwork <- rep(rwork, nchains)
    out$rWork <- rwork       
  }
  
  if("spaceGroup" %in% anno.terms) {
    sg <- sapply(x, function(x) {
      sg <- x$symmetry$space_group_name_H_M
      if(is.null(sg)) {
        sg <- as.character(NA)
      }
      sg
    })
    sg <- rep(sg, nchains)
    out$spaceGroup <- sg     
  }
  
  # Filter the table
  query.ids <- sub("\\.", "_", query.ids) ## allow PDBId.chainId
  inds <- lapply(query.ids, function(x) {
    if(nchar(x)==4) {
      which(out$structureId %in% x) 
    }
    else {
      which(paste(out$structureId, out$chainId, sep="_") %in% x)
    }
  })
  chk <- sapply(inds, length)
  if(any(chk==0)) {
    warning(paste("Annotation data could not be found for PDB ids:\n  ",
                  paste(unique(query.ids[chk==0]), collapse=", ")))
  }
  query.ids <- query.ids[chk>0]
  out <- out[unique(unlist(inds)), , drop=FALSE]
  
  if(unique) {
    # Fold the table based on PDB IDs
    out <- tapply(1:nrow(out), factor(out$structureId, levels=unique(out$structureId)),
     function(i){
       out <- out[i, , drop=FALSE]
       labs <- colnames(out); names(labs) <- labs
       cols <- lapply(labs, function(j) {
          if(j %in% c("chainId", "macromoleculeType", "chainLength", 
                      "scopDomain", "pfam", "ligandId", "ligandName", "source")) {
            paste(out[, j], collapse=";")
          }
          else {
            out[1, j]
          }
       })
       as.data.frame(cols, stringsAsFactors=FALSE)
    }, simplify=FALSE)
    out <- do.call(rbind, out)
    rownames(out) <- NULL
  }
  
  req.terms <- c("structureId", "chainId")
  out <- out[, c(req.terms, setdiff(anno.terms, c(req.terms, "ligandChainId"))), 
             drop=FALSE]
  out
}

context("Testing pdb.annotate()")


test_that("PDB annotation works", {
  skip_on_cran()
  skip_on_travis()

  expected <- c('3R1C_X', '3R1C_B', '3R1C_C', '3R1C_D',
                '3R1C_E', '3R1C_F', '3R1C_G', '3R1C_H',
                '3R1C_I', '3R1C_J', '3R1C_K', '3R1C_L',
                '3R1C_M', '3R1C_N', '3R1C_O', '3R1C_P',
                '3R1C_Q', '3R1C_R', '3R1C_S', '3R1C_Y',
                '3R1C_T', '3R1C_U', '3R1C_W', '3R1C_A',
                '3R1C_V', '3R1C_Z', '3R1C_a', '3R1C_b',
                '3R1C_c', '3R1C_d', '3R1C_e', '3R1C_f',
                '3R1C_g', '3R1C_h', '3R1C_i', '3R1C_j')

  invisible(capture.output(anno <- pdb.annotate(expected)))
  expect_identical(rownames(anno), expected)

  expected <- c('3R1C_A', '3R1C_a', '3R1C_B', '3R1C_b',
                '3R1C_C', '3R1C_c', '3R1C_D', '3R1C_d',
                '3R1C_E', '3R1C_e', '3R1C_F', '3R1C_f',
                '3R1C_G', '3R1C_g', '3R1C_H', '3R1C_h',
                '3R1C_I', '3R1C_i', '3R1C_J', '3R1C_j',
                '3R1C_K', '3R1C_L', '3R1C_M', '3R1C_N',
                '3R1C_O', '3R1C_P', '3R1C_Q', '3R1C_R',
                '3R1C_S', '3R1C_Y', '3R1C_T', '3R1C_U',
                '3R1C_W', '3R1C_X', '3R1C_V', '3R1C_Z')
  
  invisible(capture.output(anno <- pdb.annotate('3R1C')))
  # 'sort' because sometimes PDB returns chain IDs in an uncertain way...
  expect_identical(sort(rownames(anno)), sort(expected))

  expected <- c('3R1C_A', '3R1C_a', '3R1C_B', '3R1C_b',
                '3R1C_C', '3R1C_c', '3R1C_D', '3R1C_d',
                '3R1C_E', '3R1C_e', '3R1C_F', '3R1C_f',
                '3R1C_G', '3R1C_g', '3R1C_H', '3R1C_h',
                '3R1C_I', '3R1C_i', '3R1C_J', '3R1C_j',
                '3R1C_K', '3R1C_L', '3R1C_M', '3R1C_N',
                '3R1C_O', '3R1C_P', '3R1C_Q', '3R1C_R',
                '3R1C_S', '3R1C_Y', '3R1C_T', '3R1C_U',
                '3R1C_W', '3R1C_X', '3R1C_V', '3R1C_Z',
                '1CDK_A', '1CDK_B', '1CDK_I', '1CDK_J')
  
  invisible(capture.output(anno <- pdb.annotate(c('3R1C', '1CDK'))))
  # 'sort' because sometimes PDB returns chain IDs in an uncertain way...
  expect_identical(sort(rownames(anno)), sort(expected))

  expect_warning(  
    invisible(capture.output(anno <- pdb.annotate(c('3R1C_A', '3r1c_a', '3r1c_q'))))
  )
  expect_identical(rownames(anno), expected[c(1, 2)])

  invisible(capture.output(anno <- pdb.annotate(c('3R1C_A', '3r1c_a'), unique=TRUE)))
  expect_identical(rownames(anno), "3R1C")
  expect_identical(anno$chainId, "A;a")
  
  
  expected <- sort(rep(c("ANP", "MN (2)", "MYR"), 2))
  invisible(capture.output(anno <- pdb.annotate(c('1cdk_A', '1cdk_B'), anno.terms="ligandId")))
  expect_identical(sort(unlist(strsplit(anno$ligandId, ","))), expected)

  ## Test cases without ligands
  ids <- c("6AXG_B", "1AA9_A", "7L0F_A", "6AMB_A", "121P_A", "5E95_A")
  invisible(capture.output(anno <- pdb.annotate(ids)))
  expect_identical(paste(anno[, "structureId"], anno[, "chainId"], sep="_"), ids)
  expect_true(is.na(anno[1, "ligandId"]))
  expect_identical(anno[2, "experimentalTechnique"], "NMR")

  ## Test cases without 'source'
  ids <- c("1P79", "4os7")
  invisible(capture.output(anno <- pdb.annotate(ids)))
  expect_true(is.na(anno[1, "source"]))
  expect_true(is.na(anno[3, "source"]))
  expect_identical(anno[1, "macromoleculeType"], "RNA")
  expect_identical(anno[3, "macromoleculeType"], "Protein")
  
  ## Test cases with duplicated 'sources'
  ids <- c("5TOK")
  invisible(capture.output(anno <- pdb.annotate(ids)))
  expect_identical(anno[1, "source"], "Human orthopneumovirus")

  ## Test error handling
  expect_error(pdb.annotate("1234"), regexp="No data retrieved")
})

vmd.cnapath <- function(x, pdb, out.prefix = "vmd.cnapath", spline = FALSE, 
        colors = c("blue", "red"), launch = FALSE, exefile=NULL, mag=1.0, ...) {

   if(!inherits(x, "cnapath")) {
      if(is.list(x) && inherits(x[[1]], "cnapath")) {
         if(length(x)==1) {
            x <- x[[1]]
         }
         else {
            x2 <- do.call(mapply, c(list("c"), x, list(SIMPLIFY=FALSE)))
            x2$grp <- rep(1:length(x), times=sapply(x, function(x) length(x$path)))
            class(x2) <- "cnapath"
            x <- x2
         }
      }
      else {
         stop("Input x is not a (or a list of) 'cnapath' object(s)")
      }
   }

   # Check colors
   if(is.character(colors)) {
      cols <- colors
   } 
   else {
      if(length(colors) == 1 && is.numeric(colors))
         cols <- vmd_colors()[colors + 1]
      else
         stop("colors should be a character vector or an integer indicating a VMD color ID")
   }
   if(!is.null(x$grp)) {
      if(length(cols) != max(x$grp)) {
        stop("Color length does not match input x")
      }
      cols <- lapply(cols, colorRamp)
   }
   else {
      cols <- colorRamp(cols)
   }

   file = paste(out.prefix, ".vmd", sep="")
   pdbfile = paste(out.prefix, ".pdb", sep="")

   res <- unique(unlist(x$path))
   ind.source <- match(x$path[[1]][1], res)
   ind.sink <- match(x$path[[1]][length(x$path[[1]])], res)

   ca.inds <- atom.select(pdb, elety="CA", verbose = FALSE)
   res.pdb <- pdb$atom[ca.inds$atom[res], "resno"] 
   chain.pdb <- pdb$atom[ca.inds$atom[res], "chain"]
   names(res.pdb) <- chain.pdb

   # make VMD atom selection string
   .vmd.atomselect <- function(res) {
      if(any(is.na(names(res))))
          return(paste("resid", paste(res, collapse=" ")))
      else {
         res <- res[order(names(res))]
         inds <- bounds(names(res), dup.inds=TRUE)
         string <- NULL
         for(i in 1:nrow(inds)) {
            string <- c(string, paste("chain", names(res)[inds[i, "start"]],
               "and resid", paste(res[inds[i, "start"]:inds[i, "end"]], collapse=" ")))
         }   
         return(paste(string, collapse=" or "))
      }
   }
 
   # Draw molecular structures
   cat("mol new ", pdbfile, " type pdb first 0 last -1 step 1 filebonds 1 autobonds 1 waitfor all
mol delrep 0 top
mol representation NewCartoon 0.300000 10.000000 4.100000 0
mol color colorID 8
mol selection {all}
mol material Opaque
mol addrep top
mol representation Licorice 0.300000 10.000000 10.000000
mol color name
mol selection {(", .vmd.atomselect(res.pdb[c(ind.source, ind.sink)]), ")} 
mol material Opaque
mol addrep top 
mol representation VDW 0.4 10
mol color colorID 2
mol selection {(", .vmd.atomselect(res.pdb), ") and name CA}
mol material Opaque
mol addrep top
", file=file)

   # Draw paths 
   cat("\n# start drawing suboptimal paths\n", file=file, append=TRUE)

   rad <- function(r, rmin, rmax, radmin = 0.01, radmax = 0.5) {
      (rmax - r) / (rmax - rmin) * (radmax - radmin) + radmin
   }
   rmin <- min(x$dist)
   rmax <- max(x$dist)
  
   # turn off display update for speed up
   cat("display update off\n", file=file, append=TRUE)

   # find start color id for new colors 
   cat("set color_start [colorinfo num]\n", file=file, append=TRUE)

   if(!spline) {
      col.mat <- array(list(), dim=c(length(res), length(res)))
      conn <- matrix(0, length(res), length(res))
      rr <- conn
      for(j in 1:length(x$path)) {
         y = x$path[[j]]
         for(i in 1:(length(y)-1)) {
            i1 = match(y[i], res)
            i2 = match(y[i+1], res)
            if(conn[i1, i2] == 0) conn[i1, i2] = conn[i2, i1] = 1
            r = rad(x$dist[j], rmin, rmax, radmax = 0.5*mag)
            ic = (rmax - x$dist[j]) / (rmax - rmin)
            if(is.list(cols)) {
              col = list(cols[[x$grp[j]]](ic)[1:3])
            }
            else {
              col = list(cols(ic)[1:3])
            }
            if(r > rr[i1, i2]) {
               rr[i1, i2] = rr[i2, i1] = r
               col.mat[i1, i2] = col.mat[i2, i1] = col
            }
         }
      }
      rownames(conn) <- res
      colnames(conn) <- res
      rownames(rr) <- res
      colnames(rr) <- res
   
      k = 0
      for(i in 1:(nrow(conn)-1)) {
         for(j in (i+1):ncol(conn)) {
            if(conn[i, j] == 1) {
               if(!is.numeric(colors)) {
#                 col = as.numeric(col2rgb(col.mat[i, j]))/255
                  col = unlist(col.mat[i, j]) / 255
                  cat("color change rgb [expr ", k, " + $color_start] ", paste(col, collapse=" "), "\n", sep="", file=file, append=TRUE)
                  cat("graphics top color [expr ", k, " + $color_start]\n", sep="", file=file, append=TRUE)
               }
               else {
                  cat("graphics top color ", colors, "\n", sep="", file=file, append=TRUE)
               }
               cat("draw cylinder {", pdb$xyz[atom2xyz(ca.inds$atom[res[i]])], 
                  "} {", pdb$xyz[atom2xyz(ca.inds$atom[res[j]])], "} radius", rr[i, j], 
                  " resolution 6 filled 0\n", sep=" ", file=file, append=TRUE)
               k = k + 1
            }
         }
      } 
   }
   else {
      k = 0
      for(j in 1:length(x$path)) {
         # get spline coordinates
         # interpolate at 10 points evenly distributed between two nodes
         xyz = matrix(pdb$xyz[atom2xyz(ca.inds$atom[x$path[[j]]])], nrow=3)
         spline.x = spline(xyz[1, ], n = ncol(xyz)+(ncol(xyz)-1)*10)$y
         spline.y = spline(xyz[2, ], n = ncol(xyz)+(ncol(xyz)-1)*10)$y
         spline.z = spline(xyz[3, ], n = ncol(xyz)+(ncol(xyz)-1)*10)$y
    
         # spline radius
         r = rad(x$dist[j], rmin, rmax, radmax=0.5*mag)

         # spline color
         ic = (rmax - x$dist[j]) / (rmax - rmin)

         if(is.list(cols)) {
            col = cols[[x$grp[j]]](ic)[1:3] / 255
         }
         else {
            col = cols(ic)[1:3] / 255
         }

         if(!is.numeric(colors)) {
            cat("color change rgb [expr ", k, " + $color_start] ", 
                paste(col, collapse=" "), "\n", sep="", file=file, append=TRUE)
            cat("graphics top color [expr ", k, " + $color_start]\n", sep="", file=file, append=TRUE)
         } else {
            cat("graphics top color ", colors, "\n", sep="", file=file, append=TRUE)
         } 
         for(i in 1:(length(spline.x) - 1)) { 
             cat("draw cylinder {", spline.x[i], spline.y[i], spline.z[i],
                  "} {", spline.x[i+1], spline.y[i+1], spline.z[i+1], "} radius", r,
                  " resolution 6 filled 0\n", sep=" ", file=file, append=TRUE)
         }
         k = k + 1
      }
   }

   # turn on display update
   cat("display update on\n", file=file, append=TRUE)

   write.pdb(pdb, file=pdbfile)
   
   if(launch) {

     ## Find default path to external program
     if(is.null(exefile)) {
       exefile <- 'vmd'
       if(nchar(Sys.which(exefile)) == 0) {
         os1 <- Sys.info()["sysname"]
         exefile <- switch(os1,
           Windows = 'vmd.exe', # to be updated
           Darwin = '/Applications/VMD\\ 1.9.*app/Contents/MacOS/startup.command',
           'vmd' )
       }
     }
     if(nchar(Sys.which(exefile)) == 0)
       stop(paste("Launching external program failed\n",
                  "  make sure '", exefile, "' is in your search path", sep=""))

     cmd <- paste(exefile, "-e", file)

     os1 <- .Platform$OS.type
     if (os1 == "windows") {
       shell(shQuote(cmd))
     } else{
       system(cmd)
     }
      
   }
}

vmd.ecnapath <- function(x, ...) {
   if(!inherits(x, "ecnapath")) {
      stop("The input 'x' must be an object of class 'ecnapath'.")
   }
   vmd.cnapath(x, ...)
}

"rmsf" <-
function(xyz, grpby = NULL, average = FALSE) {
  if(is.null(dim(xyz)))
    stop("input 'xyz' has NULL dimension")

  if(!is.null(grpby)) {
      if(is.pdb(grpby))
         grpby <- paste(grpby$atom$resno, grpby$atom$chain, sep="-")
      if(length(grpby) != ncol(xyz)/3)
         stop("Length of 'grpby' doesn't match 'xyz'")
  }

  ## Cov function changed ~ R.2.7
  my.sd <- function (x, na.rm = FALSE) {
    if (is.matrix(x))
      apply(x, 2, my.sd, na.rm = na.rm)
    else if (is.vector(x)) {
      if(na.rm) x <- x[!is.na(x)]
      if(length(x) == 0) return(NA)
      sqrt(var(x, na.rm = na.rm))
    }
    else if (is.data.frame(x))
      sapply(x, my.sd, na.rm = na.rm)
    else {
      x <- as.vector(x)
      my.sd(x,na.rm=na.rm)
    }
  }

  fluct = rowSums( matrix( my.sd(xyz, na.rm = TRUE), ncol=3, byrow=TRUE )^2, na.rm=TRUE )
  if(average) {
     if(ncol(xyz) %% 3 == 0)
        d = ncol(xyz) / 3
     else 
        d = ncol(xyz)
     return( sqrt( sum(fluct)/d ) )
  } else {
     if(is.null(grpby)) 
        return( sqrt( fluct ) )
     else
        return( as.vector(tapply(sqrt( fluct ), as.factor(grpby), mean)) )
  }
}

plot.dccm <-function(x, resno=NULL, sse=NULL, colorkey=TRUE,
                     at=c(-1, -0.75, -0.5,  -0.25, 0.25, 0.5, 0.75, 1),
                     main="Residue Cross Correlation", # pad=0.022
                     helix.col = "gray20", sheet.col = "gray80",
                     inner.box=TRUE, outer.box=FALSE,
                     xlab="Residue No.", ylab="Residue No.",
                     margin.segments=NULL, segment.col=vmd_colors(), 
                     segment.min=1, ...) {

  requireNamespace("lattice", quietly = TRUE)
  colnames(x) = NULL; rownames(x)=NULL

  ##-- Customized axis tick labels
  if(!is.null(resno)) {
    if(is.pdb(resno)) {
      ## Take Calpha residue numbers from PDB input
      ca.inds <- atom.select(resno, "calpha", verbose = FALSE)
      resno <- resno$atom$resno[ca.inds$atom]
    }
    if(length(resno) != nrow(x)) {
      warning("Length of input 'resno' does not equal the length of input 'x'; Ignoring 'resno'")
      resno=NULL
    }
  }

  scales <- NULL
  dots <- list(...)
  if('scales' %in% names(dots)) {
    scales <- dots$scales
  }

  if(!"at" %in% names(scales)) {
    xy.at <- pretty(1:ncol(x))
    xy.at <- xy.at[xy.at <= ncol(x)]
    xy.at[1] <- 1
    if(is.null(resno)) {
      scales$at <- xy.at
      scales$labels <- xy.at
    } else {
      labs <- resno[xy.at]
      labs[is.na(labs)] <- ""
      scales$at <- xy.at
      scales$labels <- labs
    }
  }
  dots$scales <- scales

  draw.segment <- function(start, length, xymin, xymax, fill.col="gray", side=1) {
    ##-- Draw Annotation On Plot Margins, used for SSE and CLUSTER members
    ##    draw.segment(store.grps[,"start"], store.grps[,"length"],
    ##                 xymin=xymin, xymax=xymax, side=1, fill.col="red")
    
    if(side==1) {
      ## Bottom Margin
      grid.rect(x=unit(start-0.5, "native"),
                y=0,
                gp = gpar(fill=fill.col, col=NA),
                just=c("left","bottom"),
                width=unit(length-0.5, "native"),
                height=xymin,
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp")) 
    }
    if(side==2) {
      ## Left Margin
      grid.rect(x=0, 
                y=unit(start-0.5, "native"),
                gp = gpar(fill=fill.col, col=NA),
                just=c("left","bottom"),
                width=xymin,
                height=unit(length-0.5, "native"),
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp"))      
    }
    if(side==3) {
      ## Top Margin
      grid.rect(x=unit(start-0.5, "native"),
                y=xymax,
                gp = gpar(fill=fill.col,col=NA),
                just=c("left","bottom"),
                width=unit(length-0.5, "native"),
                height=unit(1, "npc"),
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp"))
    }
    if(side==4) {
      ## Right Margin
      grid.rect(x=xymax,
                y=unit(start-0.5, "native"),
                gp = gpar(fill=fill.col,col=NA),
                just=c("left","bottom"),
                width=unit(1, "npc"),
                height=unit(length-0.5, "native"),
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp"))
    }
  }
  
  ##-- Main Plot
  p1 <- do.call(lattice::contourplot, c(list(x, region = TRUE, labels=FALSE, col="gray40",
                    at=at, xlab=xlab, ylab=ylab,
                    colorkey=colorkey, main=main), dots))

  ##-- Check sse
  if(is.pdb(sse)) {
     sse <- pdb2sse(sse)
     sse <- bounds.sse(unname(sse))
  }

  if(length(sse$helix$start)==0 && 
     length(sse$sheet$start)==0) 
    sse <- NULL

  xymin=0; xymax=1
  if (is.null(sse) && is.null(margin.segments)) {
    print(p1)
  } else {
    xlim <- p1$x.limits
    ylim <- p1$y.limits
    uni <- 1/(max(xlim)-min(xlim))
    pad=0.02 ## This should be setable!
    padref <- pad/uni
    
    if(!is.null(sse)) {
      ##-- Adjust Top and Right margins for 'sse'
      xymax <- 1-(pad)
      p1$x.limits[2]=xlim[2]+padref
      p1$y.limits[2]=ylim[2]+padref
    }
    if(!is.null(margin.segments)) {
      ##-- Adjust Bottom and Left margins for 'segments'
      xymin = pad
      p1$x.limits[1]=xlim[1]-padref
      p1$y.limits[1]=ylim[1]-padref

      ##- Format margin annotation object
      grps <- table(margin.segments)
      ## Exclude small grps less than 'segment.min'
      grps = names( grps[grps > segment.min] )

      store.grps <- NULL; 
      for(i in 1:length(grps)) {
        store.grps <- rbind(store.grps,
          cbind( bounds(which(margin.segments == grps[i])),
                "grp"=as.numeric(grps[i])) )
      }
      
      ## Margin segment colors
      if(is.null(segment.col)) {
        segment.col <- (store.grps[,"grp"])
      } else {
        segment.col <- segment.col[(store.grps[,"grp"])]
      }
    }
    print(p1)

    if(!is.null(sse)) {
      ##-- SSE annotation 

      if(length(sse$helix$start) > 0) {
        ## dont have a pdb$helix$length
        if( is.null(sse$helix$length) ) {
          sse$helix$length <- (sse$helix$end+1)-sse$helix$start
        }
        ## TOP
        draw.segment(sse$helix$start, sse$helix$length,
                     xymin=xymin, xymax=xymax, fill.col=helix.col, side=3)
        ## RIGHT
        draw.segment(sse$helix$start, sse$helix$length,
                     xymin=xymin, xymax=xymax, fill.col=helix.col, side=4)
      }

      if(length(sse$sheet$start) > 0) {
        if( is.null(sse$sheet$length) ) {
          sse$sheet$length <- (sse$sheet$end+1)-sse$sheet$start
        } 
        ## TOP
        draw.segment(sse$sheet$start, sse$sheet$length,
                     xymin=xymin, xymax=xymax, fill.col=sheet.col, side=3)
        ## RIGHT
        draw.segment(sse$sheet$start, sse$sheet$length,
                     xymin=xymin, xymax=xymax, fill.col=sheet.col, side=4)
      }
    }
    

    if(!is.null(margin.segments)) {
      ##-- Cluster annotation 
      ## BOTTOM
      draw.segment(store.grps[,"start"], store.grps[,"length"],
                   xymin=xymin, xymax=xymax, fill.col=segment.col, side=1)
      ## LEFT
      draw.segment(store.grps[,"start"], store.grps[,"length"],
                   xymin=xymin, xymax=xymax, fill.col=segment.col, side=2)
    }
    if(!outer.box) {
      grid.rect(x=0, y=0,
                gp = gpar(fill=NA,col="white"),
                just=c("left","bottom"),
                width=1,height=1,
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp"))
    }
    if(inner.box) {
      grid.rect(x=xymin, y=xymin,
                gp = gpar(fill=NA,col="black"),
                just=c("left","bottom"),
                width=xymax, height=xymax,
                vp=vpPath("plot_01.toplevel.vp","plot_01.panel.1.1.vp"))
    }
  }
}

"hmmer" <- function(seq, type='phmmer', db=NULL, verbose=TRUE, timeout=90) {
  cl <- match.call()
    
  oopsa <- requireNamespace("XML", quietly = TRUE)
  oopsb <- requireNamespace("RCurl", quietly = TRUE)
  if(!all(c(oopsa, oopsb)))
     stop("Please install the XML and RCurl package from CRAN")
 
  seqToStr <- function(seq) {
    if(inherits(seq, "fasta"))
      seq <- seq$ali
    if(is.matrix(seq)) {
      if(nrow(seq)>1)
        warning(paste("Alignment with multiple sequences detected. Using only the first sequence"))
      seq <- as.vector(seq[1,!is.gap(seq[1,])])
    }
    else
      seq <- as.vector(seq[!is.gap(seq)])
    return(paste(seq, collapse=""))
  }
  
  alnToStr <- function(seq) {
    if(!inherits(seq, "fasta"))
      stop("seq must be of type 'fasta'")
    tmpfile <- tempfile()
    write.fasta(seq, file=tmpfile)
    rawlines <- paste(readLines(tmpfile), collapse="\n")
    unlink(tmpfile)
    return(rawlines)
  }
  
  types.allowed <- c("phmmer", "hmmscan", "hmmsearch", "jackhmmer")
  if(! type%in%types.allowed )
    stop(paste("Input type should be either of:", paste(types.allowed, collapse=", ")))

  ## PHMMER (protein sequence vs protein sequence database)
  ## seq is a sequence
  if(type=="phmmer") {
    seq <- seqToStr(seq)
    if(is.null(db))
      db="pdb"
    db.allowed <- c("env_nr", "nr", "refseq", "pdb", "rp15", "rp35", "rp55",
                    "rp75", "swissprot", "unimes", "uniprotkb",
                    "uniprotrefprot", "pfamseq")
    db <- tolower(db)
    if(!db%in%db.allowed)
      stop(paste("db must be either:", paste(db.allowed, collapse=", ")))
    
    seqdb <- db
    hmmdb <- NULL
    iter <- NULL
    rcurl <- TRUE
  }

  ## HMMSCAN (protein sequence vs profile-HMM database)
  ## seq is a sequence
  if(type=="hmmscan") {
    seq <- seqToStr(seq)
    if(is.null(db))
      db="pfam"
    db.allowed <- tolower(c("pfam", "gene3d", "superfamily", "tigrfam"))
    db <- tolower(db)
    if(!db%in%db.allowed)
      stop(paste("db must be either:", paste(db.allowed, collapse=", ")))
    
    seqdb <- NULL
    hmmdb <- db
    iter <- NULL
    rcurl <- TRUE
  }

  ## HMMSEARCH (protein alignment/profile-HMM vs protein sequence database)
  ## seq is an alignment
  if(type=="hmmsearch") {
    if(!inherits(seq, "fasta"))
      stop("please provide 'seq' as a 'fasta' object")
    
    ##alnfile <- tempfile()
    ##seq <- write.fasta(seq, file=alnfile)
    seq <- alnToStr(seq)

    if(is.null(db))
      db="pdb"
    db.allowed <- tolower(c("pdb", "swissprot"))
    db <- tolower(db)
    if(!db%in%db.allowed)
      stop(paste("db must be either:", paste(db.allowed, collapse=", ")))
    
    seqdb <- db
    hmmdb <- NULL
    iter <- NULL
    rcurl <- TRUE
  }

  ## JACKHMMER (iterative search vs protein sequence database)
  ## seq can be sequence, HMM, or multiple sequence alignment
  ## HMM not implemented here yet
  if(type=="jackhmmer") {
    if(!inherits(seq, "fasta"))
      stop("please provide 'seq' as a 'fasta' object")
    
    ##alnfile <- tempfile()
    ##seq <- write.fasta(seq, file=alnfile)
    seq <- alnToStr(seq)
    
    if(is.null(db))
      db="pdb"
    db.allowed <- tolower(c("pdb", "swissprot"))
    db.allowed <- c("env_nr", "nr", "refseq", "pdb", "rp15", "rp35", "rp55",
                    "rp75", "swissprot", "unimes", "uniprotkb",
                    "uniprotrefprot", "pfamseq")
    db <- tolower(db)
    if(!db%in%db.allowed)
      stop(paste("db must be either:", paste(db.allowed, collapse=", ")))

    seqdb <- db
    hmmdb <- NULL
    iter <- NULL
    rcurl <- TRUE
  }
  
  
  ## Make the request to the HMMER website
  ##url <- paste('http://hmmer.janelia.org/search/', type, sep="")
  url <- paste("https://www.ebi.ac.uk/Tools/hmmer/search/", type, sep="")
  curl.opts <- list(httpheader = "Expect:",
                    httpheader = "Accept:text/xml",
                    verbose = verbose,
                    followlocation = TRUE
                    )
    
  hmm <- RCurl::postForm(url, hmmdb=hmmdb, seqdb=seqdb, seq=seq, 
                  style = "POST",
                  .opts = curl.opts,
                  .contentEncodeFun=RCurl::curlPercentEncode, .checkParams=TRUE )

  ## check results from the server
  if(!grepl("results", hmm)) {
      if(verbose) {
          message("Content from HMMER server:")
          message("  ", hmm)
      }
      
      stop("Request to HMMER server failed")
  }
  
  add.pdbs <- function(x, ...) {
    hit <- XML::xpathSApply(x, '@*')
    pdbs <- unique(XML::xpathSApply(x, 'pdbs', XML::xmlToList))
    new <- as.matrix(hit, ncol=1)
    
    if(length(pdbs) > 1) {
      for(i in 1:length(pdbs)) {
        hit["acc"]=pdbs[i]
        new=cbind(new, hit)
      }
      colnames(new)=NULL
    }
    return(new)
  }

  ##fetch.pdbs <- function(x) {
  ##  unique(XML::xpathSApply(x, 'pdbs', XML::xmlToList))
  ##}

  ## workaround for 'act_site' tags that can not be parsed
  ## XML Parsing Error: not well-formed, e.g. for 1h1h_A
  ## type = hmmscan and pdb = pfam
  if(grepl("act_site", hmm)) {
      lines <- unlist(strsplit(hmm, "\n"))
      actsite.inds <- grep("act_site", lines)
      actlen <- length(actsite.inds)
      if(actlen>2) {
        if(actlen%%2 != 0) {
          stop("Bad XML format")
        }
        rm.inds <- NULL
        for(i in seq(1, actlen, 2)) {
          rm.inds <- c(rm.inds, seq(actsite.inds[i], actsite.inds[i+1]))
        }
        hmm <- paste(lines[-rm.inds], collapse="\n")
      }
      else {
         hmm <- paste(lines[-seq(actsite.inds[1], actsite.inds[2])],
                      collapse="\n")
      }
  }

  xml <- XML::xmlParse(hmm)
  resurl <- XML::xpathSApply(xml, '//data', XML::xpathSApply, '@*')
  resurl <- paste0("http://www.ebi.ac.uk/Tools/hmmer/results/", resurl["uuid", 1])
  data <- XML::xpathSApply(xml, '///hits', XML::xpathSApply, '@*')

  pdb.ids <- NULL
  if(db=="pdb") {
    tmp <- XML::xpathSApply(xml, '///hits', add.pdbs)
    data <- as.data.frame(tmp, stringsAsFactors=FALSE)
    colnames(data) <- NULL
  }

  data <- as.data.frame(t(data), stringsAsFactors=FALSE)
  data <- data[!duplicated(data$acc), ]
  ##rownames(data) <- data[, "acc"]
  
  ## convert to numeric
  fieldsToNumeric <- c("evalue", "pvalue", "score", "archScore", "ndom", "nincluded",
                       "niseqs", "nregions", "nreported", "bias", "dcl", "hindex")
  inds <- which(names(data) %in% fieldsToNumeric)
  
  for(i in 1:length(inds)) {
    tryCatch({
      data[[inds[i]]] = as.numeric(data[[inds[i]]])
    },
    warning = function(w) {
      #print(w)
      return(data[[inds[i]]])
    },
    error = function(e) {
      #print(e)
      return(data[[inds[i]]])
    }
    )
  }

  data$pdb.id <- data$acc
  data$bitscore <- data$score
  data$mlog.evalue <- -log(data$evalue)
  data$mlog.evalue[is.infinite(data$mlog.evalue)] <- -log(.Machine$double.xmin)

  out <- list(hit.tbl = data,
              url = resurl)
  
  ##class(data) <- c("hmmer", type, "data.frame")
  class(out) <- c("hmmer", type)
  return(out)
}

"convert.pdb" <-
function(pdb, type = c("original", "pdb", "charmm", "amber", "gromacs"),
         renumber=FALSE, first.resno=1, first.eleno=1,
         consecutive=TRUE,
         rm.h=TRUE, rm.wat=FALSE, verbose=TRUE) {

  ##-- Check the requested output format is one of 'type.options' 
  type <- match.arg(type)

  ##-- Water and hydrogen removal
  inds <- NULL
  if(rm.wat) {
    inds <- atom.select(pdb, "notwater", verbose=FALSE)
    if(verbose){
      cat(paste("\t Retaining", length(inds$atom),"non-water atoms\n"))
    }
  }
  if(rm.h) {
    inds <- combine.select(inds, atom.select(pdb, "noh", verbose=FALSE), verbose=FALSE) 
    if(verbose){
      cat(paste("\t Retaining", length(inds$atom),"non-hydrogen atoms\n"))
    } 
  }
  if(!is.null(inds)){
    nrm <- nrow(pdb$atom) - length(inds$atom)
    if( nrm > 0) {  
      if(verbose){
        cat(paste("\t Removing a total of", nrm," atoms\n"))
      } 
      pdb <- trim.pdb(pdb, inds)
    }
  }

  
  ##-- Renumbering of residues and atoms
  if(renumber) {
    if(verbose){
      cat(paste("\t Renumbering residues ( from",first.resno,") and atoms ( from",first.eleno,")\n"))
    } 

    ## Assign consecutive atom numbers 
    pdb$atom[,"eleno"] <- seq(first.eleno, length=nrow(pdb$atom))

    ## Determine chain start and end indices
    s.ind <- which(!duplicated(pdb$atom[,"chain"]))
    e.ind   <- c(s.ind[-1]-1, nrow(pdb$atom))

    ##- Assign new (consecutive) residue numbers for each chain
    prev.chain.res = 0  ## Number of residues in previous chain
    for (i in 1:length(s.ind)) {
      ## Combination of resno and insert code define a residue (wwpdb.org)
      insert = pdb$atom[s.ind[i]:e.ind[i], "insert"]
      insert[is.na(insert)] = ""
      resno0 <- paste0(pdb$atom[s.ind[i]:e.ind[i], "resno"], insert)

      ## Ordered table of residue occurrences
      tbl <- table(resno0)[unique(resno0)]
      n.chain.res <- length(tbl)


      new.nums <- (first.resno+prev.chain.res):(first.resno+n.chain.res-1+prev.chain.res)
      pdb$atom[s.ind[i]:e.ind[i],"resno"] <- rep(new.nums, tbl)

      ## SSE
      if(length(pdb$helix)>0) {
#         chs = unique(pdb$helix$chain)
         ch = pdb$atom$chain[s.ind][i]
         if(ch %in% pdb$helix$chain) {
            h.start <- pdb$helix$start[pdb$helix$chain %in% ch]
            h.insert <- names(h.start)
            t.inds = match(paste0(h.start, h.insert), unique(resno0))
            pdb$helix$start[pdb$helix$chain %in% ch] = new.nums[t.inds]

            h.end <- pdb$helix$end[pdb$helix$chain %in% ch]
            h.insert <- names(h.end)
            t.inds = match(paste0(h.end, h.insert), unique(resno0))
            pdb$helix$end[pdb$helix$chain %in% ch] = new.nums[t.inds]
         }
      }

      if(length(pdb$sheet)>0) {
#         chs = unique(pdb$sheet$chain)
         ch = pdb$atom$chain[s.ind][i]
         if(ch %in% pdb$sheet$chain) {
            s.start <- pdb$sheet$start[pdb$sheet$chain %in% ch]
            s.insert <- names(s.start)
            t.inds = match(paste0(s.start, s.insert), unique(resno0))
            pdb$sheet$start[pdb$sheet$chain %in% ch] = new.nums[t.inds]
            
            s.end <- pdb$sheet$end[pdb$sheet$chain %in% ch]
            s.insert <- names(s.end)
            t.inds = match(paste0(s.end, s.insert), unique(resno0))
            pdb$sheet$end[pdb$sheet$chain %in% ch] = new.nums[t.inds]
         }
      }
    
      if(consecutive) {
        ## Update prev.chain.res for next iteration 
        prev.chain.res = prev.chain.res + n.chain.res
      }
    }
    
    ## clean up 'insert'
    pdb$atom$insert <- as.character(NA)
    if(length(pdb$helix)>0) {
      names(pdb$helix$start) <- NULL
      names(pdb$helix$end) <- NULL
    }
    if(length(pdb$sheet)>0) {
      names(pdb$sheet$start) <- NULL
      names(pdb$sheet$end) <- NULL
    }
  }


  ##-- Format conversion
  if(type != "original") {
    if(verbose){
      cat(paste0("\t Converting to '", type, "' format\n"))
    }
    ## residue and atom types from PDB
    restype <- unique(pdb$atom[,"resid"])

    #eletype <- unique(pdb$atom[,"elety"])
    ## In future could determine 'input type' based on resid/elety

    ##- Check for non-standard residue names
    if(verbose){
      not.prot.inds <- atom.select(pdb, "notprotein", verbose=FALSE)$atom
      if(length(not.prot.inds) > 0) { 
        not.prot.res <- paste(unique(pdb$atom[not.prot.inds, "resid"]), collapse = " ")
        cat(paste("\t Non-standard residue names present (",not.prot.res,")\n") )
      }
    }

    ##- Convert HIS resid
    his <- matrix( c("HIS", "HSD", "HID","HISA",
                     "HIS", "HSE", "HIE","HISB",
                     "HIS", "HSP", "HIP","HISH"),
                  nrow=3, byrow=TRUE,
                  dimnames = list(c("d","e","b"),
                    c("pdb","charmm","amber","gromacs")) )
  
    type.inds <-  (colnames(his) %in% type)
    conv.inds <- !(colnames(his) %in% c(type,"pdb"))

    his.d.ind <- (pdb$atom[,"resid"] %in% his["d", !type.inds ])
    his.e.ind <- (pdb$atom[,"resid"] %in% his["e", conv.inds ])
    his.b.ind <- (pdb$atom[,"resid"] %in% his["b", conv.inds ])
  
    pdb$atom[his.d.ind,"resid"] <- his["d", type.inds ]
    pdb$atom[his.e.ind,"resid"] <- his["e", type.inds ]
    pdb$atom[his.b.ind,"resid"] <- his["b", type.inds ]

    ##- Convert ILE CD1 to CD elety and remove chainID
    if (type=="charmm") {
      ile.ind <- atom.select(pdb, resid="ILE", elety="CD1", verbose=FALSE)$atom
      pdb$atom[ile.ind,"elety"] <- "CD"

      pdb$atom[,"chain"]=NA ## strip chain ID

      ## Could also add a SEGID via call to chain.pdb() function
      pdb$atom[,"segid"] <- chain.pdb(pdb)

    } else {
      ile.ind <- atom.select(pdb, resid="ILE", elety="CD", verbose=FALSE)$atom
      pdb$atom[ile.ind,"elety"] <- "CD1"
    }
  } ## END type != "original" (conversion)
  

  ##-- Convert hydrogen atom types (unfinished!)
  if(!rm.h) { 
    if(type=="pdb") {  
      pdb$atom[ pdb$atom[,"elety"]=="HN", "elety"] = "H"
      ###!!! ADD Many MORE ATOM TYPE CONVERSIONS HERE !!!###
    }
    if(verbose){
      warning(paste("\t Additional hydrogen elety names may need converting.",
                    "\t   N.B. It is often best to remove hydrogen (rm.h=TRUE)", 
                    "\t        before building systems for simulation",sep="\n"))
    }  
    ## Add other atom name conversions here as the need arises...

  } 

  return(pdb)
}

bhattacharyya <- function(...)
  UseMethod("bhattacharyya")

bhattacharyya.nma <- function(...)
  bhattacharyya.matrix(...)

bhattacharyya.pca <- function(...)
  bhattacharyya.matrix(...)

bhattacharyya.enma <- function(enma, covs=NULL, ncore=NULL, ...) {
  if(!inherits(enma, "enma"))
    stop("provide a 'enma' object as obtain from function 'nma.pdbs()'")
  if(any(is.na(enma$fluctuations)))
    stop("provide 'enma' object calculated with argument 'rm.gaps=TRUE'")
  
  if(is.null(covs)) {
    cat("Calculating covariance matrices")
    covs <- cov.enma(enma, ncore=ncore)
  }
  cat("Calculating pairwise bhattacharyya coefs")
  sim.mat <- bhattacharyya.array(covs, ncore=ncore)
  
  rownames(sim.mat) <- basename(rownames(enma$fluctuations))
  colnames(sim.mat) <- basename(rownames(enma$fluctuations))
  return(sim.mat)
}

bhattacharyya.matrix <- function(a, b, q=90, n=NULL, ...) {

  if(!is.matrix(a) & is.matrix(b))
    stop("provide covariance matrices")
  
  a <- ((1 / .tr(a)) * a)*1000
  b <- ((1 / .tr(b)) * b)*1000
  ei <- eigen( (a + b)/2  )

  if(is.null(n)) {
    percent <- (ei$values/sum(ei$values))*100
    cumv <- cumsum(percent)
    n <- which(cumv>q)[1]
  }

#  ca <- det((t(ei$vectors[,1:n]) %*% a) %*% ei$vectors[,1:n])
#  cb <- det((t(ei$vectors[,1:n]) %*% b) %*% ei$vectors[,1:n])

#  d <- prod(ei$values[1:n])

  ## use logarithm to avoid numerical underflow 
  log.ca <- determinant((t(ei$vectors[,1:n]) %*% a) %*% ei$vectors[,1:n])$modulus
  log.cb <- determinant((t(ei$vectors[,1:n]) %*% b) %*% ei$vectors[,1:n])$modulus
  log.ca <- as.numeric(log.ca); log.cb <- as.numeric(log.cb)
  log.d <- sum(log(ei$values[1:n]))
  
#  ndb <- (1/(2*n)) * log( d / sqrt(ca*cb) )
  ndb <- (1/(2*n)) * ( log.d - 0.5 * (log.ca + log.cb) )
  bc <- exp( -ndb )
  return(bc)
}

bhattacharyya.array <- function(covs, ncore=NULL, ...) {
  ncore <- setup.ncore(ncore, bigmem = FALSE)

  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply

  dims <- dim(covs)
  m <- dims[3]
  
  mat <- matrix(NA, m, m)
  ##inds <- pairwise(m)
  inds <- rbind(pairwise(m),
                matrix(rep(1:m,each=2), ncol=2, byrow=T))
                
  mylist <- mylapply(1:nrow(inds), function(row) {
    i <- inds[row,1]; j <- inds[row,2];
    val <- bhattacharyya.matrix(covs[,,i], covs[,,j], ...)
    out <- list(val=val, i=i, j=j)
    cat(".")
    return(out)
  })
  
  for ( i in 1:length(mylist)) {
    tmp <- mylist[[i]]
    mat[tmp$i, tmp$j] <- tmp$val
  }

  mat[ inds[,c(2,1)] ] = mat[ inds ]
  ##diag(mat) <- rep(1, n)
  
  cat("\n")
  return(round(mat, 6))
}

pymol.nma <- function(...)
  pymol.modes(...)

pymol.pca <- function(...)
  pymol.modes(...)

pymol.modes <- function(modes, mode=NULL, file=NULL, scale=5, dual=FALSE,
                      type="script", exefile = "pymol", ...) {

  if(! (inherits(modes, "nma") || inherits(modes,"pca")) )
    stop("must supply a 'nma' or 'pca' object, i.e. from 'nma()' or 'pca.xyz()'")
  
  allowed <- c("session", "script", "launch")
  if(!type %in% allowed) {
    stop(paste("input argument 'type' must be either of:",
               paste(allowed, collapse=", ")))
  }
    
    ## Check if the program is executable
    if(type %in% c("session", "launch")) {
        
        ## determine path to exefile
        exefile1 <- .get.exepath(exefile)
        
        ## Check if the program is executable
        success <- .test.exefile(exefile1)
        
        if(!success) {
            stop(paste("Launching external program failed\n",
                       "  make sure '", exefile, "' is in your search path", sep=""))
        }
        exefile <- exefile1
    }
    
  if(inherits(modes, "nma")) {
    if(is.null(mode))
      mode <- 7
    xyz <- modes$xyz
    mode.vecs <- matrix(modes$modes[,mode], ncol=3, byrow=T)
  }
  else {
    if(is.null(mode))
      mode <- 1
    xyz <- modes$mean
    mode.vecs <- matrix(modes$U[,mode], ncol=3, byrow=T)
  }
  
  ## calc all vec lengths (for coloring later)
  all.lens <- apply(mode.vecs, 1, function(x) sqrt(sum(x**2)))

  ## output file name
  if(is.null(file)) {
    if(type=="session")
      file <- "R.pse"
    if(type=="script")
      file <- "R.py"
  }
  
  ## use temp-dir unless we output a PML script
  if(type %in% c("session", "launch"))
    tdir <- tempdir()
  else
    tdir <- "."

  pyfile <- tempfile(tmpdir=tdir, fileext=".py")
  psefile <- tempfile(tmpdir=tdir, fileext=".pse")
  pdbfile <- tempfile(tmpdir=tdir, fileext=".pdb")
  
  ## start building pymol script
  scr <- c("from pymol import cmd")
  scr <- c(scr, "from pymol.cgo import *")
  scr <- c(scr, paste("cmd.load('", 
    normalizePath(pdbfile, winslash='/', mustWork=FALSE),
    "', 'prot')", sep=""))
  scr <- c(scr, "cmd.show('cartoon')")
  scr <- c(scr, "cmd.set('cartoon_trace_atoms', 1)")
      
  ## define color range 
  blues <- colorRamp(c("blue", "white", "red"))

  ## Arrow widths
  w.body <- 0.15; w.head <- 0.2

  scr <- c(scr, "obj=[]")
  for ( i in 1:nrow(mode.vecs)) {
    inds    <- atom2xyz(i) 
    coords  <- xyz[inds]
    
    ## For coloring (longest vec has length=1)
    tmp.len <- sqrt(sum((mode.vecs[i,]/max(all.lens))**2))
    if(tmp.len>1)
      tmp.len <- 1
    
    col <- blues(tmp.len)
    col <- round(col/256,4)
    col <- paste(col, collapse=", ")
    
    ## Main vector
    tmp.vec <- mode.vecs[i,] * scale
    
    ## For arrow head
    if(sqrt(sum(tmp.vec**2))<1)
      norm.vec <-  tmp.vec
    else
      norm.vec <- normalize.vector(mode.vecs[i,])
    
    ## Set vectors
    arrow.vec.a <- (coords + tmp.vec)
    head.vec.a  <- (arrow.vec.a + (norm.vec))
    
    arrow.vec.b <- (coords - tmp.vec)
    head.vec.b <- (arrow.vec.b - (norm.vec))
    
    a  <- paste(coords,      collapse=",")
    b1 <- paste(arrow.vec.a, collapse=",")
    c1 <- paste(head.vec.a,  collapse=",")
    b2 <- paste(arrow.vec.b, collapse=",")
    c2 <- paste(head.vec.b,  collapse=",")
    
    
    ## Arrow body
    scr <- c(scr, paste("obj.extend([CYLINDER", a, b1, w.body, col, col, "])", sep=", "))
    if(dual)
      scr <- c(scr, paste("obj.extend([CYLINDER", a, b2, w.body, col, col, "])", sep=", "))
    
    ## Arrow heads
    scr <- c(scr, paste("obj.extend([CONE", b1, c1, w.head, 0.0, col, col, 1.0, 1.0,"])", sep=", "))
    if(dual)
      scr <- c(scr, paste("obj.extend([CONE", b2, c2, w.head, 0.0, col, col, 1.0, 1.0,"])", sep=", "))
  }
  
  name <- "vecs"
  scr <- c(scr, paste("cmd.load_cgo(obj, '", name, "')", sep=""))

  if(type == "session")
    scr <- c(scr, paste0("cmd.save('", 
      normalizePath(psefile, winslash='/', mustWork=FALSE),
      "')"))
   
  ## Write PDB structure file
  write.pdb(xyz=xyz, file=pdbfile)
  
  ## Write python script or PDB with conect records
  write(scr, file=pyfile, sep="\n")

  if(type %in% c("session", "launch")) {
    if(type == "session")
      args <- "-cq"
    else
      args <- ""
    
    ## Open pymol
    cmd <- paste(exefile, args, pyfile)
    
    os1 <- Sys.info()["sysname"]
    if (os1 == "Windows") {
        status <- shell(paste(shQuote(exefile), args, pyfile))
    }
    else {
        status <- system(cmd)
    }
    
    if(!(status %in% c(0,1))) {
        stop(paste("An error occurred while running command\n '",
                   exefile, "'", sep=""))
    }

  }

  if(type == "session") {
    file.copy(psefile, file, overwrite=TRUE)
    message(paste("PyMOL session written to file", file))
    invisible(file)
  }
  
  if(type == "script") {
    file.copy(pyfile, file, overwrite=TRUE)
    unlink(pyfile)
    message(paste("PyMOL script written to file", file))
    invisible(file)
  }

  
}

"write.crd" <-
function(pdb = NULL, xyz = pdb$xyz, resno = NULL, resid = NULL,
                      eleno = NULL, elety = NULL, segid = NULL, resno2 = NULL,
                      b = NULL, verbose = FALSE, file = "R.crd") {
  
    if (is.null(xyz) || !is.numeric(xyz))
        stop("write.crd: please provide a 'pdb' object or numeric 'xyz' coordinates")
    if (any(is.na(xyz)))
        stop("write.crd: 'xyz' coordinates must have no NA's.")
    if (is.matrix(xyz) && nrow(xyz) == 1) xyz = as.vector(xyz)
    if (is.vector(xyz)) {
        natom <- length(xyz)/3
    } else {
      stop("write.crd: 'xyz' or 'pdb$xyz' must contain only one structure")
    }

    if (!is.null(pdb)) {
        if (is.null(resno))
          resno = pdb$atom[, "resno"]
        if (is.null(resid))
          resid = pdb$atom[, "resid"]
        if (is.null(eleno))
          eleno = pdb$atom[, "eleno"]
        if (is.null(elety))
          elety = pdb$atom[, "elety"]
        if (is.null(segid)) 
          segid = pdb$atom[, "chain"]
        if (is.null(resno2)) 
          resno2 = pdb$atom[, "resno"]
        if (is.null(b)) 
          b = pdb$atom[, "b"]
    } else {
      if (is.null(resno))
        resno = c(1:natom)
      if (is.null(resno2))
        resno2 = c(1:natom)
      if (is.null(resid))
        resid = rep("ALA", natom)
      if (is.null(eleno))
        eleno = c(1:natom)
      if (is.null(elety))
        elety = rep("CA", natom)
      if (is.null(segid))
        segid = rep("seg", natom)
      if (is.null(b))
        b = rep("0.00", natom)
    }
    if (length(as.vector(xyz))%%3 != 0) {
        stop("write.crd: 'length(xyz)' must be divisable by 3.")
    }
    check.lengths <- sum(length(resno), length(resid), length(eleno),
                         length(elety), length(resno2))
    if (check.lengths%%natom != 0) {
      stop("write.crd: the lengths of all input vectors != 'length(xyz)/3'.")
    }
    b <- as.numeric(b)
    eleno <- as.character(eleno)
    resno <- as.character(resno)
    resno2 <- as.character(resno2)
    
    crd.print <- function(eleno, resno, resid, elety,
                          x, y, z, segid="seg", resno2, b="0.00") {
      format <- "%5s%5s%4s  %-4s%10.5f%10.5f%10.5f %-4s %-4s%10.5f"
      sprintf(format, eleno, resno, resid, elety, x, y, z, segid, resno2, b)
    }
    coords <- matrix(round(as.numeric(xyz), 3), ncol = 3, byrow = TRUE)
    if (verbose)
      cat(paste("Writing CRD file with", natom, "atoms "))
    
    lines <- NULL
    for (i in 1:natom) {
      lines <- rbind(lines, crd.print(
                    eleno = eleno[i], resno = resno[i], resid = resid[i],
                    elety = elety[i], 
                    x = coords[i,1], y = coords[i, 2], z = coords[i, 3],
                    segid = segid[i], resno2 = resno2[i], b = b[i]))
    }
    cat("* CRD from bio3d", file = file, "\n")
    cat("*", file = file, "\n", append = TRUE)
    cat(sprintf("%5g", natom), file = file, "\n", append = TRUE)
    cat(lines, file = file, sep = "\n", append = TRUE)
    if (verbose)
      cat(" DONE", "\n")
}

"atom.select.prmtop" <- function(prmtop, ...) {
  if(!inherits(prmtop, "prmtop"))
    stop("provide a PRMTOP object as obtained from read.prmtop()")

  cl <- match.call()
  tmp.pdb <- as.pdb.prmtop(prmtop, crd=as.numeric(rep(NA, prmtop$POINTERS[1]*3)))
  sele <- atom.select.pdb(tmp.pdb, ...)
  sele$call <- cl
  return(sele)
}

## Useful for checking the connectivity in a pdb(s) object

"inspect.connectivity" <- function(pdbs, cut=4.) {
  xyz <- NULL; ids <- NULL;
  if(inherits(pdbs, "pdbs")) {
    xyz <- pdbs$xyz
    n <- length(pdbs$id)
    ids <- pdbs$id
  }
  else if(is.pdb(pdbs)) {
    ca.inds <- atom.select(pdbs, 'calpha', verbose=FALSE)
    xyz <- as.xyz(pdbs$xyz)[1, ca.inds$xyz, drop=FALSE]
    n <- 1
  }
  else if(inherits(pdbs, "xyz")) {
    xyz <- pdbs
    n <- nrow(xyz)
  }
  else {
    stop("Please provide coordinates as a \n 'pdbs', 'pdb', or xyz matrix format")
  }

  if(length(xyz)<6) {
    warning("Insufficient C-alpha atoms in structure to determine connectivity")
    return(FALSE)
  }

  is.connected <- function(xyz) {
    xyz <- matrix(xyz[!is.na(xyz)], ncol=3, byrow=T)
    for(i in 1:(nrow(xyz)-1)) {
      d <- sqrt((xyz[i,1]-xyz[i+1,1])**2 +
                (xyz[i,2]-xyz[i+1,2])**2 +
                (xyz[i,3]-xyz[i+1,3])**2 )

      if(d>cut)
        return(FALSE)
    }
    return(TRUE)
  }

  cons <- rep(NA, length=n)
  for(i in 1:n) {
    cons[i] <- is.connected(xyz[i,])
  }

  names(cons) <- ids
  return(cons)
}

uniprot <- function(accid) {
  oops <- requireNamespace("XML", quietly = TRUE)
  if(!oops)
    stop("Please install the XML package from CRAN")
  
  url <- paste('http://www.uniprot.org/uniprot/', accid, '.xml', sep="")

  tmpfile <- tempfile()
  download.file(url, tmpfile) ##, method="wget")
  xml <- XML::xmlRoot(XML::xmlParse(tmpfile))
  
  node.names <- XML::xmlSApply(xml[[1]], XML::xmlName)
  
  ## acession
  inds <- which(node.names=="accession")
  accession <- NULL
  for(i in 1:length(inds))
    accession <- c(accession, XML::xmlValue(xml[[1]][[inds[i]]]))
    
  ## and name
  inds <- which(node.names=="name")
  name <- NULL
  for(i in 1:length(inds))
    name <- c(name, XML::xmlValue(xml[[1]][[inds[i]]]))
  
  ## sequence
  inds <- which(node.names=="sequence")
  sequence <-  gsub("\n", "", XML::xmlValue(xml[[1]][[inds]]))
  
  ## organism
  inds <- which(node.names=="organism")
  node <- xml[[1]][[inds]]
  organism <- NULL
  tmpl <- unlist(XML::xmlApply(node, XML::xmlAttrs))
  if("scientific" %in% tmpl)
      organism <- XML::xmlValue(node[[which(tmpl %in% "scientific")]])
  if("common" %in% tmpl)
      organism <- c(organism, XML::xmlValue(node[[which(tmpl %in% "common")]]))
    
  ## taxon
  inds <- which(node.names=="organism")
  node <- xml[[1]][[inds]]
  taxon <- NULL
  for ( i in 1:XML::xmlSize(node[['lineage']]) ) {
    taxon <- c(taxon, XML::xmlValue(node[['lineage']][[i]]))
  }
  
  ## protein
  node <- xml[[1]][['protein']]
  fullName <- XML::xmlValue(node[['recommendedName']][['fullName']])
  shortName <- XML::xmlValue(node[['recommendedName']][['shortName']])
  
  ## gene
  node <- xml[[1]][['gene']]
  gene <- XML::xmlValue(node[[1]])

  ## dbReference
  inds <- which(node.names=="dbReference")
  dbref <- list()
  for(i in 1:length(inds)) {
      node <- xml[[1]][[inds[i]]]
      dbref[[i]] <- XML::xmlAttrs(node)
  }
  
  dbref <- unlist(dbref)
  type.inds <- names((dbref)) == "type"
  id.inds <- names((dbref)) == "id"
  dbref <- data.frame(type=dbref[type.inds], id=dbref[id.inds],
                      stringsAsFactors=FALSE)
  
  out <- list(accession = accession, name = name,
              fullName = fullName, shortName = shortName,
              sequence = sequence, gene = gene,
              organism = organism, taxon = taxon,
              dbref=dbref)
  
  return(out)
}

"normalize.vector" <-
  function(x, mass=NULL) {
    x <- as.matrix(x);
    dx <- dim(x); 
    
    if(dx[2]==1)
      x <- as.numeric(x)
    
    if(!is.null(mass)) {
      if (dx[1] != (length(mass)*3))
        stop("normalize.vector: incorrect length of mass")
    }

    if(is.matrix(x))
      return(t( t(x) / sqrt(inner.prod(x,x,mass))))
    else
      return(x / sqrt(inner.prod(x,x,mass))) 
  }

community.tree <- function(x, rescale=FALSE){

  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }

  if(!inherits(x, "cna")){
    stop("Input should be a 'cna' class object as obtained from cna()")
  }

  rescaling <- function(membership){
    original.comms <- unique(membership)
    new.comms <- c(1:length(unique(membership)))
      
    a<-1  ## index to keep track of community number
    for(j in 1:length(membership)){
      membership[membership == original.comms[a]] <- new.comms[a]
      a <- a +1
    }
    return(membership)
  }
  
  num.of.nodes <- length(igraph::V(x$network))
  membership <- c(1:num.of.nodes)

  merge.table <- x$communities$merges

  membership.table <- matrix(NA, nrow=dim(merge.table)[1]+1, ncol=num.of.nodes)

  membership.table[1,] <- c(1:num.of.nodes)
  num.of.comms <- c(num.of.nodes, rep(NA,dim(merge.table)[1]))
  
  for(i in 1:dim(merge.table)[1]){
    comm.number <- num.of.nodes + i

    if(merge.table[i,1] < num.of.nodes){
      membership[merge.table[i,1]] <- comm.number
    }
    else{
      change.inds <- which(membership == merge.table[i,1])
      membership[change.inds] <- comm.number
    }
 
    if(merge.table[i,2] < num.of.nodes){
      membership[merge.table[i,2]] <- comm.number
    }
    else{
      change.inds <- which(membership == merge.table[i,2])
      membership[change.inds] <- comm.number
    }

    membership.table[i+1,] <- membership  ## i+1 because the first line is where each node forms a separated community (it will match also the modularity values)
    num.of.comms[i+1] <- length(unique(membership))
  }

  ## Rescale community number starting from 1
  if(rescale){
    membership.table <- t(apply(membership.table,1,rescaling))
  }
  
  output <- list("tree" = membership.table,
                 "modularity" = x$communities$modularity,
                 "num.of.comms" = num.of.comms)

  return(output)
}

#' Plot Residue-Residue Matrix Loadings 
#'
#' Plot residue-residue matrix loadings of a particular PC that is obtained from a 
#' principal component analysis (PCA) of cross-correlation or distance matrices.
#'
#' The function plots loadings (the eigenvectors) of PCA performed on a set of matrices 
#' such as distance matrices from an ensemble of crystallographic structures 
#' and residue-residue cross-correlations or covariance matrices derived from 
#' ensemble NMA or MD simulation replicates (See \code{\link{pca.array}} for detail). 
#' Loadings are displayed as a matrix with dimension the same as the input matrices 
#' of the PCA. Each element of loadings represents the proportion that the corresponding 
#' residue pair contributes to the variance in a particular PC. The plot can be used 
#' to identify key regions that best explain the variance of underlying matrices.
#'
#' @param x the results of PCA as obtained from \code{\link{pca.array}}. 
#' @param pc the principal component along which the loadings will be shown. 
#' @param resno numerical vector or \sQuote{pdb} object as obtained from \code{\link{read.pdb}}
#'    to show residue number on the x- and y-axis. 
#' @param sse a \sQuote{sse} object as obtained from \code{\link{dssp}} or \code{\link{stride}}, 
#'    or a \sQuote{pdb} object as obtained from \code{\link{read.pdb}} to show secondary
#'    structural elements along x- and y-axis.
#' @param mask.n the number of elements from the diagonal to be masked from output. 
#' @param plot logical, if FALSE no plot will be shown.
#' @param ... additional arguments passed to \code{\link{plot.dccm}}.
#'
#' @return Plot and also returns a numeric matrix containing the loadings.
#'
#' @seealso 
#'      \code{\link{plot.dccm}}, \code{\link{pca.array}}
#'
#' @author Xin-Qiu Yao
#' 
#' @references 
#'    Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
#'    Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
#' 
#' @examples
#' \dontrun{
#'    attach(transducin)
#'    gaps.res <- gap.inspect(pdbs$ali)
#'    sse <- pdbs$sse[1, gaps.res$f.inds]
#'
#'    # calculate modes
#'    modes <- nma(pdbs, ncore=NULL)
#'
#'    # calculate cross-correlation matrices from the modes
#'    cijs <- dccm(modes, ncore=NULL)$all.dccm
#'
#'    # do PCA on cross-correlation matrices
#'    pc <- pca.array(cijs)
#'
#'    # plot loadings
#'    l <- plot.matrix.loadings(pc, sse=sse)
#'    l[1:10, 1:10]
#'
#'    # plot loadings with elements 10-residue separated from diagonal masked
#'    plot.matrix.loadings(pc, sse=sse, mask.n=10)
#'
#' }
plot.matrix.loadings <- function(x, pc=1, resno=NULL, sse=NULL, mask.n=0, plot=TRUE, ...) {
   
   if(!inherits(x, 'pca') && grepl('pca.array', x$call))
      stop('Input x must be a "pca" object obtained from "pca.array()".')

   args.plot.dccm <- formals(plot.dccm)
   dots <- list(...)
#   args <- dots[names(dots) %in% names(args.plot.dccm)]
   args <- dots
   if('segment.min' %in% names(dots))
      segment.min <- dots$segment.min
   else
      segment.min <- args.plot.dccm$segment.min
   if('show' %in% names(dots))
      show <- dots$show
   else
      show <- as.character(args.plot.dccm$show)[2]
   if(is.na(show)) show <- 'full'
   if(!'main' %in% names(args))
     args$main <- paste('Loadings of PC ', pc, 
       ' (', round(x$L[pc]/sum(x$L)*100, 1), '%)', sep='')

   ## compute the dim of matrix
   M <- nrow(x$U)
   N <- (1 + sqrt(1 + 8*M)) / 2
   is.wholenumber <-
      function(x, tol = .Machine$double.eps^0.5)  abs(x - round(x)) < tol
   if(!is.wholenumber(N))
      stop('Wrong dimension of eigenvectors detected. Check the input x.')

   if(is.null(resno)) resno <- 1:N
   if(is.pdb(sse)) {
    sse <- unname(pdb2sse(sse))
   }
   else if(inherits(sse, 'sse')) {
    if(!is.null(sse$sse)) sse <- unname(sse$sse)
   }
   if(is.character(sse)) sse <- bounds.sse(sse)
   
   args$resno <- resno
   args$sse <- sse
   
   ## normalize
   x$U[, pc] <- x$U[, pc] / max(abs(x$U[, pc]))

   lmat <- matrix(0, N, N)
   lmat[upper.tri(lmat)] <- x$U[, pc]
   lmat[lower.tri(lmat)] <- t(lmat)[lower.tri(lmat)]
  
   ## mask diag 
   tmat <- matrix(1, N, N)
   tmat[diag.ind(tmat, n=mask.n)] <- 0
   tmat[lower.tri(tmat)] <- t(tmat)[lower.tri(tmat)]
   lmat <- lmat * as.vector(tmat)
  
   args$x <- lmat

   if(plot) {
     do.call(plot.dccm, args)

     ## add grids
     draw.sse.grid <- function(sse) {
        # vertical
        grid.segments( x0 = sse$start,
                       y0 = switch(show, full=1, upper=N, lower=1),
                       x1 = sse$start,
                       y1 = switch(show, full=N, upper=sse$start, lower=sse$start),
                       gp=gpar(col="gray80", lty=2, lwd=0.3), default.units = "native",
                       vp=vpPath("plot_01.toplevel.vp", "plot_01.panel.1.1.vp") )
        # horizental
        grid.segments( x0 = switch(show, full=1, upper=1, lower=N),
                       y0 = sse$start,
                       x1 = switch(show, full=N, upper=sse$start, lower=sse$start),
                       y1 = sse$start,
                       gp=gpar(col="gray80", lty=2, lwd=0.3), default.units = "native",
                       vp=vpPath("plot_01.toplevel.vp", "plot_01.panel.1.1.vp") )
     }

     if(!is.null(sse)) {
     	  if(length(sse$helix$start) > 0) {
          ## dont have a pdb$helix$length
          if( is.null(sse$helix$length) )
            sse$helix$length <- (sse$helix$end+1)-sse$helix$start

            inds <- which(sse$helix$length >= segment.min)
  #          sse$helix$start <- match(sort(sse$helix$start[inds]), resno)
  #          sse$helix$end <- match(sort(sse$helix$end[inds]), resno)
            draw.sse.grid(sse$helix)
        }
        if(length(sse$sheet$start) > 0) {
          ## dont have a pdb$sheet$length
          if( is.null(sse$sheet$length) )
            sse$sheet$length <- (sse$sheet$end+1)-sse$sheet$start

            inds <- which(sse$sheet$length >= segment.min)
  #          sse$sheet$start <- match(sort(sse$sheet$start[inds]), resno)
  #          sse$sheet$end <- match(sort(sse$sheet$end[inds]), resno)
            draw.sse.grid(sse$sheet)
        }
     }
   }
   invisible( lmat )
}

print.core <- function(x, vol=NULL, ...) {

  cv <- x$volume; cv[is.na(cv)]=min(cv,na.rm=TRUE)
  cl <- x$length; cl[is.na(cl)]=min(cl,na.rm=TRUE)
  ca <- NULL; cx <- NULL; cr <- NULL

  if(is.null(vol))
    vol <- 1

  ind <- (cv<=vol)
  ca <- sort(x$step.inds[ind])
  cx <- atom2xyz(ca)
  cr <- sort(x$resno[ind])
  nc <- length(ca)
  
  cat(paste("#",nc,
            "positions (cumulative volume <=",
            vol,"Angstrom^3)"),"\n")
  if(nc==0) {
    cat(paste("# Min volume is",round(min(cv),3)),"\n")
  } else {
    print(bounds(as.numeric(cr)), ...)  
  }
  ##NextMethod("print", x, quote = FALSE, right = TRUE, ...)
  invisible(list(atom=ca, xyz=cx, resno=cr))
}

core.find <- function(...)
  UseMethod("core.find")

core.find.default <- function(xyz, ...)
  core.find.pdbs(xyz, ...)

core.find.pdb <- function(pdb, verbose=TRUE, ...) {
  if(nrow(pdb$xyz)<4)
    stop("provide a multi model PDB file with 4 or more frames")

  inds1 <- atom.select(pdb, "calpha", verbose=verbose)
  inds2 <- atom.select(pdb, "nucleic", elety="P", verbose=verbose)
  inds <- combine.select(inds1, inds2, operator="OR", verbose=verbose)

  tmp <- trim.pdb(pdb, inds)
  core <- core.find.pdbs(tmp$xyz, verbose=verbose, ...)

  ## map to pdb inds
  full.ids <- paste(pdb$atom$elety, pdb$atom$resno, pdb$atom$chain, sep="-")
  tmp.ids  <- paste(tmp$atom$elety, tmp$atom$resno, tmp$atom$chain, sep="-")

  core$step.inds  <- which(full.ids %in% tmp.ids[core$step.inds])[core$step.inds]
  core$atom       <- which(full.ids %in% tmp.ids[core$atom])
  core$c1A.atom   <- which(full.ids %in% tmp.ids[core$c1A.atom])
  core$c0.5A.atom <- which(full.ids %in% tmp.ids[core$c0.5A.atom])

  core$xyz        <- atom2xyz(core$atom)
  core$c1A.xyz    <- atom2xyz(core$c1A.atom)
  core$c0.5A.xyz  <- atom2xyz(core$c0.5A.atom)

  ##core$resno       <- which(full.ids %in% tmp.ids[core$resno])[core$resno]
  ##core$c1A.resno   <- which(full.ids %in% tmp.ids[core$c1A.resno])[core$c1A.resno]
  ##core$c0.5A.resno <- which(full.ids %in% tmp.ids[core$c0.5A.resno])[core$c0.5A.resno]

  core$resno       <- tmp$atom$resno[core$resno]
  core$c1A.resno   <- tmp$atom$resno[core$c1A.resno]
  core$c0.5A.resno <- tmp$atom$resno[core$c0.5A.resno]

  return(core)
}


"core.find.pdbs" <-
function(pdbs,
         shortcut  = FALSE,
         rm.island = FALSE,
         verbose   = TRUE,
         stop.at   = 15,
         stop.vol  = 0.5,
         write.pdbs = FALSE,
         outpath="core_pruned",
         ncore = 1,
         nseg.scale = 1,
         progress = NULL, ...) {

  ##  Itterative core deffination for lsq fit optimisation
  ##  (core positions are those with low ellipsoid volume)

  # Parallelized by parallel package (Fri Apr 26 16:49:38 EDT 2013)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }

  error.ellipsoid<-function(pos.xyz) {
    S<-var(pos.xyz)
    prj  <- eigen(S, symmetric = TRUE)
    prj$values[prj$values < 0 & prj$values >= -1.0E-12]<-1.0E-12
    vol<-4/3*pi*prod( sqrt( prj$values ) )
    out<-list(vol=vol, U=prj$vectors, L=prj$values)
  }


  if(is.matrix(pdbs)) {
    xyz <- pdbs

    xyz.inds <- which(apply(is.na( xyz ), 2, sum)==0)
    res.inds<-xyz.inds[seq(3,length(xyz.inds),by=3)]/3

    pdbseq = rep("ALA",length(xyz.inds)/3)
    pdbnum = c(1:(length(xyz.inds)/3))

  } else {
    if( (is.list(pdbs)) && (inherits(pdbs, "pdbs")) ) {
      xyz=pdbs$xyz

      xyz.inds <- which(apply(is.na( xyz ), 2, sum)==0)
      res.inds <- which(apply(pdbs$ali=="-", 2, sum)==0)

      pdbseq = aa123(pdbs$ali[1,]); pdbnum = pdbs$resno[1,]
    } else {
      stop("input 'pdbs' should either be:
               a list object from 'read.fasta.pdb'
               or a numeric 'xyz' matrix of aligned coordinates")
    }
  }

  # First core = all non gap positions
  res.still.in <- res.inds # indices of core residues
  xyz.still.in <- xyz.inds # indices of core xyz's
  new.xyz.inds <- xyz.inds # indices of core xyz's
  xyz.moved    <- xyz      # core-fitted coords
  throwout.res <- NULL     # non-core res inds
  throwout.xyz <- NULL     # non-core xyz inds
  remain.vol   <- NULL
  core.length  <- NULL

  if(!length(res.still.in) > stop.at) {
    stop(paste0("Insufficient non-gap residues in alignment: \n",
                "  non-gap residues (", length(res.still.in), ") <= 'stop.at' argument (", stop.at, ")"))
  }
  
  fit.to = rep(FALSE,ncol(xyz.moved))        # Preliminary fitting
  fit.to[ as.vector(xyz.still.in) ]<-TRUE    # on first structure
#  xyz.tmp <- t(apply(xyz.moved, 1,           # to find mean structure
#                       rot.lsq,              # for next fitting
#                       yy=xyz.moved[1,],
#                       xfit=fit.to))
  xyz.tmp <- fit.xyz(xyz.moved[1,], xyz.moved, which(fit.to), which(fit.to),
                      ncore=ncore, nseg.scale=nseg.scale)

  mean.xyz <- apply(xyz.tmp,2,mean)

  if(write.pdbs) {
    dir.create(outpath,FALSE)
  }
  
  while(length(res.still.in) > stop.at) {

    ## edit for shiny version
    if(!is.null(progress)) {
      progress$inc(1/length(res.inds))
    }
    ## edit end

    # Core fitting, (core => pdbnum[ res.still.in ])
    fit.to = rep(FALSE,ncol(xyz.moved))
    fit.to[ as.vector(xyz.still.in) ]<-TRUE
#    xyz.moved <- t(apply(xyz.moved, 1,
#                         rot.lsq,
#                         #yy=xyz.moved[1,],
#                         yy=mean.xyz,
#                         xfit=fit.to))
    xyz.moved <- fit.xyz(mean.xyz, xyz.moved, which(fit.to), which(fit.to),
                    ncore=ncore, nseg.scale=nseg.scale)

    mean.xyz <- apply(xyz.moved,2,mean)

    i<-1; j<-3
    volume<-NULL # ellipsoid volume
    if(ncore > 1) {
       e <- mclapply(1:(length(new.xyz.inds)/3), function(j) {
          error.ellipsoid( xyz.moved[, new.xyz.inds[atom2xyz(j)]] )$vol
       })
       volume <- unlist(e)
    } else {
       while(j<=length( new.xyz.inds )) {
         e<-error.ellipsoid(xyz.moved[,new.xyz.inds[i:j]])
         volume<-c(volume,e$vol)
         i<-i+3;j<-j+3
       }
    }

    record <- cbind(res.still.in ,   # store indices and volumes
                    matrix(new.xyz.inds,ncol=3,byrow=3),
                    volume)

    # Find highest volume (most variable position)
    if (shortcut) {
      if (length(res.still.in) >= 35) {
        # remove four at a time
        highest.vol.ind <- rev(order(volume))[1:4]
      } else { highest.vol.ind <- which.max(volume) }
    } else {
      # no shortcut rm one at a time
      highest.vol.ind <- which.max(volume)
    }

    if (rm.island) {
      # Exclude length 4 residue islands
      check <- bounds( res.still.in )
      check.ind <- which(check[,"length"] < 4)
      if ( length(check.ind) > 0 ) {
        res.cut=NULL
        for (r in 1:length(check.ind)) {
          res.cut <- c(res.cut, check[check.ind[r],"start"]:
                       check[check.ind[r],"end"])
        }
        highest.vol.ind <- unique( c(highest.vol.ind,
                             which( is.element(res.still.in, res.cut)) ))
      }
    }

    # rm position from "new.xyz.inds"
    xyz.exclude <- record[highest.vol.ind,c(2:4)]
    inds.torm <- which(is.element( new.xyz.inds, as.vector(xyz.exclude) ))
    new.xyz.inds <- new.xyz.inds[ -inds.torm ]

    # Store details of the residue we excluded
    tmp.vol <- sum(record[-highest.vol.ind,5])
    throwout.res <- c( throwout.res, as.vector(record[highest.vol.ind,1]))
    throwout.xyz <- rbind( throwout.xyz, record[highest.vol.ind,2:4] )
    remain.vol   <- c(remain.vol, tmp.vol)
    res.still.in <- record[-highest.vol.ind,1]
    xyz.still.in <- record[-highest.vol.ind,2:4]
    core.length  <- c(core.length,length(res.still.in))

    if(verbose) {
      # Progress report
      cat( paste(" core size",length(res.still.in),"of",
                length(res.inds))," vol =",
          round(tmp.vol,3),"\n" )

      if(write.pdbs) {
        # Write current core structure
        write.pdb(file  = file.path(outpath, paste("core_",
                    sprintf("%04.0f", length(res.still.in)),".pdb",sep="")),
                  #xyz   = xyz[1, new.xyz.inds ],
                  xyz   = mean.xyz[ new.xyz.inds ],
                  resno = pdbnum[ res.still.in ],
                  resid = pdbseq[ res.still.in ],
                  b     = round((volume[-highest.vol.ind] /
                    max(volume[-highest.vol.ind]) * 1),2) )
      }
    }

    if(tmp.vol < stop.vol) {
      cat(paste(" FINISHED: Min vol (",stop.vol,") reached\n"))
      break
    }
  }

  # ordered thro-out lists
  ordered.res<-as.vector(c(throwout.res, res.still.in))
  ordered.xyz<-rbind(throwout.xyz, xyz.still.in)
  rownames(ordered.xyz)=NULL
  vol = c(remain.vol, rep(NA,stop.at))
  len = c(core.length,rep(NA,stop.at))
  blank<-rep(NA, len[1]); blank[na.omit(len)]=na.omit(vol)
  ordered.vol<-c(rev(blank),NA); blank[na.omit(len)]=na.omit(len)
  ordered.len<-c(rev(blank),NA)

  # sample cores (volume < 1 A^3, < 0.5 A^3, or the final core)
  if( min(ordered.vol,na.rm=TRUE) < 1) {
    a.atom <- sort(ordered.res[which(ordered.vol<1)[1]:length(ordered.vol)])
    a.xyz  <- sort(as.vector(ordered.xyz[which(ordered.vol<1)[1]:
                                         length(ordered.vol),]))
    a.resno <- as.numeric(pdbnum[a.atom])
  } else {
    a.atom  <- NULL
    a.xyz   <- NULL
    a.resno <- NULL
  }
  if( min(ordered.vol,na.rm=TRUE) < 0.5) {
    b.atom <- sort(ordered.res[which(ordered.vol<0.5)[1]:length(ordered.vol)])
    b.xyz  <- sort(as.vector(ordered.xyz[which(ordered.vol<0.5)[1]:
                                         length(ordered.vol),]))
    b.resno <- as.numeric(pdbnum[b.atom])
  } else {
    b.atom  <- NULL
    b.xyz   <- NULL
    b.resno <- NULL
  }
  tmp.inds <- which(!is.na(ordered.vol))
  c.atom <- sort(ordered.res[tmp.inds[length(tmp.inds)]:length(ordered.vol)])
  c.xyz  <- atom2xyz(c.atom)
  c.resno <- as.numeric(pdbnum[c.atom])

  output <- list(volume      = ordered.vol,
                 length      = ordered.len,
                 resno       = pdbnum[ ordered.res ],
                 step.inds   = ordered.res,
                 atom        = c.atom,
                 xyz         = c.xyz,
                 c1A.atom    = a.atom,
                 c1A.xyz     = a.xyz,
                 c1A.resno   = a.resno,
                 c0.5A.atom  = b.atom,
                 c0.5A.xyz   = b.xyz,
                 c0.5A.resno = b.resno )
  class(output)="core"; return(output)

}

context("Testing core.find function")


test_that("core.find() works properly", {
  skip_on_cran()

  attach(transducin)
  inds <- unlist(lapply(c("1TND_A", "1TAG", "1AS0", "1AS2"), grep, pdbs$id))
  pdbs <- trim.pdbs(pdbs, row.inds=inds)
 
  invisible(capture.output(core <- core.find(pdbs, ncore=1)))
  resnos.1 <- c(202, 206, 209, 205, 203, 201)
  resnos.2 <- c(332, 334, 335, 336, 337, 340)
  
  expect_equal(length(core$resno), 313)
  expect_equal(resnos.1, as.numeric(core$resno[1:6]))
  expect_equal(resnos.2, as.numeric(tail(core$resno)))
  
  xyz <- c(16, 17,  18,  19,  20,  21,  25,  26,  27, 34)
  expect_equal(xyz, core$xyz[1:10])
  expect_equal(sum(core$xyz), 234006)
  
  ## Check multicore 
  skip_on_travis()

  invisible(capture.output(core.mc <- core.find(pdbs, ncore=NULL)))
  expect_identical(core, core.mc)

  detach(transducin)
})

prune.cna <- function(x, edges.min=1, size.min=1) {
  
  ##-- Prune nodes based on number of edges and number of members
  ##     prune.cna(net)
  ##
  
  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }
  
  if(inherits(x, "cna")) {
    y <- summary.cna(x)
    network=x$community.network
  } else {
    warning("Input should be a 'cna' class object as obtained from cna()")
    network=x
    y <- NULL
  }

  if((edges.min==0) & (size.min==0)){
    stop("Must specify a number greater than 0 for edges.min and/or size.min")
  }
  
  ## Identify nodes with less than 'edges.min' to other nodes.
  nodes.inds <- which(igraph::degree(network) < edges.min)
  
  
  ## Identify nodes with size less than 'size.min'
  ##  cant use V(net$network)$size as these can be scaled
  ##  so we will use the summary information in 'y'
  nodes.inds <- c(nodes.inds, which(y$size < size.min))

  nodes.inds <- unique(nodes.inds)
  
  if( length(nodes.inds) == 0 ) {
    cat( "No Nodes Will Removed based on edges.min and size.min values" )
    output = x
  } else {
    rm.vs <- igraph::V(network)[nodes.inds]
    cat( paste("Removing Nodes:", paste(rm.vs, collapse=", ")),"\n")
    ## Print details of removed with edges
    if(!is.null(y)) {
      w <- cbind(y$tbl[rm.vs,c("id","size")],
                 "edges"=igraph::degree(network)[rm.vs],
                 "members"=y$tbl[rm.vs,c("members")])
      w <- w[order(w$id),]
      write.table(w, row.names=FALSE, col.names=TRUE, quote=FALSE,sep="\t")

      ## Residue raw network
      res2rm <- as.numeric(unlist(y$members[rm.vs]))
      x$communities$membership[res2rm] = NA
    }
  
    d <- igraph::delete.vertices(network, rm.vs)
    
    
    ## Will probably want to keep an edited old community object !!!
    
    output <- list("community.network"=d,
                   "network"= x$network,  ## UNCHANGED!!!
                   "communities"=x$communities)
  }

  class(output) = class(x)
  return(output)
}

"dccm.pca" <-
  function(x, pc = NULL, method=c("pearson", "lmi"), ncore = NULL, ...) {
   if (missing(x) || !"pca" %in% class(x))
     stop("dccm.pca: must supply a 'pca' object, i.e. from 'pca.xyz'")

   method = match.arg(method)
    
   modes = pc

   ## Check for multiple cores
   ncore = setup.ncore(ncore)

   ## Set modes to be included
   if(is.null(modes))
      modes <- 1:length(x$L)
  
   ## If modes are negative, take modes complementary to them
   if( any(!is.numeric(modes)) || 
       any(!(abs(modes) %in% c(1:length(x$L)))) ||
       !(all(modes>0) || all(modes<0)) )
      stop("Incorrect mode index")
   if(all(modes < 0)) {
      modes <- setdiff(c(1:length(x$L)), abs(modes))
      if(length(modes) == 0)
         stop("No mode is selected")
   } 

   modes <- unique(modes)
   nmodes <- length(modes)
    
   ## Calc variance-covariance matrix over a subset of modes
   vcovmat <- function(r.inds, pca, vcov.mat = 0) {
     for ( i in seq_along(r.inds) ) {
       vcov.mat <- vcov.mat + (pca$U[, r.inds[i]] %o% pca$U[, r.inds[i]]) * pca$L[r.inds[i]]
       .update.pb(pb)
     }
     return(vcov.mat)
   }

   ## Calculate variance-covariance matrix first ## 
   ## If contain $z, straightforward
   if(!is.null(x$z)) {

      q = x$z[, modes] %*% t(x$U[, modes])
      vcov = cov(q)

   } else {

      ## Initialize progress bar
      pb <- .init.pb(ncore, min=0, max=nmodes)

      if(ncore > 1) {   # Parallel

         jobid <- rep(1:ncore, ceiling(nmodes/ncore))
         jobid <- jobid[1:nmodes]

         ltv <- mclapply(1:ncore, function(i) {
            j <- which(jobid %in% i)
            if(length(j) > 0) {
               m <- vcovmat(modes[j], x)
               m <- m[lower.tri(m, diag = TRUE)]
            } else {
               m = 0
            }
            return(m)
         } )
         
         ltv <- colSums(do.call(rbind, ltv))
         vcov <- matrix(0, nrow(x$U), nrow(x$U))
         vcov[lower.tri(vcov, diag = TRUE)] <- ltv
         vcov <- vcov + t(vcov)
         diag(vcov) <- diag(vcov) / 2

      } else {       # Serial

         vcov <- vcovmat(modes, x)

      }
      .close.pb(pb)
   }
   
   corr.mat <- .cov2dccm(vcov, method = method, ncore = ncore)
   return(corr.mat)
}

"var.xyz" <- function(xyz, weights=TRUE) {
  ## Calculate pairwise distances
  natoms <- ncol(xyz) / 3
  all <- array(0, dim=c(natoms,natoms,nrow(xyz)))
  for( i in 1:nrow(xyz) ) {
    dists <- dist.xyz(xyz[i,])
    all[,,i] <- dists
  }
  
  ## Calculate variance of pairwise distances
  all.vars <- apply(all, 1:2, var)

  if(weights) {
    ## Make the final weights
    wts <- 1 - (all.vars / max(all.vars, na.rm=TRUE))
    wts[is.na(wts)] <- 1
    return(wts)
  }
  else {
    return(all.vars)
  }
}

"var.pdbs" <- function(pdbs, ...) {
  xyz <- pdbs$xyz
  return(var.xyz(xyz, ...))
}

"read.crd.charmm" <-
function(file, ext=TRUE, verbose = TRUE, ...) {

  split.string <- function(x) {
    x <- substring(x, first, last)
    x[nchar(x) == 0] <- as.character(NA)
    x
  }
  
  trim <- function(s) {
    s <- sub("^ +", "", s)
    s <- sub(" +$", "", s)
    s[(s == "")] <- NA
    s
  }

  if(ext)
    atom.format <- c(10, 10, 8, 8,
                     -4, 20,20,20, -1,
                     8, -1, 8, 20)
  else
    atom.format <- c(5, 5, 4, 5,
                     -1, 10,10,10, -1,
                     4, -1, 4, 10)
  
  atom.names  <- c("eleno", "resno", "resid", "elety",
                   "blank", "x", "y", "z",  "blank",
                   "segid", "blank", "resno2", "b")
  
  widths <- abs(atom.format)
  drop.ind <- (atom.format < 0)
  
  st <- c(1, 1 + cumsum(widths))
  first <- st[-length(st)][!drop.ind]
  last <- cumsum(widths)[!drop.ind]
  
  raw.lines <- readLines(file)

  
  head.ind <- which(substr(raw.lines,1,1)=="*")
  head.ind <- c(head.ind, (head.ind[length(head.ind)]+1) )

  if(length(head.ind)>0) {
    raw.lines <- raw.lines[-head.ind]
    if(verbose)
      cat(raw.lines[head.ind],sep="\n")
  }
  atom <- matrix(trim(sapply(raw.lines, split.string)),
                 byrow = TRUE,
                 ncol = length(atom.format[!drop.ind]),
                 dimnames = list(NULL,
                   atom.names[!drop.ind]) )
  
  output <- list(atom = atom,
                 xyz = as.numeric(t(atom[, c("x", "y", "z")])),
                 calpha = as.logical(atom[, "elety"] == "CA"))
  class(output) <- c("charmm", "crd")
  return(output)
}

cat.pdb <- function(..., renumber=FALSE, rechain=TRUE) {
  cl <- match.call()
   
  objs <- list(...)
  are.null <- unlist(lapply(objs, is.null))
  objs <- objs[!are.null]

  if(length(objs)==1) 
     if(is.null(cl$rechain)) rechain = FALSE
  else
     if(length(objs)<1) return(NULL)

  if(any(!unlist(lapply(objs, is.pdb))))
    stop("provide PDB objects as obtained from read.pdb()")
  
  ## avoid NA as chain ID
  na.inds <- lapply(objs, function(x) is.na(x$atom$chain))
  if(any(unlist(na.inds))) {
    na.inds <- which(unlist(lapply(na.inds, function(x) any(x))))
    for(i in na.inds) {
      tmp <- objs[[i]]
      tmp$atom$chain[ is.na(tmp$atom$chain) ] <- " "
      objs[[i]] <- tmp
    }
  }

  ## save original chain IDs
  ori.chain <- unlist(lapply(objs, function(x) unique(x$atom$chain)))

  ## always assign new chain identifiers 
  ## and bring back original chain ID later if rechain=FALSE
  k <- 1
  chain.repo <- c(LETTERS, letters, 0:9)
  for(i in 1:length(objs)) {
    x <- objs[[i]]
    objs[[i]] <- .update.chain(x, chain.repo[k:length(chain.repo)])
    k <- k + length(unique(x$atom$chain))
  }

  ## concat objects
  new <- objs[[1]]
  if(length(objs) > 1) { 
     for(i in 2:length(objs)) {
       new$atom     <- rbind(new$atom, objs[[i]]$atom)
       new$xyz      <- cbind(new$xyz, objs[[i]]$xyz)
       new$seqres <- c(new$seqres, objs[[i]]$seqres)
       new$helix <- c(new$helix, objs[[i]]$helix)
       new$sheet <- c(new$sheet, objs[[i]]$sheet)
     }
  }
  ## merge SSE info
  for(i in c("helix", "sheet")) {
     sse <- new[[i]]
     if(!is.null(sse)) {
        coms <- names(sse)
        names(sse) <- NULL # avoid nested naming in results
        inds <- which(!duplicated(coms))
        for(j in inds) 
           sse[[j]] <- do.call(c, sse[coms %in% coms[j]])
        sse <- sse[inds]
        names(sse) <- coms[inds]
        new[[i]] <- sse
     }
  }

  ## renumber residues
  chk <- try(clean.pdb(new, consecutive = !rechain, 
                force.renumber = renumber, verbose=FALSE), silent=TRUE)
  if(inherits(chk, "try-error")) {
     warning("cat.pdb(): Bad format pdb generated. Try rechain=TRUE and/or renumber=TRUE")
     new['helix'] <- list(NULL)
     new['sheet'] <- list(NULL)
  }
  else
     new <- chk

  if(!rechain) new <- .update.chain(new, ori.chain)

  ## build new PDB object
  new$call <- cl

  ## remap " " chain IDs to NA values
  new$atom$chain[ new$atom$chain==" " ] <- as.character(NA)

  ## check connectivity
  chains <- unique(new$atom$chain)
  for(i in 1:length(chains)) {
    sele <- atom.select(new, chain=chains[i], verbose=FALSE)
    tmp <- trim.pdb(new, sele)
    
    if(!inspect.connectivity(tmp))
      warning(paste("possible chain break in molecule: chain", chains[i]))
  }
  
  return(new)
}

.update.chain <- function(x, chain.repo = LETTERS) {
   new <- x
   chains <- unique(x$atom$chain)
   for(j in 1:length(chains)) {
     inds <- which(x$atom$chain==chains[j])
     new$atom$chain[inds] <- chain.repo[j]
     if(!is.null(x$helix)) new$helix$chain[x$helix$chain==chains[j]] <- chain.repo[j]
     if(!is.null(x$sheet)) new$sheet$chain[x$sheet$chain==chains[j]] <- chain.repo[j]
   }
   new
}

layout.cna <- function(x, pdb, renumber=TRUE, k=2, full=FALSE){

  ## Return the coordinate centers of network communities 
  ##  as defined in "x$communities$membership" 'membership vector' 
  ##  using Calpha's in 'pdb'.
  ##
  ##  If k=3 the xyz geometric centers are returned. if k<3 then
  ##  multidimensional scaling is used for k space ordination.
  ##
  ##   co2  <- layout.cna(net, pdb)
  ##   co3  <- layout.cna(net, pdb, k=3)
  ##   all2 <- layout.cna(net, pdb, k=2, full=TRUE)
  ##   plot.cna(net, layout=co2)

  if( !inherits(pdb, "pdb") ) {
    stop("Input 'pdb' is not of class 'pdb' as obtained from 'read.pdb()'")
  }
  if(!k %in% c(1,2,3)) {
    stop("Input 'k' should have a value of 3, 2 or 1")
  }
  if(inherits(x, "cna") || is.list(x)) {
    if(!full) {
      ## We want community coords
      membership <- x$communities$membership
    } else {  
      ## We want full all-atom/Calpha coords (check network for number)
      membership <- c(1:length(x$communities$membership))
    }
  } else {
    if(full) {
      ## Assuming we want Calpha coords - this is a BIG assumption! 
      membership <- c(1:sum(pdb$calpha))
    }
    stop("Input object 'x' should be of class cna")
  }

  ## Renumber 'pdb' to match membership resno indices
  if(renumber) {
    pdb <- convert.pdb(pdb, renumber=TRUE, rm.h=FALSE, verbose=FALSE)
  }

  ##-- Check if the number of residues in 'pdb' equals
  ##   the length of 'membership' vector
  notprotein.inds <- atom.select(pdb, "notprotein", verbose=FALSE)

  if(length(notprotein.inds$atom)>0){
    num.res <- length(pdb$atom[pdb$calpha,"resno"]) + length(unique(pdb$atom[notprotein.inds$atom,7]))
  }
  if(length(notprotein.inds$atom)==0){
    num.res <- length(pdb$atom[pdb$calpha,"resno"])
  }
  
  ##-- Calculate the geometric center of each community
  n <- unique(membership[!is.na(membership)])
  
  cent <- matrix(NA, nrow=length(n), ncol=3)
  a <- 1
  for(i in n){
    inds <- atom.select(pdb, resno=which(membership==i),
                        elety="CA", verbose=FALSE)

    cent[a,] <- apply( matrix(pdb$xyz[inds$xyz], nrow=3), 1, mean)
    a <- a + 1 
  }

  if(k != 3) {
    ##-- Multidimensional scaling for 2D or 1D projection
    ##   note. dist(centers) and dist.xyz(centers) give same answer
    if(nrow(cent) - 1 < k) {
       # e.g. only two communities 
       cent <- cmdscale(dist(cent), k = nrow(cent) - 1)
       cent <- cbind(cent, matrix(0, nrow=nrow(cent), ncol=k-nrow(cent)+1))
    } else { 
       cent <- cmdscale(dist(cent),k=k)
    }
  }
  return(cent)
}

`plot.blast` <-
function(x, cutoff=NULL, cut.seed=NULL, cluster=TRUE, mar=c(2, 5, 1, 1), cex=1.5, ...) {

  ## b <- blast.pdb( pdbseq( read.pdb("4q21") ) )
  ## plot(b, 188)  ## cut.seed=110

    cl <- class(x)
    if("hit.tbl" %in% names(x))
        x <- x$hit.tbl


  panelplot <- function(z=x$mlog.evalue, ylab="-log(Evalue)", gp=gp, ...) {
    z=as.numeric(z)
    plot(z, xlab="", ylab=ylab, col=gps, ...)
    abline(v=gp, col="gray70", lty=3)

    pos=c(rep(4, length(gp))[-length(gp)],2)
    text(  gp, z[gp], 
          labels=paste0("Nhit=",gp ,", x=", round(z[gp])), 
          col="black", pos=pos, cex=cex, ...) ##"gray50"
  }


  ##- Setup plot arangment
  opar <- par(no.readonly = TRUE)
    on.exit(par(opar))

    if("blast" %in% cl)
        par(mfcol=c(4,1), mar=mar, cex.lab=cex)
    if("hmmer" %in% cl & "kg" %in% names(x))
        par(mfcol=c(4,1), mar=mar, cex.lab=cex)

  ##- Find the point pair with largest diff evalue
  dx <- abs(diff(x$mlog.evalue))
  dx.cut = which.max(dx)


  if(!is.null(cutoff)) {
    ##- Use suplied cutoff
    gps = rep(2, length(x$mlog.evalue))
    gps[ (x$mlog.evalue >= cutoff) ] = 1

  } else {

    if(cluster) {
      ## Ask USER whether to continue with clustering with many hits  
      nhit <- length(x$mlog.evalue)
      if(nhit > 9999) {
        cluster <- readline( paste0(" Note: ", nhit, 
          " hits, continue with TIME-CONSUMING clustering [y/n/q](n): ") )

        cluster <- switch(cluster, y=TRUE, yes=TRUE, q="QUIT", FALSE)
        if(cluster=="QUIT") { stop("user stop") }
      }
    }

    if(is.null(cut.seed)) {
      ## Use mid-point of largest diff pair as seed for
      ##  cluster grps (typical PDB values are ~110)
      cut.seed = mean( x$mlog.evalue[dx.cut:(dx.cut+1)] )
    }

    if(cluster){
      ##- Partition into groups via clustering 
      ##  In future could use changepoint::cpt.var
      hc <- hclust( dist(x$mlog.evalue) )
      if(!is.null(cutoff)) { cut.seed=cutoff } 
      gps <- cutree(hc, h=cut.seed)
    } 

    if(!cluster || (length(unique(gps))==1)) {
      ##- Either we don't want to run hclust or hclust/cutree 
      ##   has returned only one grp so here we will divide   
      ##   into two grps at point of largest diff
      gps = rep(2, length(x$mlog.evalue))
      gps[1:dx.cut]=1
    }
  }

  gp.inds <- na.omit(rle2(gps)$inds)
  gp.nums <- x$mlog.evalue[gp.inds]

  cat("  * Possible cutoff values:   ", floor(gp.nums), "\n",
      "           Yielding Nhits:   ", gp.inds, "\n\n")

  if( is.null(cutoff) ) {
    ## Pick a cutoff close to cut.seed
    i <- which.min(abs(gp.nums - cut.seed))
    cutoff <- floor( gp.nums[ i ] )
  }

  inds <- x$mlog.evalue >= cutoff
  cat("  * Chosen cutoff value of:   ", cutoff, "\n",
      "           Yielding Nhits:   ", sum(inds), "\n")
      

  ##- Plot each alignment statistic with annotated grps
  panelplot(gp=gp.inds)
    panelplot(x$bitscore, ylab="Bitscore", gp=gp.inds)

    if("identity" %in% names(x))
        panelplot(x$identity, ylab="Identity", gp=gp.inds)
    if("alignmentlength" %in% names(x))
        panelplot(x$alignmentlength, ylab="Length", gp=gp.inds)
    if("kg" %in% names(x)) {
                
        tbl <- table(x$kg[inds], cut(x$score[inds], 20))
        tbl=tbl[, seq(ncol(tbl), 1), drop=FALSE]
        cols <- seq(1,nrow(tbl))
        barplot(tbl, col=cols, ylab="Frequency", border="grey50")
        box()
        
        legend("topleft", rownames(tbl), col=cols,  pch=15, ncol=3, 
               cex=cex*0.8, box.lwd = .5, box.lty=2, box.col = "grey50", bg = "white")

        
        tbl <- table(x$kg[!inds], cut(x$score[!inds], 20))
        tbl=tbl[, seq(ncol(tbl), 1), drop=FALSE]
        cols <- seq(1,nrow(tbl))
        barplot(tbl, col=cols, ylab="Frequency", border="grey50")
        
        legend("topleft", rownames(tbl), col=cols,  pch=15, ncol=3,
               cex=cex*0.8, box.lwd = .5, box.lty=2, box.col = "grey50", bg = "white")
        box()
    }


  ##- Return details of hits above cutoff
  out <- cbind("pdb.id"=x$pdb.id[inds], "acc"=x$acc[inds], "group"=gps[inds])
  rownames(out) <- which(inds)
  o <- list(hits=out, pdb.id=x$pdb.id[inds], acc=x$acc[inds], inds=inds)
  class(o) <- "blast" 
  return(invisible(o))
}

"pairwise" <-
function(N) {
  
  # deternine the indices for  pairwise
  # comparison of N things (where N = 'number.of.things')
  # Used in function 'identity'
  #
  #    A <- read.fasta(system.file("examples/kinesin.fa",
  #                                 package = "bio3d"))
  #    
  #    N<-nrow(A$ali)
  #    # comparison indices
  #    inds<-pairwise(N)
  #    # store score in 's'
  #    s<-rep(NA,nrow(inds))
  #    # go through all comparisons
  #     for(i in 1:nrow(inds)) {
  #       s[i]<-ide(A$ALI[ inds[i,1], ], A[ inds[i,2], ])
  #     }
  #     # reformat 's' as a NxN matrix
  #     mat<-matrix(NA,ncol=N,nrow=N)
  #     mat[inds]<-s; mat[inds[,c(2,1)]]<-s

  if (!is.numeric(N) || N<0 || length(N)>1) {
    stop("pairwise: N must be positve numeric and of length 1")
  }

  pair <- matrix(NA, ncol=2,
                 nrow= ( ((N*N)/2)-(N/2) )) 
  start<-1
  for(i in 1:(N-1)) {
    end  = N-i
    inds = start:( (start-1)+end )
    pair[inds,1] = rep(i, end)
    pair[inds,2] = (i+1):N
    start = start+end
  }
  return(pair)
}

read.pdb <- function(file, maxlines = -1, multi=FALSE, rm.insert=FALSE, rm.alt=TRUE,
                     ATOM.only=FALSE, hex=FALSE, verbose=TRUE) {
  
    cl <- match.call()
    
    if(missing(file)) {
        stop("read.pdb: please specify a PDB 'file' for reading")
    }
    
    if(!is.logical(multi)) {
        stop("read.pdb: 'multi' must be logical TRUE/FALSE")
    }
    
    ##- Check if file exists locally or on-line
    putfile <- NULL
    if(substr(file,1,4)=="http") {
        ## cpp function can not read from http
        putfile <- tempfile(fileext=".pdb")
        rt <- try(download.file(file, putfile, quiet = !verbose), silent=TRUE)
        if(inherits(rt, "try-error")) {
            file.remove(putfile)
            stop("File not found at provided URL")
        }
        else {
            file <- putfile
        }
    }
    
    toread <- file.exists(file)
    if(toread & basename(file) != file) {
        file <- normalizePath(file)
    }
    
    ## Check for 4 letter code and possible on-line file
    if(!toread) {
        if(nchar(file)==4) {
            cat("  Note: Accessing on-line PDB file\n")
            file <- get.pdb(file, path=tempdir(), verbose=FALSE)
        }
        else {
            stop("No input PDB file found: check filename")
        }
    }
    
    ## parse PDB file with cpp function
    pdb <- .read_pdb(file, multi=multi, hex=hex, maxlines=maxlines, atoms_only=ATOM.only)

    ## remove temp file if we downloaded it above
    if(!is.null(putfile)) {
        file.remove(putfile)
    }
    
#    if(verbose)
#        cat(" ", pdb$header, "\n")
    pdb$header <- NULL
    
    if(!is.null(pdb$error))
        stop(paste("Error in reading PDB file", file))
    else
        class(pdb) <- c("pdb", "sse")
    
    ## convert xyz to matrix
    if(pdb$models > 1)
        pdb$xyz <- matrix(pdb$xyz, nrow=pdb$models, byrow=TRUE)
    
    pdb$xyz <- as.xyz(pdb$xyz)
    pdb$models <- NULL

    ## set empty strings to NA
    pdb$atom[pdb$atom==""] <- NA
    
    ## give names to seqres
    names(pdb$seqres) <- pdb$seqres_chain
    pdb$seqres_chain <- NULL
    
    ## fix stuff that should be NULL instead of empty vectors
    if(length(pdb$helix$start) > 0) {
        ## names are set in cpp func
        ## names(pdb$helix$start) <- pdb$helix$inserti
        ## names(pdb$helix$end) <- pdb$helix$inserte
    }
    else {
        pdb$helix <- NULL
    }
    
    if(length(pdb$sheet$start) > 0) {
        ## names(pdb$sheet$start) <- pdb$sheet$inserti
        ## names(pdb$sheet$end) <- pdb$sheet$inserte
        
        ##- remove repeated records for the same strand (e.g. in 1NH0)
        pa <- paste(pdb$sheet$start, pdb$sheet$inserti, pdb$sheet$chain, sep='_')
        keep.inds <- which(!duplicated(pa))
        pdb$sheet <- lapply(pdb$sheet, '[', keep.inds)

        pdb$sheet$inserti <- NULL
    }
    else {
        pdb$sheet <- NULL
    }
    
    if(!length(pdb$seqres) > 0)
        pdb$seqres <- NULL
    
    if(!length(pdb$remark350) > 0)
        pdb$remark350 <- NULL

    ## Remove 'Alt records'
    if (rm.alt) {
        if ( sum( !is.na(pdb$atom$alt) ) > 0 ) {
            first.alt <- sort( unique(na.omit(pdb$atom$alt)) )[1]
            cat(paste("   PDB has ALT records, taking",first.alt,"only, rm.alt=TRUE\n"))
            alt.inds <- which( (pdb$atom$alt != first.alt) ) # take first alt only
            if(length(alt.inds)>0) {
                pdb$atom <- pdb$atom[-alt.inds,]
                pdb$xyz <- trim.xyz(pdb$xyz, col.inds=-atom2xyz(alt.inds))
            }
        }
    }
    
    ## Remove 'Insert records'
    if (rm.insert) {
        if ( sum( !is.na(pdb$atom$insert) ) > 0 ) {
            cat("   PDB has INSERT records, removing, rm.insert=TRUE\n")
            insert.inds <- which(!is.na(pdb$atom$insert)) # rm insert positions
            pdb$atom <- pdb$atom[-insert.inds,]
            pdb$xyz <- trim.xyz(pdb$xyz, col.inds=-atom2xyz(insert.inds))
        }
    }
    
    if(any(duplicated(pdb$atom$eleno)))
        warning("duplicated element numbers ('eleno') detected")

    if(any(is.na(pdb$atom$resno))) {
        warning("NA values for residue numbers ('resno') detected")
    }
    
    
    ## construct c-alpha attribute
    ca.inds <-  atom.select.pdb(pdb, string="calpha", verbose=FALSE)
    pdb$calpha <- seq(1, nrow(pdb$atom)) %in% ca.inds$atom
    
    ##- Parse REMARK records for storing symmetry matrices to 
    ##  build biological unit by calling 'biounit()'
    remark <- .parse.pdb.remark350(pdb$remark350)
    pdb$remark350 <- NULL
    pdb$remark <- remark
    
    ## set call
    pdb$call <- cl
    
    ## finished
    return(pdb)
}


##- parse REMARK records for building biological unit ('biounit()')
.parse.pdb.remark350 <- function(x) {

    raw.lines <- x

    # How many lines of REMARK 350?
    remark350 <- grep("^REMARK\\s+350", raw.lines)
    nlines <- length(remark350)

    # How many distinct biological unit?
    biolines <- grep("^REMARK\\s+350\\s+BIOMOLECULE", raw.lines)
    nbios <- length(biolines)

    if(nbios == 0) {
#       warning("REMARK 350 is incomplete.")
       return(NULL)
    }

    # End line number of each biological unit
    biolines2 <- c(biolines[-1], remark350[nlines])

    # How the biological unit was determined?
    method <- sapply(1:nbios, function(i) {
       author <- intersect(grep("^REMARK\\s+350\\s+AUTHOR DETERMINED BIOLOGICAL UNIT", raw.lines),
                            biolines[i]:biolines2[i])
       if(length(author) >= 1) return("AUTHOR")
       else return("SOFTWARE")
    } )
    # Get chain IDs to apply the transformation
    chain <- lapply(1:nbios, function(i) {
       chlines <- intersect(grep("^REMARK\\s+350\\s+APPLY THE FOLLOWING TO CHAINS", raw.lines),
                            biolines[i]:biolines2[i])
       if(length(chlines) >= 1) {
          chs <- gsub("\\s*", "", sub("^.*:", "", raw.lines[chlines]))
          chs <- unlist(strsplit(chs, split=","))
       }
       else {
#          warning(paste("Can't determine chain IDs from REMARK 350 for biological unit",
#              i, sep=""))
          chs = NA
       }
       return(chs)
    } )
    if(any(is.na(chain))) return(NULL)

    mat <- lapply(1:nbios, function(i) {
       # Get transformation matrices
       mtlines <- intersect(grep("^REMARK\\s+350\\s+BIOMT", raw.lines),
                            biolines[i]:biolines2[i])
       # Get chain ID again: different trans matrices may be applied to different chains
       chlines <- intersect(grep("^REMARK\\s+350\\s+APPLY THE FOLLOWING TO CHAINS", raw.lines),
                            biolines[i]:biolines2[i])
       chs <- gsub("\\s*", "", sub("^.*:", "", raw.lines[chlines]))
       chs <- strsplit(chs, split=",")

       if(length(mtlines) == 0 || length(mtlines) %% 3 != 0) {
#          warning("Incomplete transformation matrix")
          mat <- NA
       }
       else {
          mat <- lapply(seq(1, length(mtlines), 3), function(j) {
             mt <- matrix(NA, 3, 4)
             for(k in 1:3) {
                vals <- sub("^REMARK\\s+350\\s+BIOMT[123]\\s*", "", raw.lines[mtlines[j+k-1]])
                vals <- strsplit(vals, split="\\s+")[[1]]
                mt[k, ] <- as.numeric(vals[-1])
             }
             mt
          } )
          chs.pos <- findInterval(mtlines[seq(1, length(mtlines), 3)], chlines)
          names(mat) <- sapply(chs[chs.pos], paste, collapse=" ") ## apply each mat to specific chains
       }
       return(mat)
    } )
    if(any(is.na(mat))) return(NULL)

    out <- list(biomat = list(num=nbios, chain=chain, mat=mat, method=method))
    return(out)
}

context("Testing atom.select function")

test_that("atom.select() gets correct selections with various options", {

  # Use the curated test-purpose pdb file
  file <- system.file("examples/test.pdb", package="bio3d")
#  invisible(capture.output(pdb <- read.pdb(file, rm.alt = FALSE)))
  invisible(capture.output(pdb <- read.pdb(file)))

  # Select all atoms: omit 1 ALT
  capture.output(all.inds <- atom.select(pdb, "all"))
  expect_equal(length(all.inds$atom), 175)

  # Select chain A: return everything in chain A
  capture.output(a.inds <- atom.select(pdb, chain = "A"))
  expect_equal(a.inds$xyz, atom2xyz(a.inds$atom))  # self-consistent
  expect_equal(length(a.inds$atom), 98)
  expect_equal(a.inds$atom[1], 1)
  expect_equal(a.inds$atom[98], 170)

  # Select protein: omit 1 ALT
  #                 omit 2 'unknown' AA
  capture.output(pro.inds <- atom.select(pdb, "protein")$atom)
  expect_equal(length(pro.inds), 103)

  # Select C-alpha: omit 2 'unknown' AA
  #                 omit 1 with missing 'CA'
  capture.output(ca.inds <- atom.select(pdb, "calpha")$atom)
  expect_equal(length(ca.inds), 7)
  expect_equal(ca.inds[c(1, 5, 7)], c(3, 53, 110))

  capture.output(ca2.inds <- atom.select(pdb, elety = "CA")$atom)
  expect_equal(length(ca2.inds), 10) # include calcium

  # Select 'N': return the number of all amino acids
  capture.output(cb.inds <- atom.select(pdb, elety = "N")$atom)
  expect_equal(length(cb.inds), 10)
  
  # Select 'unknown' AA
  capture.output(unk.inds <- atom.select(pdb, resid = "TES")$atom)
  expect_equal(length(unk.inds), 26)
  expect_equal(unk.inds[c(3, 13)], c(10, 94))

  # Select 'ATOM' record: omit 1 'ALT'
  capture.output(ATOM.inds <- atom.select(pdb, type = "ATOM")$atom)
  expect_equal(length(ATOM.inds), 129)
 
  # Select first 5 CA atoms by 'eleno'
  capture.output(ca5.inds <- atom.select(pdb, eleno = c(3, 10, 20, 27, 42))$atom)
  expect_equal(length(ca5.inds), 5)
  expect_true(all(pdb$atom[ca5.inds, "elety"] == "CA"))

  # Select hydrogen/ligand/water
  capture.output(h.inds <- atom.select(pdb, "h")$atom)
  expect_equal(length(h.inds), 77)
  
  capture.output(lig.inds <- atom.select(pdb, "ligand")$atom)
  expect_equal(length(lig.inds), 67) # include "TES"

  capture.output(wat.inds <- atom.select(pdb, "water")$atom)
  expect_equal(length(wat.inds), 5)

  capture.output(ion.inds <- atom.select(pdb, resid = "CA")$atom)
  expect_equal(ion.inds, 170)

  capture.output(gdp.inds <- atom.select(pdb, resid = "GDP")$atom)
  expect_equal(length(gdp.inds), 40)
  
  # More string test
  capture.output(bb.inds <- atom.select(pdb, "backbone")$atom)
  capture.output(bb2.inds <- atom.select(pdb, "back")$atom)
  expect_equal(bb.inds, bb2.inds)
  expect_equal(length(bb.inds), 31)
  
  capture.output(cb2.inds <- atom.select(pdb, "cbeta")$atom)
  expect_equal(length(cb2.inds), 36)
  
  capture.output(npro.inds <- atom.select(pdb, "notprotein")$atom)
  capture.output(npro2.inds <- atom.select(pdb, "protein", inverse = TRUE)$atom)
  expect_equal(npro.inds, npro2.inds)
  expect_equal(length(intersect(pro.inds, npro.inds)), 0)
  expect_equal(length(pro.inds) + length(npro.inds), nrow(pdb$atom)) # omit ALT
  
  capture.output(nwat.inds <- atom.select(pdb, "notwater")$atom)
  capture.output(nwat2.inds <- atom.select(pdb, "water", inverse = TRUE)$atom)
  expect_equal(nwat.inds, nwat2.inds)
  expect_equal(length(intersect(wat.inds, nwat.inds)), 0)
  expect_equal(length(wat.inds) + length(nwat.inds), nrow(pdb$atom)) # omit ALT
   
  capture.output(noh.inds <- atom.select(pdb, "noh")$atom)
  capture.output(noh2.inds <- atom.select(pdb, "h", inverse = TRUE)$atom)
  expect_equal(noh.inds, noh2.inds)
  expect_equal(length(intersect(h.inds, noh.inds)), 0)
  expect_equal(length(h.inds) + length(noh.inds), nrow(pdb$atom)) # omit ALT
  
  # Test on combination of select
  capture.output(comb1.inds <- atom.select(pdb, chain = "B", resno = c(1,4)))
  expect_equal(length(comb1.inds$atom), 33) # omit ALT
  
  capture.output(comb2.inds <- atom.select(pdb, resid = "GDP", elety = "PA") )
  expect_equal(comb2.inds$atom, 135)

  capture.output(comb3.inds <- atom.select(pdb, "noh", resid = "TES", chain = "A") )
  expect_equal(comb3.inds$atom, c(8, 10, 12, 16, 17)) 
  
  capture.output(comb4.inds <- atom.select(pdb, chain = "B", resid = "GDP", operator = "OR") )
  expect_equal(length(comb4.inds$atom), 117)
})

context("Testing aanma()")

test_that("aanma based all-atom NMA works", {

  skip_on_cran()
#  skip_on_travis()

  "mysign" <- function(a,b) {
    if(all(sign(a)==sign(b)))
      return(1)
    else
      return(-1)
  }

  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))

  ## Calculate modes with default arguments
  invisible(capture.output(modes <- aanma(pdb, pfc.fun=load.enmff('aaenm2'),
                                        mass=TRUE, temp=300.0)))
 
  ## Check first eigenvector
  U7 <- c(-0.066793729, -0.053883268,  0.001891979,
          -0.036738304, -0.047565978,  0.001753576)
  nowU7 <- head(modes$U[,7])
  expect_that(nowU7 * mysign(U7, nowU7), equals(U7, tolerance=1e-4))

  ## Check second eigenvector
  U8 <- c(-0.0006820437, -0.0063015252, -0.0172583581,
          -0.0208773865, -0.0077078236, -0.0197741642)
  nowU8 <- head(modes$U[,8])
  expect_that(nowU8 * mysign(U8, nowU8), equals(U8, tolerance=1e-4))

  ## Check eigenvalues
  eival <- c(0.012147, 0.016651, 0.025490, 0.034212, 0.040073, 0.048434)
  nowEival <- modes$L[7:12]
  expect_that(nowEival, equals(eival, tolerance=1e-4))

  ## Dimensions
  expect_that(dim(modes$U), equals(c(387, 387)))
  expect_that(dim(modes$modes), equals(c(387, 387)))
  expect_that(length(modes$L), equals(387))
  expect_that(length(modes$frequencies), equals(387))
  expect_that(length(modes$mass), equals(129))
  expect_that(modes$natoms, equals(129))
  expect_that(modes$temp, equals(300))

  ## Orthognals
  tmpU <- crossprod(modes$U, modes$U)
  expect_true(all(round(diag(tmpU), 6)==1))
  expect_true(all(round(tmpU[upper.tri(tmpU)], 6)==0))

  expect_that(all(round(c(modes$L[1:6]), 6)==0), equals(TRUE))


  ###################################################################
  #
  # Test with reduced = TRUE 
  #
  ###################################################################

  ## Calculate modes
  invisible(capture.output(modes <- aanma(pdb, pfc.fun=load.enmff('aaenm2'),
                                        mass=TRUE, temp=300.0, reduced=TRUE)))
 
  ## Check first eigenvector
  U7 <- c(-0.059992473, -0.053860808,  0.002632462,
          -0.038492062, -0.060252657,  0.002212016)
  nowU7 <- head(modes$U[,7])
  expect_that(nowU7 * mysign(U7, nowU7), equals(U7, tolerance=1e-4))

  ## Check second eigenvector
  U8 <- c(-0.008837969, -0.003401558,  0.018160517, 
           0.018834639, -0.002279249,  0.022343009)
  nowU8 <- head(modes$U[,8])
  expect_that(nowU8 * mysign(U8, nowU8), equals(U8, tolerance=1e-4))

  ## Check eigenvalues
  eival <- c(0.005865, 0.007781, 0.010644, 0.015755, 0.019162, 0.020037)
  nowEival <- modes$L[7:12]
  expect_that(nowEival, equals(eival, tolerance=1e-4))

  ## Orthognals
  tmpU <- crossprod(modes$U, modes$U)
  expect_true(all(round(diag(tmpU), 6)==1))
  expect_true(all(round(tmpU[upper.tri(tmpU)], 6)==0))
  
  expect_that(all(round(c(modes$L[1:6]), 6)==0), equals(TRUE))


  ###################################################################
  #
  # Test with rtb = TRUE 
  #
  ###################################################################

  ## Calculate modes
  invisible(capture.output(modes <- aanma(pdb, pfc.fun=load.enmff('aaenm2'),
                                        mass=TRUE, temp=300.0, rtb=TRUE)))
 
  ## Check first eigenvector
  U7 <- c(0.067011206,  0.053922543, -0.001093240,
          0.036319837,  0.047227389, -0.001719102)
  nowU7 <- head(modes$U[,7])
  expect_that(nowU7 * mysign(U7, nowU7), equals(U7, tolerance=1e-4))

  ## Check second eigenvector
  U8 <- c(0.0007543764, 0.0061986220, 0.0164859315,
          0.0207461840, 0.0078183773, 0.0195714639)
  nowU8 <- head(modes$U[,8])
  expect_that(nowU8 * mysign(U8, nowU8), equals(U8, tolerance=1e-4))

  ## Check eigenvalues
  eival <- c(0.012450, 0.017159, 0.026374, 0.037100, 0.041601, 0.050559)
  nowEival <- modes$L[7:12]
  expect_that(nowEival, equals(eival, tolerance=1e-4))

  ## Orthognals
  tmpU <- crossprod(modes$U, modes$U)
  expect_true(all(round(diag(tmpU), 6)==1))
  expect_true(all(round(tmpU[upper.tri(tmpU)], 6)==0))
  
  expect_that(all(round(c(modes$L[1:6]), 6)==0), equals(TRUE))

  
  ###################################################################
  #
  # Test with outmodes = 'noh' 
  #
  ###################################################################

  ## Calculate modes
  invisible(capture.output(modes <- aanma(pdb, pfc.fun=load.enmff('aaenm2'),
                                        mass=TRUE, temp=300.0, outmodes='noh')))
 
  ## Check first eigenvector
  U7 <- c(0.0218632, 0.02019693, -0.002396826, 
          0.01873891, 0.01699585, -0.001568454)
  nowU7 <- head(modes$U[,7])
  expect_that(nowU7 * mysign(U7, nowU7), equals(U7, tolerance=1e-4))

  ## Check second eigenvector
  U8 <- c(0.009318529, 0.001879826, -0.005183737, 
          0.007078334, 0.0008036141, -0.003830362)
  nowU8 <- head(modes$U[,8])
  expect_that(nowU8 * mysign(U8, nowU8), equals(U8, tolerance=1e-4))

  ## Check eigenvalues
  eival <- c(0.011278, 0.013931, 0.01582, 0.023749, 0.030427, 0.039051)
  nowEival <- modes$L[7:12]
  expect_that(nowEival, equals(eival, tolerance=1e-4))

  ## Dimensions
  expect_that(dim(modes$U), equals(c(3003, 3003)))
  expect_that(dim(modes$modes), equals(c(3003, 3003)))
  expect_that(length(modes$L), equals(3003))
  expect_that(length(modes$frequencies), equals(3003))
  expect_that(length(modes$mass), equals(1001))
  expect_that(modes$natoms, equals(1001)) 
  expect_that(modes$temp, equals(300))

  ## Orthognals
  tmpU <- crossprod(modes$U[, 1:300], modes$U[, 1:300])
  expect_true(all(round(diag(tmpU), 6)==1))
  expect_true(all(round(tmpU[upper.tri(tmpU)], 6)==0))
  
  expect_that(all(round(c(modes$L[1:6]), 6)==0), equals(TRUE))

    
  ###################################################################
  #
  # Test with outmodes = 'noh' and rtb = TRUE
  #
  ###################################################################

  ## Calculate modes
  invisible(capture.output(modes <- aanma(pdb, pfc.fun=load.enmff('aaenm2'),
                               mass=TRUE, temp=300.0, outmodes='noh', rtb=TRUE)))
 
  ## Check first eigenvector
  U7 <- c(-0.0229911, -0.02044615, 0.002491489, 
          -0.01944523, -0.01711079, 0.001397449)
  nowU7 <- head(modes$U[,7])
  expect_that(nowU7 * mysign(U7, nowU7), equals(U7, tolerance=1e-4))

  ## Check second eigenvector
  U8 <- c(-0.005763786, -8.247862e-06, 0.00534345, 
          -0.003811432, 0.000763913, 0.003948311)
  nowU8 <- head(modes$U[,8])
  expect_that(nowU8 * mysign(U8, nowU8), equals(U8, tolerance=1e-4))

  ## Check eigenvalues
  eival <- c(0.011579, 0.014595, 0.016808, 0.024449, 0.032666, 0.040224)
  nowEival <- modes$L[7:12]
  expect_that(nowEival, equals(eival, tolerance=1e-4))

  ## Orthognals
  tmpU <- crossprod(modes$U[, 1:300], modes$U[, 1:300])
  expect_true(all(round(diag(tmpU), 6)==1))
  expect_true(all(round(tmpU[upper.tri(tmpU)], 6)==0))
  
  expect_that(all(round(c(modes$L[1:6]), 6)==0), equals(TRUE))

})

context("Testing dssp()")

test_that("SSE assignment still works", {
  skip_on_cran()
  skip_on_travis()

  if(!check.utility('dssp')) {
     skip('Need DSSP installed to run this test')
  }

  ## Simple test with PDB ID 1HEL
  invisible(capture.output(pdb <- read.pdb("3ERJ")))
  sse <- dssp(pdb)
  
  ## helices
  sse.stored   <- c(17,  37,  58, 101,  19,  37, 58, 101)
  expect_that(as.numeric(sse$helix$start), equals(sse.stored))

  sse.stored   <- c(18,  9, 14,  8, 16, 10, 13,  7)
  expect_that(as.numeric(sse$helix$length), equals(sse.stored))

  ## sheet
  sse.stored   <- c(3, 50, 75, 93,  3, 50, 75, 93 )
  expect_that(as.numeric(sse$sheet$start), equals(sse.stored))

  sse.stored   <- c(8, 6, 4, 8, 8, 6, 4, 8)
  expect_that(as.numeric(sse$sheet$length), equals(sse.stored))

  
  ## With RESNO=FALSE
  sse <- dssp(pdb, resno=FALSE)
  
  ## helices
  sse.stored   <- c(16,  36,  57, 100, 134, 152, 173, 216)
  expect_that(as.numeric(sse$helix$start), equals(sse.stored))

  sse.stored <- c(rep("A", 4), rep("B", 4))
  expect_that(as.character(sse$helix$chain), equals(sse.stored))


  ## sheet
  sse.stored   <- c(2,  49,  74,  92, 118, 165, 190, 208)
  expect_that(as.numeric(sse$sheet$start), equals(sse.stored))

  sse.stored <- c(rep("A", 4), rep("B", 4))
  expect_that(as.character(sse$sheet$chain), equals(sse.stored))



  ## With FULL=TRUE
  sse <- dssp(pdb, full=TRUE)
  
  expect_that(sum(as.numeric(sse$hbonds[,"BP1"]), na.rm=T), equals(2127))
  expect_that(sum(as.numeric(sse$hbonds[,"BP2"]), na.rm=T), equals(1355))

  expect_that(sum(as.numeric(sse$hbonds[,"NH-O.1"]), na.rm=T), equals(12017))
  expect_that(sum(as.numeric(sse$hbonds[,"E1"]), na.rm=T), equals(-315.8))
  expect_that(sum(as.numeric(sse$hbonds[,"O-HN.1"]), na.rm=T), equals(13347))
  expect_that(sum(as.numeric(sse$hbonds[,"E2"]), na.rm=T), equals(-313.4))
  expect_that(sum(as.numeric(sse$hbonds[,"NH-O.2"]), na.rm=T), equals(11859))
  expect_that(sum(as.numeric(sse$hbonds[,"E3"]), na.rm=T), equals(-51.2))
  expect_that(sum(as.numeric(sse$hbonds[,"O-HN.2"]), na.rm=T), equals(13076))
  expect_that(sum(as.numeric(sse$hbonds[,"E4"]), na.rm=T), equals(-53.6))
  
  expect_that(length(which(sse$hbonds[,"Chain1"]=="A")), equals(112))
  expect_that(length(which(sse$hbonds[,"Chain1"]=="B")), equals(105))
  expect_that(length(which(sse$hbonds[,"Chain2"]=="A")), equals(115))
  expect_that(length(which(sse$hbonds[,"Chain3"]=="B")), equals(108))
  expect_that(length(which(sse$hbonds[,"Chain4"]=="A")), equals(116))
  
}
          )

`read.pdcBD` <-
function (file, maxlines=50000, multi=FALSE,
                      rm.insert=FALSE, rm.alt=TRUE, verbose=TRUE) {

  if(missing(file)) {
    stop("read.pqr: please specify a PQR 'file' for reading")
  }
  if(!is.numeric(maxlines)) {
    stop("read.pqr: 'maxlines' must be numeric")
  }
  if(!is.logical(multi)) {
    stop("read.pqr: 'multi' must be logical TRUE/FALSE")
  }
  
  # PDB FORMAT v2.0:    colpos,  datatype,    name,      description
  atom.format <- matrix(c(-4,     NA,          NA,       # (ATOM)
                          7,     'numeric',   "eleno",   # atom_no
                         -1,     NA,          NA,        # (blank)
                          3,     'character', "elety",   # atom_ty
                          1,     'character', "alt",     # alt_loc
                          4,     'character', "resid",   # res_na 
                          1,     'character', "chain",   # chain_id 
                          5,     'numeric',   "resno",   # res_no
                          1,     'character', "insert",  # ins_code
                         -3,     NA,           NA,       # (blank)
                          10,     'numeric',   "x",       # x
                          10,     'numeric',   "y",       # y
                          10,     'numeric',   "z",       # z
                          8,     'numeric',   "o",       # o  ### 6 for pdb
                          8,     'numeric',   "b",       # b  ### 6 for pdb
                         -6,     NA,           NA,       # (blank)
                          4,     'character', "segid"    # seg_id
                         ), ncol=3, byrow=TRUE,
                       dimnames = list(c(1:17), c("widths","what","name")) )

  split.string <- function(x) {
    # split a string 'x'
    x <- substring(x, first, last)
    x[nchar(x) == 0] <- as.character(NA)
    x
  }
  is.character0 <- function(x){length(x)==0 & is.character(x)}
  
  trim <- function (s) {
    # Remove leading and traling
    # spaces from character strings
    s <- sub("^ +", "", s)
    s <- sub(" +$", "", s)
    s[(s=="")]<-NA
    s
  }


  # finds first and last (substr positions)
  widths <-  as.numeric(atom.format[,"widths"]) # fixed-width spec  
  drop.ind <- (widths < 0) # cols to ignore (i.e. -ve)
  widths <- abs(widths)    # absolute vales for later  
  st <- c(1, 1 + cumsum( widths ))
  first <- st[-length(st)][!drop.ind] # substr start
  last <- cumsum( widths )[!drop.ind] # substr end

  # read n lines of PDB file
  raw.lines  <- readLines(file, n = maxlines)
  type <- substring(raw.lines,1,6)

  # check number of END/ENDMDL records
  raw.end <- sort(c(which(type == "END"),
                    which(type == "ENDMDL")))
  
  if (length(raw.end) > 1) {
    print("PDB has multiple END/ENDMDL records")
    if (!multi) {
      print("multi=FALSE: taking first record only")
      raw.lines <- raw.lines[ (1:raw.end[1]) ]
      type <- type[ (1:raw.end[1]) ]
    } else {
      print("multi=TRUE: 'read.dcd' will be quicker!")
    }
  }
  if ( length(raw.end) !=1 ) {
    if (length(raw.lines) == maxlines) {
      # have not yet read all the file
      print("You may need to increase 'maxlines'")
      print("check you have all data in $atom")
    }
  }

  # split by record type
  raw.header <- raw.lines[type == "HEADER"]
  raw.seqres <- raw.lines[type == "SEQRES"]
  raw.helix  <- raw.lines[type == "HELIX "]
  raw.sheet  <- raw.lines[type == "SHEET "]
  raw.atom   <- raw.lines[type == "ATOM  "]
  het.atom   <- raw.lines[type == "HETATM"]
  # also look for "TER" records
  rm(raw.lines)
  
  if (verbose) {
    if (!is.character0(raw.header)) { cat(" ", raw.header, "\n") }
  }
  seqres <- unlist(strsplit( trim(substring(raw.seqres,19,80))," "))

  helix  <- list(start = as.numeric(substring(raw.helix,22,25)),
                 end   = as.numeric(substring(raw.helix,34,37)),
                 chain = trim(substring(raw.helix,20,20)),
                 type  = trim(substring(raw.helix,39,40)))

  sheet  <- list(start = as.numeric(substring(raw.sheet,23,26)),
                 end   = as.numeric(substring(raw.sheet,34,37)),
                 chain = trim(substring(raw.sheet,22,22)),
                 sense = trim(substring(raw.sheet,39,40)))
  
  # format ATOM records as a character matrix
  atom <- matrix(trim(sapply(raw.atom, split.string)), byrow=TRUE,
                 ncol=nrow(atom.format[ !drop.ind,]), 
                 dimnames = list(NULL, atom.format[ !drop.ind,"name"]) )

  # Alt records with m[,"alt"] != NA
  if (rm.alt) {
    if ( sum( !is.na(atom[,"alt"]) ) > 0 ) {
      cat("   PDB has ALT records, taking A only, rm.alt=TRUE\n")
      alt.inds <- which( (atom[,"alt"] != "A") ) # take first alt only
      if(length(alt.inds)>0)
        atom <- atom[-alt.inds,]
    }
  }
  # Insert records with m[,"insert"] != NA
  if (rm.insert) {
    if ( sum( !is.na(atom[,"insert"]) ) > 0 ) {
      cat("   PDB has INSERT records, removing, rm.insert=TRUE\n")
      insert.inds <- which(!is.na(atom[,"insert"])) # rm insert positions
      atom <- atom[-insert.inds,]
    }
  }
  het <- matrix(trim(sapply(het.atom, split.string)), byrow=TRUE,
                ncol=nrow(atom.format[ !drop.ind,]), 
                dimnames = list(NULL, atom.format[ !drop.ind,"name"]) )

  output<-list(atom=atom,
               het=het,
               helix=helix,
               sheet=sheet,
               seqres=seqres,
               xyz=as.numeric(t(atom[,c("x","y","z")])),
               calpha = as.logical(atom[,"elety"]=="CA"))

  class(output) <- "pdb"
  return(output)
  
}

"aa2mass" <-
  function(pdb, inds=NULL, mass.custom=NULL, addter=TRUE, mmtk=FALSE) {

    if (missing(pdb))
      stop("must supply 'pdb' object or vector of amino acid residue names")

    if(is.pdb(pdb)) {
      if(!is.null(inds)) {
        pdb <- trim.pdb(pdb, inds)
      }
      sequ <- pdb$atom[pdb$calpha,"resid"]
    }
    else {
      if(!is.null(inds))
        warning("'inds' has no effect when 'pdb' is vector")
      sequ <- pdb
      if(any(nchar(sequ)==1))
        sequ <- aa123(sequ)
      if(any(nchar(sequ)!=3))
        stop("must supply 'pdb' object or vector of amino acid residue names")
    }

    ## Define residues masses
    if(mmtk) {
      ## MMTK (for reproduction purposes!)
      w <- c( 71.079018, 157.196106, 114.104059, 114.080689, 103.143407,
             128.131048, 128.107678,  57.05203,  137.141527, 113.159985,
             113.159985, 129.18266,  131.197384, 147.177144,  97.117044,
              87.078323, 101.105312, 186.213917, 163.176449,  99.132996)
      
      aa <- c("ALA", "ARG", "ASN", "ASP", "CYS",
              "GLN", "GLU", "GLY", "HIS", "ILE",
              "LEU", "LYS", "MET", "PHE", "PRO",
              "SER", "THR", "TRP", "TYR", "VAL")

      mat <- data.frame(aa3=aa, aa1=aa321(aa), mass=w, formula=NA, name=NA)
      rownames(mat) <- aa
    }
    else  {
      ## Read data matrix
      mat <- bio3d::aa.table
    }
    
    ## Data frame with column names: aa3, aa1, mass, formula, name
    if (!is.null(mass.custom)) {
      if(!is.list(mass.custom))
        stop("'mass.custom' must be of class 'list'")
      
      new.aas <- names(mass.custom)
      if(any(duplicated(new.aas))) {
        mass.custom[duplicated(new.aas)] <- NULL
        warning("duplicate residue name(s) in 'mass.custom'. using first occurrence(s) only.")
      }

      new.aas <- names(mass.custom)
      if(any(new.aas %in% mat$aa3)) {
        dups <- paste(unique(new.aas[new.aas %in% mat$aa3]), collapse=", ")
        warning(paste("residue name(s)", dups,
                      "exists in 'aa.table'. overwriting with provided value(s)."))
      }
      
      for(new.aa in new.aas) {
        if( new.aa %in% rownames(mat) ) {
          ## Replace residue mass
          mat[new.aa, "mass"] = mass.custom[[ new.aa ]]
        }
        else {
          ## Add new residue to data frame (aa.table)
          nr <- data.frame(list(aa3=new.aa, aa1="X",
                                mass=mass.custom[[ new.aa ]],
                                formula=NA, name=NA))
          rownames(nr) <- new.aa
          mat <- rbind(mat, nr)
        }
      }
    }

    ## Fetch mass from data frame
    wts <- mat[sequ, "mass"]
    
    ## Check for missing masses
    if(NA %in% wts) {
      inds <- which(wts %in% NA)
      unknown <- paste(unique(sequ[inds]), collapse=" ")
      stop(paste("Unknown amino acid identifier: ", unknown, sep=""))
    }
    
    if(addter) {
      wts[1] <- wts[1] + atom2mass("H")
      wts[length(wts)] <- wts[length(wts)] + atom2mass("O") + atom2mass("H")
    }
    return(wts)
  }

context("Testing aa2mass()")


test_that("Amino acid mass tests", {

  ## Simple test
  sequ   <- c("ALA", "LYS", "TPO")
  masses <- c(71.078, 129.180, 181.084)
  
  expect_that(aa2mass(sequ, addter=FALSE, mmtk=FALSE, mass.custom=NULL),
              equals(masses, tolerance=1e-6))

  ## With Terminal atoms added
  masses <- c(72.08594, 129.18000, 198.09134)
  expect_that(aa2mass(sequ, addter=TRUE, mmtk=FALSE, mass.custom=NULL),
              equals(masses, tolerance=1e-6))
  
  ## With 'custom' residues
  sequ   <- c("MLY", "HMM", "UNK")
  masses <- c(156.225, 10.000, 20.001)
  expect_that(aa2mass(sequ, addter=FALSE, mmtk=FALSE,
                      mass.custom=list(HMM=10, UNK=20.001)),
              equals(masses, tolerance=1e-6))
   
}
          )

# Correlation network suboptimal path analysis
#
# Reference 
# Yen, J.Y. (1971) Finding the K Shortest Loopless Paths in a Network.
# Management Science. 17(11):712-716.
cnapath <- function(cna, from, to=NULL, k=10, collapse=TRUE, ncore=NULL, ...) {

  oops <- requireNamespace("igraph", quietly = TRUE)

  if (!oops) 
     stop("igraph package missing: Please install, see: ?install.packages")
  
  if(!inherits(cna, "cna")) {
     if(is.list(cna)) {
        paths <- lapply(cna, cnapath, from=from, to=to, k=k, collapse=collapse, ncore=ncore, ...)
        class(paths) <- c("ecnapath", class(paths))
        return( paths )
     } 
     stop("Input cna is not a 'cna' object")
  }

  ncore = setup.ncore(ncore)

  pairs <- NULL
  if(is.null(to)) {
     if(is.matrix(from)) {
        pairs <- apply(from, 1, function(x) list(from=x[1], to=x[2]))
     } else {
        # all other nodes as sink
        to <- setdiff(seq_along(igraph::V(cna$network)), from)
     }
  } 
  if(is.null(pairs)) {
     from <- unique(from); to <- unique(to)
     for(i in 1:length(from)) 
        for(j in 1:length(to)) pairs <- c(pairs, list(list(from=from[i], to=to[j])))
  }

  ## Initialize progress bar
  pb <- .init.pb(ncore, min=0, max=k*length(pairs))

  ## optimize ncore partition
  ncore.out <- ifelse(ncore < length(pairs), ncore, length(pairs))
  ncore.in <- as.integer(floor(ncore / ncore.out))

  paths <- mclapply(pairs, function(x)
              .cnapath.core(cna=cna, from=x$from, to=x$to, k=k, ncore=ncore.in, 
                 pb=pb, ...), mc.cores=ncore.out)
  
  rm.inds <- sapply(paths, is.null)
  if(sum(rm.inds) == length(paths)) {
     warning(paste("  No path found.\n", 
         "  Please check if the network contains isolated parts!\n\n", sep=""))
     paths <- NULL
  } else {

      if(collapse) {
         paths <- paths[!rm.inds]
         cls <- class(paths[[1]])
         coms <- names(paths[[1]])
         paths <- lapply(coms, function(x) do.call(c, lapply(paths, "[[", x)) )
         names(paths) <- coms 
         class(paths) <- cls
      }
      if(sum(rm.inds)>0) {
         warning(paste("  No path found for some source/sink pairs.\n", 
         "  Please check if the network contains isolated parts!\n\n", sep=""))
      }
  }

  ## Finish progress bar
  .close.pb(pb)

  return(paths)
}

.cnapath.core <- function(cna, from, to, k=1, ncore=1, pb=NULL, ...) {
  
  graph = cna$network

  # which path from the list is the shortest?
  select.shortest.path <- function(variants){
     return( which.min( unlist( lapply( variants, function(x){x$dist} ) ) ) )
  }

  # does a list contain this path?
  contains.path <- function(variants, variant){
     return( any( unlist( lapply( variants, function(x){ isTRUE(all.equal(x$path, variant)) } ) ) ) )
  }

  # first shortest path
  k0 <- suppressWarnings( igraph::get.shortest.paths(graph, from, to, output='both', ...) )
  
  # if no shortest path found, network contains isolated parts.
  if(length(k0$vpath[[1]]) <= 1) {
#     cat("  No path found.\n", 
#         "  Please check if the network contains isolated parts!\n\n", sep="")
     if(!is.null(pb)) .update.pb(pb, step=k)
     return(NULL)
  }

  # number of currently found shortest paths
  kk <- 1
  if(!is.null(pb)) .update.pb(pb)

  # All shortest paths are stored in container A in order
  dist = sum(igraph::E(graph)$weight[k0$epath[[1]]])
  A <- list(list(path=as.integer(k0$vpath[[1]]), epath=as.integer(k0$epath[[1]]), dist=dist))

  # All candidates are stored in container B
  B <- list()

  # until k shortest paths are found
  while(kk < k){
    # take last found shortest path
    last.path <- A[[length(A)]]
    
    tmpB <- mclapply(1:(length(last.path$path)-1), function(i) {    
       spurNode <- last.path$path[i]
       rootPath <- last.path$path[1:i]
       if(i==1) rootePath = NULL
       else rootePath = last.path$epath[1:(i-1)]

       # Remove edges that coincide with the next step from the spur node on
       # those shortest paths stored in A that share the same root path here
       g <- graph
       for(j in 1:length(A)) {
          if(length(A[[j]]$path) > i && isTRUE(all.equal(rootPath, A[[j]]$path[1:i]))) {
             nn = A[[j]]$path[i+1]
             ee = igraph::E(g)[igraph::'%--%'(spurNode, nn)]
             if(length(ee)>0) g <- igraph::delete.edges(g, ee)
          }
       }
       # Remove all edges that link to nodes on the root path (excluding the spur node)
       if(i > 1) {
          for(j in rootPath[-(length(rootPath))]) {
             ee = igraph::incident(g, j) 
             if(length(ee)>0) g <- igraph::delete.edges(g, ee)
          }
       }

       # Suppress warnings because some nodes are intentionally isolated 
       spurPath <- suppressWarnings(igraph::get.shortest.paths(g, spurNode, to, output='both'), ...)

       if(length(spurPath$vpath[[1]]) > 1 ) {
          vpath = c(rootPath, as.integer(spurPath$vpath[[1]][-1]))
          if(!contains.path(B, vpath)) {
             spurPath$epath <- as.integer(igraph::E(graph, path=as.integer(spurPath$vpath[[1]])))
             epath = c(rootePath, spurPath$epath)
             return (list(path=vpath, epath = epath, dist = sum(igraph::E(graph)$weight[epath])) )
          }
       }
       NULL
    }, mc.cores = ncore )
    tmpB <- tmpB[ !sapply(tmpB, is.null) ]
    B <- c(B, tmpB)
    if(length(B) == 0) break
    
    # find shortest candidate
    sp <- select.shortest.path(B)

    # add to A, increase kk, remove shortest path from list of B
    A <- c(A, B[sp])
    kk <- kk + 1
    B <- B[-sp]

    if(!is.null(pb)) .update.pb(pb)
  }

  # stopped before reaching k paths
  if(kk < k) {
    if(!is.null(pb)) .update.pb(pb, k-kk)
    warning("Reaching maximal number of possible paths (", kk, ")")
  }

  out <- list(path=lapply(A, "[[", "path"),  
              epath = lapply(A, "[[", "epath"), 
              dist = sapply(A, "[[", "dist"))
  class(out) <- "cnapath"
  return(out)
}

"gap.inspect" <-
function(x) {
  
  # Report the number of gaps, ("-",".",NA), per
  # row (i.e. seq) and col (i.e. position) in a
  # given "alignment" 'x'

  if(is.vector(x)) {
    gaps <- is.gap(x)
    inds <- which(gaps)
    f.inds <- which(!gaps)
    gap.pos <- as.numeric(gaps)
    gap.col <- gap.pos
    gap.row <- sum(gaps)
  } else {
    if(is.list(x)) {
      if(inherits(x, "pdbs")) {
        x <- x$xyz; warning("Taking $xyz component (NOT $ali for which you should use 'gap.inspect(x$ali)')")
      } else {
        x <- x$ali
      }
    }
    
    gap.pos1 <-( as.numeric(x=="-") + as.numeric(x==".") )
    gap.pos2 <- as.numeric(is.na(gap.pos1))
    
    gap.pos<-matrix( colSums(rbind(gap.pos1,gap.pos2), na.rm=TRUE),
                    ncol=ncol(x))
  
    gap.col <- colSums(gap.pos)
    gap.row <- rowSums(gap.pos)
    inds <- which(gap.col!=0)
    ##f.inds=(1:ncol(x))[-inds]
    f.inds <- which(gap.col == 0)
  }
  output=list(t.inds=inds, f.inds=f.inds,
    row=gap.row, col=gap.col, bin=gap.pos)
}

context("Testing pca()")

test_that("pca functions works", {
  "mysign" <- function(a,b) {
    if(all(sign(a)==sign(b)))
      return(1)
    else
      return(-1)
  }

  attach(transducin)
  inds <- unlist(lapply(c("1TND_A", "1TAG", "1AS0", "1AS2"), grep, pdbs$id))
  pdbs <- trim.pdbs(pdbs, row.inds=inds)
  gaps <- gap.inspect(pdbs$xyz)

  ## Calc modes
  invisible(capture.output(pc <- pca(pdbs)))

  ## check dimensions
  expect_that(dim(pc$U), equals(c(939, 939)))
  expect_that(length(pc$L), equals(939))

  ## check eigenvalues
  Lexpected <- c(1.964689e+02, 1.715903e+02, 7.091482e+01)

  expect_that(head(pc$L, n=3), equals(Lexpected, tolerance=1e-6))

  ## check atom-wise loadings
  AUexpected <- c(0.013422274, 0.023879443, 0.022779307, 0.023490288, 0.006308588, 0.010057694)
  expect_that(head(pc$au[,1], n=6), equals(AUexpected, tolerance=1e-6))

  Z1expected <- c(-3.555218, -12.081135, -4.602888, 20.239240)
  Z1now <- as.numeric(head(pc$z[,1], n=4))
  expect_that(Z1now * mysign(Z1expected, Z1now), equals(Z1expected, tolerance=1e-6))

  Mexpected <- c(30.12193, 67.76449, 43.36594, 27.01919, 69.66411, 44.47434)
  expect_that(head(pc$mean, n=6), equals(Mexpected, tolerance=1e-6))

  detach(transducin)
})

context("Testing nma.pdbs()")

test_that("eNMA works", {

  skip_on_cran()

  "mysign" <- function(a,b) {
    if(all(sign(a)==sign(b)))
      return(1)
    else
      return(-1)
  }

  attach(transducin)
  inds <- unlist(lapply(c("1TND_A", "1TAG", "1AS0", "1AS2"), grep, pdbs$id))
  pdbs <- trim.pdbs(pdbs, row.inds=inds)
  gaps <- gap.inspect(pdbs$xyz)


  ## Calc modes
  invisible(capture.output(modes <- nma.pdbs(pdbs, fit=TRUE, rm.gaps=TRUE, ncore=1)))

  ## check dimensions
  expect_that(dim(modes$U), equals(c(939, 933, 4)))
  expect_that(dim(modes$L), equals(c(4, 933)))
  expect_that(dim(modes$fluctuations), equals(c(4, 313)))
  
  ## structure 1- mode1:
  U1 <- c(-0.046380187,  0.007816393,  0.078933552, -0.041820111, 0.009819448, 0.047598954)
  nowU1 <- head(modes$U.subspace[,1,1], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))

  ## structure 1- mode2:
  U2 <- c(0.007819148, -0.005717370, -0.051933927, 0.002265788, -0.013386437, -0.039409712)
  nowU2 <- head(modes$U.subspace[,2,1], n=6)
  expect_that(nowU2 * mysign(U2, nowU2), equals(U2, tolerance=1e-6))

  ## structure 4- mode3:
  U3 <- c(-0.13697744, -0.05401178,  0.09615700, -0.11026525, -0.01510157, 0.05796091)
  nowU3 <- head(modes$U.subspace[,3,4], n=6)
  expect_that(nowU3 * mysign(U3, nowU3), equals(U3, tolerance=1e-6))

  ## structure 4-mode1 - tail:
  U1 <- c(0.009820174, 0.004566910, -0.055544781, 0.009938013, 0.006707436, -0.068154672)
  nowU1 <- tail(modes$U.subspace[,1,4], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))


  ## Fluctuations:
  f1 <- c(0.3657288, 0.2196504, 0.1449100, 0.1217517, 0.1130416, 0.1007862)
  f2 <- c(0.5295304, 0.3004094, 0.2011062, 0.1401276, 0.1205508, 0.1011349)
  f4 <- c(0.6488982, 0.3079024, 0.2166070, 0.1504672, 0.1282899, 0.1029634)

  expect_that(modes$fluctuations[1,1:6], equals(f1, tolerance=1e-6))
  expect_that(modes$fluctuations[2,1:6], equals(f2, tolerance=1e-6))
  expect_that(modes$fluctuations[4,1:6], equals(f4, tolerance=1e-6))
  
  ## Orthognal
  expect_that(as.numeric(modes$U.subspace[,1,1] %*% modes$U.subspace[,1,1]),
              equals(1, tolerance=1e-6))
  expect_that(as.numeric(modes$U.subspace[,1,1] %*% modes$U.subspace[,2,1]),
              equals(0, tolerance=1e-6))

  ## RMSIP
  rmsips <- c(1.0000, 0.9174, 0.9441, 0.9251)
  expect_that(as.vector(modes$rmsip[1,]), equals(rmsips, tolerance=1e-6))

  
  ## Multicore (same arguments as above!)
  skip_on_travis()

  invisible(capture.output(mmc <- nma.pdbs(pdbs, fit=TRUE, rm.gaps=TRUE, ncore=NULL)))
  expect_that(mmc$fluctuations, equals(modes$fluctuations, tolerance=1e-6))
  expect_that(mmc$U.subspace, equals(modes$U.subspace, tolerance=1e-6))


  
  ## Calc modes with rm.gaps=FALSE
  invisible(capture.output(modes <- nma.pdbs(pdbs, fit=TRUE, rm.gaps=FALSE, ncore=NULL)))

  ## structure 1-mode1 - tail:
  U1 <- c(0.04397369, -0.01400912, -0.02123377, 0.08124317, -0.02660929, -0.02619898)
  nowU1 <- tail(modes$U.subspace[,1,1], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))

  ## structure 1-mode1 - tail:
  U1 <- c(0.001300939, -0.053317847,  0.011292943, 0.003307034, -0.071684004, NA)
  nowU1 <- modes$U.subspace[938:943,1,2]
  U1[is.na(U1)] <- 0
  nowU1[is.na(nowU1)] <- 0
  expect_that(nowU1 * mysign(nowU1, U1), equals(U1, tolerance=1e-6))

  ## fluctuations
  na.expected <- c(3, 4, 1258, 1259, 1262, 1263, 1266, 1267, 1268, 1270, 1271, 1272, 1274, 1275, 1276,
                   1278, 1279, 1280, 1282, 1283, 1284, 1286, 1287, 1288, 1290, 1291, 1292)
                   
  expect_that(which(is.na(modes$fluctuations)), equals(na.expected))
  
 
  f1 <- c(0.59967448, 0.34438649, 0.20382435, 0.13350449)
  f4 <- c(0.3335200, 0.4255609, 0.5941589, rep(NA, 7))
          
  expect_that(modes$fluctuations[1,1:4], equals(f1, tolerance=1e-6))
  expect_that(tail(modes$fluctuations[4,], n=10), equals(f4, tolerance=1e-6))


   ## Calc modes with mass=FALSE and temp=NULL
  invisible(capture.output(modes <- nma.pdbs(pdbs, mass=FALSE, temp=NULL, ncore=NULL)))

  ## structure 1- mode1:
  U1 <- c(-0.04043330,  0.00730273,  0.07000757, -0.04520831,  0.01130271,  0.05337233)
  nowU1 <- head(modes$U.subspace[,1,1], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))
  
  ## structure 1- mode2:
  U2 <- c(-0.002813312,  0.005765808,  0.039807147,  0.001667637,  0.014587327, 0.038682763)
  nowU2 <- head(modes$U.subspace[,2,1], n=6)
  expect_that(nowU2 * mysign(U2, nowU2), equals(U2, tolerance=1e-6))

  ## structure 5- mode3:
  U3 <- c(0.11324262, 0.04220159, -0.07597465,  0.10267147,  0.01483591, -0.05261675)
  nowU3 <- head(modes$U.subspace[,3,4], n=6)
  expect_that(nowU3 * mysign(U3, nowU3), equals(U3, tolerance=1e-6))


  
  ## Calc modes with mass=FALSE and temp=NULL and ff="anm"
  invisible(capture.output(modes <- nma.pdbs(pdbs, mass=FALSE, temp=NULL, ff="anm", ncore=NULL)))

  ## structure 3- mode10:
  U1 <- c(0.03630660,  0.03078575, -0.02376714,  0.01906218,  0.01110582, -0.01361602)
  nowU1 <- head(modes$U.subspace[,10,3], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))
  
  ## structure 4- mode1:
  U1 <- c(-0.04113844,  0.01096919,  0.07368620, -0.04250786,  0.01320282,  0.05550216)
  nowU1 <- head(modes$U.subspace[,1,4], n=6)
  expect_that(nowU1 * mysign(U1, nowU1), equals(U1, tolerance=1e-6))

  f1 <- c(0.3630744, 0.2768045, 0.1996179, 0.1766148)
  f2 <- c(0.5231570, 0.3519813, 0.2331503, 0.2003372)
  expect_that(modes$fluctuations[1,1:4], equals(f1, tolerance=1e-6))
  expect_that(modes$fluctuations[2,1:4], equals(f2, tolerance=1e-6))

  detach(transducin)
})
          

  

# radius of gyration
# xyz: length 3N, 1D array of atomic coordinates,
#      M*3N matrix, or a list object containing xyz
# mass: length N 1D array of atomic masses [amu],
#      or a PDB object having masses stored in the 
#      "B-factor" column
rgyr <- function(xyz, mass=NULL, ncore=1, nseg.scale=1)
{
   # Parallelized by parallel package
   ncore <- setup.ncore(ncore)
   if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
   }
    
   # check xyz, vector, matrix, or list
   if(is.list(xyz)) 
      xyz <- xyz$xyz
   if(is.vector(xyz))
      xyz <- matrix(xyz, nrow=1)
   
   #check mass array and load masses
   if(is.list(mass)) 
     mass <- mass$atom[,"b"]
   if(is.null(mass))
     # assume carbon
     mass <- rep(12.01, ncol(xyz)/3)

   if(ncol(xyz)/3 != length(mass)) 
      stop("The length of masses doesn't match the number of atoms") 
   
   rg <- function (xyz, mass) {
      nAtom <- length(mass)
      mc <- matrix(xyz, 3, nAtom)
      v <- replicate(3, mass) * t(mc)

      com <- colSums(v)/sum(mass)

      recenteredpos <- mc - replicate(nAtom, com)
      rog_sq <- sum(colSums(recenteredpos**2) * mass)
      rog_sq <- rog_sq / sum(mass)
      return( sqrt(rog_sq) )
   }

   if(ncore > 1) {
      RLIMIT = R_NCELL_LIMIT
      nDataSeg = floor((nrow(xyz)-1)/RLIMIT)+1
      nDataSeg = floor(nDataSeg * nseg.scale)
      lenSeg = floor(nrow(xyz)/nDataSeg)
      rog <- NULL
      for(i in 1:nDataSeg) {
         istart = (i-1)*lenSeg + 1
         iend = if(i<nDataSeg) i*lenSeg else nrow(xyz)
         rog <- c(rog, mclapply(istart:iend, function(j)
                     rg(xyz[j,], mass)))
      }
      rog <- unlist(rog)
   } else {
      rog <- apply(xyz, 1, rg, mass)
   }
   return(rog)
}

`vec2resno` <-
function(vec, resno) {
  ## replicate vec based on concetive
  ## similar resno entries

  if(is.pdb(resno))
    resno <- resno$atom[,"resno"]

  res.len <- rle(resno)$lengths
  if(length(vec) != length(res.len))
    stop("Length miss-match of 'vec' and concetive 'resno'")

  if( sum(res.len) != length(resno) )
    stop("Replicated length Miss-match")
  
  return( rep(vec,  times=res.len))
}

"core.cmap" <-
function(pdbs,
         write.pdb = FALSE,
         outfile = "core.pdb",
         cutoff = NULL, 
         refine = FALSE, 
         ncore = NULL,
         ...) {

  ##  Quickly find core positions that have the largest number
  ##  of contact with neighboring residues 

  ncore <- setup.ncore(ncore)

  if(is.pdbs(pdbs)) {
     xyz=pdbs$xyz

     xyz.inds <- gap.inspect(xyz)$f.inds 
     res.inds <- gap.inspect(pdbs$ali)$f.inds

     pdbseq = aa123(pdbs$ali[1,]); pdbnum = pdbs$resno[1,]

  } else if(is.xyz(pdbs)) {
    xyz <- pdbs

    xyz.inds <- gap.inspect(xyz)$f.inds
    res.inds <- xyz2atom(xyz.inds)

    pdbseq = rep("ALA",length(xyz.inds)/3)
    pdbnum = c(1:(length(xyz.inds)/3))

  } else {
    stop("input 'pdbs' should either be:
             a 'pdbs' object as obtained from 'read.fasta.pdb'
             or a numeric 'xyz' matrix of aligned coordinates")
  }

  if(is.null(cutoff)) cutoff <- 1/sqrt(length(res.inds))

  cmap.default <- list(dcut=10, scut=3, pcut=1, mask.lower=FALSE, ncore=ncore)
  cmap.args <- .arg.filter( cmap.default, FUN=cmap.xyz, ...)
  cm <- do.call(cmap.xyz, c(list(xyz=xyz[, xyz.inds]), cmap.args) )
  cm[is.na(cm)] <- 0

  dm.default <- list(scut=3, mask.lower=FALSE, ncore=ncore)
  dm.args <- .arg.filter( dm.default, FUN=dm.xyz, ... )
  distmat <- do.call(dm.xyz, c(list(xyz=xyz[, xyz.inds]), dm.args) )
  distmat[is.na(distmat)] <- 0

  if(!is.na(dim(distmat)[3L])) 
    lt <- apply(distmat, 3, function(x) x[lower.tri(x)])
  else 
    lt <- as.matrix(distmat[lower.tri(distmat)])

#  mask <- apply(lt, 1, function(x) all(x==0))
#  vars <- apply(lt, 1, var)
  m <- rowMeans(lt)
  vars <- rowSums((lt - m)^2)/(ncol(lt)-1)
#  vars[vars>0] <- 1/(vars[vars>0])
  # normalize vars to solve numerical problems when some vars are very small
  vmin <- min(vars[cm[lower.tri(cm)]==1])
  vmax <- max(vars[cm[lower.tri(cm)]==1])
  if(vmax > vmin) 
     vars <- (vmax - vars) / (vmax - vmin)
  else
     vars <- 1 # ignore weight
#  vars <- 0.5 * (cos(vars * pi ) + 1) * 100

  varmat <- array(0, dim=dim(cm))
  varmat[lower.tri(varmat)] <- vars

  varmat[!cm] <- 0

  # calculate eigenvector centrality based on the weighted contact network
  ei <- eigen(varmat, symmetric=TRUE)

  if(refine) {
    # find all possible "core" positions in the top 10 PCs
    rsmall <- 0.01
    U <- ei$vector[, 1:10]
    U[abs(U) < rsmall] <- 0
    bcalc <- apply(U, 2, function(x) all(x>=0) | all(x<=0))
  
    if(sum(bcalc)==0) 
       stop('No valid eigenvector to define core atoms.')
  
    core.all <- apply(U[, bcalc, drop=FALSE], 2, function(x) {
      core <- list()
      core$atom <- res.inds[abs(x) > cutoff]
      core$xyz <- atom2xyz(core$atom)
      core
    })

    error.ellipsoid<-function(pos.xyz) {
      S<-var(pos.xyz)
      prj  <- eigen(S, symmetric = TRUE)
      prj$values[prj$values < 0 & prj$values >= -1.0E-12]<-1.0E-12
      vol<-4/3*pi*prod( sqrt( prj$values ) )
      out<-list(vol=vol, U=prj$vectors, L=prj$values)
    }
    
    if(length(core.all) > 1) {
       sv <- sapply(core.all, function(x) {
          if(length(x$atom) >=3) {
            xyz <- fit.xyz(pdbs$xyz[1, ], pdbs, x$xyz, x$xyz)
            xyz <- xyz[, xyz.inds]
            sum( sapply(1:(ncol(xyz)/3), function(i) error.ellipsoid(xyz[, atom2xyz(i)])$vol) )
          } else {
            -1
          }
       })
       sv[sv==-1] <- max(sv)
       core <- core.all[[which.min(sv)]]
    } else {
      core <- core.all[[1]]
    }

  } else {

    core <- list()
    core$atom <- res.inds[abs(ei$vector[, 1]) > cutoff]
    core$xyz <- atom2xyz(core$atom)

  }

  if(length(core$atom) < 3) {
     warning('Too few core atoms to do a proper fitting.')
     core$atom <- res.inds[order(abs(ei$vector[, 1]), decreasing=TRUE)[1:3]]
     core$xyz <- atom2xyz(core$atom)
  }

  if(write.pdb)
     write.pdb(xyz=xyz[1, core$xyz], resno=pdbnum[core$atom], 
       resid=pdbseq[core$atom], file=outfile) 
 
  class(core) <- 'select' 
  return(core)
}

".is.protein" <- function(pdb, byres=TRUE) {
  if(byres) {
    return(.is.protein1(pdb))
  }
  else {
    ## possible option to issue a warning when the two methods diverge
    sel1 <- .is.protein1(pdb)
    sel2 <- .is.protein2(pdb)
    
    if(!(identical(sel1, sel2))) {
      sel <- cbind(sel1, sel2)
      sums <- apply(sel, 1, sum)
      inds <- which(sums==1)
      unq <- paste(unique(pdb$atom$resid[inds]), collapse=",")
      warning(paste("possible protein residue(s) with non-standard residue name(s) \n   (", unq, ")"))
    }
    return(sel1)
  }
}

".is.protein1" <- function(pdb) {
  aa <- bio3d::aa.table$aa3
  return(pdb$atom$resid %in% aa)
}

".is.protein2" <- function(pdb) {
  resid <- paste(pdb$atom$chain, pdb$atom$insert, pdb$atom$resno, sep="-")

  at.ca <- resid[ pdb$atom$elety == "CA"]
  at.o  <- resid[ pdb$atom$elety == "O" ]
  at.c  <- resid[ pdb$atom$elety == "C" ]
  at.n  <- resid[ pdb$atom$elety == "N" ]

  common <- intersect(intersect(intersect(at.ca, at.o), at.n), at.c)
  return(resid %in% common)
}

".is.nucleic" <- function(pdb) {
  nuc.aa <- c("A",   "U",  "G",  "C",   "T",  "I",
              "DA", "DU", "DG", "DC",  "DT", "DI")
  return(pdb$atom$resid %in% nuc.aa)
}

".is.water" <- function(pdb) {
  hoh <- c("H2O", "OH2", "HOH", "HHO", "OHH", "SOL",
           "WAT", "TIP", "TIP2", "TIP3", "TIP4")
  return(pdb$atom$resid %in% hoh)
}

".is.hydrogen" <- function(pdb) {
  return(substr( gsub("^[123]", "",pdb$atom$elety) , 1, 1) %in% "H")
}

.match.type <- function(pdb, t) {
  if(!is.character(t))
    stop("'type' must be a character vector")
  pdb$atom$type %in% t
}

.match.eleno <- function(pdb, eleno) {
  if(!is.numeric(eleno))
    stop("'eleno' must be a numeric vector")
  pdb$atom$eleno %in% eleno
}

.match.elety <- function(pdb, elety) {
  if(!is.character(elety))
    stop("'elety' must be a character vector")
  pdb$atom$elety %in% elety
}

.match.resid <- function(pdb, resid) {
  if(!is.character(resid))
    stop("'resid' must be a character vector")
  pdb$atom$resid %in% resid
}

.match.chain <- function(pdb, chain) {
  if(!is.character(chain))
    stop("'chain' must be a character vector")
  pdb$atom$chain %in% chain
}

.match.resno <- function(pdb, resno) {
  if(!is.numeric(resno))
    stop("'resno' must be a numeric vector")
  pdb$atom$resno %in% resno
}


.match.insert <- function(pdb, insert) {
  # insert should be NA or a character vector
  if(!all(is.na(insert))) {
    if(!is.character(insert[ !is.na(insert) ]))
      stop("'insert' must be a character vector")
  }

  ## NA and '' are treated the same 
  if(any(insert=="", na.rm=TRUE))
    insert[ insert == "" ] = NA
  if(any(pdb$atom$insert == "", na.rm=TRUE))
    pdb$atom$insert[ pdb$atom$insert == "" ] = NA
  
  pdb$atom$insert %in% insert
}

.match.segid <- function(pdb, segid) {
  # segid should be NA or a character vector
  if(!all(is.na(segid))) {
    if(!is.character(segid[ !is.na(segid) ]))
      stop("'segid' must be a character vector")
  }

  ## NA and '' are treated the same 
  if(any(segid=="", na.rm=TRUE))
    segid[ segid == "" ] = NA
  if(any(pdb$atom$segid == "", na.rm=TRUE))
    pdb$atom$segid[ pdb$atom$segid == "" ] = NA
  
  pdb$atom$segid %in% segid
}

atom.select.pdb <- function(pdb, string = NULL,
                            type  = NULL, eleno = NULL, elety = NULL,
                            resid = NULL, chain = NULL, resno = NULL,
                            insert = NULL, segid = NULL, 
                            operator = "AND", inverse = FALSE,
                            value = FALSE, verbose=FALSE,  ...) {

  if(!is.pdb(pdb))
    stop("'pdb' must be an object of class 'pdb'")

  ## check input operator
  op.tbl <- c(rep("AND",3), rep("OR",4))
  operator <- op.tbl[match(operator, c("AND","and","&","OR","or","|","+"))]
  if(!operator %in% c("AND", "OR"))
    stop("Allowed values for 'operator' are 'AND' or 'OR'")

  ## check input string
  if(!is.null(string)) {
    str.allowed <- c("all", "protein", "notprotein", "nucleic", "notnucleic", "water", "notwater",
                     "calpha", "cbeta", "backbone", "back", "side", "sidechain", "ligand", "h", "noh")
    if(!(string %in% str.allowed))
      stop("Unknown 'string' keyword. See documentation for allowed values")
  }

  ## verbose message output
  if(verbose) cat("\n")
  .verboseout <- function(M, type) {
    cat(" .. ", sprintf("%08s", length(which(M))), " atom(s) from '", type, "' selection \n", sep="")
  }

  ## combine logical vectors
  .combinelv <- function(L, M, operator) {
    if(operator=="AND") M <- L & M
    if(operator=="OR") M <- L | M
    return(M)
  }
  
  cl <- match.call()
  if(operator=="AND")
    M <- rep(TRUE, nrow(pdb$atom))
  if(operator=="OR")
    M <- rep(FALSE, nrow(pdb$atom))
  
  if(!is.null(string)) {   
    M <- switch(string,
                all         =   M <- rep(TRUE, nrow(pdb$atom)),
                protein     =  .is.protein(pdb),
                notprotein  = !.is.protein(pdb),
                nucleic     =  .is.nucleic(pdb),
                notnucleic  = !.is.nucleic(pdb),
                water       =  .is.water(pdb),
                notwater    = !.is.water(pdb),
                calpha      =  .is.protein(pdb)  & .match.elety(pdb, "CA"),
                cbeta       =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O", "CB")),
                backbone    =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O")),
                back        =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O")),
                sidechain   =  .is.protein(pdb)  & !.match.elety(pdb, c("CA", "N", "C", "O")),
                side        =  .is.protein(pdb)  & !.match.elety(pdb, c("CA", "N", "C", "O")),
                ligand      = !.is.protein(pdb)  & !.is.nucleic(pdb) & !.is.water(pdb),
                h           =  .is.hydrogen(pdb),
                noh         = !.is.hydrogen(pdb),
                NA
                )
                
    if(verbose) {
      .verboseout(M, 'string')
    }
  }
  
  if(!is.null(type)) {
    L <- .match.type(pdb, type)
    if(verbose) .verboseout(L, 'type')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(eleno)) {
    L <- .match.eleno(pdb, eleno)
    if(verbose) .verboseout(L, 'eleno')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(elety)) {
    L <- .match.elety(pdb, elety)
    if(verbose) .verboseout(L, 'elety')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(resid)) {
    L <- .match.resid(pdb, resid)
    if(verbose) .verboseout(L, 'resid')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(chain)) {
    L <- .match.chain(pdb, chain)
    if(verbose) .verboseout(L, 'chain')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(resno)) {
    L <- .match.resno(pdb, resno)
    if(verbose) .verboseout(L, 'resno')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(insert)) {
    L <- .match.insert(pdb, insert)
    if(verbose) .verboseout(L, 'insert')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(segid)) {
    L <- .match.segid(pdb, segid)
    if(verbose) .verboseout(L, 'segid')
    M <- .combinelv(L, M, operator)
  }

  if(verbose)
    cat(" ..", sprintf("%08s", length(which(M))), "atom(s) in final combined selection \n")

  if(inverse) {
    if(verbose) {
      cat(" ..", sprintf("%08s", length(which(!M))), "atom(s) in inversed selection \n")
    }
    sele <- as.select(which(!M))
  }
  else
    sele <- as.select(which(M))

  sele$call <- cl
  if(verbose) cat("\n")

  if(value)
    return(trim.pdb(pdb, sele))
  else
    return(sele)
}

network.amendment <- function(x, membership, minus.log=TRUE){

  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }

  if(!inherits(x, "cna")){
    stop("Input x must be a 'cna' class object as obtained from cna()")
  }

  if(!is.numeric(membership)){
    stop("Input membership must be a numeric vector")
  }

  if(length(membership) != length(x$communities$membership)){
    stop("Input membership and x$community$membership must be of the same length")
  }
     
  contract.matrix <- function(cij.network, membership,## membership=comms$membership,
                              collapse.method="max", minus.log=TRUE){
    
    ## Function to collapse a NxN matrix to an mxm matrix
    ##  where m is the communities of N. The collapse method
    ##  can be one of the 'collapse.options' below

    ## convert to the original cij values if "-log" was used
    
    if(minus.log){
      cij.network[cij.network>0] <- exp(-cij.network[cij.network>0])
    }
    
    collapse.options=c("max", "median", "mean", "trimmed")
    collapse.method <- match.arg(tolower(collapse.method), collapse.options)

    ## Fill a 'collapse.cij' nxn community by community matrix
    node.num <- max(x$communities$membership)
    if(node.num > 1){
      collapse.cij <- matrix(0, nrow=node.num, ncol=node.num)
      inds <- pairwise(node.num)

      for(i in 1:nrow(inds)) {
        comms.1.inds <- which(membership==inds[i,1])
        comms.2.inds <- which(membership==inds[i,2])
        submatrix <- cij.network[comms.1.inds, comms.2.inds]

        ## Use specified "collapse.method" to define community couplings
        collapse.cij[ inds[i,1], inds[i,2] ] = switch(collapse.method,
                    max = max(submatrix),
                    median = median(submatrix),
                    mean = mean(submatrix),
                    trimmed = mean(submatrix, trim = 0.1))
      }
      
      if(minus.log){
        collapse.cij[collapse.cij>0] <- -log(collapse.cij[collapse.cij>0])
      }
      
      ## Copy values to lower triangle of matrix and set colnames
      collapse.cij[ inds[,c(2,1)] ] = collapse.cij[ inds ]
      colnames(collapse.cij) <- 1:ncol(collapse.cij)
    }
    else{
      warning("There is only one community in the $communities object.
               $community.cij object will be set to 0 in the 
               contract.matrix() function.")

      collapse.cij <- 0
    }

    class(collapse.cij) <- c("dccm", "matrix")
    return(collapse.cij)
  }


  x$communities$membership <- membership

  x$community.cij <- contract.matrix(x$cij, membership, minus.log=minus.log)
  
  cols=vmd_colors()
  
#  if(sum(x$community.cij)>0){
    x$community.network <-  igraph::graph.adjacency(x$community.cij,
                                          mode="undirected",
                                          weighted=TRUE,
                                          diag=FALSE)
        
    ##-- Annotate the two networks with community information
    ## Check for duplicated colors
    if(max(x$communities$membership) > length(unique(cols)) ) {
      warning("The number of communities is larger than the number of unique 
              'colors' provided as input. Colors will be recycled")
    }
  
    ## Set node colors
    igraph::V(x$network)$color <- cols[x$communities$membership]
    igraph::V(x$community.network)$color <- cols[ 1:max(x$communities$membership)]
  
    ## Set node sizes
    igraph::V(x$network)$size <- 1
    igraph::V(x$community.network)$size <- table(x$communities$membership)

#  }

  return(x)
}

setup.ncore <- function(ncore, bigmem = FALSE) {
  if(is.null(ncore) || ncore > 1) {
    os1 <- .Platform$OS.type
    if(os1 == "windows") {
       if(is.null(ncore)) 
          ncore = 1
       else
          stop("Multicore is NOT supported in Windows (Set ncore = 1 or NULL)")
    } else {
       if(bigmem) {
         oops <- requireNamespace("bigmemory", quietly = TRUE)
         if(!oops) {
           if(is.null(ncore))
             ncore <- 1
           else
             stop("Please install the bigmemory package from CRAN for running with multicore")
         }
       }
       if(is.null(ncore))
         ncore = parallel::detectCores()

       ## parallel::detectCores() returns 'NA' if the answer is unknown
       if(is.na(ncore))
           ncore <- 1
       
       # Following lines check R internal varible for potential limit on multicore usage
       # Normally it does nothing, but will be helpful in running `R CMD check --as-cran`
       if(ncore > 1) {
          chk <- tolower(Sys.getenv("_R_CHECK_LIMIT_CORES_", ""))
          if (nzchar(chk) && (chk != "false")) ncore = 1
       }

    }
  }
  options(mc.cores = ncore)
  return(ncore)
}

covsoverlap <- function(...)
  UseMethod("covsoverlap")

covsoverlap.enma <- function(enma, ncore=NULL, ...) {
  if(!inherits(enma, "enma"))
    stop("provide a 'enma' object as obtain from function 'nma.pdbs()'")
  if(any(is.na(enma$fluctuations)))
    stop("provide 'enma' object calculated with argument 'rm.gaps=TRUE'")
  
  ncore <- setup.ncore(ncore, bigmem = FALSE)

  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply

  cat("Calculating pairwise covariance overlap coefs")

  m <- dim(enma$U.subspace)[3]
  mat <- matrix(NA, m, m)
  ##inds <- pairwise(m)
  inds <- rbind(pairwise(m),
                matrix(rep(1:m,each=2), ncol=2, byrow=T))
  
  mylist <- mylapply(1:nrow(inds), function(row) {
    i <- inds[row,1]; j <- inds[row,2];
    a <- list(U=enma$U.subspace[,,i], L=enma$L[i, ])
    b <- list(U=enma$U.subspace[,,j], L=enma$L[j, ])
    val <- covsoverlap.nma(a, b, ...)
    out <- list(val=val, i=i, j=j)
    cat(".")
    return(out)
  })
  
  for ( i in 1:length(mylist)) {
    tmp <- mylist[[i]]
    mat[tmp$i, tmp$j] <- tmp$val
  }

  mat[ inds[,c(2,1)] ] = mat[ inds ]
  ##diag(mat) <- rep(1, n)

  rownames(mat) <- basename(rownames(enma$fluctuations))
  colnames(mat) <- basename(rownames(enma$fluctuations))
  
  cat("\n")
  return(round(mat, 6))
}


covsoverlap.nma <- function(a, b, subset=NULL, ...) {
  if(any(missing(a), missing(b)))
    stop("provide eigenvectors and eigenvalues")

  dims.a <- dim(a$U)
  dims.b <- dim(b$U)
  
  if(dims.a[1]!=dims.b[1])
    stop("dimension mismatch")

  if(!is.null(subset)) {
    if(subset>ncol(a$U))
      subset <- ncol(a$U)
    
    a$U <- a$U[,1:subset]
    b$U <- b$U[,1:subset]
    a$L <- a$L[1:subset]
    b$L <- b$L[1:subset]
  }

  sumb <- 0
  for( k in 1:ncol(a$U) ) {
    tmp <- sqrt(a$L[k] * b$L)
    overlap <- c((t(a$U[,k]) %*% b$U)**2)
    sumb <- sumb + sum( tmp * overlap )
  }
  
  return(1 - ( sum(a$L + b$L) - 2 *sumb ) / sum(a$L + b$L))
}

as.pdb <- function(...)
  UseMethod("as.pdb")

as.pdb.default <- function(pdb=NULL, xyz=NULL, type = NULL, resno = NULL,
                           resid = NULL, eleno = NULL,
                           elety = NULL, chain = NULL,
                           insert= NULL, alt = NULL,
                           o = NULL,  b = NULL,
                           segid = NULL, elesy = NULL,
                           charge = NULL, verbose=TRUE, ...) {
  cl <- match.call()

  ## which input argument to determine number of atoms from
  input <- list(pdb=pdb, xyz=xyz, eleno=eleno, resno=resno, resid=resid)
  nulls <- unlist(lapply(input, is.null))
  inds  <- which(!nulls)

  if(length(inds)==0)
    stop("insufficient arguments. provide 'pdb', 'xyz', 'eleno', 'resno', and/or 'resid'")

  ## check content of pdb
  if(!is.null(pdb)) {
    if(!is.pdb(pdb))
      stop("'pdb' must be of class 'pdb' as obtained from 'read.pdb'")
  }

  ## check content of xyz
  if(!is.null(xyz)) {
    if(!(is.numeric(xyz) & (is.matrix(xyz) | is.vector(xyz))))
      stop("'xyz' must be a numeric vector/matrix")
    
    xyz <- as.xyz(xyz)
  }

  ## if pdb is provided use it to determine natoms
  if (inds[1]==1) {
    natoms <- nrow(pdb$atom)
  }
  ## if xyz is provided use it to determine natoms
  else if (inds[1]==2) {
    natoms <- ncol(xyz)/3
  }
  ## else use eleno, resno, or resid
  else {
    natoms <- length(input[[inds[1]]])
  }

  if(verbose) {
    cat("\n")
    cat(" Summary of PDB generation:\n")
    cat(paste(" .. number of atoms in PDB determined by '", names(input)[inds[1]], "'\n", sep=""))
  }

  ## set value of 'xyz'
  if(!is.null(xyz)) {
    if((ncol(xyz)/3)!=natoms)
      stop("ncol(xyz)/3 != length(resno)")
  }
  else {
    if(!is.null(pdb))
      xyz <- as.xyz(pdb$xyz)
    else
      xyz <- as.xyz(rep(NA, natoms*3))
  }

  ## generic function to set the values of remaining columns of PDB
  .setval <- function(values=NULL, typ=NULL, default=NULL, class="character", repfirst=FALSE) {
    if(!is.null(values)) {
      if(class=="character") fun=is.character
      if(class=="numeric") fun=is.numeric
      if(!fun(values))
        stop(paste("'", typ, "' must be a ", class, " vector", sep=""))

      if(length(values)==1 & repfirst)
        values <- rep(values, natoms)

      if(length(values)!=natoms)
        stop(paste("length(", typ, ") != natoms", sep=""))
    }
    else {
      if(!is.null(pdb))
        values <- pdb$atom[[typ]]
      else
        values <- default
    }
    return(values)
  }

  type   <- .setval(type,   typ="type",   default=rep("ATOM", natoms), class="character", repfirst=TRUE)
  eleno  <- .setval(eleno,  typ="eleno",  default=seq(1, natoms),      class="numeric",   repfirst=FALSE)
  elety  <- .setval(elety,  typ="elety",  default=rep("CA", natoms),   class="character", repfirst=TRUE)
  resno  <- .setval(resno,  typ="resno",  default=seq(1, natoms),      class="numeric",   repfirst=FALSE)
  chain  <- .setval(chain,  typ="chain",  default=rep("A", natoms),    class="character", repfirst=TRUE)
  resid  <- .setval(resid,  typ="resid",  default=rep("ALA", natoms),  class="character", repfirst=TRUE)
  elesy  <- .setval(elesy,  typ="elesy",  default=rep(NA, natoms),     class="character", repfirst=TRUE)
  segid  <- .setval(segid,  typ="segid",  default=rep(NA, natoms),     class="character", repfirst=TRUE)
  o      <- .setval(o,      typ="o",      default=rep(NA, natoms),     class="numeric",   repfirst=TRUE)
  b      <- .setval(b,      typ="b",      default=rep(NA, natoms),     class="numeric",   repfirst=TRUE)
  alt    <- .setval(alt,    typ="alt",    default=rep(NA, natoms),     class="character", repfirst=FALSE)
  insert <- .setval(insert, typ="insert", default=rep(NA, natoms),     class="character", repfirst=FALSE)
  charge <- .setval(charge, typ="charge", default=rep(NA, natoms),     class="numeric",   repfirst=TRUE)

  ## make the data frame for the final PDB object
  atom        <- list()
  atom$type   <- type
  atom$eleno  <- eleno
  atom$elety  <- elety
  atom$alt    <- alt
  atom$resid  <- resid
  atom$chain  <- chain
  atom$resno  <- resno
  atom$insert <- insert
  atom$x      <- xyz[1, seq(1, natoms*3, by=3)]
  atom$y      <- xyz[1, seq(2, natoms*3, by=3)]
  atom$z      <- xyz[1, seq(3, natoms*3, by=3)]
  atom$o      <- o
  atom$b      <- b
  atom$segid  <- segid
  atom$elesy  <- elesy
  atom$charge <- charge
  atom        <- data.frame(atom, stringsAsFactors=FALSE)

  out        <- list()
  out$atom   <- atom
  out$xyz    <- xyz
  class(out) <- "pdb"

  ## should account for new resno and chain
  #if(!is.null(pdb)) {
    #out$helix  <- pdb$helix
    #out$sheet  <- pdb$sheet
    #out$seqres <- pdb$seqres
    #class(out) <- class(pdb)
  #}

  unwhich <- function(x, n) {
    out <- rep_len(FALSE, n)
    out[x] <- TRUE
    return(out)
  }

  ca.inds    <- atom.select(out, "calpha", verbose=verbose)
  out$calpha <- unwhich(ca.inds$atom, natoms)
  out$call   <- cl

  if(verbose) {
    resid <- unique(paste(atom$chain, atom$resno, sep="-"))
    cat(paste(" .. number of atoms in PDB: ", natoms, "\n"))
    cat(paste(" .. number of calphas in PDB:", sum(out$calpha), "\n"))
    cat(paste(" .. number of residues in PDB:", length(resid), "\n"))
    cat("\n")
  }

  return(out)
}

print.xyz <- function(x, ...) {

	## Print a summary of bio3d 'xyz' object features
  	if(!inherits(x, "xyz")) {
    	stop("Input should be a bio3d 'xyz' object")
  	}

  	if( is.null(nrow(x)) )
  		x <- t(as.matrix(x))

	cat( paste0("\n   Total Frames#: ", nrow(x), 
		        "\n   Total XYZs#:   ", ncol(x), 
		        ",  (Atoms#:  ",  round(ncol(x)/3,3), 
		        ")\n\n") ) 

	if(ncol(x) > 7) {
	s <- paste("    [1]  ", paste(round(x[1,1:3],3),collapse="  "), "  <...>  ",
		       paste(  round(x[nrow(x),(ncol(x)-2):ncol(x)], 3), collapse="  "), 
		       "  [",length(x),"]", sep="")
	} else {
		s <- paste("    [1]  ", paste(round(x[1,],3),collapse="  "), 
				   "  [",length(x),"]", sep="")
	}
	cat(s,"\n\n")

	i <- paste(attributes(x)$names, collapse = ", ")
	j <- paste("Matrix DIM =", nrow(x), "x", ncol(x))
	cat(strwrap(paste(" + attr:", i, "\n",j), width = 45, exdent = 8),
        sep = "\n")
}

`chain.pdb` <-
function(pdb, ca.dist=4, bond=TRUE, bond.dist=1.5, blank="X", rtn.vec=TRUE) {
  ##- Find possible chian breaks
  ##  i.e. Concetive Caplpa's that are further than 'ca.dist' apart,
  ##        print basic chain info and rtn a vector of chain ids
  ##        consisting of the 26 upper-case letters of the Roman
  ##        alphabet
  ##
  ## chn <- chain.pdb(pdb)
  ## pdb$atom[,"chain"] <- chain.pdb(pdb)
  ##

  ## Distance between concetive C-alphas
  ca <- atom.select(pdb, "calpha", verbose=FALSE)
  if(length(ca$atom) <=1) {
    d <- 0
  } else {
    if(bond) {
      nn <- atom.select(pdb, "protein", elety="N", verbose=FALSE)
      cc <- atom.select(pdb, "protein", elety="C", verbose=FALSE)

      ca.labs <- paste(pdb$atom$chain[ca$atom], pdb$atom$resno[ca$atom], 
        pdb$atom$insert[ca$atom], sep="_")
      nn.labs <- paste(pdb$atom$chain[nn$atom], pdb$atom$resno[nn$atom], 
        pdb$atom$insert[nn$atom], sep="_")
      cc.labs <- paste(pdb$atom$chain[cc$atom], pdb$atom$resno[cc$atom], 
        pdb$atom$insert[cc$atom], sep="_")

      # Check if N-C is available; if not, use CA-CA distance
      hasN <- rep(FALSE, length(ca.labs))
      hasC <- rep(FALSE, length(ca.labs))
      hasN[ca.labs %in% nn.labs] <- TRUE
      hasC[ca.labs %in% cc.labs] <- TRUE
      hasNC <- hasC[-length(hasC)] & hasN[-1]
      useC.labs <- ca.labs[which(hasNC)]
      useN.labs <- ca.labs[which(hasNC)+1]
      
      sel1 <- as.select(
        sort( c(ca$atom[which(!hasNC)], cc$atom[cc.labs %in% useC.labs]) )
      )
  
      sel2 <- as.select(
        sort( c(ca$atom[which(!hasNC)+1], nn$atom[nn.labs %in% useN.labs]) )
      )

      if(sum(!hasNC) > 0) {
         # Use mixed distance cutoff values
         bond.dist <- rep(bond.dist, length(hasNC))
         bond.dist[!hasNC] <- ca.dist
      }
      else if(sum(hasNC) == 0) {
         warning("No valid N-C bond to check; Use CA-CA distances")
         bond.dist <- ca.dist
      }

#      if(length(ca$atom) != length(nn$atom) ||
#         length(ca$atom) != length(cc$atom)) {
#        warning("Peptide bond atoms (N/C) and C-alpha atoms mismatch. Switch to bond=FALSE.")
#        bond <- FALSE
#      } else {
        xyz1 <- pdb$xyz[sel1$xyz]
        xyz2 <- pdb$xyz[sel2$xyz]
        d <- dist.xyz(xyz1, xyz2, all.pairs=FALSE)
#        d <- d[!is.na(d)]
#      }
    } 
    if(!bond) { 
      xyz <- matrix(pdb$xyz[ca$xyz], nrow=3)
      if(length(ca$atom) == 2) 
        d <- sqrt( sum( apply(xyz , 1, diff)^2 ) )
      else
        d <- sqrt( rowSums( apply(xyz , 1, diff)^2 ) )
    }
  }

  ## Chain break distance check
  if(bond) {
    ind <- which(d > bond.dist)
  } else {
    ind <- which(d > ca.dist)
  }
  len <- diff( c(1,ind,length(d)) )

  cat(paste("\t Found",length(ind), "possible chain breaks\n"))
  if(length(ind) > 0) {
     cat(paste("\t  After resno(s):",
           paste( pdb$atom[ca$atom,"resno"][(ind)], collapse=", " ),"\n" ))
     cat(paste("\t  Chain length(s):",
           paste(len+1, collapse=", " ),"\n" ))
  }

  ## Make a chain id vector
  if(rtn.vec) {
    resno.ind <- as.numeric(c(1, sort(as.numeric(c(ind,(ind+1)))), (length(d)+1)
))
    ## Renumber residues first, in case that original resnos are not
    ## consecutive crossing multiple chains
    res <- paste(pdb$atom[, "chain"], pdb$atom[, "resno"], pdb$atom[, "insert"], sep="_")
    pdb$atom[, "resno"] <- vec2resno(1:length(unique(res)), res) 

    resno.val <- pdb$atom[ca$atom,"resno"][resno.ind]
    resno.val <- matrix(as.numeric(resno.val),nrow=2)

    vec <- rep(blank, nrow(pdb$atom))
    if(is.na(resno.val[1])) {
      return(vec)
    } else if(is.na(resno.val[2])) {
      resno.val[2] <- resno.val[1]
    }
    
    for(i in 1:(length(resno.val)/2)) {
      sel.ind <- atom.select(pdb,
                             resno=c(resno.val[1,i]:resno.val[2,i]),
                             verbose=FALSE)
      vec[sel.ind$atom]=LETTERS[i]
    }
    return(vec)
  }
}

"read.fasta" <-
function(file, rm.dup=TRUE, to.upper=FALSE, to.dash=TRUE) {
  ## Log the call
  cl <- match.call()
  
  ## Version   0.3 ... Thu Apr 26 19:17:09 PDT 2007
  ##                    uses scan instead of read.table
  
  raw.fa <- scan(file, what=character(0), sep="\n", quiet = TRUE, na.strings='')
  ind <- grep(">", raw.fa) ## seq id lines
  if(length(ind) == 0) {
    stop("read.fasta: no '>' id lines found, check file format")
  }
  
  if (to.dash) { raw.fa[-ind] <- gsub("[/.]","-", raw.fa[-ind]) }
  if (to.upper) { raw.fa[-ind] <- toupper(raw.fa[-ind]) }  
  
  ind.s <- ind+1           ## seq start and end lines
  ind.e <- c((ind-1)[-1], length(raw.fa))

  seq.dim <-  apply(cbind(ind.s, ind.e), 1,
                    function(x) sum( nchar(raw.fa[ (x[1]:x[2])]) ))

  seq.format <- function(x, max.seq=max(seq.dim)) {
    fa <- rep("-",max.seq)
    fa[ c(1:x[3]) ] <- unlist(strsplit( raw.fa[ (x[1]:x[2]) ], split=""));
    return(fa)
  }

  ##seq.format( cbind(ind.s[1], ind.e[1], seq.dim[1]) )
  store.fa <- t(matrix(apply(cbind(ind.s, ind.e, seq.dim), 1, seq.format), ncol=length(ind)))
  rownames(store.fa) <- gsub("^>| .*", "",raw.fa[ind], perl=TRUE)
  
##  if (to.dash) { store.fa <- gsub("[/.]","-", store.fa ) }
##  if (to.upper) { store.fa <- toupper(store.fa) }
  
  if (rm.dup) {        ## remove duplicated seq id's
##    dups <- as.numeric(duplicated(row.names(store.fa)))
    dups <- duplicated(row.names(store.fa))
    if (any(dups)) {
      print(paste(" ** Duplicated sequence id's: ",
                  row.names(store.fa)[dups]," **",sep=""))
      store.fa <- store.fa[!dups,]
    }
  }
  
  output <- list(id=rownames(store.fa), ali=store.fa, call=cl)
  class(output) <- "fasta"
  return(output)
}

"project.pca" <-
function(data, pca, angular=FALSE, fit=FALSE, ...) {
  
  if(angular)
    data <- wrap.tor(data)
  if(is.null(dim(data))) {
    if(ncol(pca$U) != length(data))
      stop("Dimensionality mismatch:  length(data)!=ncol(pca$U)")
    if(fit) data <- fit.xyz(pca$mean, data, ...)
    z <- (data - pca$mean) %*% pca$U
  } else {
    if(ncol(pca$U) != ncol(data))
      stop("Dimensionality mismatch:  ncol(data)!=ncol(pca$U)")
    if(fit) data <- fit.xyz(pca$mean, data, ...)
    z <- sweep(data, 2, pca$mean) %*% pca$U
  }
  return(z)
}

z2xyz.pca <- function(z.coord, pca) {

  
  if(is.null(nrow(z.coord))) {
    if( length(z.coord) > ncol(pca$U) )
      stop("Dimension miss-match: length(z.coord) > ncol(pca$U)")
    
    xyz.coord <- (z.coord  %*% t(pca$U[, c(1:length(z.coord)) ]) ) + pca$mean

  } else {
    if( ncol(z.coord) > ncol(pca$U) )
      stop("Dimension miss-match: ncol(z.coord) > ncol(pca$U)")

    xyz.coord <- NULL
    for(i in 1:nrow(z.coord)) {
      xyz.coord <- rbind(xyz.coord,
                         (z.coord[i,]  %*% t(pca$U[, c(1:length(z.coord[i,])) ]) ) + pca$mean)

    }
  }
  return(xyz.coord)
}


xyz2z.pca <- function(xyz.coord, pca) {
  return(project.pca(xyz.coord, pca))
}

`plot.hmmer` <-
function(x, ...) {
  allowed <- c("phmmer", "hmmsearch", "jackhmmer")
  
  if(!any(inherits(x, allowed)))
    stop(paste("please provide the results of a hmmer search of type:",
               paste(allowed, collapse=", ")))

  plot.blast(x, ...)
}

geostas <- function(...)
  UseMethod("geostas")

geostas.nma <- function(nma, m.inds=7:11, verbose=TRUE, ...) {
  if(verbose) cat("  .. generating trajectory from", length(m.inds), "modes\n")
  
  trj <- NULL
  for(i in m.inds) {
    trj <- rbind(trj, mktrj(nma, mode=i, rock=FALSE))
  }
  
  gs <- geostas.xyz(trj, verbose=verbose, ...)
  return(gs)
}

geostas.enma <- function(enma, pdbs=NULL, m.inds=1:5, verbose=TRUE, ...) {
  if(!inherits(enma, "enma"))
    stop("provide an 'enma' object as obtained by function 'nma.pdbs()'")
  if(!inherits(pdbs, "pdbs"))
    stop("provide an 'pdbs' object as obtained by function 'pdbaln' or 'read.fasta.pdb'")

  if(verbose) cat("  .. generating trajectory from", length(m.inds), "modes\n")

  trj <- mktrj(enma, pdbs, m.inds=m.inds, rock=FALSE, ...)
  gs <- geostas.xyz(trj, verbose=verbose, ...)
  return(gs)
}

geostas.pdb <- function(pdb, inds=NULL, verbose=TRUE, ...) {
  if(!is.pdb(pdb))
    stop("provide a 'pdb' object as obtained from function 'read.pdb'")
  if(!nrow(pdb$xyz)>2)
    stop("provide a multi-model (>2) 'pdb' with more than ")

  if(is.null(inds)) {
    inds <- atom.select(pdb, "calpha")
    if(verbose) cat("  ..", length(inds$atom), "'calpha' atoms selected\n")
  }
  
  xyz <- pdb$xyz[,inds$xyz]
  gs <- geostas.xyz(xyz, verbose=verbose, ...)

  ## map back so that indices matches input 'pdb'
  if(verbose) {
    cat("  .. converting indices to match input 'pdb' object \n")
    cat("     (additional attribute 'atomgrps' generated) \n")
  }

  gs$fit.inds <- inds$xyz[gs$fit.inds]
  resid <- paste(pdb$atom$resid, pdb$atom$resno, pdb$atom$chain, sep="-")
  
  grps <- rep(NA, nrow(pdb$atom))
  for(i in 1:length(gs$inds)) {
    gs$inds[[i]] <- as.select(inds$atom[gs$inds[[i]]$atom])
    gs$inds[[i]]$call <- NA

    tmp.inds <- which(resid %in% resid[ gs$inds[[i]]$atom ])
    grps[ tmp.inds ] <- i
  }

  gs$atomgrps <- grps
  return(gs) 
}

geostas.pdbs <- function(pdbs, verbose=TRUE, ...) {
  if(!inherits(pdbs, "pdbs"))
    stop("provide an 'pdbs' object as obtained by function 'pdbaln' or 'read.fasta.pdb'")

  ## identify non-gap regions
  gaps.res <- gap.inspect(pdbs$ali)
  gaps.pos <- gap.inspect(pdbs$xyz)

  if(verbose) cat("  ..", length(gaps.pos$f.inds), "non-gap positions selected\n")
  
  xyz <- pdbs$xyz[, gaps.pos$f.inds]
  gs <- geostas.xyz(xyz, verbose=verbose, ...)

  ## map back so that indices matches input 'pdbs'
  gs$fit.inds <- gaps.pos$f.inds[gs$fit.inds]
  grps <- rep(NA, ncol(pdbs$ali))
  for(i in 1:length(gs$inds)) {
    gs$inds[[i]] <- as.select(gaps.res$f.inds[ gs$inds[[i]]$atom ])
    gs$inds[[i]]$call <- NA

    grps[ gs$inds[[i]]$atom ] <- i
  }
  
  return(gs) 
}

geostas.default <- function(...)
  geostas.xyz(...)

geostas.xyz <- function(xyz, amsm=NULL, k=3, pairwise=TRUE, clustalg="kmeans",
                        fit=TRUE, ncore=NULL, verbose=TRUE, ...) {
  cl <- match.call()
  
  xyz <- as.xyz(xyz)
  if(!nrow(xyz)>2)
    stop("provide a trajectory (e.g xyz object) with multiple (>2) frames")

  if(verbose) cat("  .. 'xyz' coordinate data with", nrow(xyz), "frames \n")
  
  if(!clustalg %in% c("hclust", "kmeans"))
    stop("'clustalg' should be 'kmeans' or 'hclust'")

  if(k<2)
    stop("provide 'k>1'")
  
  if(fit & is.null(amsm)) {
    if(verbose) cat("  .. 'fit=TRUE': running function 'core.find'\n")
    
    invisible(capture.output( core <- core.find(xyz) ))
    fit.inds <- core$xyz

    xyz <- fit.xyz(xyz[1,], xyz, fixed.inds=fit.inds, mobile.inds=fit.inds, ncore=ncore)
    if(is.null(fit.inds))
      warning("core indices not found. fitting to all atoms")
    
    if(verbose) cat("  .. coordinates are superimposed to core region\n")
  }
  else {
    if(verbose) cat("  .. coordinates are not superimposed prior to geostas calculation\n")
    fit.inds <- NULL
  }
  
  if(is.null(amsm)) {
    if(verbose) cat("  .. calculating atomic movement similarity matrix ('amsm.xyz()') \n")
    amsm <- amsm.xyz(xyz, ncore=ncore)
    dims <- dim(amsm)
    if(verbose) cat("  .. dimensions of AMSM are ", dims[1], "x", dims[2], "\n", sep="")
  }
  else {
    if(!all(dim(amsm)==ncol(xyz)/3))
      stop("dimension mismatch ('xyz' and 'amsm')")
  }

  if(pairwise) {
    cm <- 1-amsm
  }
  else {
    cm.tmp  <- normalize.vector(amsm)
    cm <- 1 - apply(cm.tmp, 2, function(x,y) x %*% y, cm.tmp)
  }
  
  ## hierarchical clustering
  if(clustalg=="hclust") {
    if(verbose) cat("  .. clustering AMSM using 'hclust' \n")
    dis    <- as.dist(cm)
    hc     <- hclust(dis, ...)
    grps   <- cutree(hc, k=k)
  }
  
  ## k-means clustering
  if(clustalg=="kmeans") {
    if(verbose) cat("  .. clustering AMSM using 'kmeans' \n")
    grps <- kmeans(cm, centers=k, ...)$cluster
  }

  ## return indices for the identified domains
  inds <- list()
  for(i in 1:length(unique(grps))) {
    inds[[i]] <- as.select(grps==i)
  }
  
  out <- list(call=cl, amsm=amsm, fit.inds=fit.inds, grps=grps, inds=inds)
  class(out) <- "geostas"
  return(out)
}

`conserv` <-
function(x,
         method=c("similarity","identity","entropy22","entropy10"),
         sub.matrix=c("bio3d","blosum62","pam30","other"),
         matrix.file=NULL,
         normalize.matrix = TRUE) {

  method <- match.arg(method)
  sub.matrix <- match.arg(sub.matrix)


  ##  cat(paste("Options are, method=",method,", matrix=",sub.matrix,
  ##            ", norm=",normalize.matrix),"\n" )

  if(is.list(x)) x=x$ali

  aa <- c("V","I","L","M",  "F","W","Y",  "S","T",
          "N","Q",  "H","K","R",  "D","E",
          "A","G",  "P",  "C",  "-","X")
  composition <- table(x)
  unk <- composition[!names( composition  ) %in% aa]
  if(length(unk) > 0) {
    warning(paste("non standard residue code:",names(unk),"mapped to X\n  "))
    for(i in 1:length(unk))
      x[x==names(unk[i])]="X"
  }
    
  if(method == "entropy10") { return(entropy(x)$H.10.norm) }
  if(method == "entropy22") { return(entropy(x)$H.norm) }
  if(method == "identity") {
    ## Identity (exact matchs score 1)
    freq.aa <- apply(x,2,
                     function(i){
                       i.freq <- table(i[i!="-"])
                       if(length(i.freq)==0) { return(0) } else {
                         return( max(table(i[i!="-"])) ) }
                     } )
    return( freq.aa/nrow(x) )
  }


  if(method == "similarity") {
    #####cat(sub.matrix)
    ## Pairwise matches are assigned score from a 'similarity matrix'
    if(sub.matrix=="other") {
      if(is.null(matrix.file)) stop("Missing argument: similarity requires a 'matrix.file'")
      mat.file <- matrix.file
    } else {
      ##mat.file <- system.file("matrices/similarity.mat", package="bio3d")
      mat.file <- system.file(paste("matrices/",sub.matrix,".mat",sep=""), package="bio3d")
      ##mat.file <- paste("matrices/",sub.matrix,".mat",sep="")
    }
    mat <- read.table(mat.file)
    colnames(mat)[24]="-"

    if(normalize.matrix) {
      ## Karlin Normalize
      o.mat <- mat
      n <- nrow(o.mat)
      for(a.ind in 1:n) {
        for(b.ind in 1:n) {
          ab <- o.mat[a.ind,b.ind]
          aa <- o.mat[a.ind,a.ind]
          bb <- o.mat[b.ind,b.ind]
          aabb <- aa*bb
          if(ab==0 && aabb==0) {
            mat[a.ind,b.ind] <- 0
          } else {
            if(aabb<0) {
              mat[a.ind,b.ind] <- ab / -sqrt(abs(aabb))
            } else {
              mat[a.ind,b.ind] <- ab / sqrt(aabb)
            }
          }
        }
      }
    }

    scorecol <- function(col, mat) {
      freq.aa   <- table(col)
      unique.aa <- names(freq.aa)
      missing.aa <- unique.aa[!unique.aa %in% colnames(mat)]
      
      count <- 0; score <- 0

      for(i in 1:length(unique.aa)) {
        aa.i <- unique.aa[i]; freq.i <- freq.aa[i]
        for(j in i:length(unique.aa)) {
          aa.j <- unique.aa[j]; freq.j <- freq.aa[j]
          ##sim <- mat[aa.i,aa.j]
          if(length(missing.aa)>0) {
            if(i==missing.aa || j==missing.aa) {
              sim <- 0
            } else {
              sim <- mat[aa.i,aa.j]
            }
          } else { sim <- mat[aa.i,aa.j] }

          ## number of comparisons
          if(aa.i == aa.j) {
            ncmp <- freq.i * (freq.i - 1)/2
          } else {
            ncmp <- freq.i * freq.j
          }
          count <- count + ncmp
          score <- score + (ncmp * sim)
        }
      }
      return(score/count)
    }


    return( apply(x, 2, scorecol, mat=mat) )
  }

}

"pdbs2pdb" <- function(pdbs, inds=NULL, rm.gaps=FALSE, all.atom=FALSE, ncore=NULL) {
  if(!inherits(pdbs, "pdbs")) {
    stop("Input 'pdbs' should be of class 'pdbs', e.g. from pdbaln() or read.fasta.pdb()")
  }
  
  if(is.null(inds))
    inds <- seq(1, length(pdbs$id))

  ncore <- setup.ncore(ncore)

  ## Set indicies
  gaps.res <- gap.inspect(pdbs$ali)
  gaps.pos <- gap.inspect(pdbs$xyz)

  if(all.atom) {
    if(is.null(pdbs$all)) {
       # check file paths saved in pdbs$id
       if(all(file.exists(pdbs$id[inds]))) {
          tpdbs <- read.all(trim(pdbs, row.inds=inds, col.inds=1:ncol(pdbs$ali)), verbose=FALSE)
          if(rm.gaps) {
            tpdbs <- trim(tpdbs, col.inds=gaps.res$f.inds)
          }
          else {
            tpdbs <- trim(tpdbs)
          }
          return(pdbs2pdb(tpdbs, inds=NULL, rm.gaps=rm.gaps, all.atom=TRUE, ncore=ncore))
       }
       else {
          stop("With 'all.atom=TRUE', input 'pdbs' must be obtained from read.all() or pdbs$id refers to existing files")
       }
    }
  }

  all.pdbs <- mclapply(inds, function(j) {    
    ## Temporaray file
    fname <- tempfile(fileext = "pdb")

    ## Set indices for this structure only
    f.inds <- NULL
    if(rm.gaps) {
      f.inds$res <- gaps.res$f.inds
      f.inds$pos <- gaps.pos$f.inds
    }
    else {
      f.inds$res <- which(gaps.res$bin[j,]==0)
      f.inds$pos <- atom2xyz(f.inds$res)
    }
    
    if(length(f.inds$res) > 0) {
      ## Make a temporary PDB object
      if(all.atom){
        f.inds$res <- which( (pdbs$all.grpby %in% f.inds$res) & !is.gap(pdbs$all.elety[j, ]) )
        f.inds$pos <- atom2xyz(f.inds$res)
        all.chain <- vec2resno(pdbs$chain[j, ], pdbs$all.grpby)
        if(!is.null(pdbs$insert)) {
          all.insert <- vec2resno(pdbs$insert[j, ], pdbs$all.grpby)
          insert <- all.insert[f.inds$res]
        } else {
          insert <- rep('', length(f.inds$res))
        }
        xyz <- pdbs$all[j,f.inds$pos]
        resno <- pdbs$all.resno[j,f.inds$res]
        resid <- pdbs$all.resid[j,f.inds$res]
        chain <- all.chain[f.inds$res]
        elety <- pdbs$all.elety[j,f.inds$res]
        het <- pdbs$all.hetatm[[j]]
        if(!is.null(het)) {
          xyz <- c(xyz, het$xyz)
          resno <- c(resno, het$atom[, 'resno'])
          resid <- c(resid, het$atom[, 'resid'])
          chain <- c(chain, het$atom[, 'chain'])
          elety <- c(elety, het$atom[, 'elety'])
          insert <- c(insert, rep('', nrow(het$atom)))
        }
        write.pdb(pdb=NULL, xyz=xyz, resno=resno, resid=resid, 
                  chain=chain, insert=insert, elety=elety, file=fname)
      }
      else {
        if(!is.null(pdbs$insert)) {
          insert <- pdbs$insert[j, f.inds$res]
        } else {
          insert <- rep('', length(f.inds$res))
        }
        write.pdb(pdb=NULL,
                  xyz  =pdbs$xyz[j,f.inds$pos],   resno=pdbs$resno[j,f.inds$res],
                  resid=pdbs$resid[j,f.inds$res], chain=pdbs$chain[j,f.inds$res],
                  insert=insert, file=fname)
      }
      read.pdb(fname)
    } 
    else {
      NULL
    }
  }, mc.cores=ncore )

  names(all.pdbs) <- sub(".pdb$", "", basename(pdbs$id[inds]))
  return(all.pdbs)
}

print.select <- function(x, ...){

	## Print a summary of atom selection object features
  	if(!inherits(x, "select")) {
    	stop("Input should be a 'select' object, as obtained from 'atom.select()'")
  	}

 	cat("\n Call:  ", paste(deparse(x$call), sep = "\n", collapse = "\n"), 
 		"\n", sep = "")	

	cat( paste0("\n   Atom Indices#: ", length(x$atom), "  ($atom)",
		"\n   XYZ  Indices#: ",length(x$xyz), "  ($xyz)\n\n" ) )
	## Add call
	if(	length(x$atom) != (length(x$xyz)/3) ) 
		warning("Atom and XYZ Indices Miss-Match")

	i <- paste(attributes(x)$names, collapse = ", ")
	cat(strwrap(paste(" + attr:", i), width = 45, exdent = 8), sep = "\n")

}

"pdb2aln" <-
function(aln, pdb, id="seq.pdb", aln.id=NULL, file="pdb2aln.fa", ...) {

   # check inputs
   if(!inherits(aln, "fasta") || !is.pdb(pdb))
      stop("Incorrect type of input object:
        Should be 'pdb2aln(aln, pdb, ...)'")

   cl <- match.call()

   # Mask the gaps in the first sequence to get the 
   # reference of original alignment positions 
   aln$ali[1, is.gap(aln$ali[1,])] <- "X"
   
   aa1 <- pdbseq(pdb)
   
   if(!is.null(aln.id)) findid <- grep(aln.id, aln$id)
   if(is.null(aln.id) || length(findid)==0) {
      # do sequence-profile alignment
      naln <- seq2aln(seq2add=aa1, aln=aln, id=id, file=tempfile(), ...)
      # check if the old alignment doesn't change
      if(!identical(aln$ali, naln$ali[1:(nrow(naln$ali)-1), !is.gap(naln$ali[1,]), drop = FALSE])) 
         warning("Alignment changed! Try aln.id with the closest sequence ID in the alignment")
   } else {
      # do pairwise sequence alignment     
      if(length(findid) > 1) {
         warning(paste("Multiple entities found in alignment for id=", 
            aln.id, ". Use the first one...", sep=""))
      }
      idhit <- findid[1]

      ##- Align seq to masked template from alignment
      tmp.msk <- aln$ali[idhit, ]
      tmp.msk[is.gap(tmp.msk)] <- "X"
    
      dots = list(...)
      dots$outfile = tempfile()
      args = c(list(aln = seqbind(tmp.msk, aa1)), dots)
      seq2tmp <- do.call(seqaln.pair, args)
      
      ##- check sequence identity
      ii <- seq2tmp$ali[1,]=='X'
      ide <- seqidentity(seq2tmp$ali[, !ii])[1,2]
        
      if(ide < 0.4) {
         warning(paste("Sequence identity is too low (<40%).",
             "You may want profile alignment (set aln.id=NULL)", sep=" "))
      }
 
      ##- Insert gaps to adjust alignment
      ins <- is.gap( seq2tmp$ali[1,] )
      ntmp <- matrix("-", nrow=nrow(aln$ali), ncol=(ncol(aln$ali)+sum(ins)))
      ntmp[,!ins] <- aln$ali
    
      ## Add seq to bottom of adjusted alignment
      naln <- seqbind(ntmp, seq2tmp$ali[2,])
      rownames(naln$ali) <- c(rownames(aln$ali), id)
      naln$id <- c(aln$id, id)
   }
   
   # original alignment positions (include gaps)
   # and CA indices of PDB
   ref <- matrix(NA, nrow=2, ncol=ncol(naln$ali))
   rownames(ref) <- c("ali.pos", "ca.inds")
   ref[1, !is.gap(naln$ali[1,])] <- 1:ncol(aln$ali)
   ref[2, !is.gap(naln$ali[id,])] <- atom.select(pdb, "calpha", verbose=FALSE)$atom
   
   # remove X
   naln$ali[1, naln$ali[1,]=="X"] <- "-"
 
   if(!is.null(file)) 
      write.fasta(naln, file=file)

   out <- list(id=naln$id, ali=naln$ali, ref=ref, call=cl)
   class(out) <- "fasta"
 
   return (out)
}

cov.nma <- function(nma) {
  if(!inherits(nma, "nma"))
    stop("provide a 'nma' object as obtain from function 'nma.pdb()'")
  
  dims <- dim(nma$U)
  cov <- matrix(0, ncol=dims[1], nrow=dims[1])
  tmpU <- nma$U[, (nma$triv.modes+1):ncol(nma$U)]
  tmpL <- nma$L[(nma$triv.modes+1):ncol(nma$U)]
  
  for(j in 1:ncol(tmpU) ) {
    cov <- cov + ( (tmpU[,j] %*% t(tmpU[,j])) / tmpL[j])
  }
  return(cov)
}

cov.enma <- function(enma, ncore=NULL) {
  if(!inherits(enma, "enma"))
    stop("provide a 'enma' object as obtain from function 'nma.pdbs()'")
  if(any(is.na(enma$fluctuations)))
    stop("provide 'enma' object calculated with argument 'rm.gaps=TRUE'")
  
  ncore <- setup.ncore(ncore, bigmem = FALSE)
  
  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply
  
  if(!inherits(enma, "enma"))
    stop("provide 'enma' object as obtained from nma.pdbs")
  
  dims <- dim(enma$U.subspace)
  
  mycalc <- function(i, enma) {
    cov <- matrix(0, ncol=dims[1], nrow=dims[1])
    tmpU <- enma$U.subspace[,,i]
    tmpL <- enma$L[i,]

    for(j in 1:ncol(tmpU) ) {
      cov = cov + ( (tmpU[,j] %*% t(tmpU[,j])) / tmpL[j])
    }
    cat(".")
    return(cov)
  }

  covs.list <- mylapply(1:dims[3L], mycalc, enma)
  cat("\n")
  
  covs <- array(0, dim=c(dims[1], dims[1], dims[3]))
  
  for ( i in 1:dims[3L] )
    covs[,,i]=covs.list[[i]]

  return(covs)
}

.tr <- function(mat) {
  return(sum(diag(mat)))
}

.diag.rtb <- function(H, blocks, xyz, masses, ...) {

  ## mass weighted Hessian
  if(!all(masses == 1)) {
    m <- 1/sqrt(rep(masses, each=3))
    H <- sapply(1:ncol(H), function(i) H[,i] * m[i])
    H <- t( sapply(1:nrow(H), function(i) H[i,] * m[i]) )
  }

  if(nlevels(blocks) == (nrow(H)/3))
    return( eigen(H, ...) )

  MASS <- tapply(masses, blocks, sum)  # Block mass
  xyz <- matrix(xyz, ncol=3, byrow=TRUE)

  ## block center-of-mass
  Rc <- tapply(1:length(blocks), blocks, function(i) {
      colSums(xyz[i,, drop=FALSE ] * masses[i]) / MASS[blocks[i[1]]]
  } )

  ## Gram-Schmidt process for orthonormalization
  schmidt <- function(p) {
    p[, 1] <- p[, 1] / sqrt(sum(p[, 1]^2))
    for(i in 2:ncol(p)) {
      ov <- apply(p[, 1:(i-1), drop=FALSE], 2, function(x)
              as.vector(crossprod(p[, i], x)) * x )
      ov <- rowSums(ov)
      p[, i] <- p[, i] - ov
      p[, i] <- p[, i] / sqrt(sum(p[, i]^2))
    }
    return(p)
  }

  ## RTB projector building (can be parallelized)
  P.blocks <- lapply(1:nlevels(blocks), function(i) {
     myblock <- levels(blocks)[i]
     iatom <- which(blocks %in% myblock)
     natom <- length(iatom)
     m <- masses[iatom]
     M <- MASS[myblock]

     # equilibrium position relative to COM
     r0  <- t( t(xyz[iatom, ]) - Rc[[myblock]] )

     ncol <- ifelse(natom>=3, 6, ifelse(natom>=2, 5, 3))

     P <- matrix(0, nrow=natom*3, ncol=ncol)

     # translation
     P[seq(1, nrow(P), 3), 1] <- sqrt(m/M) #xx
     P[seq(2, nrow(P), 3), 2] <- sqrt(m/M) #yy
     P[seq(3, nrow(P), 3), 3] <- sqrt(m/M) #zz

     if(natom>=3) {

       # rotation
       rr <- rbind(0, -r0[, 3], r0[, 2])
       P[, 4] <- 1/sqrt( sum(m * (r0[, 2]^2 + r0[, 3]^2)) ) *
          ( sqrt(rep(m, each=3)) * as.numeric(rr) )  ## x-axis

       rr <- rbind(r0[, 3], 0, -r0[, 1])
       P[, 5] <- 1/sqrt( sum(m * (r0[, 1]^2 + r0[, 3]^2)) ) *
          ( sqrt(rep(m, each=3)) * as.numeric(rr) )  ## y-axis

       rr <- rbind(-r0[, 2], r0[, 1], 0)
       P[, 6] <- 1/sqrt( sum(m * (r0[, 1]^2 + r0[, 2]^2)) ) *
          ( sqrt(rep(m, each=3)) * as.numeric(rr) )  ## z-axis

       schmidt(P) # Orthonormalization

     } else if(natom==2) {

       # check the line direction and choose the least overlapped axes to rotate.
       ax <- rbind(c(2,3,1), c(3,1,2), c(1,2,3))
       ax <- ax[which.max(abs(r0[1, ])), ]
       rr <- list(rbind(0, -r0[, 3], r0[, 2]),
                  rbind(r0[, 3], 0, -r0[, 1]),
                  rbind(-r0[, 2], r0[, 1], 0))
       # rotation
       P[, 4] <- 1/sqrt( sum(m * (r0[, ax[2]]^2 + r0[, ax[3]]^2)) ) *
          ( sqrt(rep(m, each=3)) * as.numeric(rr[[ax[1]]]) )  ## first-axis

       P[, 5] <- 1/sqrt( sum(m * (r0[, ax[1]]^2 + r0[, ax[3]]^2)) ) *
          ( sqrt(rep(m, each=3)) * as.numeric(rr[[ax[2]]]) )  ## second-axis

       schmidt(P) # Orthonormalization

     } else {

       P

     }
  } )

  ## effective reduced Hessian (can be parallelized)
#  H <- t(P) %*% H %*% P
  H <- lapply(1:nlevels(blocks), function(i) {
    myblock <- unique(blocks)[i]
    iatom <- which(blocks %in% myblock)
    P <- P.blocks[[myblock]]
    crossprod( P, H[atom2xyz(iatom), ] )
  } )
  H <- do.call(rbind, H)

  H <- lapply(1:nlevels(blocks), function(i) {
    myblock <- unique(blocks)[i]
    iatom <- which(blocks %in% myblock)
    P <- P.blocks[[myblock]]
    crossprod( t(H[, atom2xyz(iatom)]), P )
  })
  H <- do.call(cbind, H)

  ei <- eigen(H, ...)

  ## map eigenvector to 3N space
  block.bounds <- c(1, cumsum(sapply(P.blocks[unique(blocks)], ncol))+1)
  vecs <- lapply(1:nlevels(blocks), function(i) {
    myblock <- unique(blocks)[i]
#    iblock <- which(unique(blocks) %in% myblock)
    P <- P.blocks[[myblock]]
    crossprod( t(P), ei$vectors[(block.bounds[i]):(block.bounds[i+1]-1), ] )
  })
  ei$vectors <- do.call(rbind, vecs)

  ei
}


#' @param verbose logical, if TRUE print detailed processing message
#' @inheritParams aanma.pdb
#' @rdname aanma.pdb
rtb <- function(hessian, pdb, mass=TRUE, nmer=1, verbose=TRUE) {

  H <- hessian

  res <- paste( pdb$atom[, 'chain'],
                pdb$atom[, 'resno'],
                pdb$atom[, 'insert'], sep='_' )

  if(nmer > 1) {
    rl <- rle(res)
    g <- rep(1:ceiling(length(rl$lengths)/nmer), each=nmer)
    tosum <- split(rl$lengths, g[1:length(rl$lengths)])
    rl$lengths <- sapply(tosum, sum)
    rl$values <- rl$values[seq(1, length(g), nmer)]
    res <- inverse.rle(rl)
  }

  blocks <- as.factor(res)

  ## atom mass
  if(isTRUE(mass)) {
      m <- atom2mass(pdb)
  } else if(is.numeric(mass)) {
    m <- mass
  } else {
    m <- rep(1, nrow(pdb$atom))
  }

  if(verbose) {
    cat(" Diagonalizing Hessian with RTB...")
    ptm <- proc.time()
  }

  ei <- .diag.rtb(H, blocks, pdb$xyz, m,  symmetric=TRUE)

  if(verbose) {
    t <- proc.time() - ptm
    cat("\t\tDone in", t[[3]], "seconds.\n")
  }

  return( ei )
}

#' @param ... (in \code{gnm.pdbs}) additional arguments passed to \code{gnm.pdb}. 
#' @inheritParams aanma.pdbs
#' @rdname gnm
gnm.pdbs <- function(x, fit=TRUE, full=FALSE, subspace=NULL, rm.gaps=TRUE,
                     gc.first=TRUE, ncore=NULL, ...) {

  pdbs <- x
 
  if(!inherits(pdbs, "pdbs"))
    stop("input 'pdbs' should be a list object as obtained from 'read.fasta.pdb'")

  ## Log the call
  cl <- match.call()
  
  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore)

  if(ncore>1) {
    prev.warn <- getOption("warn")
    options(warn=1)
    on.exit(options(warn=prev.warn))
  }

  dots <- list(...)
  if('outmodes' %in% names(dots)) {
     warning('Customized "outmodes" is not supported')
     dots$outmodes <- NULL
  }
  if("keep" %in% names(dots))
    nm.keep <- dots$keep
  else
    nm.keep <- NULL
  dots$check.connect <- FALSE

  gaps.res <- gap.inspect(pdbs$ali)
  gaps.pos <- gap.inspect(pdbs$xyz)

  ## Check connectivity
  con <- inspect.connectivity(pdbs, cut=4.05)
  if(!all(con)) {
    warning(paste(paste(basename(pdbs$id[which(!con)]), collapse=", "),
                  "might have missing residue(s) in structure:\n",
                  "  Fluctuations at neighboring positions may be affected."))
  }

  ## Number of modes to store in U.subspace
  if(is.null(subspace)) {
    keep <- length(gaps.res$f.inds)-1
  }
  else {
    keep <- subspace
    if (length(gaps.res$f.inds) < (keep+1))
      keep <- length(gaps.res$f.inds)-1
  }
  if(!is.null(nm.keep) && keep > nm.keep)
    keep <- nm.keep

  if(fit) {
     xyz <- fit.xyz(pdbs$xyz[1, ], pdbs, gaps.pos$f.inds, gaps.pos$f.inds, ncore=ncore)
     pdbs$xyz[,] <- xyz
  }

  #### Prepare for NMA calculation ####      
  ## Fluctuations for each structure
  if(rm.gaps)
    flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=length(gaps.res$f.inds))
  else
    flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=ncol(gaps.res$bin))

  ## List object to store each modes object
  if(full)
    all.modes <- list()
  else
    all.modes <- NULL

  ## 3D array- containing the modes vectors for each structure
  if(rm.gaps)
    modes.array <- array(NA, dim=c(length(gaps.res$f.inds), keep, nrow(gaps.res$bin)))
  else
    modes.array <- array(NA, dim=c(ncol(pdbs$ali), keep, nrow(gaps.res$bin)))

  ## store eigenvalues of the first modes
  L.mat <- matrix(NA, ncol=keep, nrow=nrow(gaps.res$bin))

  ### Memory usage ###
  dims <- dim(modes.array)
  mem.usage <- sum(c(as.numeric(object.size(modes.array)),
                     as.numeric(object.size(L.mat)),
                     as.numeric(object.size(flucts)),
                     as.numeric(object.size(matrix(NA, ncol=dims[3], nrow=dims[3]))) ))*2

  if(full) {
    if(is.null(nm.keep))
      tmpncol <- dims[2]
    else
      tmpncol <- nm.keep

    size.mat <- object.size(matrix(0.00000001, ncol=tmpncol, nrow=dims[1]))
    size.vec <- object.size(vector(length=dims[1], 'numeric'))

    tot.size <- ((size.mat * 2) + (size.vec * 4)) * length(pdbs$id)
    mem.usage <- mem.usage+tot.size
  }
  mem.usage=round(mem.usage/1048600,1)

  #### Print overview of scheduled calcualtion ####
  cat("\nDetails of Scheduled Calculation:\n")
  cat(paste("  ...", length(pdbs$id), "input structures", "\n"))
  if(keep>0)
    cat(paste("  ...", "storing", keep, "eigenvectors for each structure", "\n"))
  if(keep>0)
    cat(paste("  ...", "dimension of x$U.subspace: (",
              paste(dims[1], dims[2], dims[3], sep="x"), ")\n"))

  if(fit)
    cat(paste("  ...", "coordinate superposition prior to NM calculation", "\n"))

  if(full)
    cat(paste("  ... individual complete 'gnm' objects will be stored", "\n"))

  if(rm.gaps)
    cat(paste("  ... aligned eigenvectors (gap containing positions removed) ", "\n"))

  if(mem.usage>0)
    cat(paste("  ...", "estimated memory usage of final 'eGNM' object:", mem.usage, "Mb \n"))

  cat("\n")

  ##### Start modes calculation #####

  ## Initialize progress bar
  pb <- .init.pb(ncore, min=0, max=length(pdbs$id))

  all.modes <- mclapply(1:length(pdbs$id), function(i) {

     if(gc.first) gc()

     pdb <- pdbs2pdb(pdbs, i, rm.gaps = FALSE)[[1]]
     sele <- match(gaps.res$f.inds, which(!is.gap(pdbs$ali[i, ])))
     sele <- as.select(sele)

     if(rm.gaps)
        modes <- try(do.call(gnm, c(list(x=pdb, outmodes=sele), dots)))
     else
        modes <- try(do.call(gnm, c(list(x=pdb), dots)))

     if(inherits(modes, 'try-error')) {
        .close.pb(pb)
        stop(paste('Encounter errors in ', i, 'th structure', sep=''))
     }

     .update.pb(pb)

     modes$call <- NULL
     return( modes )

  }, mc.cores=ncore)

  ## Finish progress bar
  .close.pb(pb)

  ##### Finalize calculation #####
  for(i in 1:length(all.modes)) {
     if(rm.gaps) {
       flucts[i, ] <- all.modes[[i]]$fluctuations
       modes.array[,,i] <- all.modes[[i]]$U[, 2:(keep+1)]
     } else {
       flucts[i, !is.gap(pdbs$ali[i, ])] <- all.modes[[i]]$fluctuations
       modes.array[!is.gap(pdbs$ali[i, ]),, i] <- all.modes[[i]]$U[, 2:(keep+1)]
     }
     L.mat[i, ] <- all.modes[[i]]$L[2:(keep+1)]
  }
  if(!full) all.modes <- NULL

  ##### RMSIP ######
  rmsip.map <- NULL
  if(rm.gaps) {
    rmsip.map <- .calcRMSIP(modes.array, ncore=ncore)
    rownames(rmsip.map) <- basename(rownames(pdbs$xyz))
    colnames(rmsip.map) <- basename(rownames(pdbs$xyz))

    if(!fit)
      warning("rmsip calculated on non-fitted structures:
               ensure that your input coordinates are pre-fitted.")
  }

  rownames(flucts) <- basename(rownames(pdbs$xyz))
  out <- list(fluctuations=flucts, rmsip=rmsip.map,
              U.subspace=modes.array, L=L.mat, full.nma=all.modes, call=cl)

  class(out) <- c("egnm", "enma")

  return(out)
}

`seqaln.pair` <-
function(aln, ...) {
  cl <- match.call()
  dots <- list(...)
  dots$extra.args = paste("-matrix",
                system.file("matrices/custom.mat", package="bio3d"),
                "-gapopen -3.0 ",
                "-gapextend -0.5",
                "-center 0.0", dots$extra.args)
  args <- c(list(aln=aln), dots) 
  l <- do.call(seqaln, args)

  if(!all((seqidentity(l))==1)) {
    warning("Sequences are not identical, use seqaln()")
  }
  l$call <- cl
  return(l)
}

rmsip <- function(...)
  UseMethod("rmsip")

rmsip.enma <- function(enma, ncore=NULL, subset=10, ...) {
  if(!inherits(enma, "enma"))
    stop("provide a 'enma' object as obtain from function 'nma.pdbs()'")
  if(any(is.na(enma$fluctuations)))
    stop("provide 'enma' object calculated with argument 'rm.gaps=TRUE'")
  
  ncore <- setup.ncore(ncore, bigmem = FALSE)
  
  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply
  
  dims <- dim(enma$fluctuations)
  m <- dims[1]

  mat <- matrix(NA, m, m)
  ##inds <- pairwise(m)
  inds <- rbind(pairwise(m),
                matrix(rep(1:m,each=2), ncol=2, byrow=T))
  
  mylist <- mylapply(1:nrow(inds), function(row) {
    i <- inds[row,1]; j <- inds[row,2];
    r <- rmsip.default(enma$U.subspace[,,i],
                      enma$U.subspace[,,j],
                      subset=subset)
    out <- list(val=r$rmsip, i=i, j=j)
    cat(".")
    return(out)
  })

  for ( i in 1:length(mylist)) {
    tmp <- mylist[[i]]
    mat[tmp$i, tmp$j] <- tmp$val
  }
  
  mat[ inds[,c(2,1)] ] = mat[ inds ]
  ##diag(mat) <- rep(1, n)
  colnames(mat) <- basename(rownames(enma$fluctuations))
  rownames(mat) <- basename(rownames(enma$fluctuations))

  cat("\n")
  return(round(mat, 6))
}

rmsip.default <- function(modes.a, modes.b, subset = 10,
                         row.name="a", col.name="b", ...) {
    
    if(missing(modes.a))
      stop("rmsip: 'modes.a' must be prodivded")
    if(missing(modes.b))
      stop("rmsip: 'modes.b' must be prodivded")
    
    m1 <- .fetchmodes(modes.a, subset=subset)
    m2 <- .fetchmodes(modes.b, subset=subset)

    dims.a <- dim(m1$U)
    dims.b <- dim(m2$U)
    subset <- dims.a[2]
    
    if( dims.a[1] != dims.b[1] )
      stop("dimension mismatch")
    if( dims.a[2] != dims.b[2] )
      stop("dimension mismatch")

    mass.a <- NULL; mass.b <- NULL;
    x <- normalize.vector(m1$U, mass.b)
    y <- normalize.vector(m2$U, mass.b)

    if(is.null(mass.a))
      o <- ( t(x) %*% y ) **2
    else
      o <- t(apply(x, 2, inner.prod, y, mass.a) **2)

    if (!is.null(row.name)) {
      rownames(o) <- paste(row.name, c(1:subset), sep="")
    }
    
    if (!is.null(col.name)) {
      colnames(o) <- paste(col.name, c(1:subset), sep="")
    }
    
    rmsip <- sqrt(sum(o)/subset)
    out <- list(overlap=round(o,3), rmsip=rmsip)

    class(out) <- "rmsip"
    return( out )
  }


.fetchmodes <- function(x, subset=NULL) {
  if (inherits(x, "pca")) {
    U <- x$U; L <- x$L;
    first.mode <- 1
  }
  else if (inherits(x, "nma")) {
    U <- x$U; L <- x$L;
    mass <- x$mass
    first.mode <- x$triv.modes+1
  }
  else {
    if( !(inherits(x, "matrix") | inherits(x, "pca.loadings")) )
      stop("provide an object of type 'pca', 'nma', or 'matrix'")
    U <- x; L <- NULL;
    first.mode <- 1
  }

  dims <- dim(U)
  if(is.null(subset)) {
    n <- dims[2]
  }
  else {
    n <- subset + first.mode - 1
    if(n>dims[2])
      n <- dims[2]
  }

  U <- U[, first.mode:n, drop=FALSE]
  L <- L[first.mode:n]
  
  out <- list(U=U, L=L, mass=NULL)
  return(out)
}

identify.cna <- function(x, labels=NULL, cna=NULL, ...){

  ## Be carefull with input argument order
  ##  - 'labels' can take any input and screw up priniting
  ##      e.g. if you pass cna as the second argument!
  ## Should this perhaps be able to take just a cna object as input
  ##   - Possible if cna object has layout defined
  ##   - Could take extra layout option for custom graphs
  ## x <- plot(net)
  ## 
  ## d <- identify.cna(x, cna=net)
  ## d <- identify.cna(x, labels=summary(net)$members)
 

  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
    stop("igraph package missing: Please install, see: ?install.packages")
  }

  if(dim(x)[2] != 2){
    stop("'x' object must be a Nx2 numeric matrix")
  }
  
  x.norm <- igraph::layout.norm(x, -1, 1, -1, 1)

  if( !is.null(labels) ) {
    ## Use input labels
    inds <- identify(x.norm[,1], x.norm[,2], labels, ...)
    return( labels[inds] ) 
  } else {
    if(is.null(cna)) {
      ## Use standard labels
      inds <- identify(x.norm[,1], x.norm[,2], ...)
      return(inds)
    } else {
      ## Take labels from cna object!!
      labels.all <- summary.cna(cna)
      labels.short <- labels.all$tbl$members
      labels.full <- labels.all$members
      inds <- identify(x.norm[,1], x.norm[,2], labels.short, ...)
      return( labels.full[inds] )
    }
  }
}

`aln2html` <-
function(aln, file = "alignment.html",
                     Entropy = 0.5,
                     append = TRUE,
                     caption.css = "color: gray; font-size: 9pt",
                     caption = "Produced by <a href=http://thegrantlab.org/bio3d/>Bio3D</a>",
                     fontsize = "11pt",
                     bgcolor = TRUE,
                     colorscheme="clustal") {

  if(is.list(aln)) {
    x=aln$ali
    id=aln$id
  } else {
    x=aln
    id=dimnames(x)[[1]]
  }

  if(is.null(id))
    stop("No $id list component or rownames for the alignment object")
  
  back <- ""; bold <- "" #bold <- "font-weight: bold"
  if (bgcolor) { back <- "background-"; bold <- "" }


  head <- paste("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n  <head>\n
    <STYLE type=\"text/css\">
      SPAN.A { ", back, "color:  #80b3e6; ", bold, " } /* Small and hydrophobic
*/
      SPAN.V { ", back, "color:  #80b3e6; ", bold, " }
      SPAN.L { ", back, "color:  #80b3e6; ", bold, " }
      SPAN.I { ", back, "color:  #80b3e6; ", bold, " }
      SPAN.M { ", back, "color:  #80b3e6; ", bold, " }
      SPAN.F { ", back, "color:  #80b3e6; ", bold, " }
      SPAN.W { ", back, "color:  #80b3e6; ", bold, " }

      SPAN.S { ", back, "color:  #1acc1a; ", bold, " } /* Hydroxyl and amine amino acids */
      SPAN.T { ", back, "color:  #1acc1a; ", bold, " }
      SPAN.N { ", back, "color:  #1acc1a; ", bold, " }
      SPAN.Q { ", back, "color:  #1acc1a; ", bold, " }

      SPAN.D { ", back, "color:  #cc4dcc; ", bold, " } /* Charged */
      SPAN.E { ", back, "color:  #cc4dcc; ", bold, " }

      SPAN.R { ", back, "color:  #e6331a; ", bold, " } /* Charged */
      SPAN.K { ", back, "color:  #e6331a; ", bold, " }

      SPAN.H { ", back, "color:  #1ab3b3; ", bold, " } /* Histidine and tyrosine */
      SPAN.Y { ", back, "color:  #1ab3b3; ", bold, " }

      SPAN.G { ", back, "color:  #e6994d; ", bold, " }

      SPAN.P { ", back, "color:  #cccc00; ", bold, " }

      SPAN.C { ", back, "color:  #80b3e6; ", bold, " }

      SPAN.boxres { border-width: 1; border: solid; text-align: center}
      SPAN.bot  { ", back, "color:  #ccffff; ", bold, " }
      SPAN.low  { ", back, "color:  #66ccff; ", bold, " }
      SPAN.mid  { ", back, "color:  #6699ff; ", bold, " }
      SPAN.high { ", back, "color:  #6666ff; ", bold, " }
      #helix { background-color: #ffcccc; }
      #strand { background-color: green }

    </STYLE>\n  </head>\n", collapse="",sep="" )


  body <- paste("  <body>
  <div style=\"font-size: ",fontsize, "; font-family: mono, courier; font-weight: normal; margin: 10px; white-space:nowrap\">\n")


##  id <- paste("\n<br /><a>",dimnames(x)[[1]],"&nbsp;&nbsp;&nbsp;&nbsp;</a>",sep="")

  #- id justification
#  id <- dimnames(x)[[1]]
  len <- nchar(id, type="chars")
  pad <- NULL; if(!all(max(len)==len)) {
    for(i in 1:length(id)) {
      pad <- c(pad, paste( rep("&nbsp;", max(len)-len[i]),collapse="" ))
    }
  }
  id <- paste("\n<br /><a>",id,pad,"&nbsp;&nbsp;&nbsp;</a>",sep="")


  if(colorscheme=="clustal") {
    # Clustal coloring
    al <- matrix( paste("<SPAN class=\"",x,"\">",x,"</SPAN>",sep=""), nrow=nrow(x))
  } else {
    #- Color by entropy score
    he <- entropy(x)
    score <- he$H.10.norm; score[ which(he$freq[c("-"),]>0.6) ] = 0

    rn <- cbind( (score > 0.4), (score > 0.575), (score > 0.75), (score > 0.9) )
    rn[ rn[,2], 1] = FALSE; rn[ rn[,3], 2] = FALSE; rn[ rn[,4], 3] = FALSE

    al=x
    b <- matrix( paste("<SPAN class=\"bot\">",x,"</SPAN>",sep=""), nrow=nrow(x))
    l <- matrix( paste("<SPAN class=\"low\">",x,"</SPAN>",sep=""), nrow=nrow(x))
    m <- matrix( paste("<SPAN class=\"mid\">",x,"</SPAN>",sep=""), nrow=nrow(x))
    h <- matrix( paste("<SPAN class=\"high\">",x,"</SPAN>",sep=""), nrow=nrow(x))

    al[ , which(rn[,1])] = b[ , which(rn[,1])]
    al[ , which(rn[,2])] = l[ , which(rn[,2])]
    al[ , which(rn[,3])] = m[ , which(rn[,3])]
    al[ , which(rn[,4])] = h[ , which(rn[,4])]
  }

  #- Dont color unconserved positions
  if(Entropy > 0) {
    if(colorscheme=="clustal")
      he <- entropy(x)
    execlude <- unique( c(which(he$H.10.norm < Entropy),
                          which(he$freq[c("-"),]>0.6)) )
    al[,execlude] = x[,execlude]
  }
  #- Dont color gaps
  ind<-which(x=="-",arr.ind=TRUE); al[ind]=x[ind]


  cat(head, body, file=file, append=append)
  for(i in 1:length(id))
    cat( id[i], al[i,], sep="", file=file, append=TRUE)
  cat(paste("\n  </div>\n",
            "<div style=\"", caption.css,"\">", caption ,"</div>\n",
            "    </body>\n</html>\n"), file=file, append=TRUE)


}

"dm" <- function(...)
  UseMethod("dm")

"dm.pdb" <- function(pdb, inds=NULL, grp=TRUE, verbose=TRUE, ...) {
  if(!is.pdb(pdb)) {
    stop("input 'pdb' should be either:
            1. an object returned from from 'read.pdb' or
            2. a numeric 'xyz' vector of coordinates")
  }

  if(!is.null(inds)) {
    pdb <- trim.pdb(pdb, inds)
  }

  if(grp)
    grpby <- paste(pdb$atom$resno, pdb$atom$chain, pdb$atom$insert, sep="-")
  else
    grpby <- NULL
  
  d <- dm.xyz(pdb$xyz, grpby=grpby, ...)
  
  class(d) <- "dmat"
  return(d)
}

"dm.pdbs" <- function(pdbs, rm.gaps=FALSE, all.atom=FALSE, 
                      aligned.atoms.only=NULL, ...) {
  if(!is.pdbs(pdbs))
    stop("Input should be a 'pdbs' object as obtained from 'read.fasta.pdb()' or 'read.all()'.")

  if(rm.gaps) {
    dots <- list(...)
    if("grpby" %in% names(dots) && !is.null(dots[["grpby"]])) {
      if(length(unique(dots[["grpby"]])) != ncol(pdbs$ali)) {
        stop("rm.gaps=TRUE not supported for non-residue wise grouping.")
      }
    }
  }
  
  if(!all.atom) {
    dmat <- dm.xyz(pdbs$xyz, ...)
  }
  else {
    # set a new default value of grpby for all-atom distance matrix
    dm.default <- list(grpby=pdbs$all.grpby)
    dm.args <- .arg.filter(dm.default, dm.xyz, ...)
    if(is.null(aligned.atoms.only)) {
      aligned.atoms.only <- FALSE
    }
    if(aligned.atoms.only) {
      # only consider aligned (equivalent) atoms
      gaps <- gap.inspect(pdbs$all)
      pdbs$all[, gaps$t.inds] <- NA
    }
    dmat <- do.call("dm.xyz", c(list(xyz=pdbs$all), dm.args))
  }
  
  if(rm.gaps) {
    gaps.res <- gap.inspect(pdbs$ali)
    dmat <- dmat[gaps.res$f.inds, gaps.res$f.inds, ]
  }
  return(dmat)

}

#' Dynamic Cross-Correlation from Gaussian Network Model
#'
#' Calculate the cross-correlation matrix from Gaussian network model normal 
#' modes analysis.
#'
#' This function calculates the cross-correlation matrix from Gaussian network
#' model (GNM) normal modes analysis (NMA) obtained from \code{gnm}. It returns 
#' a matrix of residue-wise cross-correlations whose elements, Cij, may be 
#' displayed in a graphical representation frequently termed a dynamical 
#' cross-correlation map, or DCCM. (See more details in \code{help(dccm.nma)}).
#'
#' @param x an object of class \sQuote{gnm} or \sQuote{egnm} as obtained from 
#'   \code{\link{gnm}}.
#' @param ... additional arguments (currently ignored).
#'
#' @return Returns a cross-correlation matrix.
#' 
#' @seealso \code{\link{gnm}}, \code{\link{dccm.nma}}, \code{\link{dccm.enma}},
#'   \code{\link{plot.dccm}}.
#'
#' @author Xin-Qiu Yao & Lars Skjaerven
#' 
#' @references 
#'    Bahar, I. et al. (1997) \emph{Folding Des.} \bold{2}, 173. 
#' 
#' @examples
#' ## Fetch stucture
#' pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
#'    
#' ## Calculate normal modes
#' modes <- gnm(pdb)
#'    
#' ## Calculate correlation matrix
#' cm <- dccm(modes)
#'
#' ## Plot correlation map
#' plot(cm, sse = pdb, contour = FALSE, col.regions = bwr.colors(20),
#'      at = seq(-1, 1, 0.1))
#'
#' @keywords analysis
"dccm.gnm" <- function(x, ...) {
  if (missing(x) || !inherits(x, 'gnm'))
    stop("dccm.gnm: must supply a 'gnm' object, i.e. from 'gnm.pdb()'")

  # variance-covariance matrix
  vcov <- cov.nma(x)
  
  # DCCM
  corr.mat <- vcov * 1/( sqrt(diag(vcov)) %*% t(sqrt(diag(vcov))) )
  class(corr.mat) <- c("matrix", "dccm")

  return(corr.mat)
}

#' @rdname dccm.gnm
"dccm.egnm" <- function(x, ...) {

  if (missing(x) || !inherits(x, 'egnm'))
  stop("dccm.egnm: must supply a 'egnm' object, i.e. from 'gnm.pdbs()'")
 
  # variance-covariance matrix
  vcovs <- cov.enma(x)

  # DCCM
  all.dccm <- apply(vcovs, 3, function(vcov) 
     vcov * 1/( sqrt(diag(vcov)) %*% t(sqrt(diag(vcov))) ) )
  all.dccm <- array(all.dccm, dim=dim(vcovs))

  avg.dccm <- rowMeans(all.dccm, dims=2)
  class(avg.dccm) <- c("matrix", "dccm")

  out <- list(all.dccm = all.dccm, avg.dccm = avg.dccm)
  return( out )

}

atom2mass <- function(...)
  UseMethod("atom2mass")

atom2mass.default <- function(x, mass.custom=NULL, elety.custom=NULL,
                              grpby=NULL, rescue=TRUE, ...){
  if(!is.null(mass.custom)) {
    if(!all(c("symb","mass") %in% names(mass.custom)))
      stop("'mass.custom' must contains 'symb' and 'mass' components")
    inds <- unlist(lapply(mass.custom, is.factor))
    mass.custom[inds] <- lapply(mass.custom[inds], as.character)
  }
  elements <- rbind(mass.custom[,c("symb","mass")], elements[,c("symb","mass")])
  symb <- atom2ele.default(x, elety.custom, rescue, ...)
  M <- elements[match(symb, elements[,"symb"]), "mass"]
  
  if(any(is.na(M)))
    stop(paste("\n\tatom2mass: mass of element '", symb[is.na(M)], "' unknown", sep=""))
  
  if(!is.null(grpby)) {
    if(length(grpby) != length(M))
      warning("'grpby' as been recycled")
    M <- unlist(lapply(split(M, grpby), sum))
  }
  return(M)
}

atom2mass.pdb <- function(pdb, inds=NULL, mass.custom=NULL, elety.custom=NULL,
                          grpby=NULL, rescue=TRUE, ...){
  if(!is.null(inds))
    pdb <- trim.pdb(pdb, inds)
  
  atom.names <- pdb$atom[,"elety"]
  M <- atom2mass.default(atom.names, mass.custom, elety.custom, grpby, rescue, ...)
  return(M)
}

.init.pb <- function(ncore, min=0, max=1) {
  if(ncore == 1) {

     return ( txtProgressBar(min=min, max=max, style=3) )

  } else if(ncore > 1) {

     mcparallel <- get("mcparallel", envir = getNamespace("parallel"))
     mccollect <- get("mccollect", envir = getNamespace("parallel"))

     fpb <- fifo(tempfile(), open = "w+b", blocking = T)

     # spawn a child process for message printing
     child <- mcparallel({
        pb <- txtProgressBar(min=min, max=max, style=3)
        progress <- 0.0
        while(progress < max && !isIncomplete(fpb)) {
           msg <- readBin(fpb, "double")
           progress <- progress + as.numeric(msg)
           setTxtProgressBar(pb, progress)
        }
        close(pb)
     } )

     names(fpb) <- child$pid
     return(fpb)
  }
}
.update.pb <- function(pb, step=1) {

  if(inherits(pb, "txtProgressBar")) {
     i <- getTxtProgressBar(pb)
     setTxtProgressBar(pb, i+step)
  }
  else {
     if(inherits(pb, "fifo"))
        writeBin(step, pb)
  }

}
.close.pb <- function(pb) {
   if(inherits(pb, "fifo")) {
      mccollect <- get("mccollect", envir = getNamespace("parallel"))
      mccollect(as.numeric(names(pb)))
#      mccollect(as.numeric(names(pb)))
   }
   close(pb)
}

vmd.ecna <- function(x, n=1, ...) {
   if(!inherits(x, "ecna")) {
      stop("The input 'x' must be an object of class 'ecna'.")
   }
   if(!(length(n)==1 && is.numeric(n) && n>0)) {
      stop("Input 'n' must be an nonzero integer.")
   }
   if(n > length(x)) {
      stop("Wrong index of networks.")
   }
   vmd(x[[n]], ...)
}
vmd.cna <- function(x, pdb, layout=layout.cna(x, pdb, k=3),
                     col.sphere=NULL, 
                     col.lines="silver",
                     weights=NULL,
                     radius=table(x$communities$membership)/5,
                     alpha=1,
                     vmdfile="network.vmd", pdbfile="network.pdb",
                     full=FALSE, launch=FALSE, exefile=NULL, ...) {

  ## Draw a cna network in VMD

  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }
    
  if(is.null(weights)){
    weights <- igraph::E(x$community.network)$weight
    
    if(is.null(x$call$minus.log)){
      weights <- exp(-weights)
    }
    else{
      if(x$call$minus.log){
        weights <- exp(-weights)
      }
    }
  }
  
  if(is.null(col.sphere)) {
    ## Get colors from network and convert to 0:17 VMD color index
    col.sphere <- match(igraph::V(x$community.network)$color, vmd_colors())-1
  } else {
    ## Check supplied color(s) will work in VMD
    if(!all(col.sphere %in% c(0:17))) {
      warning("Input 'col.sphere' may not work properly in VMD
               - should be 0:17 color index value")
    }
  }


  ##-- VMD draw functions for sphere, lines and cone
  .vmd.sphere <- function(cent, radius=5, col="red", resolution=25) {
    ## .vmd.sphere( matrix(c(0,0,0, 1,1,1), ncol=3,byrow=T) )
    
    if(ncol(cent) != 3)
      stop("Input 'cent' should be a 3 col xyz matrix")

    n <- nrow(cent); scr <- rep(NA, n) 
    if(length(col) != n)
      
      col <- rep(col, length=n)
    
    if(length(radius) != n)
      radius <- rep(radius, length=n)
    
    for(i in 1:n) {
      scr[i] <- paste0("draw color ", col[i],
                       "\ndraw sphere {",
                       paste(cent[i,], collapse = " "),
                       "} radius ", radius[i],
                       " resolution ",resolution, "\n")
    }
    return(scr)
  }
  
  
  .vmd.lines <- function(start, end, radius=0.2, col="silver", resolution=25) {
    
    ## .vmd.lines( start=matrix(c(0,0,0), ncol=3,byrow=T),
    ##         end=matrix(c(1,1,1), ncol=3,byrow=T) )
    
    if(ncol(start) != 3)
      stop("Input 'start' and 'end' should be 3 col xyz matrices")
    n <- nrow(start); scr <- rep(NA, n)
    
    if(length(col) != n)
      col <- rep(col, length=n)
    
    if(length(radius) != n)
      radius <- rep(radius, length=n)
    
    for(i in 1:n) {
      scr[i] <- paste0("draw color ", col[i],
                       "\ndraw cylinder {",
                       paste(start[i,], collapse = " "),
                       "} {", paste(end[i,], collapse = " "),
                       "} radius ", radius[i],
                       " resolution ",resolution, "\n")
    }
    return(scr)
  }
  
  .vmd.cone <- function(start, end, radius=5, col="silver", resolution=25) {
    warning("not here yet")
  }

  ##- Set alpha if needed
  scr <- NULL
  if(alpha != 1)
    scr <- paste("material change opacity Transparent",
                 alpha,"\ndraw material Transparent\n")
  
  ##- Lets get drawing
  ##radius = V(x$community.network)$size
  ###radius = table(x$raw.communities$membership)/5
  if(!full)  {
      scr <- c(scr, .vmd.sphere( layout, radius=radius, col=col.sphere))

      ## Edges
      ##edge.list <- unlist2(get.adjlist(x$community.network))
      ##start.no <- as.numeric(names(edge.list))
      ##end.no <- as.numeric((edge.list))
      ##inds <- which(end.no > start.no)
      ##start <- layout[start.no[inds],]
      ##end <- layout[end.no[inds],]
      edge.list <- igraph::get.edges(x$community.network, 1:length(igraph::E(x$community.network)))
      start <- layout[edge.list[,1],]
      end <- layout[edge.list[,2],]
      
      ## weights=E(x$community.network)$weight ##/0.2
      scr <- c(scr, .vmd.lines(start=start, end=end,
                               radius=weights, col=col.lines))
  }
      
  ## full network
  if(full) {

      ## Calpha PDB
      if(!all(pdb$atom$elety == "CA")) {
          message("Trimming provided PDB to calpha atoms")
          pdb.ca <- trim(pdb, "calpha")
      }
      else {
          pdb.ca <- pdb
      }

      if(length(x$network[1]) != nrow(pdb.ca$atom))
          stop("Mismatch between provided network and pdb")
      
      ## Edges
      edge.list <- igraph::get.edges(x$network, 1:length(igraph::E(x$network)))
      start <- matrix(pdb.ca$xyz[, atom2xyz(edge.list[,1]) ], ncol=3, byrow=TRUE)
      end <- matrix(pdb.ca$xyz[, atom2xyz(edge.list[,2]) ], ncol=3, byrow=TRUE)

      ## Edge colors and radius
      col2 <- match(igraph::V(x$network)$color, vmd_colors())-1
      names(col2) = 1:nrow(pdb.ca$atom)
      
      col3 = apply(edge.list, 1, function(x) {
          if(col2[x[1]]==col2[x[2]])
              col2[x[1]]
          else
              16 ## black
      })
      
      rad3 = apply(edge.list, 1, function(x) {
          if(col2[x[1]]==col2[x[2]])
              0.1
          else
              0.25
      })
      
      scr2 = .vmd.lines(start=start, end=end, radius=rad3, col=col3)
      scr = c(scr, scr2)

  }
  cat(scr, file=vmdfile, sep="")

  ## Output a PDB file with chain color
  # Use the chain field to store cluster membership data for color in VMD
  if(!is.null(igraph::V(x$network)$color)) {
    ch <- vec2resno(match(igraph::V(x$network)$color, vmd_colors()), 
                    resno=pdb$atom[, "resno"])
  }
  else {
    ch <- vec2resno(vec=x$communities$membership, resno=pdb$atom[,"resno"])
  }
    
  write.pdb(pdb, chain=LETTERS[ch], file=pdbfile)

  ## Launch option ...
  ## vmd -pdb network.pdb -e network.vmd
  if(launch) {

    ## Find default path to external program
    if(is.null(exefile)) {
      exefile <- 'vmd'
      if(nchar(Sys.which(exefile)) == 0) {
        os1 <- Sys.info()["sysname"]
        exefile <- switch(os1,
          Windows = 'vmd.exe', # to be updated
          Darwin = '/Applications/VMD\\ 1.9.*app/Contents/MacOS/startup.command',
          'vmd' )
      }
    }
    if(nchar(Sys.which(exefile)) == 0)  
      stop(paste("Launching external program failed\n",
                 "  make sure '", exefile, "' is in your search path", sep=""))
     
    cmd <- paste(exefile, pdbfile, "-e", vmdfile)

    os1 <- .Platform$OS.type
    if (os1 == "windows") {
      cmd <- paste(shQuote(exefile), pdbfile, "-e", vmdfile)
      shell(cmd)
    } else{
      system(cmd)
    }
  }
}

"rot.lsq" <-function(xx,
                    yy,
                    xfit=rep(TRUE,length(xx)),
                    yfit=xfit,
                    verbose=FALSE) {
  
  # Coordinate superposition with the Kabsch algorithm
  # from Acta Cryst (1978) A34 pp827-828 (to which equation no. refer)
  # yy is the target (i.e. fixed)

  xx <- matrix(xx,nrow=3, ) 
  x <- matrix(xx[xfit],nrow=3, ) 
  y <- matrix(yy[yfit],nrow=3, )
  
  if(length(x) != length(y)) stop("dimension mismatch in x and y")

  # mean positions 
  xbar <- apply(x,1,mean) ; ybar <- apply(y,1,mean)

  # center both sets
  xx <- sweep(xx,1,xbar) # NB xx centred on xbar 
  x <- sweep(x,1,xbar) ; y <- sweep(y,1,ybar)
  
  #irmsd <- sqrt(sum((x-y)^2)/dim(y)[2])
  #cat("#irmsd= ",round(irmsd,6),"\n")

  # generate the 3x3 moment matrix: R (Equation 3)
  R <- y %*% t(x)

  # form R'R
  RR <- t(R) %*% R
  
  # diagonalize R'R
  prj <- eigen(RR)
  prj$values[prj$values < 0 & prj$values >= -1.0E-12]<-1.0E-12
  
  # form A
  A <- prj$vectors

  # make explicitly rh system
  #	A[,3] <- v3cross(A[,1],A[,2])
  # inline the cross-product function call.
  b<-A[,1]; c <- A[,2]
  A[1,3] <- (b[2] * c[3]) - (b[3] * c[2])
  A[2,3] <- (b[3] * c[1]) - (b[1] * c[3])
  A[3,3] <- (b[1] * c[2]) - (b[2] * c[1])

  # form B (==RA) (Equation 8)
  B <- R %*% A

  # normalize B
  # B <- sweep(B,2,sqrt(apply(B^2,2,sum)),"/")
  B <- sweep(B,2,sqrt(prj$values),"/")

  # make explicitly rh system
  #	B[,3] <- v3cross(B[,1],B[,2])
  # inline the cross-product function call.
  b<-B[,1]; c <- B[,2]
  B[1,3] <- (b[2] * c[3]) - (b[3] * c[2])
  B[2,3] <- (b[3] * c[1]) - (b[1] * c[3])
  B[3,3] <- (b[1] * c[2]) - (b[2] * c[1])

  # form U (==Ba) (Equation 7)
  # U is the rotation matrix
  U <-  B %*% t(A)

  # here we apply transformation matrix to *all* elements of xx
  # rotate xx (Uxx)
  xx <- U %*% xx

  if(verbose) {
    ## also apply it to the subset, in order to compute residual
    x <- U %*% x

    ## estimate of residuals 
    frmsd <- sqrt(sum((x-y)^2)/dim(y)[2])
    cat("#rmsd= ",round(frmsd,6),"\n")
  }
# fest <- iest - sum(sqrt(prj$values))
# print(sqrt((2*fest)/dim(y)[2]))

# return xx centred on y
  xx <- sweep(xx,1,ybar,"+")
  as.vector(xx)
}

`plot.pca` <- function(x, pc.axes=NULL, pch=16, col=par("col"), cex=0.8, mar=c(4, 4, 1, 1), ...) {

  opar <- par(no.readonly=TRUE)
  par(pty="s", cex=cex, mar=mar)
  
  if(is.null(pc.axes)) {
    ##-- Overview plot has been requested
    par(mfrow=c(2, 2))
    pc.axes <- 1:3
    
    ## Variance per PC for axis label annotation
    p <- paste0("PC",1:3," (",  round((x$L[1:3]/sum(x$L)) * 100, 2),"%)")

    plot(x$z[,1],x$z[,2], type="p", pch=pch, xlab=p[1], ylab=p[2], col=col, ...)
    abline(h=0,col="gray",lty=2); abline(v=0,col="gray",lty=2)

    plot(x$z[,3],x$z[,2], type="p", pch=pch, xlab=p[3], ylab=p[2], col=col,...)
    abline(h=0,col="gray",lty=2); abline(v=0,col="gray",lty=2)

    plot(x$z[,1],x$z[,3], type="p", pch=pch, xlab=p[1], ylab=p[3], col=col,... )
    abline(h=0,col="gray",lty=2); abline(v=0,col="gray",lty=2)

    plot.pca.scree(x$L, ...)
    par(opar)  ##- Reset par for subsequent plot to this device
    
  } else {
    ##-- Score plot of an individual PC pair (e.g. 1 vs 2) has been requested
    if(length(pc.axes) != 2) { 
      stop("Input 'pc.axes' should be NULL (for overview plots) or numeric and of length two (for individual score plot)") 
    }

    ## Variance for axis labels
    p <- paste0("PC",pc.axes," (", round((x$L[pc.axes]/sum(x$L)) * 100, 2),"%)")

    par(cex=cex+0.2) ## Make axis legend text a little larger
    plot(x$z[,pc.axes[1]],x$z[,pc.axes[2]], type="p", pch=pch, xlab=p[1], ylab=p[2], col=col, ...)
    abline(h=0,col="gray",lty=2);abline(v=0,col="gray",lty=2)

  }
  invisible(x$z[,pc.axes, drop=FALSE])
}

as.pdb.prmtop <- function(prmtop, crd=NULL, inds=NULL, inds.crd=inds, ncore=NULL, ...) {
  ncore <- setup.ncore(ncore, bigmem=FALSE)

  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply

  if(!inherits(prmtop, "prmtop"))
    stop("provide a prmtop object as obtained from function read.prmtop")

  natoms.prmtop <- prmtop$POINTERS[1]
  if(is.null(crd)) {
    warning("producing PDB object with no XYZ coordinates")
    crd <- as.numeric(rep(NA, natoms.prmtop*3))
  }

  if(!inherits(crd, "amber")) {
    new <- list()
    new$xyz <- as.xyz(crd)
    new$natoms <- ncol(new$xyz)/3
    crd <- new
  }

  natoms.crd <- crd$natoms
  if( any(c(!is.null(inds), !is.null(inds.crd))) ) {
    if(is.null(inds)) {
      inds$atom = seq(1, natoms.prmtop)
      inds$xyz = atom2xyz(inds$atom)
      class(inds) = "select"
    }

    if(is.null(inds.crd)) {
      inds.crd$atom = seq(1, natoms.crd)
      inds.crd$xyz = atom2xyz(inds.crd$atom)
      class(inds.crd)="select"
    }

    natoms.prmtop = length(inds$atom)
    natoms.crd    = length(inds.crd$atom)
  }

  if(natoms.prmtop != natoms.crd)
    stop(paste("atom number mismatch:", natoms.prmtop, "(prmtop) vs", natoms.crd, "(crds)"))

  resmap <- function(i, type='resid') {
    if(i==length(prmtop$RESIDUE_POINTER))
      j <- prmtop$POINTERS[1] - prmtop$RESIDUE_POINTER[i] + 1
    else
      j <- prmtop$RESIDUE_POINTER[i+1] - prmtop$RESIDUE_POINTER[i]
    if(type=='resno')
      return(rep(i,j))
    if(type=='resid')
      return(rep(prmtop$RESIDUE_LABEL[i], j))
  }

  resno <- unlist(mylapply(1:length(prmtop$RESIDUE_POINTER), resmap, 'resno'))
  resid <- unlist(mylapply(1:length(prmtop$RESIDUE_POINTER), resmap, 'resid'))

  if(any(c(!is.null(inds), !is.null(inds.crd)))) {
    pdb <- as.pdb.default(xyz=crd$xyz[,inds.crd$xyz], elety=prmtop$ATOM_NAME[inds$atom],
                          resno=resno[inds$atom], chain=as.character(NA), resid=resid[inds$atom])
  }
  else {
    pdb <- as.pdb.default(xyz=crd$xyz, elety=prmtop$ATOM_NAME,
                          resno=resno, chain=as.character(NA), resid=resid)
  }

  pdb$call = match.call()
  return(pdb)
}

dm.xyz <- function(xyz, grpby=NULL, scut=NULL, mask.lower=TRUE, gc.first=FALSE, ncore=1, ...) {
  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore, bigmem = FALSE)

  if(ncore > 1) {
    mcparallel <- get("mcparallel", envir = getNamespace("parallel"))
    mccollect <- get("mccollect", envir = getNamespace("parallel"))
  }

  ## function for multicore calculation of dmats
  calcdm <- function(r.inds, core.id, xyz) {
    j <- 1
    out <- vector("list", length=length(r.inds))
    for(i in r.inds) {
      if(gc.first) gc()

      dmi <- .dm.xyz1(xyz[i,], grpby=grpby, scut=scut, mask.lower=mask.lower)
      out[[j]] <- dmi
      j <- j+1
      .update.pb(pb)
    }
    return(out)
  }
  
  xyz <- as.xyz(xyz)
  if(nrow(xyz)>1) {
    ## dimensions of final array
    d3 <- nrow(xyz)
    
    if(!is.null(grpby))
      d1 <- length(unique(grpby))
    else
      d1 <- ncol(xyz)/3
    
    dms <- array(data=0.00, dim=c(d1, d1, d3))

    ## multicore setup
    if(ncore>1) {
      jobs <- list()
    }

    ## run calcdm() for each core
    pb <- .init.pb(ncore, min=0, max=nrow(xyz))
    core.ids <- sort(rep(1:ncore, length.out=d3))
    for( i in 1:ncore ) {
      r.inds <- which(core.ids==i)

      if(ncore>1) {
        q <- mcparallel(calcdm(r.inds, i, xyz))
        jobs[[i]] <- q
      }
      else {
        dm.list <- calcdm(r.inds, i, xyz)
      }
    }
    .close.pb(pb)
      
    ## Collect all jobs
    if(ncore>1) 
      res <- mccollect(jobs, wait=TRUE)
    else
      res <- list(dm.list)

    ## list to array
    i <- 1
    for ( job in res ) {
      for(mat in job) {
        dms[,,i] <- mat
        i <- i+1
      }
    }
  }
  else {
    dms <- .dm.xyz1(xyz, grpby=grpby, scut=scut, mask.lower=mask.lower)
  }
  class(dms) <- 'dmat'
  return(dms)
}

.dm.xyz1 <-
function(xyz, grpby=NULL, scut=NULL, mask.lower=TRUE) {
  ##-- New distance matrix function with 'grpby' option
  ##  dm(pdb$xyz, grpby=pdb$atom[,"resno"], scut=3)
  
  xyz=as.xyz(xyz)
  if(dim(xyz)[1L]>1) {
    warning("multiple frames detected - using only the first row in xyz matrix")
    xyz = xyz[1,, drop=FALSE]
  }
  xyz=as.vector(xyz)
  
  ##- Full Distance matrix (could use 'dm' or 'dist.xyz')
  d <- as.matrix(dist(matrix(xyz, ncol = 3, byrow = TRUE)))
  
  ##- Mask lower.tri  
  if( mask.lower )
    d[lower.tri(d)] = NA

  ##- Mask concetive atoms
  if( is.null(grpby) ) {
    if (!is.null(scut)) {
      d[diag.ind(d, n = scut)] = NA
      if(!mask.lower) 
         d[lower.tri(d)] = t(d)[lower.tri(d)]
    }

    return(d)
    
  } else {

    ##- Group by concetive numbers in 'grpby'
    if( length(xyz) != (length(grpby)*3) )
      stop("dimension miss-match in 'xyz' and 'grpby', check lengths")

    ##- Bounds of 'grpby' numbers
    inds <- bounds(grpby, dup.inds=TRUE)
    nres <- nrow(inds)
    
    ##- Per-residue matrix
    m <- matrix(, ncol=nres, nrow=nres)
    ij <- pairwise(nres)
    
    ##  Ignore concetive groups (residues)
    if (!is.null(scut))
      ij <- ij[ij[,2]-ij[,1] > (scut-1),]
    
    ##- Min per residue
    for(k in 1 : nrow(ij) ) {
      t.d <- d[ (inds[ij[k,1],"start"]:inds[ij[k,1],"end"]),
                (inds[ij[k,2],"start"]:inds[ij[k,2],"end"]) ]
      if(!all(is.na(t.d))) 
        m[ij[k,1],ij[k,2]] <- min(t.d, na.rm=TRUE)
      else
        m[ij[k,1],ij[k,2]] <- NA
    }
    if( !mask.lower )
      m[lower.tri(m)] = t(m)[lower.tri(m)]
    
    return(m)
  
  }
}

check.utility <- function(x = c("muscle", "clustalo", "dssp", "stride", "mustang", "makeup"), 
   quiet = TRUE) {
  
  utilities <- match.arg(x, several.ok = TRUE)

  ##- Check on missing utility programs
  if('dssp' %in% utilities) {
    utilities <- c(utilities, 'mkdssp')
    missing.util <- nchar(Sys.which(utilities)) == 0
    missing.util['dssp'] <- all(missing.util[c('dssp', 'mkdssp')])
    missing.util <- missing.util[-length(missing.util)]
  } else {
    missing.util <- nchar(Sys.which(utilities)) == 0
  }
  if( any(missing.util) ) {
    if(!quiet) {
       warning(paste0("  Checking for external utility programs failed\n",
         "    Please make sure '", paste(names(missing.util[missing.util]), collapse="', '"),
         "' is in your search path, see:\n",
         "    http://thegrantlab.org/bio3d/tutorials/installing-bio3d#utilities"))
    }
    pass = FALSE
  } else {
    if(!quiet) cat("External utility programs found\n")
    pass = TRUE
  }
  invisible(pass)
}  

"mktrj.nma" <- function(nma = NULL,    # nma data structure
                        mode = 7,      # which mode to move along
                        mag = 10,      # magnification factor
                        step = 1.25,   # step size
                        file = NULL,   # output pdb file
                        pdb = NULL,    # pdb structure object
                        rock = TRUE,
                        ... ) {      # args for write.pdb

  ## make a trjactory of atomic displacments along a given mode
  if(!inherits(nma, "nma"))
    stop("mktrj.nma: must supply 'nma' object, i.e. from 'nma'")
  
  if(is.null(file))
    file <- paste("mode_", mode, ".pdb", sep="")

  #if(nma$L[mode]<=0)
  #  stop("Mode with eigenvalue <=0 detected. Check 'mode' index.")

  xyz <- as.vector(nma$xyz)
  nstep <- c(seq(step, to=mag, by=step))
  #zcoor  <- cbind(sqrt(nma$L[mode])) %*% nstep
  zcoor <- cbind(1) %*% nstep

  scor  <- function(x,u,m) { return(x*u+m) }
  plus  <- sapply(c(zcoor), scor, u=nma$modes[,mode], m=xyz)
  minus <- sapply(c(-zcoor), scor, u=nma$modes[,mode], m=xyz)
  
  if(rock) {
    coor  <- cbind(xyz,
                   plus,  plus[,rev(1:ncol(plus))],
                   xyz,
                   minus, minus[,rev(1:ncol(minus))])
  }
  else {
    coor  <- cbind(plus[,rev(1:ncol(plus))],
                   xyz,
                   minus)
  }
  coor <- as.xyz(t(coor))

  pdb.out <- NULL
  if(!is.null(pdb)) {
      if(!is.pdb(pdb))
        stop("provide a 'pdb' object as obtained from 'read.pdb()'")
      
      ## guess the configuration of the nma/pdb object
      natoms <- length(nma$xyz) / 3
      if(nrow(pdb$atom) == natoms)
          pdb.out <- pdb
      else if(length(atom.select(pdb, "calpha")$atom) == natoms)
          pdb.out <- trim(pdb, "calpha")
      else if(length(atom.select(pdb, "noh")$atom) == natoms)
          pdb.out <- trim(pdb, "noh")
      else {
          warning("'nma' and 'pdb' mismatch. Input argument 'pdb' will be ignored")
          pdb.out <- NULL
      }
  }
      
  write.pdb(xyz=coor, pdb=pdb.out, file=file, ...)
  invisible(coor)
}

## All-atom ENMs
"ff.aaenm" <- function(r, ...) {
  a <- 7424;
  k <- a * r^(-6)
  k[k>1500]=1500
  return(k)
}


ff.aaenm2 <- function(r, atom.id, pdb, ...) {
    # all non-covalent interactions
    a <- 7424;
    k <- a * r^(-6)

    # intra-residue
    res <- paste(pdb$atom$resno, pdb$atom$chain, pdb$atom$insert, sep="-")
    myres <- res[atom.id]
    intra.inds <- which(res == myres)
    k[ intra.inds ] = 200

    covalent.inds <- which(r < 2)
    k[ r < 2 ] = 1500

    k[k>1500]=1500
    return(k)
}


## Coarse-grained ENMs
#"ff.aaanm" <- function(r, cutoff=7, gamma=1, ...) {
#  ifelse( r>cutoff, 0, gamma )
#}


"ff.anm" <- function(r, cutoff=15, gamma=1, ...) {
  ifelse( r>cutoff, 0, gamma )
}

"ff.pfanm" <- function(r, cutoff=NULL, ...) {
  if(is.null(cutoff))
    return(r^(-2))
  else
    ifelse( r>cutoff, 0, r^(-2))
}

"ff.calpha" <- function(r, rmin=2.9, ...) {
  ## MMTK Units: kJ / mol / nm^2
  ##a <- 128; b <- 8.6 * 10^5; c <- 2.39 * 10^5;
  ## Bio3D Units: kJ / mol / A^2

  ## In case of unreasonable CA-CA distance
  if(!is.null(rmin))
    r[(r<rmin)] = rmin

  a <- 128 * 10^4; b <- 8.6 * 10^2; c <- 2.39 * 10^3;
  ifelse( r<4.0,
         b*(r) - c,
         a*(r)^(-6) )
}

"ff.sdenm" <- function(r, atom.id, pdb, ...) {
  ## sdENM by lazyload. contains an array with dimensions
  ## 20  x 20  x 27
  ## aa1 x aa2 x distance.category
  sdENM = bio3d::sdENM

  if(!is.pdb(pdb))
      stop("provide a 'pdb' object")
  sequ <- pdbseq(pdb)
   
  ## Check for non-standard amino acids
  if(any(sequ=="X")) {
    cat("\n")
    unk <- paste(unique(sequ[sequ == "X"]), collapse=", ")
    stop(paste("Unknown aminoacid identifier for:", unk))
  }

  ## Initialize
  natoms <- length(r)
  aa.now <- sequ[atom.id]

  ## vector for spring constants
  ks <- rep(NA, natoms)

  ## Make distance categories
  map.dist <- c(0, seq(4, 16.5, by=0.5))

  dist.cat <- cut(r, breaks=map.dist, labels=FALSE)
  dist.cat[is.na(dist.cat)] <- 27
  dist.cat[atom.id]         <- NA

  ## Unique distance categories
  unq.cat <- unique(dist.cat)

  for ( i in 1:length(unq.cat) ) {
    tmp.cat <- unq.cat[i]

    if(!is.na(tmp.cat)) {
      tmp.inds <- which(dist.cat==tmp.cat)

      ## Since the lower.tri is NA we look up twice :P
      a <- sdENM[ aa.now, sequ, tmp.cat ][ tmp.inds ]
      b <- sdENM[ sequ, aa.now, tmp.cat ][ tmp.inds ]

      ks[ tmp.inds ][!is.na(a)] <- a[!is.na(a)]
      ks[ tmp.inds ][!is.na(b)] <- b[!is.na(b)]
    }
  }

  ## Set special restraints for covalent pairs
  inds.k12 <- c(atom.id -1, atom.id+1)
  inds.k12 <- inds.k12[ intersect(which(inds.k12 > 0), which(inds.k12 <= natoms)) ]
  ks[inds.k12] <- 43.52
  ks[atom.id]=0

  ## should in principle not get this far ...
  if(any(is.na(ks))) {
    stop(paste("Incompatible protein sequence:\n",
               " Paramters only exists for standard amino acid residues"))
  }

  ## sdENM FF is in arbitrary units
  ## The values given were arbitrarily normalized, so that
  ## the average kappa (over all amino acid pairs) is equal to 1, at d = 6 Ang.
  ## scale to kJ / mol / A^2 range:
  ks <- ks * 0.0083144621 * 300 * 10
  return(ks)
}

"ff.reach" <- function(r, atom.id, ...) {
  natoms <- length(r)

  ## units in kJ/mol/A^2
  ## Table 1 - line DHFR
  #af <- 6770; as <- 2.08;
  #bf <- 0.951; bs <- 0.0589;
  #k12 <- 860; k13 <- 26.7; k14 <- 17;

  ## by correspondance with Kei (29 aug'13)
  ## line 38, page 1644, 2008 Biophysical J
  af <- 4810;  as <- 1.7;
  bf <- 0.872; bs <- 0.068;

  ## avgering over table 1
  k12 <- 866; k13 <- 28.7; k14 <- 24.16667;

  ## Calculate default interactions
  ks <- (af * exp(-bf*r)) + (as * exp(-bs*r))

  ## Differentiate between k12, k13, k14
  inds.k12 <- c(atom.id -1, atom.id+1)
  inds.k13 <- c(atom.id -2, atom.id+2)
  inds.k14 <- c(atom.id -3, atom.id+3)

  inds.k12 <- inds.k12[ intersect(which(inds.k12 > 0), which(inds.k12 <= natoms)) ]
  inds.k13 <- inds.k13[ intersect(which(inds.k13 > 0), which(inds.k13 <= natoms)) ]
  inds.k14 <- inds.k14[ intersect(which(inds.k14 > 0), which(inds.k14 <= natoms)) ]

  ks[inds.k12] <- k12;
  ks[inds.k13] <- k13;
  ks[inds.k14] <- k14;

  return(ks)
}


"load.enmff" <- function(ff='calpha') {

  ## Bahar "ANM"-ff
  if (ff=="anm")  {
    ff <- ff.anm
  }

  ## Yang Song and Jernigan (PNAS 2009)
  else if (ff=="pfanm") {
    ff <- ff.pfanm
  }

  ## Hinsen "C-alpha"-ff
  else if (ff=="calpha") {
    ff <- ff.calpha
  }

  ## sdENM
  else if(ff=="sdenm") {
    ff <- ff.sdenm
  }

  ## REACH
  else if(ff=="reach") {
    ff <- ff.reach
  }

  ## All-atom ENM
  else if(ff=="aaenm") {
    ff <- ff.aaenm
  }

  ## All-atom ENM
  else if(ff=="aaenm2") {
    ff <- ff.aaenm2
  }

  else {
    stop("force field not defined")
  }

  return(ff)
}

"stride" <-
function(pdb, exefile = "stride", resno=TRUE) {
  
  ## Log the call
  cl <- match.call()
  
  infile  <- tempfile()
  outfile <- tempfile()
  write.pdb(pdb, file=infile)

  os1 <- .Platform$OS.type
  if(os1 == "windows") {
     shell( paste(exefile," -f",outfile," ",infile,sep="") )
  } else {
     system( paste(exefile," -f",outfile," ",infile,sep="") )
  }
  raw.lines <- readLines(outfile)
  type <- substring(raw.lines, 1, 3)
  unlink(c(infile, outfile))

  raw.loc <- raw.lines[type == "LOC"]
  raw.tor <- raw.lines[type == "ASG"]

  phi <- as.numeric(substring(raw.tor, 43,49))
  psi <- as.numeric(substring(raw.tor, 53,59))
  
  # DEBUG: SSE length is inconsistent with the sequence length;
  # Read ASG instead of LOC lines
  sse <- substring(raw.tor, 25,25)
  cha <- substring(raw.tor, 10,10)
  acc <- as.numeric(substring(raw.tor, 65, 69))

  res.num  <- suppressWarnings(as.numeric(substring(raw.tor, 12, 15)))
  if(any(is.na(res.num))) {
    ins <- which(is.na(res.num))
    res.num[ins] <- as.numeric(substring(raw.tor, 11, 14))[ins]    
    if(resno) {
      warning("Insertions are found in PDB: Residue numbers may be incorrect.
            Try again with resno=FALSE")
    } 
    else {
      ii <- diff(res.num)
      ii[ii==0] <- 1     #Consecutive numbers at insertion residues
      ii[ii<0] <- 2      #Jumps at possible chain termination
      res.num <- res.num[1] + c(0, cumsum(ii))
    }
  }

#  res.ind <- 1:length(res.num)
#  res.name <- substring(raw.tor, 6, 8)
  h.res <- bounds(res.num[which(sse == "H")], pre.sort=FALSE)
  g.res <- bounds(res.num[which(sse == "G")], pre.sort=FALSE)
  e.res <- bounds(res.num[which(sse == "E")], pre.sort=FALSE)
  t.res <- bounds(res.num[which(sse == "T")], pre.sort=FALSE)

##  sseInfo <- cbind(resIndex=res.ind, resNumber=res.num,
##                   resName=res.name, sse=sse)
  
#  start <- as.numeric(substring(raw.loc, 23,27))
#  end   <- as.numeric(substring(raw.loc, 42,45))
#  chain <- substring(raw.loc, 29,29)
#
#  sse <- substring(raw.loc, 6,9)
#  
#  h.ind <- sse == "Alph"
#  g.ind <- sse == "310H"
#  e.ind <- sse == "Stra"
#  t.ind <- sse == "Turn"
#
#  sse.type <- sse
#  sse.type[h.ind] <- "H"
#  sse.type[g.ind] <- "G"
#  sse.type[e.ind] <- "E"
#  sse.type[t.ind] <- "T"

  h.ind <- h.res;    g.ind <- g.res
  e.ind <- e.res;    t.ind <- t.res
  
  if(length(h.res) > 0) {
    res.ind <- which(sse == "H")
    h.ind[, "end"] <- res.ind[cumsum(h.res[, "length"])]
    h.ind[, "start"] <- h.ind[, "end"] - h.res[, "length"] + 1
  }
  
  if(length(g.res) > 0) {
    res.ind <- which(sse == "G")
    g.ind[, "end"] <- res.ind[cumsum(g.res[, "length"])]
    g.ind[, "start"] <- g.ind[, "end"] - g.res[, "length"] + 1
  }
  
  if(length(e.res) > 0) {
    res.ind <- which(sse == "E")
    e.ind[, "end"] <- res.ind[cumsum(e.res[, "length"])]
    e.ind[, "start"] <- e.ind[, "end"] - e.res[, "length"] + 1
  }
  
  if(length(t.res) > 0) {
    res.ind <- which(sse == "T")
    t.ind[, "end"] <- res.ind[cumsum(t.res[, "length"])]
    t.ind[, "start"] <- t.ind[, "end"] - t.res[, "length"] + 1
  }
  
  if(!resno) {
    h.res <- h.ind;    g.res <- g.ind
    e.res <- e.ind;    t.res <- t.ind
  }

  sheet = list(start=NULL, end=NULL, length=NULL, chain=NULL)
  helix = list(start=NULL, end=NULL, length=NULL, chain=NULL, type=NULL)
  turn = sheet
  if(length(h.res)>1) {
    helix$start  = c(helix$start,h.res[, "start"])
    helix$end    = c(helix$end, h.res[, "end"])
    helix$length = c(helix$length, h.res[, "length"])
    helix$chain  = c(helix$chain, cha[h.ind[, "start"]])
    helix$type   = c(helix$type, sse[h.ind[, "start"]])
  }
  if(length(g.res)>1) {
    helix$start  = c(helix$start,g.res[, "start"])
    helix$end    = c(helix$end, g.res[, "end"])
    helix$length = c(helix$length, g.res[, "length"])
    helix$chain  = c(helix$chain, cha[g.ind[, "start"]])
    helix$type   = c(helix$type, sse[g.ind[, "start"]])
  }
  if(length(helix$start) > 0)
     helix <- lapply(helix, function(x) {names(x) <- 1:length(helix$start); return(x)})
  if(length(e.res)>1) {
    sheet$start  = c(sheet$start,e.res[, "start"])
    sheet$end    = c(sheet$end, e.res[, "end"])
    sheet$length = c(sheet$length, e.res[, "length"])
    sheet$chain  = c(sheet$chain, cha[e.ind[, "start"]])
  }
  if(length(sheet$start) > 0)
     sheet <- lapply(sheet, function(x) {names(x) <- 1:length(sheet$start); return(x)})
  if(length(t.res)>1) {
    turn$start  = c(turn$start,t.res[, "start"])
    turn$end    = c(turn$end, t.res[, "end"])
    turn$length = c(turn$length, t.res[, "length"])
    turn$chain  = c(turn$chain, cha[t.ind[, "start"]])
  }
  if(length(turn$start) > 0)
     turn <- lapply(turn, function(x) {names(x) <- 1:length(turn$start); return(x)})
  
#  if(any(h.ind | g.ind)) {
#     helix=list(start = c(start[h.ind], start[g.ind]),
#                end    = c(end[h.ind], end[g.ind]),
#                length = ( c(end[h.ind], end[g.ind]) -
#                          c(start[h.ind], start[g.ind]) + 1),
#                chain  = c(chain[h.ind], chain[g.ind]),
#                type   = c(sse.type[h.ind], sse.type[g.ind]))
#  }
#  if(any(e.ind)) {
#     sheet = list(start = start[e.ind],
#                end    = end[e.ind],
#                length = (end[e.ind] - start[e.ind] + 1),
#                chain = chain[e.ind])
#  }
#  if(any(t.ind)) {
#     turn  = list(start = start[t.ind],
#                end    = end[t.ind],
#                length =(end[t.ind] - start[t.ind] + 1),
#                chain = chain[t.ind])
#  }
  out <- list(helix = helix, sheet=sheet, hbonds=NULL, 
              turn=turn, phi=phi, psi=psi, acc=acc, 
              sse=sse, call=cl)
  
  class(out) <- "sse"
  return(out)
}

summary.cna <- function(object, verbose=TRUE, ...) {

  ## summary.cna(net)
  ## y <- summary.cna(net, file="tmp.tbl", col.names=FALSE, append=T)
  ## or just write 'y' to file!
  
  if( !"cna" %in% class(object) ) {
    stop("Input should be a cna network object")
  }

  size <- table(object$communities$membership)
  id   <- names(size)
  memb <- sapply(id, function(i) { which(object$communities$membership==i) } )
  ## NOTE: Perhaps the memb should be names() of which inds
  ##       rather than the inds themselves as it is curently?
  ##memb <- sapply(id, function(i) { names(which(object$membership==i)) } )

  ##- Format as condensed vector for printing
  if( is.numeric(unlist(memb)) ) {
    members <- rep(NA, length(id))
    for(i in 1:length(id)) {
      b <- bounds(memb[[i]])[,c("start","end"),drop=FALSE]
      
      single.member <- NULL
      for(a in 1:dim(b)[1]){
        if(b[a,1] != b[a,2]){
          single.member[a] <- paste0(b[a,1], ":", b[a,2])
        }
        else{
          single.member[a] <- b[a,1]
        }
      }
      if(length(single.member)>1){
        members[i] <- paste0("c(", paste0(single.member, collapse=", "), ")")
      }
      else{
        members[i] <- single.member
      }
    }
  } else{
    ##- non numeric vectors can not be condensed
    members <- unlist(lapply(memb, paste, collapse=", "))
  }
  
  ## Output silently as a list  
  tbl <- data.frame( id=as.numeric(id), 
              size=as.numeric(size), 
              members=members,
              stringsAsFactors=FALSE )

  y <- list("id"=id, "size"=size, "members"=memb, "tbl"=tbl)
  
  if(verbose) { print.data.frame(tbl, row.names=FALSE) }

  return(y)
}

"binding.site" <- function(a, b = NULL, a.inds = NULL, b.inds = NULL,
                           cutoff=5, hydrogens=TRUE, byres=TRUE, verbose=FALSE) {

  cl <- match.call()
  sep <- "_"

  trim <- function(s, leading=TRUE, trailing=TRUE) {
    if(leading)
      s <- sub("^ +", "", s)
    if(trailing)
      s <- sub(" +$", "", s)
    s[(s=="")]<-""
    s
  }

  if (!is.pdb(a))
    stop("must supply an input 'pdb' object 'a', i.e. from 'read.pdb'")

  ## workaround for NA chains
  if(any(is.na(a$atom$chain)))
    a$atom$chain[is.na(a$atom$chain)] <- " "

  ## backup of the original pdb provided
  a.orig <- a

  ## two PDBs provided
  if(!is.null(b)) {
    if(!is.pdb(b))
      stop("'b' should be a 'pdb' object as obtained from 'read.pdb'")

    if ( hydrogens ) {
      if(is.null(a.inds))
        a.inds <- atom.select(a, "all", verbose=verbose)
      if(is.null(b.inds))
        b.inds <- atom.select(b, "all", verbose=verbose)
    }
    else {
      if(is.null(a.inds))
        a.inds <- atom.select(a, string='noh', verbose=verbose)
      if(is.null(b.inds))
        b.inds <- atom.select(b, string='noh', verbose=verbose)
    }
  }

  ## one PDB object is provided
  else {
    if(is.null(a.inds) & is.null(b.inds)) {
      a.inds <- atom.select(a, "protein", verbose=verbose)
      b.inds <- atom.select(a, "ligand", verbose=verbose)

      if(!length(a.inds$atom)>0)
        stop("insufficent 'protein' atoms in structure")
      if(!length(b.inds$atom)>0)
        stop("insufficent 'ligand' atoms in structure")
    }

    b <- trim.pdb(a, b.inds)
    a <- trim.pdb(a, a.inds)

    if ( hydrogens ) {
      a.inds <- atom.select(a, "all", verbose=verbose)
      b.inds <- atom.select(b, "all", verbose=verbose)
    }
    else {
      a.inds <- atom.select(a, string='noh', verbose=verbose)
      b.inds <- atom.select(b, string='noh', verbose=verbose)
    }
  }

  if(!(length(a.inds$atom)>0 | length(b.inds$atom)>0))
    stop("insufficent atoms in selection(s)")

  ## omit hydrogens if any
  a <- trim.pdb(a, a.inds)
  b <- trim.pdb(b, b.inds)

  ## Calcuate pair-wise distances
  dmat <- dist.xyz(matrix(a$xyz, ncol=3, byrow=TRUE), matrix(b$xyz, ncol=3, byrow=TRUE))

  ## atoms of a in contact with b
  cmap <- apply(dmat, 1, function(x) any(x <= cutoff))
  atom.inds <- which(cmap)

  ## return NULL if no atoms are closer than cutoff
  if(length(atom.inds)<1)  {
    cat("  no atoms found within", cutoff, "A\n")
    return(NULL)
  }

  ## get rid of any trailing and leading spaces
  a$atom$resid <- trim(a$atom$resid)
  a$atom$resno <- trim(a$atom$resno)
  a$atom$elety <- trim(a$atom$elety)
  a.orig$atom$resno <- trim(a.orig$atom$resno)
  a.orig$atom$elety <- trim(a.orig$atom$elety)

  ## return all atoms in a contacting residue, otherwise, just the atoms
  if(byres) {
    resno.map  <- apply(a$atom[atom.inds, c("resno", "chain")], 1, paste, collapse=sep)
    all.resno  <- apply(a.orig$atom[, c("resno", "chain")],     1, paste, collapse=sep)
    atom.inds2 <- which(all.resno %in% resno.map)
  }
  else {
    resno.map  <- apply(a$atom[atom.inds, c("elety", "resno", "chain")], 1, paste, collapse=sep)
    all.resno  <- apply(a.orig$atom[, c("elety", "resno", "chain")],     1, paste, collapse=sep)
    atom.inds2 <- which(all.resno %in% resno.map)
  }

  xyz.inds <- atom2xyz(atom.inds2)

  ## check for chain IDs
  tmp <- unique(paste(a$atom[atom.inds, "resid"],
                      a$atom[atom.inds, "resno"],
                      a$atom[atom.inds, "chain"],
                      sep=sep))

  resno <- as.numeric(unlist(lapply(strsplit(tmp, sep), function(x) x[2])))
  chain <- unlist(lapply(strsplit(tmp, sep), function(x) x[3]))
  chain[chain==" "] <- NA

  if(all(is.na(chain))) {
    resnames <- unique(paste(a$atom[atom.inds, "resid"], " ",
                             a$atom[atom.inds, "resno"],
                             sep=""))
  }
  else {
    resnames <- unique(paste(a$atom[atom.inds, "resid"], " ",
                             a$atom[atom.inds, "resno"],
                             " (", a$atom[atom.inds, "chain"], ")",
                             sep=""))
  }

  sele <- list(atom=atom.inds2, xyz=xyz.inds)
  class(sele) <- "select"

  out <- list(inds=sele, resnames=resnames, resno=resno, chain=chain, call=cl)
  return(out)
}

## Use for trimming a pdbs object, either by removing structures,
## or by removing columns 

trim.pdbs <- function(pdbs, row.inds=NULL, col.inds=NULL, ...) {
  if(!inherits(pdbs, "pdbs"))
    stop("input 'pdbs' should be a list object as obtained from 'read.fasta.pdb'")
  
  ## Log the call
  cl <- match.call()
  
  if(is.null(row.inds))
    row.inds <- seq(1, nrow(pdbs$resno), by=1)
  if(is.null(col.inds)) {
    gaps <- gap.inspect(pdbs$resno[row.inds,,drop=FALSE])
    col.inds <- which(gaps$col < dim(pdbs$resno[row.inds,,drop=FALSE])[1L])
  }
  
  if(any(col.inds<0))
    col.inds.xyz <- atom2xyz(abs(col.inds)) * sign(rep(col.inds, each=3))
  else
    col.inds.xyz <- atom2xyz(col.inds)
  
  new <- NULL
  new$id    =pdbs$id[row.inds]
  new$xyz   = as.xyz(pdbs$xyz[row.inds, col.inds.xyz, drop=FALSE])
  new$resno =pdbs$resno[row.inds, col.inds, drop=FALSE]
  new$b     =pdbs$b[row.inds, col.inds, drop=FALSE]
  new$chain =pdbs$chain[row.inds, col.inds, drop=FALSE]
  new$ali   =pdbs$ali[row.inds, col.inds, drop=FALSE]
  new$resid =pdbs$resid[row.inds, col.inds, drop=FALSE]
  new$sse   =pdbs$sse[row.inds, col.inds, drop=FALSE]
  new$call  =cl
 
  if(!is.null(pdbs$insert)) {
    new$insert =pdbs$insert[row.inds, col.inds, drop=FALSE]
  }
  
  if(!is.null(pdbs$all)) {
    col.inds.all <- which(pdbs$all.grpby %in% abs(col.inds))
    col.inds.all <- col.inds.all * sign(rep(col.inds, rle(pdbs$all.grpby[col.inds.all])$length))

    if(any(col.inds.all<0))
      col.inds.all.xyz <- atom2xyz(abs(col.inds.all)) * sign(rep(col.inds.all, each=3))
    else
      col.inds.all.xyz <- atom2xyz(col.inds.all)

    new$all       = as.xyz(pdbs$all[row.inds, col.inds.all.xyz, drop=FALSE])
    new$all.elety = pdbs$all.elety[row.inds, col.inds.all, drop=FALSE]
    new$all.resno = pdbs$all.resno[row.inds, col.inds.all, drop=FALSE]
    new$all.resid = pdbs$all.resid[row.inds, col.inds.all, drop=FALSE]
    new$all.grpby   = vec2resno(1:ncol(new$ali), pdbs$all.grpby[col.inds.all])
  }

  class(new) <- c("pdbs", "fasta")
  return(new)
}

"pfam" <- function(id, alignment='seed', verbose=FALSE) {
  ##alignment <- 'full' ## seed, ncbi, full, metagenomics
  
  oops <- requireNamespace("RCurl", quietly = TRUE)
  if(!oops)
    stop("Please install the RCurl package from CRAN")
  
  cl <- match.call()
  format <- "fasta"
  
  url = paste('http://pfam.xfam.org/family/', id, '/acc', sep='')
  if(verbose)
    cat("Fetching accession from", url, "\n")
  
  if(!RCurl::url.exists(url)) {
    cat(url, "\n")
    stop("Url does not exist")
  }
  accid <- readLines(url, warn=FALSE)[1]
  
  ## download alignment
  url <- paste('http://pfam.xfam.org/family/', accid,
               '/alignment/', alignment, '/format?format=', format, sep='')

  if(verbose)
    cat("Fetching alignment from", url, "\n")

  if(!RCurl::url.exists(url)) {
    cat(url, "\n")
    stop("Url does not exist")
  }
  
  tmpfile <- tempfile()
  success <- download.file(url, tmpfile, quiet=!verbose)

  if(success==1)
    stop("Download failed")

  if(verbose)
    cat("Alignment successfully downloaded (", tmpfile, ")\n")
    
  fasta <- read.fasta(tmpfile)
  unlink(tmpfile)
  fasta$call=cl
  return(fasta)
}

"store.atom" <-
function(pdb=NULL) {

  atom.names <- c("N", "CA", "C", "O", "CB", "*G", "*G1", "*G2",
                  "*D", "*D1", "*D2", "*E", "*E1", "*E2", "*E3", "*Z", 
                  "*Z1", "*Z2", "*Z3", "*H", "*H1", "*H2") ##
  atom.greek <- c("N", "CA", "C", "O", "CB", "G", "G1", "G2",
                  "D", "D1", "D2", "E", "E1", "E2", "E3", "Z", 
                  "Z1", "Z2", "Z3", "H", "H1", "H2")

  if(is.null(pdb)) return(atom.names)
  
  colpaste <- function(x, col.names = colnames(x)) {
    apply(x, 1, function(row) paste(row[col.names], collapse = "."))
  }
  getinds <- function(atoms, ref = atom.names) {
    sort(atom2xyz(charmatch(atoms, ref)))
  }
  repadd <- function(num, nrep = nres, toadd = nxyz) {
    c(num, rep(num, (nrep - 1)) + rep(cumsum(rep(toadd, (nrep - 1))), each = length(num)))
  }
  atom.data <- colpaste(pdb$atom, c("elety", "resno", "insert", "chain"))
  atom.list <- matrix(unlist(strsplit(atom.data, "\\.")), ncol = 4, byrow = TRUE)
  res.data <- colpaste(pdb$atom, c("resno", "insert", "chain"))
  res.list <- unique(res.data)

  coords <- NULL
# Changed for PDB format v3.3  
#  blank <- matrix(NA, nrow = 13, ncol = length(atom.names))
  blank <- matrix(NA, nrow = ncol(pdb$atom), ncol = length(atom.names))
  for (i in 1:length(res.list)) {
    res.blank <- blank
    res.ind <- which(res.list[i] == res.data)
    
    blank.ind <- charmatch(atom.list[res.ind, 1], atom.names,
                 nomatch = 0) + charmatch(substr(atom.list[res.ind,1], 2, 4),
                   atom.greek, nomatch = 0)

    res.blank[, blank.ind[blank.ind != 0]] <-
      t( pdb$atom[(res.ind[blank.ind != 0]),] )

    coords <- cbind(coords, res.blank)
  }
  natm <- length(atom.names)
  # PDB format v3.3
  nxyz <- ncol(pdb$atom) * natm
  #  nxyz <- 13 * natm
  nres <- length(coords)/(nxyz)
  dim(coords) <- c(ncol(pdb$atom), natm, nres)
#  dim(coords) <- c(13, natm, nres)
  
  dimnames(coords) = list(atom = colnames(pdb$atom), type = atom.names,
            res = res.list)
  return(coords)
}

"orient.pdb" <-
function (pdb, atom.subset = NULL, verbose = TRUE ) {

  ## x <- c(rep(10,3), rep(0,3), rep(-10,3))
  ## write.pdb(xyz=x, file="t1.pdb")
  ## write.pdb(xyz=orient.pdb(x), file="t2.pdb")

  if (missing(pdb)) {
    stop("pdb.orient: must supply 'pdb' object, e.g. from 'read.pdb'")
  }
  
  if(is.list(pdb)) { xyz <- pdb$xyz
  } else {
    if (!is.vector(pdb)) {
      stop("pdb.orient: input 'pdb' should NOT be a matrix")
    }
    xyz <- pdb
  }
  xyz <- matrix( xyz, ncol=3, byrow=TRUE )   
  
  if (is.null(atom.subset)) atom.subset <- c(1:nrow(xyz))
  if (length(atom.subset) > nrow(xyz)) {
    stop("pdb.orient: there are more 'atom.subset' inds than there atoms")
  }
  

  ## Center on mean xyz positions
  xyz.bar <- apply(xyz[atom.subset, ], 2, mean)
  xyz <- sweep(xyz, 2, xyz.bar)
  
  ## Determine principal axis
  S <- var(xyz[atom.subset, ])
  prj <- eigen(S, symmetric = TRUE)
  
  ## Mke rotation explicitly rh system
  ## z <- xyz %*% (prj$vectors)
  A <- prj$vectors
  b <- A[,1]; c <- A[,2]
  A[1,3] <- (b[2] * c[3]) - (b[3] * c[2])
  A[2,3] <- (b[3] * c[1]) - (b[1] * c[3])
  A[3,3] <- (b[1] * c[2]) - (b[2] * c[1])
  
  ## Rotate
  z <- xyz %*% (A)
  
  if (verbose) {
    cat("Dimensions:", "\n")
    cat(" x  min=",  round(min(z[, 1]), 3),
        "   max=",   round(max(z[, 1]), 3),
        "   range=", round(max(z[, 1]) - min(z[, 1]), 3), "\n")
    
    cat(" y  min=", round(min(z[, 2]), 3),
        "   max=", round(max(z[, 2]), 3),
        "   range=", round(max(z[, 2]) - min(z[, 2]), 3), "\n")
    
    cat(" z  min=", round(min(z[, 3]), 3),
        "   max=", round(max(z[, 3]), 3),
        "   range=", round(max(z[, 3]) - min(z[, 3]), 3), "\n")
    
  }
  z <- round(as.vector(t(z)),3)
  z <- as.xyz(z)
  invisible(z)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

.read_cif <- function(filename, maxlines = -1L, multi = FALSE) {
    .Call('_bio3d_read_cif', PACKAGE = 'bio3d', filename, maxlines, multi)
}

.read_crd <- function(filename) {
    .Call('_bio3d_read_crd', PACKAGE = 'bio3d', filename)
}

.read_pdb <- function(filename, multi = FALSE, hex = FALSE, maxlines = -1L, atoms_only = FALSE) {
    .Call('_bio3d_read_pdb', PACKAGE = 'bio3d', filename, multi, hex, maxlines, atoms_only)
}

.read_prmtop <- function(filename) {
    .Call('_bio3d_read_prmtop', PACKAGE = 'bio3d', filename)
}

plot.geostas <- function(x, at=seq(0, 1, 0.1), main="AMSM with Domain Assignment",
                         col.regions=rev(heat.colors(200)), 
                         margin.segments=x$grps, ...) {
  
  plot.dccm(x$amsm, at=at, main=main, 
            col.regions=col.regions,
            margin.segments=margin.segments, ...)
  
}

"sse.bridges" <- function(sse, type="helix", hbond=TRUE, 
                          energy.cut=-1.0 ) {
  if(missing(sse))
    stop("sse missing")

  if(is.null(sse$hbonds))
    stop("sse$hbonds does not exists. run dssp with 'resno=FALSE' and 'full=TRUE'")
  
  natoms <- nrow(sse$hbonds)
  
  if(type=="helix") {
    sse2 <- sse$helix
    stype <- "H"
    lim <- 4
  }
  
  if(type=="sheet") {
    sse2 <- sse$sheet
    stype <- "S"
    lim <- 2
  }

  if(length(sse2$start)==0)
    return(NULL)

  ## character array of SSE membership
  simple.sse <- sse$sse
  simple.sse[ !(sse$sse %in% c("H", "E", "G", "I")) ] <- "L"
  simple.sse[ sse$sse %in% c("E") ]                   <- "S"
  simple.sse[ sse$sse %in% c("H", "I", "G") ]         <- "H"
  
  inds <- NULL
  for ( i in 1:(natoms-lim) ) {
    if(simple.sse[i]!=stype)
      next;

    paired <- NULL
    if(type=="helix") {
      paired <- i+4
      if(simple.sse[paired]!=stype)
        next;
    }

    if (type=="sheet") {
      ## bridge pair info
      paired <- sse$hbonds[i,c("BP1", "BP2")]
      paired <- paired[ !is.na(paired) ]

      if(length(paired)==0)
        next;
    }

    if(hbond) {
      ## H-bond info
      resid <- sse$hbonds[i, c(3,5,7,9)]
      energ <- sse$hbonds[i, c(4,6,8,10)]
      
      energ <- energ[ !is.na(resid) ]
      resid <- resid[ !is.na(resid) ]
      
      inds.tmp <- which(resid %in% paired)
      resid <- resid[inds.tmp]
      energ <- energ[inds.tmp]
      
      dups <- duplicated(resid)
      resid <- resid[ !dups ]
      energ <- energ[ !dups ]

      if(length(resid)==0)
        next;
      
      for( j in 1:length(resid) ) {
        if(energ[j] < energy.cut)
          inds <- c(inds, i, resid[j])
      }
    }

    else {
      for ( j in 1:length(paired) ) {
        inds <- c(inds, i, paired[j])
      }
    }
  }

  if(length(inds)==0)
    return(NULL)
  
  mat      <- matrix(inds, ncol=2, byrow=T)
  mat      <- t(apply(mat, 1, sort))
  pair.ids <- apply(mat, 1, function(x) paste(x, collapse="-"))
  mat      <- matrix(mat[!duplicated(pair.ids), ], ncol=2)
  
  return(mat)
}

as.pdb.mol2 <- function(mol, ...) {

    cl <- match.call()
    natoms <- nrow(mol$atom)
    pdbn <- list()

    allset <- FALSE
    resid <- strtrim(mol$atom$resid, 3)
    chain <- NULL
    
    if(!is.null(mol$substructure)) {
        if(all(c("root_atom", "subst_type", "chain") %in% colnames(mol$substructure))) {
            key1 <- paste(mol$atom$resno, mol$atom$resid, sep="-")
            rownames(mol$substructure) <- key1[ mol$subs$root_atom ]
            resid <- mol$substructure[key1, "sub_type"]
            chain <- mol$substructure[key1, "chain"]
            allset <- TRUE
        }
    }

    if(!allset & length(unique(mol$resid)) > 1) {
        warning("insuffient data in SUBSTRUCTURE to set residue and chain identifiers in PDB")
    }

    pdb <- as.pdb.default(pdb    = NULL,
                          xyz    = mol$xyz,
                          type   = rep("ATOM", natoms),
                          resno  = mol$atom$resno,
                          resid  = resid,
                          eleno  =  mol$eleno,
                          elety  = mol$atom$elena,
                          chain  = chain,
                          insert = NULL,
                          alt    = NULL,
                          o=NULL, b=NULL, segid=NULL,
                          elesy=unlist(lapply(strsplit(mol$atom$elety, split="[.]"),
                                                function(x) x[1])),
                          charge=mol$atom$charge)
    
    pdb$call <- cl
    return(pdb)
}

"dccm.nma" <-
  function(x, nmodes=NULL, ncore=NULL, progress = NULL, ...) {
    nma <- x
    if (missing(nma))
      stop("dccm.nma: must supply a 'nma' object, i.e. from 'nma'")
    if(!"nma" %in% class(nma))
      stop("dccm.nma: must supply 'nma' object, i.e. from 'nma'")

    ## Check for multiple cores
    ncore <- setup.ncore(ncore, bigmem = FALSE)
   
    if(ncore > 1) {
      mcparallel <- get("mcparallel", envir = getNamespace("parallel")) 
      mccollect <- get("mccollect", envir = getNamespace("parallel")) 
    }

    ## Inner product between all pairs of residues
    cross.inner.prod <- function(a, b) {
      mat <- apply(a, 1, "%*%", t(b))
      return(mat)
    }

    ## Calc initial correlations for a subset of modes
    corrmats <- function(r.inds, core.id, nma, corr.mat, freqs, progress) {
      for ( i in r.inds ) {
        mode <- matrix(nma$U[,i], ncol=3, byrow=TRUE)
        corr.mat <- corr.mat + (cross.inner.prod(mode, mode) / (freqs[i]**2))
    
        if(core.id==1) {
          setTxtProgressBar(pb, i)
        }

        if(!is.null(progress)) { 
            if(i %% 20 == 0) {
                progress$set(i)
            }
        }
      }
      return(corr.mat)
    }
    
    if(!is.null(nma$frequencies)) {
      freqs <- nma$frequencies
    }
    else {
      freqs <- nma$force.constants
    }
    
    if(is.null(nmodes))
      nmodes <- length(nma$L)
    else {
      nmodes <- nmodes + nma$triv.modes
      if(nmodes>length(nma$L)) {
        warning("'nmodes' larger than the number of modes")
        nmodes <- length(nma$L)
      }
    }

    ## Initialize progress bar
    ##ptm <- proc.time()
    pbmax <- nmodes + nma$natoms
    pb <- txtProgressBar(min=(nma$triv.modes+1), max=pbmax, style=3)

    ## Allocate the correl matrix
    corr.mat <- matrix(0, nma$natoms, nma$natoms)
    
    ## Which modes to use for calculation
    mode.inds <- (nma$triv.modes+1):nmodes
    core.ids  <- rep(1:ncore, length.out=length( mode.inds ))

    if(ncore>1) 
      jobs <- list()
    
    for ( i in 1:ncore ) {
      rinds <- mode.inds[ which(core.ids==i) ]
    
      if(ncore>1) {
        q <- mcparallel(corrmats(rinds, i, nma, corr.mat, freqs, progress))
        jobs[[i]] <- q
      }
      else
        corr.mat <- corrmats(rinds, i, nma, corr.mat, freqs, progress)
    }

    ## Collect all jobs, and sum matrices
    if(ncore>1) {
      res <- mccollect(jobs, wait=TRUE)
      for ( job in res ) {
        corr.mat <- corr.mat + job
      }
    }
    
    ## Basis for normalization
    a <- vector('numeric', length=nrow(corr.mat))
    k <- length(mode.inds) ## for ProgressBar !
    inds <- rep(1:nrow(corr.mat), each=3)
    
    for ( j in (nma$triv.modes+1):nmodes )  {
      v <- nma$U[, j] * nma$U[, j]
      a <- a + ( tapply( v, inds, sum) / (freqs[j]**2))
      
      k <- k+1
      setTxtProgressBar(pb, k)
      
      if(!is.null(progress)) {
          if(j %% 20 == 0) {
              progress$set(k)
          }
      }
    }
    
    close(pb)
    
    a <- sqrt(a)
    bn <- a%o%a
    
    ## Normalized correlation matrix
    corr.mat <- corr.mat / bn
    class(corr.mat) <- c("dccm", "matrix")
    
    ##t <- proc.time() - ptm
    ##cat(" Done in", t[[3]], "seconds.\n")
    
    return(corr.mat)
  }

cmap.pdb <- function(pdb, inds=NULL, verbose=FALSE, ...) {
  if(!is.pdb(pdb))
    stop("provide a pdb object as obtained from function 'pdb'")

  if(is.null(inds)) {
    inds <- atom.select(pdb, "notwater", verbose=verbose)
  }

  pdb <- trim.pdb(pdb, inds)
  xyz <- pdb$xyz
  grpby <- paste(pdb$atom$chain, pdb$atom$insert, pdb$atom$resno, sep="-")
  return(cmap.xyz(xyz, grpby, ...))

}

cmap.pdbs <- function(pdbs, rm.gaps=FALSE, all.atom=FALSE, ...) {
  if(!is.pdbs(pdbs))
    stop("Input should be a 'pdbs' object as obtained from 'read.fasta.pdb()' or 'read.all()'.")
  
  if(rm.gaps) {
    dots <- list(...)
    if("grpby" %in% names(dots) && !is.null(dots[["grpby"]])) {
      if(length(unique(dots[["grpby"]])) != ncol(pdbs$ali)) {
        stop("rm.gaps=TRUE not supported for non-residue wise grouping.")
      }
    }
  }
  
  if(!all.atom) {
    # set a new default value of dcut for CA-CA contact map
    cmap.default <- list(dcut=10.0, collapse=FALSE)
    cmap.args <- .arg.filter(cmap.default, cmap.xyz, ...)
    cm <- do.call("cmap.xyz", c(list(xyz=pdbs$xyz), cmap.args))
  }
  else {
    # set a new default value of grpby for all-atom contact map
    cmap.default <- list(grpby=pdbs$all.grpby, collapse=FALSE)
    cmap.args <- .arg.filter(cmap.default, cmap.xyz, ...)
    cm <- do.call("cmap.xyz", c(list(xyz=pdbs$all), cmap.args))
  }
  
  if(rm.gaps) {
    gaps.res <- gap.inspect(pdbs$ali)
    ndim <- length(dim(cm))
    if(ndim>2) {
       cm <- cm[gaps.res$f.inds, gaps.res$f.inds, ]
    }
    else {
       cm <- cm[gaps.res$f.inds, gaps.res$f.inds]
    }
  }
  return(cm)
}

pymol.dccm <- function(dccm, pdb, file=NULL,
                       step=0.2, omit=0.2, radius = 0.15,
                       type="script", exefile = "pymol", ...) {
  
  allowed <- c("session", "script", "launch", "pdb")
  if(!type %in% allowed) {
    stop(paste("input argument 'type' must be either of:",
               paste(allowed, collapse=", ")))
  }

  if(type %in% "pdb")
    pymol <- FALSE
  else
    pymol <- TRUE

  ## Check if the program is executable
    if(type %in% c("session", "launch")) {
        
        ## determine path to exefile
        exefile1 <- .get.exepath(exefile)
        
        ## Check if the program is executable
        success <- .test.exefile(exefile1)
        
        if(!success) {
            stop(paste("Launching external program failed\n",
                       "  make sure '", exefile, "' is in your search path", sep=""))
        }
        exefile <- exefile1
    }
  
  if(is.pdb(pdb)) {
    ca.inds <- atom.select(pdb, 'calpha', verbose=FALSE)
    bb.inds <- atom.select(pdb, 'backbone', verbose=FALSE)
    xyz <- pdb$xyz[ca.inds$xyz]
    
    ## If more than CA atoms are provided, assume its enough to draw cartoon in pymol
    if(length(pdb$xyz[bb.inds$xyz])==length(xyz))
      ca.pdb <- TRUE
    else
      ca.pdb <- FALSE
  }
  else {
    xyz <- pdb
  }
  
  if(missing(dccm))
    stop("correlation matrix must be provided")
  if(missing(xyz))
    stop("cartesian coordinates missing")

  if(is.matrix(radius)) {
    if(!all(dim(dccm) == dim(radius)))
      stop("dimension mismatch. provide a 'radius' matrix with the same dimensions as 'dccm'")
  }    
  
  dims <- dim(dccm)
  if((length(xyz)/3)!=dims[1L])
    stop("unequal vector lengths")

  if(is.null(file)) {
    if(type=="session")
      file <- "R.pse"
    if(type=="script")
      file <- "R.py"
    if(type=="pdb")
      file <- "R.pdb"
  }

  ## use temp-dir unless we output a PML script
  if(type %in% c("session", "launch"))
    tdir <- tempdir()
  else
    tdir <- "."

  psefile <- tempfile(tmpdir=tdir, fileext=".pse")
  pyfile <- tempfile(tmpdir=tdir, fileext=".py")
  pdbfile <- tempfile(tmpdir=tdir, fileext=".pdb")
  
  ## Build the new PDB or pymol script in a vector
  scr <- c()
    
  if(pymol) {
    ## start pymol script
    scr <- c("from pymol import cmd")
    scr <- c(scr, "from pymol.cgo import *")
    scr <- c(scr, paste("cmd.load('", 
      normalizePath(pdbfile, winslash='/', mustWork=FALSE), 
       "', 'prot')", sep=""))
    scr <- c(scr, "cmd.show('cartoon')")
    
    if(!is.pdb(pdb) || ca.pdb)
      scr <- c(scr, "cmd.set('cartoon_trace_atoms', 1)")
    
    ## define color range 
    blues <- colorRamp(c("white", "blue"))
    reds  <- colorRamp(c("white", "red"))
    w <- radius 
  }
  else {
    m <- 0
  }
  
  ## mask lower tri of correlation matrix
  dccm[lower.tri(dccm, diag=TRUE)] <- NA
  
  lims <- c(-1, 1)
  intervals <- seq(lims[1], lims[2], by=step)
  
  ## get rid of interval around 0
  if(!is.null(omit)) {
    i <- which(intervals>(omit-0.001))
    j <- which(intervals<(-omit+0.001))
    inds <- sort(c(i,j))
    intervals <- sort(intervals[inds])
  }
  
  for ( i in 1:(length(intervals)-1) ) {
    lower <- intervals[i]
    upper <- intervals[i+1]
    
    if(lower<0 && upper>0)
      next
   
    ## make the positive and negative distributions symmetric
    if(lower<0)
      sele <- intersect( which(dccm>=lower), which(dccm<upper) )
    else
      sele <- intersect( which(dccm>lower), which(dccm<=upper) )

    if(length(sele)==0)
      next
    
    f       <- matrix(FALSE, ncol(dccm), nrow(dccm))
    f[sele] <- TRUE
    inds    <- which(f, arr.ind=TRUE)
    
    if(pymol) {
      scr <- c(scr, "obj=[]")
    }
    else {
      m <- m+1
      chain <- LETTERS[m]
    }
    
    for ( j in 1:nrow(inds) ) {
      x <- inds[j,1]; y <- inds[j,2]; 
      
      if(x==y)
        next
      
      val <- dccm[x,y]           ## corr coeff
      k   <- atom2xyz(inds[j,1]) ## resi 1
      l   <- atom2xyz(inds[j,2]) ## resi 2

      if(is.matrix(w))
        w2 <- abs(w[x, y])
      else
        w2 <- w
      
      if(pymol) {
        a <- paste(xyz[k], collapse=",")
        b <- paste(xyz[l], collapse=",")
        
        if(val<=0)
          col <- blues( abs(val) )
        else
          col <- reds( abs(val) )
        
        col <- round(col/256,4)
        col <- paste(col, collapse=", ")
        
        str <- paste("obj.extend([CYLINDER", a, b, w2, col, col, "])", sep=", ")
        scr <- c(scr, str)
      }
      else {
        a <- paste(format(xyz[k], justify="right", width=8), collapse="")
        b <- paste(format(xyz[l], justify="right", width=8), collapse="")
        
        val <- format(round(val,2), justify="right", width=6)
        res.str <- format(x, justify="right", width=4)
        str <- paste("ATOM   ", res.str, "  CA  ALA ", chain, res.str, "    ", a, "  0.00", val, sep="")
        scr <- c(scr, str)
        
        res.str <- format(y, justify="right", width=4)
        str <- paste("ATOM   ", res.str, "  CA  ALA ", chain, res.str, "    ", b, "  0.00", val,  sep="")
        scr <- c(scr, str)
        
        str <- paste("CONECT",
                     format(x, justify="right", width=5),
                     format(y, justify="right", width=5), sep="")
        scr <- c(scr, str)
      }
    }
    
    if(pymol) {
      tmpa <- gsub("\\.", "", as.character(lower))
      tmpb <- gsub("\\.", "", as.character(upper))
      name <- paste("cor_", tmpa, "_", tmpb, sep="")
      str <- paste("cmd.load_cgo(obj, '", name, "')", sep="")
      scr <- c(scr, str)
    }
    else {
      str <- "TER"
      scr <- c(scr, str)
    }
  }

  if(type == "session") {
    scr <- c(scr, paste0("cmd.save('", 
      normalizePath(psefile, winslash='/', mustWork=FALSE),
      "')"))
    }
  
  ## Write python script or PDB with conect records
  if(pymol) {
    write(scr, file=pyfile, sep="\n")
    
    ## Write PDB structure file
    if(is.pdb(pdb))
      write.pdb(pdb, file=pdbfile)
    else
      write.pdb(xyz=xyz, file=pdbfile)
  }
  else {
    write(scr, file=pdbfile, sep="\n")
  }
  
  if(type %in% c("session", "launch")) {
    if(type == "session")
      args <- "-cq"
    else
      args <- ""
    
    ## Open pymol
    cmd <- paste(exefile, args, pyfile)

    os1 <- Sys.info()["sysname"]
    if (os1 == "Windows") {
        status <- shell(paste(shQuote(exefile), args, pyfile))
    }
    else {
        status <- system(cmd)
    }
    
    if(!(status %in% c(0,1))) {
        stop(paste("An error occurred while running command\n '",
                   exefile, "'", sep=""))
    }

  }

  if(type == "session") {
    file.copy(psefile, file, overwrite=TRUE)
    message(paste("PyMOL session written to file", file))
    invisible(file)
  }
  
  if(type == "script") {
    file.copy(pyfile, file, overwrite=TRUE)
    unlink(pyfile)
    message(paste("PyMOL script written to file", file))
    invisible(file)
  }

  if(type == "pdb") {
    file.copy(pdbfile, file, overwrite=TRUE)
    unlink(pdbfile)
    message(paste("PDB written to file", file))
    invisible(file)
  }
  
}

"fit.xyz" <-
function(fixed,
         mobile,
         fixed.inds  = NULL,
         mobile.inds = NULL,
         verbose = FALSE,
         prefix = "",
         pdbext = "",
         outpath = "fitlsq",
         full.pdbs=FALSE,
         ncore=1,
         nseg.scale=1, # to resolve the memory problem in using multicore
         ...) {

  # Parallelized by parallel package (Tue Dec 11 17:41:08 EST 2012)
  ncore <- setup.ncore(ncore)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }
 
  ### Addation (Mon Jul 23 17:26:16 PDT 2007)
  if( is.null(fixed.inds) && is.null(mobile.inds) ) {
    if(is.list(mobile)) {
      fixed.inds <- intersect(which(!is.gap(fixed)),
                              gap.inspect(mobile$xyz)$f.inds )
    } else {
      fixed.inds <- intersect(which(!is.gap(fixed)),
                              gap.inspect(mobile)$f.inds )
    }
    mobile.inds <- fixed.inds
    warning(paste("No fitting indices provided, using the",
                  length(fixed.inds)/3,  "non NA positions\n"))
  }
  
  
  if (is.null(fixed.inds)) fixed.inds=which(!is.gap(fixed))
  if (is.null(mobile.inds))  mobile.inds=gap.inspect(mobile)$f.inds

  if (length(fixed.inds) != length(mobile.inds))
    stop("length of 'fixed.inds' != length of 'mobile.inds'")

#  if(!is.xyz(fixed) || !is.numeric(fixed))
  if(!is.numeric(fixed))
    stop("input 'fixed' should be a numeric 'xyz' vector or matrix")

  if(is.vector(mobile)) {   # INPUT is a single vector
    if(!is.numeric(mobile))
      stop("input 'mobile' should be numeric")

    if( any(is.na(fixed[fixed.inds])) ||
       any(is.na(mobile[mobile.inds])) ) {
      stop(" NA elements selected for fitting (check indices)")
    }
    
    fit <- rot.lsq(xx=mobile,
                   yy=fixed,
                   xfit=mobile.inds,
                   yfit=fixed.inds,
                   verbose=verbose)

    return(as.xyz(fit))
  } else {
    if(is.list(mobile)) {      # INPUT is a list object
      if(!is.numeric(mobile$xyz))
        stop("non numeric input 'mobile$xyz'")
      
      if( any(is.na(fixed[fixed.inds])) ||
         any(is.na(mobile$xyz[,mobile.inds])) ) {
        stop(" NA elements selected for fitting (check indices)")
      }

      if(ncore>1 && is.matrix(mobile$xyz) ) {        # Parallelized
         RLIMIT = floor(R_NCELL_LIMIT/ncol(mobile$xyz))
         nDataSeg = floor((nrow(mobile$xyz)-1)/RLIMIT)+1
         nDataSeg = floor(nDataSeg * nseg.scale)
         lenSeg = floor(nrow(mobile$xyz)/nDataSeg)
         fit = vector("list", nDataSeg)
         for(i in 1:nDataSeg) {
            istart = (i-1)*lenSeg + 1
            iend = if(i<nDataSeg) i*lenSeg else nrow(mobile$xyz)
            fit[[i]] <- mclapply(istart:iend, function(j) rot.lsq(xx=mobile$xyz[j,],
               yy=fixed, xfit=mobile.inds, yfit=fixed.inds, verbose=verbose), 
               mc.preschedule=TRUE)
         }
         fit <- matrix(unlist(fit), ncol=ncol(mobile$xyz), byrow=TRUE)
      } else {           # Single version
         fit <- t( apply(mobile$xyz, 1, rot.lsq,
                         yy = fixed,
                         xfit = mobile.inds,
                         yfit = fixed.inds,
                         verbose=verbose))
      }
       
      if(full.pdbs) {        # FULL PDB fitting and output
        core.inds.atom = mobile.inds[seq(3,length(mobile.inds),by=3)]/3
        dir.create(outpath, FALSE)
        
        full.files  <- paste(prefix, mobile$id, pdbext, sep="")
        
        mylapply <- lapply 
        if(ncore>1) mylapply <- mclapply

#        for(i in 1:length(mobile$id)) {
        mylapply(1:length(mobile$id), function(i) {
###          pdb  <- read.pdb( paste(pdb.path,"/",mobile$id[i],pdbext,sep=""), ... )
          pdb  <- read.pdb( full.files[i], ... )
          res.resno  <- mobile$resno[i,core.inds.atom]
          res.chains <- mobile$chain[i,core.inds.atom]
          chains <- unique(res.chains[!is.na(res.chains)])

          if(length(chains)==0) {
            ##string <- paste("///",
            ##          paste(mobile$resno[i,core.inds.atom],collapse = ","),
            ##                   "///CA/", sep="")
            
            inds <- atom.select(pdb, resno=res.resno, elety="CA",
                                verbose=verbose)$xyz

          } else {
            if(length(chains)==1) {
              #string <- paste("//",chains,"/",
              #                paste(res.resno, collapse = ","),
              #                "///CA/", sep="")
              
              inds <- atom.select(pdb, resno=res.resno, chain=chains, elety="CA", 
                                  verbose=verbose)$xyz
            } else {
              # indices for each chain
              inds <- NULL
              for(j in 1:length(chains)) {
                #string <- paste("//",chains[j],"/",
                #                paste(res.resno[ res.chains==chains[j] ],
                #                      collapse = ","),
                #                "///CA/", sep="")
                
                inds <- c(inds, atom.select(pdb, resno=res.resno[ res.chains==chains[j] ],
                                            chain=chains[j], elety="CA", verbose=verbose)$xyz)
              }
            }
          }
          pdb.xyz <- pdb$xyz
          #if (het) 
          #  pdb.xyz <- c(pdb.xyz,
          #               as.numeric(t(pdb$het[,c("x","y","z")])))

          if(length(inds) > length(fixed.inds)) {
            warning("Looks like we have a multi-chain pdb with no chain id: ignoring extra indices\n\t")
            inds <- inds[1:length(fixed.inds)]
          }
          
          xyz.fit <- rot.lsq(xx=pdb.xyz,
                             yy=fixed,
                             xfit=inds, # sort!!
                             yfit=fixed.inds)

          write.pdb(xyz = xyz.fit, pdb = pdb, ##het = het, 
                    file = file.path(outpath, paste(basename(mobile$id[i]),
                      "_flsq.pdb",sep = "")) )
          return (NULL)
        } )
      }
      return(as.xyz(fit))
    } else {
      if(full.pdbs)
        warning("Need 'mobile' list object for 'full.pdbs=TRUE'")
      if(is.matrix(mobile)) {       # INPUT is a matrix
        if(!is.numeric(mobile))
          stop("input 'mobile' should be numeric")

        if( any(is.na(fixed[fixed.inds])) ||
           any(is.na(mobile[,mobile.inds])) ) {
          stop("error: NA elements selected for fitting")
        }

        if(ncore > 1) {         # Parallelized
           RLIMIT = floor(R_NCELL_LIMIT/ncol(mobile))
           nDataSeg = floor((nrow(mobile)-1)/RLIMIT)+1
           nDataSeg = floor(nDataSeg * nseg.scale)
           lenSeg = floor(nrow(mobile)/nDataSeg)
           fit = vector("list", nDataSeg)
           for(i in 1:nDataSeg) {
              istart = (i-1)*lenSeg + 1
              iend = if(i<nDataSeg) i*lenSeg else nrow(mobile)
              fit[[i]] <- mclapply(istart:iend, function(j) rot.lsq(xx=mobile[j,],
                 yy=fixed, xfit=mobile.inds, yfit=fixed.inds, verbose=verbose), 
                 mc.preschedule=TRUE)
           }
           fit <- matrix(unlist(fit), ncol=ncol(mobile), byrow=TRUE)
        } else {         # Single version
           fit <- t( apply(mobile, 1, rot.lsq,
                           yy = fixed,
                           xfit = mobile.inds,
                           yfit = fixed.inds,
                           verbose=verbose))
        }
        return(as.xyz(fit))
      }
    }
  }
}

"plot.dmat" <-
function(x,
         key = TRUE,
         resnum.1 = c(1:ncol(x)),
         resnum.2 = resnum.1,
         axis.tick.space = 20,
         zlim = range(x, finite = TRUE),
         nlevels = 20,
         levels = pretty(zlim, nlevels),
         color.palette = bwr.colors,
         col = color.palette(length(levels) -1),
         axes = TRUE,
         key.axes,
         xaxs = "i",
         yaxs = "i",
         las = 1,
         grid = TRUE,
         grid.col = "yellow",
         grid.nx = floor(ncol(x)/30),
         grid.ny = grid.nx,
         center.zero = TRUE,
         flip=TRUE,
         ...) {
  
  if (missing(x)) {
    stop("no 'x' distance matrix specified")
  }

  if(center.zero) {
    if(zlim[1]<0) {
      ## make levels equidistant around 0
      levels = pretty(c(-max(abs(zlim)),max(abs(zlim))), nlevels)
    }
  }
    
  mar.orig <- (par.orig <- par(c("mar", "las", "mfrow")))$mar
  on.exit(par(par.orig))

  # Color key
  if(key) {
    w <- (3 + mar.orig[2]) * par("csi") * 2.54
    layout(matrix(c(2, 1), ncol = 2), widths = c(1, lcm(w)))
    
    par(las = las)
    mar <- mar.orig
    mar[4] <- mar[2]
    mar[2] <- 1
    par(mar = mar)

    plot.new()
    plot.window(xlim = c(0, 1), ylim = range(levels),
                xaxs = "i", yaxs = "i")
    rect(0, levels[-length(levels)], 1, levels[-1], col = col)
    if (missing(key.axes)) {
      if (axes)
        axis(4)
    }
    else key.axes
    box()
  }    

  # Matrix plot
  mar <- mar.orig
  mar[4] <- 1
  par(mar = mar)
  class(x)=NULL
  
  z <- as.matrix(as.data.frame(t(x)))
  nums <- seq(1,ncol(x),by=axis.tick.space)
    
  if(flip) { 
    ylim = c(ncol(z),1) 
  } else { 
    ylim = c(1,ncol(z)) 
  }

  image(x=1:ncol(x),
        y=1:nrow(x),
        z=z,
        zlim=zlim,
        col=col, yaxt="n", xaxt="n", ...)
        #xlab="Residue Number", ylab="Residue Number")

  axis(side=1, at=nums, labels=resnum.1[nums])
  axis(side=2, at=nums, labels=resnum.2[nums])
  
  if(grid)
    grid(grid.nx ,grid.ny, col=grid.col)
  box()
}

`get.seq` <-
function(ids, outfile="seqs.fasta", db="nr", verbose=FALSE) {
  ## Download FASTA format sequences from the NCBI nr,
  ## SWISSPROT/UNIPROT, or RCSB PDB databases via their gi,
  ## SWISSPROT identifer number, or PDB ids.
  oops <- requireNamespace("httr", quietly = TRUE)
  if(!oops)
    stop("Please install the httr package from CRAN")

  db <- tolower(db)
  if( !(db %in% c("nr", "swissprot", "uniprot", "pdb")) )
    stop("Option database should be one of nr, swissprot/uniprot, or pdb")

  db <- switch(db, nr='nr', swissprot='uniprotkb', 
                   uniprot='uniprotkb', pdb='pdb')

  ids <- toupper(ids)
  ids <- unique(ids)

  if(db == "nr") {
    baseUrl <- 'https://www.ncbi.nlm.nih.gov/sviewer/viewer.fcgi?db=protein'
  } else {
    baseUrl <- 'https://www.ebi.ac.uk/Tools/dbfetch/dbfetch'
 
    # check if API works
    url <- paste(baseUrl, '/dbfetch.databases', sep='')
    resp <- httr::GET(url)
    if(httr::http_error(resp))
      stop('Access to EMBL-EBI server failed.')
  }
  
  # fetch sequences
  ## Remove existing file
  if(file.exists(outfile)) {
    warning(paste("Removing existing file:",outfile))
    unlink(outfile)
  }
  
  if(verbose) {
    cat("Fetching sequences from\n\t", baseUrl, "\n\nPlease wait", sep="")
  } else {
    cat("Fetching... Please wait")
  }

  ## do multiple requests if # of sequences > nmax
  if(grepl('ebi', baseUrl)) {
     nmax = 100
  } else {
     nmax = 500
  }
  errorCount=0
  checkInterval = 3
  checkInterval2 = 300 # wait longer if blocked by servers
  n <- floor( (length(ids)-1)/nmax) + 1
  for(i in 1:n) {
    if(i>1) Sys.sleep(10) # sleep 10s before sending another request
    i1 <- (i-1)*nmax+ 1
    i2 <- ifelse(i*nmax>length(ids), length(ids), i*nmax)
    ids1 <- ids[i1:i2]
    if(db=="nr") {
      url <- paste(baseUrl, "&val=", paste(ids1, collapse=','), 
                   "&report=fasta&retmode=text&page_size=",nmax, sep='')
    } else {
      url <- paste(baseUrl, '?db=', db, '&id=', paste(ids1, collapse=','), '&format=fasta&style=raw', sep='')
    }
    resp <- try(httr::GET(url), silent=TRUE)
    if(inherits(resp, 'try-error')) {
      text <- 'LOST CONNECTION'
    } else {
      text <- httr::content(resp, 'text', encoding='utf-8')
    }
    retry=0
    while((grepl('^LOST CONNECTION', text) || httr::http_error(resp) || 
           grepl('^ERROR', text) ||
           grepl('Nothing has been found', text)) && retry<3) {
      retry = retry + 1
      if(grepl('^LOST CONNECTION', text)) {
        if(verbose) {
          cat('\nLost connection to the URL:\n\t', url, '\n\nRetry ', retry, 
            ' in ', as.integer(checkInterval2*retry/60), ' minutes...', sep='')
        } else {
          cat('\nLost connection. Retry ', retry, ' in ', 
            as.integer(checkInterval2*retry/60), 'min...', sep='') 
        }
        Sys.sleep(checkInterval2 * retry)
      } else { 
        if(verbose) {
          cat('\nFetching sequences failed from the URL:\n\t', url, '\n\nRetry ', 
            retry, '...', sep='')
        } else {
          cat('\nFailed. Retry ', retry, '...', sep='')
        }
        Sys.sleep(checkInterval)
      }
      resp <- try(httr::GET(url), silent=TRUE)
      if(inherits(resp, 'try-error')) {
         text <- 'LOST CONNECTION'
      } else {
         text <- httr::content(resp, 'text', encoding='utf-8')
      }
    }
    if(grepl('^LOST CONNECTION', text) || httr::http_error(resp) || 
       grepl('^ERROR', text) ||
       grepl('Nothing has been found', text)) {
      errorCount = errorCount + 1
      if(errorCount==n)
        stop('No sequence found. Check the ID(s).')
    } else {
       ## BUGFIX: remove the space between uniprot ID and acc. no.
       ## and so both will be read via read.fasta() for checking below.
       if(db == "uniprotkb") {
         text <- gsub("(>[^ ]*) ", "\\1|", text)
       }
       cat(text, file=outfile, append=TRUE)
    }
    cat('.')
  }
  cat(' Done.\n')
  
  # check if all sequences are downloaded successfully.
  seqs <- read.fasta(outfile)
  if(db=="nr") {
    myids <- strsplit(seqs$id, split='\\|')
    myids <- sapply(myids, function(x) {
      ii <- match('pdb', x)
      if(!is.na(ii)) {
        x[ii+1] <- paste(x[ii+1], x[ii+2], sep='_')
      }
      paste(x, collapse='|')
    })
    rtn <- sapply(ids, function(x) !any(grepl(x, myids)))
    
    if(length(seqs$id) == length(ids)) {
      if(any(rtn)) {
        warning("Returned sequence IDs may be different from query.")
      }
      rtn = FALSE
    }
  } 
  else {
    rtn <- sapply(ids, function(x) !any(grepl(x, seqs$id)))
  }
  
  if(all(!rtn)) {
    return(seqs)
  } else {
    warning("Not all downloads were successful. See returned values (TRUE=possibly failed).")
    return(rtn)
  }
}

context("Testing get.seq()")

test_that("get.seq() works properly", {
  skip_on_cran()
  skip_on_travis()

  outfile <- tempfile()
  
  # NR
  # Use mixed RefSeq, Uniprot, and PDB Accession.
  ids <- c("NP_851365", "P62873", "1L3R_E", "5P21_A")
  capture.output( seqs <- get.seq(ids, outfile=outfile, db='nr') )
  expect_equal(length(seqs$id), 4)
  expect_identical(head(seqs$ali[1,]), c('M','G','A','G','A','S'))
  expect_identical(head(seqs$ali[2,]), c('M','S','E','L','D','Q'))
  expect_identical(head(seqs$ali[3,]), c('G','N','A','A','A','A'))
  expect_identical(head(seqs$ali[4,]), c('M','T','E','Y','K','L'))
  unlink(outfile)
  
  Sys.sleep(5)
  
  # NR
  # Retrieved IDs may be different from the query; shoot warning
  # In the following, a GI number is converted to a PDB code.
  ids <- c("829581541")
  expect_warning( capture.output(seqs <- get.seq(ids, outfile=outfile, db='nr')) )
  expect_equal(length(seqs$id), 1)
  expect_identical(seqs$id, c("pdb|4TND|A"))
  expect_identical(head(seqs$ali[1,]), c('M','E','L','E','N','I'))
  unlink(outfile)
  
  Sys.sleep(5)
  
  # NR
  # Another example that retrieved ID changes is when query ID is from
  # a different database. 5X3X has both "A" and "a" chains in PDB.
  # But in 'nr', they are coded as "A" and "AA".
  # But the server behaves weirdly in this case:
  # - input '5X3X_A' or '5X3X_a' (bio3d calls toupper() internally) 
  #   gives either A or AA randomly.
  # - input '5X3X_AA' does not work anymore.
  # 
  # Comment out because of the random behavior
  #ids <- c("5X3X_A", "5X3X_a", "5X3X_AA")
  #expect_warning( seqs <- get.seq(ids, outfile=outfile, db='nr') )
  #expect_equal(length(seqs$id), 1)
  #expect_identical(seqs$id, c("pdb|5X3X|AA"))
  #expect_identical(head(seqs$ali[1,]), c('M','T','P','I','L','A'))
  #unlink(outfile)
  #Sys.sleep(5)

    
  # NR
  # Some wrong IDs.
  #         OK,       wrong chain ID,  typo
  ids <- c("4Q21_A",  "1TND_E",        "1L3_E")
  expect_warning( capture.output(seqs <- get.seq(ids, outfile=outfile, db='nr')) )
  expect_true(is.logical(seqs))
  expect_equivalent(seqs, c(FALSE, TRUE, TRUE))
  unlink(outfile)
  
  Sys.sleep(5)
  
  
  # EBI - uniprot/swissprot
  ids <- c("P11488", "P62873", "TCPA_YEAST")
  capture.output( seqs <- get.seq(ids, outfile=outfile, db='uniprot') )
  expect_equal(length(seqs$id), 3)
  expect_identical(head(seqs$ali[1, ]), c('M','G','A','G','A','S'))
  expect_identical(head(seqs$ali[2, ]), c('M','S','E','L','D','Q'))
  expect_identical(head(seqs$ali[3, ]), c('M','S','Q','L','F','N'))
  unlink(outfile)
  
  Sys.sleep(5)
  
  # EBI - pdb
  ids <- c("1TAG_A", "1TND_B", "3J3Q_0") 
  capture.output( seqs <- get.seq(ids, outfile=outfile, db='pdb') )
  expect_equal(length(seqs$id), 3)
  expect_identical(head(seqs$ali[1,]), c('A','R','T','V','K','L'))
  expect_identical(tail(seqs$ali[2,]), c('K','D','C','G','L','F'))
  expect_identical(head(seqs$ali[3,]), c('P','I','V','Q','N','L'))
  unlink(outfile)
  
  Sys.sleep(5)
  
  # EBI - pdb
  # Double-letter chain IDs are not supported.
  # So, for example, "3J3Q_10", "3J3Q_aA" etc. do not work.
  # 
  # ids <- c("3J3Q_10", "3J3Q_aA", "3J3Q_0")
  # expect_warning( seqs <- get.seq(ids, outfile=outfile, db='pdb') )
  # expect_true(is.logical(seqs))
  # expect_equivalent(seqs, c(TRUE, TRUE, FALSE))
  #
  # Smaller case chain IDs are not supported (because the internal 
  # case conversion in get.seq(); Does the server supports smaller cases?)
  #
  # Not all chains are available from the server:
  # ids <- c("3J3Q_A")
  # expect_error( seqs <- get.seq(ids, outfile=outfile, db='pdb') )
  #
  # In the following, the result will be constantly "A" (not random as NCBI)
  # ids <- c("5X3X_A")
  # seqs <- get.seq(ids, outfile=outfile, db='pdb') 
  #
  # Returns all capital cases only
  # ids <- c("5X3X")
  # seqs <- get.seq(ids, outfile=outfile, db='pdb') 
  
  
  # EBI - uniprot/swissprot
  # One of the ids is wrong.
  # Note: all sequences after the wrong id will not be retrieved.
  # The behavior for 'pdb' is different: only wrong ids are not retrieved.
  ids <- c("P11488", "P62873", "P999")
  expect_warning(capture.output(seqs <- get.seq(ids, outfile=outfile, db='uniprot')))
  expect_true(is.logical(seqs))
  expect_equivalent(seqs, c(FALSE, FALSE, TRUE))
  unlink(outfile)
  
  Sys.sleep(5)
  
  # EBI
  # All ids are wrong - choose wrong database
  ids <- c("1TAG_A", "1TND_B")
  expect_error( capture.output(seqs <- get.seq(ids, outfile=outfile, db='uniprot')) )
   
  unlink(outfile)
})

#' Inspect And Clean Up A PDB Object
#'
#' Inspect alternative coordinates, chain breaks, bad residue
#' numbering, non-standard/unknow amino acids, etc. Return
#' a 'clean' pdb object with fixed residue numbering and optionally
#' relabeled chain IDs, corrected amino acid names, removed water,
#' ligand, or hydrogen atoms. All changes are recorded in a log in the 
#' returned object.
#'
#' @details call for its effects.
#' 
#' @param pdb an object of class \code{pdb} as obtained from
#'    function \code{\link{read.pdb}}. 
#' @param consecutive logical, if TRUE renumbering will result in
#'    consecutive residue numbers spanning all chains. Otherwise new residue
#'    numbers will begin at 1 for each chain.
#' @param force.renumber logical, if TRUE atom and residue records are renumbered 
#'    even if no 'insert' code is found in the \code{pdb} object.
#' @param fix.chain logical, if TRUE chains are relabeled based on chain breaks detected.
#' @param fix.aa logical, if TRUE non-standard amino acid names are converted into 
#'    equivalent standard names. 
#' @param rm.wat logical, if TRUE water atoms are removed.
#' @param rm.lig logical, if TRUE ligand atoms are removed.
#' @param rm.h logical, if TRUE hydrogen atoms are removed.
#' @param verbose logical, if TRUE details of the conversion process are printed.
#'
#' @return a 'pdb' object with an additional \code{$log} component storing 
#'    all the processing messages.
#'
#' @seealso \code{\link{read.pdb}}
#'
#' @author Xin-Qiu Yao & Barry Grant
#' 
#' @examples
#' \donttest{
#'    # PDB server connection required - testing excluded
#'
#'    pdb <- read.pdb("1a7l")
#'    clean.pdb(pdb)
#' } 
"clean.pdb" <-
function(pdb, consecutive=TRUE, force.renumber = FALSE, fix.chain = FALSE, 
    fix.aa = FALSE, rm.wat = FALSE, rm.lig = FALSE, rm.h = FALSE, verbose=FALSE) {

  if(!is.pdb(pdb)) 
     stop("Input should be a 'pdb' object")

  cl <- match.call()

  ## processing message
  ## stored as an N-by-3 matrix with columns: 
  ##     FACT, OPERATION, IMPORTANT NOTE
  log <- NULL

  ## a flag to indicate if the pdb is clean
  clean <- TRUE

  ## Recognized amino acid names
  prot.aa <- bio3d::aa.table$aa3
  
  ## for residues and atoms renumbering
  first.eleno = 1
  first.resno = 1

  ## remove water
  if(rm.wat) {
     wat <- atom.select(pdb, "water", verbose = FALSE)
     if(length(wat$atom) > 0) {
        pdb$atom <- pdb$atom[-wat$atom, ,drop=FALSE]
        pdb$xyz <- pdb$xyz[, -wat$xyz, drop=FALSE]
        log <- .update.log(log, paste("Found", length(wat$atom), "water atoms"), "REMOVED")
     }
  }

  ## remove ligands 
  if(rm.lig) {
     lig <- atom.select(pdb, "ligand", verbose = FALSE)
     if(length(lig$atom) > 0) {
        pdb$atom <- pdb$atom[-lig$atom, ,drop=FALSE]
        pdb$xyz <- pdb$xyz[, -lig$xyz, drop=FALSE]
        log <- .update.log(log, paste("Found", length(lig$atom), "ligand atoms"), "REMOVED")
     }
  }

  ## remove hydrogens
  if(rm.h) {
     h.inds <- atom.select(pdb, "h", verbose = FALSE)
     if(length(h.inds$atom) > 0) {
        pdb$atom <- pdb$atom[-h.inds$atom, ,drop=FALSE]
        pdb$xyz <- pdb$xyz[, -h.inds$xyz, drop=FALSE]
        log <- .update.log(log, paste("Found", length(h.inds$atom), "hydrogens"), "REMOVED")
     }
  }
 
  ## check if 'alt' coords exist
  if(any(rm.p <- !is.na(pdb$atom$alt) & pdb$atom$alt != "A")) {
     pdb$atom <- pdb$atom[!rm.p, , drop=FALSE]
     pdb$xyz <- pdb$xyz[, -atom2xyz(which(rm.p)), drop=FALSE]
     log <- .update.log(log, paste("Found", sum(rm.p), "ALT records"), "REMOVED")
  }

  ## Some initial check: 
  ##   1. Are all amino acid and/or nucleic acid residues
  ##   distinguished by the combination chainID_resno_insert?
  .check.residue.ambiguity(pdb)

  ##   2. Check and clean up SSE annotation
  pdb <- .check.sse(pdb)
  log <- .update.log(log, pdb$log)

  ##   3. Fix pdb$calpha if it is mismatch pdb$atom
  ca.inds <- atom.select(pdb, "calpha", verbose = FALSE)
  calpha <- seq(1, nrow(pdb$atom)) %in% ca.inds$atom
  if(!identical(pdb$calpha, calpha)) {
     pdb$calpha <- calpha
     log <- .update.log(log, "pdb$calpha", "UPDATED")
  }
  
  ##   4. Fix object class if it is incorrect
  if(!inherits(pdb, "pdb") || !inherits(pdb, "sse") || 
       !inherits(pdb$xyz, "xyz")) {
     class(pdb) <- c("pdb", "sse")
     class(pdb$xyz) <- "xyz"
     log <- .update.log(log, "Object class", "UPDATED")
  }
  ###########
 
  ## following operations are on an independent object
  npdb <- pdb

  ## check chain breaks and missing chain ids
  has.fixed.chain <- FALSE
  capture.output( new.chain <- chain.pdb(npdb) )
  chain <- npdb$atom[, "chain"]  
  if(any(is.na(npdb$atom[, "chain"]))) {
     log <- .update.log(log, "Found empty chain IDs", 
               ifelse(fix.chain, "FIXED", "NO CHANGE"), 
               ifelse(fix.chain, "ALL CHAINS ARE RELABELED", ""))
     if(fix.chain) {
        npdb$atom[, "chain"] <- new.chain
        has.fixed.chain <- TRUE 
     } 
     else if(clean) 
        clean <- FALSE 
  }
  else {
     ## check if new chain id assignment is consistent to original one
     chn.brk <- bounds(chain[ca.inds$atom], dup.inds=TRUE, pre.sort=FALSE)
     new.chn.brk <- bounds(new.chain[ca.inds$atom], dup.inds=TRUE, pre.sort=FALSE)
     if(!isTRUE(all.equal(chn.brk, new.chn.brk))) {
        log <- .update.log(log, "Found inconsistent chain breaks",
                 ifelse(fix.chain, "FIXED", "NO CHANGE"),
                 ifelse(fix.chain, "ALL CHAINS ARE RELABELED", ""))
     
        log <- .update.log(log, "Original chain breaks:")
        if(nrow(chn.brk) == 1) {
           log <- .update.log(log, "  No chain break")
        } 
        else {
           pre.ca <- ca.inds$atom[chn.brk[-nrow(chn.brk), "end"]]
           pre.log <- capture.output( print(npdb$atom[pre.ca, c("resid", "resno", "chain")], row.names = FALSE) )
           log <- .update.log(log, pre.log)
        }
        log <- .update.log(log)
 
        log <- .update.log(log, "New chain breaks:")
        if(nrow(new.chn.brk) == 1) {
           log <- .update.log(log, "  No chain breaks")
        } 
        else { 
           new.ca <- ca.inds$atom[new.chn.brk[-nrow(new.chn.brk), "end"]]
           new.log <- capture.output( print(npdb$atom[new.ca, c("resid", "resno", "chain")], row.names = FALSE) )
           log <- .update.log(log, new.log)
        }

        if(fix.chain) {
           npdb$atom[, "chain"] <- new.chain
           has.fixed.chain <- TRUE 
        }
        else if(clean)
           clean <- FALSE
     } 
  }
   
  ## Renumber residues and atoms
  renumber <- FALSE
  if( any(!is.na(npdb$atom[, "insert"])) ) {
     renumber <- TRUE
     log <- .update.log(log, "Found INSERT records", "RENUMBERED")
     npdb$atom[, "insert"] <- as.character(NA)
  }
  else if(force.renumber) {
     renumber <- TRUE 
     log <- .update.log(log, "force.renumber = TRUE", "RENUMBERED")
  }
  else if(has.fixed.chain) {
     ## check again the ambiguity of residue labeling
     chk <- try(.check.residue.ambiguity(npdb))
     if(inherits(chk, "try-error")) {
        renumber <- TRUE
        log <- .update.log(log, "Found ambiguious residues after chain relabeling", "RENUMBERED")
     }
  }

  if(renumber) {

    ## Assign consecutive atom numbers 
    npdb$atom[,"eleno"] <- seq(first.eleno, length=nrow(npdb$atom))

    ## Determine what chain ID we have
    chain <- unique(npdb$atom[, "chain"])
    
    ##- Assign new (consecutive) residue numbers for each chain
    prev.chain.res = 0  ## Number of residues in previous chain
    for(i in 1:length(chain)) {
       inds <- which(npdb$atom[, "chain"] == chain[i])
       
       ## Combination of chain id, resno and insert code uniquely defines a residue (wwpdb.org)
       ## Here we use original pdb because we assume it should at least 
       ## distinguish different residues by above combination.
       ## We don't use the modified pdb (npdb) because all non-protein residues 
       ## are assigned a chain ID as "X" after calling chain.pdb(); 
       ## These residues could have the same resno (which are still in original 
       ## form) as they may be assigned different chain IDs in the original pdb. 
       res <- paste(pdb$atom[inds, "chain"], pdb$atom[inds, "resno"], 
                    pdb$atom[inds, "insert"], sep="_")

       n.chain.res <- length(unique(res))

       new.nums <- (first.resno+prev.chain.res):(first.resno+n.chain.res-1+prev.chain.res)
       npdb$atom[inds, "resno"] <- vec2resno(new.nums, res)

       if(consecutive) {
         ## Update prev.chain.res for next iteration 
         prev.chain.res = prev.chain.res + n.chain.res
       }
    }
  }

  ## update SSE
  if(has.fixed.chain || renumber) {
     ## Must use original pdb to unfold SSE
     sse <- pdb2sse(pdb, verbose = FALSE)  

     if(!is.null(sse)) {
        id <- sub(".*_.*_.*_([^_]*)$", "\\1", names(sse))
        names(sse) <- paste(npdb$atom[ca.inds$atom, "resno"], 
                            npdb$atom[ca.inds$atom, "chain"],
                            npdb$atom[ca.inds$atom, "insert"],
                            id, sep = "_")
        new.sse <- bounds.sse(sse)
     
        if(length(new.sse$helix$start) > 0) {
           npdb$helix$start <- new.sse$helix$start
           npdb$helix$end <- new.sse$helix$end
           npdb$helix$chain <- new.sse$helix$chain
        }
        if(length(new.sse$sheet$start) > 0) {
           npdb$sheet$start <- new.sse$sheet$start
           npdb$sheet$end <- new.sse$sheet$end
           npdb$sheet$chain <- new.sse$sheet$chain
        }
      
        if(!isTRUE(all.equal(npdb$helix, pdb$helix)) ||
           !isTRUE(all.equal(npdb$sheet, pdb$sheet)) )
           log <- .update.log(log, "SSE annotation", "UPDATED")
     }
  }
  
  ## update seqres 
  if(has.fixed.chain && !is.null(npdb$seqres)) {
     tinds <- combine.select(atom.select(npdb, 'protein'), atom.select(npdb, 'nucleic'), 
                             operator='+', verbose=FALSE)
     npdb2 <- trim(npdb, tinds)
     id <- paste(npdb2$atom$resno, npdb2$atom$chain, npdb2$atom$insert, sep='_')
     chs <- npdb2$atom[!duplicated(id), "chain"]
     names(npdb$seqres) <- chs
     if(!identical(npdb$seqres, pdb$seqres))
        log <- .update.log(log, "SEQRES", "UPDATED")
  }
 
  ## update amino acid name
  naa.atom <- which(npdb$atom[, "resid"] %in% prot.aa[-c(1:20)])
  naa.res <- intersect(ca.inds$atom, naa.atom)
  unk.atom <- which(!npdb$atom[, "resid"] %in% prot.aa)
  unk.res <- intersect(ca.inds$atom, unk.atom)
  if(length(naa.res) > 0) {
     log <- .update.log(log, paste("Found", length(naa.res), "non-standard amino acids"), 
              ifelse(fix.aa, "FIXED", "NO CHANGE"), 
              ifelse(fix.aa, "AMINO ACID NAMES ARE CHANGED", ""))
     tbl <- table(npdb$atom[naa.res, "resid"]) 
     tbl <- paste("  ", names(tbl), "(", tbl, ")", collapse = ",")
     log <- .update.log(log, tbl)
     if(fix.aa) {
         npdb$atom[naa.atom, "resid"] <- aa123(aa321(npdb$atom[naa.atom, "resid"])) 
         log <- .update.log(log, " Converted to")
         tbl <- table(npdb$atom[naa.res, "resid"])
         tbl <- paste("  ", aa123(aa321(names(tbl))), "(", tbl, ")", collapse = ",")
         log <- .update.log(log, tbl)
     }
     else 
        if(clean) clean <- FALSE
  }
  if(length(unk.res) > 0) {
     log <- .update.log(log, paste("Found", length(unk.res), "unknow amino acids"), 
               "NO CHANGE")
     tbl <- table(npdb$atom[unk.res, "resid"]) 
     tbl <- paste("  ", names(tbl), "(", tbl, ")", collapse = ",")
     log <- .update.log(log, tbl)
#     if(clean) clean <- FALSE
  } 

  ## update pdb$call
  npdb$call <- cl

  ## is the pdb clean?
#  if(clean)
#     log <- .update.log(log, "PDB is clean!")
  if(!clean) {
     msg <- "PDB is still not clean. Try fix.chain=TRUE and/or fix.aa=TRUE"
#     log <- .update.log(log, msg)
     warning(msg)
  }
     
  ## format log
#  log <- .format.log(log)
  if(verbose) print(log)

  npdb$log <- log
  return(npdb)
} 

.update.log <- function(log, fact="", op="", note="") {
  if(is.null(fact)) log
  else if(is.data.frame(fact)) .update.log(log, fact[,1], fact[,2], fact[,3])
  else rbind(log, data.frame(Data = fact, Action = op, Note = note))
}

.format.log <- function(log, format = c("print", "cat"), op.sign = "->", note.sign = "!!") {
  format <- match.arg(format)

  if(!is.null(log)) {
    log <- apply(log, 1, function(x) {
        if(nchar(x[2]) == 0)
           sprintf("%-40s", x[1])
        else if(nchar(x[3]) == 0)
           paste(sprintf("%-40s", x[1]), op.sign, sprintf("%-12s", x[2]))
        else
           paste(paste(sprintf("%-40s", x[1]), op.sign, sprintf("%-12s", x[2]), note.sign, x[3], note.sign) )
    } )
  }
  else {
    log <- "No problem found"
  }

  log <- switch(format, 
     print = log, 
     cat = paste(paste(log, collapse="\n"), "\n", sep="")
  )
  return(log)
}

.check.residue.ambiguity <- function(pdb) {

   ca.inds <- atom.select(pdb, "calpha", verbose = FALSE)
   c1p.inds <- atom.select(pdb, "nucleic", elety = "C1'", verbose = FALSE)
   inds <- combine.select(ca.inds, c1p.inds, operator = "+", verbose = FALSE)

   if(length(inds$atom) > 0) {
      strings <- paste(pdb$atom[inds$atom, "resno"],
                       pdb$atom[inds$atom, "chain"],
                       pdb$atom[inds$atom, "insert"], sep = "_")
      if(any(duplicated(strings)))
         stop(".check.residue.ambiguity(): Found ambiguous residue labeling")

   }
   invisible(NULL)
}

.check.sse <- function(pdb) {
   log <- NULL
   if(!is.null(pdb$helix) | !is.null(pdb$sheet)) {
      if(is.null(pdb$helix)) {
         pdb$helix <- list(start=NULL, end=NULL, chain=NULL, type=NULL) 
         log <- .update.log(log, "Helix is null but sheet is not", "UPDATED")
      }
      if(is.null(pdb$sheet)) {
         pdb$sheet <- list(start=NULL, end=NULL, chain=NULL, sense=NULL) 
         log <- .update.log(log, "Sheet is null but helix is not", "UPDATED")
      }
   }

   # if there is problem to generate sse vector
   ss <- try(pdb2sse(pdb, verbose = FALSE))
   if(inherits(ss, "try-error"))
      stop(".check.sse(): Unable to generate SSE sequence")

   pdb$log <- log

   return(pdb)
}

#' Ensemble Normal Mode Analysis with All-Atom ENM
#'
#' Perform normal mode analysis (NMA) on an ensemble of aligned protein
#' structures using all-atom elastic network model (aaENM).
#'
#' @details This function builds elastic network model (ENM) using all heavy 
#'    atoms and performs subsequent normal mode analysis (NMA) on a set of 
#'    aligned protein structures obtained with function \code{\link{read.all}}.
#'    The main purpose is to automate ensemble normal mode analysis using 
#'    all-atom ENMs.
#'
#'    By default, the effective Hessian for all C-alpha atoms is calculated 
#'    based on the Hessian built from all heavy atoms (including ligand atoms if 
#'    \code{ligand=TRUE}). Returned values include aligned mode vectors and 
#'    (when \code{full=TRUE}) a list containing the full \sQuote{nma} objects
#'    one per each structure. When \sQuote{rm.gaps=TRUE} the unaligned atoms 
#'    are ommited from output. With default arguments \sQuote{rmsip} provides 
#'    RMSIP values for all pairwise structures.
#'
#'    When \code{outmodes} is provided and is not \sQuote{calpha} 
#'    (e.g. \sQuote{noh}. See \code{\link{aanma}} for more details), the 
#'    function simply returns a list of \sQuote{nma} objects, one per each 
#'    structure, and no aligned mode vector is returned. In this case, the 
#'    arguments \code{full}, \code{subspace}, and \code{rm.gaps} are ignored. 
#'    This is equivalent to a wrapper function repeatedly calling 
#'    \code{\link{aanma}}.
#'
#' @param pdbs an \sQuote{pdbs} object as obtained from \code{\link{read.all}}. 
#' @param fit logical, if TRUE C-alpha coordinate based superposition is 
#'    performed prior to normal mode calculations. 
#' @param full logical, if TRUE return the complete, full structure,
#'    \sQuote{nma} objects.
#' @param subspace number of eigenvectors to store for further analysis.
#' @param rm.gaps logical, if TRUE obtain the hessian matrices for only
#'    atoms in the aligned positions (non-gap positions in all aligned
#'    structures). Thus, gap positions are removed from output.
#' @param ligand logical, if TRUE ligand molecules are also included in the 
#'    calculation.
#' @param outpath character string specifing the output directory to
#'    which the PDB structures should be written.
#' @param gc.first logical, if TRUE will call gc() first before mode calculation
#'    for each structure. This is to avoid memory overload when 
#'    \code{ncore > 1}.
#' @param ncore number of CPU cores used to do the calculation.
#' @param ... additional arguments to \code{\link{aanma}}.
#'
#' @return Returns a list of \sQuote{nma} objects (\code{outmodes} is provided 
#'    and is not \sQuote{calpha}) or an \sQuote{enma} object with the following 
#'    components:
#'    \item{fluctuations }{ a numeric matrix containing aligned atomic
#'      fluctuations with one row per input structure. }
#'    \item{rmsip }{ a numeric matrix of pair wise RMSIP values (only the ten
#'      lowest frequency modes are included in the calculation). }
#'    \item{U.subspace }{ a three-dimensional array with aligned
#'      eigenvectors  (corresponding to the subspace defined by the first N
#'      non-trivial eigenvectors (\sQuote{U}) of the \sQuote{nma} object). }
#'    \item{L }{ numeric matrix containing the raw eigenvalues with one row
#'      per input structure. }
#'    \item{full.nma }{ a list with a \code{nma} object for each input
#'      structure (available only when \code{full=TRUE}). }
#'
#' @seealso 
#'      For normal mode analysis on single structure PDB:
#'      \code{\link{aanma}}
#'
#'      For conventional C-alpha based normal mode analysis:
#'      \code{\link{nma}}, \code{\link{nma.pdbs}}.
#'
#'      For the analysis of the resulting \sQuote{eNMA} object:
#'      \code{\link{mktrj.enma}}, \code{\link{dccm.enma}},
#'      \code{\link{plot.enma}}, \code{\link{cov.enma}}.
#'    
#'      Similarity measures:
#'      \code{\link{sip}}, \code{\link{covsoverlap}},
#'      \code{\link{bhattacharyya}}, \code{\link{rmsip}}.
#'    
#'      Related functionality:
#'      \code{\link{read.all}}.
#'
#' @author Xin-Qiu Yao & Lars Skjaerven
#' 
#' @examples
#' \donttest{
#'   # Needs MUSCLE installed - testing excluded
#'   if(check.utility("muscle")) {
#'
#'     ## Fetch PDB files and split to chain A only PDB files
#'     ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
#'     files <- get.pdb(ids, split = TRUE, path = tempdir())
#'     
#'     ## Sequence Alignement
#'     aln <- pdbaln(files, outfile = tempfile())
#'     
#'     ## Read all pdb coordinates
#'     pdbs <- read.all(aln)
#'
#'     ## Normal mode analysis on aligned data
#'     modes <- aanma(pdbs, rm.gaps=TRUE)
#'     
#'     ## Plot fluctuation data
#'     plot(modes, pdbs=pdbs)
#'     
#'     ## Cluster on Fluctuation similariy
#'     sip <- sip(modes)
#'     hc <- hclust(dist(sip))
#'     col <- cutree(hc, k=3)
#'     
#'     ## Plot fluctuation data
#'     plot(modes, pdbs=pdbs, col=col)
#'     
#'     ## RMSIP is pre-calculated
#'     heatmap(1-modes$rmsip)
#'     
#'     ## Bhattacharyya coefficient
#'     bc <- bhattacharyya(modes)
#'     heatmap(1-bc)
#'
#'   }
#' }
aanma.pdbs <- function(pdbs, fit=TRUE, full=FALSE, subspace=NULL, rm.gaps=TRUE, 
  ligand=FALSE, outpath=NULL, gc.first=TRUE, ncore=NULL, ...) {

  if(!inherits(pdbs, "pdbs") || is.null(pdbs$all))
    stop("input 'pdbs' should be a list object as obtained from 'read.all()'")

  ## Log the call
  cl <- match.call()

  if(!is.null(outpath))
    dir.create(outpath, FALSE)

  ## Parallelized by parallel package
  ncore = setup.ncore(ncore)
  if(ncore>1) {
    prev.warn <- getOption("warn")
    options(warn=1)
    on.exit(options(warn=prev.warn))
  }

  dots <- list(...)

  aligned.modes <- TRUE
  if('outmodes' %in% names(dots)) {
     if(dots$outmodes == 'noh') {
       warning(paste('Non C-alpha atoms are selected for output modes.', 
        'A plain list of "nma" objects will be returned.'))
       aligned.modes <- FALSE
     } else if(dots$outmodes == 'calpha') {
       ## use default select, i.e. 'non-gap' C-alpha positions.
       dots$outmodes <- NULL
     } else {
       stop('Unsupported "outmodes"')
     }
  }

  if("keep" %in% names(dots))
    nm.keep <- dots$keep
  else
    nm.keep <- NULL

  if('rtb' %in% names(dots)) {
    rtb <- dots$rtb
    if(isTRUE(rtb)) {
      if('nmer' %in% names(dots) && dots$nmer!=1)
        stop( paste('Currently only nmer=1 is supported for', 
         'RTB based ensemble normal mode analysis') )
    }
  } else {
    rtb <- formals(aanma.pdb)$rtb
  }

  if('reduced' %in% names(dots)) 
    reduced <- dots$reduced
  else
    reduced <- formals(aanma.pdb)$reduced

  gaps.res <- gap.inspect(pdbs$ali)
  gaps.pos <- gap.inspect(pdbs$xyz)

  ## Number of modes to store in U.subspace
  if(is.null(subspace)) {
    keep <- length(gaps.pos$f.inds)-6
  }
  else {
    keep <- subspace
    if (length(gaps.pos$f.inds) < (keep+6))
      keep <- length(gaps.pos$f.inds)-6
  }
  if(!is.null(nm.keep) && keep > nm.keep) 
    keep <- nm.keep

  ## Convert from pdbs to pdb
  all.pdb <- pdbs2pdb(pdbs, all.atom=TRUE, ncore=ncore)

  ## Check if some structures are unavailable
  keep.inds <- which(sapply(all.pdb, is.pdb))
  if(length(keep.inds) == 0) 
     stop('No pdb file is found.')
  if(length(keep.inds) != length(all.pdb)) {
     warning(paste('Following pdb coordinates are not found: ', pdbs$id[-keep.inds], 
               sep=''))

     pdbs <- trim(pdbs, row.inds=keep.inds, col.inds=1:ncol(pdbs$ali))
     all.pdb <- all.pdb[keep.inds]
  }

  ## Remove ligand
  if(!ligand) 
    all.pdb <- mclapply(all.pdb, trim, 'protein', mc.cores=ncore)

  ## Non-gap position for each pdb
  nogap.inds <- mclapply(1:length(all.pdb), function(i)  {
     pdb <- all.pdb[[i]]
     pdb2aln.ind(pdbs, pdb, aln.id = pdbs$id[i], gaps.res$f.inds, file=NULL)$b
  }, mc.cores=ncore)

  if(fit) {
     cat('Fitting pdb structures')
     all.pdb <- mclapply(1:length(all.pdb), function(i) {
        cat('.')
        pdb <- all.pdb[[i]]
        xyz <- fit.xyz(pdbs$xyz[1, ], pdb$xyz, gaps.pos$f.inds, nogap.inds[[i]]$xyz)
        if(!is.null(outpath))
           ofile <- file.path(outpath, basename(pdbs$id[i]))
        else
           ofile <- tempfile()
        write.pdb(pdb, xyz=xyz, file=ofile)
        read.pdb(ofile)
     }, mc.cores=ncore, mc.allow.recursive=FALSE)
     cat('done\n')

  } else {

     if(!is.null(outpath)) 
        mclapply(1:length(all.pdb), function(i)
           write.pdb(all.pdb[[i]], file=file.path(outpath, basename(pdbs$id[i]))), 
           mc.cores = ncore)
  }

  if(aligned.modes) {

    #### Prepare for NMA calculation ####      
    ## Fluctuations for each structure
    if(rm.gaps)
      flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=length(gaps.res$f.inds))
    else
      flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=ncol(gaps.res$bin))

    ## List object to store each modes object
    if(full)
      all.modes <- list()
    else
      all.modes <- NULL

    ## 3D array- containing the modes vectors for each structure
    if(rm.gaps)
      modes.array <- array(NA, dim=c(length(gaps.pos$f.inds), keep, nrow(gaps.res$bin)))
    else
      modes.array <- array(NA, dim=c(ncol(pdbs$xyz), keep, nrow(gaps.res$bin)))

    ## store eigenvalues of the first modes
    L.mat <- matrix(NA, ncol=keep, nrow=nrow(gaps.res$bin))

    ### Memory usage ###
    dims <- dim(modes.array)
    mem.usage <- sum(c(as.numeric(object.size(modes.array)),
                       as.numeric(object.size(L.mat)),
                       as.numeric(object.size(flucts)),
                       as.numeric(object.size(matrix(NA, ncol=dims[3], nrow=dims[3]))) ))*2

    if(full) {
      if(is.null(nm.keep))
        tmpncol <- dims[2]
      else
        tmpncol <- nm.keep

      size.mat <- object.size(matrix(0.00000001, ncol=tmpncol, nrow=dims[1]))
      size.vec <- object.size(vector(length=dims[1], 'numeric'))

      tot.size <- ((size.mat * 2) + (size.vec * 4)) * length(pdbs$id)
      mem.usage <- mem.usage+tot.size
    }
    mem.usage=round(mem.usage/1048600,1)

    #### Print overview of scheduled calcualtion ####
    cat("\nDetails of Scheduled Calculation:\n")
    cat(paste("  ...", length(pdbs$id), "input structures", "\n"))
    if(keep>0)
      cat(paste("  ...", "storing", keep, "eigenvectors for each structure", "\n"))
    if(keep>0)
      cat(paste("  ...", "dimension of x$U.subspace: (",
                paste(dims[1], dims[2], dims[3], sep="x"), ")\n"))

    if(fit)
      cat(paste("  ...", "coordinate superposition prior to NM calculation", "\n"))

    if(full)
      cat(paste("  ... individual complete 'nma' objects will be stored", "\n"))

    if(rm.gaps)
      cat(paste("  ... aligned eigenvectors (gap containing positions removed) ", "\n"))

    if(reduced)
      cat(paste("  ... reduced all-atom ENM will be employed", "\n"))

    if(rtb)
      cat(paste("  ... rotation-translation block (RTB) approximation will be applied", "\n"))

    if(mem.usage>0)
      cat(paste("  ...", "estimated memory usage of final 'eNMA' object:", mem.usage, "Mb \n"))

    cat("\n")

  }

  ##### Start modes calculation #####
  ## Initialize progress bar
  pb <- .init.pb(ncore, min=0, max=length(pdbs$id))

  all.modes <- mclapply(1:length(all.pdb), function(i) {

     if(gc.first) gc()

     pdb <- all.pdb[[i]]
     nogap.inds <- nogap.inds[[i]]

     if(aligned.modes) {
 
       if(rm.gaps) 
          capture.output( modes <- try(do.call(aanma, c(list(pdb=pdb, 
              outmodes=nogap.inds), dots))) )
       else
          capture.output( modes <- try(do.call(aanma, c(list(pdb=pdb), dots))) )

     } else {

       capture.output( modes <- try(do.call(aanma, c(list(pdb=pdb), dots))) )

     } 

     if(inherits(modes, 'try-error')) {
        .close.pb(pb)
        stop(paste('Encounter errors in ', i, 'th structure', sep=''))
     }

     .update.pb(pb)

     modes$call <- NULL
     return( modes )

  }, mc.cores=ncore)

  ## Finish progress bar
  .close.pb(pb)

  if(!aligned.modes) return( all.modes )

  ##### Finalize calculation #####
  for(i in 1:length(all.modes)) {
     if(rm.gaps) {
       flucts[i, ] <- all.modes[[i]]$fluctuations
       modes.array[,,i] <- all.modes[[i]]$U[, 7:(keep+6)]
     } else {
       flucts[i, !is.gap(pdbs$ali[i, ])] <- all.modes[[i]]$fluctuations
       modes.array[!is.gap(pdbs$xyz[i, ]),, i] <- all.modes[[i]]$U[, 7:(keep+6)]
     }
     L.mat[i, ] <- all.modes[[i]]$L[7:(keep+6)]
  }
  if(!full) all.modes <- NULL

  ##### RMSIP ######
  rmsip.map <- NULL
  if(rm.gaps) {
    rmsip.map <- .calcRMSIP(modes.array, ncore=ncore)
    rownames(rmsip.map) <- basename(rownames(pdbs$xyz))
    colnames(rmsip.map) <- basename(rownames(pdbs$xyz))

    if(!fit)
      warning("rmsip calculated on non-fitted structures:
               ensure that your input coordinates are pre-fitted.")
  }

  if(fit) {
    xyz <- fit.xyz(fixed = pdbs$xyz[1, ], mobile = pdbs,
                   fixed.inds = gaps.pos$f.inds, mobile.inds = gaps.pos$f.inds,
                   ncore = ncore)
  }
  else {
     xyz <- pdbs$xyz
  }

  rownames(flucts) <- basename(rownames(pdbs$xyz))
  out <- list(fluctuations=flucts, rmsip=rmsip.map,
              U.subspace=modes.array, L=L.mat, full.nma=all.modes, 
              xyz=xyz, call=cl)

  class(out) <- "enma"

  return(out)
}

get.blast <- function(urlget, time.out = NULL, chain.single=TRUE) {

  if(substr(urlget, 1, 5) == "https" && grep("Blast.cgi", urlget)
      && grep("RID[[:space:]]*=", urlget)) {
     rid <- sub("^.*RID[[:space:]]*=[[:space:]]*", "", urlget)
     names(urlget)=rid 
  } else {
     stop("Illegal link for retrieving BLAST results")
  }

  cat(paste(" Searching ... please wait (updates every 5 seconds) RID =",rid,"\n "))

  ##- Retrieve results via RID code and check for job completion
  ##   (completion is based on retrieving HTML or CSV output)
  html <- 1
  t.count <- 0
  repeat {
    raw  <- try(read.csv(urlget,
                     header = FALSE, sep = ",", quote="", dec=".",
                     fill = TRUE, comment.char="", stringsAsFactors=FALSE), silent=TRUE)
    if(inherits(raw, "try-error")) { stop("No hits found: thus no output generated") }
    html <- grep("DOCTYPE", raw[1,])
    
    if(!is.null(time.out) && (t.count > time.out) || (length(html) != 1))
      break;
    
    cat("."); Sys.sleep(5)
    t.count <- t.count + 5
  }
  
  if(length(html) == 1) {
     warning("\nTime out (", time.out, "s): Retrieve results with returned link\n", 
        urlget, "\n", sep="")
     return(urlget)
  }
  
  colnames(raw) <- c("queryid", "subjectids", "identity", 
                     "alignmentlength", "mismatches", "gapopens",
                     "q.start", "q.end", "s.start", "s.end",
                     "evalue", "bitscore", "positives")
  
  ##- Expand 'raw' for each hit in 'subjectids' (i.e. split on ";")
  eachsubject <- strsplit(raw$subjectids, ";")
  subjectids  <- unlist(eachsubject)
  n.subjects  <- sapply(eachsubject, length)

  df <- raw[rep(row.names(raw), times=n.subjects), ]
  df$subjectids <- subjectids
  row.names(df) <- 1:nrow(df)
    
  ##- Parse ids
  #all.ids <- strsplit(subjectids, "\\|")
  #gi.id  <- sapply(all.ids, '[', 2)
  gi.id <- subjectids
  
  all.ids <- strsplit(subjectids, "_")
  pdb.4char <- sapply(all.ids, '[', 1)
  pdb.chain <- sapply(all.ids, '[', 2)

  ## Catch long chain IDs as in hits from "P12612" (e.g "1WF4_GG" => "1WF4_g")
  if(chain.single) {
    chain.ind <- which(nchar(pdb.chain) > 1 & nchar(pdb.4char)==4)
    if(length(chain.ind) > 0) {
      pdb.chain[ chain.ind ] <- tolower( substr(pdb.chain[ chain.ind ],1,1 ) )
    }
  }
  pdb.id <- rep(NA, length(pdb.4char))
  tinds <- !is.na(pdb.chain) & nchar(pdb.4char)==4
  pdb.id[tinds] <- paste(pdb.4char[tinds],"_",pdb.chain[tinds],sep="")


  ##- Map zero evalues to arbitrarily high value for -log(evalue)
  df$mlog.evalue <- -log(df$evalue)
  df$mlog.evalue[is.infinite(df$mlog.evalue)] <- -log(1e-308)
  df$pdb.id <- pdb.id
  df$acc <- gi.id
  
  cat(paste("\n Reporting",length(pdb.id),"hits\n"))

  # sort hit table according to mlog.evalue
  df <- df[order(df$mlog.evalue, decreasing = TRUE), ]  
  output <- list(hit.tbl = df,
                 raw = raw,
                 url = urlget)
  
  class(output) <- "blast"
  return(output)
}

pdb.pfam <- function(ids, best.only=TRUE, compact=TRUE) {

  ##-- Annotate PDBs with PFAM hits from RCSB PDB
  ##    Input 'pdbid' can be a vector of ids with chainID:
  ##  
  ##     pdb.pfam(c("1bg2", "2kin", "4q21", "3kin_A"))
  ## 
  ##   There are often multiple hits to a structure. The option
  ##    'best.only' will keep the lowest eValue one only.
  ##

  oops <- requireNamespace("XML", quietly = TRUE)
  if(!oops) { stop("Please install the XML package from CRAN") }

  ##- 'ids' may optionally contain chain ID (e.g '3kin_A')
  pdbid <- ids    ## keep a copy of input 'ids' for later reporting
  ids   <- toupper(ids) 
  chains <- rep(NA, length(ids))

  standard.ids <- nchar(ids) == 4
  if(any(!standard.ids)) {
    ids[!standard.ids] <- sub("\\.pdb$","", basename(ids[!standard.ids]))
    chains[!standard.ids] <- substr(ids[!standard.ids],6,6)
    ids[!standard.ids] <- substr(ids[!standard.ids],1,4) 
  }

	url <- paste0("http://www.rcsb.org/pdb/rest/hmmer?structureId=", 
                paste0(ids, collapse=","))
	xl <-  try(XML::xmlToList(url), silent=TRUE)

	##- Exit with NULL if PFAM annotation page not found (cant load)
	if(!is.list(xl)) { return(NULL) }

	## Else process and order data.frame
	df <- data.frame(matrix(unlist(xl), ncol=8, byrow=TRUE), stringsAsFactors=FALSE)
	colnames(df) <- names(xl[1]$pfamHit)
  df <- df[order(df$eValue),]

  ## Add ID in from of 'pdbID_chainID' and PFAMname_PFAMacc
  df$ID = paste(df$structureId, df$chainId,sep="_")
  df$PFAM = paste0(df$pfamName," (",df$pfamAcc,")")

  ##- Optionally keep top hit for each structure only 
  if(best.only) { df <- df[!duplicated(df$ID),] }

  ##- If chain Id was found in input keep only entries for that chain 
  ind <- !is.na(chains)
  if(any(ind)) {
    ## Exclude entries that match PDBID but not PDBID_chainID
    filter.id1 <- ids[ind]
    filter.id2 <- paste(ids[ind], chains[ind],sep="_")
    filter.ind1 <- which(df$structureId %in% filter.id1)
    filter.ind2 <- which(df$ID %in% filter.id2)
    filter.ind  <- filter.ind1[!filter.ind1 %in% filter.ind2]
    if(length(filter.ind) > 0) { df <- df[-filter.ind,] }
  }

  ##- Check if any 'pdbids' were not found and add a blank row to df
  missing <- !toupper(ids) %in% df$structureId
  if( any(missing) ){
    warning(paste("PFAM annotation not found for pdbid(s):", paste(pdbid[missing], collapse=", ")))
    blank <- matrix(rep(NA, ncol(df)*sum(missing)), nrow=sum(missing))
    colnames(blank) <- colnames(df)
    blank[,"ID"] <- toupper(pdbid[missing])
    df <- rbind(df,blank)
  }

  ## Optionally rtn a subset of data cols only
  if(compact) {
    return(df[,c("ID","PFAM","pfamDesc","eValue")])
  } else { return(df) }

}

"print.pca" <-
  function(x, nmodes=6, ...) {

    cn <- class(x)
    
    cat("\nCall:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
        "\n\n", sep = "")
    
    cat("Class:\n  ", cn, "\n\n", sep = "")
    
    cat("Number of eigenvalues:\n  ", length(x$L), 
        "\n\n", sep="")

    inds <- 1:nmodes
    e <- round(x$L[inds], 3)
    p <- (x$L[inds]/sum(x$L)) * 100
    d <- data.frame( "Eigenvalue"=e, 
                     "Variance"=round(p,3), 
                     "Cumulative"=round(cumsum(p),3), 
                     row.names = paste("   PC",inds))

    #cat("Eigenvalues:\n", sep="")
    print(d)

    cat("\n",paste("  (Obtained from", nrow(x$z), "conformers with", ncol(x$z), "xyz input values)."))
    i <- paste( attributes(x)$names, collapse=", ")
    cat("\n",strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")

    invisible(d)
  }

.match.statbit <- function(pdb, statbit) {
  if(!is.character(statbit))
    stop("'statbit' must be a character vector")
  pdb$atom$statbit %in% statbit
}


.match.elena <- function(pdb, elena) {
    if(!is.character(elena))
        stop("'elena' must be a character vector")
    pdb$atom$elena %in% elena
}


atom.select.mol2 <- function(mol, string=NULL,
                             eleno = NULL, elena = NULL, elety = NULL,
                             resid = NULL, chain = NULL, resno = NULL,
                             statbit = NULL, 
			     operator = "AND", inverse = FALSE,
                             value = FALSE, verbose=FALSE,  ...) {              

        
    #str.allowed <- c("noh", "h")
    #if(!is.null(string)) {
    #    if(!(string %in% str.allowed)) {
    #        stop("Not a valid selection string shortcut.\n\t Please use 'h' or 'noh'\n")
    #    }
    #}
    
    cl <- match.call()

    pdb <- as.pdb(mol)

    if(!is.mol2(mol))
        stop("'mol' must be an object of class 'mol2'")
    
    ## check input operator
    op.tbl <- c(rep("AND",3), rep("OR",4))
    operator <- op.tbl[match(operator, c("AND","and","&","OR","or","|","+"))]
    if(!operator %in% c("AND", "OR"))
        stop("Allowed values for 'operator' are 'AND' or 'OR'")
    
    ## check input string
    if(!is.null(string)) {
        str.allowed <- c("all", "protein", "notprotein", "nucleic", "notnucleic", "water", "notwater",
                         "calpha", "cbeta", "backbone", "back", "ligand", "h", "noh")
        if(!(string %in% str.allowed))
            stop("Unknown 'string' keyword. See documentation for allowed values")
    }

    ## verbose message output
    if(verbose) cat("\n")
    .verboseout <- function(M, type) {
        cat(" .. ", sprintf("%08s", length(which(M))), " atom(s) from '", type, "' selection \n", sep="")
    }
    
    ## combine logical vectors
    .combinelv <- function(L, M, operator) {
        if(operator=="AND") M <- L & M
        if(operator=="OR") M <- L | M
        return(M)
    }
    
    if(operator=="AND")
        M <- rep(TRUE, nrow(pdb$atom))
    if(operator=="OR")
        M <- rep(FALSE, nrow(pdb$atom))
    
    if(!is.null(string)) {   
        M <- switch(string,
                    all         =   M <- rep(TRUE, nrow(pdb$atom)),
                    protein     =  .is.protein(pdb),
                    notprotein  = !.is.protein(pdb),
                    nucleic     =  .is.nucleic(pdb),
                    notnucleic  = !.is.nucleic(pdb),
                    water       =  .is.water(pdb),
                    notwater    = !.is.water(pdb),
                    calpha      =  .is.protein(pdb)  & .match.elety(pdb, "CA"),
                    cbeta       =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O", "CB")),
                    backbone    =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O")),
                    back        =  .is.protein(pdb)  & .match.elety(pdb, c("CA", "N", "C", "O")),
                    ligand      = !.is.protein(pdb)  & !.is.nucleic(pdb) & !.is.water(pdb),
                    h           =  .is.hydrogen(pdb),
                    noh         = !.is.hydrogen(pdb),
                    NA
                    )
        
        if(verbose) {
            .verboseout(M, 'string')
        }
    }

  if(!is.null(eleno)) {
    L <- .match.eleno(mol, eleno)
    if(verbose) .verboseout(L, 'eleno')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(elety)) {
    L <- .match.elety(mol, elety)
    if(verbose) .verboseout(L, 'elety')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(elena)) {
    L <- .match.elena(mol, elena)
    if(verbose) .verboseout(L, 'elena')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(resid)) {
    L <- .match.resid(mol, resid)
    if(verbose) .verboseout(L, 'resid')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(chain)) {
    L <- .match.chain(pdb, chain)
    if(verbose) .verboseout(L, 'chain')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(resno)) {
    L <- .match.resno(mol, resno)
    if(verbose) .verboseout(L, 'resno')
    M <- .combinelv(L, M, operator)
  }
  if(!is.null(statbit)) {
    L <- .match.statbit(mol, statbit)
    if(verbose) .verboseout(L, 'statbit')
    M <- .combinelv(L, M, operator)
  }

  if(verbose)
    cat(" ..", sprintf("%08s", length(which(M))), "atom(s) in final combined selection \n")

  if(inverse) {
    if(verbose) {
      cat(" ..", sprintf("%08s", length(which(!M))), "atom(s) in inversed selection \n")
    }
    sele <- as.select(which(!M))
  }
  else
    sele <- as.select(which(M))
    
  sele$call <- cl

  keep.bonds <- matrix(as.numeric(t(mol$bond[, c("origin","target")])) %in% sele$atom, ncol=2, byrow=T)
  bond.inds  <- which(apply(keep.bonds, 1, all))
  sele$bond <- bond.inds

  if(value)
    return(trim.pdb(pdb, sele))
  else
    return(sele)
}

"pca.pdbs" <- function(pdbs, core.find=FALSE, fit=FALSE, ...) {
  ## Log the call
  cl <- match.call()

  if(core.find & fit) {
    warning("incompatible arguments- neglecting 'fit=TRUE'")
    fit=FALSE
  }
  
  if(core.find) {
    core <- core.find(pdbs)
    pdbs$xyz = pdbfit(pdbs, core$c0.5A.xyz)
  } else if(fit) {
     pdbs$xyz = pdbfit(pdbs)
  }
  
  gaps.pos <- gap.inspect(pdbs$xyz)
  pc <- pca.xyz(pdbs$xyz[,gaps.pos$f.inds], ...)

  pc$call=cl
  return(pc)
}

"trim.xyz" <- function(xyz, row.inds=NULL, col.inds=NULL, ...) {
  xyz <- as.xyz(xyz)

  if(is.select(row.inds))
    row.inds <- row.inds$xyz
  if(is.select(col.inds))
    col.inds <- col.inds$xyz
    
  if(!is.null(row.inds))
    xyz <- xyz[row.inds, , drop=FALSE]
  if(!is.null(col.inds))
    xyz <- xyz[, col.inds, drop=FALSE]

  return(as.xyz(xyz))
}

## takes a vector of residue numbers and generates a string
## e.g. (1,2,3,5,8,9) --> "1-3,5,8-9"
.resno2str <- function(res, sep=c("+", "-")) {
  res <- res[!is.na(res)]
  if(!length(res)>0){
    return(NULL)
  }
  else {
    res1 <- bounds(res)
    res2 <- paste(res1[,"start"], res1[,"end"], sep=sep[2])
    inds <- res1[,"start"] == res1[,"end"]
    res2[inds] <- res1[inds, "start"]
    res3 <- paste(res2, collapse=sep[1])
    return(res3)
  }
}

pymol <- function(...)
  UseMethod("pymol")

pymol.pdbs <- function(pdbs, col=NULL, as="ribbon", file=NULL,
                       type="script", exefile = "pymol", user.vec=NULL, ...) {
  
  allowed <- c("session", "script", "launch")
  if(!type %in% allowed) {
    stop(paste("input argument 'type' must be either of:",
               paste(allowed, collapse=", ")))
  }

  allowed <- c("ribbon", "cartoon", "lines", "putty")
  if(!as %in% allowed) {
    stop(paste("input argument 'as' must be either of:",
               paste(allowed, collapse=", ")))
  }

  if(!is.null(col) & !inherits(col, "core")) {
    if(length(col) == 1) {
      allowed <- c("index", "index2", "rmsf", "gaps", "user")
      if(!col %in% allowed) {
        stop(paste("input argument 'col' must be either of:",
                   paste(allowed, collapse=", ")))
      }
    }
    else {
      if(!is.numeric(col)) {
        stop("col must be a numeric vector with length equal to the number of structures in the input pdbs object")
      }
      
      if(length(col) != length(pdbs$id)) {
        stop("col must be a vector with length equal to the number of structures in input pdbs")
      }
    }
  }
  
  ## output file name
  if(is.null(file)) {
    if(type=="session")
      file <- "R.pse"
    if(type=="script")
      file <- "R.pml"
  }
 
    ## Check if the program is executable
    if(type %in% c("session", "launch")) {
        
        ## determine path to exefile
        exefile1 <- .get.exepath(exefile)
        
        ## Check if the program is executable
        success <- .test.exefile(exefile1)
        
        if(!success) {
            stop(paste("Launching external program failed\n",
                       "  make sure '", exefile, "' is in your search path", sep=""))
        }
        exefile <- exefile1
    }
  
  ## add support for "prefix" and "pdbext"
  dots <- list(...)
  if("prefix" %in% names(dots)) {
    pdbs$id <- paste(dots$prefix, pdbs$id, sep="")
  }
  if("pdbext" %in% names(dots)) {
    pdbs$id <- paste(pdbs$id, dots$pdbext, sep="")
  }
  
  ## use temp-dir unless we output a PML script
  if(type %in% c("session", "launch"))
    tdir <- tempdir()
  else
    tdir <- "."

  pdbdir <- paste(tdir, "pymol_pdbs", sep="/")
  if(!file.exists(pdbdir))
    dir.create(pdbdir)
  
  pmlfile <- tempfile(tmpdir=tdir, fileext=".pml")
  psefile <- tempfile(tmpdir=tdir, fileext=".pse")
  ids <- basename.pdb(pdbs$id)

  ## include stuff in the b-factor column
  bf <- NULL
  if(as == "putty") {
    bf <- rmsf(pdbs$xyz)
  }
  else {
    if(!is.null(col)) {
      ## RMSF coloring
      if(col[1] == "rmsf") {
        bf <- rmsf(pdbs$xyz)
      }
      ## color by index of pdbs$ali
      if(col[1] == "index2") {
        bf <- 1:ncol(pdbs$ali)/ncol(pdbs$ali)
      }
      ## color by user defined vector
      if(col[1] == "user") {
        if(is.null(user.vec) || !is.numeric(user.vec) ||
           length(user.vec) != ncol(pdbs$ali)) {
          stop("User defined color vector must be numeric and the same dimension as pdbs")
        }
        bf <- user.vec
      }
    }
  }
  
  ## use all all-atom PDBs if they exist
  if(all(file.exists(pdbs$id))) {
    allatom <- TRUE
    files <- pdbs$id

    ## align all-atom PDBs to pdbs$xyz
    for(i in 1:length(pdbs$id)) {
      pdb <- read.pdb(files[i])
      sele <- atom.select(pdb, "calpha")
      gaps <- is.gap(pdbs$xyz[i,])
      pdb$xyz <- fit.xyz(pdbs$xyz[i, !gaps], pdb$xyz,
                         fixed.inds = 1:length(pdbs$xyz[i, !gaps]),
                         mobile.inds = sele$xyz)
      fn <- paste0(pdbdir, "/", ids[i], ".pdb")

      ## store new b-factor column to PDB
      tmpbf <- NULL
      if(!is.null(bf)) {
        gaps <- is.gap(pdbs$ali[i,])
        tmpbf <- pdb$atom$b*0
        tmpbf[sele$atom] <- bf[!gaps]
      }

      write.pdb(pdb, b=tmpbf, file=fn)
      files[i] <- fn
    }
  }
  else {
    ## use pdbs$xyz to build CA-atom PDBs
    allatom <- FALSE
    files <- rep(NA, length(pdbs$id))
    for(i in 1:length(pdbs$id)) {
      pdb <- pdbs2pdb(pdbs, inds=i)[[1]]
      fn <- paste0(pdbdir, "/", ids[i], ".pdb")

      ## store new b-factor column to PDB
      tmpbf <- NULL
      if(!is.null(bf)) {
        gaps <- is.gap(pdbs$ali[i,])
        tmpbf <- bf[!gaps]
      }
        
      write.pdb(pdb=pdb, b=tmpbf, file=fn)
      files[i] <- fn
    }
  }

  ## load PDBs
  lines <- rep(NA, 5*length(pdbs$id))
  for(i in 1:length(files)) {
    lines[i] <- paste("load", files[i])
  }

  ## line pointer
  l <- i

  
  ## Structure representation (as)
  if(as == "putty") {
    lines[l+1] <- "cartoon putty"
    lines[l+2] <- "as cartoon"
    lines[l+3] <- "unset cartoon_smooth_loops"
    lines[l+4] <- "unset cartoon_flat_sheets"
    lines[l+5] <- "spectrum b, rainbow"
    lines[l+6] <- "set cartoon_putty_radius, 0.2"
    l <- l+6

    as <- "cartoon"
  }
  
  if(!allatom) {
    if(!as %in% c("cartoon", "ribbon")) {
      warning("'as' set to 'ribbon' for c-alpha only structures")
      as <- "ribbon"
    }

    lines[l+1] <- paste0("set ", as, "_trace_atoms, 1")
    l <- l+1
  }
  
  lines[l+1] <- paste("as", as)
  l <- l+1
  ## representation ends
  
  
  ## Coloring
  if(!is.null(col)) {
    if(inherits(col, "core")) {
      core <- col
      l <- l+1
      lines[l] <- "color grey50"
      
      for(j in 1:length(files)) {
        res <- .resno2str(pdbs$resno[j, core$atom])
        if(!is.null(res)) {
          selname <- paste0(ids[j], "-core")
          lines[l+1] <- paste0("select ", selname, ", ", ids[j], " and resi ", res)
          lines[l+2] <- paste0("color red, ", selname)
          l <- l+2
        }
      }
    }
    
    if(col[1] == "gaps") {
      l <- l+1
      lines[l] <- "color grey50"
      
      gaps <- gap.inspect(pdbs$ali)
      for(j in 1:length(files)) {
        res <- .resno2str(pdbs$resno[j, gaps$t.inds])
        if(!is.null(res)) {
          selname <- paste0(ids[j], "-gap")
          lines[l+1] <- paste0("select ", selname, ", ", ids[j], " and resi ", res)
          lines[l+2] <- paste0("color red, ", selname)
          l <- l+2
        }
      }
    }
    
    if(length(col) > 1 & is.vector(col)) {
      
      ## add more colors here
      cols <- c("grey40", "red", "green", "blue", "cyan",
                "purple", "yellow", "grey90", "magenta", "orange",
                "pink", "wheat", "deepolive", "teal", "violet",
                "limon", "slate", "density", "forest", "smudge", "salmon",
                "brown")

      for(j in 1:length(files)) {
        lines[l+1] <- paste0("color ", cols[col[j]], ", ", ids[j])
        l <- l+1
      }
    }

    ## color by RMSF
    if(col[1] == "rmsf") {
      l <- l+1
      lines[l] <- "spectrum b, rainbow"
    }

    ## color by index of individual structures
    if(col[1] == "index") {
      for(i in 1:length(pdbs$id)) {
        l <- l+1
        lines[l] <- paste("spectrum count, rainbow,", ids[i], "and name C*")
      }
    }

    ## color by index of alignment
    if(col[1] == "index2") {
      for(i in 1:length(pdbs$id)) {
        l <- l+1
        lines[l] <- paste("spectrum b, rainbow,", ids[i])
      }
    }
    
    ## color by user defined vector
    if(col[1] == "user") {
      for(i in 1:length(pdbs$id)) {
        l <- l+1
        lines[l] <- paste("spectrum b, rainbow,", ids[i])
      }
    }
  } ## coloring ends
  

  lines[l+1] <- "zoom"
  l <- l+1
  
    if(type == "session") {
        lines[l+1] <- paste("save", 
                            normalizePath(psefile, winslash='/', mustWork=FALSE))
    }
  
  lines <- lines[!is.na(lines)]
  write.table(lines, file=pmlfile, append=FALSE, quote=FALSE, sep="\n",
              row.names=FALSE, col.names=FALSE)

  if(type %in% c("session", "launch")) {
    if(type == "session")
      args <- "-cq"
    else
      args <- ""
    
    ## Open pymol
    cmd <- paste(exefile, args, pmlfile)

    os1 <- Sys.info()["sysname"]
    if (os1 == "Windows") {
        status <- shell(paste(shQuote(exefile), args, pmlfile))
    }
    else {
        status <- system(cmd)
    }
    
    if(!(status %in% c(0,1))) {
        stop(paste("An error occurred while running command\n '",
                   exefile, "'", sep=""))
    }

  }
    
  if(type == "session") {
      file.copy(psefile, file, overwrite=TRUE)
      unlink(pmlfile)
      unlink(psefile)
      message(paste("PyMOL session written to file", file))
      invisible(file)
  }
    
  if(type == "script") {
      file.copy(pmlfile, file, overwrite=TRUE)
      unlink(pmlfile)
      message(paste("PyMOL script written to file", file))
      invisible(file)
  }
}

"com.xyz" <- function(xyz, mass=NULL, ...) {
  xyz <- as.xyz(xyz)
  natoms <- ncol(xyz)/3
  
  if(is.null(mass))
    mass <- rep(1, times=natoms)

  if (natoms != length(mass))
    stop("com.xyz: length of input vector 'mass' uequal to number of atoms (ncol(xyz)/3)")

  com1 <- function(x) {
    xyz <- matrix(x, ncol=3, byrow=T)
    com <- colSums(xyz * mass) / sum(mass)
    return(com)
  }

  com <- t(apply(xyz, 1, com1))
  colnames(com) <- c("x", "y", "z")
  return(com)
}

"aa321" <-
function (aa) {

  # convert three-letters amino-acid code into
  # one-letter IUPAC code, for instance "ALA" into "A".
  # new residues should be added to through the util/make_aatable.R script

  aa1 <- c("-",   ".",  "X",   bio3d::aa.table$aa1)
  aa3 <- c("---", "---","UNK", bio3d::aa.table$aa3)

    convert <- function(x) {
      if(is.na(x)) return(NA)
      if (all(x != aa3)) {
        warning(paste("Unknown 3-letters code for aminoacid:",x))
        return("X") # mask unk
      }
      else {
        return(aa1[which(x == aa3)])
      }
    }
  return(as.vector(unlist(sapply(aa, convert))))
}


".aa321.na" <-
function (aa) {

  # convert three-letters amino-acid code into
  # one-letter IUPAC code, for instance "ALA" into "A".

  aa1 <- c("-",".","X",
           "C",  "G",  "T",  "A", "U", "I",
           "C",  "G",  "T","  A", "U", "I")
  aa3 <- c("---", "---","UNK",
           "DC", "DG", "DT", "DA", "DU", "DI",
            "C",  "G",  "T",  "A",  "U", "I")
  
    convert <- function(x) {
      if(is.na(x)) return(NA)
      if (all(x != aa3)) {
        warning(paste("Unknown 3-letters code for residue:",x))
        return("X") # mask unk
      }
      else {
        return(aa1[which(x == aa3)])
      }
    }
  return(as.vector(unlist(sapply(aa, convert))))
}

cmap <- function(...)
  UseMethod("cmap")

cmap.default <- function(...)
  return(cmap.xyz(...))

cmap.xyz <-
function(xyz, grpby=NULL, dcut=4, scut=3, pcut=1, binary=TRUE, mask.lower = TRUE,
         collapse=TRUE, gc.first = FALSE, ncore=1, nseg.scale=1, ...) {

  # Parallelized by parallel package (Mon Apr 22 16:32:19 EDT 2013)
  ncore <- setup.ncore(ncore, bigmem = TRUE)
  if(ncore > 1) {
     # Issue of serialization problem
     # Maximal number of cells of a double-precision matrix
     # that each core can serialize: (2^31-1-61)/8
     R_NCELL_LIMIT_CORE = 2.68435448e8
     R_NCELL_LIMIT = ncore * R_NCELL_LIMIT_CORE

     if(nseg.scale < 1) {
        warning("nseg.scale should be 1 or a larger integer\n")
        nseg.scale=1
     }
  }

  if (!(is.numeric(pcut) && pcut >= 0 && pcut <= 1)) {
    stop("Input 'pcut' should a number between 0 and 1")
  }

  xyz=as.xyz(xyz)
  nxyz =nrow(xyz)

    if(nrow(xyz)>1) {
      pb <- txtProgressBar(min=0, max=nrow(xyz), style=3)
        
     if(is.null(grpby)) {
        nres <- ncol(xyz)/3
     } else {
        inds <- bounds(grpby, dup.inds = TRUE)
        nres <- nrow(inds)
     }
      if(ncore > 1) {
        ## shared memory to follow progress bar
        iipb <- bigmemory::big.matrix(1, nrow(xyz), init=NA)
          
        ni = nrow(xyz)
        RLIMIT = floor(R_NCELL_LIMIT/(0.5*nres*(nres+1)))
        nDataSeg = floor((ni-1)/RLIMIT)+1
        nDataSeg = floor(nDataSeg * nseg.scale)
        lenSeg = floor(ni/nDataSeg)
        cmap.list <- NULL
        for(i in 1:nDataSeg) {
           istart = (i-1)*lenSeg + 1
           iend = if(i<nDataSeg) i*lenSeg else ni
           cmap.list <- c(cmap.list, mclapply(istart:iend, function(j) {
               if(gc.first) gc()
               
               dmat <- dm.xyz(xyz[j,], grpby, scut, mask.lower=TRUE)

               ## progress bar
               iipb <- get("iipb")
               iipb[1,j] <- 1
               k <- length(which(!is.na(bigmemory::as.matrix(iipb))))
               setTxtProgressBar(pb, k)
               
               return(as.numeric(dmat[!lower.tri(dmat)] < dcut))
           }) )
        }
     } else {
         cmap.list <- lapply(1:nrow(xyz), function(j) {
             dmat <- dm.xyz(xyz[j,], grpby, scut, mask.lower=TRUE)
             setTxtProgressBar(pb, j)
            return(as.numeric(dmat[!lower.tri(dmat)] < dcut))
        }) 
     }

      rm(xyz)
      if(gc.first) gc()
      
     if(collapse) {
       cmap.t <- rowMeans(do.call(cbind, cmap.list), na.rm=TRUE)
       cmap.t[!is.finite(cmap.t)] <- NA

      rm(cmap.list)
      if(gc.first) gc()
      
       if(binary) cmap.t <- as.numeric(cmap.t >= pcut )
       cont.map <- matrix(NA, nrow=nres, ncol=nres)
       cont.map[!lower.tri(cont.map)] <- cmap.t
       if(!mask.lower) 
         cont.map[lower.tri(cont.map)] <- t(cont.map)[lower.tri(cont.map)]
     }
     else {
       cont.map <- array(NA, dim=c(nres, nres, nxyz))
       cmap.t <- matrix(NA, nres, nres)
       for(i in 1:nxyz) {
         cmap.t[!lower.tri(cmap.t)] <- cmap.list[[i]]
         if(!mask.lower)
           cmap.t[lower.tri(cmap.t)] <- t(cmap.t)[lower.tri(cmap.t)]
         cont.map[,,i] <- cmap.t
       }

      rm(cmap.list)
      if(gc.first) gc()
      
     }
      
      rm(cmap.t)
      if(gc.first) gc()
      close(pb)
      
  } else {

     ## Distance matrix (all-atom)
     dmat <- dm.xyz( xyz, grpby, scut, mask.lower = mask.lower, ncore=ncore)
     ## Contact map
     return(matrix(as.numeric(dmat < dcut),
                ncol = ncol(dmat),
                nrow = nrow(dmat)))

  }

  return (cont.map)
}

print.mol2 <- function(x, ...) {
  cat(paste("... Name:", x$name, "\n"))
  cat(paste("...", nrow(x$atom), "atoms in molecule", "\n"))
  cat(paste("...", nrow(x$bond), "bonds in molecule", "\n"))
  cat(paste("...", nrow(x$xyz), "frame(s) stored", "\n"))
  cat("\n")

  i <- paste( attributes(x)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")
  cat("\n")
}


"read.mol2" <-
  function (file, maxlines = -1L)
  {
    if (missing(file)) {
      stop("read.mol2: please specify a MOL2 'file' for reading")
    }
    if (!is.numeric(maxlines)) {
      stop("read.mol2: 'maxlines' must be numeric")
    }
    toread <- file.exists(file)
    if (!toread) {
      stop("No input MOL2 file found: check filename")
    }
    
    atom.format <- matrix(c("eleno",   'numeric', 
                            "elena",   'character',
                            "x",       'numeric', 
                            "y",       'numeric', 
                            "z",       'numeric', 
                            "elety",   'character',
                            "resno",   'numeric', 
                            "resid",   'character',
                            "charge",  'numeric', 
                            "statbit", 'character'), ncol=2, byrow=TRUE,
                          dimnames = list(c(1:10), c("name","what")) )

    
    bond.format <- matrix( c("id",      'numeric', 
                            "origin",  'numeric', 
                            "target",  'numeric', 
                            "type",    'character',
                            "statbit", 'character'), ncol=2, byrow=TRUE,
                         dimnames = list(c(1:5), c("name","what")) )

    substr.format <-  matrix( c("id",      'numeric', 
                                "name",  'character', 
                                "root_atom",  'numeric', 
                                "subst_type",    'character',
                                "dict_type",    'character',
                                "chain",    'character',
                                "sub_type",    'character',
                                "inter_bonds",    'numeric',
                                "status",    'character'), ncol=2, byrow=TRUE,
                             dimnames = list(c(1:9), c("name","what")) )
    
    trim <- function(s) {
        s <- sub("^ +", "", s)
        s <- sub(" +$", "", s)
        s[(s == "")] <- NA
        s
      }

    
    split.line <- function(x, collapse=TRUE, ncol=NULL) {
      tmp <- unlist(strsplit(x, split=" "))
      inds <- which(tmp!="")
      if(!collapse)
        return(tmp[inds])
      else {
        tmp <- tmp[inds]
        if(length(tmp) < ncol)
          tmp <- c(tmp, "")
        return(paste(tmp, collapse=";"))
      }
    }

    ## Read and parse mol2 file
    raw.lines <- readLines(file, n = maxlines)
    
    mol.start <- grep("@<TRIPOS>MOLECULE", raw.lines)
    atom.start <- grep("@<TRIPOS>ATOM", raw.lines)
    bond.start <- grep("@<TRIPOS>BOND", raw.lines)
    subs.start <- grep("@<TRIPOS>SUBSTRUCTURE", raw.lines)
    num.mol <- length(mol.start)

    if (!num.mol>0) {
        stop("read.mol2: mol2 file contains no molecules")
    }

    ## Fetch molecule names and info
    mol.names <- raw.lines[mol.start+1]
    mol.info <- trim( raw.lines[mol.start+2] )
    mol.info <- as.numeric(unlist(lapply(mol.info, split.line, collapse=FALSE)))
    if(length(mol.info) < 5) mol.info <- c(mol.info, rep(NA, 5-length(mol.info)))
        

    ## mol.info should contain num_atoms, num_bonds, num_subs, num_feat, num_sets
    mol.info <- matrix(mol.info, nrow=num.mol, byrow=T)
 
    num.atoms <- as.numeric(mol.info[,1])
    num.bonds <- as.numeric(mol.info[,2])
    atom.end  <- atom.start + num.atoms
    bond.end  <- bond.start + num.bonds
    subs.end <- subs.start + mol.info[,3]

    ## Build a list containing ATOM record indices
    if(length(atom.start) > 0) {
        se <- matrix(c(atom.start, atom.end), nrow=length(atom.start))
        atom.indices <- lapply(1:num.mol, function(d) seq(se[d,1]+1, se[d,2]))
    }
    else {
        stop("No ATOM records found")
    }

    if(length(bond.start) > 0) {
        se <- matrix(c(bond.start, bond.end), nrow=length(bond.start))
        bond.indices <- lapply(1:num.mol, function(d) seq(se[d,1]+1, se[d,2]))
    }
    else {
        bond.indices <- NULL
        warning("No BOND records found")
    }

    if(length(subs.start) > 0) {
        se <- matrix(c(subs.start, subs.end), nrow=length(subs.start))
        subs.indices <- lapply(1:num.mol, function(d) seq(se[d,1]+1, se[d,2]))
    }
    else {
        subs.indices <- NULL
    }    

    ## Check if file consist of identical molecules
    same.mol <- TRUE
    mol.first <- NULL
    
    mols <- list()
    for ( i in 1:num.mol ) {
        raw.atom <- raw.lines[ atom.indices[[i]] ]

        if(!is.null(bond.indices))
            raw.bond <- raw.lines[ bond.indices[[i]] ]
        else
            raw.bond <- NULL

        if(!is.null(subs.indices))
            raw.subs <- raw.lines[ subs.indices[[i]] ]
        else
            raw.subs <- NULL
      
      ## Read atoms - split by space
      txt <- unlist(lapply(raw.atom, split.line, ncol=10, collapse=TRUE))
      ncol <- length(unlist(strsplit(txt[1], ";")))

      if(ncol==9) {
          txt[1]=paste0(txt[1], ";")
          ncol <- length(unlist(strsplit(txt[1], ";")))
      }
      
      atom <- read.table(text=txt, 
                         stringsAsFactors=FALSE, sep=";", quote='',
                         colClasses=unname(atom.format[1:ncol,"what"]),
                         col.names=atom.format[1:ncol,"name"],
                         comment.char="", na.strings="", fill=TRUE)

        ## Read bond - split by space
        if(!is.null(raw.bond)) {
            txt <- unlist(lapply(raw.bond, split.line, ncol=5, collapse=TRUE))
            ncol <- length(unlist(strsplit(txt[1], ";")))
            
            if(ncol==4) {
                txt[1]=paste0(txt[1], ";")
                ncol <- length(unlist(strsplit(txt[1], ";")))
            }

            bond <- read.table(text=txt,
                               stringsAsFactors=FALSE, sep=";", quote='',
                               colClasses=unname(bond.format[1:ncol,"what"]),
                               col.names=bond.format[1:ncol,"name"],
                               comment.char="", na.strings="", fill=TRUE)
        }
        else {
            bond <- NULL
        }
            
            
        ## Read substructure info - split by space
        subs <- NULL
        if(!is.null(raw.subs)) {
            txt <- unlist(lapply(raw.subs, split.line, ncol=5, collapse=TRUE))
            ncol <- length(unlist(strsplit(txt[1], ";")))
            
            if(ncol==4) {
                txt[1]=paste0(txt[1], ";")
                ncol <- length(unlist(strsplit(txt[1], ";")))
            }

            subs <- try(read.table(text=txt,
                                   stringsAsFactors=FALSE, sep=";", quote='',
                                   colClasses=unname(substr.format[1:ncol,"what"]),
                                   col.names=substr.format[1:ncol,"name"],
                                   comment.char="", na.strings="", fill=TRUE), silent=TRUE)

            
            if(inherits(subs, "try-error")) {
                subs <- try(read.table(text=txt,
                                       stringsAsFactors=FALSE, sep=";", quote='',
                                       comment.char="", na.strings="", fill=TRUE), silent=TRUE)
                
                if(inherits(subs, "try-error")) {
                    warning("error reading SUBSTRUCTURE records. check format.")
                    subs <- NULL
                }
                else {
                    ncol <- ncol(subs)
                    if(ncol < 3) {
                        warning("insufficent fields in SUBSTRUCTURE. check format.")
                    }
                    else {
                        warning("could not determine field type of SUBSTRUCTURE records. check format.")
                        if(ncol > 3) 
                            colnames(subs) <- c(substr.format[1:3], colnames(subs[4:ncol]))
                        else
                            colnames(subs) <- c(substr.format[1:3])
                        }
                }
            }
        }
        
      ## Same molecules as the previous ones?
      mol.str <- paste(atom$elena, collapse="")

      if ( i==1 ) {
        mol.first <- mol.str
      }
      else if (mol.str != mol.first) {
        same.mol <- FALSE
      }

      ## Store data
      xyz <- as.xyz(as.numeric(t(atom[, c("x", "y", "z")])))
      
      out <- list("atom" = atom, "bond" = bond, "xyz" = xyz, "substructure" = subs,
                  "info" = mol.info[i,], "name" = mol.names[i])
      class(out) <- "mol2"
      mols[[i]] <- out
    }

    ## If identical molecules
    if ( length(unique(num.atoms)) == 1 && same.mol == TRUE ) {
      atom <- mols[[1]]$atom
      bond <- mols[[1]]$bond
      xyz <- t(sapply(lapply(mols, function(x) x$xyz), rbind))
      xyz <- as.xyz(xyz)
      
      out <- list("atom" = atom, "bond" = bond, "substructure" = subs, "xyz" = xyz,
                  "info" = mol.info[1,], "name" = mol.names[1])
      class(out) <- "mol2"
    }
    else {
      out <- mols
      ##class(out) <- "mol2s"
    }
    
    return(out)
  }
  

context("Testing basic PDB structure operation")

test_that("read.mol2() reads a mol2 from zinc", {

  ## Simple test with aspirin
  file <- system.file("examples/aspirin.mol2",package="bio3d")
  invisible(capture.output(mol <- read.mol2(file)))

  expect_is(mol$atom, "data.frame")
  expect_true(inherits(mol, "mol2"))
  expect_true(inherits(mol$xyz, "xyz"))
  expect_equal(nrow(mol$atom), 20)
  expect_equal(nrow(mol$bond), 20)
  expect_equal(mol$info[1], 20)
  expect_equal(mol$info[2], 20)
  expect_equal(sum(mol$atom$elety=="H"), 7)

  elena <- c("C1", "C2", "O1", "O2", "C3", "C4", "C5",
             "C6", "C7", "C8", "C9", "O3", "O4", "H1", "H2",
             "H3", "H4", "H5", "H6", "H7")
  expect_equal(mol$atom$elena, elena)
      
  x <- c(-1.4238, -1.3441, -1.4532, -1.1519, -0.9822)
  y <- c(-2.5790, -3.9491, -4.7933, -4.2739, -2.8882)
  z <- c(0.6434,  0.0976,  0.0938,  0.0032, -0.0844)
  expect_equal(mol$atom$x[1:5], x)
  expect_equal(mol$atom$y[6:10], y)
  expect_equal(mol$atom$z[16:20], z)
  
})


test_that("read.mol2() reads and stores data properly", {
  skip_on_cran()
  skip_on_travis()
  
  file <- system.file("examples/aspirin.mol2",package="bio3d")
  invisible(capture.output(mol <- read.mol2(file)))

  f <- tempfile()
  write.mol2(mol, file=f)
  mol2 <- read.mol2(f)
  expect_equal(mol, mol2)
  
})


test_that("basic atom select and trim of mol2", {
  skip_on_cran()
  skip_on_travis()
  
  file <- system.file("examples/aspirin.mol2",package="bio3d")
  invisible(capture.output(mol <- read.mol2(file)))

  capture.output( sele <- atom.select(mol, "noh") )
  expect_equal(length(sele$atom), 13)

  capture.output( sele <- atom.select(mol, elety="H") )
  expect_equal(length(sele$atom), 7)

  capture.output( sele <- atom.select(mol, elena="C1") )
  expect_equal(length(sele$atom), 1)

  capture.output( sele <- atom.select(mol, resno=1) )
  expect_equal(length(sele$atom), 20)

  capture.output( sele <- atom.select(mol, "noh") )
  mol2 <- trim(mol, sele)

  expect_equal(nrow(mol2$atom), 13)
  expect_equal(nrow(mol2$bond), 13)
  expect_equal(length(mol2$xyz), 39)
  
  xyz <- c(-1.4238,  1.4221,  1.2577, -1.3441, -0.0813)
  expect_equal(mol2$xyz[1:5], xyz)
  
})



test_that("converting mol2 to pdb works", {
  skip_on_cran()
  skip_on_travis()
  
  file <- system.file("examples/aspirin.mol2",package="bio3d")
  invisible(capture.output(mol <- read.mol2(file)))

  capture.output( pdb <- as.pdb(mol) )
  expect_equal(nrow(pdb$atom), nrow(mol$atom))
  expect_equal(pdb$xyz, mol$xyz)

  expect_equal(mol$atom$elena, pdb$atom$elety)
  expect_equal(mol$atom$x, pdb$atom$x)
  expect_equal(mol$atom$charge, pdb$atom$charge)

})

filter.cmap <- function(cm, cutoff.sims = NULL) {

  ## Convert list to array  
  if(is.list(cm)) {
      dims <- dim(cm[[1]])
      if(length(dims) != 2)
          stop("Input 'cm' should be a NxNxS 3d array or a list of NxN matrices,
      where N is the number of atoms and S is the number of simulations")
      
      if(length(unique(c(sapply(cm, dim)))) != 1)
          stop("Matrices in provided list have unequal dimensions")
      
      cm <- array(unlist(cm), dim = c(nrow(cm[[1]]), ncol(cm[[1]]), length(cm)))
  }
    
  ## Check input
  dims <- dim(cm)
  if(length(dims) != 3) {
      stop("Input 'cm' should be a NxNxS 3d array or a list of NxN matrices,
      where N is the number of atoms and S is the number of simulations")
  }

  if(dims[3L] < 2)
      stop("2 or more contact maps required")
  
  if(is.null(cutoff.sims))
      cutoff.sims <- dims[3L]

    if(!is.numeric(cutoff.sims) | cutoff.sims > dims[3L] | cutoff.sims < 1) {
        stop(paste("Input 'cutoff.sims' should be a number between 1 and", dims[3L], "\n  ",
                   "(i.e. the number of simulations upon which filtering is based)"))
    }

  ## Sum across simulations and filter by cutoff.sims de
  cm.sum <- apply(cm, c(1:2), sum, na.rm = TRUE)

  return(array(as.numeric(cm.sum >= cutoff.sims), dim = dim(cm.sum)))
}

"plot.rmsip" <-
  function(x, xlab=NULL, ylab=NULL, col=gray(50:0/50), zlim=c(0,1), ...) {
    
    ##opar <- par(no.readonly = TRUE)
    ##on.exit(par(opar))
    
    if(is.null(xlab))
      xlab <- "a"
    if(is.null(ylab))
      ylab <- "b"
    
    image(1:ncol(x$overlap), 1:nrow(x$overlap), x$overlap,
          col=col, zlim=zlim,
          xlab=xlab, ylab=ylab, ...)
    mtext(paste("RMSIP:", round(x$rmsip, 2)), side=3, line=0.5, at=0.5, adj=0, ...)
    
  }

#' Gaussian Network Model
#'
#' Perform Gaussian network model (GNM) based normal mode analysis (NMA) for 
#' a protein structure.
#'
#' @details This function builds a Gaussian network model (an isotropic elastic network 
#'    model) for C-alpha atoms and performs subsequent normal mode analysis (NMA). 
#'    The model employs a distance cutoff for the network construction: Atom pairs with 
#'    distance falling  within the cutoff have a harmonic interaction with a uniform force constant; 
#'    Otherwise atoms have no interaction. Output contains N-1 (N, the number of residues) 
#'    non-trivial modes (i.e. the degree of freedom is N-1), which can then be used to 
#'    calculate atomic fluctuations and covariance.  
#'
#' @param x an object of class \code{pdb} as obtained from function \code{\link{read.pdb}}. 
#' @param inds atom and xyz coordinate indices obtained from \code{\link{atom.select}} that 
#'    selects the elements of \code{pdb} upon which the calculation should be based. 
#'    If not provided the function will attempt to select all calpha atoms automatically.
#' @param temp numerical, temperature for which the amplitudes for scaling the atomic 
#'    displacement vectors are calculated. Set \sQuote{temp=NULL} to avoid scaling. 
#' @param keep numerical, final number of modes to be stored. Note that all subsequent analyses 
#'    are limited to this subset of modes. This option is useful for very large structures and 
#'    cases where memory may be limited.
#' @param outmodes atom indices as obtained from \code{\link{atom.select}} specifying the atoms 
#'    to include in the resulting mode object. 
#' @param gamma numerical, global scale of the force constant.
#' @param cutoff numerical, distance cutoff for pair-wise interactions.
#' @param check.connect logical, if TRUE check chain connectivity.
#'
#' @return Returns an object of class \sQuote{gnm} with the following components:
#'    \item{force.constants}{ numeric vector containing the force constants corresponding 
#'       to each mode. }
#'    \item{fluctuations}{ numeric vector of atomic fluctuations. }
#'    \item{U}{ numeric matrix with columns containing the raw eigenvectors. }
#'    \item{L}{ numeric vector containing the raw eigenvalues. }
#'    \item{xyz}{ numeric matrix of class \code{xyz} containing the Cartesian coordinates 
#'       in which the calculation was performed. }
#'    \item{temp}{ numerical, temperature for which the amplitudes for scaling the atomic 
#'       displacement vectors are calculated. }
#'    \item{triv.modes}{ number of trivial modes. }
#'    \item{natoms}{ number of C-alpha atoms. }
#'    \item{call}{ the matched call. }
#'
#' @seealso 
#'      \code{\link{gnm.pdbs}}
#'
#' @author Xin-Qiu Yao & Lars Skjaerven
#' 
#' @references 
#'    Bahar, I. et al. (1997) \emph{Folding Des.} \bold{2}, 173. 
#' 
#' @examples
#'    ## Fetch stucture
#'    pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
#'    
#'    ## Calculate normal modes
#'    modes <- gnm(pdb)
#'    
#'    ## Print modes
#'    print(modes)
#'    
#'    ## Plot modes
#'    plot(modes)
#'
gnm <- function(x, ...) {
  UseMethod("gnm")
}

#' @rdname gnm
gnm.pdb <- function(x, inds=NULL, temp=300.0, keep=NULL, outmodes=NULL, 
                      gamma=1.0, cutoff=8.0, check.connect=TRUE, ...) {
 
  pdb <- x
 
  ## Log the call
  cl <- match.call()

  if(!is.pdb(pdb))
    stop("please provide a 'pdb' object as obtained from 'read.pdb()'")

  if(!is.null(outmodes) & !is.select(outmodes))
    stop("provide 'outmodes' as obtained from function atom.select()")
  
  ## Prepare PDB
  ## Take only first frame of multi model PDB files
  if(nrow(pdb$xyz)>1) {
    warning("multimodel PDB file detected - using only first frame")
    pdb$xyz=pdb$xyz[1,, drop=FALSE]
  }

  ## Trim to only CA atoms
  if(is.null(inds)) {
    ca.inds <- atom.select(pdb, "calpha", verbose=FALSE)
    pdb.in <- trim.pdb(pdb, ca.inds)
  }

  ## or to user selection
  else {
    pdb.in <- trim.pdb(pdb, inds)
    if(!all(pdb.in$atom$elety=="CA"))
      stop("non-CA atoms detected")
  }

  ## Indices for effective hessian
  if(is.select(outmodes)) {
    ## re-select since outmodes indices are based on input PDB
    inc.inds <- .match.sel(pdb, pdb.in, outmodes)
    pdb.out <- trim.pdb(pdb.in, inc.inds)
  }
  else {
    pdb.out <- pdb.in
    inc.inds <- atom.select(pdb.in, "all", verbose=FALSE)
  }

  ## fetch number of atoms and sequence
  natoms.in  <- ncol(pdb.in$xyz)/3
  natoms.out <- ncol(pdb.out$xyz)/3
  
  if (natoms.in<2)
    stop("gnm: insufficient number of atoms")

  ## check structure connectivity
  if(check.connect) {
    conn <- inspect.connectivity(pdb.in$xyz)
    if(!conn) {
      warning("Possible multi-chain structure or missing in-structure residue(s) present\n", 
              "  Fluctuations at neighboring positions may be affected.")
    }
  }
 
  ## build Kirchhoff matrix
  K <- cmap(pdb.in, scut=1, dcut=cutoff, mask.lower=FALSE)
  K[!is.na(K) & K > 0] <- -1
  diag(K) <- - apply(K, 1, sum, na.rm=TRUE)
  
  if(length(inc.inds$atom) < nrow(K)) {
    # calculate effective Kirchhoff
    ptm <- proc.time()
#    cat(" Extracting effective Kirchhoff..")
    inc.inds <- inc.inds$atom
    kaa    <- K[inc.inds, inc.inds]
    kqq.inv <- chol2inv(chol(K[-inc.inds, -inc.inds]))
    kaq     <- K[inc.inds, -inc.inds]
    kqa     <- t(kaq)
    K <- kaa - crossprod(crossprod(kqq.inv, kqa), kqa)
    t <- proc.time() - ptm
#    cat("\tDone in", t[[3]], "seconds.\n")
  }

  ## diagonalize - get eigenvectors
  ei <- eigen(K, symmetric=TRUE)
  ei$values <- ei$values[length(ei$values):1]
  ei$vectors <- ei$vectors[, length(ei$values):1]

  if(any(ei$values[-1] < 0)) {
    warning("Negative eigenvalue(s) detected! \
            This can be an indication of an unphysical input structure.")
  }

  ## keep only a subset of modes - including trivial modes
   if(!is.null(keep)) {
    if(keep > ncol(ei$vectors))
      keep <- ncol(ei$vectors)
    keep.inds <- seq(1, keep)
    ei$vectors <- ei$vectors[, keep.inds]
    ei$values <- ei$values[keep.inds]
  }
  
  ## fluctuations
  kb <- 0.00831447086363271
  f <- t(ei$vectors[, -1]**2) / ei$values[-1]
  f <- colSums(f) * 3 * kb * temp / gamma

  ## make a GNM object
  gnm <- list(force.constants = ei$values, 
              fluctuations = f,
              U = ei$vectors, L = ei$values,
              xyz = pdb.out$xyz,
              temp = temp, 
              triv.modes=1,
              natoms = natoms.out,
              call = cl)
  class(gnm) <- c('EnergeticModes', 'gnm', 'nma')
  return(gnm)
}

context("Testing gnm()")


test_that("GNM", {

  "mysign" <- function(a,b) {
    if(all(sign(a)==sign(b)))
      return(1)
    else
      return(-1)
  }

  ## Simple test with PDB ID 1HEL
  file <- system.file("examples/1hel.pdb",package="bio3d")
  invisible(capture.output(pdb <- read.pdb(file)))
  
  ## Calculate modes with default arguments
  invisible(capture.output(modes <- gnm.pdb(pdb) ) )

  ## NOTE: all following reference results are from Prody
  ## Check first eigenvector 
  U2 <- c( -0.020,  0.008,  0.026,  0.052,  0.069,  0.086)
  nowU2 <- round(head(modes$U[, 2]), 3)
  expect_that(nowU2 * mysign(U2, nowU2), equals(U2, tolerance=1e-6))
  
  ## Check second eigenvector
  U3 <- c(0.050, 0.064, 0.084, 0.110, 0.105, 0.145)
  nowU3 <- round(head(modes$U[,3]), 3)
  expect_that(nowU3 * mysign(U3, nowU3), equals(U3, tolerance=1e-6))

  ## Check eigenvalues
  eival <- c(0.342,   0.804,   1.108,   1.277,   1.416,   1.617)
  nowEival <- round(modes$L[2:7], 3)
  expect_that(nowEival, equals(eival, tolerance=1e-6))

  ## Dimensions
  expect_that(dim(modes$U), equals(c(129, 129)))
  expect_that(length(modes$L), equals(129))
  expect_that(modes$natoms, equals(129))
  expect_that(modes$temp, equals(300))

  ## Orthognals
  expect_that(as.numeric(modes$U[,2] %*% modes$U[,2]),
              equals(1, tolerance=1e-6))
  expect_that(all(round(c(modes$U[,2] %*% modes$U[, 3:ncol(modes$U)]), 6)==0),
              equals(TRUE))
  
  expect_that(all(round(c(modes$L[1]), 6)==0), equals(TRUE))
  
  ## fluctuations (NOTE: Prody results are scaled here by the thermodynamic factor 3*k_B*T)
  flucts <- c( 1.379, 1.370, 1.108, 1.425, 1.044, 1.202, 1.315, 0.976, 0.855, 1.173 ) 
  nowFlucts <- round(modes$fluctuations[1:10], 3)
  expect_that(nowFlucts, equals(flucts, tolerance=1e-6))
  
  ## Covariance
#  vcov <- c( 0.368,  0.293,  0.118,  0.032, -0.019,  0.037,  0.032, -0.040, -0.039, -0.020 )
#  nowVcov <- round(cov.nma(modes)[1, 2:11], 3)
#  expect_that(nowVcov, equals(vcov, tolerance=1e-6))

 
}   )

"unbound" <-
function(start, end=NULL) {
  if(is.matrix(start) && all(c("start", "end") %in% colnames(start))) {
     if(is.null(end)) end = start[, "end"]
     start = start[, "start"]
  }

  if(length(start)!=length(end))
    stop("start and end must are not the same length")
  ex <- NULL
  for(i in 1:length(start)) {
    ex <- c(ex, start[i]:end[i])
  }
  return(ex)
}

"bounds" <-
function (nums, dup.inds=FALSE, pre.sort=TRUE) {

  if(dup.inds) {
    ## bounds of concetive duplicated numbers 
    s.ind <- which(!duplicated(nums))
    e.ind   <- c(s.ind[-1]-1, length(nums))
    return(cbind(1:length(s.ind),"start"=s.ind,"end"=e.ind,
                 "length"=(e.ind - s.ind + 1)))

  } else {
    if (!is.numeric(nums)) 
        stop("must supply a numeric vector")
    if (length(nums)==0)
      return(nums)

    if(pre.sort) {
      ## should we pre-sort...
      nums <- sort(unique(nums))
    }

    if (length(nums) == 1) {
      bounds <- c(nums, nums, 1)
      names(bounds) <- c("start", "end", "length")
      ## Edit here to return matrix (not vector) 
      ## following dssp bug report from Yun Liu
      ## Fri, Apr 29, 2011
     return( t(as.matrix(bounds)) )
    }

    bounds <- nums[1]
    nums.start <- nums[1]
    diff.i <- 1
    for (i in 2:length(nums)) {
        if ((nums[i] - diff.i) != nums.start) {
            bounds <- c(bounds, nums[i - 1], nums[i])
            nums.start <- nums[i]
            diff.i <- 1
        }
        else {
            diff.i <- diff.i + 1
        }
    }
    bounds <- c(bounds, nums[length(nums)])
    bounds <- matrix(bounds, ncol = 2, byrow = TRUE,
                     dimnames = list(c(1:(length(bounds)/2)),
                       c("start", "end")))
    bounds <- cbind(bounds, length = (bounds[, 2] - bounds[,1]) + 1)
    return(bounds)
  }
}

"fluct.nma" <-
  function(nma, mode.inds=NULL) {
    
    kb <- 0.00831447086363271
    pi <- 3.14159265359
    
    if(!"nma" %in% class(nma))
      stop("fluct.nma: must supply 'nma' object, i.e. from 'nma'")
    
    if("VibrationalModes" %in% class(nma))
      mass <- TRUE
    else
      mass <- FALSE

    if(is.null(mode.inds))
      mode.inds <- seq(nma$triv.modes+1, length(nma$L))

    if(min(mode.inds)<=nma$triv.modes)
      stop("'mode.inds' should not contain indices to trivial modes")

    f <- apply(nma$U, 2, function(x) { rowSums(matrix(x, ncol=3, byrow=TRUE)**2) })
    
    if(mass)
      freq <- nma$frequencies**2
    else
      freq <- nma$force.constants


    for ( i in mode.inds )  {
      f[,i] <- f[,i] / freq[i]
    }

    if(length(mode.inds)>1)
      f <- rowSums(f[,mode.inds])
    else
      f <- f[,mode.inds]
  
    if(mass) {
      f <- f / nma$mass
      s <- 1/(2*pi)**2
      if(!is.null(nma$temp))
        s <- s*kb*nma$temp
      f <- f*s
    }
    else {
      if(!is.null(nma$temp))
        f <- f*kb*nma$temp
    }
    
    return(f)
  }

"build.hessian" <-
  function(xyz, pfc.fun, fc.weights=NULL, pdb=NULL, ... )  {
    
    if(missing(xyz))
      stop("build.hessian: 'xyz' coordinates must be provided")
    
    if (!is.function(pfc.fun))
      stop("build.hessian: 'pfc.fun' must be a function")

    ## Coordinates
    xyz = as.xyz(xyz)
    if(nrow(xyz)>1)
      xyz=xyz[1,,drop=FALSE]
    xyz=as.vector(xyz)
    
    xyz    <- matrix(xyz, ncol=3, byrow=TRUE)
    natoms <- nrow(xyz)

    ## Check provided weight matrix
    if(!is.null(fc.weights)) {
      if(!is.matrix(fc.weights))
        stop("'fc.weights' must be a numeric matrix")
      
      if((nrow(fc.weights) != natoms) ||
         (ncol(fc.weights) != natoms) )
        stop("'fc.weights' must be numeric matrix with dimensions NxN")
    }

    build.submatrix <- function(xyz, natoms, 
                                fc.weights=NULL, 
                                pdb=NULL, ...) {
     
      ## Full Hessian
      Hsm <- matrix(0, ncol=3*natoms, nrow=3*natoms)
      
      ## Indices relating atoms and columns in the sub-hessian
      col.inds <- seq(1, ncol(Hsm), by=3)

      ## Weight indices
      inds <- rep(1:natoms, each=3)

      ## Convenient indices for accessing the hessian
      inds.x <- seq(1, natoms*3, by=3)
      inds.y <- inds.x+1
      inds.z <- inds.x+2
            
      for ( i in 1:natoms ) {
        ## Calculate difference vectors and force constants
        diff.vect <- t(t(xyz) - xyz[i,])
        
        ##dists <- apply(diff.vect, 1, function(x) sqrt(sum(x**2)))
        dists <- sqrt(rowSums(diff.vect**2))  ## quicker !

        ## pfc.fun takes a vector of distances
        ff.names <- names(formals( pfc.fun ))
        args <- list(dists)
        if('atom.id' %in% ff.names) args <- c(args, list(atom.id=i))
        if('pdb' %in% ff.names) args <- c(args, list(pdb=pdb))
        args <- c(args, list(...))
        force.constants <- do.call(pfc.fun, args)
          
        ## Scale the force constants
        if(!is.null(fc.weights)) {
          force.constants <- force.constants * fc.weights[i,]
        }
        
        force.constants <- (-1) * force.constants / (dists**2)

        ## since we divide on zero, ensure no Inf values
        force.constants[i] <- 0
        diff.vect[i,] <- 0

        ## Hessian elements
        dxx <- diff.vect[,1] * diff.vect[,1] * force.constants
        dyy <- diff.vect[,2] * diff.vect[,2] * force.constants
        dzz <- diff.vect[,3] * diff.vect[,3] * force.constants
        
        dxy <- diff.vect[,1] * diff.vect[,2] * force.constants
        dxz <- diff.vect[,1] * diff.vect[,3] * force.constants
        dyz <- diff.vect[,2] * diff.vect[,3] * force.constants

        ## Place the elements
        m <- col.inds[i]
        
        ## Off-diagonals 
        Hsm[inds.x, m   ] <- dxx
        Hsm[inds.y, m+1 ] <- dyy
        Hsm[inds.z, m+2 ] <- dzz

        Hsm[inds.y, m   ] <- dxy
        Hsm[inds.z, m   ] <- dxz
        
        Hsm[inds.x, m+1 ] <- dxy
        Hsm[inds.z, m+1 ] <- dyz
        
        Hsm[inds.x, m+2 ] <- dxz
        Hsm[inds.y, m+2 ] <- dyz

        ## Diagonal super elements
        Hsm[inds.x[i], m] <- sum(Hsm[inds.x, m]) * (-1)
        Hsm[inds.y[i], m] <- sum(Hsm[inds.y, m]) * (-1)
        Hsm[inds.z[i], m] <- sum(Hsm[inds.z, m]) * (-1)

        Hsm[inds.x[i], m+1] <- sum(Hsm[inds.x, m+1]) * (-1)
        Hsm[inds.y[i], m+1] <- sum(Hsm[inds.y, m+1]) * (-1)
        Hsm[inds.z[i], m+1] <- sum(Hsm[inds.z, m+1]) * (-1)

        Hsm[inds.x[i], m+2] <- sum(Hsm[inds.x, m+2]) * (-1)
        Hsm[inds.y[i], m+2] <- sum(Hsm[inds.y, m+2]) * (-1)
        Hsm[inds.z[i], m+2] <- sum(Hsm[inds.z, m+2]) * (-1)

      }
      return(Hsm)
    }
      

    H <- build.submatrix(xyz=xyz, natoms=natoms,
                         fc.weights=fc.weights,
                         pdb=pdb, ... )
    
    return(H)
  }

"com.pdb" <-
  function(pdb, inds=NULL, use.mass=TRUE, ... ) {
    
    if (missing(pdb))
      stop("Please supply an input 'pdb' object, i.e. from 'read.pdb()'")
    if(!is.pdb(pdb))
      stop("Input 'pdb' must be of type 'pdb'")
    
    if(is.null(inds)) {
      xyz <- pdb$xyz
      at <- pdb$atom[, "elety"]
    }
    else {
      if(!is.select(inds))
        stop("provide a select object as obtained from 'atom.select'")
      
      if(length(inds$xyz)<3)
        stop("insufficient atoms in selection")
      xyz <- pdb$xyz[,inds$xyz]
      at <- pdb$atom[inds$atom, "elety"]
    }
    
    if(use.mass) {
      m <- atom2mass(at, ...)
    }
    else {
      m <- NULL
    }

    com <- com.xyz(xyz, m)
    return(com)
  }

"struct.aln" <-
  function(fixed, mobile, fixed.inds  = NULL, mobile.inds = NULL,
           write.pdbs = TRUE, outpath = "fitlsq",
           prefix = c("fixed", "mobile"),
           max.cycles = 10, cutoff = 0.5, ... ) {
    
    if(missing(fixed)) 
      stop("align: must supply 'pdb' object, i.e. from 'read.pdb'")
    if(missing(mobile)) 
      stop("align: must supply 'pdb' object, i.e. from 'read.pdb'")
    
    if(!is.pdb(fixed))
      stop("align: 'fixed' must be of type 'pdb'")
    if(!is.pdb(mobile))
      stop("align: 'mobile' must be of type 'pdb'")
    
    ## if indices are provided, make new PDB entities
    if ( !is.null(fixed.inds) ) {
      if(length(fixed.inds$atom)<2)
        stop("align: insufficent atom indices for fitting")
      
      #a <- NULL
      #a$atom <- fixed$atom[fixed.inds$atom, ]
      #a$xyz <- fixed$xyz[fixed.inds$xyz]
      #a$calpha <- as.logical(a$atom[,"elety"] == "CA")
      a <- trim.pdb(fixed, fixed.inds)
    }
    else {
      a <- fixed
      fixed.inds <- atom.select(fixed, 'all', verbose=FALSE)
    }
    
    if ( !is.null(mobile.inds) ) {
      if(length(mobile.inds$atom)<2)
        stop("align: insufficent atom indices for fitting")
      
      #b <- NULL
      #b$atom <- mobile$atom[mobile.inds$atom, ]
      #b$xyz <- mobile$xyz[mobile.inds$xyz]
      #b$calpha <- as.logical(b$atom[,"elety"] == "CA")
      b <- trim.pdb(mobile, mobile.inds)
    }
    else {
      b <- mobile
      mobile.inds <- atom.select(mobile, 'all', verbose=FALSE)
    }

    "xyz.dist" <- function(v) {
      a <- v[1:3]; b <- v[4:6]
      sqrt(sum((a-b)**2))
    }
    
    "resi.dev" <- function(xyz.a, xyz.b, cycle=1, cutoff = 0.5) {
      k <- matrix(xyz.a, ncol=3, byrow=T)
      l <- matrix(xyz.b, ncol=3, byrow=T)

      devs <- apply( cbind(k,l), 1, "xyz.dist")
      m <- median(devs)
      std <- sd(devs)
      
      cut <- m + (2*std)
      inds <- which( devs > cut )
      
      if ( (std < cutoff) || (length(inds)==0) ) {
        return( NULL )
      }
      else {
        cat( " Cycle ", i, ": ", length(inds), " atoms rejected", "\n", sep="")
        cat("  Mean: ", round(m,1),
            " Std: ", round(std,1),
            " Cut: ", round(cut,1), "\n", sep="" )
        return(inds)
      }
    }
    
    "remap.inds" <- function(pdb.init, inds.init, inds.trunc.atom) {
      ## Map back to indices for the entire PDB given
      inds.full <- NULL
      inds.full$atom <- inds.init$atom[inds.trunc.atom]
      inds.full$xyz <- atom2xyz(inds.full$atom)
      inds.full$logical <- atom2xyz(seq(1, nrow(pdb.init$atom))) %in% inds.full$xyz
      return(inds.full)
    }

    "parse.pdb" <- function(pdb, gaps, s, i) {
      pdbseq <- aa321(pdb$atom[pdb$calpha, "resid"])
      aliseq <- toupper(s$ali[i, ])
      tomatch <- gsub("X", "[A-Z]", aliseq[!is.gap(aliseq)])
      start.num <- regexpr(pattern = paste(c(na.omit(tomatch[1:15])), 
                             collapse = ""), text = paste(pdbseq, collapse = ""))[1]
      
      nseq <- rep(NA, length(aliseq))
      ali.res.ind <- which(!is.gap(aliseq))
      
      ali.res.ind <- ali.res.ind[1:length(pdbseq)]
      nseq[ali.res.ind] = start.num:((start.num - 1) + length(tomatch))
      
      pdb$atom <- cbind(pdb$atom, index=seq(1, nrow(pdb$atom)))
      ca.ali <- pdb$atom[pdb$calpha, ][nseq, ]
      at.inds <- ca.ali[, "index"]
      return(at.inds)
    }
    
    ## PDB list for sequence alignment
    pdb.list <- NULL
    pdb.list[[1]] <- a
    pdb.list[[2]] <- b
    
    ## Sequence alignment
    s <- lapply(pdb.list, pdbseq)
    s <- t(sapply(s, `[`, 1:max(sapply(s, length))))
    s[is.na(s)] <- "-"
    s <- seqaln(s, id = c("fixed", "mobile"), ...)
    gaps <- gap.inspect(s$ali)

    ## Parse truncated PDBs
    at.inds.a <- parse.pdb(a, gaps, s, 1)
    at.inds.b <- parse.pdb(b, gaps, s, 2)
    
    ## Fetch indices for fitting (truncated pdb)
    at.a <- as.numeric(at.inds.a[gaps$f.inds])
    at.b <- as.numeric(at.inds.b[gaps$f.inds])

    ## Indices for full pdb - done with the truncated ones
    a.inds.full <- remap.inds(fixed, fixed.inds, at.a)
    b.inds.full <- remap.inds(mobile, mobile.inds, at.b)

    ## Perform the initial fitting
    fit <- rot.lsq(mobile$xyz, fixed$xyz,
                   xfit=b.inds.full$logical, yfit=a.inds.full$logical)
    rmsd.init <- rmsd(as.vector(fixed$xyz), fit,
                      a.inds=a.inds.full$xyz, b.inds=b.inds.full$xyz)
    cat("\n")
    cat(" Initial RMSD (", length(gaps$f.inds), " atoms): ", rmsd.init,
        "\n", sep="")
    
    if ( write.pdbs ) {
      dir.create(outpath, FALSE)
      fname <- file.path(outpath, paste(prefix[2], "_", 0, ".pdb", sep=""))
      write.pdb(mobile, xyz=fit, file=fname)
    }

    ## Refinement process 
    rmsd.all <- c(rmsd.init)
    for ( i in seq(1,max.cycles) ) {
      if(i>max.cycles)
        break

      ## Find residues with largest structural deviation
      exc <- resi.dev(fixed$xyz[a.inds.full$xyz], fit[b.inds.full$xyz],
                      cycle = i, cutoff = cutoff)

      if ( is.null(exc) ) {
        break
      }
      else {
        ## Remove atoms for new round of fitting
        exc <- atom2xyz(exc)
        
        tmp <- seq(1,length( a.inds.full$logical ))
        exc.a <- tmp[which( a.inds.full$logical )][exc]
        a.inds.full$logical[exc.a] <- FALSE

        tmp <- seq(1,length( b.inds.full$logical ))
        exc.b <- tmp[which( b.inds.full$logical )][exc]
        b.inds.full$logical[exc.b] <- FALSE

        ## Build new xyz and atom indices
        a.inds.full$xyz <- which(a.inds.full$logical)
        b.inds.full$xyz <- which(b.inds.full$logical)

        a.inds.full$atom <- xyz2atom(a.inds.full$xyz)
        b.inds.full$atom <- xyz2atom(b.inds.full$xyz)
        
        ## Fit based on new indices
        fit <- rot.lsq(mobile$xyz, fixed$xyz,
                       xfit=b.inds.full$logical, yfit=a.inds.full$logical)

        if ( write.pdbs ) {
          fname <- file.path(outpath, paste(prefix[2], "_", i, ".pdb", sep=""))
          write.pdb(mobile, xyz=fit, file=fname)
        }
        
        ## Calculate RMSD 
        tmp.rmsd <- rmsd(as.vector(fixed$xyz), fit, a.inds=a.inds.full$xyz, b.inds.full$xyz)
        rmsd.all <- c(rmsd.all, tmp.rmsd)
        num.resi <- length(which(a.inds.full$logical))/3
        
        cat("  RMSD (", num.resi, " of ", length(gaps$f.inds), " atoms): ",
            tmp.rmsd, "\n", sep="")
      }
    }

    if ( write.pdbs ) {
      fname <- file.path(outpath, paste(prefix[1], ".pdb", sep=""))
      write.pdb(fixed, file=fname)
    }

    a.inds.full$logical <- NULL
    b.inds.full$logical <- NULL
    
    out <- list("a.inds"=a.inds.full, "b.inds"=b.inds.full,
                xyz=as.xyz(fit), rmsd=rmsd.all)
    
    return(out)     
  }

sip <- function(...)
  UseMethod("sip")

sip.nma <- function(a, b, ...) {
  if(length(a$fluctuations)!=length(b$fluctuations))
    stop("dimension mismatch")
  return(sip.default(a$fluctuations, b$fluctuations))
}

sip.enma <- function(enma, ncore=NULL, ...) {
  if(!inherits(enma, "enma"))
    stop("provide a 'enma' object as obtain from function 'nma.pdbs()'")
  
  ncore <- setup.ncore(ncore, bigmem = FALSE)
  
  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply

  gaps <- gap.inspect(enma$fluctuations)
  dims <- dim(enma$fluctuations)
  m <- dims[1]
  
  mat <- matrix(NA, m, m)
  ##inds <- pairwise(m)
  inds <- rbind(pairwise(m),
                matrix(rep(1:m,each=2), ncol=2, byrow=T))
  
  mylist <- mylapply(1:nrow(inds), function(row) {
    i <- inds[row,1]; j <- inds[row,2];
    out <- list(val=sip.default(
                  enma$fluctuations[i,gaps$f.inds],
                  enma$fluctuations[j,gaps$f.inds]),
                i=i, j=j)
    return(out)
  })

  for ( i in 1:length(mylist)) {
    tmp <- mylist[[i]]
    mat[tmp$i, tmp$j] <- tmp$val
  }

  mat[ inds[,c(2,1)] ] = mat[ inds ]
  ##diag(mat) <- rep(1, n)
  colnames(mat) <- basename(rownames(enma$fluctuations))
  rownames(mat) <- basename(rownames(enma$fluctuations))
  
  return(round(mat, 6))
}

sip.default <- function(v, w, ...) {
  if(length(v)!=length(w))
    stop("dimension mismatch")
  return(as.numeric(((t(v) %*% w)**2) / ((t(v) %*% v)*(t(w) %*% w))))
}

read.crd.amber <- function(file, ...) {
  cl <- match.call()

  if(missing(file)) {
    stop("read.pdb: please specify a PDB 'file' for reading")
  }
  
  ##- Check if file exists locally or on-line
  if(!file.exists(file)) {
    stop("No input PDB file found: check filename")
  }
  
  ## parse CRD file with cpp function
  crd <- .read_crd(file)
  if(!is.null(crd$error))
    stop(paste("Could not read", file))
  else
    class(crd) <- c("amber", "crd")

  if(is.na(crd$time))
    crd$time <- NULL
  
  if(!length(crd$velocities)>0)
    crd$velocities <- NULL

  if(!length(crd$box)>0)
    crd$box <- NULL
  
  crd$xyz <- as.xyz(crd$xyz)
  crd$call <- cl
  
  ## finished
  return(crd)
}

seqbind <- function(..., blank = "-") {
  cl <- match.call()
  
  objs <- list(...)
  are.null <- unlist(lapply(objs, is.null))
  objs <- objs[!are.null]
  
  if(length(objs)==0)
    stop("Incompatible input")
  
  if(length(objs)==1)
    return(unlist(objs))
  
  is.fasta <- function(x)
    return(inherits(x, "fasta"))
           
  are.fas <- unlist(lapply(objs, is.fasta))
  are.vec <- unlist(lapply(objs, is.vector))
  are.mat <- unlist(lapply(objs, is.matrix))
  
  if(!all(are.vec | are.mat | are.fas))
    stop("'Can combine only vectors and/or matrices'")

  objs[are.fas] <- lapply(objs[are.fas], function(x) x$ali)
  objs[are.vec] <- lapply(objs[are.vec], matrix, nrow = 1)
  max.col <- max(unlist(lapply(objs, ncol)))
  extend <- function(x, n, add)
    cbind(x, matrix(add, nrow=nrow(x), ncol=n-ncol(x)))  
  objs <- lapply(objs, extend, n = max.col, add = blank)
  objs <- do.call(rbind, objs)

  out <- as.fasta(objs, id=rownames(objs))
  out$call <- cl
  return(out)
}

"mktrj.enma" <- function(enma=NULL,   # enma data structure
                         pdbs=NULL,   # pdbs object 
                         s.inds=NULL, # structure ids
                         m.inds=NULL, # modes ids
                         mag=10,      # magnification factor
                         step=1.25,   # step size
                         file=NULL,   # output pdb file
                         rock=TRUE, ncore=NULL,
                         ... ) {      # args for write.pdb

  ## make a trjactory of atomic displacments along a given mode
  if(!inherits(enma, "enma")) 
    stop("mktrj.enma: must supply 'enma' object, i.e. from 'nma.pdbs'")

  if(!is.null(pdbs)) {
      if(!inherits(pdbs, "pdbs"))
          stop("input 'pdbs' should be a list object as obtained from 'read.fasta.pdb'")
  }
    
  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore, bigmem = FALSE)
  
  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply
  
  if(is.null(s.inds))
    s.inds <- 1:nrow(enma$fluctuations)

  if(is.null(m.inds))
    m.inds <- 1:5
  
  if(is.null(file) & length(s.inds)==1 & length(m.inds)==1)
    file <- paste("mode_", m.inds+6, "-s", s.inds, ".pdb", sep="")

  ## check dimensions to determine rm.gaps
  if(any(is.gap(enma$xyz))
     & (dim(enma$U.subspace)[1] == dim(enma$xyz)[2])) {
      rm.gaps <- FALSE
  }
  else {
      rm.gaps <- TRUE
  }

  if(!rm.gaps & length(s.inds)>1)
    stop(paste("enma object must be calculated with argument rm.gaps=TRUE", "\n",
               "for trajectory generation of multiple structures and modes"))

  if(any(enma$L[s.inds, m.inds]<=0))
    warning("Mode with eigenvalue <=0 detected. Check 'mode' index.")

  nstep <- c(seq(step, to=mag, by=step))
  zcoor <- cbind(1) %*% nstep
  scor  <- function(x,u,m) { return(x*u+m) }
  
  myMktrj <- function(i) {
    coor <- NULL
    ind <- s.inds[i]
    
    for(j in 1:length(m.inds)) {
      mode <- m.inds[j]
      
      u.inds <- which(!is.na(enma$U.subspace[,mode,ind]))
      if(rm.gaps)
        xyz.inds <- gap.inspect(enma$xyz)$f.inds
      else
        xyz.inds <- u.inds
      
      plus  <- sapply(c(zcoor), scor, u=enma$U.subspace[u.inds,mode,ind], m=enma$xyz[ind,xyz.inds])
      minus <- sapply(c(-zcoor), scor, u=enma$U.subspace[u.inds,mode,ind], m=enma$xyz[ind,xyz.inds])
      
      if(rock) {
          tmp  <- cbind(enma$xyz[ind,xyz.inds],
                      plus,  plus[,rev(1:ncol(plus))],
                      enma$xyz[ind,xyz.inds],
                      minus, minus[,rev(1:ncol(minus))])
      }
      else {
        tmp  <- cbind(plus[,rev(1:ncol(plus))],
                      enma$xyz[ind,xyz.inds],
                      minus)
      }
      
      coor <- rbind(coor, t(tmp))
    }
    return(coor)
  }

  ## do the calc
  coor <- mylapply(1:length(s.inds), myMktrj)
  coor <- do.call(rbind, coor)
  class(coor) <- "xyz"
  
  if(!is.null(file)) {
    if(rm.gaps)
      xyz.inds <- gap.inspect(enma$xyz)$f.inds
    else
      xyz.inds <- which(!is.na(enma$U.subspace[,m.inds[1],s.inds[1]]))

    if(is.null(pdbs)) 
      write.pdb(xyz=coor, file=file, ...)
    else {
      write.pdb(xyz=coor, file=file, 
                chain=pdbs$chain[s.inds[1], xyz2atom(xyz.inds)],
                resno=pdbs$resno[s.inds[1], xyz2atom(xyz.inds)],
                resid=pdbs$resid[s.inds[1], xyz2atom(xyz.inds)],
                b=enma$fluctuations[s.inds[1], !is.gap(enma$fluctuations[s.inds[1],])],
                ...)
    }
    invisible(coor)
  }
  else {
    return(coor)
  }
}

## class DistanceCalculator --> calculate()
"amsm.xyz" <- function(xyz, ncore=NULL) {
  if(!is.matrix(xyz))
    stop("'xyz' must be a trajectory matrix")
  
  natoms <- ncol(xyz) / 3
  atom.pairs <- natoms * (natoms -1) / 2

  ## Distance Calculator
  ## returns a list of 4x4 matrices
  M <- .amsm.distCalc(xyz, ncore=ncore)

  ## we use 'list' in this version of the code
  if(inherits(M, "list"))
    Mlist <- TRUE
  else
    Mlist <- FALSE

  ## assign the atom mov. sim. matrix
  matrixCorr <- matrix(0, nrow=natoms, ncol=natoms)
  maxEigenVal <- 0
  
  ## solve eigenvalue problems
  ij <- combn(natoms,2)
  for ( i in 1:atom.pairs ) {
    atom.inds <- ij[,i]

    if(Mlist) {
      ev      <- eigen(M[[i]])
      maxDist <- M[[i]][1,1]
    }
    else {
      ev      <- eigen(M[,,i])
      maxDist <- M[1,1,i]
    }
    
    maxEigenVal <- max(ev$values)
    hei <- 1 - (sqrt(maxDist / maxEigenVal))
    matrixCorr[atom.inds[1], atom.inds[2]] <- hei
    matrixCorr[atom.inds[2], atom.inds[1]] <- hei

    ##matrixCorr[atom.inds[1], atom.inds[2]] <- maxDist
    ##matrixCorr[atom.inds[2], atom.inds[1]] <- maxDist
    
    ##if(max(ev$values)>maxEigenVal) 
    ##  maxEigenVal <- max(ev$values)
  }

  ##matrixCorr <- 1 - sqrt(matrixCorr / maxEigenVal)
  diag(matrixCorr) <- 1
  return(matrixCorr)
}


## class DistanceCalculator --> DistanceCalculator()
".amsm.distCalc" <- function(xyz, ncore=NULL) {

  if(!is.matrix(xyz))
    stop("'xyz' must be a trajectory matrix")

  ## Parallelized by package 'parallel'
  ncore <- setup.ncore(ncore, bigmem = FALSE)
    
  ## used for vectProdSum
  vectPS <- function(xyz.ab) {
    a <- xyz.ab[1:3]; b <- xyz.ab[4:6];
    m <- (a[2] * b[3]) - (a[3] * b[2])
    n <- (a[3] * b[1]) - (a[1] * b[3])
    o <- (a[1] * b[2]) - (a[2] * b[1])
    return(c(m,n,o))
  }

  ## used for matrixPSum
  matrPS <- function(xyz.ab) {
    a <- xyz.ab[1:3]; b <- xyz.ab[4:6];
    m <- a[1] * b + b[1] * a
    n <- a[2] * b + b[2] * a
    o <- a[3] * b + b[3] * a
    return(c(m,n,o))
  }

  for.atompair2 <- function(i, xyz, ij, M) {
    ij <- ij[,i]
    
    inds <- rep(ij*3,each=3) - c(2,1,0)
    xyz.ab <- xyz[, inds]

    vectProdSum <- rowSums(apply(xyz.ab, 1, vectPS))
    matrixPSum  <- rowSums(apply(xyz.ab, 1, matrPS))
    suma <- sum((xyz.ab[,1:3]-xyz.ab[,4:6])^2)

    ##M <- matrix(0, ncol=4, nrow=4)
    M[1,1] = suma
    M[1,2] = vectProdSum[1];
    M[1,3] = vectProdSum[2];
    M[1,4] = vectProdSum[3];
    
    M[2,2] = matrixPSum[1];
    M[2,3] = matrixPSum[2];
    M[2,4] = matrixPSum[3];
    
    M[3,3] = matrixPSum[5];
    M[3,4] = matrixPSum[6];
    M[4,4] = matrixPSum[9];
    
    ## symmerty
    M[2,1] = M[1,2]
    M[3,1] = M[1,3]
    M[4,1] = M[1,4]
    
    M[3,2] = M[2,3]
    M[4,2] = M[2,4]
    M[4,3] = M[3,4]
    
    return(M)
  }

  ##atom.pairs <- natoms * (natoms -1) / 2
  natoms <- ncol(xyz) / 3
  M      <- matrix(0, ncol=4, nrow=4)
  ij     <- combn(natoms,2)
  
  if(ncore==1) {
    all.Ms <- lapply(1:ncol(ij), for.atompair2, xyz, ij, M)
  }
  else {
    all.Ms <- mclapply(1:ncol(ij), for.atompair2, xyz, ij, M,
                       mc.cores=ncore)
  }
  return(all.Ms)
}

"wrap.tor" <-
function(data,wrapav=TRUE,avestruc=NULL){
  
  wrap180 <- function(x) {
    x[which(x > 180, arr.ind=TRUE)] <-
      x[which(x > 180, arr.ind=TRUE)] - 360
    x[which(x < -180, arr.ind=TRUE)] <-
      x[which(x < -180, arr.ind=TRUE)] + 360
    x
  }
  
  if(!wrapav && is.null(avestruc))
    stop("Average structure is missing")
  if(is.vector(data)) {
    data <- matrix(data,ncol=1)
    return.vec = TRUE
  } else {
    return.vec = FALSE
  }

  
  avestruc.i<-avestruc
  datawrap <- NULL
  for(i in 1:ncol(data)) {
    struc <- data[,i]
    if(all(is.na(struc))) { struc <- rep(NA, length(struc)) } else {
    
      if(wrapav){ avestruc <- wrap180( mean(struc, na.rm=TRUE) ) } else {
        avestruc<-avestruc.i[i]
      }
	           
      difvar <- avestruc - struc
      while (length(difvar[ as.vector(na.omit(abs(difvar)>180)) ]) > 0) {
          
        struc[which(difvar > 180, arr.ind=TRUE)] <-
          struc[which(difvar > 180, arr.ind=TRUE)] + 360
          
        struc[which(difvar < -180, arr.ind=TRUE)] <-
          struc[which(difvar < -180, arr.ind=TRUE)] - 360
	    
        if(wrapav){avestruc <- wrap180( mean(struc, na.rm=TRUE) %% 360 )}
        
        difvar <- avestruc - struc
      }

    }
    datawrap <- cbind(datawrap,struc)
  }
  if(return.vec) datawrap = as.vector(datawrap)

  return(datawrap)
}

## Two options - both calculating modes on the FULL structure:
## 1 -  use k <- kaa - ((kaq %*% kqq.inv) %*% kqa) to derive hessian for core atoms
## 2 - return the full objects

"nma.pdbs" <- function(pdbs, fit=TRUE, full=FALSE, subspace=NULL,
                       rm.gaps=TRUE, varweight=FALSE,
                       outpath = NULL, ncore=1, progress = NULL, ...) {

  if(!inherits(pdbs, "pdbs"))
    stop("input 'pdbs' should be a list object as obtained from 'read.fasta.pdb'")

  ## Log the call
  cl <- match.call()

  if(!is.null(outpath))
    dir.create(outpath, FALSE)

  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore, bigmem = TRUE)
  prev.warn <- getOption("warn")

  if(ncore>1) {
    mylapply <- mclapply
    options(warn=1)
  }
  else
    mylapply <- lapply

  ## Passing arguments to functions aa2mass and nma
  am.names <- names(formals( aa2mass ))
  nm.names <- names(formals( nma.pdb ))

  dots <- list(...)
  am.args <- dots[names(dots) %in% am.names]
  nm.args <- dots[names(dots) %in% nm.names]

  ## Limiting input
  if("mass" %in% names(nm.args))
    mass <- nm.args$mass
  else
    mass <- TRUE
  if("ff" %in% names(nm.args))
    ff <- nm.args$ff
  else
    ff <- 'calpha'
  if("temp" %in% names(nm.args))
    temp <- nm.args$temp
  else
    temp <- 300
  if("keep" %in% names(nm.args))
    nm.keep <- nm.args$keep
  else
    nm.keep <- NULL

  if(!all((names(nm.args) %in% c("mass", "ff", "temp", "keep")))) {
    war <- paste(names(nm.args)[! names(nm.args) %in% c("mass", "ff", "temp", "keep") ], collapse=", ")
    warning(paste("ignoring arguments:", war))
  }

  ## Force field
  pfc.fun <- load.enmff(ff)

  ## Check for optional arguments to pfc.fun
  ff.names <- names(formals( pfc.fun ))
  ff.args  <- dots[names(dots) %in% ff.names]

  ## Set indicies
  gaps.res <- gap.inspect(pdbs$resno)
  gaps.pos <- gap.inspect(pdbs$xyz)

  ## check for missing masses before we start calculating
  if(any(pdbs$ali=="X") & mass==TRUE) {
    resnames <- c(bio3d::aa.table$aa3, names(am.args$mass.custom))

    ops.inds <- which(pdbs$ali=="X", arr.ind=TRUE)
    unknowns <- c()

    for(i in 1:nrow(ops.inds)) {
      j <- ops.inds[i, ]

      resid <- pdbs$resid[j[1], j[2]]
      if(any(!(resid %in% resnames)))
        unknowns <- c(unknowns, resid[!resid%in%resnames])
    }

    if(length(unknowns)>0) {
      options(warn=prev.warn)
      unknowns <- paste(unique(unknowns), collapse=", ")
      stop(paste0("Unknown mass for amino acid(s): ", unknowns,
                  "\n  Provide mass with argument 'mass.custom=list(", unknowns[1], "=100.00)',",
                  "\n  or ommit mass weighting with argument 'mass=FALSE'."))
    }
  }

  ## Check connectivity
  con <- inspect.connectivity(pdbs, cut=4.05)
  if(!all(con)) {
    warning(paste(paste(basename(pdbs$id[which(!con)]), collapse=", "),
                  "might have missing residue(s) in structure:\n",
                  "  Fluctuations at neighboring positions may be affected."))
  }

  ## Use for later indexing
  pdbs$inds <- matrix(NA, ncol=ncol(pdbs$resno), nrow=nrow(pdbs$resno))

  ## Number of modes to store in U.subspace
  if(is.null(subspace)) {
    keep <- length(gaps.pos$f.inds)-6
  }
  else {
    keep <- subspace
    if (length(gaps.pos$f.inds) < (keep+6))
      keep <- length(gaps.pos$f.inds)-6
  }

  ## Coordiantes - fit or not
  if(fit) {
    xyz <- fit.xyz(fixed = pdbs$xyz[1, ], mobile = pdbs,
                   fixed.inds = gaps.pos$f.inds, mobile.inds = gaps.pos$f.inds,
                   ncore = ncore)
  }
  else
    xyz <- pdbs$xyz

  ## Fluctuations for each structure
  if(rm.gaps)
    flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=length(gaps.res$f.inds))
  else
    flucts <- matrix(NA, nrow=nrow(gaps.res$bin), ncol=ncol(gaps.res$bin))

  ## store residue numbers (same as pdbs$inds[,gaps$f.inds])
  ##resnos <- flucts

  ## List object to store each modes object
  if(full)
    all.modes <- list()
  else
    all.modes <- NULL

  ## 3D array- containing the modes vectors for each structure
  if(rm.gaps)
    modes.array <- array(NA, dim=c(length(gaps.pos$f.inds), keep, nrow(gaps.res$bin)))
  else
    modes.array <- array(NA, dim=c(ncol(pdbs$xyz), keep, nrow(gaps.res$bin)))

  ## store eigenvalues of the first modes
  L.mat <- matrix(NA, ncol=keep, nrow=nrow(gaps.res$bin))

  if(is.null(outpath))
    fname <- tempfile(fileext = "pdb")


  ##### Start calculation of variance weighting  #####
  wts <- NULL
  if(is.logical(varweight)) {
    if(varweight)
      wts <- var.xyz(xyz, weights=TRUE)
  }
  else {
    dims.vw <- dim(varweight)
    if(all(dims==ncol(xyz)/3)) {
      wts <- varweight
      varweight <- TRUE
    }
    else
      stop("incompatible length of varweight vector")
  }

  ### Memory usage ###
  dims <- dim(modes.array)
  mem.usage <- sum(c(as.numeric(object.size(modes.array)),
                     as.numeric(object.size(L.mat)),
                     as.numeric(object.size(flucts)),
                     as.numeric(object.size(matrix(NA, ncol=dims[3], nrow=dims[3]))) ))*2

  if(full) {
    if(is.null(nm.keep))
      tmpncol <- dims[2]
    else
      tmpncol <- nm.keep

    size.mat <- object.size(matrix(0.00000001, ncol=tmpncol, nrow=dims[1]))
    size.vec <- object.size(vector(length=dims[1], 'numeric'))

    tot.size <- ((size.mat * 2) + (size.vec * 4)) * length(pdbs$id)
    mem.usage <- mem.usage+tot.size
  }
  mem.usage=round(mem.usage/1048600,1)


  #### Print overview of scheduled calcualtion ####
  cat("\nDetails of Scheduled Calculation:\n")
  cat(paste("  ...", length(pdbs$id), "input structures", "\n"))
  if(keep>0)
    cat(paste("  ...", "storing", keep, "eigenvectors for each structure", "\n"))
  if(keep>0)
    cat(paste("  ...", "dimension of x$U.subspace: (",
              paste(dims[1], dims[2], dims[3], sep="x"), ")\n"))

  if(fit)
    cat(paste("  ...", "coordinate superposition prior to NM calculation", "\n"))

  if(varweight)
    cat(paste("  ...", "weighting force constants based on structural variance", "\n"))

  if(full)
    cat(paste("  ... individual complete 'nma' objects will be stored", "\n"))

  if(rm.gaps)
    cat(paste("  ... aligned eigenvectors (gap containing positions removed) ", "\n"))

  if(mem.usage>0)
    cat(paste("  ...", "estimated memory usage of final 'eNMA' object:", mem.usage, "Mb \n"))

  cat("\n")


  ##### Start modes calculation #####
  pb <- txtProgressBar(min=0, max=length(pdbs$id), style=3)

  ## shared memory to follow progress bar
  if(ncore>1)
    iipb <- bigmemory::big.matrix(1, length(pdbs$id), init=NA)


  ## call .calcAlnModes for each structure in 'pdbs'
  alnModes <- mylapply(1:length(pdbs$id), .calcAlnModes,
                       pdbs, xyz, gaps.res,
                       mass, am.args, nm.keep, temp, keep, wts,
                       rm.gaps, full,
                       pfc.fun, ff, ff.args, outpath, pb, ncore, env=environment(),
                       ## edit for shiny version  
                       progress=progress)
                       ## edit end
  close(pb)

  ##### Collect data #####
  for(i in 1:length(alnModes)) {
    tmp.modes <- alnModes[[i]]

    modes.array[,,i] = tmp.modes$U
    L.mat[i, ]       = tmp.modes$L
    flucts[i, ]      = tmp.modes$flucts

    if(full)
      all.modes[[i]] = tmp.modes$modes
  }

  remove(alnModes)
  invisible(gc())

  ##### RMSIP ######
  rmsip.map <- NULL
  if(rm.gaps) {
    rmsip.map <- .calcRMSIP(modes.array, ncore=ncore)
    rownames(rmsip.map) <- basename(rownames(pdbs$xyz))
    colnames(rmsip.map) <- basename(rownames(pdbs$xyz))

    if(!fit)
      warning("rmsip calculated on non-fitted structures:
               ensure that your input coordinates are pre-fitted.")
  }

  if(ncore>1) {
#    rm(iipb, pos = ".GlobalEnv")  ## remove global iipb variable
    options(warn=prev.warn)       ## restore warning option
  }

  rownames(flucts) <- basename(rownames(pdbs$xyz))
  out <- list(fluctuations=flucts, rmsip=rmsip.map,
              U.subspace=modes.array, L=L.mat, full.nma=all.modes,
              xyz=xyz, call=cl)
  class(out) = "enma"
  return(out)
}

.calcRMSIP <- function(x, ncore=1) {
  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply

  n <- dim(x)[3]
  mat <- matrix(NA, n, n)
  inds <- rbind(pairwise(n),
                matrix(rep(1:n,each=2), ncol=2, byrow=T))

  mylist <- mylapply(1:nrow(inds), function(row) {
    return(list(
      rmsip=rmsip(x[,,inds[row,1]], x[,,inds[row,2]])$rmsip,
      i=inds[row,1], j=inds[row,2])
           )
  })

  for ( i in 1:length(mylist)) {
    tmp.rmsip <- mylist[[i]]
    mat[tmp.rmsip$i, tmp.rmsip$j] <- tmp.rmsip$rmsip
  }

  mat[ inds[,c(2,1)] ] = mat[ inds ]
  return(round(mat, 4))
}


## Calculate 'aligned' normal modes of structure i in pdbs
.calcAlnModes <- function(i, pdbs, xyz, gaps.res,
                          mass, am.args, nm.keep, temp, keep, wts,
                          rm.gaps, full,
                          pfc.fun, ff, ff.args, outpath, pb, ncore, env=NULL,
                          ## edit for shiny version
                          progress=NULL) {
                          ## edit end

  ## Set indices for this structure only
  f.inds <- NULL
  f.inds$res <- which(gaps.res$bin[i,]==0)
  f.inds$pos <- atom2xyz(f.inds$res)

  ## similar to $resno but sequential indices
  pdbs$inds[i, f.inds$res] <- seq(1, length(f.inds$res))

  ## Indices to extract from Hessian
  inds.inc <- pdbs$inds[i, gaps.res$f.inds]
  inds.exc <- pdbs$inds[i, gaps.res$t.inds][ !is.na(pdbs$inds[i, gaps.res$t.inds]) ]

  inds.inc.xyz <- atom2xyz(inds.inc)
  inds.exc.xyz <- atom2xyz(inds.exc)

  ## Generate content of PDB object
  tmp.xyz <- xyz[i, f.inds$pos]
  resno   <- pdbs$resno[i,f.inds$res]
  chain   <- pdbs$chain[i,f.inds$res]

  ## Fix for missing chain IDs
  chain[is.na(chain)] <- ""

  ## 3-letter AA code is provided in the pdbs object
  ## avoid using aa123() here (translates TPO to THR)
  resid <- pdbs$resid[i,f.inds$res]
  sequ  <- resid

  ## Build a dummy PDB to use with function nma.pdb()
  pdb.in <- as.pdb.default(xyz=tmp.xyz, elety="CA",
                           resno=resno, chain=chain, resid=resid, verbose=FALSE)

  if(!is.null(outpath)) {
    fname <- file.path(outpath, basename(pdbs$id[i]))
    write.pdb(pdb.in, file=fname)
  }

  if(mass) {
    masses <- try(
      do.call('aa2mass', c(list(pdb=sequ, inds=NULL), am.args)),
      silent=TRUE
      )

    if(inherits(masses, "try-error")) {
      hmm <- attr(masses,"condition")
      cat("\n\n")
      stop(paste(hmm$message, "in file", basename(pdbs$id[i])))
    }
    masses.in <- masses
    masses.out <- masses
  }
  else {
    masses.in <- NULL
    masses.out <- NULL
  }

  natoms.in <- nrow(pdb.in$atom)
  natoms.out <- natoms.in

  if(rm.gaps) {
    ## Second PDB - containing only the aligned atoms
    sele <- list(atom=inds.inc, xyz=inds.inc.xyz)
    class(sele) <- "select"

    pdb.out <- trim.pdb(pdb.in, sele)
    natoms.out <- nrow(pdb.out$atom)

    if(mass)
      masses.out <- masses.in[ inds.inc ]

    inc.inds <- list(xyz=inds.inc.xyz)
}
  else {
    pdb.out <- pdb.in
    inc.inds <- NULL
}

  ## Build full hessian
  bh.args <- c(list(fc.weights=wts[f.inds$res, f.inds$res]), ff.args)
  args <- list(bh.args=bh.args)

  invisible(capture.output( hessian <-
                           .nma.hess(pdb.in$xyz, pfc.fun=pfc.fun, pdb=pdb.in,
                                     args=args, hessian=NULL)))

  ## extract effective hessian
  invisible(capture.output( hessian <-
                           .nma.trim.hessian(hessian, inc.inds=inc.inds)))

  ## Mass-weight hessian
  if(!is.null(masses.out))
    invisible(capture.output( hessian <-
                             .nma.mwhessian(hessian, masses=masses.out)))

  ## Diagonalize
  invisible(capture.output( ei <- .nma.diag(hessian) ))

  ## Build an NMA object
  invisible(capture.output( modes <-
                           .nma.finalize(ei, xyz=pdb.out$xyz, temp=temp,
                                         masses=masses.out,
                                         natoms=natoms.out, keep=nm.keep, call=NULL) ))

  if(rm.gaps)
    modes.mat <- matrix(NA, ncol=keep, nrow=nrow(modes$U))
  else
    modes.mat <- matrix(NA, ncol=keep, nrow=ncol(pdbs$xyz))

  j <- 1
  for(k in 7:(keep+6)) {
    if(rm.gaps)
      modes.mat[, j] <- modes$U[,k]
    else
      modes.mat[f.inds$pos, j] <- modes$U[,k]
    j <- j+1
  }

  if(rm.gaps) {
    flucts <- modes$fluctuations
  }
  else {
    flucts <- rep(NA, length=ncol(pdbs$resno))
    flucts[f.inds$res] <- modes$fluctuations
  }

  ## Progress bar
  if(ncore>1) {
    iipb <- get("iipb", envir = env)
    iipb[1,i] <- 1
    j <- length(which(!is.na(bigmemory::as.matrix(iipb))))
  }
  else
    j <- i
  setTxtProgressBar(pb, j)

  ## edit for shiny version
  if(!is.null(progress)) {
    progress$inc(1/length(pdbs$id))
  }
  ## edit end
  
  L <- modes$L[seq(7, keep+6)]
  if(!full) {
    remove(modes)
    modes <- NULL
  }

  out <- list(modes=modes,
              U=modes.mat,
              L=L,
              flucts=flucts)
              ##f.inds=f.inds)

  invisible(gc())
  return(out)
}

"dccm.enma" <- function(x, ncore=NULL, na.rm=FALSE, ...) {
 
  enma <- x
  if(!inherits(enma, "enma"))
    stop("input should be an 'enma' object as obtained from 'nma.pdbs'")

  ## Parallelized by parallel package
  ncore <- setup.ncore(ncore, bigmem = FALSE)

  if(ncore>1)
    mylapply <- mclapply
  else
    mylapply <- lapply
  
  mass <- TRUE
  if(!is.null(enma$call$mass))
    mass <- enma$call$mass
  
  pi <- 3.14159265359
  dims <- dim(enma$U.subspace)
  if(is.null(enma$full.nma)) {
    if((dims[1]-6)>dims[2])
      warning(paste(dims[2], "modes used in the calculation of the DCCMs"))
  }
  
  myCalcDCCM <- function(i, enma, na.rm=FALSE, ...) {
    if(is.null(enma$full.nma)) {
      if(mass) {
        freqs <- sqrt(abs(enma$L[i,])) / (2 * pi)
        fcs <- NULL
      }
      else {
        freqs <- NULL
        fcs <- enma$L[i,]
      }

      if(na.rm) {
        inds <- which( !is.na(enma$U.subspace[,1,i]) )
        U <- enma$U.subspace[inds,,i]
      }
      else
        U <- enma$U.subspace[,,i]
      dummy.nma <- list(U=U,
                        L=enma$L[i,],
                        modes=NULL,
                        frequencies=freqs,
                        force.constants=fcs,
                        triv.modes=0,
                        natoms=nrow(U)/3)
                        ##natoms=nrow(enma$U.subspace[,,i])/3)
      class(dummy.nma) <- "nma"

      invisible(capture.output(
        cm.tmp <- dccm.nma(dummy.nma, ncore=1, ...) ))
    }
    else {
      invisible(capture.output(
        cm.tmp <- dccm.nma(enma$full.nma[[i]], ncore=1, ...) ))
    }

    .update.pb(pb)
    return(cm.tmp)
  }

  ## do the calc
  pb <- .init.pb(ncore, min=0, max=dims[3L])
  all.dccm <- mylapply(1:dims[3L], myCalcDCCM, enma, na.rm=na.rm, ...)
  .close.pb(pb)

  if(any(is.na(enma$U.subspace)))
    arr <- FALSE
  else
    arr <- TRUE
  
  if(arr) {
    ## convert to a 3d-array
    dccm.arr <- array(0, dim=c(dims[1L]/3, dims[1L]/3, dims[3L]))
  
    ## collect data
    for(i in 1:length(all.dccm)) {
      tmp.cm <- all.dccm[[i]]
      dccm.arr[,,i] <- tmp.cm
    }
  }
  
  if(arr) {
    avg <- apply(dccm.arr, 1:2, mean)
    class(avg) <- c("matrix", "dccm")
    out <- list(all.dccm=dccm.arr, avg.dccm=avg)
  }
  else {
    out <- list(all.dccm=all.dccm, avg.dccm=NULL)
  }
  
  
  return(out)
}

"as.fasta" <- function(x, id=NULL, ...) {
  cl <- match.call()
  
  if(is.list(x)) {
    if(is.null(id))
      id <- x$id
    
    x <- x$ali
  }
  
  if(is.vector(x)) {
    if(any(nchar(x)>1))
      stop("provide a matrix/vector of one letter amino acid codes")
      ##x <- seqbind(lapply(lapply(x, strsplit, ""), unlist))

    x <- as.matrix(t(x))
  }
  
  if(is.matrix(x)) {
    if(is.null(id))
      id <- rownames(x)
    
    if(is.null(id))
      id <- paste("seq",1:nrow(x), sep="")
    
    if(any(id=="") | any(is.na(id))) {
      id[id==""] <- NA
      inds <- which(is.na(id))
      id[inds] <- paste("seq", inds, sep="")
    }
    
    if(nrow(x) != length(id))
      stop("length of 'id' does not match number of rows in alignment")
    
    rownames(x) <- id
  }

  else {
    stop("provide a sequence character matrix/vector")
  }
  
  out <- list(id=id, ali=x, call=cl)
  class(out) <- "fasta"
  return(out)
  
}

"aa123" <-
function (aa) {
  if(any(nchar(aa)!=1))
    stop("Provide a character vector of individual 1-letter aminoacid codes")
  
  # convert one-letter IUPAC amino-acid code into
  # three-letter PDB style, for instance "A" into "ALA".
  
  aa1 <- c("-","X",
           "A","C","D","E","F","G",
           "H","I","K","L","M","N","P","Q",
           "R","S","T","V","W","Y")
  aa3 <- c("---","UNK",
           "ALA", "CYS", "ASP", "GLU", "PHE", "GLY",
           "HIS", "ILE", "LYS", "LEU", "MET", "ASN", "PRO", "GLN",
           "ARG", "SER", "THR", "VAL", "TRP", "TYR")

  convert <- function(x) {
    if(is.na(x)) return(NA)
    if (all(x != aa1)) {
      warning("Unknown one letter code for aminoacid")
      return("UNK")
    }
    else {
      return(aa3[which(x == aa1)])
    }
  }
  return(as.vector(unlist(sapply(aa, convert))))
}

"print.enma" <-
  function(x, ...) {

    cn      <- class(x)
    nstruct <- nrow(x$fluctuations)
    dims    <- dim(x$U.subspace)

    if(is.null(x$call$rm.gaps))
      rm.gaps <- TRUE
    else if(x$call$rm.gaps=="T" || x$call$rm.gaps=="TRUE")
      rm.gaps <- TRUE
    else
      rm.gaps <- FALSE
    
    if(is.null(x$call$fit))
      fit <- TRUE
    else if(x$call$fit=="T" || x$call$fit=="TRUE")
      fit <- TRUE
    else
      fit <- FALSE


    
    cat("\nCall:\n  ", paste(deparse(x$call), sep = "\n", collapse = "\n"),
        "\n\n", sep = "")
    
    cat("Class:\n  ", cn,
        "\n\n", sep = "")
    
    cat("Number of structures:\n  ", nstruct,
        "\n\n", sep="")

    cat("Attributes stored:\n")
    
    if(!is.null(x$full.nma))
      cat("  - Full 'nma' objects\n")
    if(!is.null(x$rmsip))
      cat("  - Root mean square inner product (RMSIP)\n")
    if(!is.null(x$fluctuations))
      cat("  - Aligned atomic fluctuations\n")
    
    if(rm.gaps)
      cat("  - Aligned eigenvectors (gaps removed)\n")
    else
      cat("  - Aligned eigenvectors (gaps not removed)\n")
    
    cat("  - Dimensions of x$U.subspace: ", dims[1L], "x", dims[2L], "x", dims[3L], sep="")

    cat("\n\n")

    if(fit)
      cat("Coordinates were aligned prior to NMA calculations")
    else
      cat("Coordinates were NOT aligned prior to NMA calculations")
    
    cat("\n\n")

  i <- paste( attributes(x)$names, collapse=", ")
  cat(strwrap(paste(" + attr:",i,"\n"),width=60, exdent=8), sep="\n")

    invisible(x)
  }

write.mol2 <- function(mol, file="R.mol2", append=FALSE) {

    if(!is.mol2(mol))
        stop("input should be of class 'mol2' as obtained by 'read.mol2'")

    if(any(is.na(mol$atom))) {
        mol$atom[ is.na(mol$atom) ] = ""
    }
    if(!is.null(mol$bond)) {
        if(any(is.na(mol$bond)))
            mol$bond[ is.na(mol$bond) ] = ""
    }
    if(!is.null(mol$substructure)) {
        if(any(is.na(mol$substructure)))
            mol$substructure[ is.na(mol$substructure) ] = ""
    }
  
    raw.lines <- c()
    
    raw.lines <- c(raw.lines, "@<TRIPOS>MOLECULE")
    raw.lines <- c(raw.lines, mol$name)

    if(length(mol$info) < 5) mol$info <- c(mol$info, rep(NA, 5-length(mol$info)))
    mol$info[is.na(mol$info)] = ""
    fmt <- paste(rep("%7s", length(mol$info)), collapse=" ")
    raw.lines <- c(raw.lines,
                   sprintf(fmt, mol$info[1], mol$info[2], mol$info[3], mol$info[4], mol$info[5])
                   )
    
    
    raw.lines <- c(raw.lines, "@<TRIPOS>ATOM")
    fmt <- "%7s %-8s %9.4f %9.4f %9.4f %-5s %5s %-9s %8.4f "
    for ( i in 1:nrow(mol$atom) ) {
        raw.lines <- c(raw.lines,
                       paste0(
                           sprintf(fmt, mol$atom[i, 1], mol$atom[i, 2],
                                   mol$atom[i, 3], mol$atom[i, 4],
                                   mol$atom[i, 5], mol$atom[i, 6],
                                   mol$atom[i, 7], mol$atom[i, 8],
                                   mol$atom[i, 9] 
                                   ),  mol$atom[i, 10])
                       )
    }

    if(!is.null(mol$bond)) {
        raw.lines <- c(raw.lines, "@<TRIPOS>BOND")
        fmt <- "%7s %5s %5s %-5s "
        for ( i in 1:nrow(mol$bond) ) {
            raw.lines <- c(raw.lines, 
                           paste0(
                               sprintf(fmt,
                                       mol$bond[i, 1], mol$bond[i, 2],
                                       mol$bond[i, 3], mol$bond[i, 4]
                                       ), mol$bond[i, 5])
                           )
        }
    }

    if(!is.null(mol$substructure)) {
        raw.lines <- c(raw.lines, "@<TRIPOS>SUBSTRUCTURE")
        fmt <- "%7s %-8s %-10s %8s %4s %-6s %4s %4s "
        for ( i in 1:nrow(mol$substructure) ) {
            raw.lines <- c(raw.lines, 
                           paste0(
                               sprintf(fmt,
                                       mol$substructure[i, 1], mol$substructure[i, 2],
                                       mol$substructure[i, 3], mol$substructure[i, 4],
                                       mol$substructure[i, 5], mol$substructure[i, 6],
                                   mol$substructure[i, 7], mol$substructure[i, 8]
                                   ), mol$substructure[i, 9])
                           )
        }
    }
     
    
    write.table(raw.lines, file = file, quote = FALSE, na="",
                row.names = FALSE, col.names = FALSE, append = append)
    

}

"pdb2aln.ind" <-
function(aln, pdb, inds = NULL, ...) {

   # get the new alignment; also check arguments internally
   naln <- pdb2aln(aln=aln, pdb=pdb, ...)

   if(is.null(inds)) 
      inds <- gap.inspect(aln$ali)$f.inds

   ninds <- which(naln$ref["ali.pos",] %in% inds)
   ca.inds <- naln$ref["ca.inds", ninds]

   if(any(is.na(ca.inds))) {
      warning("Gaps are found in equivalent positions in PDB")
   }

   inds.a = inds[!is.na(ca.inds)]
   inds.b = ca.inds[!is.na(ca.inds)]

   a = list(atom=inds.a, xyz=atom2xyz(inds.a)) 
   class(a) = "select"  
   b = list(atom=inds.b, xyz=atom2xyz(inds.b)) 
   class(b) = "select"  

   out = list(a = a, b = b)

   return(out)
}

plot.ecna <- function(x, ...) {

   if(!inherits(x, "ecna")) {
      stop("The input 'x' must be an object of class 'ecna'.")
   }
   n <- length(x)
   if(n == 1) {
      return( plot(x[[1]], ...) )
   }
   if(n > 9) {
      stop("Plotting for more than 9 networks is not supported.")
   }

   opar <- par(no.readonly = TRUE)
   on.exit(par(opar))
  
   if(n<=6) {
      # N x 2
      nr <- floor( (n-1) / 2 ) + 1
      layout(matrix(1:(nr*2), ncol=2, byrow=TRUE), respect = TRUE)
   }
   else {
      # 3 x 3
      layout(matrix(1:9, ncol=3, byrow=TRUE), respect = TRUE)    
   }

   par(mar=c(0,0,2,0))
   invisible( 
    sapply(1:n, function(i) {
      x <- x[[i]]
      arg.default <- list(main=paste("Network", i))
      arg <- .arg.filter(arg.default, FUN=NULL, ...)
      do.call("plot", c(list(x=x), arg))
    })
   )
}

plot.cna <- function(x, pdb=NULL, weights=NULL, vertex.size=NULL,
                     layout=NULL, col=NULL, full=FALSE, scale = TRUE, 
                     color.edge = FALSE, interactive = FALSE, ...) {

  ##- Function for plotting cna networks the way we like them.
  ##   Returns the plot layout coordinates silently. These can 
  ##   be passed to identify.cna() 
  ##
  ##- Examples:
  ##   plot.cna(net)
  ##   plot.cna(net, pdb)
  ##   plot.cna(net, layout=layout.cna(net,pdb))
  ##   plot.cna(net, layout=layout.cna(net,pdb, full=TRUE), full=TRUE)
  ##   plot.cna(net, full=T, layout=layout.cna(net,pdb, full=T), vertex.size=3, weights=1, vertex.label=NA)
  ##
  ##- Other options:
  ##   \dots can contain all ?igraph.plotting options, including:
  ##   col=vmd_colors(),
  ##   mark.groups=list() - A list of vertex id vectors 
  ##   mark.col=vmd_colors(alpha=0.3),
  ##   mark.border=vmd_colors()
  ##     etc... see ?plot.igraph
  ##  AND
  ##   vertex.size:  Node sizes:   V(x$network)$size
  ##   vertex.color: Node colors:  V(x$network)$color
  ##   vertex.label: Node labels:  V(x$network)$name - use NA to omit
  ##   edge.width:   Edge weights: E(x$network)$weight
  ##   edge.color:   Edge colors:  E(x$network)$color
  ##    (also vertex.label.color, vertex.label.cex etc.
  ##     see ?igraph.plotting)
  ##   

  ## Check for presence of igraph package
  oops <- requireNamespace("igraph", quietly = TRUE)
  if (!oops) {
     stop("igraph package missing: Please install, see: ?install.packages")
  }
  
#  if(color.edge) {
#     oops <- require(classInt)
#     if (!oops) {
#        warning("package classInt missing: color.edge is set to FALSE.
#            To make color.edge work, please install the missing package. See: ?install.packages")
#        color.edge = FALSE
#     }    
#  }

  ##- Determine which network to plot along with node size
  if(full) {
    ## Plot the 'full' all-atom network
    y <- x$network 

    if(is.null(vertex.size)) {
      ## Scale up the node size to something visible
      if(max(igraph::V(y)$size) < 10) {
        igraph::V(y)$size = igraph::V(y)$size + 13
      }
    }
  } else {
    ## Plot the 'coarse-grained' community network
    y <- x$community.network
    ## here we will leave the node size as is
  }

 
  ##- Determine edge weights and scale values for plotting
  if(is.null(weights)){
    ## Use weights defined in network
    weights <- igraph::E(y)$weight
    
    if(is.null(x$call$minus.log)){  
      ## If '$call$mins.log' is NULL => -log option was used in cna()
      ##  so we we will revert back with exponential here
      weights <- exp(-weights)
    } else{
      if(x$call$minus.log){
        ## Again here we have 'minus.log=TRUE'
        weights <- exp(-weights)
      }
    }
    ## Lets scale the weights to lie between 1 and 5
#    weights <- (weights - min(weights)) / max(weights - min(weights)) * (1 - 5) + 5
    if(scale && (length(weights)>1)) weights <- (weights - min(weights)) / max(weights - min(weights)) * 4 + 1
    else weights <- 10 * weights
  }
  
  ##- Obtain the plot layout coords
  if(!is.null(pdb) && is.null(layout)) {
    cat("Obtaining layout from PDB structure\n")
    layout = layout.cna(x, pdb, full=full)
  }
  if(is.null(pdb) && is.null(layout)) {
    cat("Obtaining estimated layout with fruchterman.reingold\n")
    layout <- igraph::layout.fruchterman.reingold(y, weights=weights)
  }
  if(dim(layout)[2] != 2){
    stop("Input 'layout' must be an Nx2 matrix, where N is the number of communities")
  }
  
  if(color.edge) {

#     vec2color <- function(vec, pal=c("blue", "green", "red"), n=10) {
#        ##-- Define a color scale from a numeric vector
#        return( findColours(classIntervals(vec, n=n, style="equal"), pal) )
#     }
     vec2color <- function(vec, pal=c("blue", "green", "red"), n=30) {
        col <- colorRampPalette(pal)(n)
        vec.cut <- cut(vec, seq(min(vec), max(vec), length.out=n), include.lowest = TRUE)
        levels(vec.cut) <- 1:length(col)
        return( col[vec.cut] )
     }

     colors <- vec2color(weights)
     if(interactive) 
        igraph::tkplot(y, edge.width=weights, edge.color = colors, layout=layout, 
                          vertex.color=col, vertex.size=vertex.size, ...)
     else 
        igraph::plot.igraph(y, edge.width=weights, edge.color = colors, layout=layout, 
                          vertex.color=col, vertex.size=vertex.size, ...)

  } else { 
     if(interactive)
        igraph::tkplot(y, edge.width=weights, layout=layout, vertex.color=col, 
                       vertex.size=vertex.size, ...)
     else 
        igraph::plot.igraph(y, edge.width=weights, layout=layout, vertex.color=col, 
                       vertex.size=vertex.size, ...)

  }
  
  ## Silently return plot coordinates
  #class(layout) = "cna"
  layout <- layout
}

"plot.pca.score" <-
function(x, inds=NULL, col=rainbow(nrow(x)), lab="", ... ) {

  # Produces a z-score plot for PC1 vs PC2,
  # PC3 vs PC2 and PC1 vs PC3 if given a
  # matrix "z"that contains the column wise
  # scores obtained from PCA 'pca.xyz'

  if(is.list(x))  x=x$z # output from pca.xyz()
  if(is.null(inds)) inds <- 1:nrow(x)
  
  op <- par(no.readonly=TRUE)
  on.exit(par(op))
  
  par(mfrow=c(2,2));par(pty="s")
  limits<-max(abs(c(range(x[,1]),range(x[,2]),range(x[,3]))))
  print(paste("axes limits: ",round(limits,2),sep=""))

  text.offset<-limits/19

  plot(x[,1], x[,2],  # pc1 vs pc2
       xlim=c(-limits,limits),
       ylim=c(-limits,limits),
       xlab="PC1", ylab="PC2",col=col, ...)  
  abline(h=0,col="gray",lty=2);abline(v=0,col="gray",lty=2)
  text(x[inds,1]+text.offset,
       x[inds,2]+text.offset,
       labels = lab[inds])

  plot(x[,3], x[,2],  # pc3 vs pc3
       xlim=c(-limits,limits),
       ylim=c(-limits,limits),
       xlab="PC3", ylab="PC2", col=col, ...)
  abline(h=0,col="gray",lty=2);abline(v=0,col="gray",lty=2)
  text(x[inds,3]+text.offset,
       x[inds,2]+text.offset,
       labels = lab[inds])

  plot(x[,1], x[,3],  # pc1 vs pc3
       xlim=c(-limits,limits),
       ylim=c(-limits,limits),
       xlab="PC1", ylab="PC3",col=col, ...)
  abline(h=0,col="gray",lty=2);abline(v=0,col="gray",lty=2)
  text(x[inds,1]+text.offset,
       x[inds,3]+text.offset,
       labels = lab[inds])

}

## NOTE:
##   We do not support old-version DSSP any longer
##   Please update your DSSP program to the newest version
"dssp.pdb" <-
  function (pdb, exefile = "dssp", resno=TRUE, full=FALSE, verbose=FALSE, ...) {

    ## Log the call
      cl <- match.call()

      ## determine path to exefile
      os1 <- Sys.info()["sysname"]
      exefile <- .get.exepath(exefile)
      message(exefile)
      success <- .test.exefile(exefile)
      
      if(!success) {
          stop(paste("Launching external program 'dssp' (or 'mkdssp') failed\n",
                     "  make sure '", exefile, "' is in your search path", sep=""))
      }

    ## check atom composition - need backbone atoms to continue SSE analysis
    checkatoms <- TRUE
    if(checkatoms) {

      ## check on backbone atoms
      inds <- atom.select(pdb, "backbone", verbose=verbose)
      tmp <- trim.pdb(pdb, inds)
      
      resid <- paste(tmp$atom$resno, tmp$atom$chain, sep="-")
      musthave <- c("C", "CA", "N", "O")

      incomplete <- sapply(unique(resid), function(x) {
        inds <- which(resid==x)
        elety <- sort(tmp$atom$elety[inds])
        if(!all(musthave %in% elety))
          return(TRUE)
        else
          return(FALSE)
      })

      if(all(incomplete))
        stop("No residues found with a complete set of backbone atoms")
      if(any(incomplete))
        warning(paste("Residues with missing backbone atoms detected:",
                      paste(unique(resid)[incomplete], collapse=", "), 
                      collapse=" "))

      ## check for non-protein atoms
      inds <- atom.select(pdb, "protein", verbose=verbose, inverse=TRUE)
      if(length(inds$atom) > 0)
          warning(paste("Non-protein residues detected in input PDB:",
                        paste(unique(pdb$atom$resid[ inds$atom ]), collapse=", ")))
 
    }
    
    infile <- tempfile()
    outfile <- tempfile()
    write.pdb(pdb, file = infile)
    cmd <- paste(exefile, infile, outfile)

    if(verbose)
      cat(paste("Running command:\n ", cmd , "\n"))
    
      if(os1 == "Windows") {
          status <- shell(paste(shQuote(exefile), infile, outfile),
                          ignore.stderr = !verbose, ignore.stdout = !verbose)
      }
      else  {
          status <- system(cmd,
                           ignore.stderr = !verbose, ignore.stdout = !verbose)
      }
          
    if(!(status %in% c(0,1))) {
      stop(paste("An error occurred while running command\n '",
                 cmd, "'", sep=""))
    }

    
##
## For Debug (Tue Aug  3 18:22:11 PDT 2010)
##  -- Following multi chain error report from Heiko Strathmann
##    outfile <- "2jk2.dssp"
##    outfile <- "4q21.dssp"
##
    trim <- function(s) {
      s <- sub("^ +", "", s)
      s <- sub(" +$", "", s)
      s[(s == "")] <- NA
      s
    }

    split.line <- function(x, split=" ") {
      tmp <- unlist(strsplit(x, split=split))
      inds <- which(tmp!="")
      return(trim(tmp[inds]))
    }

      raw.lines <- readLines(outfile)
    unlink(c(infile, outfile))
    type <- substring(raw.lines, 1, 3)
    raw.lines <- raw.lines[-(1:which(type == "  #"))]

    ## delete chain breaking lines
    aa <- substring(raw.lines, 14, 14)
    if(any(aa == "!"))
       raw.lines <- raw.lines[-which(aa == "!")]

    cha      <- substring(raw.lines, 12, 12)
    sse      <- substring(raw.lines, 17, 17)
    res.name <- substring(raw.lines, 14, 14)
    
    res.id  <- as.numeric(substring(raw.lines, 1, 5))   ## dssp residue IDs
    res.num <- as.numeric(substring(raw.lines, 6, 10))  ## Residue numbers
    res.insert <- substring(raw.lines, 11, 11)          ## Insertion codes
    res.ind <- 1:length(res.num)                        ## Internal indices

    ## names for output sse vector
    ins <- trim(res.insert)
    ins[ ins=="" ] = NA
    names(sse) <- paste(res.num, cha, ins, sep="_")
      
    if(any(res.insert!=" ")) {
       if(resno) {
         warning("Insertions are found in PDB: Residue numbers may be incorrect.
                Try again with resno=FALSE")
       }
       else { 
         ii <- diff(res.num)
         ii[ii==0] <- 1     #Consecutive numbers at insertion residues
         ii[ii<0] <- 2      #Jumps at possible chain termination
         res.num <- res.num[1] + c(0, cumsum(ii))
       }
    }
    
    if(full) {
      ## Difference between sse res id and internal res indices
      diff        <- res.id - res.ind
      names(diff) <- res.id

      ## Beta bridge partner residue ids
      bp1         <- as.numeric(substring(raw.lines, 26, 29))
      bp2         <- as.numeric(substring(raw.lines, 30, 33))
      bp1[bp1==0] <- NA
      bp2[bp2==0] <- NA

      ## Convert from dssp SSE residue IDs to internal residue indices
      bp1[ !is.na(bp1) ] <- as.vector(bp1[ !is.na(bp1) ] - diff[as.character(bp1[!is.na(bp1)])])
      bp2[ !is.na(bp2) ] <- as.vector(bp2[ !is.na(bp2) ] - diff[as.character(bp2[!is.na(bp2)])])

      ## H-bond records
      hbonds <- split.line(split.line(substring(raw.lines, 40, 83), split=","), split=" ")
      hbonds <- matrix(as.numeric(hbonds), ncol=8, byrow=TRUE)
      hbonds <- as.data.frame(hbonds)
      
      for(i in seq(1,7,by=2)) {
        hbonds[[i]][ which(hbonds[[i]]==0) ] <- NA
        
        ## Convert from relative to absolute residue numbering
        hmm <- res.id + hbonds[[i]]
        
        ## Convert from dssp SSE residue IDs to internal residue indices
        hbonds[[i]][ !is.na(hmm) ] <- as.vector(hmm[ !is.na(hmm) ] -
                                           diff[as.character(hmm[!is.na(hmm)])])
      }
      
      ## Bind bridge pair and H-bond records to one matrix
      hbonds <- cbind(bp1, bp2, hbonds)
      cnames <- c("BP1", "BP2", "NH-O.1", "E1", "O-HN.1", "E2", "NH-O.2", "E3", "O-HN.2", "E4")
      colnames(hbonds) <- cnames

      if(resno) {
        ## 2 col matrix mapping the res.ind's to res.num and chain id
        tmp.map            <- cbind(res.num, cha)
        row.names(tmp.map) <- res.ind

        ## Add an additional matrix holding the Chain IDs
        hbonds           <- cbind(hbonds, data.frame(matrix(NA, ncol=6, nrow=nrow(tmp.map)),
                                                     stringsAsFactors=FALSE))
                                                     
        colnames(hbonds) <- c(cnames,
                              "ChainBP1", "ChainBP2", "Chain1", "Chain2", "Chain3", "Chain4")

        ## Add chain IDs for each entry
        tmp.inds                    <- which(!is.na(hbonds[,"BP1"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"BP1"])
        hbonds[tmp.inds,"BP1"]      <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"ChainBP1"] <- tmp.map[tmp.names, "cha"]

        tmp.inds                    <- which(!is.na(hbonds[,"BP2"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"BP2"])
        hbonds[tmp.inds,"BP2"]      <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"ChainBP2"] <- tmp.map[tmp.names, "cha"]

        tmp.inds                    <- which(!is.na(hbonds[,"NH-O.1"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"NH-O.1"])
        hbonds[tmp.inds,"NH-O.1"]   <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"Chain1"]   <- tmp.map[tmp.names, "cha"]

        tmp.inds                    <- which(!is.na(hbonds[,"O-HN.1"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"O-HN.1"])
        hbonds[tmp.inds,"O-HN.1"]   <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"Chain2"]   <- tmp.map[tmp.names, "cha"]

        tmp.inds                    <- which(!is.na(hbonds[,"NH-O.2"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"NH-O.2"])
        hbonds[tmp.inds,"NH-O.2"]   <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"Chain3"]   <- tmp.map[tmp.names, "cha"]

        tmp.inds                    <- which(!is.na(hbonds[,"O-HN.2"]))
        tmp.names                   <- as.character(hbonds[tmp.inds,"O-HN.2"])
        hbonds[tmp.inds,"O-HN.2"]   <- as.numeric(tmp.map[tmp.names, "res.num"])
        hbonds[tmp.inds,"Chain4"]   <- tmp.map[tmp.names, "cha"]

        ## Set row names to "RESNUM-CHAINID"
        row.names(hbonds)           <- apply(tmp.map, 1, paste, collapse="-")
      }
    }
    else {
      hbonds <- NULL
    }

    # column numbers of phi and psi are different between
    # the old and new versions of DSSP
    phi <- as.numeric(substring(raw.lines, 104, 109))
    psi <- as.numeric(substring(raw.lines, 110, 115))
    acc <- as.numeric(substring(raw.lines, 35, 38))

    h.res <- bounds(res.num[which(sse == "H")], pre.sort=FALSE)
    g.res <- bounds(res.num[which(sse == "G")], pre.sort=FALSE)
    e.res <- bounds(res.num[which(sse == "E")], pre.sort=FALSE)
    t.res <- bounds(res.num[which(sse == "T")], pre.sort=FALSE)

    h.ind <- h.res;    g.ind <- g.res
    e.ind <- e.res;    t.ind <- t.res

    if(length(h.res) > 0) {
       res.ind <- which(sse == "H")
       h.ind[, "end"] <- res.ind[cumsum(h.res[, "length"])]
       h.ind[, "start"] <- h.ind[, "end"] - h.res[, "length"] + 1
    }

    if(length(g.res) > 0) {
       res.ind <- which(sse == "G")
       g.ind[, "end"] <- res.ind[cumsum(g.res[, "length"])]
       g.ind[, "start"] <- g.ind[, "end"] - g.res[, "length"] + 1
    }

    if(length(e.res) > 0) {
       res.ind <- which(sse == "E")
       e.ind[, "end"] <- res.ind[cumsum(e.res[, "length"])]
       e.ind[, "start"] <- e.ind[, "end"] - e.res[, "length"] + 1
    }

    if(length(t.res) > 0) {
       res.ind <- which(sse == "T")
       t.ind[, "end"] <- res.ind[cumsum(t.res[, "length"])]
       t.ind[, "start"] <- t.ind[, "end"] - t.res[, "length"] + 1
    }

    if(!resno) {
       h.res <- h.ind;    g.res <- g.ind
       e.res <- e.ind;    t.res <- t.ind
    }

    sheet = list(start=NULL, end=NULL, length=NULL, chain=NULL)
    helix = list(start=NULL, end=NULL, length=NULL, chain=NULL, type=NULL)
    turn = sheet

    ## ToDo: Add "type" for turns and strands too...

    if(length(h.res)>1) {
#      if(is.null(nrow(h.res)))
#        h.s <- as.matrix(t(h.res))
      helix$start  = c(helix$start,h.res[, "start"])
      helix$end    = c(helix$end, h.res[, "end"])
      helix$length = c(helix$length, h.res[, "length"])
      helix$chain  = c(helix$chain, cha[h.ind[, "start"]])
      helix$type   = c(helix$type, sse[h.ind[, "start"]])
    }
    if(length(g.res)>1) {
#      if(is.null(nrow(g.res)))
#        g.s <- as.matrix(t(g.res))
      helix$start  = c(helix$start,g.res[, "start"])
      helix$end    = c(helix$end, g.res[, "end"])
      helix$length = c(helix$length, g.res[, "length"])
      helix$chain  = c(helix$chain, cha[g.ind[, "start"]])
      helix$type   = c(helix$type, sse[g.ind[, "start"]])
    }
    if(length(helix$start) > 0)
       helix <- lapply(helix, function(x) {names(x) <- 1:length(helix$start); return(x)})
    if(length(e.res)>1) {
#      if(is.null(nrow(e.res)))
#        e.s <- as.matrix(t(e.res))
      sheet$start  = c(sheet$start,e.res[, "start"])
      sheet$end    = c(sheet$end, e.res[, "end"])
      sheet$length = c(sheet$length, e.res[, "length"])
      sheet$chain  = c(sheet$chain, cha[e.ind[, "start"]])
    }
    if(length(sheet$start) > 0)
       sheet <- lapply(sheet, function(x) {names(x) <- 1:length(sheet$start); return(x)})
    if(length(t.res)>1) {
#      if(is.null(nrow(t.res)))
#        t.s <- as.matrix(t(t.res))
      turn$start  = c(turn$start,t.res[, "start"])
      turn$end    = c(turn$end, t.res[, "end"])
      turn$length = c(turn$length, t.res[, "length"])
      turn$chain  = c(turn$chain, cha[t.ind[, "start"]])
    }
    if(length(turn$start) > 0)
       turn <- lapply(turn, function(x) {names(x) <- 1:length(turn$start); return(x)})

    out <- list(helix = helix, sheet = sheet, hbonds = hbonds,
                turn = turn, phi = phi, psi = psi, acc = acc,
                sse = sse, call=cl)

    class(out) <- "sse"
    return(out)
}

---
title: "bio3d Vignettes"
date: "Sep 22 2016"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{bio3d Vignettes}
  \usepackage[utf8]{inputenc}
---

We distribute a number of extended **Bio3D vignettes** that provide worked examples of using Bio3D to perform a particular type of structural bioinformatics analysis. An updated list of these can be found <a href="http://thegrantlab.org/bio3d/articles/">on-line</a>.

At the time of writing these include:

- [Installing Bio3D](http://thegrantlab.org/bio3d/articles/online/install_vignette/Bio3D_install.html)

- [Getting started with Bio3D](http://thegrantlab.org/bio3d/articles/online/intro_vignette/Bio3D_introduction.html)

- [PDB structure manipulation and analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/pdb_vignette/Bio3D_pdb.html)

- [Beginning trajectory analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/traj_vignette/Bio3D_md.html)

- [Enhanced methods for Normal Mode Analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/nma_vignette/Bio3D_nma.html)

- [Comparative sequence and structure analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/pca_vignette/Bio3D_pca.html)

- [Ensemble NMA of E.coli DHFR structures](http://thegrantlab.org/bio3d/articles/online/enma_vignettes/Bio3D_nma-dhfr-partI.html)

- [Ensemble NMA across multiple species of DHFR](http://thegrantlab.org/bio3d/articles/online/enma_vignettes/Bio3D_nma-dhfr-partII.html)

- [Protein structure network analysis with Bio3D](http://thegrantlab.org/bio3d/articles/online/cna_vignette/cna_vignette.spin.html)

- [Introduction to Ensemble Difference Distance Matrix (eDDM) Analysis](http://thegrantlab.org/bio3d/articles/online/eddm_vignette/Bio3D_eddm.spin.html)

- Online protein structure analysis with the Bio3D WebApp ( [PDF](http://thegrantlab.org/bio3d_v2/download/webapp-tutorials?download=22:bio3d-webapp-pca))

- Online Normal Mode Analysis with Bio3D WebApps ( PDF | HTML )

There is also extensive [on-line documentation](http://thegrantlab.org/bio3d/reference/) with worked examples (and their output) for all functions and a package manual (in [PDF](https://CRAN.R-project.org/package=bio3d/bio3d.pdf) format) that is a concatenation of each functions documentation (without example output).

Note that for information on Bio3D development status or to report a bug, please refer to: https://bitbucket.org/Grantlab/bio3d/

\name{plot.fluct}
\alias{plot.fluct}
\title{ Plot Fluctuations }
\description{
  Produces a plot of atomic fluctuations obtained from ensemble normal mode analysis or
  molecular dynamics simulations.
}
\usage{
\method{plot}{fluct}(x,
        col = NULL, label = rownames(x), signif = FALSE,
        p.cutoff = 0.005, q.cutoff = 0.04,
        s.cutoff = 5, n.cutoff = 2, mean = FALSE, polygon = FALSE,
        spread = FALSE, offset = 1,
        ncore = NULL, ...)
}
\arguments{
  \item{x}{ a numeric vector or matrix containing atomic fluctuation data obtained
    from e.g. \code{\link{nma.pdbs}} or \code{\link{rmsf}}. }
  \item{col}{ a character vector of plotting colors. Used also to group
    fluctuation profiles. NA values in col will omit the corresponding fluctuation
    profile in the plot. }
  \item{label}{ a character vector of plotting labels with length matching
    \code{nrow(x)}. If \code{mean=TRUE}, the length of \code{label} can be equal to
    the number of categories indicated by \code{col}. }
  \item{signif}{ logical, if TRUE significance of fluctuation difference is calculated
             and annotated for each atomic position. }
  \item{p.cutoff}{ Cutoff of p-value to define significance. }
  \item{q.cutoff}{ Cutoff of the mean fluctuation difference to define significance. }
  \item{s.cutoff}{ Cutoff of sample size in each group to calculate the significance. }
  \item{n.cutoff}{ Cutoff of consecutive residue positions with significant fluctuation
             difference. If the actual number is less than the cutoff,
             correponding postions will not be annotated. }
  \item{mean}{ logical, if TRUE plot mean fluctuations of each group. Significance is
             still calculated with the original data. }
  \item{polygon}{ logical, if TRUE a nicer plot with area under the line for the first
             row of \code{x} are filled with polygons. }
  \item{ncore }{ number of CPU cores used to do the calculation. By default
             (\code{ncore=NULL}), use all available CPU cores. The argument is only
             used when \code{signif=TRUE}. }
  \item{spread}{ logical, if TRUE the fluctuation profiles are spread -
    i.e. not on top of each other. }
  \item{offset}{ numerical offset value in use when
    \sQuote{spread=TRUE}. }
  \item{\dots}{ extra plotting arguments passed to \code{plot.bio3d}. }
}
\details{
  The significance calculation is performed when \code{signif=TRUE} and there are at least
  two groups with sample size larger than or equal to \code{s.cutoff}. A "two-sided"
  student's t-test is performed for each atomic position (each
  column of \code{x}).  If \code{x} contains gaps, indicated by \code{NA}s,
  only non-gapped positions are considered. The position is considered significant if both
  \code{p-value <= p.cutoff} and the mean value difference of the two groups, q, satisfies
  \code{q >= q.cutoff}. If more than two groups are available, every pair of groups are
  subjected to the t-test calculation and the minimal p-value along with the q-value
  for the corresponding pair are used for the significance evaluation.
}
\value{
  If significance is calculated, return a vector indicating significant positions.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao, Lars Skjaerven, Barry Grant }
\seealso{ \code{\link{plot.bio3d}}, \code{\link{rmsf}}, \code{\link{nma.pdbs}},
          \code{\link[stats:t.test]{t.test}}, \code{\link[graphics:polygon]{polygon}}. }
\examples{
\dontrun{
## load transducin example data
attach(transducin)

## subset of pdbs to analyze
inds = c(1:5, 16:20)
pdbs <- trim(pdbs, row.inds=inds)
gaps.res = gap.inspect(pdbs$ali)

## reference RESNO and SSE for axis annotations
resno <- pdbs$resno[1, gaps.res$f.inds]
sse <- pdbs$sse[1, gaps.res$f.inds]

## eNMA calculation and obtain modes of motion including atomic fluctuations
modes <- nma(pdbs, ncore=NULL)
x = modes$fluctuation

## simple line plot with SSE annotation
plot.fluct(x, sse=sse, resno=resno)

## group data by specifying colors of each fluctuation line; same color indicates
## same group. Also do significance calculation and annotation
col = c(rep('red', 5), rep('blue', 5))
plot.fluct(x, col=col, signif=TRUE, sse=sse, resno=resno)

## spread lines
plot.fluct(x, col=col, signif=TRUE, sse=sse, resno=resno, typ='l', spread=TRUE)

## show only line of mean values for each group. 
## Nicer plot with area shaded for the first group.
plot.fluct(x, col=col, signif=TRUE, sse=sse, resno=resno, mean=TRUE, 
           polygon=TRUE, label=c('GTP', 'GDI'))

detach(transducin)
}
}
\keyword{ hplot }

\name{plot.cmap}
\alias{plot.cmap}
\title{ Plot Contact Matrix }
\description{
  Plot a contact matrix with optional secondary structure in the
  marginal regions.
}
\usage{
\method{plot}{cmap}(x, col=2, pch=16, main="Contact map", sub="",
           xlim=NULL, ylim=NULL, xlab = "Residue index", ylab = xlab, 
           axes=TRUE, ann=par("ann"), sse=NULL, sse.type="classic",
           sse.min.length=5, bot=TRUE, left=TRUE,
           helix.col="gray20", sheet.col="gray80", sse.border=FALSE,
           add=FALSE, ...)
}
\arguments{
  \item{x}{ a numeric matrix of residue contacts as obtained from
    function \code{cmap}. }
  \item{col}{ color code or name, see \code{par}. }
  \item{pch}{ plotting \sQuote{character}, i.e., symbol to use. This can
    either be a single character or an integer code for one of a set of
    graphics symbols. See \code{points}. }
  \item{main}{ a main title for the plot, see also \sQuote{title}. }
  \item{sub}{ a sub-title for the plot. }
  \item{xlim}{ the x limits (x1,x2) of the plot.  Note that x1 > x2 is
          allowed and leads to a reversed axis. }
  \item{ylim}{ the y limits of the plot. }
  \item{xlab}{ a label for the x axis, defaults to a description of \sQuote{x}. }
  \item{ylab}{ a label for the y axis, defaults to a description of \sQuote{y}. }
  \item{axes}{ a logical value indicating whether both axes should be drawn
    on the plot.  Use graphical parameter \sQuote{xaxt} or
    \sQuote{yaxt} to suppress just one of the axes. }
  \item{ann}{ a logical value indicating whether the default annotation
    (title and x and y axis labels) should appear on the plot. }
  \item{sse}{ secondary structure object as returned from
    \code{\link{dssp}}, \code{\link{stride}} or in certain cases
    \code{\link{read.pdb}}. }
  \item{sse.type}{ single element character vector that determines the
    type of secondary structure annotation drawn. The following values
    are possible, \sQuote{classic} and \sQuote{fancy}. See details and 
    examples below. }
  \item{sse.min.length}{ a single numeric value giving the length below
    which secondary structure elements will not be drawn. This is useful
    for the exclusion of short helix and strand regions that can often crowd
    these forms of plots. }
  \item{left}{ logical, if TRUE rectangles for each sse are drawn towards
    the left of the plotting region.  }
  \item{bot}{ logical, if TRUE rectangles for each sse are drawn towards
    the bottom of the plotting region. }
  \item{helix.col}{ The colors for rectangles representing alpha helices. }
  \item{sheet.col}{ The colors for rectangles representing beta strands. }
  \item{sse.border}{ The border color for all sse rectangles. }
  \item{add}{ logical, specifying if the contact map should be added to an
    already existing plot. Note that when \sQuote{TRUE} only points are
    plotted (no annotation). }
  \item{\dots}{ other graphical parameters. }
}
\details{
  This function is useful for plotting a residue-residue contact data
  for a given protein structure along with a schematic representation of
  major secondary structure elements. 

  Two forms of secondary structure annotation are available: so called
  \sQuote{classic} and \sQuote{fancy}. The former draws marginal
  rectangles and has been available within Bio3D from version 0.1. The
  later draws more \sQuote{fancy} (and distracting) 3D like helices and
  arrowed strands.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven, Barry Grant }
\note{ Be sure to check the correspondence of your \sQuote{sse} object with the
  \sQuote{x} values being plotted as no internal checks are performed.
}
\seealso{
  \code{\link{cmap}}, \code{\link{dm}},
  \code{\link{plot.dmat}}, 
  \code{\link{plot.default}}, \code{\link{plot.bio3d}},
  \code{\link{dssp}}, \code{\link{stride}}
}
\examples{

##- Read PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

##- Calcualte contact map
cm <- cmap(pdb)

##- Plot contact map
plot.cmap(cm, sse=pdb)

##- Add to plot
plot.cmap(t(cm), col=3, pch=17, add=TRUE)

}
\keyword{ hplot }

\name{elements}
\alias{elements}
\docType{data}
\title{Periodic Table of the Elements}
\description{This data set gives various information on chemical elements.}
\usage{elements}
\format{
  A data frame containing for each chemical element the following information.
  \describe{
    \item{\code{num}}{atomic number}
    \item{\code{symb}}{elemental symbol}
    \item{\code{areneg}}{Allred and Rochow electronegativity  (0.0 if unknown)}
    \item{\code{rcov}}{covalent radii (in Angstrom) (1.6 if unknown)}
    \item{\code{rbo}}{"bond order" radii}
    \item{\code{rvdw}}{van der Waals radii (in Angstrom) (2.0 if unknown)}
    \item{\code{maxbnd}}{maximum bond valence (6 if unknown)}
    \item{\code{mass}}{IUPAC recommended atomic masses (in amu)}
    \item{\code{elneg}}{Pauling electronegativity (0.0 if unknown)}
    \item{\code{ionization}}{ionization potential (in eV) (0.0 if unknown)}
    \item{\code{elaffinity}}{electron affinity (in eV) (0.0 if unknown)}
    \item{\code{red}}{red value for visualization}
    \item{\code{green}}{green value for visualization}
    \item{\code{blue}}{blue value for visualization}
    \item{\code{name}}{element name}
  }
}

\source{
Open Babel (2.3.1) file: element.txt\cr

  Created from the Blue Obelisk Cheminformatics Data Repository\cr
  Direct Source: http://www.blueobelisk.org/\cr
  http://www.blueobelisk.org/repos/blueobelisk/elements.xml includes furhter bibliographic citation information\cr

  - Allred and Rochow Electronegativity from http://www.hull.ac.uk/chemistry/electroneg.php?type=Allred-Rochow\cr
  - Covalent radii from http://dx.doi.org/10.1039/b801115j\cr
  - Van der Waals radii from http://dx.doi.org/10.1021/jp8111556\cr
}

\examples{
data(elements)
elements

# Get the mass of some elements
symb <- c("C","O","H")
elements[match(symb,elements[,"symb"]),"mass"]

# Get the van der Waals radii of some elements
symb <- c("C","O","H")
elements[match(symb,elements[,"symb"]),"rvdw"]

}
\keyword{datasets}

\name{seqaln.pair}
\alias{seqaln.pair}
\title{ Sequence Alignment of Identical Protein Sequences }
\description{
  Create multiple alignments of amino acid sequences according to the
  method of Edgar.
}
\usage{
seqaln.pair(aln, \dots)
}
\arguments{
  \item{aln}{ a sequence character matrix, as obtained from
    \code{\link{seqbind}}, or an alignment list object as obtained from
      \code{\link{read.fasta}}. }
  \item{\dots}{ additional arguments for the function \code{\link{seqaln}}. }
}
\details{
  This function is intended for the alignment of identical sequences only.
  For standard alignment see the related function \code{\link{seqaln}}.

  This function is useful for determining the equivalences between
  sequences and structures. For example in aligning a PDB sequence to an
  existing multiple sequence alignment, where one would first mask the
  alignment sequences and then run the alignment to determine equivalences.
}
\value{
  A list with two components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{ids}{ sequence names as identifers.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  \sQuote{MUSCLE} is the work of Edgar:
  Edgar (2004) \emph{Nuc. Acid. Res.} \bold{32}, 1792--1797.

  Full details of the \sQuote{MUSCLE} algorithm, along with download and
  installation instructions can be obtained from:\cr
  \url{http://www.drive5.com/muscle/}.
}
\author{ Barry Grant }
\note{
  A system call is made to the \sQuote{MUSCLE} program, which must be
  installed on your system and in the search path for executables.
}
\seealso{ \code{\link{seqaln}}, \code{\link{read.fasta}},
  \code{\link{read.fasta.pdb}}, \code{\link{seqbind}}
}
\examples{

## NOTE: FOLLOWING EXAMPLE NEEDS MUSCLE INSTALLED
if(check.utility("muscle")) {

##- Aligning a PDB sequence to an existing sequence alignment


##- Simple example
aln <- seqbind(c("X","C","X","X","A","G","K"),
               c("C","-","A","X","G","X","X","K"))

seqaln.pair(aln, outfile = tempfile())

}
}
\keyword{ utilities }

\name{example.data}
\docType{data}
\alias{example.data}
\alias{kinesin}
\alias{transducin}
\alias{pdbs}
\alias{core}
\alias{annotation}
\alias{hivp}
\title{Bio3d Example Data}
\description{
  These data sets contain the results of running various Bio3D
  functions on example kinesin and transducin structural data, and on a short 
  coarse-grained MD simulation data for HIV protease. The main 
  purpose of including this data (which may be generated by the user by following the extended examples documented within the various Bio3D functions) is to
  speed up example execution. It should allow users to more quickly
  appreciate the capabilities of functions that would otherwise require
  raw data download, input and processing before execution.

  Note that related datasets formed the basis of
  the work described in (Grant, 2007) and (Yao & Grant, 2013) for \code{kinesin}
  and \code{transducin} examples, respectively.
}
\usage{
data(kinesin)
data(transducin)
data(hivp)
}
\format{
  Three objects from analysis of the \code{kinesin} and \code{transducin} sequence and structure
  data:
  \enumerate{
    \item{pdbs}{ is a list of class \code{pdbs} containing aligned PDB
      structure data.  In the case of transducin this is the output of running 
      \code{\link{pdbaln}} on a set of 53 G[alpha]i structures from the PDB database (see \code{pdbs$id} 
      or \code{annotation} described below for details). The coordinates
      are fitted onto the first structure based on \code{"core"} positions obtained from \code{\link{core.find}} and superposed using the function \code{\link{pdbfit}}. }
    \item{core}{ is a list of class \code{"core"} obtained by running the
      function \code{\link{core.find}} on the \code{pdbs} object as described above.}
    \item{annotation}{ is a character matrix describing the nucleotide state and bound 
      ligand species for each structure in \code{pdbs} as obtained from the function \code{\link{pdb.annotate}}.}
  }

  One object named \code{net} in the hivp example data stores the correlation 
  network obtained from the analysis of the MD simulation trajectory of HIV 
  protease using the \code{cna} function. The original trajectory file can be 
  accessed by the command \sQuote{system.file("examples/hivp.dcd", package="bio3d")}. 

}
\source{
  A related but more extensive dataset formed the basis of
  the work described in (Grant, 2007) and (Yao & Grant, 2013) for \code{kinesin}
  and \code{transducin} examples, respectively.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Grant, B.J. et al. (2007) \emph{J. Mol. Biol.} \bold{368}, 1231--1248.
  
  Yao, X.Q. et al. (2013) \emph{Biophys. J.} \bold{105}, L08--L10.
}
\keyword{datasets}

\name{bounds}
\alias{bounds}
\title{ Bounds of a Numeric Vector }
\description{
  Find the \sQuote{bounds} (i.e. start, end and length) of consecutive
  numbers within a larger set of numbers in a given vector.
}
\usage{
  bounds(nums, dup.inds=FALSE, pre.sort=TRUE)
}
\arguments{
  \item{nums}{ a numeric vector. }
  \item{dup.inds}{ logical, if TRUE the bounds of consecutive duplicated
    elements are returned. }
  \item{pre.sort}{ logical, if TRUE the input vector is ordered prior to
    bounds determination. }
}
\details{
   This is a simple utility function useful for summarizing the contents
   of a numeric vector. For example: find the start position, end
   position and lengths of secondary structure elements given a vector
   of residue numbers obtained from a DSSP secondary structure
   prediction.

   By setting \sQuote{dup.inds} to TRUE then the indices of the first
   (start) and last (end) duplicated elements of the vector are
   returned. For example: find the indices of atoms belonging to a particular
   residue given a vector of residue numbers (see below).
}
\value{
  Returns a three column matrix listing starts, ends and lengths.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22},
  2695--2696.
}
\author{ Barry Grant }
\examples{
 test <- c(seq(1,5,1),8,seq(10,15,1))
 bounds(test)

 test <- rep(c(1,2,4), times=c(2,3,4))
 bounds(test, dup.ind=TRUE)
}
\keyword{ utilities }

\name{vec2resno}
\alias{vec2resno}
\title{ Replicate Per-residue Vector Values }
\description{
  Replicate values in one vector based on consecutive entries in a second
  vector. Useful for adding per-residue data to all-atom PDB files.
}
\usage{
vec2resno(vec, resno)
}
\arguments{
  \item{vec}{ a vector of values to be replicated.}
  \item{resno}{ a reference vector or a PDB structure object, obtained
    from \code{\link{read.pdb}}, upon which replication is based. }
}
\details{
  This function can aid in mapping data to PDB structure files. For
  example, residue conservation per position (or any other one value per
  residue data) can be replicated to fit the B-factor field of an all
  atom PDB file which can then be rendered according to this field in a
  molecular viewer.
  
  A basic check is made to ensure that the number of consecutively
  unique entries in the reference vector equals the length of the vector
  to be replicated.
}
\value{
  Returns a vector of replicated values.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}  
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}},
  \code{\link{write.pdb}} }
\examples{
vec2resno(c("a","b"), c(1,1,1,1,2,2))
}
\keyword{ utilities }

\name{plot.dccm}
\alias{plot.dccm}
\title{ DCCM Plot }
\description{
  Plot a dynamical cross-correlation matrix.
}
\usage{
\method{plot}{dccm}(x, resno=NULL, sse=NULL, colorkey=TRUE,
                    at=c(-1, -0.75, -0.5,  -0.25, 0.25, 0.5, 0.75, 1),
                    main="Residue Cross Correlation",
                    helix.col = "gray20", sheet.col = "gray80",
                    inner.box=TRUE, outer.box=FALSE,
                    xlab="Residue No.", ylab="Residue No.",
                    margin.segments=NULL, segment.col=vmd_colors(), segment.min=1, ...)
}
\arguments{
  \item{x}{ a numeric matrix of atom-wise cross-correlations as output by
    the \sQuote{dccm} function. }
  \item{resno}{ an optional vector with length equal to that of
    \code{x} that will be used to annotate the x- and y-axis. This is typically
    a vector of residue numbers. Can be also provided with a \sQuote{pdb} object,
    in which \sQuote{resno} of all C-alpha atoms will be used. If NULL residue 
    positions from 1 to the length of \code{x} will be used. See examples below. }
  \item{sse}{ secondary structure object as returned from
    \code{\link{dssp}}, \code{\link{stride}} or \code{\link{read.pdb}}. }
  \item{colorkey}{ logical, if TRUE a key is plotted. }
  \item{at}{ numeric vector specifying the levels to be colored. }
  \item{main}{ a main title for the plot. }
  \item{helix.col}{ The colors for rectangles representing alpha helices. }
  \item{sheet.col}{ The colors for rectangles representing beta strands. }
  \item{inner.box}{ logical, if TRUE an outer box is drawn. }
  \item{outer.box}{ logical, if TRUE an outer box is drawn. }
  \item{xlab}{ a label for the x axis. } 
  \item{ylab}{ a label for the y axis. }
  \item{margin.segments}{ a numeric vector of cluster membership as 
     obtained from cutree() or other community detection method. This 
     will be used for bottom and left margin annotation. }
  \item{segment.col}{ a vector of colors used for each cluster group in 
     margin.segments. }
  \item{segment.min}{ a single element numeric vector that will cause 
    margin.segments with a length below this value to be excluded from
    the plot. }
   \item{\dots}{ additional graphical parameters for contourplot. }
}
\details{
  See the \sQuote{contourplot} function from the lattice package for plot customization options, and the functions \code{\link{dssp}} and \code{\link{stride}} for further details.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{ Be sure to check the correspondence of your \sQuote{sse} object with the
  \sQuote{cij} values being plotted as no internal checks are currently performed.
}
\seealso{ \code{\link{plot.bio3d}}, \code{\link{plot.dmat}},
  \code{\link{filled.contour}}, \code{\link{contour}},
  \code{\link{image}} \code{\link{plot.default}}, \code{\link{dssp}},
  \code{\link{stride}} }
\examples{

\dontrun{
  ##-- Read example trajectory file
  trtfile <- system.file("examples/hivp.dcd", package="bio3d")
  trj <- read.dcd(trtfile)

  ## Read reference PDB and trim it to match the trajectory
  pdb <- trim(read.pdb("1W5Y"), 'calpha')

  ## select residues 24 to 27 and 85 to 90 in both chains
  inds <- atom.select(pdb, resno=c(24:27,85:90))

  ## lsq fit of trj on pdb
  xyz <- fit.xyz(pdb$xyz, trj, fixed.inds=inds$xyz, mobile.inds=inds$xyz)

  ## Dynamic cross-correlations of atomic displacements
  cij <- dccm(xyz)

  ## Default plot
  plot.dccm(cij)

  ## Change the color scheme and the range of colored data levels
  plot.dccm(cij, contour=FALSE, col.regions=bwr.colors(200), at=seq(-1,1,by=0.01) )

  ## Add secondary structure annotation to plot margins
  plot.dccm(cij, sse=pdb) 

  ## Add additional margin annotation for chains
  ## Also label x- and y-axis with PDB residue numbers
  ch <- ifelse(pdb$atom$chain=="A", 1,2)
  plot.dccm(cij, resno=pdb, sse=pdb, margin.segments=ch)

  ## Plot with cluster annotation from dynamic network analysis
  #net <- cna(cij)
  #plot.dccm(cij, margin.segments=net$raw.communities$membership)

  ## Focus on major communities (i.e. exclude those below a certain total length)
  #plot.dccm(cij, margin.segments=net$raw.communities$membership, segment.min=25)

}

}
\keyword{ hplot }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bounds.sse.R
\name{bounds.sse}
\alias{bounds.sse}
\title{Obtain A SSE Object From An SSE Sequence Vector}
\usage{
bounds.sse(x, pdb = NULL)
}
\arguments{
\item{x}{a character vector indicating SSE for each amino acid residue.}

\item{pdb}{an object of class \code{pdb} as obtained from
function \code{\link{read.pdb}}. Can be ignored if \code{x} has 'names'
attribute for residue labels.}
}
\value{
a 'sse' object.
}
\description{
Inverse process of the funciton \code{\link{pdb2sse}}.
}
\details{
call for its effects.
}
\note{
In both \code{$helix} and \code{$sheet}, an additional 
   \code{$id} component is added to indicate the original numbering of the sse.
   This is particularly useful in e.g. \code{trim.pdb()} function.
}
\examples{
\donttest{
   # PDB server connection required - testing excluded

   pdb <- read.pdb("1a7l")
   sse <- pdb2sse(pdb)
   sse.ind <- bounds.sse(sse)
   sse.ind 
} 
}
\author{
Xin-Qiu Yao & Barry Grant
}
\seealso{
\code{\link{pdb2sse}}
}

\name{unbound}
\alias{unbound}
\title{ Sequence Generation from a Bounds Vector }
\description{
  Generate a sequence of consecutive numbers from a \code{\link{bounds}} vector.
}
\usage{
unbound(start, end = NULL)
}
\arguments{
  \item{start}{ vector of starting values, or a matrix containing starting and 
      end values such as that obtained from \code{\link{bounds}}. }
  \item{end}{ vector of (maximal) end values, such as that obtained from 
      \code{\link{bounds}}. }
}
\details{
   This is a simple utility function that does the opposite of the
   \code{\link{bounds}} function. If \code{start} is a vector, \code{end} must 
   be a vector having the same length as \code{start}. If \code{start} is a 
   matrix with column names contain 'start' and 'end', such as that returned 
   from \code{\link{bounds}}, \code{end} can be skipped and both starting and 
   end values will be extracted from \code{start}.
}
\value{
  Returns a numeric sequence vector.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\seealso{ \code{\link{bounds}} }
\author{ Barry Grant }
\examples{

test <- c(seq(1,5,1),8,seq(10,15,1))
b <- bounds(test)
unbound(b)

}
\keyword{ utilities }

\name{pca.xyz}
\alias{pca.xyz}
\alias{print.pca}
\title{ Principal Component Analysis }
\description{
   Performs principal components analysis (PCA) on a \code{xyz}
   numeric data matrix.
 }
\usage{
\method{pca}{xyz}(xyz, subset = rep(TRUE, nrow(as.matrix(xyz))),
                 use.svd = FALSE, rm.gaps=FALSE, mass = NULL, \dots)

\method{print}{pca}(x, nmodes=6, \dots)
}
\arguments{
  \item{xyz}{ numeric matrix of Cartesian coordinates with a row per
    structure. }
  \item{subset}{ an optional vector of numeric indices that selects a
    subset of rows (e.g. experimental structures vs molecular dynamics
    trajectory structures) from the full \code{xyz} matrix. Note: the
    full \code{xyz} is projected onto this subspace.}
  \item{use.svd}{ logical, if TRUE singular value decomposition (SVD) is 
    called instead of eigenvalue decomposition. }
  \item{rm.gaps}{ logical, if TRUE gap positions (with missing
    coordinate data in any input structure) are removed before
    calculation. This is equivalent to removing NA cols from xyz. }
  \item{x}{ an object of class \code{pca}, as obtained from function
    \code{pca.xyz}. }
  \item{nmodes}{ numeric, number of modes to be printed. }
  \item{mass}{ a \sQuote{pdb} object or numeric vector of residue/atom masses. 
     By default (\code{mass=NULL}), mass is ignored. If provided 
     with a \sQuote{pdb} object, masses of all amino acids obtained from 
     \code{\link{aa2mass}} are used. }
  \item{\dots}{ additional arguments to \code{\link{fit.xyz}} 
     (for \code{pca.xyz}) or to \code{print} (for \code{print.pca}). }
}
\note{
     If \code{mass} is provided, mass weighted coordinates will be considered, 
     and iteration of fitting onto the mean structure is performed internally. 
     The extra fitting process is to remove external translation and rotation 
     of the whole system. With this option, a direct comparison can be made 
     between PCs from \code{\link{pca.xyz}} and vibrational modes from 
     \code{\link{nma.pdb}}, with the fact that 
                           \deqn{A=k_BTF^{-1}}{A=k[B]TF^-1}, 
     where \eqn{A} is the variance-covariance matrix, \eqn{F} the Hessian 
     matrix, \eqn{k_B}{k[B]} the Boltzmann's constant, and \eqn{T} the 
     temperature.
}
\value{
  Returns a list with the following components:
  \item{L }{eigenvalues.}
  \item{U }{eigenvectors (i.e. the x, y, and z variable loadings).}
  \item{z }{scores of the supplied \code{xyz} on the pcs.}
  \item{au }{atom-wise loadings (i.e. xyz normalized eigenvectors).}
  \item{sdev }{the standard deviations of the pcs.}
  \item{mean }{the means that were subtracted.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{
  \code{\link{pca}}, \code{\link{pca.pdbs}},
  \code{\link{plot.pca}}, \code{\link{mktrj.pca}},
  \code{\link{pca.tor}}, \code{\link{project.pca}} }
\examples{

\dontrun{
#-- Read transducin alignment and structures
aln <- read.fasta(system.file("examples/transducin.fa",package="bio3d"))
pdbs <- read.fasta.pdb(aln)

# Find core
core <- core.find(pdbs, 
                  #write.pdbs = TRUE,
                  verbose=TRUE)

rm(list=c("pdbs", "core"))
}

#-- OR for demo purposes just read previously saved transducin data
attach(transducin)

# Previously fitted coordinates based on sub 1.0A^3 core. See core.find() function.
xyz <- pdbs$xyz
                
#-- Do PCA ignoring gap containing positions
pc.xray <- pca.xyz(xyz, rm.gaps=TRUE)

# Plot results (conformer plots & scree plot overview)
plot(pc.xray, col=annotation[, "color"])

# Plot a single conformer plot of PC1 v PC2
plot(pc.xray, pc.axes=1:2, col=annotation[, "color"])

## Plot atom wise loadings
plot.bio3d(pc.xray$au[,1], ylab="PC1 (A)")

\donttest{
# PDB server connection required - testing excluded

## Plot loadings in relation to reference structure 1TAG
pdb <- read.pdb("1tag")
ind <- grep("1TAG", pdbs$id)             ## location in alignment

resno <- pdbs$resno[ind, !is.gap(pdbs)]  ## non-gap residues
tpdb <- trim.pdb(pdb, resno=resno)

op <- par(no.readonly=TRUE)
par(mfrow = c(3, 1), cex = 0.6, mar = c(3, 4, 1, 1))
plot.bio3d(pc.xray$au[,1], resno, ylab="PC1 (A)", sse=tpdb)
plot.bio3d(pc.xray$au[,2], resno, ylab="PC2 (A)", sse=tpdb)
plot.bio3d(pc.xray$au[,3], resno, ylab="PC3 (A)", sse=tpdb)
par(op)
}

\dontrun{
# Write PC trajectory
resno = pdbs$resno[1, !is.gap(pdbs)]
resid = aa123(pdbs$ali[1, !is.gap(pdbs)])

a <- mktrj.pca(pc.xray, pc=1, file="pc1.pdb",
               resno=resno, resid=resid )

b <- mktrj.pca(pc.xray, pc=2, file="pc2.pdb",
               resno=resno, resid=resid )

c <- mktrj.pca(pc.xray, pc=3, file="pc3.pdb",
               resno=resno, resid=resid )
}

detach(transducin)
}
\keyword{ utilities }
\keyword{ multivariate }

\name{plot.dmat}
\alias{plot.dmat}
\title{ Plot Distance Matrix }
\description{
  Plot a distance matrix (DM) or a difference distance matrix (DDM).
}
\usage{
\method{plot}{dmat}(x, key = TRUE, resnum.1 = c(1:ncol(x)), resnum.2 = resnum.1,
          axis.tick.space = 20, zlim = range(x, finite = TRUE),
          nlevels = 20, levels = pretty(zlim, nlevels),
          color.palette = bwr.colors,
          col = color.palette(length(levels) - 1),
          axes = TRUE, key.axes, xaxs = "i", yaxs = "i", las = 1,
          grid = TRUE, grid.col = "yellow", grid.nx = floor(ncol(x)/30),
          grid.ny = grid.nx, center.zero = TRUE, flip=TRUE, ...)
}
\arguments{
  \item{x}{ a numeric distance matrix generated by the function
    \code{\link{dm}}. }
  \item{key}{ logical, if TRUE a color key is plotted. }
  \item{resnum.1}{ a vector of residue numbers for annotating the x axis. }
  \item{resnum.2}{ a vector of residue numbers for annotating the y axis. }
  \item{axis.tick.space}{ the separation between each axis tick mark. }
  \item{zlim}{ z limits for the distances to be plotted. }
  \item{nlevels}{ if \code{levels} is not specified, the range of 'z' values
    is divided into approximately this many levels. }
  \item{levels}{ a set of levels used to partition the range of 'z'.
    Must be *strictly* increasing (and finite).  Areas with 'z' values
    between consecutive levels are painted with the same color. }
  \item{color.palette}{ a color palette function, used to assign
    colors in the plot. }
  \item{col}{ an explicit set of colors to be used in the plot. This
    argument overrides any palette function specification. }
  \item{axes}{ logical, if TRUE plot axes are drawn. }
  \item{key.axes}{ statements which draw axes on the plot key. It
    overrides the default axis. }
  \item{xaxs}{ the x axis style.  The default is to use internal labeling. }
  \item{yaxs}{ the y axis style.  The default is to use internal labeling. }
  \item{las}{ the style of labeling to be used.  The default is to use
    horizontal labeling. }
  \item{grid}{ logical, if TRUE overlaid grid is drawn. }
  \item{grid.col}{ color of the overlaid grid. }
  \item{grid.nx}{ number of grid cells in the x direction.  }
  \item{grid.ny}{ number of grid cells in the y direction.  }
  \item{center.zero}{ logical, if TRUE levels are forced to be
    equidistant around zero, assuming that zlim ranges from less than to
    more than zero. }
  \item{flip}{ logical, indicating whether the second axis should be
    fliped. }
  \item{\dots}{ additional graphical parameters for image. }
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.T

  Much of this function is based on the \code{filled.contour} function
  by Ross Ihaka.
 }
\author{ Barry Grant }
\note{
  This function is based on the \code{layout} and legend key code in the
  function \code{filled.contour} by Ross Ihaka.  As with
  \code{filled.contour} the output is a combination of two plots: the
  legend and (in this case) \code{image} (rather than a contour plot).
}
\seealso{ \code{\link{dm}}, \code{\link{filled.contour}},
  \code{\link{contour}}, \code{\link{image}} }
\examples{

# Read PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

# DM
d <- dm(pdb,"calpha")

# Plot DM
##filled.contour(d, nlevels = 4)
##plot(d)
plot(d,
     resnum.1 = pdb$atom[pdb$calpha,"resno"],
     color.palette = mono.colors,
     xlab="Residue Number", ylab="Residue Number")

\dontrun{
# Download and align two PDB files
pdbs <- pdbaln( get.pdb( c( "4q21", "521p"), path=tempdir(), overwrite=TRUE))

# Get distance matrix
a <- dm.xyz(pdbs$xyz[1,])
b <- dm.xyz(pdbs$xyz[2,])

# Calculate DDM
c <- a - b

# Plot DDM
plot(c,key=FALSE, grid=FALSE)

plot(c, axis.tick.space=10,
     resnum.1=pdbs$resno[1,],
     resnum.2=pdbs$resno[2,],
     grid.col="black",
     xlab="Residue No. (4q21)", ylab="Residue No. (521p)")

}
}
\keyword{ hplot }

\name{rmsip}
\alias{rmsip}
\alias{rmsip.default}
\alias{rmsip.enma}
\title{ Root Mean Square Inner Product }
\description{
  Calculate the RMSIP between two mode subspaces. 
}
\usage{
rmsip(...)

\method{rmsip}{enma}(enma, ncore=NULL, subset=10, ...)

\method{rmsip}{default}(modes.a, modes.b, subset=10,
                        row.name="a", col.name="b", ...)
}
\arguments{
  \item{enma}{ an object of class \code{"enma"} obtained from function
    \code{nma.pdbs}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{subset}{ the number of modes to consider. }   
  \item{modes.a}{ an object of class \code{"pca"} or \code{"nma"} as
    obtained from functions \code{pca.xyz} or \code{nma}. }
  \item{modes.b}{ an object of class \code{"pca"} or \code{"nma"} as
    obtained from functions \code{pca.xyz} or \code{nma}. }
  \item{row.name}{ prefix name for the rows. }
  \item{col.name}{ prefix name for the columns. }
  \item{\dots}{ arguments passed to associated functions. }
}
\details{
  RMSIP is a measure for the similarity between two set of modes obtained
  from principal component or normal modes analysis. 
}
\value{
  Returns an \code{rmsip} object with the following components:
  \item{overlap}{ a numeric matrix containing pairwise (squared) dot products 
    between the modes. }
  \item{rmsip}{ a numeric RMSIP value. }
  
  For function \code{rmsip.enma} a numeric matrix containing all
  pairwise RMSIP values of the modes stored in the \code{enma} object.
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
  Amadei, A. et al. (1999) \emph{Proteins} \bold{36}, 19--424.   
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{pca}}, \code{\link{nma}},
  \code{\link{overlap}}.

  Other similarity measures:
  \code{\link{sip}}, \code{\link{covsoverlap}},
  \code{\link{bhattacharyya}}.
}
\examples{
\dontrun{
# Load data for HIV example
trj <- read.dcd(system.file("examples/hivp.dcd", package="bio3d"))
pdb <- read.pdb(system.file("examples/hivp.pdb", package="bio3d"))

# Do PCA on simulation data
xyz.md <- fit.xyz(pdb$xyz, trj, fixed.inds=1:ncol(trj))
pc.sim <- pca.xyz(xyz.md)

# NMA 
modes <- nma(pdb)

# Calculate the RMSIP between the MD-PCs and the NMA-MODEs
r <- rmsip(modes, pc.sim, subset=10, row.name="NMA", col.name="PCA")

# Plot pairwise overlap values
plot(r, xlab="NMA", ylab="PCA")
}
}
\keyword{ utilities }

\name{combine.select}
\alias{combine.select}
\title{ Combine Atom Selections From PDB Structure }
\description{
  Do "and", "or", or "not" set operations between two or more atom
  selections made by \code{\link{atom.select}}
}
\usage{
combine.select(sel1=NULL, sel2=NULL, \dots, operator="AND", verbose=TRUE)
}
\arguments{
  \item{sel1}{ an atom selection object of class \code{"select"}, obtained from
    \code{\link{atom.select}}. }
  \item{sel2}{ a second atom selection object of class \code{"select"}, obtained
    from \code{\link{atom.select}}. }
  \item{\dots}{ more select objects for the set operation. }
  \item{operator}{ name of the set operation. }
  \item{verbose}{ logical, if TRUE details of the selection combination are
     printed. }
}
\details{
  The value of \code{operator} should be one of following:
  (1) "AND", "and", or "&" for set intersect,
  (2) "OR", "or", "|", or "+" for set union,
  (3) "NOT", "not", "!", or "-" for set difference \code{sel1 - sel2 - sel3 ...}.
}
\value{
  Returns a list of class \code{"select"} with components:
  \item{atom }{atom indices of selected atoms.}
  \item{xyz }{xyz indices of selected atoms.}
  \item{call }{the matched call.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao }
\seealso{
  \code{\link{atom.select}}, \code{\link{as.select}}
  \code{\link{read.pdb}}, \code{\link{trim.pdb}}
}
\examples{

# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## - Build atom selections to be operated
# Select C-alpha atoms of entire system
ca.global.inds <- atom.select(pdb, "calpha")

# Select C-beta atoms of entire protein
cb.global.inds <- atom.select(pdb, "protein", elety="CB")

# Select backbone atoms of entire system
bb.global.inds <- atom.select(pdb, "backbone")

# Select all atoms with residue number from 46 to 50
aa.local.inds <- atom.select(pdb, resno=46:50)


# Do set intersect:
# - Return C-alpha atoms with residue number from 46 to 50
ca.local.inds <- combine.select(ca.global.inds, aa.local.inds)
print( pdb$atom[ ca.local.inds$atom, ] )

# Do set subtract:
# - Return side-chain atoms with residue number from 46 to 50
sc.local.inds <- combine.select(aa.local.inds, bb.global.inds, operator="-")
print( pdb$atom[ sc.local.inds$atom, ] )

# Do set union:
# - Return C-alpha and side-chain atoms with residue number from 46 to 50
casc.local.inds <- combine.select(ca.local.inds, sc.local.inds, operator="+")
print( pdb$atom[ casc.local.inds$atom, ] )

# More than two selections:
# - Return side-chain atoms (but not C-beta) with residue number from 46 to 50
sc2.local.inds <- combine.select(aa.local.inds, bb.global.inds, cb.global.inds, operator="-")
print( pdb$atom[ sc2.local.inds$atom, ] )

}
\keyword{utilities}

\name{core.find}
\alias{core.find}
\alias{core.find.default}
\alias{core.find.pdbs}
\alias{core.find.pdb}
\title{ Identification of Invariant Core Positions }
\description{
  Perform iterated rounds of structural superposition to identify the
  most invariant region in an aligned set of protein structures.
}
\usage{
core.find(\dots)

\method{core.find}{pdbs}(pdbs, shortcut = FALSE, rm.island = FALSE,
          verbose = TRUE, stop.at = 15, stop.vol = 0.5,
          write.pdbs = FALSE, outpath="core_pruned",
          ncore = 1, nseg.scale = 1, progress = NULL, \dots)

\method{core.find}{default}(xyz, \dots)

\method{core.find}{pdb}(pdb, verbose=TRUE, \dots)
}
\arguments{
  \item{pdbs}{ a numeric matrix of aligned C-alpha xyz Cartesian
    coordinates. For example an alignment data structure obtained with
    \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}. }
  \item{shortcut}{ if TRUE, remove more than one position at a time. }
  \item{rm.island}{ remove isolated fragments of less than three
    residues. }
  \item{verbose}{ logical, if TRUE a \dQuote{core_pruned} directory
    containing \sQuote{core structures} for each iteraction is written 
    to the current directory. }
  \item{stop.at}{ minimal core size at which iterations should be
    stopped. }
  \item{stop.vol}{ minimal core volume at which iterations should be
    stopped. }  
  \item{write.pdbs}{ logical, if TRUE core coordinate files, containing
    only core positions for each iteration, are written to a location
    specified by \code{outpath}. }
  \item{outpath}{ character string specifying the output directory when
    \code{write.pdbs} is TRUE. }  
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}.}
  \item{progress}{ progress bar for use with shiny web app. }
  \item{xyz}{ a numeric matrix of xyz Cartesian coordinates,
    e.g. obtained from \code{\link{read.dcd}} or \code{\link{read.ncdf}}. }
  \item{pdb}{ an object of type \code{pdb} as obtained from function
    \code{\link{read.pdb}} with multiple frames (>=4) stored in its
    \code{xyz} component. Note that the function will attempt to
    identify C-alpha and phosphate atoms (for protein and nucleic acids,
    respectively) in which the calculation should be based. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  This function attempts to iteratively refine an initial structural
  superposition determined from a multiple alignment.
  This involves iterated rounds of superposition, where at each round the
  position(s) displaying the largest differences is(are) excluded from the
  dataset. 
  The spatial variation at each aligned position is determined from the
  eigenvalues of their Cartesian coordinates (i.e. the variance of the
  distribution along its three principal directions). Inspired by the
  work of Gerstein \emph{et al.} (1991, 1995), an ellipsoid of
  variance is determined from the eigenvalues, and its volume is taken as
  a measure of structural variation at a given position.

  Optional \dQuote{core PDB files} containing core positions, upon which
  superposition is based, can be written to a location specified by
  \code{outpath} by setting \code{write.pdbs=TRUE}.  These files are
  useful for examining the core filtering process by visualising them in a
  graphics program.
  
 }
\value{
  Returns a list of class \code{"core"} with the following components:
  \item{volume }{total core volume at each fitting iteration/round.}
  \item{length }{core length at each round.}
  \item{resno }{residue number of core residues at each round (taken
    from the first aligned structure) or, alternatively, the numeric
    index of core residues at each round.}
  \item{step.inds}{atom indices of core atoms at each round.}
  \item{atom }{atom indices of core positions in the last round.}
  \item{xyz }{xyz indices of core positions in the last round.}
  \item{c1A.atom }{atom indices of core positions with a total volume
    under 1 Angstrom^3.}
  \item{c1A.xyz }{xyz indices of core positions with a total volume
    under 1 Angstrom^3.}
  \item{c1A.resno }{residue numbers of core positions with a total volume
    under 1 Angstrom^3.}
  \item{c0.5A.atom }{atom indices of core positions with a total volume
    under 0.5 Angstrom^3.}
  \item{c0.5A.xyz }{xyz indices of core positions with a total volume
    under 0.5 Angstrom^3.}
  \item{c0.5A.resno }{residue numbers of core positions with a total volume
    under 0.5 Angstrom^3.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Gerstein and Altman (1995) \emph{J. Mol. Biol.}  \bold{251}, 161--175.

  Gerstein and Chothia (1991) \emph{J. Mol. Biol.} \bold{220}, 133--149.
}
\note{
  The relevance of the \sQuote{core positions} identified by this
  procedure is dependent upon the number of input structures and their
  diversity.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.fasta.pdb}}, \code{\link{plot.core}},
  \code{\link{fit.xyz}} }
\examples{
\dontrun{
##-- Generate a small kinesin alignment and read corresponding structures
pdbfiles <- get.pdb(c("1bg2","2ncd","1i6i","1i5s"), URLonly=TRUE)
pdbs <- pdbaln(pdbfiles)

##-- Find 'core' positions
core <- core.find(pdbs)
plot(core)

##-- Fit on these relatively invarient subset of positions 
#core.inds <- print(core, vol=1)
core.inds <- print(core, vol=0.5)
xyz <- pdbfit(pdbs, core.inds, outpath="corefit_structures")

##-- Compare to fitting on all equivalent positions
xyz2 <- pdbfit(pdbs)

## Note that overall RMSD will be higher but RMSF will
##  be lower in core regions, which may equate to a
##  'better fit' for certain applications
gaps <- gap.inspect(pdbs$xyz)
rmsd(xyz[,gaps$f.inds])
rmsd(xyz2[,gaps$f.inds])

plot(rmsf(xyz[,gaps$f.inds]), typ="l", col="blue", ylim=c(0,9))
points(rmsf(xyz2[,gaps$f.inds]), typ="l", col="red")
}

\dontrun{
##-- Run core.find() on a multimodel PDB file
pdb <- read.pdb('1d1d', multi=TRUE)
core <- core.find(pdb)

##-- Run core.find() on a trajectory
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## select calpha coords from a manageable number of frames
ca.ind <- atom.select(pdb, "calpha")$xyz
frames <- seq(1, nrow(trj), by=10)

core <- core.find( trj[frames, ca.ind], write.pdbs=TRUE )

## have a look at the various cores "vmd -m core_pruned/*.pdb"

## Lets use a 6A^3 core cutoff
inds <- print(core, vol=6)
write.pdb(xyz=pdb$xyz[inds$xyz],resno=pdb$atom[inds$atom,"resno"], file="core.pdb")


##- Fit trj onto starting structure based on core indices
xyz <- fit.xyz( fixed = pdb$xyz,
               mobile = trj,
               fixed.inds  = inds$xyz,
               mobile.inds = inds$xyz)

##write.pdb(pdb=pdb, xyz=xyz, file="new_trj.pdb")
##write.ncdf(xyz, "new_trj.nc")

}

}
\keyword{ utilities }

\name{seqbind}
\alias{seqbind}
\title{ Combine Sequences by Rows Without Recycling }
\description{
  Take vectors and/or matrices arguments and combine them row-wise without
  recycling them (as is the case with \code{\link{rbind}}).
}
\usage{
seqbind(..., blank = "-")
}
\arguments{
  \item{\dots}{ vectors, matrices, and/or alignment \sQuote{fasta}
    objects to combine. }
  \item{blank}{ a character to add to short arguments, to achieve the
    same length as the longer argument. }
}
\value{
  Returns a list of class \code{"fasta"} with the following components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{id}{ sequence names as identifers.}
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{seqaln}}, \code{\link{read.fasta}},
  \code{\link{read.pdb}}, \code{\link{write.fasta}}, \code{\link{rbind}} }
\examples{
\dontrun{
## Read two pdbs
a.pdb <- read.pdb("1bg2")
b.pdb <- read.pdb("1goj")

seqs <- seqbind(aa321(a.pdb$atom[a.pdb$calpha,"resid"]),
                aa321(b.pdb$atom[b.pdb$calpha,"resid"]))

# seqaln(seqs)
}
}
\keyword{ utilities }

\name{filter.dccm}
\alias{filter.dccm}
\title{ Filter for Cross-correlation Matrices (Cij) }
\description{
  This function builds various cij matrix for correlation network analysis
}
\usage{
  filter.dccm(x, cutoff.cij = NULL, cmap = NULL, xyz = NULL, fac = NULL, 
      cutoff.sims = NULL, collapse = TRUE, extra.filter = NULL, ...)
}
\arguments{
  \item{x}{ A matrix (nXn), a numeric array with 3 dimensions (nXnXm), 
    a list with m cells each containing nXn matrix, or a list with
    \sQuote{all.dccm} component, containing atomic correlation values, 
    where "n" is the number of residues and "m" the number of calculations. 
    The matrix elements should be in between -1 and 1. See \sQuote{dccm} 
    function in bio3d package for further details. }
  \item{cutoff.cij}{ Threshold for each individual correlation value. 
    If NULL, a guessed value will be used. See below for details. }
  \item{cmap}{ logical or numerical matrix indicating the contact map.
    If logical and TRUE, contact map will be calculated with input
    \code{xyz}. } 
  \item{xyz}{ XYZ coordinates, or a \sQuote{pdbs} object obtained from 
    \code{pdbaln} or \code{read.fasta.pdb}, for contact map calculations. }
  \item{fac}{ factor indicating distinct categories of input correlation matrices. }
  \item{cutoff.sims}{ Threshold for the number of simulations with observed correlation
    value above \code{cutoff.cij} for the same residue/atomic pairs. See below for details. }
  \item{collapse}{ logical, if TRUE the mean matrix will be returned. }
  \item{extra.filter}{ Filter to apply in addition to the model chosen. } 
  \item{\dots}{ extra arguments passed to function \code{cmap}. } 
}
\value{
  Returns a matrix of class "dccm" or a 3D array of filtered cross-correlations.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao, Guido Scarabelli & Barry Grant }
\details{ 
     If cmap is TRUE or provided a numerical matrix, the function inspects
     a set of cross-correlation matrices, or DCCM, and decides edges for 
     correlation network analysis based on:

        1. min(abs(cij)) >= cutoff.cij, or
        2. max(abs(cij)) >= cutoff.cij && residues contact each other 
           based on results from \code{cmap}.

     Otherwise, the function filters DCCMs with \code{cutoff.cij} and 
     return the mean of correlations present in at least 
     \code{cutoff.sims} calculated matrices.

     An internally guessed \code{cuoff.cij} is used if \code{cutoff.cij=NULL} is provided. 
     By default, the cutoff is determined by keeping 5\% of all residue pairs connected. 
}
\seealso{
   \code{\link{cna}}, \code{\link{dccm}}, \code{\link{dccm.nma}}, \code{\link{dccm.xyz}},
   \code{\link{cmap}}, \code{\link{plot.dccm}} 
}
\examples{

\dontrun{

# Example of transducin
attach(transducin)

gaps.pos <- gap.inspect(pdbs$xyz)
modes <- nma.pdbs(pdbs, ncore=NULL)
dccms <- dccm.enma(modes, ncore=NULL)

cij <- filter.dccm(dccms, xyz=pdbs)

# Example protein kinase
# Select Protein Kinase PDB IDs
ids <- c("4b7t_A", "2exm_A", "1opj_A", "4jaj_A", "1a9u_A",
                 "1tki_A", "1csn_A", "1lp4_A")

# Download and split by chain ID
files <- get.pdb(ids, path = "raw_pdbs", split=TRUE)

# Alignment of structures
pdbs <- pdbaln(files) # Sequence identity
summary(c(seqidentity(pdbs)))

# NMA on all structures
modes <- nma.pdbs(pdbs, ncore=NULL)

# Calculate correlation matrices for each structure
cij <- dccm(modes)

# Set DCCM plot panel names for combined figure
dimnames(cij$all.dccm) = list(NULL, NULL, ids)
plot.dccm(cij$all.dccm)

# Filter to display only correlations present in all structures
cij.all <- filter.dccm(cij, cutoff.sims = 8, cutoff.cij = 0)
plot.dccm(cij.all, main = "Consensus Residue Cross Correlation")

detach(transducin)
}

}
\keyword{analysis}

\name{normalize.vector}
\alias{normalize.vector}
\title{ Mass-Weighted Normalized Vector }
\description{
  Normalizes a vector (mass-weighted if requested).
}
\usage{
normalize.vector(x, mass=NULL)
}
\arguments{
  \item{x}{ a numeric vector or matrix to be normalized. }
  \item{mass}{ a numeric vector containing the atomic masses for
    weighting. }
}
\details{
  This function normalizes a vector, or alternatively, the column-wise
  vector elements of a matrix. If atomic masses are provided the vector
  is mass-weigthed. 
  
  See examples for more details.
}
\value{
  Returns the normalized vector(s).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma} }, \code{\link{inner.prod} } }
\examples{
x <- 1:3
y <- matrix(1:9, ncol = 3, nrow = 3)

normalize.vector(x)
normalize.vector(y)

## Application to normal modes
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Returns a vector
nv <- normalize.vector(modes$modes[,7])

## Returns a matrix
nv <- normalize.vector(modes$modes[,7:10])

## Mass-weighted
nv <- normalize.vector(modes$modes[,7], mass=modes$mass)
}
\keyword{ utilities }

\name{core.cmap}
\alias{core.cmap}
\title{ Identification of Contact Map Core Positions }
\description{
  Find core positions that have the largest number
  of contact with neighboring residues.
}
\usage{
core.cmap(pdbs, write.pdb = FALSE, outfile="core.pdb",
          cutoff = NULL, refine = FALSE, ncore = NULL, \dots)
}
\arguments{
  \item{pdbs}{ an alignment data structure of class \sQuote{pdbs} 
    as obtained with \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}, 
    or a numeric matrix of aligned C-alpha xyz Cartesian coordinates. }
  \item{write.pdb}{ logical, if TRUE core coordinate files, containing
    only core positions for each iteration, are written to a location
    specified by \code{outpath}. }
  \item{outfile}{ character string specifying the output directory when
    \code{write.pdb} is \sQuote{TRUE}. }  
  \item{cutoff}{ numeric value speciyfing the inclusion criteria for
    core positions. }
  \item{refine}{ logical, if TRUE explore core positions determined by
    multiple eigenvectors. By default only the eigenvector describing
    the largest variation is used. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    By default (\code{ncore=NULL}) use all cores detected. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  This function calculates eigenvector centrality of the weighted
  contact network built based on input structure data and uses it
  to determine the core positions.
  
  In this context, core positions correspond to the most invariant
  C-alpha atom positions across an aligned set of protein
  structures. Traditionally one would use the \code{core.find}
  function to for their identification and then use these positions as
  the basis for improved structural superposition. This more recent
  function utilizes a  much faster approach and is thus preferred in
  time sensitive applications such as shiny apps.
}
\value{
  Returns a list of class \code{"select"} containing \sQuote{atom} and
  \sQuote{xyz} indices.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao }
\seealso{
  \code{\link{core.find}},
  \code{\link{read.fasta.pdb}}, 
  \code{\link{fit.xyz}}
}
\examples{
\dontrun{
##-- Generate a small kinesin alignment and read corresponding structures
pdbfiles <- get.pdb(c("1bg2","2ncd","1i6i","1i5s"), URLonly=TRUE)
pdbs <- pdbaln(pdbfiles)

##-- Find 'core' positions
core <- core.cmap(pdbs)
xyz <- pdbfit(pdbs, core, outpath="corefit_structures")
}
}
\keyword{ utilities }

\name{trim.pdbs}
\alias{trim.pdbs}
\title{ Filter or Trim a PDBs Object }
\description{
  Trim residues and/or filter out structures from a PDBs object. 
}
\usage{
\method{trim}{pdbs}(pdbs, row.inds=NULL, col.inds=NULL, \dots)
}
\arguments{
  \item{pdbs}{ an object of class \code{pdbs} as obtained from
    function \code{pdbaln} or \code{read.fasta.pdb}; a xyz matrix
    containing the cartesian coordinates of C-alpha atoms. }
  \item{row.inds }{ a numeric vector of indices pointing to the PDB
    structures to keep (rows in the \code{pdbs$ali} matrix). }
  \item{col.inds }{ a numeric vector of indices pointing to the
    alignment columns to keep (columns in the \code{pdbs$ali} matrix). } 
  \item{\dots}{ additional arguments passed to and from functions. } 
}
\details{
  Utility function to remove structures, or trim off columns, in a   
  \sQuote{pdbs} object. 
}
\value{
  Returns an updated \sQuote{pdbs} object with the following
  components:
  \item{xyz}{numeric matrix of aligned C-alpha coordinates.}
  \item{resno}{character matrix of aligned residue numbers.}
  \item{b}{numeric matrix of aligned B-factor values.}
  \item{chain}{character matrix of aligned chain identifiers.}
  \item{id}{character vector of PDB sequence/structure names.}
  \item{ali}{character matrix of aligned sequences.}
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{pdbaln}}, \code{\link{gap.inspect}},
  \code{\link{read.fasta}},\code{\link{read.fasta.pdb}},
  \code{\link{trim.pdb}},
}
\examples{
\dontrun{
## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
raw.files <- get.pdb(ids, path = "raw_pdbs")
files <- pdbsplit(raw.files, ids, path = "raw_pdbs/split_chain")

## Sequence Alignement, and connectivity check
pdbs <- pdbaln(files)

cons <- inspect.connectivity(pdbs)

## omit files with missing residues
trim.pdbs(pdbs, row.inds=which(cons))
}
}
\keyword{ utilities }

\name{binding.site}
\alias{binding.site}
\title{ Binding Site Residues }
\description{
  Determines the interacting residues between two PDB entities.
}
\usage{
binding.site(a, b=NULL, a.inds=NULL, b.inds=NULL, cutoff=5,
            hydrogens=TRUE, byres=TRUE, verbose=FALSE)
}
\arguments{
  \item{a}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb}. }
  \item{b}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb}. }
  \item{a.inds}{ atom and xyz coordinate indices obtained from \code{atom.select}
    that selects the elements of \code{a} upon which the calculation
    should be based.}
  \item{b.inds}{ atom and xyz coordinate indices obtained from \code{atom.select}
    that selects the elements of \code{b} upon which the calculation
    should be based.}
  \item{cutoff}{ distance cutoff }
  \item{hydrogens}{ logical, if FALSE hydrogen atoms are omitted from
    the calculation. }
  \item{byres}{ logical, if TRUE all atoms in a contacting residue is
    returned. }
  \item{verbose}{ logical, if TRUE details of the selection are printed. }
}
\details{
  This function reports the residues of \code{a} closer than a cutoff to
  \code{b}. This is a wrapper function calling the underlying function
  \code{dist.xyz}.

  If \code{b=NULL} then \code{b.inds} should be elements of \code{a}
  upon which the calculation is based (typically chain A and B of the
  same PDB file).

  If \code{b=a.inds=b.inds=NULL} the function will use
  \code{\link{atom.select}} with arguments \code{"protein"} and
  \code{"ligand"} to determine receptor and ligand, respectively.
}
\value{
  Returns a list with the following components:
  \item{inds}{ object of class \code{select} with \code{atom} and
  \code{xyz} components. }
  \item{inds$atom}{ atom indices of \code{a}. }
  \item{inds$xyz}{ xyz indices of \code{a}. }
  \item{resnames}{ a character vector of interacting residues. }
  \item{resno}{ a numeric vector of interacting residues numbers. }
  \item{chain}{ a character vector of the associated chain identifiers
    of \code{"resno"}. }
  \item{call}{ the matched call. }
}
\references{
   Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}}, \code{\link{dm}} }
\examples{
   \donttest{
    # PDB server connection required - testing excluded

     pdb <- read.pdb('3dnd')

     ## automatically identify 'protein' and 'ligand'
     bs <- binding.site(pdb)

     bs$resnames
     #pdb$atom[bs$inds$atom, ]

     # provide indices
     rec.inds <- atom.select(pdb, chain="A", resno=1:350)
     lig.inds <- atom.select(pdb, chain="A", resno=351)
     bs <- binding.site(pdb, a.inds=rec.inds, b.inds=lig.inds)
   }


   \dontrun{  
     # Interaction between peptide and protein
     rec.inds <- atom.select(pdb, chain='A', resno=c(1:350))
     lig.inds <- atom.select(pdb, chain='I', resno=c(5:24))
     bs <- binding.site(pdb, a.inds=rec.inds, b.inds=lig.inds)
   }

   \donttest{
    # Redundant testing excluded

     # Interaction between two PDB entities   
     #rec <- read.pdb("receptor.pdb")
     #lig <- read.pdb("ligand.pdb")
     rec <- trim.pdb(pdb, inds=rec.inds)
     lig <- trim.pdb(pdb, inds=lig.inds)
     bs <- binding.site(rec, lig, hydrogens=FALSE)
   }
}
\keyword{ utilities }

\name{blast.pdb}
\alias{blast.pdb}
\alias{get.blast}
\alias{plot.blast}
\title{ NCBI BLAST Sequence Search and Summary Plot of Hit Statistics}
\description{
  Run NCBI blastp, on a given sequence, against the PDB, NR and
  swissprot sequence databases. Produce plots that facilitate hit selection
  from the match statistics of a BLAST result.
}
\usage{
blast.pdb(seq, database = "pdb", time.out = NULL, chain.single=TRUE)

get.blast(urlget, time.out = NULL, chain.single=TRUE)

\method{plot}{blast}(x, cutoff = NULL, cut.seed=NULL, cluster=TRUE, mar=c(2, 5, 1, 1), cex=1.5, ...)
}
\arguments{
  \item{seq}{ a single element or multi-element character vector
    containing the query sequence. Alternatively a \sQuote{fasta}
    object from function \code{get.seq} or \sQuote{pdb} object from 
    function \code{read.pdb} can be provided. }
  \item{database}{ a single element character vector specifying the
    database against which to search. Current options are \sQuote{pdb},
    \sQuote{nr} and \sQuote{swissprot}. }
  \item{time.out}{ integer specifying the number of seconds to wait for
    the blast reply before a time out occurs. }
  \item{urlget}{ the URL to retrieve BLAST results; Usually it is returned
    by blast.pdb if time.out is set and met. }
  \item{chain.single}{ logical, if TRUE double NCBI character PDB database  
    chain identifiers are simplified to lowercase '1WF4_GG' > '1WF4_g'. If 
    FALSE no conversion to match RCSB PDB files is performed. } 
  \item{x}{ BLAST results as obtained from the function
    \code{\link{blast.pdb}}. }
  \item{cutoff}{ A numeric cutoff value, in terms of minus the log of
    the evalue, for returned hits.  If null then the function will
    try to find a suitable cutoff near \sQuote{cut.seed} which can be used
    as an initial guide (see below). }
  \item{cut.seed}{ A numeric seed cutoff value, used for initial
    cutoff estimation. If null then a seed position is set to the point of 
    largest drop-off in normalized scores (i.e. the biggest jump in 
    E-values). }
  \item{cluster}{ Logical, if TRUE (and \sQuote{cutoff} is null) a clustering 
    of normalized scores is performed to partition hits in groups by 
    similarity to query. If FALSE the partition point is set to the point of largest drop-off in normalized scores. }
  \item{mar}{ A numerical vector of the form c(bottom, left, top, right)
    which gives the number of lines of margin to be specified on the
    four sides of the plot.}
  \item{cex}{ a numerical single element vector giving the amount by
    which plot labels should be magnified relative to the default. }
  \item{\dots}{ extra plotting arguments. }    
}
\details{
  The \code{blast.pdb} function employs direct HTTP-encoded requests to the NCBI web
  server to run BLASTP, the protein search algorithm of the BLAST
  software package.

  BLAST, currently the most popular pairwise sequence comparison algorithm 
  for database searching, performs gapped local alignments via a heuristic 
  strategy: it identifies short nearly exact matches or hits, bidirectionally 
  extends non-overlapping hits resulting in ungapped extended hits or 
  high-scoring segment pairs(HSPs), and finally extends the highest scoring 
  HSP in both directions via a gapped alignment (Altschul et al., 1997)

  For each pairwise alignment BLAST reports the raw score, bitscore
  and an E-value that assess the statistical significance of the
  raw score. Note that unlike the raw score E-values are normalized with
  respect to both the substitution matrix and the query and database lengths.

  Here we also return a corrected normalized score (mlog.evalue) that in
  our experience is easier to handle and store than conventional
  E-values. In practice, this score is equivalent to minus the natural
  log of the E-value. Note that, unlike the raw score, this score is
  independent of the substitution matrix and and the query and database
  lengths, and thus is comparable between BLASTP searches. 

  Examining plots of BLAST alignment lengths, scores, E-values and normalized
  scores (-log(E-Value) from the \code{blast.pdb} function can aid in the
  identification sensible hit similarity thresholds. This is facilitated by 
  the \code{plot.blast} function.

  If a \sQuote{cutoff} value is not supplied then a basic hierarchical
  clustering of normalized scores is performed with initial group partitioning
  implemented at a hopefully sensible point in the vicinity of
  \sQuote{h=cut.seed}. Inspection of the resultant plot can then be use
  to refine the value of \sQuote{cut.seed} or indeed
  \sQuote{cutoff}. As the \sQuote{cutoff} value can vary depending on
  the desired application and indeed the properties of the system under
  study it is envisaged that \sQuote{plot.blast} will be called multiple
  times to aid selection of a suitable \sQuote{cutoff} value. See the
  examples below for further details.
}
\value{
  The function \code{blast.pdb} returns a list with three components,
  \code{hit.tbl}, \code{raw}, and \code{url}. 
  The function \code{plot.blast} produces a plot on the 
  active graphics device and returns a list object with four components,
  \code{hits}, \code{pdb.id}, \code{acc}, and \code{inds}. See below:
 
  \item{hit.tbl }{ a data frame summarizing BLAST results for each
    reported hit. It contains following major columns:
    \itemize{
      \item \sQuote{bitscore}, a numeric vector containing the raw score for each
    alignment.
      \item \sQuote{evalue}, a numeric vector containing the E-value of the raw
    score for each alignment. 
      \item \sQuote{mlog.evalue}, a numeric vector containing minus the natural log
    of the E-value. 
      \item \sQuote{acc}, a character vector containing the accession database identifier of
    each hit.  
      \item \sQuote{pdb.id}, a character vector containing the PDB database identifier of
    each hit. 
   } 
  }
  \item{raw }{ a data frame containing the raw BLAST output. Note multiple
    hits may appear in the same row. }
  \item{url }{ a single element character vector with the NCBI result URL and 
    RID code. This can be passed to the get.blast function. }

  \item{hits}{ an ordered matrix detailing the subset of hits with a normalized
    score above the chosen cutoff. Database identifiers are listed along
    with their cluster group number. }
  \item{pdb.id}{ a character vector containing the PDB database identifier of
    each hit above the chosen threshold. }
  \item{acc}{ a character vector containing the accession database identifier of
    each hit above the chosen threshold. }
  \item{inds}{ a numeric vector containing the indices of the hits
    relative to the input blast object.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  \sQuote{BLAST} is the work of Altschul et al.:
  Altschul, S.F. et al. (1990) \emph{J. Mol. Biol.} \bold{215}, 403--410.
  
  Full details of the \sQuote{BLAST} algorithm, along with download and
  installation instructions can be obtained from:\cr
  \url{https://www.ncbi.nlm.nih.gov/BLAST/}.
}
\author{ Barry Grant }
\note{
  Online access is required to query NCBI blast services.
}
\seealso{ \code{\link{plot.blast}}, \code{\link{hmmer}}, \code{\link{seqaln}}, \code{\link{get.pdb}} }
\examples{
\dontrun{
pdb <- read.pdb("4q21")
blast <- blast.pdb( pdbseq(pdb) )

head(blast$hit.tbl)
top.hits <- plot(blast)
head(top.hits$hits)

## Use 'get.blast()' to retrieve results at a later time.
#x <- get.blast(blast$url)
#head(x$hit.tbl)

# Examine and download 'best' hits
top.hits <- plot.blast(blast, cutoff=188)
head(top.hits$hits)
#get.pdb(top.hits)
}
}
\keyword{ utilities }
\keyword{ hplot }

\name{plot.geostas}
\alias{plot.geostas}
\title{ Plot Geostas Results }
\description{
  Plot an atomic movement similarity matrix with domain annotation
}
\usage{
\method{plot}{geostas}(x, at=seq(0, 1, 0.1), main="AMSM with Domain Assignment",
                         col.regions=rev(heat.colors(200)), 
                         margin.segments=x$grps, ...)
}
\arguments{
  \item{x}{ an object of type \code{geostas} as obtained by the
    \sQuote{geostas} function. } 
  \item{at}{ numeric vector specifying the levels to be colored. }
  \item{main}{ a main title for the plot. }
  \item{col.regions}{ color vector. See \code{contourplot} for more 
    information. }
  \item{margin.segments}{ a numeric vector of cluster membership as 
    obtained from cutree() or other community detection method. This 
    will be used for bottom and left margin annotation. }
  \item{\dots}{ additional graphical parameters for
    \code{\link{plot.dccm}} and \code{contourplot}. }
}
\details{
  This is a wrapper function for \code{\link{plot.dccm}} with appropriate
  adjustments for plotting atomic movement similarity matrix obtained
  from function \code{\link{geostas}}. 
  
  See the \code{\link{plot.dccm}} for more details.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{
  \code{\link{plot.dccm}}, \code{\link{geostas}}
}
\keyword{ hplot }

\name{torsion.pdb}
\alias{torsion.pdb}
\title{ Calculate Mainchain and Sidechain Torsion/Dihedral Angles }
\description{
  Calculate all torsion angles for a given protein PDB structure object.
}
\usage{
torsion.pdb(pdb)
}
\arguments{
  \item{pdb}{ a PDB structure object as obtained from
    function \code{read.pdb}. }
}
\details{
  The conformation of a polypeptide chain can be usefully described in
  terms of angles of internal rotation around its constituent bonds. See
  the related \code{torsion.xyz} function, which is called by this
  function, for details.
}
\value{
  Returns a list object with the following components:
  \item{phi}{ main chain torsion angle for atoms C,N,CA,C. }
  \item{psi}{ main chain torsion angle for atoms N,CA,C,N. }
  \item{omega}{ main chain torsion angle for atoms CA,C,N,CA. }
  \item{alpha}{ virtual torsion angle between consecutive C-alpha atoms. }
  \item{chi1}{ side chain torsion angle for atoms N,CA,CB,*G. }
  \item{chi2}{ side chain torsion angle for atoms CA,CB,*G,*D. }
  \item{chi3}{ side chain torsion angle for atoms CB,*G,*D,*E. }
  \item{chi4}{ side chain torsion angle for atoms *G,*D,*E,*Z. }
  \item{chi5}{ side chain torsion angle for atoms *D,*E,*Z, NH1. }
  \item{coords}{ numeric matrix of \sQuote{justified} coordinates. }
  \item{tbl}{ a numeric matrix of psi, phi and chi torsion angles. }
  
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{ 
  For the protein backbone, or main-chain atoms, the partial double-bond
  character of the peptide bond between \sQuote{C=N} atoms severely restricts
  internal rotations.  In contrast, internal rotations around the single
  bonds between \sQuote{N-CA} and \sQuote{CA-C} are only restricted by
  potential steric collisions. Thus, to a good approximation, the
  backbone conformation of each residue in a given polypeptide chain can
  be characterised by the two angles phi and psi.

  Sidechain conformations can also be described by angles of internal
  rotation denoted chi1 up to chi5 moving out along the sidechain.
}
\seealso{ \code{\link{torsion.xyz}}, \code{\link{read.pdb}},
  \code{\link{dssp}}, \code{\link{stride}}. }
\examples{
\donttest{
# PDB server connection required - testing excluded

##-- PDB torsion analysis
pdb <- read.pdb( "1bg2" )
tor <- torsion.pdb(pdb)
head(tor$tbl)

## basic Ramachandran plot
plot(tor$phi, tor$psi)

## torsion analysis of a single coordinate vector 
#inds <- atom.select(pdb,"calpha")
#tor.ca <- torsion.xyz(pdb$xyz[inds$xyz], atm.inc=1)

##-- Compare two PDBs to highlight interesting residues
aln <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
m <- read.fasta.pdb(aln)
a <- torsion.xyz(m$xyz[1,],1)
b <- torsion.xyz(m$xyz[2,],1)
d <- wrap.tor(a-b)
plot(m$resno[1,],d, typ="h")
}
}
\keyword{ utilities }

\name{dccm.xyz}
\alias{dccm.xyz}
\title{ Dynamical Cross-Correlation Matrix from Cartesian Coordinates }
\description{
  Determine the cross-correlations of atomic displacements.
}
\usage{
\method{dccm}{xyz}(x, reference = NULL, grpby=NULL, method=c("pearson", "lmi"),
                   ncore=1, nseg.scale=1, \dots)
}
\arguments{
  \item{x}{ a numeric matrix of Cartesian coordinates with a row per
    structure/frame. }
  \item{reference}{ The reference structure about which displacements are
    analysed. }
  \item{grpby}{ a vector counting connective duplicated elements that
    indicate the elements of \code{xyz} that should be considered as a group
    (e.g. atoms from a particular residue). }
  \item{method}{ method to calculate the cross-correlation. Currently supports
    Pearson and linear mutual information (LMI). }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore=NULL} will use all the cores detected. } 
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
  \item{\dots}{ Additional arguments to be passed (currently ignored). }
}
\details{
  The extent to which the atomic fluctuations/displacements of a system are
  correlated with one another can be assessed by examining the magnitude
  of all pairwise cross-correlation coefficients (see McCammon and Harvey,
  1986).

  This function returns a matrix of all atom-wise cross-correlations
  whose elements, Cij, may be displayed in a graphical representation
  frequently termed a dynamical cross-correlation map, or DCCM.

  If Cij = 1 the fluctuations of atoms i and j are completely correlated
  (same period and same phase), if Cij = -1 the fluctuations of atoms i
  and j are completely anticorrelated (same period and opposite phase),
  and if Cij = 0 the fluctuations of i and j are not correlated.

  Typical characteristics of DCCMs include a line of strong
  cross-correlation along the diagonal, cross-correlations emanating
  from the diagonal, and off-diagonal cross-correlations. The high
  diagonal values occur where i = j, where Cij is always equal to
  1.00. Positive correlations emanating from the diagonal indicate
  correlations between contiguous residues, typically within a secondary
  structure element or other tightly packed unit of structure.
  Typical secondary structure patterns include a triangular pattern for
  helices and a plume for strands.  Off-diagonal positive and negative
  correlations may indicate potentially interesting correlations between
  domains of non-contiguous residues.

  If \code{method = "pearson"}, the conventional Pearson's inner-product 
  correlaiton calculation will be invoked, in which only the diagnol of 
  each atom-atom variance-covariance sub-matrix is considered. 

  If \code{method = "lmi"}, then the linear mutual information
  cross-correlation will be calculated. \sQuote{LMI} considers both
  diagnol and off-diagnol entries in the sub-matrices, and so even captures 
  the correlation of atoms moving in orthognal directions.
  
}
\value{
  Returns a cross-correlation matrix with values in a range from -1 to 1 (Pearson)
  or from 0 to 1 (LMI).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  McCammon, A. J. and Harvey, S. C. (1986) \emph{Dynamics of
  Proteins and Nucleic Acids}, Cambridge University Press, Cambridge.

  Lange, O.F. and Grubmuller, H. (2006) \emph{PROTEINS: Structure, Function, and Bioinformatics} \bold{62}:1053--1061.
}
\author{ Xin-Qiu Yao, Hongyang Li, Gisle Saelensminde, and Barry Grant }

\seealso{ \code{\link{cor}} for examining xyz cross-correlations,
  \code{\link{dccm}}, \code{\link{dccm.nma}},
  \code{\link{dccm.pca}}, \code{\link{dccm.enma}}. }
  
\examples{
\donttest{

##-- Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## select residues 24 to 27 and 85 to 90 in both chains
inds <- atom.select(pdb, resno=c(24:27,85:90), elety='CA')

## lsq fit of trj on pdb
xyz <- fit.xyz(pdb$xyz, trj, fixed.inds=inds$xyz, mobile.inds=inds$xyz)

## DCCM (slow to run so restrict to Calpha)
cij <- dccm(xyz)

## Plot DCCM
plot(cij)

## Or
library(lattice)
contourplot(cij, region = TRUE, labels=FALSE, col="gray40",
            at=c(-1, -0.75, -0.5, -0.25, 0.25, 0.5, 0.75, 1),
            xlab="Residue No.", ylab="Residue No.",
            main="DCCM: dynamic cross-correlation map")
            
## LMI matrix
cij <- dccm(xyz, method='lmi')

## Plot LMI matrix
#plot(cij)
col.scale <- colorRampPalette(c("gray95", "cyan"))(5)
plot(cij, at=seq(0.4,1, length=5), col.regions=col.scale)
}

}
\keyword{ utilities }

\name{print.xyz}
\alias{print.xyz}
\title{ Printing XYZ coordinates }
\description{
    Print method for objects of class \sQuote{xyz}.
}
\usage{
\method{print}{xyz}(x, ...)
}
\arguments{
  \item{x}{ a \sQuote{xyz} object indicating 3-D coordinates of 
    biological molecules. }
  \item{\dots}{ additional arguments passed to \sQuote{print}. }
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.}
\author{ Barry Grant }
\seealso{
  \code{\link{is.xyz}}, \code{\link{read.ncdf}},
  \code{\link{read.pdb}}, \code{\link{read.dcd}}, \code{\link{fit.xyz}}
}
\examples{

# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
print(pdb$xyz)

}
\keyword{ utilities }

\name{atom.select}
\alias{atom.select}
\alias{atom.select.pdb}
\alias{atom.select.pdbs}
\alias{atom.select.mol2}
\alias{atom.select.prmtop}
\alias{print.select}
\title{ Atom Selection from PDB and PRMTOP Structure Objects }
\description{
  Return the \sQuote{atom} and \sQuote{xyz} coordinate indices of
  \sQuote{pdb} or \sQuote{prmtop} structure objects corresponding to the
  intersection of a hierarchical selection.
}
\usage{
atom.select(\dots)

\method{atom.select}{pdb}(pdb, string = NULL,
                          type  = NULL, eleno = NULL, elety = NULL,
                          resid = NULL, chain = NULL, resno = NULL,
                          insert = NULL, segid = NULL, 
                          operator = "AND", inverse = FALSE,
                          value = FALSE, verbose=FALSE, \dots)
\method{atom.select}{pdbs}(pdbs, string = NULL, 
                           resno = NULL, chain = NULL, resid = NULL,
                           operator="AND", inverse = FALSE,
                           value = FALSE, verbose=FALSE, \dots)
\method{atom.select}{mol2}(mol, string=NULL,
                           eleno = NULL, elena = NULL, elety = NULL,
                           resid = NULL, chain = NULL, resno = NULL,
                           statbit = NULL,
			   operator = "AND", inverse = FALSE,
                           value = FALSE, verbose=FALSE,  \dots)

\method{atom.select}{prmtop}(prmtop, ...)

\method{print}{select}(x, \dots)
}
\arguments{
  \item{\dots}{ arguments passed to \code{atom.select.pdb},
    \code{atom.select.prmtop}, or \code{print}. }
  \item{pdb}{ a structure object of class \code{"pdb"}, obtained from
    \code{\link{read.pdb}}. }
  \item{pdbs}{ a numeric matrix of aligned C-alpha xyz Cartesian
    coordinates as obtained with \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}. }
  \item{string}{ a single selection keyword from \code{calpha}
    \code{cbeta} \code{backbone} \code{sidechain} \code{protein}
    \code{nucleic} \code{ligand} \code{water} \code{h} or \code{noh}. }
  \item{type}{ a single element character vector for selecting \sQuote{ATOM}
    or \sQuote{HETATM} record types. }
  \item{eleno}{ a numeric vector of element numbers. }
  \item{elena}{ a character vector of atom names. }
  \item{elety}{ a character vector of atom names. }
  \item{resid}{ a character vector of residue name identifiers. }
  \item{chain}{ a character vector of chain identifiers. }
  \item{resno}{ a numeric vector of residue numbers. }
  \item{insert}{ a character vector of insert identifiers. Non-insert 
    residues can be selected with \code{NA} or \sQuote{} values. The default value 
    of \code{NULL} will select both insert and non-insert residues. }
  \item{segid}{ a character vector of segment identifiers. Empty segid
    values can be selected with \code{NA} or \sQuote{} values. The default value
    of \code{NULL} will select both empty and non-empty segment identifiers. }
  \item{operator}{ a single element character specifying either the AND
    or OR operator by which individual selection components should be
    combined. Allowed values are \sQuote{"AND"} and \sQuote{"OR"}. }
  \item{verbose}{ logical, if TRUE details of the selection are printed. }
  \item{inverse}{ logical, if TRUE the inversed selection is retured
    (i.e. all atoms NOT in the selection). }
  \item{value}{ logical, if FALSE, vectors containing the (integer) indices of
    the matches determined by \code{atom.select} are returned, and if TRUE,
    a \code{pdb} object containing the matching atoms themselves is
    returned. }
  \item{mol}{ a structure object of class \code{"mol2"}, obtained from
    \code{\link{read.mol2}}. }
  \item{statbit}{ a character vector of statbit identifiers. }
  \item{prmtop}{ a structure object of class \code{"prmtop"}, obtained from
    \code{\link{read.prmtop}}. }
  \item{x}{ a atom.select object as obtained from
    \code{\link{atom.select}}.  }
}
\details{
  This function allows for the selection of atom and coordinate data
  corresponding to the intersection of various input criteria.

  Input selection criteria include selection \code{string} keywords (such as
  \code{"calpha"}, \code{"backbone"}, \code{"sidechain"},  \code{"protein"},
  \code{"nucleic"}, \code{"ligand"}, etc.) and individual named
  selection components (including \sQuote{chain},  \sQuote{resno},
  \sQuote{resid}, \sQuote{elety} etc.).

  For example, \code{atom.select(pdb, "calpha")} will return indices for
  all C-alpha (CA) atoms found in protein residues in the \code{pdb}
  object, \code{atom.select(pdb, "backbone")} will return indices
  for all protein N,CA,C,O atoms, and \code{atom.select(pdb, "cbeta")}
  for all protein N,CA,C,O,CB atoms. 

  Note that keyword \code{string} shortcuts can be combined with individual
  selection components, e.g. \code{atom.select(pdb, "protein", chain="A")}
  will select all protein atoms found in chain A.

  Selection criteria are combined according to the provided
  \code{operator} argument. The default operator \code{AND} (or \code{&}) will
  combine by intersection while \code{OR} (or \code{|}) will take the union.

  For example, \code{atom.select(pdb, "protein", elety=c("N", "CA", "C"),
  resno=65:103)} will select the N, CA, C atoms in the protein residues
  65 through 103, while \code{atom.select(pdb, "protein", resid="ATP",
  operator="OR")} will select all protein atoms as well as any ATP
  residue(s).

  Other \code{string} shortcuts include:
  \code{"calpha"}, \code{"back"}, \code{"backbone"}, \code{"cbeta"},
  \code{"protein"}, \code{"notprotein"}, \code{"ligand"},
  \code{"water"}, \code{"notwater"}, \code{"h"}, \code{"noh"},
  \code{"nucleic"}, and \code{"notnucleic"}.

  In addition, the \code{\link{combine.select}} function can further combine atom
  selections using \sQuote{AND}, \sQuote{OR}, or \sQuote{NOT} logical
  operations.

}
\note{
  Protein atoms are defined as any atom in a residue matching the
  residue name in the attached \code{aa.table} data frame. See
  \code{aa.table$aa3} for a complete list of residue names.

  Nucleic atoms are defined as all atoms found in residues with names A,
  U, G, C, T, I, DA, DU, DG, DC, DT, or DI.

  Water atoms/residues are defined as those with residue names H2O, OH2,
  HOH, HHO, OHH, SOL, WAT, TIP, TIP, TIP3, or TIP4.
}
\value{
  Returns a list of class \code{"select"} with the following components:
  \item{atom}{ a numeric matrix of atomic indices. }
  \item{xyz }{ a numeric matrix of xyz indices. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{
  \code{\link{read.pdb}}, \code{\link{as.select}},
  \code{\link{combine.select}}, \code{\link{trim.pdb}},
  \code{\link{write.pdb}}, \code{\link{read.prmtop}},
  \code{\link{read.crd}}, \code{\link{read.dcd}},
  \code{\link{read.ncdf}}.
}
\examples{

##- PDB example
# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

# Select protein atoms of chain A
atom.select(pdb, "protein", chain="A")

# Select all atoms except from the protein
atom.select(pdb, "protein", inverse=TRUE, verbose=TRUE)

# Select all C-alpha atoms with residues numbers between 43 and 54
sele <- atom.select(pdb, "calpha", resno=43:54, verbose=TRUE)

# Access the PDB data with the selection indices
print( pdb$atom[ sele$atom, "resid" ] )
print( pdb$xyz[ sele$xyz ] )

# Trim PDB to selection
ca.pdb <- trim.pdb(pdb, sele)

\dontrun{

##- PRMTOP example
prmtop <- read.prmtop(system.file("examples/crambin.prmtop", package="bio3d"))

## Atom selection
ca.inds <- atom.select(prmtop, "calpha")

}
}
\keyword{utilities}

\name{plot.cna}
\alias{plot.cna}
\alias{plot.ecna}
\title{ Protein Structure Network Plots in 2D and 3D.  }
\description{
  Plot a protein dynamic network as obtained from the \emph{cna} function.
}
\usage{
  \method{plot}{cna}(x, pdb = NULL, weights=NULL, vertex.size=NULL,
            layout=NULL, col=NULL, full=FALSE, scale=TRUE, color.edge = FALSE, 
            interactive=FALSE, ...)
  \method{plot}{ecna}(x, \dots)
}
\arguments{
  \item{x}{ A protein network graph object (or a list of such objects) as obtained from the
    \sQuote{cna} function. }
  \item{pdb}{ A PDB structure object obtained from \sQuote{read.pdb}. 
    If supplied this will be used to guide the network plot \sQuote{layout}, 
    see \sQuote{layout.cna} for details. }    
  \item{weights}{ A numeric vector containing the edge weights for the
    network. }
  \item{vertex.size}{ A numeric vector of node/community sizes. If NULL
    the size will be taken from the input network graph object \sQuote{x}. 
    Typically for \sQuote{full=TRUE} nodes will be of an equal size and 
    for \sQuote{full=FALSE} community node size will be proportional to 
    the residue membership of each community. }
  \item{layout}{ Either a function or a numeric matrix. It specifies how the
    vertices will be placed on the plot. See \sQuote{layout.cna}. }
  \item{col}{ A vector of colors used for node/vertex rendering. If NULL
    these values are taken from the input network
    \sQuote{V(x$community.network)$color}. }
  \item{full}{ Logical, if TRUE the full all-atom network rather than the 
    clustered community network will be plotted. }    
  \item{scale}{ Logical, if TRUE weights are scaled with respect to the network. }   
  \item{color.edge}{ Logical, if TRUE edges are colored with respect to their weights. }   
  \item{interactive}{ Logical, if TRUE interactive graph will be drawn where users
    can manually adjust the network (positions of vertices, colors of edges, etc.).
    Needs Tcl/Tk support in the installed R build. }
  \item{\dots}{ Additional graphical parameters for \sQuote{plot.igraph}. }
}
\details{
  This function calls \sQuote{plot.igraph} from the igraph package to 
  plot cna networks the way we like them.

  The plot layout is user settable, we like the options of: 
  \sQuote{layout.cna}, \sQuote{layout.fruchterman.reingold},  
  \sQuote{layout.mds} or \sQuote{layout.svd}. Note that first of these 
  uses PDB structure information to produce a more meaningful layout.

  Extensive plot modifications are possible by setting additional graphical 
  parameters (\dots). These options are detailed in \sQuote{igraph.plotting}. 
  Common parameters to alter include:

  \describe{
    \item{vertex.label:}{Node labels, \code{V(x$network)$name}. Use NA to omit.}
    \item{vertex.label.color:}{Node label colors, see also \code{vertex.label.cex} etc. }
    \item{edge.color:}{Edge colors,  \code{E(x$network)$color}. }
    \item{mark.groups:}{Community highlighting, a community list object, see also \code{mark.col} etc.}
  }
  
}
\value{
  Produces a network plot on the active graphics device.
  Also returns the plot layout coordinates silently, which can be passed to the 
  \sQuote{identify.cna} function.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant and Guido Scarabelli }
\note{ Be sure to check the correspondence of your \sQuote{pdb} object with your
  network object \sQuote{x}, as few internal checks are currently performed by the 
  \sQuote{layout.cna} function.
}
\seealso{ \code{\link[igraph:plot.igraph]{plot.igraph}}, 
  \code{\link[igraph:communities]{plot.communities}},
  \code{\link[igraph:plot.common]{igraph.plotting}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

##-- Build a CNA object
pdb <- read.pdb("4Q21")
modes <- nma(pdb)
cij <- dccm(modes)
net <- cna(cij, cutoff.cij=0.2)

# Plot coarse grain network based on dynamically coupled communities
xy <- plot.cna(net)
#plot.dccm(cij, margin.segments=net$communities$membership)

# Chose a different PDB informed layout for plot
plot.cna(net, pdb)

# Play with plot layout and colors...
plot.cna(net, layout=igraph::layout.mds(net$community.network), col=c("blue","green") ) 

# Plot full residue network colored by communities - will be slow due to number of edges!!
plot.cna(net, pdb, full=TRUE)

# Alter plot settings
plot.cna(net, pdb, full=TRUE, vertex.size=3, weights=1, vertex.label=NA)

}
}
}
\keyword{ hplot }

\name{dist.xyz}
\alias{dist.xyz}
\title{  Calculate the Distances Between the Rows of Two Matrices }
\description{
  Compute the pairwise euclidean distances between the rows of two matrices.
}
\usage{
dist.xyz(a, b = NULL, all.pairs=TRUE, ncore=1, nseg.scale=1)
}
\arguments{
  \item{a}{ a \sQuote{xyz} object, numeric data matrix, or vector. }
  \item{b}{ an optional second \sQuote{xyz} object, data matrix, or vector. }
  \item{all.pairs}{  logical, if TRUE all pairwise distances between the
    rows of \sQuote{a} and all rows of \sQuote{b} are computed, if FALSE
    only the distances between coresponding rows of \sQuote{a} and
    \sQuote{b} are computed. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
}
\details{
 This function returns a matrix of euclidean distances between each row
 of \sQuote{a} and all rows of \sQuote{b}.  Input vectors are
 coerced to three dimensional matrices (representing the Cartesian
 coordinates x, y and z) prior to distance computation.  If \sQuote{b} is
 not provided then the pairwise distances between all rows of \sQuote{a}
 are computed.
}
\value{
  Returns a matrix of pairwise euclidean distances between each row of
  \sQuote{a} and all rows of \sQuote{b}.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  This function will choke if \sQuote{b} has too many rows.
}
\seealso{ \code{\link{dm}}, \code{\link{dist}} }
\examples{
 dist.xyz( c(1,1,1, 3,3,3), c(3,3,3, 2,2,2, 1,1,1))
 dist.xyz( c(1,1,1, 3,3,3), c(3,3,3, 2,2,2, 1,1,1), all.pairs=FALSE)

}
\keyword{ utilities }

\name{pdbaln}
\alias{pdbaln}
\title{ Sequence Alignment of PDB Files }
\description{
  Create multiple sequences alignments from a list of PDB files
  returning aligned sequence and structure records.
}
\usage{
pdbaln(files, fit = FALSE, pqr = FALSE, ncore = 1,
       nseg.scale = 1, progress = NULL, ...) 
}
\arguments{
  \item{files}{ a character vector of PDB file names. Alternatively, a
    list of \code{pdb} objects can be provided. }
  \item{fit}{ logical, if TRUE coordinate superposition is performed on
    the input structures. }
  \item{pqr}{ logical, if TRUE the input structures are assumed to be in
  PQR format. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
  \item{progress}{ progress bar for use with shiny web app. }
  \item{\dots}{ extra arguments passed to \code{seqaln} function. }
}
\details{
  This wrapper function calls the underlying functions \code{read.pdb},
  \code{pdbseq}, \code{seqaln} and \code{read.fasta.pdb} returning a
  list of class \code{"pdbs"} similar to that returned by
  \code{read.fasta.pdb}.

  As these steps are often error prone it is recomended for most cases that
  the individual underlying functions are called in sequence with checks
  made on the valadity of their respective outputs to ensure sensible
  results.
}
\value{
  Returns a list of class \code{"pdbs"} with the following five
  components:
  \item{xyz}{numeric matrix of aligned C-alpha coordinates.}
  \item{resno}{character matrix of aligned residue numbers.}
  \item{b}{numeric matrix of aligned B-factor values.}
  \item{chain}{character matrix of aligned chain identifiers.}
  \item{id}{character vector of PDB sequence/structure names.}
  \item{ali}{character matrix of aligned sequences.}
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{ See recommendation in details section above. }
\seealso{
  \code{\link{read.pdb}}, \code{\link{pdbseq}}, \code{\link{seqaln}},
  \code{\link{read.fasta}},\code{\link{read.fasta.pdb}},
  \code{\link{core.find}}, \code{\link{fit.xyz}}, \code{\link{read.all}},
  \code{\link{pymol.pdbs}}
}
\examples{
\dontrun{
##- Align PDBs (from vector of filenames)
#files <- get.pdb(c("4q21","5p21"), URLonly=TRUE)
files <- get.pdb(c("4q21","5p21"), path=tempdir(), overwrite=TRUE)
pdbaln(files)


##- Align PDBs (from list of existing PDB objects)
pdblist <- list(read.pdb(files[1]), read.pdb(files[2]))
pdbaln(pdblist)

}
}
\keyword{ utilities }

\name{read.dcd}
\alias{read.dcd}
\title{ Read CHARMM/X-PLOR/NAMD Binary DCD files }
\description{
  Read coordinate data from a binary DCD trajectory file.
}
\usage{
read.dcd(trjfile, big=FALSE, verbose = TRUE, cell = FALSE)
}
\arguments{
  \item{trjfile}{ name of trajectory file to read. A vector if 
    treat a batch of files }
  \item{big}{ logical, if TRUE attempt to read large files into a
    big.matrix object }
  \item{verbose}{ logical, if TRUE print details of the reading
    process. }
  \item{cell}{logical, if TRUE return cell information only.
  Otherwise, return coordinates.}    
}
\details{
  Reads a CHARMM or X-PLOR/NAMD binary trajectory file with either big-
  or little-endian storage formats.
  
  Reading is accomplished with two different sub-functions:
  \code{dcd.header}, which reads header info, and \code{dcd.frame}, which
  takes header information and reads atoms frame by frame producing an
  nframes/natom*3 matrix of cartesian coordinates or an nframes/6 matrix
  of cell parameters.

}
\value{
   A numeric matrix of xyz coordinates with a frame/structure per row and
   a Cartesian coordinate per column or a numeric matrix of cell information 
   with a frame/structure per row and lengths and angles per column.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  See CHARMM documentation for DCD format description.

  If you experience problems reading your trajectory file with read.dcd()
  consider first reading your file into VMD and from there exporting a
  new DCD trajectory file with the 'save coordinates' option. This new
  file should be easily read with read.dcd().

   Error messages beginning 'cannot allocate vector of size' indicate a
   failure to obtain memory, either because the size exceeded the
   address-space limit for a process or, more likely, because the system
   was unable to provide the memory. Note that on a 32-bit OS there may
   well be enough free memory available, but not a large enough
   contiguous block of address space into which to map it. In such cases
   try setting the input option 'big' to TRUE. This is an experimental
   option that results in a 'big.matrix' object.

}
\seealso{ \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{atom.select}} }
\examples{
\donttest{
# Redundant testing excluded

##-- Read cell parameters from example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile, cell = TRUE)
##-- Read coordinates from example trajectory file
trj <- read.dcd(trtfile)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## select residues 24 to 27 and 85 to 90 in both chains
inds <- atom.select(pdb, resno=c(24:27,85:90), elety='CA')

## lsq fit of trj on pdb
xyz <- fit.xyz(pdb$xyz, trj, fixed.inds=inds$xyz, mobile.inds=inds$xyz)

##-- RMSD of trj frames from PDB
r1 <- rmsd(a=pdb, b=xyz)
}

\dontrun{
# Pairwise RMSD of trj frames for positions 47 to 54
flap.inds <- atom.select(pdb, resno=c(47:54), elety='CA')
p <- rmsd(xyz[,flap.inds$xyz])
# plot highlighting flap opening?
plot.dmat(p, color.palette = mono.colors)
}

}
\keyword{ IO }

\name{as.select}
\alias{as.select}
\title{ Convert Atomic Indices to a Select Object }
\description{
  Convert atomic indices to a select object with \sQuote{atom} and
  \sQuote{xyz} components.
}
\usage{
as.select(x, \dots)
}
\arguments{
  \item{x}{ a numeric vector containing atomic indices to be converted
    to a \sQuote{select} object. Alternatively, a logical vector can be
    provided. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  Convert atomic indices to a select object with \sQuote{atom} and
  \sQuote{xyz} components. 
}
\value{
  Returns a list of class \code{"select"} with the following components:
  \item{atom}{ a numeric matrix of atomic indices. }
  \item{xyz }{ a numeric matrix of xyz indices. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{atom.select}}, \code{\link{read.pdb}}
}
\examples{
as.select(c(1,2,3))
}
\keyword{ utilities }

\name{struct.aln}
\alias{struct.aln}
\title{ Structure Alignment Of Two PDB Files }
\description{
  Performs a sequence and structural alignment of two PDB entities.
}
\usage{
struct.aln(fixed, mobile, fixed.inds=NULL, mobile.inds=NULL, 
           write.pdbs=TRUE, outpath = "fitlsq", prefix=c("fixed",
           "mobile"), max.cycles=10, cutoff=0.5, ... )
}
\arguments{
  \item{fixed}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb}. }
  \item{mobile}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb}. }
  \item{fixed.inds}{ atom and xyz coordinate indices obtained from
    \code{atom.select} that selects the elements of \code{fixed} upon
    which the calculation should be based.}
  \item{mobile.inds}{ atom and xyz coordinate indices obtained from
    \code{atom.select} that selects the elements of \code{mobile} upon
    which the calculation should be based.}
  \item{write.pdbs}{ logical, if TRUE the aligned structures are written
    to PDB files.}
  \item{outpath}{ character string specifing the output directory when
    \code{write.pdbs} is TRUE. }
  \item{prefix}{ a character vector of length 2 containing the filename
    prefix in which the fitted structures should be written. }
  \item{max.cycles}{ maximum number of refinement cycles.}
  \item{cutoff}{ standard deviation of the pairwise distances for
    aligned residues at which the fitting refinement stops.}
  \item{\dots}{ extra arguments passed to \code{seqaln} function.}
}
\details{
  This function performs a sequence alignment followed by a structural
  alignment of the two PDB entities. Cycles of refinement steps of the
  structural alignment are performed to improve the fit by removing
  atoms with a high structural deviation. The primary purpose of the
  function is to allow rapid structural alignment (and RMSD analysis)
  for protein structures with unequal, but related sequences.

  The function reports the residues of \code{fixed} and \code{mobile}
  included in the final structural alignment, as well as the related
  RMSD values.
  
  This function makes use of the underlying functions \code{seqaln},
  \code{rot.lsq}, and \code{rmsd}.
}
\value{
  Returns a list with the following components:
  \item{a.inds}{ atom and xyz indices of \code{fixed}. }
  \item{b.inds}{ atom and xyz indices of \code{mobile}. }
  \item{xyz}{ fitted xyz coordinates of \code{mobile}. }
  \item{rmsd}{ a numeric vector of RMSD values after each cycle of
    refinement. }
}
\references{
   Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjarven }
\seealso{ \code{\link{rmsd}}, \code{\link{rot.lsq}},
  \code{\link{seqaln}}, \code{\link{pdbaln}} }
\examples{
\donttest{
# Needs MUSCLE installed - testing excluded

if(check.utility("muscle")) {

     ## Stucture of PKA:
     a <- read.pdb("1cmk")

     ## Stucture of PKB:
     b <- read.pdb("2jdo")

     ## Align and fit b on to a:
     path = file.path(tempdir(), "struct.aln")
     aln <- struct.aln(a, b, outpath = path, outfile = tempfile())
     
     ## Should be the same as aln$rmsd (when using aln$a.inds and aln$b.inds)
     rmsd(a$xyz, b$xyz, aln$a.inds$xyz, aln$b.inds$xyz, fit=TRUE)
     
     invisible( cat("\nSee the output files:", list.files(path, full.names = TRUE), sep="\n") )
}
}

\dontrun{
     ## Align two subunits of GroEL (open and closed states)
     a <- read.pdb("1sx4")
     b <- read.pdb("1xck")

     ## Select chain A only
     a.inds <- atom.select(a, chain="A")
     b.inds <- atom.select(b, chain="A")

     ## Align and fit:
     aln <- struct.aln(a,b, a.inds, b.inds)
}
}
\keyword{ utilities }

\name{dssp}
\alias{dssp}
\alias{dssp.pdb}
\alias{dssp.pdbs}
\alias{dssp.xyz}
\alias{stride}
\alias{print.sse}
\title{ Secondary Structure Analysis with DSSP or STRIDE }
\description{
  Secondary structure assignment according to the method of Kabsch and Sander (DSSP)
  or the method of Frishman and Argos (STRIDE).
}
\usage{
dssp(\dots)

\method{dssp}{pdb}(pdb, exefile = "dssp", resno=TRUE, full=FALSE, verbose=FALSE, \dots)

\method{dssp}{pdbs}(pdbs, \dots)

\method{dssp}{xyz}(xyz, pdb, \dots)

stride(pdb, exefile = "stride", resno=TRUE)

\method{print}{sse}(x, \dots)
}
\arguments{
  \item{pdb}{ a structure object of class \code{"pdb"}, obtained from
    \code{\link{read.pdb}}. }
  \item{exefile}{ file path to the \sQuote{DSSP} or \sQuote{STRIDE} program 
    on your system (i.e. how is \sQuote{DSSP} or \sQuote{STRIDE} invoked). }
  \item{resno}{ logical, if TRUE output is in terms of residue numbers
    rather than residue index (position in sequence). }
  \item{full}{ logical, if TRUE bridge pairs and hbonds columns are
    parsed. }
  \item{verbose}{ logical, if TRUE \sQuote{DSSP} warning and error
    messages are printed. }
  \item{pdbs}{ a list object of class \code{"pdbs"} (obtained with
    \code{\link{pdbaln}} or \code{\link{read.fasta.pdb}}). }
  \item{xyz}{ a trajectory object of class \code{"xyz"}, obtained from
    \code{\link{read.ncdf}}, \code{\link{read.dcd}},
    \code{\link{read.crd}}. }
  \item{x}{ an \code{sse} object obtained from \code{\link{dssp.pdb}} or 
    \code{\link{stride}}. }
  \item{...}{ additional arguments to and from functions. }
  }
\details{
  This function calls the \sQuote{DSSP} or \sQuote{STRIDE} program to define 
  secondary structure and psi and phi torsion angles.
}
\value{
  Returns a list with the following components:
  \item{helix}{ \sQuote{start}, \sQuote{end}, \sQuote{length},
    \sQuote{chain} and \sQuote{type} of helix, where start and end are
    residue numbers or residue index positions depending on the value of
    \dQuote{resno} input argument. }
  \item{sheet}{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{turn}{ \sQuote{start}, \sQuote{end} and \sQuote{length} of T
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{phi}{ a numeric vector of phi angles. }
  \item{psi}{ a numeric vector of psi angles. }
  \item{acc}{ a numeric vector of solvent accessibility. }
  \item{sse}{ a character vector of secondary structure type per residue. }
  \item{hbonds}{ a 10 or 16 column matrix containing the bridge pair
    records as well as backbone NH-->O and O-->NH H-bond records. 
    (Only available for \code{\link{dssp}} }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  \sQuote{DSSP} is the work of Kabsch and Sander:
  Kabsch and Sander (1983) \emph{Biopolymers.}  \bold{12}, 2577--2637.

  For information on obtaining \sQuote{DSSP}, see:\cr
  \url{https://swift.cmbi.umcn.nl/gv/dssp/}.

  \sQuote{STRIDE} is the work of Frishman and Argos:
  Frishman and Argos (1995) \emph{Proteins.}  \bold{3}, 566--579.

  For information on obtaining the \sQuote{STRIDE} program, see:\cr
  \url{http://webclu.bio.wzw.tum.de/stride/},
  or copy it from an installation of VMD.
}
\author{ Barry Grant, Lars Skjaerven (dssp.pdbs) }
\note{
  A system call is made to the \sQuote{DSSP} or \sQuote{STRIDE} program, 
  which must be installed on your system and in the search path for executables.
  See \url{http://thegrantlab.org/bio3d/articles/online/install_vignette/Bio3D_install.html} for 
  instructions of how to install these programs.
  
  For the \code{hbonds} list component the column names can be
  used as a convenient means of data access, namely:\cr
  Bridge pair 1            \dQuote{BP1},\cr
  Bridge pair 2            \dQuote{BP2},\cr
  Backbone H-bond (NH-->O) \dQuote{NH-O.1},\cr
  H-bond energy of NH-->O  \dQuote{E1},\cr
  Backbone H-bond (O-->NH) \dQuote{O-HN.1},\cr
  H-bond energy of O-->NH  \dQuote{E2},\cr
  Backbone H-bond (NH-->O) \dQuote{NH-O.2},\cr
  H-bond energy of NH-->O  \dQuote{E3},\cr
  Backbone H-bond (O-->NH) \dQuote{O-HN.2},\cr
  H-bond energy of O-->NH  \dQuote{E4}.\cr

  If \sQuote{resno=TRUE} the following additional columns are included:\cr
  Chain ID of resno \dQuote{BP1}:    \dQuote{ChainBP1},\cr
  Chain ID of resno \dQuote{BP2}:    \dQuote{ChainBP2},\cr
  Chain ID of resno \dQuote{O-HN.1}: \dQuote{Chain1},\cr
  Chain ID of resno \dQuote{NH-O.2}: \dQuote{Chain2},\cr
  Chain ID of resno \dQuote{O-HN.1}: \dQuote{Chain3},\cr
  Chain ID of resno \dQuote{NH-O.2}: \dQuote{Chain4}.
}
\seealso{
  \code{\link{read.pdb}},
  \code{\link{torsion.pdb}}, \code{\link{torsion.xyz}},
  \code{\link{plot.bio3d}},
  
  \code{\link{read.ncdf}}, \code{\link{read.dcd}},
  \code{\link{read.prmtop}}, \code{\link{read.crd}},
}
\examples{
\dontrun{
##- PDB example
# Read a PDB file
pdb <- read.pdb("1bg2")
sse <- dssp(pdb)
sse2 <- stride(pdb)

## Short summary
sse
sse2

# Helix data
sse$helix

# Precent SSE content
sum(sse$helix$length)/sum(pdb$calpha) * 100
sum(sse$sheet$length)/sum(pdb$calpha) * 100



##- PDBs example
aln  <- read.fasta( system.file("examples/kif1a.fa",package="bio3d") )
pdbs <- read.fasta.pdb( aln )

## Aligned PDB defined secondary structure
pdbs$sse

## Aligned DSSP defined secondary structure 
sse <- dssp(pdbs)


##- XYZ Trajectory
pdb <- read.pdb("2mda", multi=TRUE)
dssp.xyz(pdb$xyz, pdb)

## Note. for large MD trajectories you may want to skip some frames, e.g.
xyz <- rbind(pdb$xyz, pdb$xyz)       ## dummy trajectory
frames <- seq(1, to=nrow(xyz), by=4) ## frame numbers to examine
ss <- dssp.xyz(xyz[frames, ], pdb)      ## matrix of sse frame x residue

}
}
\keyword{ utilities }

\name{pfam}
\alias{pfam}
\title{ Download Pfam FASTA Sequence Alignment }
\description{
  Downloads FASTA sequence alignment from the Pfam database.
}
\usage{
pfam(id, alignment = "seed", verbose = FALSE)
}
\arguments{
  \item{id}{ the Pfam familiy identifier (e.g \sQuote{Piwi}) or accession
    (e.g. \sQuote{PF02171}). } 
  \item{alignment}{ the alignment type. Allowed values are:
    \sQuote{seed}, \sQuote{ncbi}, \sQuote{full},
    \sQuote{metagenomics}. }
  \item{verbose}{ logical, if TRUE details of the download process
    is printed. }
}
\details{
  This is a basic function to download a multiple sequence alignment for
  a protein family from the Pfam database. 
}
\value{
  A \sQuote{fasta} object with the following components:
  \item{ali }{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{ids }{ sequence names as identifiers. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\note{
  Full more information on the Pfam database:\cr
  \url{http://pfam.xfam.org}
}
\seealso{ \code{\link{read.fasta}},
  \code{\link{hmmer}}, \code{\link{get.seq}},
  \code{\link{uniprot}}
}
\examples{
\dontrun{
# PFAM server connection required - testing excluded

aln <- pfam("piwi")
aln <- pfam("PF02171")

seq <- get.seq("1rx2_A", outfile = tempfile())
hmm <- hmmer(seq, type="hmmscan", db="pfam")
aln <- pfam(hmm$hit.tbl$acc[1])

# Or much more simply for RCSB PDB entries:
acc <- pdb.pfam("1rx2_A", compact=FALSE)$pfamAcc
aln <- pfam(acc)
}
}
\keyword{ utilities }

\name{nma.pdbs}
\alias{nma.pdbs}
\alias{print.enma}
\title{ Ensemble Normal Mode Analysis }
\description{
  Perform normal mode analysis (NMA) on an ensemble of aligned protein
  structures.
}
\usage{
\method{nma}{pdbs}(pdbs, fit = TRUE, full = FALSE, subspace = NULL,
         rm.gaps = TRUE, varweight=FALSE, 
         outpath = NULL, ncore = 1, progress = NULL, \dots)

\method{print}{enma}(x, \dots)
}
\arguments{
  \item{pdbs}{ a numeric matrix of aligned C-alpha xyz Cartesian
    coordinates. For example an alignment data structure obtained with
    \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}. }
  \item{fit}{ logical, if TRUE coordinate superposition is performed
    prior to normal mode calculations. }
  \item{full}{ logical, if TRUE return the complete, full structure, 
    \sQuote{nma} objects. }
  \item{subspace}{ number of eigenvectors to store for further
    analysis. }
  \item{rm.gaps}{ logical, if TRUE obtain the hessian matrices for only
    atoms in the aligned positions (non-gap positions in all aligned
    structures). Thus, gap positions are removed from output. }
  \item{varweight}{ logical, if TRUE perform weighing of the pair force
    constants. Alternatively, provide a NxN matrix containing the
    weights. See function \code{\link{var.xyz}}. }
  \item{outpath}{ character string specifing the output directory to
    which the PDB structures should be written. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  
  \item{x}{ an \code{enma} object obtained from \code{\link{nma.pdbs}}. }
  \item{progress}{ progress bar for use with shiny web app. }
  \item{...}{ additional arguments to \code{nma}, \code{\link{aa2mass}}, and
    \code{\link{print}}. }
}
\details{
  This function performs normal mode analysis (NMA) on a set of aligned
  protein structures obtained with function \code{\link{read.fasta.pdb}} or
  \code{\link{pdbaln}}. The main purpose is to provide aligned atomic
  fluctuations and mode vectors in an automated fashion. 

  The normal modes are calculated on the full structures as provided 
  by object \sQuote{pdbs}. With the input argument \sQuote{full=TRUE}
  the full \sQuote{nma} objects are returned together with output
  \sQuote{U.subs} providing the aligned mode vectors. When
  \sQuote{rm.gaps=TRUE} the unaligned atoms are ommited from
  output. With default arguments \sQuote{rmsip} provides RMSIP
  values for all pairwise structures.
  
  See examples for more details. 
 }
\value{
  Returns an \sQuote{enma} object with the following components:
  \item{fluctuations }{ a numeric matrix containing aligned atomic
    fluctuations with one row per input structure. }
  \item{rmsip}{ a numeric matrix of pair wise RMSIP values (only the ten
    lowest frequency modes are included in the calculation). }
  \item{U.subspace }{ a three-dimensional array with aligned
    eigenvectors  (corresponding to the subspace defined by the first N
    non-trivial eigenvectors (\sQuote{U}) of the \sQuote{nma} object). }
  \item{L}{ numeric matrix containing the raw eigenvalues with one row
    per input structure. }
  \item{xyz }{ an object of class \sQuote{xyz} containing the Cartesian
    coordinates in which the calculation was performed. Coordinates are
    superimposed to the first structure of the \code{pdbs} object when
    \sQuote{fit=TRUE}. }   
  \item{full.nma }{ a list with a \code{nma} object for each input
    structure. }
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  For normal mode analysis on single structure PDB:
  \code{\link{nma.pdb}}
  
  For the analysis of the resulting \sQuote{eNMA} object:
  \code{\link{mktrj.enma}}, \code{\link{dccm.enma}},
  \code{\link{plot.enma}}, \code{\link{cov.enma}}.
    
  Similarity measures:
  \code{\link{sip}}, \code{\link{covsoverlap}},
  \code{\link{bhattacharyya}}, \code{\link{rmsip}}.
  
  Related functionality:
  \code{\link{pdbaln}}, \code{\link{read.fasta.pdb}}.
}
\examples{
\donttest{
# Needs MUSCLE installed - testing excluded

if(check.utility("muscle")) {

## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
files <- get.pdb(ids, split = TRUE, path = tempdir())

## Sequence Alignement
pdbs <- pdbaln(files, outfile = tempfile())

## Normal mode analysis on aligned data
modes <- nma(pdbs, rm.gaps=FALSE)

## Plot fluctuation data
plot(modes, pdbs=pdbs)

## Cluster on Fluctuation similariy
sip <- sip(modes)
hc <- hclust(dist(sip))
col <- cutree(hc, k=3)

## Plot fluctuation data
plot(modes, pdbs=pdbs, col=col)

## Remove gaps from output
modes <- nma(pdbs, rm.gaps=TRUE)

## RMSIP is pre-calculated
heatmap(1-modes$rmsip)

## Bhattacharyya coefficient
bc <- bhattacharyya(modes)
heatmap(1-bc)

}
}
}
\keyword{ analysis }

\name{identify.cna}
\alias{identify.cna}
\title{ Identify Points in a CNA Protein Structure Network Plot }
\description{
  \sQuote{identify.cna} reads the position of the graphics pointer when the
  (first) mouse button is pressed.  It then searches the coordinates given
  in \sQuote{x} for the point closest to the pointer.  If this point is 
  close enough to the pointer, its index and community members will be
  returned as part of the value of the call and the community members will 
  be added as labels to the plot.
}
\usage{
  \method{identify}{cna}(x, labels=NULL, cna=NULL, ...)
}
\arguments{
  \item{x}{ A numeric matrix with Nx2 dimensions, where N is equal to
    the number of objects in a 2D CNA plot such as obtained from the 
    \sQuote{plot.cna} and various \sQuote{layout} functions. }
  \item{labels}{ An optional character vector giving labels for the points.
    Will be coerced using \sQuote{as.character}, and recycled if
    necessary to the length of \sQuote{x}.  Excess labels will be
    discarded, with a warning. }
  \item{cna}{ A network object as returned from the \sQuote{cna} function. }
  \item{\dots}{ Extra options passed to \sQuote{identify} function. } 
}
\details{
  This function calls the \sQuote{identify} and \sQuote{summary.cna} functions to 
  query and label 2D CNA protein structure network plots produced by the \sQuote{plot.cna} function. Clicking with the mouse on plot points will add the corresponding  
  labels and them to the plot and returned list object. A click with the right 
  mouse button will stop the function.
}
\value{
  If \sQuote{labels} or \sQuote{cna} inputs are provided then a membership vector 
  will be returned with the selected community ids and their members. Otherwise a 
  vector with the ids of the selected communities will be returned.
}
\author{ Guido Scarabelli and Barry Grant }

\seealso{ \code{\link{plot.cna}}, 
          \code{\link{identify}}, 
          \code{\link[igraph:plot.igraph]{plot.igraph}}, 
          \code{\link[igraph:communities]{plot.communities}}, 
          \code{\link[igraph:plot.common]{igraph.plotting}} }
\examples{
\dontrun{

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

attach(hivp)

# Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

# Plot the network
xy <- plot.cna(net)

# Use identify.cna on the communities
d <- identify.cna(xy, cna=net)

# Right click to end the function...
## d <- identify(xy, summary(net)$members)

detach(hivp)

}
}
}
\keyword{ utility }

\name{project.pca}
\alias{project.pca}
\alias{z2xyz.pca}
\alias{xyz2z.pca}
\title{ Project Data onto Principal Components }
\description{
  Projects data onto principal components.
}
\usage{
project.pca(data, pca, angular = FALSE, fit = FALSE, ...)
z2xyz.pca(z.coord, pca)
xyz2z.pca(xyz.coord, pca)
}
\arguments{
  \item{data}{ a numeric vector or row-wise matrix of data to be projected. }
  \item{pca}{ an object of class \code{"pca"} as obtained from
    functions \code{pca.xyz} or \code{pca.tor}. }
  \item{angular}{ logical, if TRUE the data to be projected is treated
    as torsion angle data. }
  \item{fit}{ logical, if TRUE the data is first fitted to \code{pca$mean}. }
  \item{\dots}{ other parameters for \code{\link{fit.xyz}}. }
  \item{xyz.coord}{ a numeric vector or row-wise matrix of data to be projected. }
  \item{z.coord}{ a numeric vector or row-wise matrix of PC scores
    (i.e. the z-scores which are centered and rotated versions of the
    origional data projected onto the PCs) for conversion to xyz coordinates. }
}
\value{
  A numeric vector or matrix of projected PC scores.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Karim ElSawy and Barry Grant}
\seealso{ \code{\link{pca.xyz}}, \code{\link{pca.tor}}, \code{\link{fit.xyz}} }
\examples{
\dontrun{
attach(transducin)

gaps.pos <- gap.inspect(pdbs$xyz)

#-- Do PCA without structures 2 and 7
pc.xray <- pca.xyz(pdbs$xyz[-c(2,7), gaps.pos$f.inds])

#-- Project structures 2 and 7 onto the PC space
d <- project.pca(pdbs$xyz[c(2,7), gaps.pos$f.inds], pc.xray)

plot(pc.xray$z[,1], pc.xray$z[,2],col="gray")
points(d[,1],d[,2], col="red")

detach(transducin)
}
}
\keyword{ utilities }

\name{write.crd}
\alias{write.crd}
\title{ Write CRD File }
\description{
  Write a CHARMM CARD (CRD) coordinate file.
}
\usage{
write.crd(pdb = NULL, xyz = pdb$xyz, resno = NULL, resid = NULL, 
   eleno = NULL, elety = NULL, segid = NULL, resno2 = NULL, b = NULL, 
   verbose = FALSE, file = "R.crd")
}
\arguments{
  \item{pdb}{ a structure object obtained from \code{\link{read.pdb}} or
    \code{\link{read.crd}}. }
  \item{xyz}{ Cartesian coordinates as a vector or 3xN matrix. }
  \item{resno}{ vector of residue numbers of length equal to
    length(xyz)/3. }
  \item{resid}{ vector of residue types/ids of length equal to
    length(xyz)/3. }
  \item{eleno}{ vector of element/atom numbers of length equal to
    length(xyz)/3. }
  \item{elety}{ vector of element/atom types of length equal to
    length(xyz)/3. }
  \item{segid}{ vector of segment identifiers with length equal to
    length(xyz)/3. }
  \item{resno2}{ vector of alternate residue numbers of length equal to
    length(xyz)/3. }
  \item{b}{ vector of weighting factors of length equal to length(xyz)/3. }
  \item{verbose}{ logical, if TRUE progress details are printed. }
  \item{file}{ the output file name. }
}
\details{
  Only the \code{xyz} argument is strictly required.  Other arguments
  assume a default poly-ALA C-alpha structure with a blank segid and
  B-factors equal to 0.00.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  For a description of CHARMM CARD (CRD) format see:\cr
  \url{https://www.charmm.org/wiki//index.php/CHARMM:The_Basics}.
}
\author{ Barry Grant }
\note{
  Check that \code{resno} and \code{eleno} do not exceed \dQuote{9999}.
}
\seealso{ \code{\link{read.crd}}, \code{\link{read.pdb}},
  \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}}
}
\examples{
\dontrun{
# Read a PDB file
pdb <- read.pdb( "1bg2" )
summary(pdb)
# Convert to CHARMM format
new <- convert.pdb(pdb, type="charmm")
summary(new)
# Write a CRD file
write.crd(new, file="4charmm.crd")
}
}
\keyword{ IO }

\name{plot.pca}
\alias{plot.pca}
\alias{plot.pca.score}
\alias{plot.pca.scree}
\title{ Plot PCA Results }
\description{
  Produces a z-score plot (conformer plot) and an eigen spectrum plot
  (scree plot).
}
\usage{
\method{plot}{pca}(x, pc.axes=NULL, pch=16, col=par("col"), cex=0.8, mar=c(4, 4, 1, 1),...)

\method{plot}{pca.scree}(x, y = NULL, type = "o", pch = 18,
         main = "", sub = "", xlim = c(0, 20), ylim = NULL,
         ylab = "Proportion of Variance (\%)",
         xlab = "Eigenvalue Rank", axes = TRUE, ann = par("ann"),
         col = par("col"), lab = TRUE, ...)
\method{plot}{pca.score}(x, inds=NULL, col=rainbow(nrow(x)), lab = "", ...)

}
\arguments{
  \item{x}{ the results of principal component analysis obtained with
    \code{\link{pca.xyz}}. }
  \item{pc.axes}{ an optional numeric vector of length two specifying the principal components to be plotted.  A NULL value will result in an overview plot of the first three PCs and a scree plot. See examples. }    
  \item{pch}{ a vector of plotting characters or symbols: see \sQuote{points}. }
  \item{col}{ a character vector of plotting colors.  }
  \item{cex}{ a numerical single element vector giving the amount by
    which plotting text and symbols should be magnified relative to the
    default. }
  \item{mar}{ A numerical vector of the form c(bottom, left, top, right)
    which gives the number of lines of margin to be specified on the
    four sides of the plot.}
  \item{inds}{ row indices of the conformers to label. }
  \item{lab}{ a character vector of plot labels. }
  \item{y}{ the y coordinates for the scree plot. }
  \item{type}{ one-character string giving the type of plot desired.}
  \item{main}{ a main title for the plot, see also 'title'.}
  \item{sub}{ a sub-title for the plot.}
  \item{xlim}{ the x limits of the plot. }
  \item{ylim}{ the y limits of the plot.}
  \item{ylab}{ a label for the y axis.}
  \item{xlab}{ a label for the x axis.}
  \item{axes}{ a logical value indicating whether both axes should be drawn.}
  \item{ann}{ a logical value indicating whether the default annotation
    (title and x and y axis labels) should appear on the plot. }
  \item{\dots}{ extra plotting arguments. }
}
\details{
  \code{plot.pca} is a wrapper calling both \code{plot.pca.score} and
  \code{plot.pca.scree} resulting in a 2x2 plot with three score plots
  and one scree plot.
}
\value{
  Produces a plot of PCA results in the active graphics device and invisibly 
  returns the plotted \sQuote{z} coordinates along the requested \sQuote{pc.axes}. 
  See examples section where these coordinates are used to identify plotted points.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{pca.xyz}}, \code{\link{plot.bio3d}} }
\examples{
attach(transducin)

pc.xray <- pca(pdbs$xyz, rm.gaps=TRUE)
plot(pc.xray)

## Color plot by nucleotide state
vcolors <- annotation[, "color"]
plot(pc.xray, col=vcolors)

## Focus on a single plot of PC1 vs PC2
x <- plot(pc.xray, pc.axes=1:2, col=vcolors)

## Identify points interactively with mouse clicks
#identify(x, labels=basename.pdb(pdbs$id))

## Add labels to select points
inds <- c(1,10,37)
text(x[inds,], labels=basename.pdb(pdbs$id[inds]), col="blue")

## Alternative labeling method
#labs <- rownames(annotation)
#inds <- c(2,7)
#plot.pca.score(pc.xray, inds=inds, col=vcolors, lab=labs)

## color by seq identity groupings
#ide <- seqidentity(pdbs$ali)
#hc <- hclust(as.dist(1-ide))
#grps <- cutree(hc, h=0.2)
#vcolors <- rainbow(max(grps))[grps]
#plot.pca.score(pc.xray, inds=inds, col=vcolors, lab=labs)

detach(transducin)
}
\keyword{ hplot }

\name{hmmer}
\alias{hmmer}
\title{ HMMER Sequence Search }
\description{
  Perform a HMMER search against the PDB, NR, swissprot or other sequence
  and structure databases.
}
\usage{
hmmer(seq, type="phmmer", db = NULL, verbose = TRUE, timeout = 90)
}
\arguments{
  \item{seq}{ a multi-element character vector containing the query
    sequence. Alternatively a \sQuote{fasta} object as obtained
    from functions \code{get.seq} or \code{read.fasta} can be
    provided. }
  \item{type}{ character string specifying the \sQuote{HMMER} job
    type. Current options are \sQuote{phmmer}, \sQuote{hmmscan},
    \sQuote{hmmsearch}, and \sQuote{jackhmmer}. }
  \item{db}{ character string specifying the database to search.
    Current options are \sQuote{pdb}, \sQuote{nr}, \sQuote{swissprot},
    \sQuote{pfam}, etc. See \sQuote{details} for a complete list. }
  \item{verbose}{ logical, if TRUE details of the download process
    is printed. }
  \item{timeout}{ integer specifying the number of seconds to wait for
    the blast reply before a time out occurs. }
}
\details{
  This function employs direct HTTP-encoded requests to the HMMER web
  server. HMMER can be used to search sequence databases for homologous
  protein sequences. The HMMER server implements methods using
  probabilistic models called profile hidden Markov models (profile
  HMMs).

  There are currently four types of HMMER search to perform:
  
  - \sQuote{phmmer}: protein sequence vs protein sequence database.\cr
  (input argument \code{seq} must be a sequence). 
  
  Allowed options for \code{type} includes: 
  \sQuote{env_nr}, \sQuote{nr}, \sQuote{refseq}, \sQuote{pdb},
  \sQuote{rp15}, \sQuote{rp35}, \sQuote{rp55}, \sQuote{rp75},
  \sQuote{swissprot}, \sQuote{unimes}, \sQuote{uniprotkb},
  \sQuote{uniprotrefprot}, \sQuote{pfamseq}. 

  
  - \sQuote{hmmscan}: protein sequence vs profile-HMM database.\cr
  (input argument \code{seq} must be a sequence). 
  
  Allowed options for \code{type} includes:
  \sQuote{pfam}, \sQuote{gene3d},  \sQuote{superfamily}, \sQuote{tigrfam}.
  

  - \sQuote{hmmsearch}: protein alignment/profile-HMM vs protein sequence
  database.\cr
  (input argument \code{seq} must be an alignment). 
  
  Allowed options for \code{type} includes:
  \sQuote{pdb}, \sQuote{swissprot}.
  

  - \sQuote{jackhmmer}: iterative search vs protein sequence database.\cr
  (input argument \code{seq} must be an alignment).
  \sQuote{jackhmmer} functionality incomplete!!
  
  Allowed options for \code{type} includes:
  \sQuote{env_nr}, \sQuote{nr}, \sQuote{refseq}, \sQuote{pdb},
  \sQuote{rp15}, \sQuote{rp35}, \sQuote{rp55}, \sQuote{rp75},
  \sQuote{swissprot}, \sQuote{unimes}, \sQuote{uniprotkb},
  \sQuote{uniprotrefprot}, \sQuote{pfamseq}. 
  
  
  More information can be found at the HMMER website:\cr
  \url{http://hmmer.org}
}
\value{
  A list object with components \sQuote{hit.tbl} and
  \sQuote{url}. \sQuote{hit.tbl} is a data frame with multiple
  components depending on the selected job \sQuote{type}. Frequently
  reported fields include: 

  \item{name}{ a character vector containing the name of the target. }
  \item{acc}{ a character vector containing the accession identifier of
    the target. }
  \item{acc2}{ a character vector containing secondary accession of the
    target. }
  \item{pdb.id}{ same as \sQuote{acc}. }
  \item{id}{ a character vector containing Identifier of the target }
  \item{desc}{ a character vector containing entry description. }
  \item{score}{ a numeric vector containing bit score of the sequence (all
    domains, without correction). }
  \item{bitscore}{ same as \sQuote{score}. }
  \item{pvalue}{ a numeric vector containing the P-value of the score. }
  \item{evalue}{ a numeric vector containing the E-value of the score. }
  \item{mlog.evalue }{ a numeric vector containing minus the natural log
    of the E-value. }
  \item{nregions}{ a numeric vector containing Number of regions
    evaluated. } 
  \item{nenvelopes}{ a numeric vector containing the number of envelopes
    handed over for domain definition, null2, alignment, and scoring. }
  \item{ndom}{ a numeric vector containing the total number of domains
    identified in this sequence. } 
  \item{nreported}{ a numeric vector containing the number of domains
    satisfying reporting thresholding. } 
  \item{nincluded}{ a numeric vector containing the number of domains
    satisfying inclusion thresholding. } 
  \item{taxid}{ a character vector containing The NCBI taxonomy identifier
    of the target (if applicable). } 
  \item{species}{ a character vector containing the species name. }
  \item{kg}{ a character vector containing the kingdom of life that the
    target belongs to - based on placing in the NCBI taxonomy tree. }

  More details can be found at the HMMER website:\cr
  \url{https://www.ebi.ac.uk/Tools/hmmer/help/api}
}
\note{
  Note that the chained \sQuote{pdbs} HMMER field (used for redundant
  PDBs) is included directly into the result list (applies only when
  \code{db='pdb'}). In this case, the \sQuote{name} component of the
  target contains the parent (non redundant) entry, and the \sQuote{acc}
  component the chained PDB identifiers. The search results will therefore
  provide duplicated PDB identifiers for component \code{$name}, while
  \code{$acc} should be unique. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Finn, R.D. et al. (2011) \emph{Nucl. Acids Res.} \bold{39}, 29--37.
  Eddy, S.R. (2011) \emph{PLoS Comput Biol} \bold{7}(10): e1002195.
  
  See also the \sQuote{HMMER} website:\cr
  \url{http://hmmer.org}
}
\author{ Lars Skjaerven }
\note{
  Online access is required to query HMMER services.
}
\seealso{
  \code{\link{blast.pdb}}, \code{\link{plot.blast}}, 
  \code{\link{seqaln}}, \code{\link{get.seq}},
  \code{\link{pfam}}, \code{\link{uniprot}}
}
\examples{
\dontrun{
# HMMER server connection required - testing excluded

##- PHMMER
seq <- get.seq("2abl_A", outfile=tempfile())
res <- hmmer(seq, db="pdb")

##- HMMSCAN
fam <- hmmer(seq, type="hmmscan", db="pfam")
pfam.aln <- pfam(fam$hit.tbl$acc[1])

##- HMMSEARCH
hmm <- hmmer(pfam.aln, type="hmmsearch", db="pdb")
unique(hmm$hit.tbl$species)
hmm$hit.tbl$acc

}
}
\keyword{ utilities }

\name{mustang}
\alias{mustang}
\title{ Structure-based Sequence Alignment with MUSTANG }
\description{
  Create a multiple sequence alignment from a bunch of PDB files.
}
\usage{
mustang(files, exefile="mustang", outfile="aln.mustang.fa",
        cleanpdb=FALSE, cleandir="mustangpdbs", verbose=TRUE)  
}
\arguments{
  \item{files}{ a character vector of PDB file names. }
  \item{exefile}{ file path to the \sQuote{MUSTANG} program on your system (i.e.
    how is \sQuote{MUSTANG} invoked). }
  \item{outfile}{ name of \sQuote{FASTA} output file to which alignment
    should be written. }
  \item{cleanpdb}{ logical, if TRUE iterate over the PDB files and map
    non-standard residues to standard residues (e.g. SEP->SER..) to
    produce \sQuote{clean} PDB files. }
  \item{cleandir}{ character string specifying the directory in which
    the \sQuote{clean} PDB files should be written. }
  \item{verbose}{ logical, if TRUE \sQuote{MUSTANG} warning and error
    messages are printed. } 
}
\details{
  Structure-based sequence alignment with \sQuote{MUSTANG} attempts to
  arrange and align the sequences of proteins based on their 3D
  structure.
  
  This function calls the \sQuote{MUSTANG} program, to perform a multiple
  structure alignment, which MUST BE INSTALLED on your system and in the
  search path for executables.

  Note that non-standard residues are mapped to \dQuote{Z} in
  MUSTANG. As a workaround the bio3d \sQuote{mustang} function will
  attempt to map any non-standard residues to standard residues
  (e.g. SEP->SER, etc). To avoid this behaviour use
  \sQuote{cleanpdb=FALSE}.  
  
}
\value{
  A list with two components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid. }
  \item{ids}{ sequence names as identifers.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  \sQuote{MUSTANG} is the work of Konagurthu et al:
  Konagurthu, A.S. et al. (2006) \emph{Proteins} \bold{64}(3):559--74.
  
  More details of the \sQuote{MUSTANG} algorithm, along with download and
  installation instructions can be obtained from:\cr
  \url{https://lcb.infotech.monash.edu/mustang/}.
}
\author{ Lars Skjaerven }
\note{
  A system call is made to the \sQuote{MUSTANG} program, which must be
  installed on your system and in the search path for executables.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}},
  \code{\link{pdbaln}}, \code{\link{plot.fasta}},
  \code{\link{seqaln}}
}
\examples{
\dontrun{

if(!check.utility('mustang')) {
   message('Need MUSTANG installed to run this example')
} else {

## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A")
files <- get.pdb(ids, split = TRUE, path = tempdir())

##-- Or, read a folder/directory of existing PDB files
#pdb.path <- "my_dir_of_pdbs"
#files  <- list.files(path=pdb.path ,
#                     pattern=".pdb",
#                     full.names=TRUE)

##-- Align these PDB sequences
aln <- mustang(files)

##-- Read Aligned PDBs storing coordinate data
pdbs <- read.fasta.pdb(aln) 

}
}
}
\keyword{ utilities }

\name{rle2}
\title{Run Length Encoding with Indices}
\alias{rle2}
\alias{print.rle2}
\concept{runs}
\description{
  Compute the lengths, values and indices of runs of equal values in a
  vector. This is a modifed version of base function \code{rle()}.
}
\usage{
rle2(x)

\method{print}{rle2}(x, digits = getOption("digits"), prefix = "", \dots)
}
\arguments{
  \item{x}{an atomic vector for \code{rle()}; an object of class
    \code{"rle"} for \code{inverse.rle()}.}
  \item{\dots}{further arguments; ignored here.}
  \item{digits}{number of significant digits for printing, see
    \code{\link{print.default}}.}
  \item{prefix}{character string, prepended to each printed line.}
}
\details{
  Missing values are regarded as unequal to the previous value, even if
  that is also missing.

  \code{inverse.rle()} is the inverse function of \code{rle2()} and \code{rle()},
  reconstructing \code{x} from the runs.
}
\value{
  \code{rle()} returns an object of class \code{"rle"} which is a list
  with components:
  \item{lengths}{an integer vector containing the length of each run.}
  \item{values}{a vector of the same length as \code{lengths} with the
    corresponding values.}
}
\examples{
x <- rev(rep(6:10, 1:5))
rle(x)
## lengths [1:5]  5 4 3 2 1
## values  [1:5] 10 9 8 7 6
rle2(x)
## lengths: int [1:5] 5 4 3 2 1
## values : int [1:5] 10 9 8 7 6
## indices: int [1:5] 5 9 12 14 15
}
\keyword{manip}

\name{read.crd.amber}
\alias{read.crd.amber}
\title{ Read AMBER Coordinate files }
\description{
  Read coordinate data from an AMBER coordinate / restart file.
}
\usage{
\method{read.crd}{amber}(file, ...)
}
\arguments{
  \item{file}{ name of crd file to read. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  Read a AMBER Coordinate format file.
}
\value{
  A list object of type \sQuote{amber} and \sQuote{crd} with the
  following components:
  \item{xyz}{ a numeric matrix of class \sQuote{xyz} containing the
    Cartesian coordinates. }
  \item{velocities}{ a numeric vector containg the atom velocities. }
  \item{time}{ numeric, length of the simulation (applies to Amber
    restart coordinate files). }
  \item{natoms}{ total number of atoms in the coordinate file. }
  \item{box}{ dimensions of the box. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  \url{http://ambermd.org/FileFormats.php}
}
\author{ Lars Skjaerven }
\note{
  See AMBER documentation for Coordinate format description.
}
\seealso{
  \code{\link{read.prmtop}}, \code{\link{read.ncdf}},
  \code{\link{as.pdb}}, \code{\link{atom.select}},
  \code{\link{read.pdb}}, \code{\link{read.crd.charmm}}  }
\examples{
\dontrun{
## Read Amber PRMTOP and CRD files
prm <- read.prmtop(system.file("examples/crambin.prmtop", package="bio3d"))
crd <- read.crd(system.file("examples/crambin.inpcrd", package="bio3d"))

## Convert to PDB format
pdb <- as.pdb(prm, crd)

## Atom selection
ca.inds <- atom.select(prm, "calpha")
}
}
\keyword{ IO }

\name{filter.rmsd}
\alias{filter.rmsd}
\title{ RMSD Filter }
\description{
  Identify and filter subsets of conformations at a given RMSD cutoff.
}
\usage{
filter.rmsd(xyz = NULL, rmsd.mat = NULL, cutoff = 0.5,
            fit = TRUE, verbose = TRUE, inds = NULL, method = "complete",
            \dots)
}
\arguments{
  \item{xyz}{ a numeric matrix or list object containing multiple
    coordinates for pairwise comparison, such as that obtained from
    \code{\link{read.fasta.pdb}}. Not used if \code{rmsd.mat} is
    given. }
  \item{rmsd.mat}{  an optional matrix of RMSD values obtained from
    \code{\link{rmsd}}. } 
  \item{cutoff}{ a numeric rmsd cutoff value. }
  \item{fit}{ logical, if TRUE coordinate superposition is performed
    prior to RMSD calculation. }
  \item{verbose}{ logical, if TRUE progress details are printed. }
  \item{inds}{ a vector of indices that selects the elements of
    \code{xyz} upon which the calculation should be based. By default, 
    all the non-gap sites in \code{xyz}. }
  \item{method}{ the agglomeration method to be used. See function 
    \code{\link{hclust}} for more information. }
  \item{\dots}{ additional arguments passed to and from functions. } 
}
\details{
  This function performs hierarchical cluster analysis of a given matrix of
  RMSD values \sQuote{rmsd.mat}, or an RMSD matrix calculated from a given
  coordinate matrix \sQuote{xyz}, to identify conformers that fall below a
  given RMSD cutoff value \sQuote{cutoff}.
}
\value{
  Returns a list object with components:
  \item{ind}{indices of the conformers (rows) below the cutoff value.}
  \item{tree}{an object of class \code{"hclust"}, which describes the
    tree produced by the clustering process. }
  \item{rmsd.mat}{a numeric matrix with all pairwise RMSD values.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{
  \code{\link{rmsd}}, \code{\link{read.pdb}},
  \code{\link{read.fasta.pdb}}, \code{\link{read.dcd}}
}
\examples{
\dontrun{
attach(kinesin)

k <- filter.rmsd(xyz=pdbs,cutoff=0.5)
pdbs$id[k$ind]
hclustplot(k$tree, h=0.5, ylab="RMSD")
abline(h=0.5, col="gray")

detach(kinesin)
}
}
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dccm.gnm.R
\name{dccm.gnm}
\alias{dccm.egnm}
\alias{dccm.gnm}
\title{Dynamic Cross-Correlation from Gaussian Network Model}
\usage{
\method{dccm}{gnm}(x, ...)

\method{dccm}{egnm}(x, ...)
}
\arguments{
\item{x}{an object of class \sQuote{gnm} or \sQuote{egnm} as obtained from 
\code{\link{gnm}}.}

\item{...}{additional arguments (currently ignored).}
}
\value{
Returns a cross-correlation matrix.
}
\description{
Calculate the cross-correlation matrix from Gaussian network model normal 
modes analysis.
}
\details{
This function calculates the cross-correlation matrix from Gaussian network
model (GNM) normal modes analysis (NMA) obtained from \code{gnm}. It returns 
a matrix of residue-wise cross-correlations whose elements, Cij, may be 
displayed in a graphical representation frequently termed a dynamical 
cross-correlation map, or DCCM. (See more details in \code{help(dccm.nma)}).
}
\examples{
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
   
## Calculate normal modes
modes <- gnm(pdb)
   
## Calculate correlation matrix
cm <- dccm(modes)

## Plot correlation map
plot(cm, sse = pdb, contour = FALSE, col.regions = bwr.colors(20),
     at = seq(-1, 1, 0.1))

}
\author{
Xin-Qiu Yao & Lars Skjaerven
}
\references{
Bahar, I. et al. (1997) \emph{Folding Des.} \bold{2}, 173.
}
\seealso{
\code{\link{gnm}}, \code{\link{dccm.nma}}, \code{\link{dccm.enma}},
  \code{\link{plot.dccm}}.
}
\keyword{analysis}

\name{print.core}
\alias{print.core}
\title{ Printing Core Positions and Returning Indices }
\description{
  Print method for core.find objects.
}
\usage{
\method{print}{core}(x, vol = NULL, ...)
}
\arguments{
  \item{x}{ a list object obtained with the function
    \code{\link{core.find}}. }
  \item{vol}{ the maximal cumulative volume value at which core positions
    are detailed. }
  \item{...}{ additional arguments to \sQuote{print}. }
}
\value{
  Returns a three component list of indices:
  \item{atom}{atom indices of core positions}
  \item{xyz}{xyz indices of core positions}
  \item{resno}{residue numbers of core positions}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  The produced \code{\link{plot.core}} function can be useful for deciding on the
  core/non-core boundary.
}
\seealso{ \code{\link{core.find}}, \code{\link{plot.core}}}
\examples{

\dontrun{
##-- Generate a small kinesin alignment and read corresponding structures
pdbfiles <- get.pdb(c("1bg2","2ncd","1i6i","1i5s"), URLonly=TRUE)
pdbs <- pdbaln(pdbfiles)

##-- Find 'core' positions
core <- core.find(pdbs)
plot(core)

##-- Fit on these relatively invarient subset of positions 
core.inds <- print(core, vol=0.5)

print(core, vol=0.7)
print(core, vol=1.0)

}
}
\keyword{ utilities }

\name{read.pdb}
\alias{read.pdb}
\alias{read.pdb2}
\alias{print.pdb}
\alias{summary.pdb}
\title{ Read PDB File}
\description{
  Read a Protein Data Bank (PDB) coordinate file.
}
\usage{
read.pdb(file, maxlines = -1, multi = FALSE, rm.insert = FALSE,
         rm.alt = TRUE, ATOM.only = FALSE, hex = FALSE, verbose = TRUE)

read.pdb2(file, maxlines = -1, multi = FALSE, rm.insert = FALSE,
         rm.alt = TRUE, ATOM.only = FALSE, verbose = TRUE)

\method{print}{pdb}(x, printseq=TRUE, \dots)

\method{summary}{pdb}(object, printseq=FALSE, \dots)
}
\arguments{
  \item{file}{ a single element character vector containing the name of
    the PDB file to be read, or the four letter PDB identifier for
    online file access. }
  \item{maxlines}{ the maximum number of lines to read before giving up
    with large files. By default if will read up to the end of input on
    the connection. }
  \item{multi}{ logical, if TRUE multiple ATOM records are read for all
    models in multi-model files and their coordinates returned. }
  \item{rm.insert}{ logical, if TRUE PDB insert records are ignored. }
  \item{rm.alt}{ logical, if TRUE PDB alternate records are ignored. }
  \item{ATOM.only}{ logical, if TRUE only ATOM/HETATM records are stored.
    Useful for speed enhancements with large files where secondary structure, 
    biological unit and other remark records are not required. }
  \item{hex}{ logical, if TRUE enable parsing of hexadecimal atom
    numbers (> 99.999) and residue numbers (> 9.999) (e.g. from VMD). Note
    that numbering is assumed to be consecutive (with no missing numbers)
    and the hexadecimals should start at atom number 100.000 and residue
    number 10.000 and proceed to the end of file. }
  \item{verbose}{ print details of the reading process. }
  \item{x}{ a PDB structure object obtained from
    \code{\link{read.pdb}}.  }
  \item{object}{ a PDB structure object obtained from
    \code{\link{read.pdb}}.  }
  \item{printseq}{ logical, if TRUE the PDB ATOM sequence will be printed
    to the screen. See also \code{\link{pdbseq}}.  }
  \item{...}{ additional arguments to \sQuote{print}. }
   
}
\details{
  \code{read.pdb} is a re-implementation (using Rcpp) of the slower but
  more tested R implementation of the same function (called
  \code{read.pdb2} since bio3d-v2.3).
  
  \code{maxlines} may be set so as to restrict the reading to a portion
  of input files. Note that the preferred means of reading large 
  multi-model files is via binary DCD or NetCDF format trajectory files 
  (see the \code{\link{read.dcd}} and \code{\link{read.ncdf}} functions).
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a data.frame containing all atomic coordinate ATOM and 
    HETATM data, with a row per ATOM/HETATM and a column per record type.  
    See below for details of the record type naming convention (useful for 
    accessing columns). }
  \item{helix }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of H
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{sheet }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{seqres }{ sequence from SEQRES field. }
  \item{xyz }{ a numeric matrix of class \code{"xyz"} containing the
    ATOM and HETATM coordinate data. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
  \item{remark }{ a list object containing information taken from 'REMARK'
    records of a \code{"pdb"}. It can be used for building biological units
    (See \code{\link{biounit}}). }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\note{ 
  For both \code{atom} and \code{het} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno} ,
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Chain identifier \dQuote{chain},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Occupancy \dQuote{o}, and
  Temperature factor \dQuote{b}.
  See examples for further details.
}
\seealso{
  \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{trim.pdb}}, \code{\link{cat.pdb}}, 
  \code{\link{read.prmtop}}, \code{\link{as.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.ncdf}}, 
  \code{\link{read.fasta.pdb}}, \code{\link{read.fasta}}, 
  \code{\link{biounit}}
}
\examples{
## Read a PDB file from the RCSB online database
#pdb <- read.pdb("4q21")

## Read a PDB file from those included with the package
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Print a brief composition summary
pdb

## Examine the storage format (or internal *str*ucture)
str(pdb)

## Print data for the first four atom
pdb$atom[1:4,]

## Print some coordinate data
head(pdb$atom[, c("x","y","z")])

## Or coordinates as a numeric vector
#head(pdb$xyz)

## Print C-alpha coordinates (can also use 'atom.select' function)
head(pdb$atom[pdb$calpha, c("resid","elety","x","y","z")])
inds <- atom.select(pdb, elety="CA")
head( pdb$atom[inds$atom, ] )

## The atom.select() function returns 'indices' (row numbers)
## that can be used for accessing subsets of PDB objects, e.g.
inds <- atom.select(pdb,"ligand")
pdb$atom[inds$atom,]
pdb$xyz[inds$xyz]

## See the help page for atom.select() function for more details.


\dontrun{
## Print SSE data for helix and sheet,
##  see also dssp() and stride() functions
print.sse(pdb)
pdb$helix
pdb$sheet$start
  
## Print SEQRES data
pdb$seqres

## SEQRES as one letter code
aa321(pdb$seqres)

## Where is the P-loop motif in the ATOM sequence
inds.seq <- motif.find("G....GKT", pdbseq(pdb))
pdbseq(pdb)[inds.seq]

## Where is it in the structure
inds.pdb <- atom.select(pdb,resno=inds.seq, elety="CA")
pdb$atom[inds.pdb$atom,]
pdb$xyz[inds.pdb$xyz]

## View in interactive 3D mode
#view(pdb)
}

}
\keyword{ IO }

\name{sdENM}
\alias{sdENM}
\title{ Index for the sdENM ff }
\description{
  A dictonary of spring force constants for the sdENM force field.
}
\usage{
data(sdENM)
}
\format{
  An array of 27 matrices containg the spring force constants for the
  \sQuote{sdENM} force field (see Dehouch et al for more
  information). Each matrix in the array holds the force constants for
  all amino acid pairs for a specific distance range.

  See examples for more details.
}
\source{
  Dehouck Y. & Mikhailov A.S. (2013) \emph{PLoS Comput Biol} \bold{9}:e1003209.
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  Dehouck Y. et al. (2013) \emph{PLoS Comput Biol} \bold{9}:e1003209.
}
\examples{
## Load force constant data
data(sdENM)

## force constants for amino acids A, C, D, E, and F
## in distance range [4, 4.5)
sdENM[1:5, 1:5, 1]

## and distance range [4.5, 5)
sdENM[1:5, 1:5, 2]

## amino acid pair A-P, at distance 4.2
sdENM["A", "P", 1]

\dontrun{
## for use in NMA
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
modes <- nma(pdb, ff="sdenm")
}
}
\keyword{datasets}

\name{setup.ncore}
\alias{setup.ncore}
\title{ Setup for Running Bio3D Functions using Multiple CPU Cores }
\description{
  Internally used in parallelized Bio3D functions.
}
\usage{
  setup.ncore(ncore, bigmem = FALSE)
}
\arguments{
  \item{ncore}{
    User set (or default) value of \sQuote{ncore}.
  }
  \item{bigmem}{
    logical, if TRUE also check the availability of \sQuote{bigmemory} package.
  }
}
\details{
  Check packages and set correct value of \sQuote{ncore}.
}
\value{
  The actual value of \sQuote{ncore}.
}
\examples{
   setup.ncore(NULL)
   setup.ncore(1)
#   setup.ncore(2)
}
\keyword{ utilities }

\name{aa.index}
\alias{aa.index}
\docType{data}
\title{ AAindex: Amino Acid Index Database }
\description{
  A collection of published indices, or scales, of numerous
  physicochemical and biological properties of the 20 standard
  aminoacids (Release 9.1, August 2006).
}
\usage{data(aa.index)}
\format{
 A list of 544 named indeces each with the following components:
 \enumerate{
  \item{H}{ character vector: Accession number. }
  \item{D}{ character vector: Data description. }
  \item{R}{ character vector: LITDB entry number. }
  \item{A}{ character vector: Author(s). }
  \item{T}{ character vector: Title of the article. }
  \item{J}{ character vector: Journal reference. }
  \item{C}{ named numeric vector: Correlation coefficients of similar
    indeces (with coefficients of 0.8/-0.8 or more/less). The
    correlation coefficient is calculated with zeros filled for missing
    values. }
  \item{I}{ named numeric vector: Amino acid index data. }
 }
}
\source{
\sQuote{AAIndex} was obtained from:\cr
\url{https://www.genome.jp/aaindex/}\cr
For a description of the \sQuote{AAindex} database see:\cr 
\url{https://www.genome.jp/aaindex/aaindex_help.html}.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
\sQuote{AAIndex} is the work of Kanehisa and co-workers:\cr
Kawashima and Kanehisa (2000) \emph{Nucleic Acids Res.} \bold{28}, 374;\cr
Tomii and Kanehisa (1996) \emph{Protein Eng.} \bold{9}, 27--36;\cr
Nakai, Kidera and Kanehisa (1988) \emph{Protein Eng.} \bold{2}, 93--100.
}
\examples{
## Load AAindex data
data(aa.index)

## Find all indeces described as "volume"
ind <- which(sapply(aa.index, function(x)
                    length(grep("volume", x$D, ignore.case=TRUE)) != 0))

## find all indeces with author "Kyte"
ind <- which(sapply(aa.index, function(x) length(grep("Kyte", x$A)) != 0))

## examine the index
aa.index[[ind]]$I

## find indeces which correlate with it
all.ind <- names(which(Mod(aa.index[[ind]]$C) >= 0.88))

## examine them all
sapply(all.ind, function (x) aa.index[[x]]$I)
}
\keyword{datasets}

\name{pdbfit}
\alias{pdbfit}
\alias{pdbfit.pdb}
\alias{pdbfit.pdbs}
\title{ PDB File Coordinate Superposition }
\description{ Protein Databank Bank file coordinate superposition with
  the Kabsch algorithm. }
\usage{

pdbfit(...)

\method{pdbfit}{pdb}(pdb, inds = NULL, ...)

\method{pdbfit}{pdbs}(pdbs, inds = NULL, outpath = NULL, ...)

}
\arguments{
  \item{pdb}{ a multi-model pdb object of class \code{"pdb"}, as
    obtained from \code{read.pdb}. }
  \item{pdbs}{ a list of class \code{"pdbs"} containing PDB file
    data, as obtained from \code{read.fasta.pdb} or
    \code{pdbaln}. }
  \item{inds}{ a list object with a \sQuote{xyz} component with indices
    that selects the coordinate  positions (in terms of x, y and z
    elements) upon which fitting should be based. This defaults to all
    equivalent non-gap positions for function \code{pdbfit.pdbs}, and to
    all calpha atoms for function \code{pdbfit.pdb}. }
  \item{outpath}{ character string specifing the output directory for
    optional coordinate file output. Note that full files (i.e. all atom
    files) are written, seebelow. }
  \item{\dots}{ extra arguments passed to \code{fit.xyz} function. }
}
\details{
  The function \code{pdbfit} is a wrapper for the function
  \code{fit.xyz}, wherein full details of the superposition procedure
  are documented.

  Input to \code{pdbfit.pdbs} should be a list object obtained with the
  function \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}.  See
  the examples below.

  For function \code{pdbfit.pdb} the input should be a multi-model
  \code{pdb} object with multiple (>1) frames in the \sQuote{xyz}
  component. 
  
  The reference frame for supperposition (i.e. the fixed structure to
  which others are superposed) is the first entry in the input
  \code{"pdbs"} object. For finer control use \code{\link{fit.xyz}}.
}
\value{
  Returns moved coordinates.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Kabsch \emph{Acta Cryst} (1978) \bold{A34}, 827--828.
}
\author{ Barry Grant }
\seealso{ \code{\link{pdbaln}}, \code{\link{read.fasta.pdb}},
  \code{\link{fit.xyz}}, \code{\link{rmsd}}, \code{\link{read.pdb}} }
\examples{
\dontrun{
#files <- get.pdb(c("4q21","5p21"), URLonly=TRUE)
files <- get.pdb(c("4q21","5p21"), path=tempdir(), overwrite=TRUE)
pdbs <- pdbaln(files)
xyz <- pdbfit(pdbs)

# Superpose again this time outputing all-atom PDBs to disc
#xyz <- pdbfit( pdbs, outpath="fitted" )
}
}
\keyword{ utilities }

\name{covsoverlap}
\alias{covsoverlap}
\alias{covsoverlap.enma}
\alias{covsoverlap.nma}
\title{ Covariance Overlap }
\description{
  Calculate the covariance overlap obtained from NMA. 
}
\usage{
covsoverlap(...)

\method{covsoverlap}{enma}(enma, ncore=NULL, ...)

\method{covsoverlap}{nma}(a, b, subset=NULL, ...)
}
\arguments{
  \item{enma}{ an object of class \code{"enma"} obtained from function
    \code{nma.pdbs}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{a}{ a list object with elements \sQuote{U} and \sQuote{L}
    (e.g. as obtained from function \code{nma}) containing the
    eigenvectors and eigenvalues, respectively, to be 
    compared with \code{b}. }
  \item{b}{ a list object with elements \sQuote{U} and \sQuote{L}
    (e.g. as obtained from function \code{nma}) containing the
    eigenvectors and eigenvalues, respectively, to be 
    compared with \code{a}. }
  \item{subset}{ the number of modes to consider. }
  \item{\dots}{ arguments passed to associated functions. }
}
\details{
  Covariance overlap is a measure for the similarity between two
  covariance matrices, e.g. obtained from NMA. 
}
\value{
  Returns the similarity coefficient(s).
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
  Romo, T.D. et al. (2011) \emph{Proteins} \bold{79}, 23--34.
}
\author{ Lars Skjaerven }
\seealso{ Other similarity measures:
  \code{\link{sip}}, \code{\link{covsoverlap}}, \code{\link{bhattacharyya}}.
}
\keyword{ utilities }

\name{basename.pdb}
\alias{basename.pdb}
\title{
Manipulate PDB File Names
}
\description{
  Removes all of the path up to and including the last 
  path separator (if any) and the final \sQuote{.pdb} extension.
}
\usage{
basename.pdb(x, mk4 = FALSE, ext=".pdb")
}
\arguments{
  \item{x}{ character vector of PDB file names, containing path and extensions.}
  \item{mk4}{ logical, if TRUE the output will be truncated to the first 4 
    characters of the basename. This is frequently convenient for matching RCSB 
    PDB identifier conventions (see examples below). }
  \item{ext}{ character, specifying the file extension,
    e.g. \sQuote{.pdb} or \sQuote{.mol2}. }
}
\details{
This is a simple utility function for the common task of PDB file name manipulation. It is used internally in several bio3d functions and van be thought of as basename for PDB files. 
}
\value{
A character vector of the same length as the input \sQuote{x}.

Paths not containing any separators are taken to be in the current directory.

If an element of input is \sQuote{x} is \sQuote{NA}, so is the result.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{
	\code{\link{basename}}, \code{\link{dirname}}
}
\examples{
	basename.pdb("/somedir/somewhere/1bg2_myfile.pdb")
	basename.pdb("/somedir/somewhere/1bg2_myfile.pdb", TRUE)
}
\keyword{ utilities }

\name{angle.xyz}
\alias{angle.xyz}
\title{ Calculate the Angle Between Three Atoms }
\description{
  A function for basic bond angle determination.
}
\usage{
angle.xyz(xyz, atm.inc = 3)
}
\arguments{
  \item{xyz}{ a numeric vector of Cartisean coordinates. }
  \item{atm.inc}{ a numeric value indicating the number of atoms to
    increment by between successive angle evaluations (see below). }
}
\value{
  Returns a numeric vector of angles.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  With \code{atm.inc=1}, angles are calculated for each set of
  three successive atoms contained in \code{xyz} (i.e. moving along one
  atom, or three elements of \code{xyz}, between sucessive
  evaluations).  With \code{atm.inc=3}, angles are calculated for each set
  of three successive non-overlapping atoms contained in \code{xyz}
  (i.e. moving along three atoms, or nine elements of \code{xyz}, between
  sucessive evaluations).
}
\seealso{ \code{\link{torsion.pdb}}, \code{\link{torsion.xyz}},
  \code{\link{read.pdb}}, \code{\link{read.dcd}}.
}
\examples{
## Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Angle between N-CA-C atoms of residue four
inds <- atom.select(pdb, resno=4, elety=c("N","CA","C"))
angle.xyz(pdb$xyz[inds$xyz])

## Basic stats of all N-CA-C bound angles
inds <- atom.select(pdb, elety=c("N","CA","C"))
summary( angle.xyz(pdb$xyz[inds$xyz]) )
#hist( angle.xyz(pdb$xyz[inds$xyz]), xlab="Angle" )

}
\keyword{ utilities }

\name{print.fasta}
\alias{print.fasta}
\alias{.print.fasta.ali}
\title{ Printing Sequence Alignments }
\description{
    Print method for fasta and pdbs sequence alignment objects.
}
\usage{
\method{print}{fasta}(x, alignment=TRUE, ...)
.print.fasta.ali(x, width = NULL, col.inds = NULL, numbers = TRUE,
         conservation=TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a sequence alignment object as obtained from the functions  
    \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}},
    \code{\link{pdbaln}}, \code{\link{seqaln}}, etc. }
  \item{alignment}{ logical, if TRUE the sequence alignment will be
    printed to screen. }
  \item{width}{ a single numeric value giving the number of residues per 
    printed sequence block. By default this is determined from considering 
    alignment identifier widths given a standard 85 column terminal
    window. }
  \item{col.inds}{ an optional numeric vector that can be used to select 
    subsets of alignment positions/columns for printing. } 
  \item{numbers}{ logical, if TRUE position numbers and a tick-mark every 
    10 positions are printed above and below sequence blocks. }
  \item{conservation}{ logical, if TRUE conserved and semi-conserved
    columns in the alignment are marked with an \sQuote{*} and 
    \sQuote{^}, respectively. }
  \item{\dots}{ additional arguments to \sQuote{.print.fasta.ali}. }
}
\value{
  Called mostly for its effect but also silently returns block
  divided concatenated sequence strings as a matrix.  
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.}
\author{ Barry Grant }
\seealso{
  \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}},
  \code{\link{pdbaln}}, \code{\link{seqaln}}
}
\examples{

     file <- system.file("examples/kif1a.fa",package="bio3d")
     aln  <- read.fasta(file)
     print(aln)

     # print(aln, col.inds=30:100, numbers=FALSE)
}
\keyword{ utilities }

\name{plot.rmsip}
\alias{plot.rmsip}
\title{ Plot RMSIP Results }
\description{
  Produces a heat plot of RMSIP (Root mean square inner product) for the
  visualization of modes similarity.
}
\usage{
\method{plot}{rmsip}(x, xlab = NULL, ylab = NULL, col = gray(50:0/50),
      zlim=c(0,1), \dots)
}
\arguments{
  \item{x}{ an object of class \code{rmsip}. }
  \item{xlab}{ a label for the x axis, defaults to \sQuote{a}. }
  \item{ylab}{ a label for the y axis, defaults to \sQuote{b}. }
  \item{col}{ a vector of colors for the RMSIP map (or overlap values). }
  \item{zlim}{ the minimum and maximum \sQuote{z} values for which
    colors should be plotted. }
  \item{\dots}{ additional arguments to function \code{image}. }
}
\details{
  \code{plot.rmsip} produces a color image with the function
  \code{image}. 
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{rmsip}}, \code{\link{overlap}},
  \code{\link{nma}}, \code{\link{image}}.  }
\examples{
## Read PDB structure
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Perform NMA
modes.a <- nma(pdb, ff="calpha")
modes.b <- nma(pdb, ff="anm")

## Calculate and plot RMSIP
r <- rmsip(modes.a, modes.b)
plot(r)
}
\keyword{ hplot }

\name{pdb.annotate}
\alias{pdb.annotate}
\alias{pdb.pfam}
\title{ Get Customizable Annotations From PDB Or PFAM Databases}
\description{
  Get customizable annotations for query results from PDB or PFAM.  
}
\usage{
pdb.annotate(ids, anno.terms = NULL, unique = FALSE, verbose = FALSE,
             extra.terms = NULL)
pdb.pfam(ids, best.only = TRUE, compact = TRUE)
}
\arguments{
  \item{ids}{ A charater vector of one or more 4-letter PDB
    codes/identifiers of the files for query, or a \sQuote{blast}
    object containing \sQuote{pdb.id}. }
  \item{anno.terms}{ Terms can be used for query. The "anno.terms" can be
   "structureId", "chainId", "macromoleculeType", "chainLength", 
   "experimentalTechnique",  "resolution", "scopDomain", "pfam", "ligandId", 
   "ligandName", "source", "structureTitle", "citation", "rObserved", 
   "rFree", "rWork", and "spaceGroup".
   If anno.terms=NULL, all information would be returned. }
  \item{unique}{ logical, if TRUE only unique PDB entries are
    returned. Alternatively data for each chain ID is provided. }
  \item{verbose}{ logical, if TRUE more details are printed. }
  \item{extra.terms}{ Additional annotation terms to retrieve from PDB.
    Currently not supported. }
  \item{best.only}{ logical, if TRUE only the lowest eValue match for a 
    given input id will be reported. Otherwise all significant matches 
    will be returned. }
  \item{compact}{ logical, if TRUE only a subset of annotation terms 
    are returned. Otherwise full match details are reported (see 
    examples).}      
}
\details{
  Given a list of PDB IDs (and query terms for the pdb.annotate function),  
  these functions will download annotation information from the RCSB PDB 
  and PFAM databases.
}
\value{
  Returns a data frame of query results with a row for each PDB record,
  and annotation terms column-wise. 
}
\author{ Hongyang Li, Barry Grant, Lars Skjaerven, Xin-Qiu Yao}
\examples{
\donttest{
# PDB server connection required - testing excluded

# Fetch all annotation terms
ids <- c("6Q21_B", "1NVW", "1P2U_A")
anno <- pdb.annotate(ids)

# Access terms, e.g. ligand names:
anno$ligandName

## only unique PDB IDs
anno <- pdb.annotate(ids, unique=TRUE)

# Fetch only specific terms
pdb.annotate(ids, anno.terms = c("pfam", "ligandId", "citation"))

}

\dontrun{
# PFAM server connection required - testing excluded

# Find PFAM annotations of PDB entries
pdb.pfam(c("6Q21_A", "1NVW", "1P2U_A"))

# More details and a not fond entry warning
pdb.pfam(c("1P2U_A", "6Q21_B"), compact=FALSE)
}

}
\keyword{ utilities }

\name{deformation.nma}
\alias{deformation.nma}
\title{ Deformation Analysis }
\description{
  Calculate deformation energies from Normal Mode Analysis.
}
\usage{
deformation.nma(nma, mode.inds = NULL, pfc.fun = NULL, ncore = NULL)
}
\arguments{
  \item{nma}{ a list object of class \code{"nma"} (obtained with
    \code{\link{nma}}).}
  \item{mode.inds}{ a numeric vector of mode indices in which the
    calculation should be based. }
  \item{pfc.fun}{ customized pair force constant (\sQuote{pfc})
    function. The provided function should take a vector of distances as
    an argument to return a vector of force constants. See \code{nma}
    for examples. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
}
\details{
  Deformation analysis provides a measure for the amount of local
  flexibility of the protein structure - i.e. atomic motion relative to
  neighbouring atoms. It differs from \sQuote{fluctuations} (e.g. RMSF
  values) which provide amplitudes of the absolute atomic motion.
    
  Deformation energies are calculated based on the \code{nma} object. By
  default the first 20 non-trivial modes are included in the calculation.

  See examples for more details.
}
\value{
  Returns a list with the following components:
  \item{ei }{ numeric matrix containing the energy contribution (E) from
    each atom (i; row-wise) at each mode index (column-wise). }
  \item{sums }{ deformation energies corresponding to each mode. }
}
\references{
  Hinsen, K. (1998) \emph{Proteins} \bold{33}, 417--429.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma} } }
\examples{
\donttest{
# Running the example takes some time - testing excluded

## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Calculate deformation energies
def.energies <- deformation.nma(modes)
}

\dontrun{
## Fluctuations of first non-trivial mode
def.energies <- deformation.nma(modes, mode.inds=seq(7, 16))

write.pdb(pdb=NULL, xyz=modes$xyz,
          b=def.energies$ei[,1])
}
}
\keyword{ analysis }

\name{plot.nma}
\alias{plot.nma}
\title{ Plot NMA Results }
\description{
  Produces eigenvalue/frequency spectrum plots and an atomic fluctuations plot.
}
\usage{
\method{plot}{nma}(x, pch = 16, col = par("col"), cex=0.8, mar=c(6, 4, 2, 2),...)
}
\arguments{
  \item{x}{ the results of normal modes analysis obtained with
    \code{\link{nma}}. }
  \item{pch}{ a vector of plotting characters or symbols: see \code{\link{points}}. }
  \item{col}{ a character vector of plotting colors.  }
  \item{cex}{ a numerical single element vector giving the amount by
    which plotting text and symbols should be magnified relative to the
    default. }
  \item{mar}{ A numerical vector of the form c(bottom, left, top, right)
    which gives the number of lines of margin to be specified on the
    four sides of the plot.}
  \item{\dots}{ extra plotting arguments passed to \code{\link{plot.bio3d}}
    that effect the atomic fluctuations plot only. }
}
\details{
  \code{plot.nma} produces an eigenvalue (or frequency) spectrum plot
  together with a plot of the atomic fluctuations. 
}
\value{
  Called for its effect.
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma}}, \code{\link{plot.bio3d}} }
\examples{
## Fetch structure
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate modes
modes <- nma(pdb)

plot(modes, sse=pdb)

}
\keyword{ hplot }

\name{atom2xyz}
\alias{atom2xyz}
\alias{xyz2atom}
\title{ Convert Between Atom and xyz Indices }
\description{
  Basic functions to convert between xyz and their corresponding atom indices.
}
\usage{
atom2xyz(num)
xyz2atom(xyz.ind)
}
\arguments{
  \item{num}{ a numeric vector of atom indices. }
  \item{xyz.ind}{ a numeric vector of xyz indices. }
}
\value{
  A numeric vector of either xyz or atom indices.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{atom.select}}, \code{\link{read.pdb}} }
\examples{
xyz.ind <- atom2xyz(c(1,10,15))
xyz2atom( xyz.ind )
}
\keyword{ utilities }

\name{load.enmff}
\alias{load.enmff}
\alias{ff.calpha}
\alias{ff.anm}
\alias{ff.pfanm}
\alias{ff.sdenm}
\alias{ff.reach}
\alias{ff.aaenm}
\alias{ff.aaenm2}
\title{ ENM Force Field Loader }
\description{
  Load force field for elastic network normal mode calculation.
}
\usage{
load.enmff(ff = 'calpha')
ff.calpha(r, rmin=2.9, ...)
ff.anm(r, cutoff=15, gamma=1, ...)
ff.pfanm(r, cutoff=NULL, ...)
ff.sdenm(r, atom.id, pdb, ...)
ff.reach(r, atom.id, ...)
ff.aaenm(r, ...)
ff.aaenm2(r, atom.id, pdb, ...)
}
\arguments{
  \item{ff}{ a character string specifying the force field to use:
    \sQuote{calpha}, \sQuote{anm}, \sQuote{pfanm}, 
    \sQuote{reach}, or  \sQuote{sdenm}. }
  \item{r}{ a numeric vector of c-alpha distances. }
  \item{rmin}{ lowest allowed atom-atom distance for the force constant
    calculation. The default of 2.9A is based on an evaluation of 24
    high-resolution X-ray structures (< 1A). }
  \item{cutoff}{ numerical, cutoff for pair-wise interactions. }
  \item{gamma}{ numerical, global scaling factor. }
  \item{atom.id}{ atomic index. }
  \item{pdb}{ a \code{pdb} object as obtained from function \code{read.pdb}. }
  \item{...}{ additional arguments passed to and from functions. }
}
\details{
  This function provides a collection of elastic network model (ENM)
  force fields for normal modes analysis (NMA) of protein structures. It
  returns a function for calculating the residue-residue spring force
  constants.

  The \sQuote{calpha} force field - originally developed by Konrad
  Hinsen - is the recommended one for most applications. It employs a
  spring force constant differentiating between nearest-neighbour pairs
  along the backbone and all other pairs. The force constant function
  was parameterized by fitting to a local minimum of a crambin model
  using the AMBER94 force field.

  The implementation of the \sQuote{ANM} (Anisotropic Network Model)
  force field originates from the lab of Ivet Bahar. It uses a
  simplified (step function) spring force constant based on the
  pair-wise distance. A variant of this from the Jernigan lab is the
  so-called \sQuote{pfANM} (parameter free ANM) with interactions that
  fall off with the square of the distance.
  
  The \sQuote{sdENM} (by Dehouck and Mikhailov) employs residue specific
  spring force constants. It has been parameterized through a
  statistical analysis of a total of 1500 NMR ensembles.

  The \sQuote{REACH} force field (by Moritsugu and Smith) is
  parameterized based on variance-covariance matrices obtained from MD
  simulations. It employs force constants that fall off exponentially
  with distance for non-bonded pairs.

  The all-atom ENM force fields (\sQuote{aaenm} and \sQuote{aaenm2}) was
  obtained by fitting to a local energy minimum of a crambin model
  derived from the AMBER99SB force field (same approach as in Hinsen et
  al 2000). It employs a pair force constant function which falls as
  r^-6. \sQuote{aanma2} employs additonally specific force constants for
  covalent and intra-residue atom pairs. See also \code{\link{aanma}}
  for more details.

  See references for more details on the individual force fields.
}
\note{
  The arguments \sQuote{atom.id} and \sQuote{pdb} are used
  from within function \sQuote{build.hessian} for functions that are not
  simply a function of the pair-wise distance. e.g. the force constants
  in the \sQuote{sdENM} model computes the force constants based on a
  function of the residue types and calpha distance. 
}
\value{
  \sQuote{load.enmff} returns a function for calculating the spring 
  force constants. The \sQuote{ff} functions returns a numeric vector of
  residue-residue spring force constants. 
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Hinsen, K. et al. (2000) \emph{Chemical Physics} \bold{261}, 25--37.
  Atilgan, A.R. et al. (2001) \emph{Biophysical Journal} \bold{80}, 505--515.
  Dehouck Y. & Mikhailov A.S. (2013) \emph{PLoS Comput Biol} \bold{9}:e1003209.
  Moritsugu K. & Smith J.C. (2008) \emph{Biophysical Journal} \bold{95}, 1639--1648.
  Yang, L. et al. (2009) \emph{PNAS} \bold{104}, 12347-52.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma}}, \code{\link{build.hessian}} }
\examples{
## Load the c-alpha force field
pfc.fun <- load.enmff('calpha')

## Calculate the pair force constant for a set of C-alpha distances
force.constants <- pfc.fun( seq(4,8, by=0.5) )

## Calculate the complete spring force constant matrix
## Fetch PDB
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Fetch only c-alpha coordinates
ca.inds <- atom.select(pdb, 'calpha')
xyz <- pdb$xyz[ca.inds$xyz]

## Calculate distance matrix
dists <- dm.xyz(xyz, mask.lower=FALSE)

## all pair-wise spring force constants
fc.matrix <- apply(dists, 1, pfc.fun)
}
\keyword{ utilities }

 
  
  

\name{plot.pca.loadings}
\alias{plot.pca.loadings}
\title{  Plot Residue Loadings along PC1 to PC3 }
\description{
   Plot residue loadings along PC1 to PC3 from a given xyz C-alpha matrix
   of \code{loadings}.
 }
\usage{
\method{plot}{pca.loadings}(x, resnums = seq(1, (length(x[, 1])/3), 25), ...)
}
\arguments{
  \item{x}{ the results of principal component analysis obtained
    from \code{\link{pca.xyz}}, or just the loadings returned from
    \code{\link{pca.xyz}}. }
  \item{resnums}{ a numeric vector of residue numbers. }
  \item{\dots}{ extra plotting arguments. }  
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{pca.xyz}}, \code{\link{plot.pca}} }
\examples{
attach(transducin)

pc.xray <- pca.xyz(pdbs$xyz[, gap.inspect(pdbs$xyz)$f.inds])
plot.pca.loadings(pc.xray$U)

detach(transducin)
}
\keyword{ hplot }

\name{formula2mass}
\alias{formula2mass}
\title{Chemical Formula to Mass Converter}
\description{Compute the molar mass associated to a chemical formula.}
\usage{
formula2mass(form, sum.mass = TRUE)
}
\arguments{
  \item{form}{a character string containing a chemical formula on the form: 'C3 H5 N O1'.}
  \item{sum.mass}{logical, should the mass of each element be summed.}
}
\details{
Compute the molar mass (in g.mol-1) associated to a chemical formula.
}
\value{
Return a single element numeric vector containing the mass corresponding to a given chemical formula.
}

\author{Lars Skjaerven}

\seealso{
\code{\link{atom2ele}}, \code{\link{atom2mass}}
}
\examples{
#formula2mass("C5 H6 N O3")
}
\keyword{ utilities }

\name{atom.index}
\alias{atom.index}
\docType{data}
\title{ Atom Names/Types }
\description{
  This data set gives for various atom names/types the corresponding
  atomic symbols.
}
\usage{
atom.index
}
\format{
  A data frame with the following components.
  \describe{
    \item{\code{name}}{a character vector containing atom names/types.}
    \item{\code{symb}}{a character vector containing atomic symbols.}
  }
}
\seealso{
  \code{\link{elements}}, \code{\link{atom.index}},
  \code{\link{atom2ele}}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\examples{
data(atom.index)
atom.index

# Get the atomic symbol of some atoms
atom.names <- c("CA", "O", "N", "OXT")
atom.index[match(atom.names, atom.index$name), "symb"]

}
\keyword{datasets}

\name{lbio3d}
\alias{lbio3d}
\title{ List all Functions in the bio3d Package }
\description{
  A simple shortcut for ls("package:bio3d"). 
}
\usage{
lbio3d()
}
\value{
  A character vector of function names from the bio3d package.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/community.aln.R
\name{community.aln}
\alias{community.aln}
\title{Align communities from two or more networks}
\usage{
community.aln(x, ..., aln = NULL)
}
\arguments{
\item{x, ...}{two or more objects of class \code{cna} (if the numbers of
nodes are different, an alignment \sQuote{fasta} object is required for 
the \code{aln} argument; See below) as obtained from function \code{\link{cna}}. 
Alternatively, a list of \code{cna} objects can be given to \code{x}.}

\item{aln}{alignment for comparing networks with different numbers of nodes.}
}
\value{
Returns a list of updated \code{cna} objects.
}
\description{
Find equivalent communities from two or more networks and re-assign colors
to them in a consistent way across networks. A \sQuote{new.membership} vector is
also generated for each network, which maps nodes to community IDs that are 
renumbered according to the community equivalency.
}
\details{
This function facilitates the inspection on the variance of the community
partition in a group of similar networks. The original community numbering
(and so the colors of communities in the output of \code{plot.cna} and 
\code{vmd.cna}) can be inconsistent across networks, i.e. equivalent 
communities may display different colors, impeding network comparison. 
The function calculates the dissimilarity between all communities and 
clusters communities with \sQuote{hclust} funciton. In each cluster, 0 or
1 community per network is included. The color attribute of communities is 
then re-assigned according to the clusters through all networks. In addition,
a \sQuote{new.membership} vector is generated for each network, which mapps 
nodes to new community IDs that are numbered consistently across networks.
}
\examples{
\donttest{
  # Needs MUSCLE installed - testing excluded
  if(check.utility("muscle")) {

    if (!requireNamespace("igraph", quietly = TRUE)) {
      message('Need igraph installed to run this example')
    } else {

    ## Fetch PDB files and split to chain A only PDB files
    ids <- c("1tnd_A", "1tag_A")
    files <- get.pdb(ids, split = TRUE, path = tempdir())
    
    ## Sequence Alignement
    pdbs <- pdbaln(files, outfile = tempfile())
    
    ## Normal mode analysis on aligned data
    modes <- nma(pdbs, rm.gaps=TRUE)
    
    ## Dynamic Cross Correlation Matrix
    cijs <- dccm(modes)$all.dccm
 
    ## Correlation Network
    nets <- cna(cijs, cutoff.cij=0.3)

    ## Align network communities
    nets.aln <- community.aln(nets)

    ## plot all-residue and coarse-grained (community) networks
    pdb <- pdbs2pdb(pdbs, inds=1, rm.gaps=TRUE)[[1]]
    op <- par(no.readonly=TRUE)

    # before alignment
    par(mar=c(0.1, 0.1, 0.1, 0.1), mfrow=c(2,2))
    invisible( lapply(nets, function(x) 
       plot(x, layout=layout.cna(x, pdb=pdb, k=3, full=TRUE)[, 1:2], 
               full=TRUE)) )
    invisible( lapply(nets, function(x) 
       plot(x, layout=layout.cna(x, pdb=pdb, k=3)[, 1:2])) )

    # after alignment
    par(mar=c(0.1, 0.1, 0.1, 0.1), mfrow=c(2,2))
    invisible( lapply(nets.aln, function(x) 
       plot(x, layout=layout.cna(x, pdb=pdb, k=3, full=TRUE)[, 1:2], 
               full=TRUE)) )
    invisible( lapply(nets.aln, function(x) 
       plot(x, layout=layout.cna(x, pdb=pdb, k=3)[, 1:2])) )

    par(op)     

    }
  }
}
}
\seealso{
\code{\link{cna}}, \code{\link{plot.cna}}, \code{\link{vmd.cna}}
}
\keyword{analysis}

\name{nma.pdb}
\alias{nma.pdb}
\alias{build.hessian}
\alias{print.nma}
\title{ Normal Mode Analysis }
\description{
  Perform elastic network model (ENM) C-alpha normal modes calculation
  of a protein structure.
}
\usage{
\method{nma}{pdb}(pdb, inds = NULL, ff = 'calpha', pfc.fun = NULL,
                  mass = TRUE, temp = 300.0, keep = NULL, hessian = NULL,
                  outmodes = NULL, \dots )

build.hessian(xyz, pfc.fun, fc.weights = NULL, pdb = NULL, \dots)

\method{print}{nma}(x, nmodes=6, \dots)
}
\arguments{
  \item{pdb}{ an object of class \code{pdb} as obtained from
    function \code{\link{read.pdb}}. }
  \item{inds}{ atom and xyz coordinate indices obtained from
    \code{\link{atom.select}} that selects the elements of \code{pdb}
    upon which the calculation should be based. If not provided the
    function will attempt to select the calpha atoms automatically
    (based on function \code{\link{atom.select}}). }
  \item{ff}{ character string specifying the force field to use:
    \sQuote{calpha}, \sQuote{anm}, \sQuote{pfanm}, 
    \sQuote{reach}, or \sQuote{sdenm}. }
  \item{pfc.fun}{ customized pair force constant (\sQuote{pfc})
    function. The provided function should take a vector of distances as
    an argument to return a vector of force constants. If provided,
    'pfc.fun' will override argument \code{ff}. See examples below. }
  \item{mass}{ logical, if TRUE the Hessian will be mass-weighted. }
  \item{temp}{ numerical, temperature for which the amplitudes for
    scaling the atomic displacement vectors are calculated. Set
    \sQuote{temp=NULL} to avoid scaling. }
  \item{keep}{ numerical, final number of modes to be stored. Note that
    all subsequent analyses are limited to this subset of modes. This
    option is useful for very large structures and cases where memory
    may be limiting. }
  \item{hessian}{ hessian matrix as obtained from
    \code{\link{build.hessian}}. For internal purposes and generally not
    intended for public use. }
  \item{outmodes}{ atom indices as obtained from \code{\link{atom.select}}) 
    specifying the atoms to include in the resulting mode object. }
  \item{xyz}{ a numeric vector of Cartesian coordinates. }
  \item{fc.weights}{ a numeric matrix of size NxN (where N is the number
    of calpha atoms) containg scaling factors for the pariwise force
    constants. See examples below. }
  \item{x}{ an \code{nma} object obtained from \code{\link{nma.pdb}}. }
  \item{nmodes}{ numeric, number of modes to be printed. }
  \item{...}{ additional arguments to \code{\link{build.hessian}},
    \code{\link{aa2mass}}, \code{pfc.fun}, and \code{\link{print}}. One
    useful option here for dealing with unconventional residues is
    \sQuote{mass.custom}, see the \code{\link{aa2mass}} function for details. }
}
\details{
  This function calculates the normal modes of a C-alpha model of a
  protein structure. A number of force fields are implemented all of
  whhich employ the elastic network model (ENM).

  The \sQuote{calpha} force field - originally developed by Konrad
  Hinsen - is the recommended one for most applications. It employs a
  spring force constant differentiating between nearest-neighbour pairs
  along the backbone and all other pairs. The force constant function
  was parameterized by fitting to a local minimum of a crambin model
  using the AMBER94 force field.

  See \code{\link{load.enmff}} for details of the different force fields.

  By default \code{\link{nma.pdb}} will diagonalize the mass-weighted Hessian
  matrix. The resulting mode vectors are moreover scaled by the thermal
  fluctuation amplitudes.

  The implementation under default arguments reproduces the calculation
  of normal modes (VibrationalModes) in the Molecular Modeling Toolkit
  (MMTK) package. To reproduce ANM modes set \code{ff='anm'},
  \code{mass=FALSE}, and \code{temp=NULL}.
}
\value{
  Returns an object of class \sQuote{nma} with the following components:
  \item{modes}{ numeric matrix with columns containing the normal mode
    vectors. Mode vectors are converted to unweighted Cartesian
    coordinates  when \code{mass=TRUE}. Note that the 6 first trivial
    eigenvectos appear in columns one to six. }
  \item{frequencies}{ numeric vector containing the vibrational
    frequencies corresponding to each mode (for \code{mass=TRUE}). }
  \item{force.constants}{ numeric vector containing the force constants
    corresponding to each mode (for \code{mass=FALSE)}). }
  \item{fluctuations}{ numeric vector of atomic fluctuations. }
  \item{U}{ numeric matrix with columns containing the raw
    eigenvectors. Equals to the \code{modes} component when
    \code{mass=FALSE} and \code{temp=NULL}. }
  \item{L}{ numeric vector containing the raw eigenvalues. }
  \item{xyz}{ numeric matrix of class \code{xyz} containing the
    Cartesian coordinates in which the calculation was performed. }
  \item{mass}{ numeric vector containing the residue masses used for the
    mass-weighting. }
  \item{temp}{ numerical, temperature for which the amplitudes for
    scaling the atomic displacement vectors are calculated. }
  \item{triv.modes}{ number of trivial modes. }
  \item{natoms}{ number of C-alpha atoms. }
  \item{call}{ the matched call. }
}
\note{
  The current version provides an efficent implementation of NMA with
  execution time comparable to similar software (when the entire Hessian
  is diagonalized).

  The main (speed related) bottleneck is currently the diagonalization
  of the Hessian matrix which is performed with the core R function
  \code{\link{eigen}}. For computing a few (5-20) approximate modes the user
  can consult package \sQuote{irlba}.

  NMA is memory extensive and users should be cautions when running
  larger proteins (>3000 residues). Use \sQuote{keep} to reduce the
  amount of memory needed to store the final \sQuote{nma} object (the
  full 3Nx3N Hessian matrix still needs to be allocated).

  We thank Edvin Fuglebakk for valuable discussions on the
  implementation as well as for contributing with testing.
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  Hinsen, K. et al. (2000) \emph{Chemical Physics} \bold{261}, 25--37.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{fluct.nma}}, \code{\link{mktrj.nma}},
  \code{\link{dccm.nma}}, \code{\link{overlap}}, \code{\link{rmsip}},
  \code{\link{load.enmff}}. }
\examples{
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate normal modes
modes <- nma(pdb)

## Print modes
print(modes)

## Plot modes
plot(modes)

## Visualize modes
#m7 <- mktrj.nma(modes, mode=7, file="mode_7.pdb")

\dontrun{
## Use Anisotropic Network Model
modes <- nma(pdb, ff="anm", mass=FALSE, temp=NULL, cutoff=15)

## Use SSE information and SS-bonds
sse      <- dssp(pdb, resno=FALSE, full=TRUE)
ss.bonds <- matrix(c(76,94, 64,80, 30,115, 6,127),
                   ncol=2, byrow=TRUE)


## User defined energy function
## Note: Must take a vector of distances
"my.ff" <- function(r) {
   ifelse( r>15, 0, 1 )
}

## Modes with a user defined energy function
modes <- nma(pdb, pfc.fun=my.ff)


## A more manual approach
sele <- atom.select(pdb, chain='A', elety='CA')
xyz <- pdb$xyz[sele$xyz]

hessian <- build.hessian(xyz, my.ff)
modes <- eigen(hessian)

## Dealing with unconventional residues
pdb <- read.pdb("1xj0")

## nma(pdb)
#modes <- nma(pdb, mass.custom=list(CSX=121.166))
}
}
\keyword{ analysis }

\name{cnapath}
\alias{cnapath}
\alias{summary.cnapath}
\alias{print.cnapath}
\alias{plot.cnapath}
\alias{plot.ecnapath}
\title{ Suboptimal Path Analysis for Correlation Networks }
\description{
  Find k shortest paths between a pair of nodes, source and sink, in a correlation 
  network. 
}
\usage{
cnapath(cna, from, to=NULL, k=10, collapse=TRUE, ncore=NULL, \dots)
\method{summary}{cnapath}(object, \dots, pdb = NULL, label = NULL, col = NULL,
   plot = FALSE, concise = FALSE, cutoff = 0.1, normalize = TRUE, weight = FALSE)
\method{print}{cnapath}(x, \dots)
\method{plot}{cnapath}(x, \dots)
\method{plot}{ecnapath}(x, \dots)
}
\arguments{
  \item{cna}{ A \sQuote{cna} object or a list of \sQuote{cna} objects obtained from 
       \code{\link{cna}}. }
  \item{from}{ Integer vector or matrix indicating node id(s) of source. If is matrix
       and \code{to} is NULL, the first column represents source and the second sink. }
  \item{to}{ Integer vector indicating node id(s) of sink. All combinations of 
       \code{from} and \code{to} values will be used as source/sink pairs. }
  \item{k}{ Integer, number of suboptimal paths to identify. }
  \item{collapse}{ Logical, if TRUE results from all source/sink pairs are merged with
       a single \sQuote{cnapath} object returned. }
  \item{ncore}{ Number of CPU cores used to do the calculation. 
       By default (NULL), use all detected CPU cores. }

  \item{object}{ A \sQuote{cnapath} class of object obtained from 
       \code{cnapath}. Multiple \sQuote{object} input is allowed for 
       comparing paths from different networks. }
  \item{pdb}{ A \sQuote{pdb} class of object obtained from \code{\link{read.pdb}} 
       and is used as the reference for node residue ids (in \code{summary.cnapath}) or 
       for molecular visulaization with VMD (in \code{vmd.cnapath}). }
  \item{label}{ Character, label for paths identified from different networks. }
  \item{col}{ Colors for plotting statistical results for paths identified 
       from different networks. }
  \item{plot}{ Logical, if TRUE path length distribution and node degeneracy will be plotted. }
  \item{concise}{ Logical, if TRUE only \sQuote{on path} residues will be displayed in the
       node degeneracy plot. }
  \item{cutoff}{ Numeric, nodes with node degeneracy larger than \code{cutoff} are
       shown in the output. }
  \item{normalize}{ Logical, if TRUE node degeneracy is divided by the total 
       (weighted) number of paths. }
  \item{weight}{ Logical, if TRUE each path is weighted by path length in calculating the
    node degeneracty. }
  \item{x}{ A 'cnapath' class object, or a list of such objects, as obtained from function \code{cnapath}.
  }
  \item{\dots}{ Additional arguments passed to igraph function 
       \code{\link[igraph:distances]{get.shortest.paths}} (in 
       the function \code{cnapath}), passed to \code{summary.cnapath} 
       (in \code{print.cnapath}), as additional paths for 
       comparison (in \code{summary.cnapath}). }
}
\value{
  The function \code{cnapath} returns a (or a list of) \sQuote{cnapath} 
  class of list containing following three components:
  \item{path}{ a list object containing all identified suboptimal paths.  
      Each entry of the list is a sequence of node ids for the path. }
  \item{epath}{ a list object containing all identified suboptimal paths. 
      Each entry of the list is a sequence of edge ids for the path. }
  \item{dist}{ a numeric vector of all path lengths. }

  The function \code{summary.cnapath} returns a matrix of (normalized)
  node degeneracy for \sQuote{on path} residues. 
}
\references{
  Yen, J.Y. (1971) \emph{Management Science} \bold{17}, 712--716.
}
\author{ Xin-Qiu Yao }
\seealso{
  \code{\link{cna}}, \code{\link{cna.dccm}},
  \code{\link{vmd.cna}}, \code{\link{vmd.cnapath}}, 
  \code{\link[igraph:distances]{get.shortest.paths}}. }
\examples{
\donttest{
# Redundant testing excluded

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

attach(transducin)
inds = match(c("1TND_A", "1TAG_A"), pdbs$id)

npdbs <- trim(pdbs, row.inds=inds)
gaps.res <- gap.inspect(npdbs$ali)

modes <- nma(npdbs)
cij <- dccm(modes)
net <- cna(cij, cutoff.cij=0.3)

# get paths
pa1 <- cnapath(net[[1]], from = 314, to=172, k=50)
pa2 <- cnapath(net[[2]], from = 314, to=172, k=50)

# print the information of a path
pa1

# print two paths simultaneously
pas <- list(pa1, pa2)
names(pas) <- c("GTP", "GDP")
print.cnapath(pas)

# Or, for the same effect,
# summary(pa1, pa2, label=c("GTP", "GDP"))

# replace node numbers with residue name and residue number in the PDB file
pdb <- read.pdb("1tnd")
pdb <- trim.pdb(pdb, atom.select(pdb, chain="A", resno=npdbs$resno[1, gaps.res$f.inds]))
print.cnapath(pas, pdb=pdb)

# plot path length distribution and node degeneracy
print.cnapath(pas, pdb = pdb, col=c("red", "darkgreen"), plot=TRUE)

# View paths in 3D molecular graphic with VMD
#vmd.cnapath(pa1, pdb, launch = TRUE)
#vmd.cnapath(pa1, pdb, colors = 7, launch = TRUE)
#vmd.cnapath(pa1, pdb, spline=TRUE, colors=c("pink", "red"), launch = TRUE)
#pdb2 <- read.pdb("1tag")
#pdb2 <- trim.pdb(pdb2, atom.select(pdb2, chain="A", resno=npdbs$resno[2, gaps.res$f.inds]))
#vmd.cnapath(pa2, pdb2, launch = TRUE)

detach(transducin)

}
}
}
\keyword{ utilities }

\name{is.xyz}
\alias{is.xyz}
\alias{as.xyz}
\title{ Is an Object of Class \sQuote{xyz}?  }
\description{
  Checks whether its argument is an object of class \sQuote{xyz}.
}
\usage{
  is.xyz(x)
  as.xyz(x)
}
\arguments{
  \item{x}{
    an R object to be tested
  }
}
\details{
  Tests if x is an object of class \sQuote{xyz}, i.e. if x has a
  \dQuote{class} attribute equal to \code{xyz}. 
}
\value{
  TRUE if x is an object of class \sQuote{xyz} and FALSE otherwise
}

\seealso{
  \code{\link{read.pdb}}, \code{\link{read.ncdf}},
  \code{\link{read.dcd}}, \code{\link{fit.xyz}}
}
\examples{
# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
is.xyz(pdb$xyz)

}
\keyword{ classes }

\name{pca}
\alias{pca}
\title{ Principal Component Analysis }
\description{
  Performs principal components analysis (PCA) on biomolecular structure data. 
}
\usage{
  pca(...)
}
\arguments{
  \item{\dots}{ arguments passed to the methods \code{pca.xyz},
    \code{pca.pdbs}, etc. Typically this includes either a numeric
    matrix of Cartesian coordinates with a row per structure/frame (function
    \code{pca.xyz()}), or an object  of class \code{pdbs} as obtained from
    function \code{pdbaln} or \code{read.fasta.pdb} (function
    \code{pca.pdbs()}). } 
}
\details{
  Principal component analysis can be performed on any structure dataset of equal or unequal sequence composition to capture and characterize inter-conformer relationships.

  This generic \code{pca} function calls the corresponding methods function for actual calculation, which is determined by the class of the input argument \code{x}. Use
  \code{methods("pca")} to list all the current methods for \code{pca}
  generic. These will include:

  \code{\link{pca.xyz}}, which will be used when \code{x} is a numeric matrix
  containing Cartesian coordinates (e.g. trajectory data).
  
  \code{\link{pca.pdbs}}, which will perform PCA on the 
  Cartesian coordinates of a input \code{pdbs} object (as obtained from 
  the \sQuote{read.fasta.pdb} or \sQuote{pdbaln} functions).

  Currently, function \code{\link{pca.tor}} should be called explicitly as there
  are currently no defined \sQuote{tor} object classes.
  
  See the documentation and examples for each individual function for
  more details and worked examples.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{
  \code{\link{pca.xyz}}, \code{\link{pca.pdbs}},
  \code{\link{pdbaln}}. }
\keyword{ utilities }

\name{cmap}
\alias{cmap}
\alias{cmap.default}
\alias{cmap.xyz}
\alias{cmap.pdb}
\alias{cmap.pdbs}
\title{ Contact Map }
\description{
  Construct a Contact Map for Given Protein Structure(s).}
\usage{
cmap(\dots)

\method{cmap}{default}(\dots)

\method{cmap}{xyz}(xyz, grpby = NULL, dcut = 4, scut = 3, pcut=1, binary=TRUE,
            mask.lower = TRUE, collapse=TRUE, gc.first=FALSE, ncore=1, nseg.scale=1, \dots)

\method{cmap}{pdb}(pdb, inds = NULL, verbose = FALSE, \dots)

\method{cmap}{pdbs}(pdbs, rm.gaps=FALSE, all.atom=FALSE, \dots)
}
\arguments{
  \item{xyz}{ numeric vector of xyz coordinates or a numeric matrix of
    coordinates with a row per structure/frame. }
  \item{grpby}{ a vector counting connective duplicated elements that
    indicate the elements of \code{xyz} that should be considered as a group
    (e.g. atoms from a particular residue). }  
  \item{dcut}{ a cutoff distance value below which atoms are considered
    in contact. }
  \item{scut}{ a cutoff neighbour value which has the effect of
    excluding atoms that are sequentially within this value. }
  \item{pcut}{ a cutoff probability of structures/frames showing a contact,
    above which atoms are considered in contact with respect to the ensemble.
    Ignored if \code{binary=FALSE}. }
  \item{binary}{ logical, if FALSE the raw matrix containing fraction of frames that 
    two residues are in contact is returned. }
  \item{mask.lower}{ logical, if TRUE the lower matrix elements
    (i.e. those below the diagonal) are returned as NA.}
  \item{collapse}{ logical, if FALSE an array of contact maps for all frames is returned. }
  \item{gc.first}{ logical, if TRUE will call gc() first before calculation of 
    distance matrix. This is to solve the memory overload problem when \code{ncore > 1}
    and \code{xyz} has many rows, with a bit sacrifice on speed. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
  \item{pdb}{  a structure object of class \code{"pdb"}, obtained from
    \code{\link{read.pdb}}. }
  \item{inds}{ a list object of ATOM and XYZ indices as obtained from
    \code{\link{atom.select}}. }
  \item{verbose}{ logical, if TRUE details of the selection are
    printed. }
  \item{pdbs}{ a \sQuote{pdbs} object as returned by \code{\link{read.fasta.pdb}},
    \code{\link{read.all}}, or \code{\link{pdbaln}}. }
  \item{rm.gaps}{ logical, if TRUE gapped positions are removed in the returned value. }
  \item{all.atom}{ logical, if TRUE all-atom coordinates from \code{\link{read.all}}
    are used. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  A contact map is a simplified distance matrix. See the distance matrix
  function \code{\link{dm}} for further details.
  
  Function \code{"cmap.pdb"} is a wrapper for \code{"cmap.xyz"}
  which selects all \sQuote{notwater} atoms and calculates the contact
  matrix grouped by residue number.

}
\value{
  Returns a N by N numeric matrix composed of zeros and ones, where
  one indicates a contact between selected atoms.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{dm}}, \code{\link{dccm}}, \code{\link{dist}},
  \code{\link{dist.xyz}} }
\examples{

##- Read PDB file
pdb <- read.pdb( system.file("examples/hivp.pdb", package="bio3d") )

## Atom Selection indices
inds <- atom.select(pdb, "calpha")

## Reference contact map
ref.cont <- cmap( pdb$xyz[inds$xyz], dcut=6, scut=3 )
plot.cmap(ref.cont)

\dontrun{
##- Read Traj file
trj <- read.dcd( system.file("examples/hivp.dcd", package="bio3d") )
## For each frame of trajectory
sum.cont <- NULL
for(i in 1:nrow(trj)) {

  ## Contact map for frame 'i'
  cont <- cmap(trj[i,inds$xyz], dcut=6, scut=3)

  ## Product with reference
  prod.cont <- ref.cont * cont
  sum.cont <- c(sum.cont, sum(prod.cont,na.rm=TRUE))
}

plot(sum.cont, typ="l")
}
}
\keyword{ utilities }

\name{is.mol2}
\alias{is.mol2}
\title{ Is an Object of Class \sQuote{mol2}?  }
\description{
  Checks whether its argument is an object of class \sQuote{mol2}.
}
\usage{
  is.mol2(x)
}
\arguments{
  \item{x}{ an R object. }
}
\details{
  Tests if the object \sQuote{x} is of class \sQuote{mol2}
  (\code{is.mol2}), i.e. if \sQuote{x} has a
  \dQuote{class} attribute equal to \code{mol2}.
}
\value{
  TRUE if x is an object of class \sQuote{mol2} and FALSE otherwise
}

\seealso{
  \code{\link{read.mol2}}
}
\examples{
# Read a PDB file
mol <- read.mol2( system.file("examples/aspirin.mol2", package="bio3d") )
is.mol2(mol)
}
\keyword{ classes }

\name{motif.find}
\alias{motif.find}
\title{ Find Sequence Motifs. }
\description{
  Return Position Indices of a Short Sequence Motif Within a Larger Sequence.
}
\usage{
motif.find(motif, sequence)
}
\arguments{
  \item{motif}{ a character vector of the short sequence motif. }
  \item{sequence}{ a character vector of the larger sequence. }
}
\details{
  The sequence and the motif can be given as a either a multiple or
  single element character vector. The dot character and other valid
  \code{regexpr} characters are allowed in the motif, see examples.
}
\value{
  Returns a vector of position indices within the sequence where the
  motif was found, see examples.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{regexpr}}, \code{\link{read.fasta}}, \code{\link{pdbseq}} 
}
\examples{
\donttest{
# PDB server connection required - testing excluded

aa.seq <- pdbseq( read.pdb( get.pdb("4q21", URLonly=TRUE) ) )
motif = c("G....GKS")
motif.find(motif, aa.seq)
}
}
\keyword{ utilities }

\name{filter.cmap}
\alias{filter.cmap}
\title{ Contact Map Consensus Filtering }
\description{
  This function filters a tridimensional contact matrix (NxNxZ), where N is
  the residue number and Z is the simulation number) selecting only
  contacts present in at least P simulations.
}
\usage{
filter.cmap(cm, cutoff.sims = NULL)
}
\arguments{
  \item{cm}{ An array of dimensions NxNxZ or a list of NxN matrices
    containing binary contact values as obtained from
    \code{cmap}. Here, \sQuote{N} is the residue number and \sQuote{Z}
    the simulation number. The matrix elements should be 1 if two
    residues are in contact and 0 if they are not in contact. }
  \item{cutoff.sims}{ A single element numeric vector corresponding to
    the minimum number of simulations a contact between two residues
    must be present. If not, it will be set to 0 in the output matrix. }
}
\value{
  The output matrix is a nXn binary matrix (n = residue number). Elements
  equal to 1 correspond to residues in contact, elements equal to 0 to
  residues not in contact. 
}
\seealso{
  \code{\link{cmap}}, \code{\link{plot.cmap}}
}
\examples{

\dontrun{
   ## load example data
  pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
  pdb <- read.pdb(pdbfile)

  trtfile <- system.file("examples/hivp.dcd", package="bio3d")
  trj <- read.dcd(trtfile, verbose=FALSE)

  ## split the trj example in two
  num.of.frames <- dim(trj)[1]
  trj1 <- trj[1:(num.of.frames/2),]
  trj2 <- trj[((num.of.frames/2)+1):num.of.frames,]

  ## Lets work with Calpha atoms only
  ca.inds <- atom.select(pdb, "calpha")
  #noh.inds <- atom.select(pdb, "noh")

  ## calculate single contact map matrices
  cms <- list()
  cms[[1]] <- cmap(trj1[,ca.inds$xyz], pcut=0.3, scut=0, dcut=7, mask.lower=FALSE)
  cms[[2]] <- cmap(trj1[,ca.inds$xyz], pcut=0.3, scut=0, dcut=7, mask.lower=FALSE)

  ## calculate average contact matrix
  cm.filter <- filter.cmap(cms, cutoff.sims=2)

  ## plot the result
  par(pty="s", mfcol=c(1,3))
  plot.cmap(cms[[1]])
  plot.cmap(cms[[2]])
  plot.cmap(cm.filter)
}
}
\keyword{analysis}

\name{diag.ind}
\alias{diag.ind}
\title{ Diagonal Indices of a Matrix }
\description{
  Returns a matrix of logicals the same size of a given matrix with
  entries 'TRUE' in the upper triangle close to the diagonal.
}
\usage{
diag.ind(x, n = 1, diag = TRUE)
}
\arguments{
  \item{x}{ a matrix. }
  \item{n}{ the number of elements from the diagonal to include. }
  \item{diag}{ logical. Should the diagonal be included? }
}
\details{
  Basic function useful for masking elements close to the diagonal of a
  given matrix.
}
\value{
  Returns a matrix of logicals the same size of a given matrix with
  entries 'TRUE' in the upper triangle close to the diagonal.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{diag}},  \code{\link{lower.tri}},
  \code{\link{upper.tri}}, \code{\link{matrix}} }
\examples{
diag.ind( matrix(,ncol=5,nrow=5), n=3 )
}
\keyword{ utilities }

\name{dccm.enma}
\alias{dccm.enma}
\title{ Cross-Correlation for Ensemble NMA (eNMA) }
\description{
  Calculate the cross-correlation matrices from an ensemble of NMA
  objects. 
}
\usage{
\method{dccm}{enma}(x, ncore = NULL, na.rm=FALSE, \dots)
}
\arguments{
  \item{x}{ an object of class \code{enma} as obtained from
    function \code{nma.pdbs}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{na.rm }{ logical, if FALSE the DCCM might containt NA values
    (applies only when the \code{enma} object is calculated with
    argument \sQuote{rm.gaps=FALSE}). }
  \item{\dots}{ additional arguments passed to \code{dccm.nma}. }
}
\details{
  This is a wrapper function for calling \code{dccm.nma} on a collection
  of \sQuote{nma} objects as obtained from function \code{nma.pdbs}.
  
  See examples for more details.
}
\value{
  Returns a list with the following components:
  \item{all.dccm }{ an array or list containing the correlation matrices
    for each \sQuote{nma} object. An array is returned when the
    \sQuote{enma} object is calculated with \sQuote{rm.gaps=TRUE}, and a
    list is used when \sQuote{rm.gaps=FALSE}. }
  \item{avg.dccm }{ a numeric matrix containing the average correlation
    matrix. The average is only calculated when the \sQuote{enma} object
    is calculated with \sQuote{rm.gaps=TRUE}. }
}
\references{
  Wynsberghe. A.W.V, Cui, Q. \emph{Structure} \bold{14}, 1647--1653.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma}}, \code{\link{dccm.nma}}, \code{\link{plot.dccm}} }
\examples{
\donttest{
## Needs MUSCLE installed - testing excluded

if(check.utility("muscle")) {

## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
files <- get.pdb(ids, split = TRUE, path = tempdir())

## Sequence/Structure Alignement
pdbs <- pdbaln(files, outfile = tempfile())

## Normal mode analysis on aligned data
modes <- nma(pdbs)

## Calculate all 6 correlation matrices
cij <- dccm(modes)

## Plot correlations for first structure
plot.dccm(cij$all.dccm[,,1])

}
}

}
\keyword{ analysis }

\name{plot.bio3d}
\alias{plot.bio3d}
\alias{plotb3}
\title{ Plots with marginal SSE annotation }
\description{
  Draw a standard scatter plot with optional secondary structure in the
  marginal regions.
}
\usage{
  plotb3(x, resno = NULL, rm.gaps = FALSE, type = "h",
             main = "", sub = "",
             xlim = NULL, ylim = NULL, ylim2zero = TRUE,
             xlab = "Residue", ylab = NULL, 
             axes = TRUE, ann = par("ann"), col = par("col"),
             sse = NULL, sse.type="classic", sse.min.length=5,
             top = TRUE, bot = TRUE, 
             helix.col = "gray20", sheet.col = "gray80",
             sse.border = FALSE, ...)

             \method{plot}{bio3d}(...)


}
\arguments{
  \item{x}{ a numeric vector of values to be plotted.  Any reasonable way of
    defining these plot coordinates is acceptable.  See the function
    \sQuote{xy.coords} for details. }
  \item{resno}{ an optional vector with length equal to that of
    \sQuote{x} that will be used to annotate the xaxis. This is typically
    a vector of residue numbers. If NULL residue positions from 1 to the
    length of \sQuote{x} will be used. See examples below. }
  \item{rm.gaps}{ logical, if TRUE gaps in \code{x}, indicated by NA values,
    will be removed from plot. }
  \item{type}{ one-character string giving the type of plot desired.  The
    following values are possible, (for details, see \sQuote{plot}): \sQuote{p}
    for points, \sQuote{l} for lines, \sQuote{o} for over-plotted points and
    lines, \sQuote{b}, \sQuote{c}) for points joined by lines,
    \sQuote{s} and \sQuote{S} for stair steps and \sQuote{h} for
    histogram-like vertical lines.  Finally, \sQuote{n} does not produce
    any points or lines. }
  \item{main}{ a main title for the plot, see also \sQuote{title}. }
  \item{sub}{ a sub-title for the plot. }
  \item{xlim}{ the x limits (x1,x2) of the plot.  Note that x1 > x2 is
          allowed and leads to a reversed axis. }
  \item{ylim}{ the y limits of the plot. }
  \item{ylim2zero}{ logical, if TRUE the y-limits are forced to start at zero. }
  \item{xlab}{ a label for the x axis, defaults to a description of \sQuote{x}. }
  \item{ylab}{ a label for the y axis, defaults to a description of \sQuote{y}. }
  \item{axes}{ a logical value indicating whether both axes should be drawn
    on the plot.  Use graphical parameter \sQuote{xaxt} or
    \sQuote{yaxt} to suppress just one of the axes. }
  \item{ann}{ a logical value indicating whether the default annotation
    (title and x and y axis labels) should appear on the plot. }
  \item{col}{ The colors for lines and points.  Multiple colors can be
    specified so that each point is given its own color.  If there are
    fewer colors than points they are recycled in the standard fashion.
    Lines are plotted in the first color specified. }
  \item{sse}{ secondary structure object as returned from
    \code{\link{dssp}}, \code{\link{stride}} or in certain cases
    \code{\link{read.pdb}}. }
  \item{sse.type}{ single element character vector that determines the
    type of secondary structure annotation drawn. The following values
    are possible, \sQuote{classic} and \sQuote{fancy}. See details and 
    examples below. }
  \item{sse.min.length}{ a single numeric value giving the length below
    which secondary structure elements will not be drawn. This is useful
    for the exclusion of short helix and strand regions that can often crowd
    these forms of plots. }
  \item{top}{ logical, if TRUE rectangles for each sse are drawn towards
    the top of the plotting region.  }
  \item{bot}{ logical, if TRUE rectangles for each sse are drawn towards
    the bottom of the plotting region. }
  \item{helix.col}{ The colors for rectangles representing alpha helices. }
  \item{sheet.col}{ The colors for rectangles representing beta strands. }
  \item{sse.border}{ The border color for all sse rectangles. }
  \item{\dots}{ other graphical parameters. }
}
\details{
  This function is useful for plotting per-residue numeric vectors for a
  given protein structure (e.g. results from RMSF, PCA, NMA etc.) along
  with a schematic representation of major secondary structure elements.

  Two forms of secondary structure annotation are available: so called
  \sQuote{classic} and \sQuote{fancy}. The former draws marginal
  rectangles and has been available within Bio3D from version 0.1. The
  later draws more \sQuote{fancy} (and distracting) 3D like helices and
  arrowed strands.
  
  See the functions \sQuote{plot.default}, \code{\link{dssp}} and \code{\link{stride}} 
  for further details.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{ Be sure to check the correspondence of your \sQuote{sse} object with the
  \sQuote{x} values being plotted as no internal checks are performed.
}
\seealso{ \code{\link{plot.default}}, \code{\link{dssp}}, \code{\link{stride}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

## Plot of B-factor values along with secondary structure from PDB
pdb <- read.pdb( "1bg2" )
bfac <- pdb$atom[pdb$calpha,"b"]
plot.bio3d(bfac, sse=pdb, ylab="B-factor", col="gray")
points(bfac, typ="l")
}

\dontrun{
## Use PDB residue numbers and include short secondary structure elements
plot.bio3d(pdb$atom[pdb$calpha,"b"], sse=pdb, resno=pdb, ylab="B-factor",
  typ="l", lwd=1.5, col="blue", sse.min.length=0)


## Calculate secondary structure using stride() or dssp()
#sse <- stride(pdb)
sse <- dssp(pdb)

## Plot of B-factor values along with calculated secondary structure
plot.bio3d(pdb$atom[pdb$calpha,"b"], sse=sse, ylab="B-factor", typ="l",
col="blue", lwd=2)
}

\donttest{
# PDB server connection required - testing excluded

## Plot 'aligned' data respecting gap positions
attach(transducin)

pdb = read.pdb("1tnd") ## Reference PDB see: pdbs$id[1]
pdb = trim.pdb(pdb, inds=atom.select(pdb, chain="A"))

## Plot of B-factor values with gaps
plot.bio3d(pdbs$b, resno=pdb, sse=pdb, ylab="B-factor")

## Plot of B-factor values after removing all gaps 
plot.bio3d(pdbs$b, rm.gaps=TRUE, resno = pdb, sse=pdb, ylab="B-factor")

detach(transducin)
}

## Fancy secondary structure elements
##plot.bio3d(pdb$atom[pdb$calpha,"b"], sse=pdb, ssetype="fancy")
## Currently not implemented
}
\keyword{ hplot }

\name{cna}
\alias{cna}
\alias{cna.dccm}
\alias{cna.ensmb}
\title{ Protein Dynamic Correlation Network Construction and Community Analysis.  }
\description{
  This function builds both residue-based and community-based undirected weighted
  network graphs from an input correlation matrix, as obtained from the
  functions \sQuote{dccm}, \sQuote{dccm.nma}, and \sQuote{dccm.enma}. Community
  detection/clustering is performed on the initial residue based 
  network to determine the community organization and network structure
  of the community based network.
}
\usage{
  cna(cij, \dots)
  \method{cna}{dccm}(cij, cutoff.cij=0.4, cm=NULL,  vnames=colnames(cij),
      cluster.method="btwn", collapse.method="max", 
      cols=vmd_colors(), minus.log=TRUE, \dots)
  \method{cna}{ensmb}(cij, \dots, ncore = NULL)
}
\arguments{
  \item{cij}{ A numeric array with 2 dimensions (nXn) containing atomic
    correlation values, where "n" is the residue number. The matrix
    elements should be in between 0 and 1 (atomic correlations). Can be
    also a set of correlation matrices for ensemble network analysis. See
     \sQuote{dccm} function in bio3d package for further details. }
  \item{\dots}{  Additional arguments passed to the methods
    \code{cna.dccm} and \code{cna.ensmb}. }
  \item{cutoff.cij}{ Numeric element specifying the cutoff on cij matrix
    values. Coupling below cutoff.cij are set to 0. }
  \item{cm}{ (optinal) A numeric array with 2 dimensions (nXn)
    containing binary contact values, where "n" is the residue
    number. The matrix elements should be 1 if two residues are in
    contact and 0 if not in contact. See the  \sQuote{cmap} function in
    bio3d package for further details. }
  \item{vnames}{ A vector of names for each column in the input
    cij. This will be used for referencing residues in a similar way
    to residue numbers in later analysis. }  
  \item{cluster.method}{ A character string specifying the method for
    community determination. Supported methods are:\cr
    btwn="Girvan-Newman betweenness"\cr
    walk="Random walk"\cr
    greed="Greedy algorithm for modularity optimization"\cr 
    infomap="Infomap algorithm for community detection"\cr }  
  \item{collapse.method}{ A single element character vector specifing
    the \sQuote{cij} collapse method, can be one of \sQuote{max}, \sQuote{median},
    \sQuote{mean}, or \sQuote{trimmed}. By defualt the \sQuote{max} method is
    used to collapse the input residue based \sQuote{cij} matrix into a smaller
    community based network by taking the maximium \sQuote{abs(cij)} value between
    communities as the comunity-to-community cij value for clustered
    network construction. }
  \item{cols}{ A vector of colors assigned to network nodes. }
  \item{minus.log}{ Logical, indicating whether \sQuote{-log(abs(cij))}
    values should be used for network construction. } 
  \item{ncore}{ Number of CPU cores used to do the calculation. By default,
    use all available cores. }
}
\value{
  Returns a list object that includes igraph network and community
  objects with the following components:
  \item{network}{ An igraph residue-wise graph object. See below
    for more details.}
  \item{communities}{ An igraph residue-wise community object. See
    below for more details. }
  \item{communitiy.network}{ An igraph community-wise graph object. See
    below for more details. }
  \item{community.cij}{ Numeric square matrix containing the absolute values of
    the atomic correlation input matrix for each community as obtained
    from \sQuote{cij} via application of  \sQuote{collapse.method}. }
  \item{cij}{ Numeric square matrix containing the absolute values of
    the atomic correlation input matrix. }

  If an ensemble of correlation matrices is provided, a list of \sQuote{cna} 
  object, of the \sQuote{ecna} class, will be returned.
}
\details{
  The input to this function should be a correlation matrix as
  obtained from the  \sQuote{dccm}, \sQuote{dccm.mean} or \sQuote{dccm.nma}
  and related functions. Optionally, a contact map \sQuote{cm} may also given 
  as input to filter the correlation matrix resulting in the exclusion of  
  network edges between non-contacting atom pairs (as defined in the contact map).

  Internally this function calls the igraph package
  functions \sQuote{graph.adjacency},
  \sQuote{edge.betweenness.community}, \sQuote{walktrap.community},
  \sQuote{fastgreedy.community}, and \sQuote{infomap.community}. The first constructs an undirected
  weighted network graph. The second performs Girvan-Newman style clustering by
  calculating the edge betweenness of the graph, removing the edge with
  the highest edge betweenness score, calculates modularity (i.e. the difference between
  the current graph partition and the partition of a random graph, see Newman and Girvan,
  Physical Review E (2004), Vol 69, 026113), then recalculating edge betweenness
  of the edges and again removing the one with the highest score, etc. 
  The returned community partition is the one with the highest overall modularity value.
  \sQuote{walktrap.community} implements the Pons and Latapy algorithm based on the idea that
  random walks on a graph tend to get "trapped" into densely connected parts of it,
  i.e. a community. The random walk process is used to determine a distance
  between nodes. Nodes with low distance values are joined in the same community.
  \sQuote{fastgreedy.community} instead determines the community structure based on the
  optimization of the modularity. In the starting state each node is isolated and 
  belongs to a separated community. Communities are then joined together (according to the
  network edges) in pairs and the modularity is calculated. At each step the join resulting
  in the highest increase of modularity is chosen. This process is repeated until a single
  community is obtained, then the partitioning with the highest modularity score is selected.
  \sQuote{infomap.community} finds community structure that minimizes the expected description
     length of a random walker trajectory.
}
\author{ Guido Scarabelli and Barry Grant }  
\seealso{
   \code{\link{plot.cna}},  \code{\link{summary.cna}},
   \code{\link{vmd.cna}}, \code{\link[igraph:graph_from_adjacency_matrix]{graph.adjacency}},
   \code{\link[igraph:cluster_edge_betweenness]{edge.betweenness.community}},
   \code{\link[igraph:cluster_walktrap]{walktrap.community}}, 
   \code{\link[igraph:cluster_fast_greedy]{fastgreedy.community}},
   \code{\link[igraph:cluster_infomap]{infomap.community}}
}
\examples{
\donttest{
# PDB server connection required - testing excluded

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

##-- Build a correlation network from NMA results
## Read example PDB
pdb <- read.pdb("4Q21")

## Perform NMA
modes <- nma(pdb)
#plot(modes, sse=pdb)

## Calculate correlations 
cij <- dccm(modes)
#plot(cij, sse=pdb)

## Build, and betweenness cluster, a network graph
net <- cna(cij, cutoff.cij=0.35)
#plot(net, pdb)

## within VMD set 'coloring method' to 'Chain' and 'Drawing method' to Tube
#vmd.cna(net, trim.pdb(pdb, atom.select(pdb,"calpha")), launch=TRUE )

##-- Build a correlation network from MD results
## Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## select residues 24 to 27 and 85 to 90 in both chains
inds <- atom.select(pdb, resno=c(24:27,85:90), elety='CA')

## lsq fit of trj on pdb
xyz <- fit.xyz(pdb$xyz, trj, fixed.inds=inds$xyz, mobile.inds=inds$xyz)

## calculate dynamical cross-correlation matrix
cij <- dccm(xyz)

## Build, and betweenness cluster, a network graph
net <- cna(cij)

# Plot coarse grained network based on dynamically coupled communities
xy <- plot.cna(net)
plot.dccm(cij, margin.segments=net$communities$membership)


##-- Begin to examine network structure - see CNA vignette for more details
net
summary(net)
attributes(net)
table( net$communities$members )

}
}
}
\keyword{analysis}

\name{plot.fasta}
\alias{plot.fasta}
\title{ Plot a Multiple Sequence Alignment }
\description{
  Produces a schematic representation of a multiple sequence alignment.
}
\usage{
\method{plot}{fasta}(x, hc = TRUE, labels = x$id, cex.lab = 0.7,
                         xlab = "Alignment index",
                         main = "Sequence Alignment Overview",
                         mar4 = 4, ...)
}
\arguments{
  \item{x}{ multiple sequence alignement of class \sQuote{fasta} as
    obtained from  \code{\link{seqaln}}. }
  \item{hc}{ logical, if TRUE plot a dendrogram on the left
    side. Alternatively, an object obtained from \code{\link{hclust}}
    can be provided. }
  \item{labels}{ labels corresponding to each row in the alignment. }
  \item{cex.lab}{ scaling factor for the labels. }
  \item{xlab}{ label for x-axis. }
  \item{main}{ a main title for the plot. }
  \item{mar4}{ margin size for the labels. }
  \item{\dots}{ additional arguments passed to function \code{\link{hclust}}. }
}
\details{
  \code{plot.fasta} is a utility function for producting a schematic
  representation of a multiple sequence alignment.  
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{seqaln}}, \code{\link{read.fasta}},
  \code{\link{entropy}}, \code{\link{aln2html}}. }
\examples{
# Read alignment
aln <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))

## alignment plot
plot(aln, labels=basename.pdb(aln$id))

## Works also for a 'pdbs' object
attach(transducin)
plot(pdbs)

detach(transducin)

\dontrun{
infile <- "http://pfam.xfam.org/family/PF00071/alignment/seed/format?format=fasta"
aln <- read.fasta( infile )
plot(aln)
}
}
\keyword{ hplot }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aanma.pdbs.R
\name{aanma.pdbs}
\alias{aanma.pdbs}
\title{Ensemble Normal Mode Analysis with All-Atom ENM}
\usage{
\method{aanma}{pdbs}(pdbs, fit = TRUE, full = FALSE, subspace = NULL,
  rm.gaps = TRUE, ligand = FALSE, outpath = NULL, gc.first = TRUE,
  ncore = NULL, ...)
}
\arguments{
\item{pdbs}{an \sQuote{pdbs} object as obtained from \code{\link{read.all}}.}

\item{fit}{logical, if TRUE C-alpha coordinate based superposition is 
performed prior to normal mode calculations.}

\item{full}{logical, if TRUE return the complete, full structure,
\sQuote{nma} objects.}

\item{subspace}{number of eigenvectors to store for further analysis.}

\item{rm.gaps}{logical, if TRUE obtain the hessian matrices for only
atoms in the aligned positions (non-gap positions in all aligned
structures). Thus, gap positions are removed from output.}

\item{ligand}{logical, if TRUE ligand molecules are also included in the 
calculation.}

\item{outpath}{character string specifing the output directory to
which the PDB structures should be written.}

\item{gc.first}{logical, if TRUE will call gc() first before mode calculation
for each structure. This is to avoid memory overload when 
\code{ncore > 1}.}

\item{ncore}{number of CPU cores used to do the calculation.}

\item{...}{additional arguments to \code{\link{aanma}}.}
}
\value{
Returns a list of \sQuote{nma} objects (\code{outmodes} is provided 
   and is not \sQuote{calpha}) or an \sQuote{enma} object with the following 
   components:
   \item{fluctuations }{ a numeric matrix containing aligned atomic
     fluctuations with one row per input structure. }
   \item{rmsip }{ a numeric matrix of pair wise RMSIP values (only the ten
     lowest frequency modes are included in the calculation). }
   \item{U.subspace }{ a three-dimensional array with aligned
     eigenvectors  (corresponding to the subspace defined by the first N
     non-trivial eigenvectors (\sQuote{U}) of the \sQuote{nma} object). }
   \item{L }{ numeric matrix containing the raw eigenvalues with one row
     per input structure. }
   \item{full.nma }{ a list with a \code{nma} object for each input
     structure (available only when \code{full=TRUE}). }
}
\description{
Perform normal mode analysis (NMA) on an ensemble of aligned protein
structures using all-atom elastic network model (aaENM).
}
\details{
This function builds elastic network model (ENM) using all heavy 
   atoms and performs subsequent normal mode analysis (NMA) on a set of 
   aligned protein structures obtained with function \code{\link{read.all}}.
   The main purpose is to automate ensemble normal mode analysis using 
   all-atom ENMs.

   By default, the effective Hessian for all C-alpha atoms is calculated 
   based on the Hessian built from all heavy atoms (including ligand atoms if 
   \code{ligand=TRUE}). Returned values include aligned mode vectors and 
   (when \code{full=TRUE}) a list containing the full \sQuote{nma} objects
   one per each structure. When \sQuote{rm.gaps=TRUE} the unaligned atoms 
   are ommited from output. With default arguments \sQuote{rmsip} provides 
   RMSIP values for all pairwise structures.

   When \code{outmodes} is provided and is not \sQuote{calpha} 
   (e.g. \sQuote{noh}. See \code{\link{aanma}} for more details), the 
   function simply returns a list of \sQuote{nma} objects, one per each 
   structure, and no aligned mode vector is returned. In this case, the 
   arguments \code{full}, \code{subspace}, and \code{rm.gaps} are ignored. 
   This is equivalent to a wrapper function repeatedly calling 
   \code{\link{aanma}}.
}
\examples{
\donttest{
  # Needs MUSCLE installed - testing excluded
  if(check.utility("muscle")) {

    ## Fetch PDB files and split to chain A only PDB files
    ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
    files <- get.pdb(ids, split = TRUE, path = tempdir())
    
    ## Sequence Alignement
    aln <- pdbaln(files, outfile = tempfile())
    
    ## Read all pdb coordinates
    pdbs <- read.all(aln)

    ## Normal mode analysis on aligned data
    modes <- aanma(pdbs, rm.gaps=TRUE)
    
    ## Plot fluctuation data
    plot(modes, pdbs=pdbs)
    
    ## Cluster on Fluctuation similariy
    sip <- sip(modes)
    hc <- hclust(dist(sip))
    col <- cutree(hc, k=3)
    
    ## Plot fluctuation data
    plot(modes, pdbs=pdbs, col=col)
    
    ## RMSIP is pre-calculated
    heatmap(1-modes$rmsip)
    
    ## Bhattacharyya coefficient
    bc <- bhattacharyya(modes)
    heatmap(1-bc)

  }
}
}
\author{
Xin-Qiu Yao & Lars Skjaerven
}
\seealso{
For normal mode analysis on single structure PDB:
     \code{\link{aanma}}

     For conventional C-alpha based normal mode analysis:
     \code{\link{nma}}, \code{\link{nma.pdbs}}.

     For the analysis of the resulting \sQuote{eNMA} object:
     \code{\link{mktrj.enma}}, \code{\link{dccm.enma}},
     \code{\link{plot.enma}}, \code{\link{cov.enma}}.
   
     Similarity measures:
     \code{\link{sip}}, \code{\link{covsoverlap}},
     \code{\link{bhattacharyya}}, \code{\link{rmsip}}.
   
     Related functionality:
     \code{\link{read.all}}.
}

\name{read.mol2}
\alias{read.mol2}
\alias{print.mol2}
\title{ Read MOL2 File }
\description{
  Read a Tripos MOL2 file
}
\usage{
read.mol2(file, maxlines = -1L)

\method{print}{mol2}(x, \dots)
}
\arguments{
  \item{file}{ a single element character vector containing the name of
    the MOL2 file to be read. }
  \item{maxlines}{ the maximum number of lines to read before giving up
    with large files. Default is all lines. }
  \item{x}{ an object as obtained from \code{read.mol2}. }
  \item{...}{ additional arguments to \sQuote{print}. }
}
\details{
  Basic functionality to parse a MOL2 file. The current version reads
  and stores \sQuote{@<TRIPOS>MOLECULE}, \sQuote{@<TRIPOS>ATOM},
  \sQuote{@<TRIPOS>BOND} and \sQuote{@<TRIPOS>SUBSTRUCTURE} records. 

  In the case of a multi-molecule MOL2 file, each molecule will be stored
  as an individual \sQuote{mol2} object in a list. Conversely, if the multi-molecule
  MOL2 file contains identical molecules in different conformations
  (typically from a docking run), then the output will be one object
  with an \code{atom} and \code{xyz} component (xyz in
  matrix representation; row-wise coordinates).

  See examples for further details.
}
\value{
  Returns a list of molecules containing the following components:
  \item{atom}{ a data frame containing all atomic coordinate ATOM data, 
    with a row per ATOM and a column per record type.  See below for details
    of the record type naming convention (useful for accessing
    columns). }
  \item{bond}{ a data frame containing all atomic bond information. }
  \item{substructure}{ a data frame containing all substructure information. }
  \item{xyz}{ a numeric matrix of ATOM coordinate data. }
  \item{info}{ a numeric vector of MOL2 info data. }
  \item{name}{ a single element character vector containing the molecule name. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\note{ 
  For \code{atom} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno},
  Atom name \dQuote{elena},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Reisude number \dQuote{resno},
  Atom type \dQuote{elety},
  Residue name \dQuote{resid},
  Atom charge \dQuote{charge},
  Status bit \dQuote{statbit},

  For \code{bond} list components the column names are:
  Bond identifier \dQuote{id},
  number of the atom at one end of the bond\dQuote{origin},
  number of the atom at the other end of the bond \dQuote{target},
  the SYBYL bond type \dQuote{type}.

  For \code{substructure} list components the column names are:
  substructure identifier \dQuote{id},
  substructure name \dQuote{name},
  the ID number of the substructure's root atom \dQuote{root_atom},
  the substructure type \dQuote{subst_type},
  the type of dictionary associated with the substructure \dQuote{dict_type},
  the chain to which the substructre belongs \dQuote{chain},
  the subtype of the chain \dQuote{sub_type},
  the number of inter bonds \dQuote{inter_bonds},
  status bit \dQuote{status}. 
    
  See examples for further details.
}
\seealso{
  \code{\link{write.mol2}}, \code{\link{atom.select.mol2}}, 
  \code{\link{trim.mol2}}, \code{\link{as.pdb.mol2}}
  \code{\link{read.pdb}}
}
\examples{
cat("\n")
\dontrun{
## Read a single entry MOL2 file
## (returns a single object)
mol <- read.mol2( system.file("examples/aspirin.mol2", package="bio3d") )

## Short summary of the molecule
print(mol)

## ATOM records
mol$atom

## BOND records
mol$bond

## Print some coordinate data
head(mol$atom[, c("x","y","z")])

## Or coordinates as a numeric vector
#head(mol$xyz)

## Print atom charges
head(mol$atom[, "charge"])

## Convert to PDB
pdb <- as.pdb(mol)


## Read a multi-molecule MOL2 file
## (returns a list of objects)
#multi.mol <- read.mol2("zinc.mol2")

## Number of molecules described in file
#length(multi.mol)

## Access ATOM records for the first molecule
#multi.mol[[1]]$atom

## Or coordinates for the second molecule
#multi.mol[[2]]$xyz



## Process output from docking (e.g. DOCK)
## (typically one molecule with many conformations)
## (returns one object, but xyz in matrix format)
#dock <- read.mol2("dock.mol2")

## Reference PDB file (e.g. X-ray structure)
#pdb <- read.pdb("dock_ref.pdb")

## Calculate RMSD of docking modes
#sele <- atom.select(dock, "noh")
#rmsd(pdb$xyz, dock$xyz, b.inds=sele$xyz)
}
}
\keyword{ IO }

\name{aa2mass}
\alias{aa2mass}
\title{ Amino Acid Residues to Mass Converter }
\description{
  Convert a sequence of amino acid residue names to mass.
}
\usage{
aa2mass(pdb, inds=NULL, mass.custom=NULL, addter=TRUE, mmtk=FALSE)
}
\arguments{
  \item{pdb}{ a character vector containing the atom names to convert
    to atomic masses. Alternatively, a object of type \code{pdb} can be
    provided. }
  \item{inds}{ atom and xyz coordinate indices obtained from \code{atom.select}
    that selects the elements of \code{pdb} upon which the calculation
    should be based. }
  \item{mass.custom}{ a list of amino acid residue names and their
    corresponding masses. }
  \item{addter}{ logical, if TRUE terminal atoms are added to final
    masses. }
  \item{mmtk}{ logical, if TRUE use the exact aminoacid residue masses as
    provided with the MMTK database (for testing purposes). }
}
\details{
  This function converts amino acid residue names to their corresponding
  masses. In the case of a non-standard amino acid residue name
  \code{mass.custom} can be used to map the residue to the correct
  mass. User-defined amino acid masses (with argument \code{mass.custom})
  will override mass entries obtained from the database. 

  See examples for more details.
}
\note{
  When object of type \code{pdb} is provided, non-calpha atom records
  are omitted from the selection.
}
\value{
  Returns a numeric vector of masses.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{atom.index}}, \code{\link{atom2mass}},
  \code{\link{aa.index}}}
\examples{
resi.names <- c("LYS", "ALA", "CYS", "HIS")
masses <- aa2mass(resi.names, addter=FALSE)

\dontrun{
## Fetch atomic masses in a PDB object
pdb <- read.pdb("3dnd")
masses <- aa2mass(pdb)

## or
masses <- aa2mass(pdb$atom[1:10,"resid"])

## Dealing with unconventional residues
#pdb <- read.pdb("1xj0")

#mass.cust <- list("CSX"=122.166)
#masses <- aa2mass(pdb, mass.custom=mass.cust)
}
}
\keyword{ utilities }

\name{rgyr}
\alias{rgyr}
\title{ Radius of Gyration}
\description{
  Calculate the radius of gyration of coordinate sets.
}
\usage{
rgyr(xyz, mass=NULL, ncore=1, nseg.scale=1)
}
\arguments{
  \item{xyz}{ a numeric vector, matrix or list object with an \code{xyz}
    component, containing one or more coordinate sets.}
  \item{mass}{ a numeric vector of atomic masses (unit a.m.u.),
    or a PDB object with masses stored in the "B-factor" column. 
    If \code{mass==NULL}, all atoms are assumed carbon.}
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
}
\details{
  Radius of gyration is a standard measure of overall structural change of
  macromolecules.
}
\value{
  Returns a numeric vector of radius of gyration.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao & Pete Kekenes-Huskey}
\seealso{ \code{\link{fit.xyz}}, \code{\link{rmsd}},
  \code{\link{read.pdb}}, \code{\link{read.fasta.pdb}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

# -- Calculate Rog of single structure
pdb <- read.pdb("1bg2")
mass <- rep(12, length(pdb$xyz)/3)
mass[substr(pdb$atom[,"elety"], 1, 1) == "N"] <- 14
mass[substr(pdb$atom[,"elety"], 1, 1) == "H"] <- 1
mass[substr(pdb$atom[,"elety"], 1, 1) == "O"] <- 16 
mass[substr(pdb$atom[,"elety"], 1, 1) == "S"] <- 32

rgyr(pdb, mass)
}

\dontrun{
# -- Calculate Rog of a trajectory
xyz <- read.dcd(system.file("examples/hivp.dcd", package="bio3d"))
rg <- rgyr(xyz)
rg[1:10]

}
}
\keyword{ utilities }

\name{dccm}
\alias{dccm}
\title{ DCCM: Dynamical Cross-Correlation Matrix }
\description{
  Determine the cross-correlations of atomic displacements. 
}
\usage{
dccm(x, ...)
}
\arguments{
  \item{x}{ a numeric matrix of Cartesian coordinates with a row per
    structure/frame which will br passed to \code{dccm.xyz()}.
    Alternatively, an object  of class \code{nma} as obtained from
    function \code{nma} that will be passed to the \code{dccm.nma()}
    function, see below for examples. } 
  \item{\dots}{ additional arguments passed to the methods
    \code{dccm.xyz}, \code{dccm.pca}, \code{dccm.nma}, and \code{dccm.enma}. }
}
\details{
  \code{dccm} is a generic function calling the corresponding function
  determined by the class of the input argument \code{x}. Use
  \code{methods("dccm")} to get all the methods for \code{dccm}
  generic:

  \code{\link{dccm.xyz}} will be used when \code{x} is a numeric matrix
  containing Cartesian coordinates (e.g. trajectory data).
  
  \code{\link{dccm.pca}} will calculate the cross-correlations based on
  an \code{pca} object.

  \code{\link{dccm.nma}} will calculate the cross-correlations based on
  an \code{nma} object. Similarly, \code{\link{dccm.enma}} will
  calculate the correlation matrices based on an ensemble of \code{nma}
  objects (as obtained from function \code{nma.pdbs}).

  \code{\link{plot.dccm}} and \code{\link{pymol.dccm}} provides
  convenient functionality to plot a correlation map, and visualize the
  correlations in the structure, respectively.

  See examples for each corresponding function for more details.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{ \code{\link{dccm.xyz}}, \code{\link{dccm.nma}},
  \code{\link{dccm.enma}}, \code{\link{dccm.pca}}, \code{\link{plot.dccm}},
    \code{\link{pymol.dccm}}. }
\keyword{ utilities }

\name{read.all}
\alias{read.all}
\title{ Read Aligned Structure Data}
\description{
  Read aligned PDB structures and store their equalvalent atom data, including xyz
  coordinates, residue numbers, residue type and B-factors.
}
\usage{
read.all(aln, prefix = "", pdbext = "", sel = NULL, rm.wat=TRUE, rm.ligand=FALSE,
         compact = TRUE, ncore = NULL, ...)
}

\arguments{
  \item{aln}{ an alignment data structure obtained with
    \code{\link{read.fasta}}. }
  \item{prefix}{ prefix to aln$id to locate PDB files. }
  \item{pdbext}{ the file name extention of the PDB files. }
  \item{sel}{ a selection string detailing the atom type data to store
    (see function store.atom) }
  \item{rm.wat}{logical, if TRUE water atoms are removed. }
  \item{rm.ligand}{logical, if TRUE ligand atoms are removed. }
  \item{compact}{ logical, if TRUE the number of atoms stored for each aligned
    residue varies according to the amino acid type. If FALSE, the constant 
    maximum possible number of atoms are stored for all aligned residues. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    By default (\code{ncore=NULL}) use all detected CPU cores. }
  \item{\dots}{ other parameters for \code{\link{read.pdb}}. }   
}
\details{
  The input \code{aln}, produced with \code{\link{read.fasta}}, must
  have identifers (i.e. sequence names) that match the PDB file
  names. For example the sequence corresponding to the structure
  file \dQuote{mypdbdir/1bg2.pdb} should have the identifer
  \sQuote{mypdbdir/1bg2.pdb} or \sQuote{1bg2} if input \sQuote{prefix}
  and \sQuote{pdbext} equal \sQuote{mypdbdir/} and \sQuote{pdb}. See the
  examples below.

  Sequence miss-matches will generate errors.  Thus, care should be taken
  to ensure that the sequences in the alignment match the sequences in
  their associated PDB files.
}
\value{
  Returns a list of class \code{"pdbs"} with the following five
  components:
  \item{xyz}{numeric matrix of aligned C-alpha coordinates.}
  \item{resno}{character matrix of aligned residue numbers.}
  \item{b}{numeric matrix of aligned B-factor values.}
  \item{chain}{character matrix of aligned chain identifiers.}
  \item{id}{character vector of PDB sequence/structure names.}
  \item{ali}{character matrix of aligned sequences.}
  \item{resid}{character matrix of aligned 3-letter residue names.}
  \item{all }{numeric matrix of aligned equalvelent atom coordinates. }
  \item{all.elety}{numeric matrix of aligned atom element types. }
  \item{all.resid}{numeric matrix of aligned three-letter residue codes. }
  \item{all.resno}{numeric matrix of aligned residue numbers. }
  \item{all.grpby}{numeric vector indicating the group of atoms belonging to
    the same aligned residue. }
  \item{all.hetatm}{a list of \sQuote{pdb} objects for non-protein atoms. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  This function is still in development and is NOT part of the
  offical bio3d package.
  
  The sequence character \sQuote{X} is useful for masking unusual
  or unknown residues, as it can match any other residue type.
}
\seealso{
  \code{\link{read.fasta}}, \code{\link{read.pdb}},
  \code{\link{core.find}}, \code{\link{fit.xyz}}  }
\examples{
# still working on speeding this guy up
\dontrun{
## Read sequence alignment
file <- system.file("examples/kif1a.fa",package="bio3d")
aln  <- read.fasta(file)

## Read aligned PDBs storing all data for 'sel'
sel <- c("N", "CA", "C", "O", "CB", "*G", "*D",  "*E", "*Z")
pdbs <- read.all(aln, sel=sel)

atm <- colnames(pdbs$all)
ca.ind  <- which(atm == "CA")
core <- core.find(pdbs)
core.ind <- c( matrix(ca.ind, nrow=3)[,core$c0.5A.atom] )

## Fit structures
nxyz <- fit.xyz(pdbs$all[1,], pdbs$all,
               fixed.inds  = core.ind,
               mobile.inds = core.ind)

ngap.col <- gap.inspect(nxyz)

#npc.xray <- pca.xyz(nxyz[ ,ngap.col$f.inds])

#a <- mktrj.pca(npc.xray, pc=1, file="pc1-all.pdb",
#               elety=pdbs$all.elety[1,unique( ceiling(ngap.col$f.inds/3) )],
#               resid=pdbs$all.resid[1,unique( ceiling(ngap.col$f.inds/3) )],
#               resno=pdbs$all.resno[1,unique( ceiling(ngap.col$f.inds/3) )] )

}

}
\keyword{ IO }

\name{read.prmtop}
\alias{read.prmtop}
\alias{print.prmtop}
\title{ Read AMBER Parameter/Topology files }
\description{
  Read parameter and topology data from an AMBER PrmTop file.
}
\usage{
read.prmtop(file)

\method{print}{prmtop}(x, printseq=TRUE, \dots)
}
\arguments{
  \item{file}{ a single element character vector containing the name of
    the PRMTOP file to be read. }
  \item{x}{ a PRMTOP structure object obtained from
    \code{\link{read.prmtop}}. }
  \item{printseq}{ logical, if TRUE the residue sequence will be printed
    to the screen. See also \code{\link{pdbseq}}. }
  \item{...}{ additional arguments to \sQuote{print}. }
}
\details{
  This function provides basic functionality to read and parse a AMBER
  PrmTop file. The resulting \sQuote{prmtop} object contains a complete
  list object of the information stored in the PrmTop file.

  See examples for further details.
}
\value{
  Returns a list of class \sQuote{prmtop} (inherits class
  \sQuote{amber}) with components according to the flags present in the PrmTop
  file. See the AMBER documentation for a complete list of
  flags/components: \url{http://ambermd.org/FileFormats.php}.

  Selected components:
  \item{ATOM_NAME}{ a character vector of atom names. }
  \item{ATOMS_PER_MOLECULE}{ a numeric vector containing the number of
    atoms per molecule. }
  \item{MASS}{ a numeric vector of atomic masses. }
  \item{RESIDUE_LABEL}{ a character vector of residue labels. }
  \item{RESIDUE_RESIDUE_POINTER}{ a numeric vector of pointers to the
    first atom in each residue. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  \url{http://ambermd.org/FileFormats.php}
}
\author{ Lars Skjaerven }
\note{
  See AMBER documentation for PrmTop format description:\cr
  \url{http://ambermd.org/FileFormats.php}.
}
\seealso{
  \code{\link{read.crd}}, \code{\link{read.ncdf}},
  \code{\link{as.pdb}}, \code{\link{atom.select}},
  \code{\link{read.pdb}}
}
\examples{
\dontrun{
## Read a PRMTOP file
prmtop <- read.prmtop(system.file("examples/crambin.prmtop", package="bio3d"))
print(prmtop)

## Explore prmtop file
head(prmtop$MASS)
head(prmtop$ATOM_NAME)

## Read Amber coordinates
crds <- read.crd(system.file("examples/crambin.inpcrd", package="bio3d"))

## Atom selection
ca.inds <- atom.select(prmtop, "calpha")

## Convert to PDB format
pdb <- as.pdb(prmtop, crds)
pdb.ca <- as.pdb(prmtop, crds, inds=ca.inds)

## Trajectory processing
#trj <- read.ncdf("traj.nc", at.sel=ca.inds)

## Convert to multimodel PDB format
#pdb <- as.pdb(prmtop, trj[1:20,], inds=ca.inds, inds.crd=NULL)

## RMSD of trajectory
#rd <- rmsd(crds$xyz[ca.inds$xyz], traj, fit=TRUE)
}
}
\keyword{ IO }

\name{community.tree}
\alias{community.tree}
\title{ Reconstruction of the Girvan-Newman Community Tree for a CNA Class Object.  }
\description{
  This function reconstructs the community tree of the community
  clustering analysis performed by the \sQuote{cna} function. 
  It allows the user to explore different network community partitions.
}
\usage{
  community.tree(x, rescale=FALSE)
}
\arguments{
  \item{x}{  A protein network graph object as obtained from the
    \sQuote{cna} function. }
  \item{rescale}{ Logical, indicating whether to rescale the community
    names starting from 1. If FALSE, the community names will start from
    N+1, where N is the number of nodes. } 
}
\value{
  Returns a list object that includes the following components:
  \item{modularity}{ A numeric vector containing the modularity values. }
  \item{tree}{ A numeric matrix containing in each row the
    community residue memberships corresponding to a modularity
    value. The rows are ordered according to the \sQuote{modularity} object. }
  \item{num.of.comms}{ A numeric vector containing the number of
    communities per modularity value. The vector elements are ordered according
    to the \sQuote{modularity} object. }
}
\details{
  The input of this function should be a \sQuote{cna} class object
  containing \sQuote{network} and \sQuote{communities} attributes.

  This function reconstructs the community residue memberships for each
  modularity value. The purpose is to facilitate inspection of alternate 
  community partitioning points, which in practice often corresponds to a value 
  close to the maximum of the modularity, but not the maximum value itself.
}
\author{ Guido Scarabelli }  
\seealso{
   \code{\link{cna}}, \code{\link{network.amendment}}, \code{\link{summary.cna}}
}
\examples{
\donttest{
# PDB server connection required - testing excluded

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

###-- Build a CNA object
pdb <- read.pdb("4Q21")
modes <- nma(pdb)
cij <- dccm(modes)
net <- cna(cij, cutoff.cij=0.2)


##-- Reconstruct the community membership vector for each clustering step.
tree <- community.tree(net, rescale=TRUE)

## Plot modularity vs number of communities
plot( tree$num.of.comms, tree$modularity )

## Inspect the maximum modularity value partitioning
max.mod.ind <- which.max(tree$modularity)

## Number of communities (k) at max modularity
tree$num.of.comms[ max.mod.ind ]

## Membership vector at this partition point 
tree$tree[max.mod.ind,]

# Should be the same as that contained in the original CNA network object
net$communities$membership == tree$tree[max.mod.ind,]

# Inspect a new membership partitioning (at k=7)
memb.k7 <- tree$tree[ tree$num.of.comms == 7, ]

## Produce a new k=7 community network  
net.7 <- network.amendment(net, memb.k7)
plot(net.7, pdb)
#view.cna(net.7, trim.pdb(pdb, atom.select(pdb,"calpha")), launch=TRUE )

}
}
}
\keyword{analysis}

\name{pdb2aln.ind}
\alias{pdb2aln.ind}
\title{ Mapping from alignment positions to PDB atomic indices }
\description{
  Find the best alignment between a PDB structure and an 
  existing alignment. Then, given a set of column indices
  of the original alignment, returns atom selections of 
  equivalent C-alpha atoms in the PDB structure.
}
\usage{
pdb2aln.ind(aln, pdb, inds = NULL, ...)
}
\arguments{
  \item{aln}{ an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}},
    \code{\link{read.fasta.pdb}}, \code{\link{pdbaln}}, and 
    \code{\link{seqaln}}. }
  \item{pdb}{ the PDB object to be aligned to \code{aln}. }
  \item{inds}{ a numeric vector containing a subset of column indices of
    \code{aln}. If NULL, non-gap positions of \code{aln$ali} are used. }
  \item{\dots}{ additional arguments passed to \code{\link{pdb2aln}}. }
}
\details{
  Call \code{\link{pdb2aln}} to align the sequence of \code{pdb} to \code{aln}.
  Then, find the atomic indices of C-alpha atoms in \code{pdb} that are 
  equivalent to \code{inds}, the subset of column indices of \code{aln$ali}. 

  The function is a rountine utility in a combined analysis of 
  molecular dynamics (MD) simulation trajectories and crystallographic 
  structures. For example, a typical post-analysis of MD simulation is to 
  compare the principal components (PCs) derived from simulation trajectories 
  with those derived from crystallographic structures. The C-alpha atoms used
  to fit trajectories and do PCA must be the same (or equivalent) to those
  used in the analysis of crystallographic structures, e.g. the 'non-gap'  
  alignment positions. Call \code{pdb2aln.ind} with providing relevant
  alignment positions, one can easily get equivalent atom selections 
  ('select' class objects) for the simulation topology (PDB) file and then
  do proper trajectory analysis. 
 
}
\value{
  Returns a list containing two "select" objects:
  \item{a}{ atom and xyz indices for the alignment. }
  \item{b}{ atom and xyz indices for the PDB. }

  Note that if any element of \code{inds} has no corresponding CA atom in the 
  PDB, the output \code{a$atom} and \code{b$atom} will be shorter than 
  \code{inds}, i.e. only indices having equivalent CA atoms are returned. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao, Lars Skjaerven & Barry Grant }
\seealso{ \code{\link{seq2aln}}, \code{\link{seqaln.pair}},
       \code{\link{pdb2aln}} }
\examples{
\dontrun{
##--- Read aligned PDB coordinates (CA only)
aln  <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
pdbs <- read.fasta.pdb(aln)

##--- Read the topology file of MD simulations
##--- For illustration, here we read another pdb file (all atoms)
pdb <- read.pdb("2kin")

#--- Map the non-gap positions to PDB C-alpha atoms
#pc.inds <- gap.inspect(pdbs$ali)
#npc.inds <- pdb2aln.ind(aln=pdbs, pdb=pdb, inds=pc.inds$f.inds)

#npc.inds$a
#npc.inds$b

#--- Or, map the non-gap positions with a known close sequence in the alignment
#npc.inds <- pdb2aln.ind(aln=pdbs, pdb=pdb, aln.id="1bg2", inds=pc.inds$f.inds)

#--- Map core positions
core <- core.find(pdbs)
core.inds <- pdb2aln.ind(aln=pdbs, pdb=pdb, inds = core$c1A.atom)

core.inds$a
core.inds$b

##--- Fit simulation trajectories to one of the X-ray structures based on
##--- core positions
#xyz <- fit.xyz(pdbs$xyz[1,], pdb$xyz, core.inds$a$xyz, core.inds$b$xyz)

##--- Do PCA of trajectories based on non-gap positions
#pc.traj <- pca(xyz[, npc.inds$b$xyz])

}

}
\keyword{ utilities }

\name{write.pdb}
\alias{write.pdb}
\title{ Write PDB Format Coordinate File }
\description{
  Write a Protein Data Bank (PDB) file for a given \sQuote{xyz}
  Cartesian coordinate vector or matrix.
}
\usage{
write.pdb(pdb = NULL, file = "R.pdb", xyz = pdb$xyz, type = NULL, resno = NULL,
 resid = NULL, eleno = NULL, elety = NULL, chain = NULL, insert = NULL, 
 alt = NULL, o = NULL, b = NULL, segid = NULL, elesy = NULL, charge = NULL, 
 append = FALSE, verbose = FALSE, chainter = FALSE, end = TRUE, sse = FALSE, 
 print.segid = FALSE)
}
\arguments{
  \item{pdb}{ a PDB structure object obtained from
    \code{\link{read.pdb}}. }
  \item{file}{ the output file name. }
  \item{xyz}{ Cartesian coordinates as a vector or 3xN matrix. }
  \item{type}{ vector of record types, i.e. "ATOM" or "HETATM", 
    with length equal to length(xyz)/3. }
  \item{resno}{ vector of residue numbers of length equal to
    length(xyz)/3. }
  \item{resid}{ vector of residue types/ids of length equal to
    length(xyz)/3. }
  \item{eleno}{ vector of element/atom numbers of length equal to
    length(xyz)/3. }
  \item{elety}{ vector of element/atom types of length equal to
    length(xyz)/3. }
  \item{chain}{ vector of chain identifiers with length equal to
    length(xyz)/3. }
  \item{insert}{ vector of insertion code with length equal to
    length(xyz)/3. }
  \item{alt}{ vector of alternate record with length equal to
    length(xyz)/3. }
  \item{o}{ vector of occupancy values of length equal to
    length(xyz)/3. }
  \item{b}{ vector of B-factors of length equal to length(xyz)/3. }
  \item{segid}{ vector of segment id of length equal to length(xyz)/3. }
  \item{elesy}{ vector of element symbol of length equal to length(xyz)/3. }
  \item{charge}{ vector of atomic charge of length equal to length(xyz)/3. }
  \item{append}{ logical, if TRUE output is appended to the bottom of an
    existing file (used primarly for writing multi-model files). }
  \item{verbose}{ logical, if TRUE progress details are printed. }
  \item{chainter}{ logical, if TRUE a TER line is inserted at termination
    of a chain. }
  \item{end}{ logical, if TRUE END line is written. }
  \item{sse}{ logical, if TRUE secondary structure annotations are written. }
  \item{print.segid}{ logical, if FALSE segid will not be written. }
}
\details{
  Only the \code{xyz} argument is strictly required.  Other arguments
  assume a default poly-ALA C-alpha structure with a blank chain id,
  occupancy values of 1.00 and B-factors equal to 0.00.
  
  If the input argument \code{xyz} is a matrix then each row is assumed
  to be a different structure/frame to be written to a
  \dQuote{multimodel} PDB file, with frames separated by \dQuote{END}
  records.
  
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{
  Barry Grant
  with contributions from Joao Martins.

}
\note{
  Check that:
  (1) \code{chain} is one character long e.g. \dQuote{A}, and 
  (2) \code{resno} and \code{eleno} do not exceed \dQuote{9999}.
}
\seealso{ \code{\link{read.pdb}}, \code{\link{read.dcd}},
  \code{\link{read.fasta.pdb}}, \code{\link{read.fasta}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

# Read a PDB file
pdb <- read.pdb( "1bg2" )

# Renumber residues
nums <- as.numeric(pdb$atom[,"resno"])
nums <- nums - (nums[1] - 1)

# Write out renumbered PDB file
outfile = file.path(tempdir(), "eg.pdb")
write.pdb(pdb=pdb, resno = nums, file = outfile)

invisible( cat("\nSee the output file:", outfile, sep = "\n") )
}
}
\keyword{ IO }

\name{convert.pdb}
\alias{convert.pdb}
\title{Renumber and Convert Between Various PDB formats}
\description{
  Renumber and convert between CHARMM, Amber, Gromacs and Brookhaven
  PDB formats.
}
\usage{
convert.pdb(pdb, type=c("original", "pdb", "charmm", "amber", "gromacs"),
                renumber = FALSE, first.resno = 1, first.eleno = 1,
                consecutive=TRUE, rm.h = TRUE, rm.wat = FALSE,
                verbose=TRUE)
}
\arguments{
  \item{pdb}{ a structure object of class \code{"pdb"}, obtained from
    \code{\link{read.pdb}}. }
  \item{type}{ output format, one of \sQuote{original}, \sQuote{pdb}, 
    \sQuote{charmm}, \sQuote{amber}, or \sQuote{gromacs}. The default 
    option of \sQuote{original} results in no conversion. }
  \item{renumber}{ logical, if TRUE atom and residue records are
    renumbered using \sQuote{first.resno} and \sQuote{first.eleno}. }
  \item{first.resno}{ first residue number to be used if
    \sQuote{renumber} is TRUE. }
  \item{first.eleno}{ first element number to be used if
    \sQuote{renumber} is TRUE. }
  \item{consecutive}{ logical, if TRUE renumbering will result in 
    consecutive residue numbers spanning all chains. Otherwise new residue  
    numbers will begin at \sQuote{first.resno} for each chain. }
  \item{rm.h}{ logical, if TRUE hydrogen atoms are removed. }
  \item{rm.wat}{ logical, if TRUE water atoms are removed. }
  \item{verbose}{ logical, if TRUE details of the conversion process 
    are printed. }
}
\details{
  Convert atom names and residue names, renumber atom and residue
  records, strip water and hydrogen atoms from \code{pdb} objects.

  Format \code{type} can be one of \dQuote{ori}, \dQuote{pdb}, \dQuote{charmm},
      \dQuote{amber} or \dQuote{gromacs}.
}
\value{
  Returns a list of class \code{"pdb"}, with the following components:
  \item{atom}{ a character matrix containing all atomic coordinate ATOM data,
  with a row per ATOM and a column per record type.  See below for details
  of the record type naming convention (useful for accessing columns). }
  \item{het}{ a character matrix containing atomic coordinate records
    for atoms within \dQuote{non-standard} HET groups (see \code{atom}). }
  \item{helix}{ \sQuote{start}, \sQuote{end} and \sQuote{length} of H
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{sheet}{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{seqres }{ sequence from SEQRES field. }
  \item{xyz}{ a numeric vector of ATOM coordinate data. }
  \item{calpha}{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\note{
  For both \code{atom} and \code{het} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno} ,
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Chain identifier \dQuote{chain},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Occupancy \dQuote{o}, and
  Temperature factor \dQuote{b}.
  See examples for further details.
}
\seealso{ \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}} }
\examples{
\dontrun{

# Read a PDB file
pdb <- read.pdb("4q21")
pdb
head( pdb$atom[pdb$calpha,"resno"] )

# Convert to CHARMM format
new <- convert.pdb(pdb, type="amber", renumber=TRUE, first.resno=22 )
head( new$atom[new$calpha,"resno"] )

# Write a PDB file
#write.pdb(new, file="tmp4amber.pdb")

}
}
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biounit.R
\name{biounit}
\alias{biounit}
\title{Biological Units Construction}
\usage{
biounit(pdb, biomat = NULL, multi = FALSE, ncore = NULL)
}
\arguments{
\item{pdb}{an object of class \code{pdb} as obtained from
function \code{\link{read.pdb}}.}

\item{biomat}{a list object as returned by \code{read.pdb} 
(pdb$remark$biomat), containing matrices for 
symmetry operation on individual chains to build biological units.
It will override the matrices stored in \code{pdb}.}

\item{multi}{logical, if TRUE the biological unit is returned as a 
'multi-model' \code{pdb} object with each symmetric copy a distinct
structural 'MODEL'. Otherwise, all copies are represented 
as separated chains.}

\item{ncore}{number of CPU cores used to do the calculation. By default
(\code{ncore=NULL}), use all available CPU cores.}
}
\value{
a list of \code{pdb} objects with each representing an individual 
   biological unit.
}
\description{
Construct biological assemblies/units based on a 'pdb' object.
}
\details{
A valid structural/simulation study should be performed on the biological 
unit of a protein system. For example, the alpha2-beta2 tetramer form of
hemoglobin. However, canonical PDB files usually contain the asymmetric unit of 
the crystal cell, which can be:
\enumerate{
     \item One biological unit 
     \item A portion of a biological unit 
     \item Multiple biological units
}
The function performs symmetry operations to the coordinates based on the 
transformation matrices stored in a 'pdb' object returned by 
\code{\link{read.pdb}}, and returns biological units stored as a list of
\code{pdb} objects.
}
\examples{
\donttest{
   # PDB server connection required - testing excluded

   pdb <- read.pdb("2dn1")
   biounit <- biounit(pdb)
   pdb
   biounit
}
\dontrun{
   biounit <- biounit(read.pdb("2bfu"), multi=TRUE)
   write.pdb(biounit[[1]], file="biounit.pdb")
   # open the pdb file in VMD to have a look on the biological unit
} 
}
\author{
Xin-Qiu Yao
}
\seealso{
\code{\link{read.pdb}}
}

\encoding{UTF-8}
\name{atom2mass}
\alias{atom2mass}
\alias{atom2mass.default}
\alias{atom2mass.pdb}
\title{ Atom Names/Types to Mass Converter }
\description{
  Convert atom names/types into atomic masses.
}
\usage{
atom2mass(\dots)
\method{atom2mass}{default}(x, mass.custom=NULL, elety.custom=NULL,
                            grpby=NULL, rescue=TRUE, \dots) 
\method{atom2mass}{pdb}(pdb, inds=NULL, mass.custom=NULL,
                        elety.custom=NULL, grpby=NULL, rescue=TRUE, \dots) 
}
\arguments{
  \item{x}{ a character vector containing atom names/types to be
    converted. } 
  \item{mass.custom}{ a customized data.frame containing atomic symbols
    and corresponding masses. } 
  \item{elety.custom}{ a customized data.frame containing atom
    names/types and corresponding atomic symbols.} 
  \item{grpby}{a \sQuote{factor}, as returned by \code{as.factor}, used
    to group the atoms.} 
  \item{rescue}{ logical, if TRUE the atomic symbols will be mapped to
    the first character of the atom names/types.} 
  \item{pdb}{ an object of class \sQuote{pdb} for which \code{elety} will
    be converted.} 
  \item{inds}{ an object of class \sQuote{select} indicating a subset of
    the \code{pdb} object to be used (see \code{\link{atom.select}} and
    \code{\link{trim.pdb}}).} 
  \item{\dots}{.}
}
\details{
  The default method first convert atom names/types into atomic symbols
  using the \code{\link{atom2ele}} function. Then, atomic symbols are
  searched in the \code{elements} data set and their corresponding masses
  are returned. If \code{mass.custom} is specified it is combined with
  \code{elements} (using \code{rbind}) before searching. Therefore,
  \code{mass.custom} must have columns named \code{symb} and \code{mass}
  (see examples). If \code{grpby} is specified masses are splitted (using
  \code{split}) to compute the mass of groups of atoms defined by
  \code{grpby}. 

  The S3 method for object of class \sQuote{pdb}, pass
  \code{pdb$atom$elety} to the default method. 
}
\value{Return a numeric vector of masses.}
\author{Julien Ide, Lars Skjaerven}
\seealso{
  \code{\link{elements}}, \code{\link{atom.index}},
  \code{\link{atom2ele}}, \code{\link{read.pdb}}
}
\examples{
atom.names <- c("CA", "O", "N", "OXT")
atom2mass(atom.names)

\donttest{
# PDB server connection required - testing excluded

## Get atomic symbols from a PDB object with a customized data set
pdb <- read.pdb("3RE0", verbose=FALSE)
inds <- atom.select(pdb, resno=201, verbose=FALSE)

## selected atoms
print(pdb$atom$elety[inds$atom])

## default will map CL2 to C
atom2mass(pdb, inds)

## map element CL2 correctly to Cl
myelety  <- data.frame(name = c("CL2","PT1","N1","N2"), symb = c("Cl","Pt","N","N"))
atom2mass(pdb, inds, elety.custom = myelety)

## custom masses
mymasses <- data.frame(symb = c("Cl","Pt"), mass = c(35.45, 195.08))
atom2mass(pdb, inds, elety.custom = myelety, mass.custom = mymasses)

}
}
\keyword{ utilities }

\name{write.pir}
\alias{write.pir}
\title{ Write PIR Formated Sequences }
\description{
  Write aligned or un-aligned sequences to a PIR format file.
}
\usage{
write.pir(alignment=NULL, ids=NULL, seqs=alignment$ali, 
   pdb.file = NULL, chain.first = NULL, resno.first = NULL,
   chain.last = NULL, resno.last = NULL, file, append = FALSE)
}
\arguments{
  \item{alignment}{  an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}}. }
  \item{ids}{ a vector of sequence names to serve as sequence identifers }
  \item{seqs}{ an sequence or alignment character matrix or vector with a row per sequence }
  \item{pdb.file}{ a vector of pdb filenames; For sequence, provide "". }
  \item{chain.first}{ a vector of chain id for the first residue. }
  \item{resno.first}{ a vector of residue number for the first residue. }
  \item{chain.last}{ a vector of chain id for the last residue. }
  \item{resno.last}{ a vector of residue number for the last residue. }
  \item{file}{ name of output file.  }
  \item{append}{ logical, if TRUE output will be appended to
    \code{file}; otherwise, it will overwrite the contents of
    \code{file}. }
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
 }
\author{ Xin-Qiu Yao }
\note{
  PIR is required format for input alignment file to use Modeller. 
  For a description of PIR format see:
  \url{https://salilab.org/modeller/manual/node501.html}.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}}, 
   \code{\link{write.fasta}} }
\examples{
\donttest{
# Needs MUSCLE installed - testing excluded

if(check.utility("muscle")) {

## Generate an input file for structural modeling of 
## transducin G-alpha subunit using the template 3SN6_A

## Read transducin alpha subunit sequence
seq <- get.seq("P04695", outfile = tempfile())

## Read structure template
path = tempdir()
pdb.file <- get.pdb("3sn6_A", path = path, split = TRUE)
pdb <- read.pdb(pdb.file)

## Build an alignment between template and target
aln <- seqaln(seqbind(pdbseq(pdb), seq), id = c("3sn6_A", seq$id), outfile = tempfile())

## Write PIR format alignment file
outfile = file.path(tempdir(), "eg.pir")
write.pir(aln, pdb.file = c(pdb.file, ""), file = outfile)

invisible( cat("\nSee the output file:", outfile, sep = "\n") )

}
}
}
\keyword{ IO }

\name{check.utility}
\alias{check.utility}
\title{ Check on Missing Utility Programs }
\description{
  Internally used in examples, tests, or vignettes.
}
\usage{
  check.utility(x = c("muscle", "clustalo", "dssp", "stride", 
                "mustang", "makeup"), quiet = TRUE)
}
\arguments{
  \item{x}{ Names of one or more utility programs to check. }
  \item{quiet}{ logical, if TRUE no warning or message printed. }
}
\details{
  Check if requested utility programs are availabe or not.
}
\value{
  logical, TRUE if programs are available and FALSE if any one of 
     them is missing.
}
\examples{
   check.utility(c("muscle", "dssp"), quiet=FALSE)
   if(!check.utility("mustang")) 
      cat(" The utility program, MUSTANG, is missing on your system\n")
}
\keyword{ utilities }

\name{wrap.tor}
\alias{wrap.tor}
\title{ Wrap Torsion Angle Data }
\description{
  Adjust angular data so that the absolute difference of any of the
  observations from its mean is not greater than 180 degrees.
}
\usage{
wrap.tor(data, wrapav=TRUE, avestruc=NULL)
}
\arguments{
  \item{data}{ a numeric vector or matrix of torsion angle data as
    obtained from \code{torsion.xyz}. }
  \item{wrapav}{ logical, if TRUE average structure is also
    \sQuote{wrapped} }
  \item{avestruc}{ a numeric vector corresponding to the average
    structure } 
  
}
\details{
  This is a basic utility function for coping with the periodicity of 
  torsion angle data, by \sQuote{wraping} angular data such that the 
  absolute difference of any of the observations from its column-wise 
  mean is not greater than 180 degrees.
}
\value{
  A numeric vector or matrix of wrapped torsion angle data.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Karim ElSawy }
\seealso{ \code{\link{torsion.xyz}} }
\keyword{ utilities }

\name{hclustplot}
\alias{hclustplot}
\title{ Dendrogram with Clustering Annotation }
\description{
  Draw a standard dendrogram with clustering annotation in the marginal
  regions and colored labels.
}
\usage{
hclustplot(hc, k = NULL, h = NULL, colors = NULL, labels = NULL,
             fillbox = FALSE, heights = c(1, .3), mar = c(1, 1, 0, 1), ...)
}
\arguments{
  \item{hc}{ an object of the type produced by \code{hclust}. }
  \item{k}{ an integer scalar or vector with the desired number of
    groups. Redirected to function \code{cutree}. }
  \item{h}{ numeric scalar or vector with heights where the tree should
    be cut. Redirected to function \code{cutree}. At least one of \sQuote{k}
    or \sQuote{h} must be specified. }
  \item{colors}{ a numerical or character vector with the same length as
    \sQuote{hc} specifying the colors of the labels. }
  \item{labels}{ a character vector with the same length as
    \sQuote{hc} containing the labels to be written. }
  \item{fillbox}{ logical, if TRUE clustering annotation will be drawn
    as filled boxes below the dendrogram. }
  \item{heights}{ numeric vector of length two specifying the values for
    the heights of rows on the device. See function \code{layout}. }
  \item{mar}{ a numerical vector of the form \sQuote{c(bottom, left, top, right)}
    which gives the number of lines of margin to be specified on
    the four sides of the plot. If left at default the margins will be
    adjusted upon adding arguments \sQuote{main}, \sQuote{ylab}, etc. }
  \item{\dots}{ other graphical parameters passed to functions
    \code{plot.dendrogram}, \code{mtext}, and \code{par}. Note that
    certain arguments will be ignored. }
}
\details{
  This function adds extended visualization of cluster membership to a
  standard dendrogram. If \sQuote{k} or \sQuote{h} is provided a call to
  \code{cutree} will provide cluster membership
  information. Alternatively a vector of colors or cluster membership
  information can be provided through argument \sQuote{colors}.

  See examples for further details on usage.
}
\note{
  Argument \sQuote{horiz=TRUE} currently not supported.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{plot.hclust}}, \code{\link{plot.dendrogram}},
  \code{\link{hclust}}, \code{\link{cutree}}.  }
\examples{
\donttest{
# Redundant testing excluded

attach(transducin)

##- perform RMSD clustering
rd <- rmsd(pdbs, fit=TRUE)
hc <- hclust(as.dist(rd))

##- draw dendrogram 
hclustplot(hc, k=3)

##- draw dendrogram with manual clustering annotation
#hclustplot(hc, colors=annotation[, "color"], labels=pdbs$id)

detach(transducin)

}
}
\keyword{ hplot }

\name{seq2aln}
\alias{seq2aln}
\title{ Add a Sequence to an Existing Alignmnet }
\description{
  Add one or more sequences to an existing multiple alignment that you
  wish to keep intact.
}
\usage{
seq2aln(seq2add, aln, id = "seq", file = "aln.fa", \dots)
}
\arguments{
  \item{seq2add}{ an sequence character vector or an alignment list
    object with \code{id} and \code{ali} components, similar to that
    generated by \code{\link{read.fasta}} and \code{\link{seqaln}}. }
  \item{aln}{ an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}}
    and \code{\link{seqaln}}. }
  \item{id}{ a vector of sequence names to serve as sequence
    identifers. }
  \item{file}{ name of \sQuote{FASTA} output file to which alignment
    should be written. }
  \item{\dots}{ additional arguments passed to \code{\link{seqaln}}. }
}
\details{
  This function calls the \sQuote{MUSCLE} program, to perform a profile
  profile alignment, which MUST BE INSTALLED on your system and in the
  search path for executables.
}
\value{
  A list with two components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{id}{ sequence names as identifers.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  \sQuote{MUSCLE} is the work of Edgar:
  Edgar (2004) \emph{Nuc. Acid. Res.} \bold{32}, 1792--1797.
  
  Full details of the \sQuote{MUSCLE} algorithm, along with download and
  installation instructions can be obtained from:\cr
  \url{http://www.drive5.com/muscle/}.
}
\author{ Barry Grant }
\note{
  A system call is made to the \sQuote{MUSCLE} program, which must be
  installed on your system and in the search path for executables.
}
\seealso{ \code{\link{seqaln}}, \code{\link{read.fasta}},
  \code{\link{read.fasta.pdb}}, \code{\link{seqbind}}
}
\examples{

\dontrun{
aa.1 <- pdbseq( read.pdb("1bg2") )
aa.2 <- pdbseq( read.pdb("3dc4") )
aa.3 <- pdbseq( read.pdb("1mkj") )

aln <- seqaln( seqbind(aa.1,aa.2) )

seq2aln(aa.3, aln)
}

}
\keyword{ utilities }

\name{inspect.connectivity}
\alias{inspect.connectivity}
\title{ Check the Connectivity of Protein Structures }
\description{
  Investigate protein coordinates to determine if the structure
  has missing residues. 
}
\usage{
inspect.connectivity(pdbs, cut=4.)
}
\arguments{
  \item{pdbs}{ an object of class \code{3daling} as obtained from
    function \code{pdbaln} or \code{read.fasta.pdb}; a xyz matrix
    containing the cartesian coordinates of C-alpha atoms; or a
    \sQuote{pdb} object as obtained from function \code{read.pdb}. }
  \item{cut }{ cutoff value to determine residue connectvitiy. }
}
\details{
  Utility function for checking if the PDB structures in a
  \sQuote{pdbs} object contains missing residues inside the
  structure. 

}
\value{
  Returns a vector. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{dm}}, \code{\link{gap.inspect}} }
\examples{
\dontrun{
## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
raw.files <- get.pdb(ids, path = "raw_pdbs")
files <- pdbsplit(raw.files, ids, path = "raw_pdbs/split_chain")

## Sequence Alignement, and connectivity check
pdbs <- pdbaln(files)

cons <- inspect.connectivity(pdbs)

## omit files with missing residues
files = files[cons]
}
}
\keyword{ analysis }

\name{read.cif}
\alias{read.cif}
\title{ Read mmCIF File}
\description{
  Read a Protein Data Bank (mmCIF) coordinate file.
}
\usage{
read.cif(file, maxlines = -1, multi = FALSE,
         rm.insert = FALSE, rm.alt = TRUE, verbose = TRUE)
}
\arguments{
  \item{file}{ a single element character vector containing the name of
    the mmCIF file to be read, or the four letter PDB identifier for
    online file access. }
  \item{maxlines}{ the maximum number of lines to read before giving up
    with large files. By default if will read up to the end of input on
    the connection. }
  \item{multi}{ logical, if TRUE multiple ATOM records are read for all
    models in multi-model files and their coordinates returned. }
  \item{rm.insert}{ logical, if TRUE PDB insert records are ignored. }
  \item{rm.alt}{ logical, if TRUE PDB alternate records are ignored. }
  \item{verbose}{ print details of the reading process. }
}
\details{
  The current version of \code{read.cif} reads only ATOM/HETATM records
  and creates a \code{pdb} object of the data.

  See \code{read.pdb} for more info.
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a data.frame containing all atomic coordinate ATOM and 
    HETATM data, with a row per ATOM/HETATM and a column per record type.  
    See below for details of the record type naming convention (useful for 
    accessing columns). }
  \item{xyz }{ a numeric matrix of class \code{"xyz"} containing the
    ATOM and HETATM coordinate data. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{read.pdb}}
  \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{trim.pdb}}, \code{\link{cat.pdb}}, 
  \code{\link{read.prmtop}}, \code{\link{as.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.ncdf}}, 
}
\examples{
## Read a mmCIF file from the RCSB online database
# cif <- read.cif("1hel")
}
\keyword{ IO }

\name{aa2index}
\alias{aa2index}
\title{ Convert an Aminoacid Sequence to AAIndex Values }
\description{
  Converts sequences to aminoacid indeces from the \sQuote{AAindex} database. 
}
\usage{
aa2index(aa, index = "KYTJ820101", window = 1)
}
\arguments{
  \item{aa}{ a protein sequence character vector. }
  \item{index}{ an index name or number (default: \dQuote{KYTJ820101},
    hydropathy index by Kyte-Doolittle, 1982). }
  \item{window}{ a positive numeric value, indicating the window size
    for smoothing with a sliding window average (default: 1, i.e. no
    smoothing). }
}
\details{
  By default, this function simply returns the index values for each
  amino acid in the sequence. It can also be set to perform a crude
  sliding window average through the \code{window} argument. 
}
\value{
  Returns a numeric vector.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  \sQuote{AAIndex} is the work of Kanehisa and co-workers:
Kawashima and Kanehisa (2000) \emph{Nucleic Acids Res.} \bold{28}, 374;
Tomii and Kanehisa (1996) \emph{Protein Eng.} \bold{9}, 27--36;
Nakai, Kidera and Kanehisa (1988) \emph{Protein Eng.} \bold{2}, 93--100.

For a description of the \sQuote{AAindex} database see:\cr 
\url{https://www.genome.jp/aaindex/} or the \code{\link{aa.index}} documentation.
}
\author{ Ana Rodrigues }
\seealso{ \code{\link{aa.index}}, \code{\link{read.fasta}} }
\examples{
## Residue hydropathy values
seq <- c("R","S","D","X","-","X","R","H","Q","V","L")
aa2index(seq)

\dontrun{
## Use a sliding window average
aa2index(aa=seq, index=22, window=3)

## Use an alignment

aln  <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))
prop <- t(apply(aln$ali, 1, aa2index, window=1))

## find and use indices for volume calculations
i <- which(sapply(aa.index,
       function(x) length(grep("volume", x$D, ignore.case=TRUE)) != 0))
sapply(i, function(x) aa2index(aa=seq, index=x, window=5)) 
}
}
\keyword{ utilities }

\name{write.fasta}
\alias{write.fasta}
\title{ Write FASTA Formated Sequences }
\description{
  Write aligned or un-aligned sequences to a FASTA format file.
}
\usage{
write.fasta(alignment=NULL, ids=NULL, seqs=alignment$ali, gap=TRUE, file, append = FALSE)
}
\arguments{
  \item{alignment}{  an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}}. }
  \item{ids}{ a vector of sequence names to serve as sequence identifers }
  \item{seqs}{ an sequence or alignment character matrix or vector with a row per sequence }
  \item{gap}{ logical, if FALSE gaps will be removed. }
  \item{file}{ name of output file.  }
  \item{append}{ logical, if TRUE output will be appended to
    \code{file}; otherwise, it will overwrite the contents of
    \code{file}. }
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
 }
\author{ Barry Grant }
\note{
  For a description of FASTA format see:
  \url{https://www.ncbi.nlm.nih.gov/BLAST/blastcgihelp.shtml}.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

## Read a PDB file
pdb <- read.pdb("1bg2")

## Extract sequence from PDB file
s <- aa321(pdb$seqres)                   # SEQRES
a <- aa321(pdb$atom[pdb$calpha,"resid"]) # ATOM

## Write simple fasta file
#write.fasta( seqs=seqbind(s,a), file="eg.fa")
#write.fasta( ids=c("seqres","atom"), seqs=seqbind(s,a), file="eg.fa" )

outfile1 = file.path(tempdir(), "eg.fa")
write.fasta(list( id=c("seqres"),ali=s ), file = outfile1)
write.fasta(list( id=c("atom"),ali=a ), file = outfile1, append=TRUE)

## Align seqres and atom records
#seqaln(seqbind(s,a))

## Read alignment
aln<-read.fasta(system.file("examples/kif1a.fa",package="bio3d"))

## Cut all but positions 130 to 245
aln$ali=aln$ali[,130:245]

outfile2 = file.path(tempdir(), "eg2.fa")
write.fasta(aln, file = outfile2)

invisible( cat("\nSee the output files:", outfile1, outfile2, sep="\n") )
}
}
\keyword{ IO }

\name{rmsf}
\alias{rmsf}
\title{ Atomic RMS Fluctuations }
\description{
  Calculate atomic root mean squared fluctuations.
}
\usage{
rmsf(xyz, grpby=NULL, average=FALSE)
}
\arguments{
  \item{xyz}{ numeric matrix of coordinates with each row corresponding
    to an individual conformer. }
  \item{grpby}{ a vector counting connective duplicated elements that
    indicate the elements of 'xyz' that should be considered as a
    group (e.g. atoms from a particular residue). If provided a
    'pdb' object, grouping is automatically set by amino acid residues. }
  \item{average}{ logical, if TRUE averaged over atoms. }
}
\details{
  RMSF is an often used measure of conformational variance. It is calculated by
  \deqn{f_i=\sqrt{\frac{1}{M-1}\sum_j \|r_i^j-r_i^0\|^2}}{%
        f_i=sqrt((1/(M-1))Sum_j(||r_i^j-r_i^0||^2))},
  where \eqn{f_i}{f_i} is the RMSF value for the ith atom, M the total number of frames 
  (total number of rows of \code{xyz}), \eqn{r_i^j}{r_i^j} the positional vector of the
  ith atom in the jth frame, and \eqn{r_i^0}{r_i^0} the mean position of ith atom. 
  ||r|| denotes the Euclidean norm of the vector r.
}
\value{
  Returns a numeric vector of RMSF values. If \code{average=TRUE} a single numeric value
  representing the averaged RMSF value over all atoms will be returned. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.dcd}}, \code{\link{fit.xyz}},
  \code{\link{read.fasta.pdb}} }
\examples{
attach(transducin)

# Ignore Gaps
gaps <- gap.inspect(pdbs$ali)

r <- rmsf(pdbs$xyz)
plot(r[gaps$f.inds], typ="h", ylab="RMSF (A)")

detach(transducin)

\dontrun{

pdb <- read.pdb("1d1d", multi=TRUE)
xyz <- pdb$xyz

# superimpose trajectory
xyz <- fit.xyz(xyz[1, ], xyz)

# select mainchain atoms
sele <- atom.select(pdb, elety=c("CA", "C", "N", "O"))

# residue numbers to group by
resno <- pdb$atom$resno[sele$atom]

# mean rmsf value of mainchain atoms of each residue
r <- rmsf(xyz[, sele$xyz], grpby=resno)
plot.bio3d(r, resno=pdb, sse=pdb, ylab="RMSF (A)")

}

}
\keyword{ utilities }

\name{seqaln}
\alias{seqaln}
\title{ Sequence Alignment with MUSCLE}
\description{
  Create multiple alignments of amino acid or nucleotide sequences
  according to the method of Edgar.
}
\usage{
seqaln(aln, id=NULL, profile=NULL, exefile="muscle", outfile="aln.fa", 
       protein=TRUE, seqgroup=FALSE, refine=FALSE, extra.args="",
       verbose=FALSE, web.args = list(), \dots)  
}
\arguments{
  \item{aln}{ a sequence character matrix, as obtained from
    \code{\link{seqbind}}, or an alignment list object as obtained from
      \code{\link{read.fasta}}. }
  \item{id}{ a vector of sequence names to serve as sequence
    identifers. }
  \item{profile}{ a profile alignment of class \sQuote{fasta}
    (e.g. obtained from \code{\link{read.fasta}}). The alignment
    \code{aln} will be added to the profile. }
  \item{exefile}{ file path to the \sQuote{MUSCLE} program on your system (i.e.
    how is \sQuote{MUSCLE} invoked). Alternatively, \sQuote{CLUSTALO} can
    be used. Also supported is using the \sQuote{msa} package from Bioconductor
    (need to install packages using \code{BiocManager::install()}). To do so, simply
    set \code{exefile="msa"}. }
  \item{outfile}{ name of \sQuote{FASTA} output file to which alignment
    should be written. }
  \item{protein}{ logical, if TRUE the input sequences are assumed to be
    protein not DNA or RNA. }
  \item{seqgroup}{ logical, if TRUE similar sequences are grouped
    together in the output. }
  \item{refine}{ logical, if TRUE the input sequences are assumed to already
  be aligned, and only tree dependent refinement is performed. }
  \item{extra.args}{ a single character string containing extra command
    line arguments for the alignment program. }
  \item{verbose}{ logical, if TRUE \sQuote{MUSCLE} warning and error
    messages are printed. }
  \item{web.args}{ a \sQuote{list} object containing arguments to perform
    online sequence alignment using EMBL-EBI Web Services. 
    See below for details. } 
  \item{\dots}{ additional arguments passed to the function
    \code{msa::msaMuscle()}. }
}
\details{
  Sequence alignment attempts to arrange the sequences of protein,
  DNA or RNA, to highlight regions of shared similarity that may
  reflect functional, structural, and/or evolutionary relationships
  between the sequences.

  Aligned sequences are represented as rows within a matrix. Gaps
  (\sQuote{-}) are inserted between the aminoacids or nucleotides so that
  equivalent characters are positioned in the same column.

  This function calls the \sQuote{MUSCLE} program to perform a multiple 
  sequence alignment, which must be installed on your system and in the search 
  path for executables. If local \sQuote{MUSCLE} can not be found, alignment
  can still be performed via online web services (see below) with limited
  features. 

  If you have a large number of input sequences (a few thousand), or they are
  very long, the default settings may be too slow for practical
  use. A good compromise between speed and accuracy is to run just the
  first two iterations of the \sQuote{MUSCLE} algorithm by setting the
  \code{extra.args} argument to \dQuote{-maxiters 2}.

  You can set \sQuote{MUSCLE} to improve an existing alignment by setting
  \code{refine} to TRUE.

  To inspect the sequence clustering used by \sQuote{MUSCLE} to produce
  alignments, include \dQuote{-tree2 tree.out} in the \code{extra.args}
  argument. You can then load the \dQuote{tree.out} file with the
  \sQuote{read.tree} function from the \sQuote{ape} package.

  \sQuote{CLUSTALO} can be used as an alternative to \sQuote{MUSCLE} by
  specifiying \code{exefile='clustalo'}. This might be useful e.g. when
  adding several sequences to a profile alignment. 

  If local \sQuote{MUSCLE} or \sQuote{CLUSTALO} program is unavailable, the alignment
  can be performed via the \sQuote{msa} package from the Bioconductor repository.
  To do so, set \code{exefile="msa"}. Note that both \sQuote{msa} and 
  \sQuote{Biostrings} packages need to be installed properly using \code{BiocManager::install()}. 
  
  If the access to any method metioned above fails, 
  the function will attempt to perform alignment via the EMBL-EBI Web Services 
  (See \url{https://www.ebi.ac.uk/}). In this case, the argument \code{web.args} 
  cannot be empty and must contain at least user's E-Mail address. 
  Note that as stated by EBI, a fake email address may result 
  in your jobs being killed and your IP, organisation or entire domain being 
  black-listed (See FAQs on \url{https://www.ebi.ac.uk/}). 
  Possible parameters to be passed via \code{web.args} include:
  \describe{
    \item{email}{ a string containing a valid E-Mail address. Required. }
    \item{title}{ a string for the title of the job to be submitted to
      the remote server. Optional. }
    \item{timeout}{ integer specifying the number of seconds to wait for
      the response of the server before a time out occurs. Default: 90. }
  }
  An example of usage is \code{web.args=list(email='user_id@email.provider')}.
}
\value{
  Returns a list of class \code{"fasta"} with the following components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{id}{ sequence names as identifers.}
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  \sQuote{MUSCLE} is the work of Edgar:
  Edgar (2004) \emph{Nuc. Acid. Res.} \bold{32}, 1792--1797.
  
  Full details of the \sQuote{MUSCLE} algorithm, along with download and
  installation instructions can be obtained from:\cr
  \url{http://www.drive5.com/muscle/}.
}
\author{ Barry Grant }
\note{
  A system call is made to the \sQuote{MUSCLE} program, which must be
  installed on your system and in the search path for executables.
  See \url{http://thegrantlab.org/bio3d/articles/online/install_vignette/Bio3D_install.html} for 
  instructions of how to install this program.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}},
  \code{\link{get.seq}}, \code{\link{seqbind}}, 
  \code{\link{pdbaln}}, \code{\link{plot.fasta}},
  \code{\link{blast.pdb}}
}
\examples{
\dontrun{
##-- Basic sequence alignemnt
seqs <- get.seq(c("4q21_A", "1ftn_A"))
aln <- seqaln(seqs)

##-- add a sequence to the (profile) alignment
seq <- get.seq("1tnd_A")
aln <- seqaln(seq, profile=aln)


##-- Read a folder/directory of PDB files
#pdb.path <- "my_dir_of_pdbs"
#files  <- list.files(path=pdb.path ,
#                     pattern=".pdb",
#                     full.names=TRUE)

##-- Use online files
files <- get.pdb(c("4q21","1ftn"), URLonly=TRUE)

##-- Extract and store sequences
raw <- NULL
for(i in 1:length(files)) {
  pdb <- read.pdb(files[i])
  raw <- seqbind(raw, pdbseq(pdb) )
}

##-- Align these sequences
aln <- seqaln(raw, id=files, outfile="seqaln.fa")

##-- Read Aligned PDBs storing coordinate data
pdbs <- read.fasta.pdb(aln) 

## Sequence identity
seqidentity(aln)

## Note that all the above can be done with the pdbaln() function:
#pdbs <- pdbaln(files)


##-- For identical sequences with masking use a custom matrix
aa <- seqbind(c("X","C","X","X","A","G","K"),
              c("C","-","A","X","G","X","X","K"))

aln <- seqaln(aln=aln, id=c("a","b"), outfile="temp.fas", protein=TRUE,
               extra.args= paste("-matrix",
                system.file("matrices/custom.mat", package="bio3d"),
                "-gapopen -3.0 ",
                "-gapextend -0.5",
                "-center 0.0") )
}
}
\keyword{ utilities }

\name{pca.pdbs}
\alias{pca.pdbs}
\title{ Principal Component Analysis }
\description{
  Performs principal components analysis (PCA) on an ensemble of PDB structures.
}
\usage{
\method{pca}{pdbs}(pdbs, core.find = FALSE, fit = FALSE, \dots)
}
\arguments{
  \item{pdbs}{ an object of class \code{pdbs} as obtained from
    function \code{pdbaln} or \code{read.fasta.pdb}. }
  \item{core.find}{ logical, if TRUE core.find() function will be called
    to find core positions and coordinates of PDB structures will be
    fitted based on cores.  }
  \item{fit}{ logical, if TRUE coordinates of PDB structures will be
    fitted based on all CA atoms.  }
  \item{\dots}{ additional arguments passed to the method \code{pca.xyz}. }
}
\details{
  The function \code{pca.pdbs} is a wrapper for the function
  \code{\link{pca.xyz}}, wherein more details of the PCA procedure
  are documented. 
}
\value{
  Returns a list with the following components:
  \item{L }{eigenvalues.}
  \item{U }{eigenvectors (i.e. the variable loadings).}
  \item{z.u }{scores of the supplied \code{data} on the pcs.}
  \item{sdev }{the standard deviations of the pcs.}
  \item{mean }{the means that were subtracted.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{  Barry Grant, Lars Skjaerven and Xin-Qiu Yao}
\seealso{
  \code{\link{pca}}, \code{\link{pca.xyz}},
  \code{\link{pdbaln}}, \code{\link{nma}}. 
}
\examples{

attach(transducin)

#-- Do PCA ignoring gap containing positions
pc.xray <- pca(pdbs)

# Plot results (conformer plots & scree plot)
plot(pc.xray, col=annotation[, "color"])

detach(transducin)

}
\keyword{ utilities }
\keyword{ multivariate }

\name{seqidentity}
\alias{seqidentity}
\title{ Percent Identity}
\description{
  Determine the percent identity scores for aligned sequences.
}
\usage{
  seqidentity(alignment, normalize=TRUE, similarity=FALSE, ncore=1, nseg.scale=1)
}
\arguments{
  \item{alignment}{ sequence alignment obtained from
    \code{\link{read.fasta}} or an alignment character matrix. }
  \item{normalize}{ logical, if TRUE output is normalized to values
    between 0 and 1 otherwise percent identity is returned. }
  \item{similarity}{ logical, if TRUE sequence similarity is calculated
    instead of identity. }
  \item{ncore}{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{nseg.scale}{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
}
\details{
  The percent identity value is a single numeric score determined for
  each pair of aligned sequences.  It measures the number of identical
  residues (\dQuote{matches}) in relation to the length of the alignment.
}
\value{
  Returns a numeric matrix with all pairwise identity values.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{
  \code{\link{read.fasta}}, \code{\link{filter.identity}},
  \code{\link{entropy}}, \code{\link{consensus}}
}
\examples{

attach(kinesin)

ide.mat <- seqidentity(pdbs)

# Plot identity matrix
plot.dmat(ide.mat, color.palette=mono.colors,
          main="Sequence Identity", xlab="Structure No.",
          ylab="Structure No.")

# Histogram of pairwise identity values
hist(ide.mat[upper.tri(ide.mat)], breaks=30,xlim=c(0,1),
     main="Sequence Identity", xlab="Identity")

# Compare two sequences
seqidentity( rbind(pdbs$ali[1,], pdbs$ali[15,]) )

detach(kinesin)
}
\keyword{ utilities }

\name{store.atom}
\alias{store.atom}
\title{ Store all-atom data from a PDB object }
\description{
  Not intended for public usage
}
\usage{
store.atom(pdb=NULL)
}
\arguments{
  \item{pdb}{ A pdb object as obtained from read.pdb }
}
\details{
  This function was requested by a user and has not been extensively
  tested.  Hence it is not yet recommended for public usage.
}
\value{
  Returns a matrix of all-atom data. If \code{pdb=NULL}, returns the default 
  atom names to be stored. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{ This function is still in development and is NOT part of the
  offical bio3d package
}
\seealso{ \code{\link{read.fasta.pdb}} }
\examples{
\dontrun{
pdb <- read.pdb( get.pdb("5p21", URLonly=TRUE) )
a <- store.atom(pdb)
a[,,1:2]
}
}
\keyword{ utilities }

\name{read.ncdf}
\alias{read.ncdf}
\title{ Read AMBER Binary netCDF files }
\description{
  Read coordinate data from a binary netCDF trajectory file.
}
\usage{
read.ncdf(trjfile, headonly = FALSE, verbose = TRUE, time = FALSE,
          first = NULL, last = NULL, stride = 1, cell = FALSE,
          at.sel = NULL)
}
\arguments{
  \item{trjfile}{ name of trajectory file to read. A vector if treat
    a batch of files }
  \item{headonly}{ logical, if TRUE only trajectory header information
    is returned. If FALSE only trajectory coordinate data is returned. }
  \item{verbose}{ logical, if TRUE print details of the reading process. }
  \item{time}{ logical, if TRUE the \code{first} and \code{last} have the
    time unit ps; Otherwise the unit is the frame number. }
  \item{first}{ starting time or frame number to read; If NULL, start
    from the begining of the file(s). }
  \item{last}{ read data until \code{last} time or frame number; If NULL or
    equal to -1, read until the end of the file(s). }
  \item{stride}{ take at every \code{stride} frame(s) }
  \item{cell}{ logical, if TRUE and \code{headonly} is FALSE return cell 
    information only. Otherwise, return header or coordinates.}
  \item{at.sel}{an object of class \sQuote{select} indicating a subset
    of atomic coordinates to be read.}
}
\details{
  Reads a AMBER netCDF format trajectory file with the help of David
  W. Pierce's (UCSD) ncdf4 package available from CRAN.
}
\value{
   A list of trajectory header data,  a numeric matrix of xyz
   coordinates with a frame/structure per row and a Cartesian 
   coordinate per column, or a numeric matrix of cell information 
   with a frame/structure per row and lengths and angles per column.
   If time=TRUE, row names of returned coordinates or cell are
   set to be the physical time of corresponding frames.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  \url{https://www.unidata.ucar.edu/software/netcdf/}
  \url{https://cirrus.ucsd.edu/~pierce/ncdf/}
  \url{https://ambermd.org/FileFormats.php#netcdf}
}
\author{ Barry Grant }
\note{
  See AMBER documentation for netCDF format description.

  NetCDF binary trajectory files are supported by the AMBER modules
  sander, pmemd and ptraj. Compared to formatted trajectory files, the
  binary trajectory files are smaller, higher precision and
  significantly faster to read and write.

  NetCDF provides for file portability across architectures, allows for
  backwards compatible extensibility of the format and enables the files
  to be self-describing. Support for this format is available in VMD.

  If you experience problems reading your trajectory file with read.ncdf()
  consider first reading your file into VMD and from there exporting a
  new DCD trajectory file with the 'save coordinates' option. This new
  file should be easily read with read.dcd().
}
\seealso{ \code{\link{read.dcd}}, \code{\link{write.ncdf}},
  \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{atom.select}} }
\examples{
\dontrun{
##-- Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Write to netCDF format
write.ncdf(trj, "newtrj.nc")

## Read trj
trj <- read.ncdf("newtrj.nc")
}
}
\keyword{ IO }

\name{inner.prod}
\alias{inner.prod}
\title{ Mass-weighted Inner Product }
\description{
  Inner product of vectors (mass-weighted if requested).
}
\usage{
inner.prod(x, y, mass=NULL)
}
\arguments{
  \item{x}{ a numeric vector or matrix. }
  \item{y}{ a numeric vector or matrix. }
  \item{mass}{ a numeric vector containing the atomic masses for
    weighting. }
}
\details{
  This function calculates the inner product between two vectors, or
  alternatively, the column-wise vector elements of matrices. If atomic
  masses are provided, the dot products will be mass-weighted.
  
  See examples for more details.
}
\value{
  Returns the inner product(s).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma} }, \code{\link{normalize.vector} } }
\examples{
## Matrix operations
x <- 1:3
y <- diag(x)
z <- matrix(1:9, ncol = 3, nrow = 3)

inner.prod(x,y)
inner.prod(y,z)


## Application to normal modes
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Check for orthogonality 
inner.prod(modes$U[,7], modes$U[,8])

}
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clean.pdb.R
\name{clean.pdb}
\alias{clean.pdb}
\title{Inspect And Clean Up A PDB Object}
\usage{
clean.pdb(pdb, consecutive = TRUE, force.renumber = FALSE,
  fix.chain = FALSE, fix.aa = FALSE, rm.wat = FALSE, rm.lig = FALSE,
  rm.h = FALSE, verbose = FALSE)
}
\arguments{
\item{pdb}{an object of class \code{pdb} as obtained from
function \code{\link{read.pdb}}.}

\item{consecutive}{logical, if TRUE renumbering will result in
consecutive residue numbers spanning all chains. Otherwise new residue
numbers will begin at 1 for each chain.}

\item{force.renumber}{logical, if TRUE atom and residue records are renumbered 
even if no 'insert' code is found in the \code{pdb} object.}

\item{fix.chain}{logical, if TRUE chains are relabeled based on chain breaks detected.}

\item{fix.aa}{logical, if TRUE non-standard amino acid names are converted into 
equivalent standard names.}

\item{rm.wat}{logical, if TRUE water atoms are removed.}

\item{rm.lig}{logical, if TRUE ligand atoms are removed.}

\item{rm.h}{logical, if TRUE hydrogen atoms are removed.}

\item{verbose}{logical, if TRUE details of the conversion process are printed.}
}
\value{
a 'pdb' object with an additional \code{$log} component storing 
   all the processing messages.
}
\description{
Inspect alternative coordinates, chain breaks, bad residue
numbering, non-standard/unknow amino acids, etc. Return
a 'clean' pdb object with fixed residue numbering and optionally
relabeled chain IDs, corrected amino acid names, removed water,
ligand, or hydrogen atoms. All changes are recorded in a log in the 
returned object.
}
\details{
call for its effects.
}
\examples{
\donttest{
   # PDB server connection required - testing excluded

   pdb <- read.pdb("1a7l")
   clean.pdb(pdb)
} 
}
\author{
Xin-Qiu Yao & Barry Grant
}
\seealso{
\code{\link{read.pdb}}
}

\name{trim.mol2}
\alias{trim.mol2}
\title{ Trim a MOL2 Object To A Subset of Atoms. }
\description{
  Produce a new smaller MOL2 object, containing a subset of atoms, from a
  given larger MOL2 object. 
}
\usage{
\method{trim}{mol2}(mol, \dots, inds = NULL)
}
\arguments{
  \item{mol}{ a MOL2 structure object obtained from
    \code{\link{read.mol2}}. }
  \item{\dots}{ additional arguments passed to \code{\link{atom.select}}. If
     \code{inds} is also provided, these arguments will be ignored. }
  \item{inds}{ a list object of ATOM and XYZ indices as obtained from
    \code{\link{atom.select}}. If NULL, atom selection will be obtained
    from calling \code{atom.select(mol, \dots)}. }
}
\details{
  This is a basic utility function for creating a new MOL2 object based
  on a selection of atoms.
}
\value{
  Returns a list of class \code{"mol2"}.
  }
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{read.mol2}}, \code{\link{atom.select.mol2}},
  \code{\link{as.pdb.mol2}}, \code{\link{write.mol2}}, 
}
\examples{
\dontrun{
## Read a MOL2 file from those included with the package
mol <- read.mol2( system.file("examples/aspirin.mol2", package="bio3d"))

## Trim away H-atoms
mol <- trim(mol, "noh")

}
}
\keyword{ utilities }

\name{torsion.xyz}
\alias{torsion.xyz}
\title{ Calculate Torsion/Dihedral Angles }
\description{
  Defined from the Cartesian coordinates of four successive atoms
  (A-B-C-D) the torsion or dihedral angle is calculated about an axis
  defined by the middle pair of atoms (B-C).
}
\usage{
torsion.xyz(xyz, atm.inc = 4)
}
\arguments{
  \item{xyz}{ a numeric vector of Cartisean coordinates. }
  \item{atm.inc}{ a numeric value indicating the number of atoms to
    increment by between successive torsion evaluations (see below). }
}
\details{
  The conformation of a polypeptide or nucleotide chain can be usefully
  described in terms of angles of internal rotation around its
  constituent bonds.

  If a system of four atoms A-B-C-D is projected onto a plane normal to
  bond B-C, the angle between the projection of A-B and the projection
  of C-D is described as the torsion angle of A and D about bond B-C.

  By convention angles are measured in the range -180 to +180, rather
  than from 0 to 360, with positive values defined to be in the
  clockwise direction.

  With \code{atm.inc=1}, torsion angles are calculated for each set of
  four successive atoms contained in \code{xyz} (i.e. moving along one
  atom, or three elements of \code{xyz}, between sucessive
  evaluations).  With \code{atm.inc=4}, torsion angles are calculated
  for each set of four successive non-overlapping atoms contained in
  \code{xyz} (i.e. moving along four atoms, or twelve elements of
  \code{xyz}, between sucessive evaluations).
  
}
\value{
  A numeric vector of torsion angles.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Karim ElSawy }
\note{ Contributions from Barry Grant. }
\seealso{ \code{\link{torsion.pdb}}, \code{\link{pca.tor}},
  \code{\link{wrap.tor}}, \code{\link{read.pdb}}, \code{\link{read.dcd}}.
}
\examples{

## Calculate torsions for cis & trans conformers
xyz <- rbind(c(0,-0.5,0,1,0,0,1,1,0,0,1.5,0),
             c(0,-0.5,0,1,0,0,1,1,0,2,1.5,0)-3)
cis.tor   <- torsion.xyz( xyz[1,] )
trans.tor <- torsion.xyz( xyz[2,] )
apply(xyz, 1, torsion.xyz)


plot(range(xyz), range(xyz), xlab="", ylab="", typ="n", axes=FALSE)
  apply(xyz, 1, function(x){
    lines(matrix(x, ncol=3, byrow=TRUE), lwd=4)
    points(matrix(x, ncol=3, byrow=TRUE), cex=2.5,
           bg="white", col="black", pch=21) } )
  
  text( t(apply(xyz, 1, function(x){
    apply(matrix(x, ncol=3, byrow=TRUE)[c(2,3),], 2, mean) })),
       labels=c(0,180), adj=-0.5, col="red")

\donttest{
# PDB server connection required - testing excluded

##-- PDB torsion analysis
pdb <- read.pdb("1bg2")
tor <- torsion.pdb(pdb)
## basic Ramachandran plot
plot(tor$phi, tor$psi)

## torsion analysis of a single coordinate vector 
inds <- atom.select(pdb,"calpha")
tor.ca <- torsion.xyz(pdb$xyz[inds$xyz], atm.inc=3)

##-- Compare two PDBs to highlight interesting residues
aln <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
m <- read.fasta.pdb(aln)
a <- torsion.xyz(m$xyz[1,],1)
b <- torsion.xyz(m$xyz[2,],1)
## Note the periodicity of torsion angles
d <- wrap.tor(a-b)
plot(m$resno[1,],d, typ="h")

}

}
\keyword{ utilities }

\name{as.fasta}
\alias{as.fasta}
\title{ Alignment to FASTA object }
\description{
  Convert alignment/sequence in matrix/vector format to FASTA object.
}
\usage{
as.fasta(x, id=NULL, \dots)
}
\arguments{
  \item{x}{ a sequence character matrix/vector (e.g obtained from
    \code{\link{get.seq}} or \code{\link{seqbind}}). }
  \item{id}{ a vector of sequence names to serve as sequence
    identifers. By default the function will use the row names of the
    alignment if they exists, otherwise ids will be generated. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  This function provides basic functionality to convert a sequence
  character matrix/vector to a FASTA object. 
}
\value{
  Returns a list of class \code{"fasta"} with the following components:
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{id}{ sequence names as identifers.}
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{get.seq}}, \code{\link{seqaln}},
  \code{\link{seqbind}}, \code{\link{pdbaln}}
}
\examples{
as.fasta(c("A", "C", "D"))
}
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pdb2sse.R
\name{pdb2sse}
\alias{pdb2sse}
\title{Obtain An SSE Sequence Vector From A PDB Object}
\usage{
pdb2sse(pdb, verbose = TRUE)
}
\arguments{
\item{pdb}{an object of class \code{pdb} as obtained from
function \code{\link{read.pdb}}.}

\item{verbose}{logical, if TRUE warnings and other messages will be printed.}
}
\value{
a character vector indicating SSE elements for each amino acide residue.
   The 'names' attribute of the vector contains 'resno', 'chain', 'insert', and
   'SSE segment number', seperated by the character '_'.
}
\description{
Results are similar to that returned by stride(pdb)$sse and dssp(pdb)$sse.
}
\details{
call for its effects.
}
\examples{
\donttest{
   #PDB server connection required - testing excluded

   pdb <- read.pdb("1a7l")
   sse <- pdb2sse(pdb)
   sse
} 
}
\author{
Barry Grant & Xin-Qiu Yao
}
\seealso{
\code{\link{dssp}}, \code{\link{stride}}, \code{\link{bounds.sse}}
}

\name{pdbsplit}
\alias{pdbsplit}
\title{ Split a PDB File Into Separate Files, One For Each Chain. }
\description{
  Split a Protein Data Bank (PDB) coordinate file into new separate
  files with one file for each chain.
}
\usage{
pdbsplit(pdb.files, ids = NULL, path = "split_chain", overwrite=TRUE,
         verbose = FALSE, mk4=FALSE, ncore = 1, progress = NULL, \dots)
}
\arguments{
  \item{pdb.files}{ a character vector of PDB file names. }
  \item{ids}{ a character vector of PDB and chain identifiers
    (of the form: \sQuote{pdbId_chainId}, e.g. \sQuote{1bg2_A}). 
    Used for filtering chain IDs for output (in the above example only 
    chain A would be produced). }
  \item{path}{ output path for chain-split files. }
  \item{overwrite}{ logical, if FALSE the PDB structures will not be
    read and written if split files already exist. }
  \item{verbose}{ logical, if TRUE details of the PDB header and
    chain selections are printed. }
  \item{mk4}{ logical, if TRUE output filenames will use only the first
    four characters of the input filename (see \code{basename.pdb} for details).  }   
  \item{ncore}{ number of CPU cores used for the calculation.
    \code{ncore>1} requires package \sQuote{parallel} be installed. }
  \item{progress}{ progress bar for use with shiny web app. }
  \item{...}{ additional arguments to \code{read.pdb}. Useful e.g. for
    parsing multi model PDB files, including ALT records etc. in the
    output files. }
}
\details{
  This function will produce single chain PDB files from multi-chain
  input files. By default all separate filenames are returned. To return 
  only a subset of select chains the optional input \sQuote{ids} can be 
  provided to filter the output (e.g. to fetch only chain C, of a PDB 
  object with additional chains A+B ignored). See examples section for 
  further details.

  Note that multi model atom records will only split into individual 
  PDB files if \code{multi=TRUE}, else they are omitted. See examples.
}
\value{
  Returns a character vector of chain-split file names.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}},
  \code{\link{write.pdb}}, \code{\link{get.pdb}}. }
\examples{
\dontrun{
  ## Save separate PDB files for each chain of a local or on-line file
  pdbsplit( get.pdb("2KIN", URLonly=TRUE) )


  ## Split several PDBs by chain ID and multi-model records
  raw.files <- get.pdb( c("1YX5", "3NOB") , URLonly=TRUE)
  chain.files <- pdbsplit(raw.files,  path=tempdir(), multi=TRUE)
  basename(chain.files)


  ## Output only desired pdbID_chainID combinations
  ## for the last entry (1f9j), fetch all chains
  ids <- c("1YX5_A", "3NOB_B", "1F9J")
  raw.files <- get.pdb( ids , URLonly=TRUE)
  chain.files <- pdbsplit(raw.files, ids, path=tempdir())
  basename(chain.files)
}
}
\keyword{ utilities }

\name{is.select}
\alias{is.select}
\title{Is an Object of Class \sQuote{select}?}
\description{
Checks whether its argument is an object of class \sQuote{select}.
}
\usage{
is.select(x)
}
\arguments{
  \item{x}{an R object to be tested.}
}
\details{
Tests if x is an object of class \sQuote{select}, i.e. if x has a \dQuote{class} attribute equal to \code{select}.
}
\value{
TRUE if x is an object of class \sQuote{select} and FALSE otherwise
}

\author{
Julien Ide
}

\seealso{
\code{\link{atom.select}}
}
\examples{
# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

# Print structure summary
atom.select(pdb)

# Select all C-alpha atoms with residues numbers between 43 and 54
ca.inds <- atom.select(pdb, "calpha", resno=43:54)
is.select(ca.inds)

}
\keyword{ classes }

\name{vmd}
\alias{vmd}
\alias{vmd.cna}
\alias{vmd.ecna}
\alias{vmd.cnapath}
\alias{vmd.ecnapath}
\title{ View CNA Protein Structure Network Community Output in VMD }
\description{
  This function generates a VMD scene file and a PDB file that can be 
  read and rendered by the VMD molecular viewer. Chose \sQuote{color by chain} 
  to see corresponding regions of structure colored by community along with 
  the community protein structure network. 
}
\usage{
vmd(\dots)

\method{vmd}{cna}(x, pdb, layout = layout.cna(x, pdb, k=3), 
		col.sphere=NULL, col.lines = "silver", weights = NULL, 
		radius = table(x$communities$membership)/5, alpha = 1,
		vmdfile = "network.vmd", pdbfile = "network.pdb", 
                full = FALSE, launch = FALSE, exefile=NULL, \dots)
\method{vmd}{ecna}(x, n=1, \dots)
\method{vmd}{cnapath}(x, pdb, out.prefix = "vmd.cnapath", spline = FALSE, 
   colors = c("blue", "red"), launch = FALSE, exefile=NULL, mag=1.0, \dots)
\method{vmd}{ecnapath}(x, \dots)
}
\arguments{
  \item{x}{A 'cna' or 'cnapath' class object, or a list of such objects, as 
    obtained from functions \code{cna} or \code{cnapath}.
  }
  \item{n}{ The index to indicate which network or path to view with \code{vmd}. }
  \item{pdb}{A 'pdb' class object such as obtained from \sQuote{read.pdb} function.
  }
  \item{layout}{ A numeric matrix of Nx3 XYZ coordinate matrix, where N is the 
  number of community spheres to be drawn.
  }
  \item{col.sphere}{ A numeric vector containing the sphere colors.
  }
  \item{col.lines}{ A character object specifying the color of the
    edges (default 'silver'). Must use VMD colors names.
  }
  \item{weights}{ A numeric vector specifying the edge width. Default is
    taken from E(x$community.network)$weight.
  }
  \item{radius}{ A numeric vector containing the sphere radii. Default
    is taken from the number of community members divided by 5.
  }
  \item{alpha}{ A single element numeric vector specifying the VMD alpha
    transparency parameter. Default is set to 1.
  }
  \item{vmdfile}{ A character element specifying the output VMD scene file 
    name that will be loaded in VMD.
  }
  \item{pdbfile}{ A character element specifying the output pdb file name to be
    loaded in VMD.
  }
  \item{full}{ Logical, if TRUE the full all-atom network rather than the
    clustered community network will be drawn. Intra community edges are
    colored according to the community membership, while inter community
    edges are thicker and colored black.
  }
  \item{launch}{ Logical. If TRUE, a VMD session will be started with
    the output of \sQuote{vmd.cna}.
  }
  \item{out.prefix}{ Prefix for the names of output files, \sQuote{vmd.cnapath.vmd}
    and \sQuote{vmd.cnapath.pdb}.
  }
  \item{spline}{ Logical, if TRUE all paths are displayed as spline
    curves. 
  }
  \item{colors}{
    Character vector or integer scalar, define path colors. If a
    character vector, passed to \code{\link{colorRamp}} function to generate the 
    color scales. If an integer, color all paths the same way with VMD color 
    ID equal to the integer. }
  \item{exefile}{ file path to the \sQuote{VMD} program on your system (i.e.
    how is \sQuote{VMD} invoked). If \code{NULL}, use OS-dependent
    default path to the program. }
  \item{mag}{ A numeric factor to scale the maximal thickness of paths. }
  \item{\dots}{ additional arguments passed to the function
    \code{\link{colorRamp}} (in \code{vmd.cnapath}).
  }
}
\details{ 
  This function generates a scaled sphere (communities) and stick (edges) 
  representation of the community network along with the corresponding protein 
  structure divided into chains, one chain for each community. The sphere radii 
  are proportional to the number of community members and the edge widths correspond 
  to network edge weights.
}
\value{
  Two files are generated as output. A pdb file with the residue chains
  assigned according to the community and a text file containing The
  drawing commands for the community representation.
}
\references{ Humphrey, W., Dalke, A. and Schulten, K., ``VMD - Visual Molecular Dynamics'' J. Molec. Graphics 1996, 14.1, 33-38.
}
\author{
Barry Grant}

\examples{
\dontrun{

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

# Load the correlation network from MD data
attach(hivp)

# Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

# View cna 
vmd.cna(net, pdb, launch=FALSE)
## within VMD set 'coloring method' to 'Chain' and 'Drawing method' to Tube


##-- From NMA
pdb.gdi = read.pdb("1KJY")
pdb.gdi = trim.pdb(pdb.gdi, inds=atom.select(pdb.gdi, chain="A", elety="CA")) 
modes.gdi = nma(pdb.gdi)
cij.gdi = dccm(modes.gdi)
net.gdi = cna(cij.gdi, cutoff.cij=0.35)
#vmd.cna(net.gdi, pdb.gdi, alpha = 0.7, launch=TRUE)

detach(hivp)

}
}
}

\keyword{ utility }

\name{dm}
\alias{dm}
\alias{dm.pdb}
\alias{dm.xyz}
\alias{dm.pdbs}
\title{ Distance Matrix Analysis }
\description{
  Construct a distance matrix for a given protein structure.
}
\usage{
dm(\dots)

\method{dm}{pdb}(pdb, inds = NULL, grp = TRUE, verbose=TRUE, \dots)
\method{dm}{pdbs}(pdbs, rm.gaps=FALSE, all.atom=FALSE, 
                        aligned.atoms.only=NULL, \dots)

\method{dm}{xyz}(xyz, grpby = NULL, scut = NULL, mask.lower = TRUE, 
                  gc.first=FALSE, ncore=1, \dots)
}
\arguments{
  \item{pdb}{ a \code{pdb} structure object as returned by
    \code{\link{read.pdb}} or a numeric vector of \sQuote{xyz} coordinates.}
  \item{inds}{ atom and xyz coordinate indices obtained from \code{atom.select}
    that selects the elements of \code{pdb} upon which the calculation
    should be based. }
  \item{grp}{ logical, if TRUE atomic distances will be grouped according
    to their residue membership. See \sQuote{grpby}. }
  \item{verbose}{ logical, if TRUE possible warnings are printed. }
  \item{pdbs}{ a \sQuote{pdbs} object as returned by \code{\link{read.fasta.pdb}},
    \code{\link{read.all}}, or \code{\link{pdbaln}}. }
  \item{rm.gaps}{ logical, if TRUE gapped positions are removed in the returned value. }
  \item{all.atom}{ logical, if TRUE all-atom coordinates from \code{\link{read.all}}
    are used. }
  \item{aligned.atoms.only}{ logical, if TRUE only equivalent (aligned) atoms are considered. 
    Only meaningful when \code{all.atom=TRUE}. Default: FALSE. } 
  \item{xyz}{ a numeric vector or matrix of Cartesian coordinates.}
  \item{grpby}{ a vector counting connective duplicated elements that
    indicate the elements of \code{xyz} that should be considered as a group
    (e.g. atoms from a particular residue). }
  \item{scut}{ a cutoff neighbour value which has the effect of
    excluding atoms, or groups, that are sequentially within this
    value.}
  \item{mask.lower}{ logical, if TRUE the lower matrix elements
    (i.e. those below the diagonal) are returned as NA.}
  \item{gc.first}{ logical, if TRUE will call gc() first before calculation of 
    distance matrix. This is to solve the memory overload problem when \code{ncore > 1}
    and \code{xyz} has many rows/columns, with a bit sacrifice on speed. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{\dots}{ arguments passed to and from functions. }
}
\details{
  Distance matrices, also called distance plots or distance maps, are an
  established means of describing and comparing protein conformations
  (e.g. Phillips, 1970; Holm, 1993).

  A distance matrix is a 2D representation of 3D structure that is
  independent of the coordinate reference frame and, ignoring
  chirality, contains enough information to reconstruct the 3D Cartesian
  coordinates (e.g. Havel, 1983).
}
\value{
  Returns a numeric matrix of class \code{"dmat"}, with all N by N
  distances, where N is the number of selected atoms. With multiple
  frames the output is provided in a three dimensional array. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Phillips (1970) \emph{Biochem. Soc. Symp.} \bold{31}, 11--28.
  
  Holm (1993) \emph{J. Mol. Biol.} \bold{233}, 123--138.
  
  Havel (1983) \emph{Bull. Math. Biol.} \bold{45}, 665--720.
}
\author{ Barry Grant }
\note{
  The input \code{selection} can be any character string or pattern
  interpretable by the function \code{\link{atom.select}}.  For example,
  shortcuts \code{"calpha"}, \code{"back"}, \code{"all"} and selection
  strings of the form \code{/segment/chain/residue number/residue
    name/element number/element name/}; see \code{\link{atom.select}}
  for details.

  If a coordinate vector is provided as input (rather than a \code{pdb}
  object) the \code{selection} option is redundant and the input vector
  should be pruned instead to include only desired positions. 
}
\seealso{ \code{\link{plot.dmat}}, \code{\link{read.pdb}}, \code{\link{atom.select}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

##--- Distance Matrix Plot
pdb <- read.pdb( "4q21" )
k <- dm(pdb,inds="calpha")
filled.contour(k, nlevels = 10)

## NOTE: FOLLOWING EXAMPLE NEEDS MUSCLE INSTALLED
if(check.utility("muscle")) {

##--- DDM: Difference Distance Matrix
# Downlaod and align two PDB files
pdbs <- pdbaln( get.pdb( c( "4q21", "521p"), path = tempdir() ), outfile = tempfile() )

# Get distance matrix
a <- dm.xyz(pdbs$xyz[1,])
b <- dm.xyz(pdbs$xyz[2,])

# Calculate DDM
c <- a - b

# Plot DDM
plot(c,key=FALSE, grid=FALSE)

plot(c, axis.tick.space=10,
     resnum.1=pdbs$resno[1,],
     resnum.2=pdbs$resno[2,],
     grid.col="black",
     xlab="Residue No. (4q21)", ylab="Residue No. (521p)")
}
}

\dontrun{
##-- Residue-wise distance matrix based on the
##   minimal distance between all available atoms
l <- dm.xyz(pdb$xyz, grpby=pdb$atom[,"resno"], scut=3)
}
}
\keyword{ utilities }

\name{layout.cna}
\alias{layout.cna}
\title{ Protein Structure Network Layout }
\description{
  Determine protein structure network layout in 2D and 3D from the geometric 
  center of each community.
}
\usage{
  layout.cna(x, pdb, renumber=TRUE, k=2, full=FALSE)
}
\arguments{
  \item{x}{ A protein structure network object as obtained from the \sQuote{cna} 
    function. }
  \item{pdb}{ A pdb class object as obtained from the \sQuote{read.pdb} 
    function. }
  \item{renumber}{ Logical, if TRUE the input \sQuote{pdb} will be re-numbered 
    starting at residue number one before community coordinate averages are 
    calculated. } 
  \item{k}{ A single element numeric vector between 1 and 3 specifying the 
    returned coordinate dimensions. }
  \item{full}{ Logical, if TRUE the full all-Calpha atom network coordinates will 
    be returned rather than the default clustered network community coordinates. }       

}
\details{
  This function calculates the geometric center for each community from
  the atomic position of it's Calpha atoms taken from a corresponding PDB 
  file. Care needs to be taken to ensure the PDB residue numbers and the
  community vector names/length match.

  The community residue membership are typically taken from the input network 
  object but can be supplied as a list object with 'x$communities$membership'.
}
\value{
 A numeric matrix of Nxk, where N is the number of communities and k the number of dimensions requested.
}
\author{ Guido Scarabelli and Barry Grant }

\seealso{ \code{\link{plot.cna}}, \code{\link[igraph:communities]{plot.communities}},
  \code{\link[igraph:plot.common]{igraph.plotting}}, 
  \code{\link[igraph:plot.igraph]{plot.igraph}}}
\examples{

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

# Load the correlation network
attach(hivp)

# Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

# Plot will be slow
#xy <- plot.cna(net)
#plot3d.cna(net, pdb)

layout.cna(net, pdb, k=3)
layout.cna(net, pdb)

# can be used as input to plot.cna and plot3d.cna....
# plot.cna( net, layout=layout.cna(net, pdb) )
# plot3d.cna(net, pdb, layout=layout.cna(net, pdb, k=3))

detach(hivp)

}
}
\keyword{ utility }

\name{mktrj}
\alias{mktrj}
\alias{mktrj.pca}
\alias{mktrj.nma}
\alias{mktrj.enma}
\title{ PCA / NMA Atomic Displacement Trajectory }
\description{
  Make a trajectory of atomic displacments along a given principal
  component / normal mode.
}
\usage{
mktrj(...)

\method{mktrj}{pca}(pca = NULL, pc = 1, mag = 1, step = 0.125, file =
NULL, pdb = NULL, rock=TRUE, ...)

\method{mktrj}{nma}(nma = NULL, mode = 7, mag = 10, step = 1.25, file = NULL, 
      pdb = NULL, rock=TRUE,  ...)

\method{mktrj}{enma}(enma = NULL, pdbs = NULL, s.inds = NULL, m.inds = NULL,
      mag = 10, step = 1.25, file = NULL, rock = TRUE, ncore = NULL, ...) 
}
\arguments{
  \item{pca}{ an object of class \code{"pca"} as obtained with
    function \code{\link{pca.xyz}} or \code{\link{pca}}.}
  \item{nma}{ an object of class \code{"nma"} as obtained with
    function \code{\link{nma.pdb}}.}
  \item{enma}{ an object of class \code{"enma"} as obtained with
    function \code{\link{nma.pdbs}}.}
  \item{pc}{ the PC number along which displacements should be made.}
  \item{mag}{ a magnification factor for scaling the displacements. }
  \item{step}{ the step size by which to increment along the pc/mode. }
  \item{file}{ a character vector giving the output PDB file name. }
  \item{pdb}{ an object of class \code{"pdb"} as obtained from 
    \code{\link{read.pdb}} or class \code{"pdbs"} as obtained from
    \code{\link{read.fasta.pdb}}. If not NULL, used as reference to write
    the PDB file. }
  \item{rock}{ logical, if TRUE the trajectory rocks. }
  \item{mode}{ the mode number along which displacements should be made.}
  \item{pdbs}{ a list object of class \code{"pdbs"} (obtained with
    \code{\link{pdbaln}} or \code{\link{read.fasta.pdb}}) which
    corresponds to the \code{"enma"} object.}
  \item{s.inds}{ index or indices pointing to the structure(s) in the
    \code{enma} object for which the trajectory shall be generated. }
  \item{m.inds}{ the mode number(s) along which displacements should be
    made. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{\dots}{ additional arguments passed to and from functions
    (e.g. to function \code{\link{write.pdb}}). }
}
\details{
  Trajectory frames are built from reconstructed Cartesian coordinates
  produced by interpolating from the mean structure along a given
  \code{pc} or \code{mode}, in increments of \code{step}.

  An optional magnification factor can be used to amplify
  displacements.  This involves scaling by \code{mag}-times the standard
  deviation of the conformer distribution along the given \code{pc}
  (i.e. the square root of the associated eigenvalue).
}
\note{ Molecular graphics software such as VMD or PyMOL is useful
  for viewing trajectories see e.g: \cr
  \url{http://www.ks.uiuc.edu/Research/vmd/}. }
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{
  \code{\link{pca}}, \code{\link{nma}},
  \code{\link{nma.pdbs}},
  \code{\link{pymol.modes}}.
}
\examples{
\dontrun{

##- PCA example
attach(transducin)

# Calculate principal components
pc.xray <- pca(pdbs, fit=TRUE)

# Write PC trajectory of pc=1
outfile = tempfile()
a <- mktrj(pc.xray, file = outfile)
outfile

detach(transducin)


##- NMA example
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Visualize modes
outfile = file.path(tempdir(), "mode_7.pdb")
mktrj(modes, mode=7, pdb=pdb, file = outfile)
outfile

}
}
\keyword{ utilities }

\name{read.crd}
\alias{read.crd}
\title{ Read Coordinate Data from Amber or Charmm }
\description{
  Read a CHARMM CARD (CRD) or AMBER coordinate file.
}
\usage{
read.crd(file, ...)
}
\arguments{
  \item{file}{ the name of the coordinate file to be read.  }
  \item{\dots}{ additional arguments passed to the methods
    \code{read.crd.charmm} or \code{read.crd.amber}. }
}
\details{
  \code{read.crd} is a generic function calling the corresponding function
  determined by the class of the input argument \code{x}. Use
  \code{methods("read.crd")} to get all the methods for \code{read.crd}
  generic:

  \code{\link{read.crd.charmm}} will be used for file extension
  \sQuote{.crd}.

  \code{\link{read.crd.amber}} will be used for file extension
  \sQuote{.rst} or \sQuote{.inpcrd}.

  See examples for each corresponding function for more details.
}
\value{
  See the \sQuote{value} section for the corresponding functions for
  more details.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant and Lars Skjaerven}
\seealso{
  \code{\link{read.crd.amber}}, \code{\link{read.crd.charmm}},
  \code{\link{write.crd}}, \code{\link{read.prmtop}},
  \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{atom.select}},
  \code{\link{read.dcd}}, \code{\link{read.ncdf}} }
\examples{
\dontrun{
## Read a PRMTOP file
prmtop <- read.prmtop(system.file("examples/crambin.prmtop", package="bio3d"))
print(prmtop)

## Read a Amber CRD file
crds <- read.crd(system.file("examples/crambin.inpcrd", package="bio3d"))

## Atom selection
ca.inds <- atom.select(prmtop, "calpha")

## Convert to PDB format
pdb <- as.pdb(prmtop, crds, inds=ca.inds)
}
}
\keyword{ IO }

\name{get.seq}
\alias{get.seq}
\title{ Download FASTA Sequence Files }
\description{
  Downloads FASTA sequence files from the NCBI nr, SWISSPROT/UNIPROT,
  OR RCSB PDB databases.
}
\usage{
get.seq(ids, outfile = "seqs.fasta", db = "nr", verbose = FALSE)
}
\arguments{
  \item{ids}{ A character vector of one or more appropriate database
    codes/identifiers of the files to be downloaded. }
  \item{outfile}{ A single element character vector specifying the name
    of the local file to which sequences will be written. }
  \item{db}{ A single element character vector specifying the database
    from which sequences are to be obtained. }
  \item{verbose}{ logical, if TRUE URL details of the download process
    are printed. }
}
\details{
  This is a basic function to automate sequence file download from the 
  databases including NCBI nr, SWISSPROT/UNIPROT, and RCSB PDB.
}
\value{
  If all files are successfully downloaded a list object with two
  components is returned:
  \item{ali }{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{ids }{ sequence names as identifiers.}
  This is similar to that returned by \code{\link{read.fasta}}. However,
  if some files were not successfully downloaded then a vector detailing
  which ids were not found is returned.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{  
  For a description of FASTA format see:
  \url{https://www.ncbi.nlm.nih.gov/BLAST/blastcgihelp.shtml}.
  When reading alignment files, the dash \sQuote{-} is interpreted as
  the gap character.
}
\seealso{ \code{\link{blast.pdb}}, \code{\link{read.fasta}},
  \code{\link{read.fasta.pdb}}, \code{\link{get.pdb}}
}
\examples{
\dontrun{
## Sequence identifiers (GI or PDB codes e.g. from blast.pdb etc.)
get.seq( c("P01112", "Q61411", "P20171") )

#aa <-get.seq( c("4q21", "5p21") )
#aa$id
#aa$ali
}
}
\keyword{ IO }
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gnm.R, R/gnm.pdbs.R
\name{gnm}
\alias{gnm}
\alias{gnm.pdb}
\alias{gnm.pdbs}
\title{Gaussian Network Model}
\usage{
gnm(x, ...)

\method{gnm}{pdb}(x, inds = NULL, temp = 300, keep = NULL,
  outmodes = NULL, gamma = 1, cutoff = 8, check.connect = TRUE, ...)

\method{gnm}{pdbs}(x, fit = TRUE, full = FALSE, subspace = NULL,
  rm.gaps = TRUE, gc.first = TRUE, ncore = NULL, ...)
}
\arguments{
\item{x}{an object of class \code{pdb} as obtained from function \code{\link{read.pdb}}.}

\item{...}{(in \code{gnm.pdbs}) additional arguments passed to \code{gnm.pdb}.}

\item{inds}{atom and xyz coordinate indices obtained from \code{\link{atom.select}} that 
selects the elements of \code{pdb} upon which the calculation should be based. 
If not provided the function will attempt to select all calpha atoms automatically.}

\item{temp}{numerical, temperature for which the amplitudes for scaling the atomic 
displacement vectors are calculated. Set \sQuote{temp=NULL} to avoid scaling.}

\item{keep}{numerical, final number of modes to be stored. Note that all subsequent analyses 
are limited to this subset of modes. This option is useful for very large structures and 
cases where memory may be limited.}

\item{outmodes}{atom indices as obtained from \code{\link{atom.select}} specifying the atoms 
to include in the resulting mode object.}

\item{gamma}{numerical, global scale of the force constant.}

\item{cutoff}{numerical, distance cutoff for pair-wise interactions.}

\item{check.connect}{logical, if TRUE check chain connectivity.}

\item{fit}{logical, if TRUE C-alpha coordinate based superposition is 
performed prior to normal mode calculations.}

\item{full}{logical, if TRUE return the complete, full structure,
\sQuote{nma} objects.}

\item{subspace}{number of eigenvectors to store for further analysis.}

\item{rm.gaps}{logical, if TRUE obtain the hessian matrices for only
atoms in the aligned positions (non-gap positions in all aligned
structures). Thus, gap positions are removed from output.}

\item{gc.first}{logical, if TRUE will call gc() first before mode calculation
for each structure. This is to avoid memory overload when 
\code{ncore > 1}.}

\item{ncore}{number of CPU cores used to do the calculation.}
}
\value{
Returns an object of class \sQuote{gnm} with the following components:
   \item{force.constants}{ numeric vector containing the force constants corresponding 
      to each mode. }
   \item{fluctuations}{ numeric vector of atomic fluctuations. }
   \item{U}{ numeric matrix with columns containing the raw eigenvectors. }
   \item{L}{ numeric vector containing the raw eigenvalues. }
   \item{xyz}{ numeric matrix of class \code{xyz} containing the Cartesian coordinates 
      in which the calculation was performed. }
   \item{temp}{ numerical, temperature for which the amplitudes for scaling the atomic 
      displacement vectors are calculated. }
   \item{triv.modes}{ number of trivial modes. }
   \item{natoms}{ number of C-alpha atoms. }
   \item{call}{ the matched call. }
}
\description{
Perform Gaussian network model (GNM) based normal mode analysis (NMA) for 
a protein structure.
}
\details{
This function builds a Gaussian network model (an isotropic elastic network 
   model) for C-alpha atoms and performs subsequent normal mode analysis (NMA). 
   The model employs a distance cutoff for the network construction: Atom pairs with 
   distance falling  within the cutoff have a harmonic interaction with a uniform force constant; 
   Otherwise atoms have no interaction. Output contains N-1 (N, the number of residues) 
   non-trivial modes (i.e. the degree of freedom is N-1), which can then be used to 
   calculate atomic fluctuations and covariance.
}
\examples{
   ## Fetch stucture
   pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
   
   ## Calculate normal modes
   modes <- gnm(pdb)
   
   ## Print modes
   print(modes)
   
   ## Plot modes
   plot(modes)

}
\author{
Xin-Qiu Yao & Lars Skjaerven
}
\references{
Bahar, I. et al. (1997) \emph{Folding Des.} \bold{2}, 173.
}
\seealso{
\code{\link{gnm.pdbs}}
}

\name{pdb2aln}
\alias{pdb2aln}
\title{ Align a PDB structure to an existing alignment }
\description{
  Extract sequence from a PDB object and align it to 
  an existing multiple sequence alignment that you wish 
  keep intact.
}
\usage{
pdb2aln(aln, pdb, id="seq.pdb", aln.id=NULL, file="pdb2aln.fa", \dots)
}
\arguments{
  \item{aln}{ an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}},
    \code{\link{read.fasta.pdb}}, and \code{\link{seqaln}}. }
  \item{pdb}{ the PDB object to be added to \code{aln}. }
  \item{id}{ name for the PDB sequence in the generated new alignment. }
  \item{aln.id}{ id of the sequence in \code{aln} that is close to the 
     sequence from \code{pdb}. }
  \item{file}{ output file name for writing the generated new alignment. }
  \item{\dots}{ additional arguments passed to \code{\link{seqaln}}. }
}
\details{
  The basic effect of this function is to add a PDB sequence to an existing
  alignement. In this case, the function is simply a wrapper of 
  \code{\link{seq2aln}}.

  The more advanced (and also more useful) effect is giving complete mappings
  from the column indices of the original alignment (\code{aln$ali}) to 
  atomic indices of equivalent C-alpha atoms in the \code{pdb}. These mappings
  are stored in the output list (see below 'Value' section). This feature
  is better illustrated in the function \code{\link{pdb2aln.ind}}, which 
  calls \code{pdb2aln} and directly returns atom selections given a set of 
  alignment positions. (See \code{\link{pdb2aln.ind}} for details. ) 

  When \code{aln.id} is provided, the function will do pairwise alignment 
  between the sequence from \code{pdb} and the sequence in \code{aln} 
  with id matching \code{aln.id}. This is the best way to use the
  function if the protein has an identical or very similar sequence 
  to one of the sequences in \code{aln}.
}
\value{
  Return a list object of the class 'fasta' containing three components:
  \item{id}{ sequence names as identifers.}
  \item{ali}{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{ref}{ an integer 2xN matrix, where N is the number of columns of
    the new alignment \code{ali}. The first row contains the column indices of 
    the original alignment \code{aln$ali}. The second row contains atomic 
    indices of equivalent C-alpha atoms in \code{pdb}. Gaps in the new 
    alignement are indicated by NAs. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao & Barry Grant }
\seealso{ \code{\link{seqaln}}, \code{\link{seq2aln}}, 
   \code{\link{seqaln.pair}}, \code{\link{pdb2aln.ind}}}
\examples{
\dontrun{
##--- Read aligned PDB coordinates (CA only)
aln  <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
pdbs <- read.fasta.pdb(aln)

##--- Read PDB coordinate for a new structure (all atoms)
id <- get.pdb("2kin", URLonly=TRUE)
pdb <- read.pdb(id)

# add pdb to the alignment 
naln <- pdb2aln(aln=pdbs, pdb=pdb, id=id)
naln

}

}
\keyword{ utilities }

\name{bwr.colors}
\alias{bwr.colors}
\alias{mono.colors}
\title{ Color Palettes }
\description{
  Create a vector of \sQuote{n} \dQuote{contiguous} colors forming
  either a Blue-White-Red or a White-Gray-Black color palette.
}
\usage{
bwr.colors(n)
mono.colors(n)
}
\arguments{
  \item{n}{ the number of colors in the palette (>=1). }
}
\details{
  The function \code{bwr.colors} returns a vector of \code{n} color
  names that range from blue through white to red.
  
  The function \code{mono.colors} returns color names ranging from
  white to black.  Note: the first element of the returned vector
  will be NA. 
}
\value{
  Returns a character vector, \code{cv}, of color names.  This can be
  used either to create a user-defined color palette for subsequent
  graphics with \code{palette(cv)}, or as a \code{col=} specification in
  graphics functions and \code{par}.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  The \code{bwr.colors} function is derived from the \code{gplots}
  package function \code{colorpanel} by Gregory R. Warnes.
}
\author{ Barry Grant }
\seealso{ \code{\link{vmd_colors}}, \code{\link{cm.colors}},
  \code{\link{colors}}, \code{\link{palette}}, \code{\link{hsv}},
  \code{\link{rgb}}, \code{\link{gray}}, \code{\link{col2rgb}}
}
\examples{
\donttest{
# Redundant testing excluded

# Color a distance matrix
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
d <- dm(pdb,"calpha")

plot(d, color.palette=bwr.colors)

plot(d,
     resnum.1 = pdb$atom[pdb$calpha,"resno"],
     color.palette = mono.colors,
     xlab="Residue Number", ylab="Residue Number")
}
}
\keyword{ utilities }

\name{pdbs2sse}
\alias{pdbs2sse}
\title{ SSE annotation for a PDBs Object }
\description{
  Returns secondary structure element (SSE) annotation (\code{"sse"} object) for a structure in the provided \code{"pdbs"} object.
}
\usage{
pdbs2sse(pdbs, ind = NULL, rm.gaps = TRUE, resno = TRUE, pdb = FALSE, \dots)
}
\arguments{
  \item{pdbs}{ a list of class \code{"pdbs"} containing PDB file
    data, as obtained from \code{read.fasta.pdb} or
    \code{pdbaln}. }
  \item{ind}{ numeric index pointing to the PDB in which the SSE should
    be provided. If \code{ind=NULL}, then the consensus SSE is returned. }
  \item{rm.gaps}{ logical, if TRUE SSEs spanning gap containing columns are
    omitted from the output in the resulting \code{sse} object. }
  \item{resno}{ logical, if TRUE output is in terms of residue numbers
    rather than residue index (position in sequence). }
  \item{pdb}{ logical, if TRUE function \code{dssp} will be called on
    the corresponding \code{pdb} object rather than to use \code{pdbs$sse} to
    obtain the SSE object. }
   \item{\dots}{ arguments passed to function \code{dssp}. }
}
\details{
  This function provides a \code{"sse"} list object containing
  secondary structure elements (SSE) annotation data for a particular
  structure in the provided \code{"pdbs"} object. Residue numbers are
  provided relative to the alignment in the \code{"pdbs"} object.

  When \code{ind=NULL} the function will attemt to return the consensus
  SSE annotation, i.e. where there are SSEs across all structures. This
  will only work SSE data is found in the \code{"pdbs"} object.

  See examples for more details.
}
\value{
  Returns a list object of class \code{sse}.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{dssp}}, \code{\link{pdbaln}},
  \code{\link{read.fasta.pdb}}. }
\examples{
\dontrun{
attach(transducin)

## calculate RMSF
rf <- rmsf(pdbs$xyz)

## Fetch SSE annotation, output in terms of alignment index
sse <- pdbs2sse(pdbs, ind=1, rm.gaps=FALSE, resno=FALSE)

## Add SSE annotation to plot
plotb3(rf, sse=sse)


## Calculate RMSF only for non-gap columns
gaps.pos <- gap.inspect(pdbs$xyz)
rf <- rmsf(pdbs$xyz[, gaps.pos$f.inds])

## With gap columns removed, output in terms of residue number
sse <- pdbs2sse(pdbs, ind=1, rm.gaps=TRUE, resno=TRUE)
gaps.res <- gap.inspect(pdbs$ali)
plotb3(rf, sse=sse, resno=pdbs$resno[1, gaps.res$f.inds])

detach(transducin)
}
}
\keyword{ utilities }

\name{cat.pdb}
\alias{cat.pdb}
\title{ Concatenate Multiple PDB Objects }
\description{
  Produce a new concatenated PDB object from two or more smaller PDB objects.
}
\usage{
cat.pdb(\dots, renumber=FALSE, rechain=TRUE)
}
\arguments{
  \item{\dots}{ two or more PDB structure objects obtained from
    \code{\link{read.pdb}}. }
  \item{renumber}{ logical, if \sQuote{TRUE} residues will be
    renumbered. }
  \item{rechain}{ logical, if \sQuote{TRUE} molecules will be assigned
    new chain identifiers. }
}
\details{
  This is a basic utility function for creating a concatenated PDB
  object based on multipe smaller PDB objects. 
}
\value{
  Returns an object of class \code{"pdb"}. See \code{\link{read.pdb}} for
  further details. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}},
  \code{\link{write.pdb}}, \code{\link{trim.pdb}} }
\examples{
\dontrun{
## Read a PDB file from the RCSB online database
pdb1 <- read.pdb("1etl")
pdb2 <- read.pdb("1hel")

## Concat
new.pdb <- cat.pdb(pdb1, pdb2, pdb1, rechain=TRUE, renumber=TRUE)

## Write to file
write.pdb(new.pdb, file="concat.pdb")
}
}
\keyword{ utilities }

\name{read.fasta.pdb}
\alias{read.fasta.pdb}
\title{ Read Aligned Structure Data }
\description{
  Read aligned PDB structures and store their C-alpha atom data, including xyz
  coordinates, residue numbers, residue type and B-factors.
}
\usage{
read.fasta.pdb(aln, prefix = "", pdbext = "", fix.ali = FALSE,
             pdblist=NULL, ncore = 1, nseg.scale = 1, progress = NULL, ...)
}
\arguments{
  \item{aln}{ an alignment data structure obtained with
    \code{\link{read.fasta}}. }
  \item{prefix}{ prefix to aln$id to locate PDB files. }
  \item{pdbext}{ the file name extention of the PDB files. }
  \item{fix.ali}{ logical, if TRUE check consistence between \code{$ali} 
    and \code{$resno}, and correct \code{$ali} if they don't match. }
  \item{pdblist}{ an optional list of \code{pdb} objects with sequence
    corresponding to the alignments in \code{aln}. Primarily used
    through function \code{pdbaln} when the PDB objects already exists
    (avoids reading PDBs from file). }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
  \item{progress}{ progress bar for use with shiny web app. }
  \item{\dots}{ other parameters for \code{\link{read.pdb}}. }  
}
\details{
  The input \code{aln}, produced with \code{\link{read.fasta}}, must
  have identifers (i.e. sequence names) that match the PDB file
  names. For example the sequence corresponding to the structure
  \dQuote{1bg2.pdb} should have the identifer \sQuote{1bg2}. See
  examples below.
  
  Sequence miss-matches will generate errors.  Thus, care should be taken
  to ensure that the sequences in the alignment match the sequences in
  their associated PDB files.
}
\value{
  Returns a list of class \code{"pdbs"} with the following five
  components:
  \item{xyz}{numeric matrix of aligned C-alpha coordinates.}
  \item{resno}{character matrix of aligned residue numbers.}
  \item{b}{numeric matrix of aligned B-factor values.}
  \item{chain}{character matrix of aligned chain identifiers.}
  \item{id}{character vector of PDB sequence/structure names.}
  \item{ali}{character matrix of aligned sequences.}
  \item{resid}{character matrix of aligned 3-letter residue names.}
  \item{sse}{character matrix of aligned helix and strand secondary
    structure elements as defined in each PDB file.}  
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
   The sequence character \sQuote{X} is useful for masking unusual
   or unknown residues, as it can match any other residue type.
}
\seealso{
  \code{\link{read.fasta}}, \code{\link{read.pdb}},
  \code{\link{core.find}}, \code{\link{fit.xyz}},
  \code{\link{read.all}}, \code{\link{pymol.pdbs}}  }
\examples{
\donttest{
# Redundant testing excluded

# Read sequence alignment
file <- system.file("examples/kif1a.fa",package="bio3d")
aln  <- read.fasta(file)

# Read aligned PDBs
pdbs <- read.fasta.pdb(aln)

# Structure/sequence names/ids
basename( pdbs$id )

# Alignment positions 335 to 339
pdbs$ali[,335:339]
pdbs$resid[,335:339]
pdbs$resno[,335:339]
pdbs$b[,335:339]

# Alignment C-alpha coordinates for these positions
pdbs$xyz[, atom2xyz(335:339)]

# See 'fit.xyz()' function for actual coordinate superposition
#  e.g. fit to first structure
# xyz <- fit.xyz(pdbs$xyz[1,], pdbs)
# xyz[, atom2xyz(335:339)]

}
}
\keyword{ IO }

\name{bio3d-package}
\alias{bio3d-package}
\alias{bio3d}
\docType{package}
\title{ Biological Structure Analysis }
\description{
Utilities for the analysis of protein structure and sequence data.
}
\details{
\tabular{ll}{
Package: \tab bio3d\cr
Type: \tab Package\cr
Version: \tab 2.4-4\cr
Date: \tab 2022-10-20\cr
License: \tab GPL version 2 or newer\cr
URL: \tab \url{http://thegrantlab.org/bio3d/}\cr
}

Features include the ability to read and write structure
(\code{\link{read.pdb}},  \code{\link{write.pdb}},
\code{\link{read.fasta.pdb}}),  sequence (\code{\link{read.fasta}},
\code{\link{write.fasta}}) and dynamics trajectory data
(\code{\link{read.dcd}}, \code{\link{read.ncdf}}, \code{\link{write.ncdf}}).

Perform sequence and structure database searches (\code{\link{blast.pdb}},
\code{\link{hmmer}}), atom summaries (\code{\link{summary.pdb}}),  atom selection
(\code{\link{atom.select}}), alignment (\code{\link{pdbaln}},  \code{\link{seqaln}},
\code{\link{mustang}}) superposition (\code{\link{rot.lsq}},  \code{\link{fit.xyz}}),
\code{\link{pdbfit}}), rigid core identification (\code{\link{core.find}},  \code{\link{plot.core}},
\code{\link{fit.xyz}}), dynamic domain analysis (\code{\link{geostas}}), torsion/dihedral analysis
(\code{\link{torsion.pdb}},  \code{\link{torsion.xyz}}), clustering (via
\code{\link{hclust}}), principal component analysis
(\code{\link{pca.xyz}},  \code{\link{pca.pdbs}}, \code{\link{pca.tor}},  \code{\link{plot.pca}},
\code{\link{plot.pca.loadings}},  \code{\link{mktrj.pca}}), dynamical
cross-correlation analysis (\code{\link{dccm}}, \code{\link{plot.dccm}}) and correlation network analysis (\code{\link{cna}},  \code{\link{plot.cna}}, \code{\link{cnapath}}) of structure data.

Perform conservation analysis of sequence (\code{\link{seqaln}}, \code{\link{conserv}},
\code{\link{seqidentity}},  \code{\link{entropy}},  \code{\link{consensus}})
and structural (\code{\link{pdbaln}}, \code{\link{rmsd}},
\code{\link{rmsf}}, \code{\link{core.find}}) data.

Perform normal mode analysis (\code{\link{nma}}, \code{\link{build.hessian}}), ensemble normal
mode analysis (\code{\link{nma.pdbs}}), mode comparison
(\code{\link{rmsip}}) and (\code{\link{overlap}}), atomic fluctuation
prediction (\code{\link{fluct.nma}}), cross-correlation analysis
(\code{\link{dccm.nma}}), cross-correlation visualization (\code{\link{pymol.dccm}}),
deformation analysis (\code{\link{deformation.nma}}), and mode visualization
(\code{\link{pymol.modes}}, \code{\link{mktrj.nma}}).

In addition, various utility functions are provided to facilitate
manipulation and analysis of biological sequence and structural data
(e.g. \code{\link{get.pdb}}, \code{\link{get.seq}}, \code{\link{aa123}},
\code{\link{aa321}}, \code{\link{pdbseq}}, \code{\link{aln2html}}, \code{\link{atom.select}},
\code{\link{rot.lsq}},  \code{\link{fit.xyz}}, \code{\link{is.gap}}, \code{\link{gap.inspect}},
\code{\link{orient.pdb}}, \code{\link{pairwise}}, \code{\link{plot.bio3d}}, \code{\link{plot.nma}}, \code{\link{plot.blast}}, \code{\link{biounit}}, etc.).
}
\note{
The latest version, package vignettes and documentation with worked example
outputs can be obtained from the bio3d website:\cr
\url{http://thegrantlab.org/bio3d/}.\cr
\url{http://thegrantlab.org/bio3d/reference/}.\cr
\url{https://bitbucket.org/Grantlab/bio3d/}.
}
\author{
Barry Grant <bjgrant@ucsd.edu>
Xin-Qiu Yao <xinqiu.yao@gmail.com>
Lars Skjaerven <larsss@gmail.com>
Julien Ide <julien.ide.fr@gmail.com>
}
\references{
Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
Grant, B.J. et al. (2021) \emph{Protein Science} \bold{30}, 20--30.
}
\keyword{ documentation }
\examples{
help(package="bio3d")     # list the functions within the package
#lbio3d()                  # list bio3d function names only

## Or visit:
##   http://thegrantlab.org/bio3d/reference/

## See the individual functions for further documentation and examples, e.g.
#help(read.pdb)

## Or online:
##    http://thegrantlab.org/bio3d/reference/read.pdb.html

\dontrun{
##-- See the list of Bio3D demos
demo(package="bio3d")

## Try some out, e.g:
demo(pdb) # PDB Reading, Manipulation, Searching and Alignment
demo(pca) # Principal Component Analysis
demo(md)  # Molecular Dynamics Trajectory Analysis
demo(nma) # Normal Mode Analysis

## See package vignettes and tutorals online:
##   http://thegrantlab.org/bio3d/articles/
}
}

\name{plot.hmmer}
\alias{plot.hmmer}
\title{ Plot a Summary of HMMER Hit Statistics. }
\description{
  Produces a number of basic plots that should facilitate hit selection
  from the match statistics of a HMMER result.
}
\usage{
 \method{plot}{hmmer}(x, ...)
}
\arguments{
  \item{x}{ HMMER results as obtained from the function
    \code{\link{hmmer}}. }
  \item{\dots}{ arguments passed to \code{\link{plot.blast}}. }
}
\details{
  See \code{\link{plot.blast}} for details. 
}
\value{
  Produces a plot on the active graphics device and returns a three
  component list object:
  \item{hits}{ an ordered matrix detailing the subset of hits with a normalized
    score above the chosen cutoff. Database identifiers are listed along
    with their cluster group number. }
  \item{acc}{ a character vector containing the database accession identifier of
    each hit above the chosen threshold. }
  \item{pdb.id}{ a character vector containing the database accession identifier of
    each hit above the chosen threshold. }
  \item{inds}{ a numeric vector containing the indices of the hits
               relative to the input hmmer object.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant, Lars Skjaerven }
\seealso{ \code{\link{hmmer}}, \code{\link{blast.pdb}} }
\examples{
\dontrun{
# HMMER server connection required - testing excluded

##- PHMMER
seq <- get.seq("2abl_A", outfile = tempfile())
res <- hmmer(seq, db="pdb")
plot.hmmer(res)

}
}
\keyword{ hplot }

\name{sip}
\alias{sip}
\alias{sip.default}
\alias{sip.nma}
\alias{sip.enma}
\title{ Square Inner Product }
\description{
  Calculate the correlation between two atomic fluctuation vectors.
}
\usage{
sip(...)

\method{sip}{nma}(a, b, ...)

\method{sip}{enma}(enma, ncore=NULL, ...)

\method{sip}{default}(v, w, ...)
}
\arguments{
  \item{enma}{ an object of class \code{"enma"} obtained from function
    \code{nma.pdbs}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{a}{ an \sQuote{nma} object as object from function \code{nma} to
    be compared to \code{b}. }
  \item{b}{ an \sQuote{nma} object as object from function \code{nma} to
    be compared to \code{a}. }
  \item{v}{ a numeric vector containing the atomic fluctuation values. }
  \item{w}{ a numeric vector containing the atomic fluctuation values. }
  \item{\dots}{ arguments passed to associated functions. }
}
\details{
  SIP is a measure for the similarity of atomic fluctuations of two
  proteins, e.g. experimental b-factors, theroetical RMSF values, or 
  atomic fluctuations obtained from NMA.
}
\value{
  Returns the similarity coefficient(s).
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
  Fuglebakk, E. et al. (2013) \emph{JCTC} \bold{9}, 5618--5628.
}
\author{ Lars Skjaerven }
\seealso{Other similarity measures:
  \code{\link{covsoverlap}}, \code{\link{bhattacharyya}},
  \code{\link{rmsip}}.
}
\examples{

pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
a <- nma(pdb)
b <- nma(pdb, ff="anm")

sip(a$fluctuations, b$fluctuations)

}
\keyword{ utilities }

\name{consensus}
\alias{consensus}
\title{ Sequence Consensus for an Alignment }
\description{
  Determines the consensus sequence for a given alignment at a given
  identity cutoff value.
}
\usage{
  consensus(alignment, cutoff = 0.6)
}
\arguments{
  \item{alignment}{ an \code{alignment} object created by the
    \code{\link{read.fasta}} function or an alignment character matrix. }
  \item{cutoff}{ a numeric value beteen 0 and 1, indicating the minimum
    sequence identity threshold for determining a consensus amino acid.
    Default is 0.6, or 60 percent residue identity. }
}
\value{
  A vector containing the consensus sequence, where \sQuote{-} represents
  positions with no consensus (i.e. under the \code{cutoff})
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.fasta}} }
\examples{

#-- Read HIV protease alignment
aln <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))

# Generate consensus
con <- consensus(aln)
print(con$seq)

# Plot residue frequency matrix
##png(filename = "freq.png", width = 1500, height = 780)
col <- mono.colors(32)
aa  <- rev(rownames(con$freq))

image(x=1:ncol(con$freq),
      y=1:nrow(con$freq),
      z=as.matrix(rev(as.data.frame(t(con$freq)))),
      col=col, yaxt="n", xaxt="n",
      xlab="Alignment Position", ylab="Residue Type")

# Add consensus along the axis
axis(side=1, at=seq(0,length(con$seq),by=5))
axis(side=2, at=c(1:22), labels=aa)
axis(side=3, at=c(1:length(con$seq)), labels =con$seq)
axis(side=4, at=c(1:22), labels=aa)
grid(length(con$seq), length(aa))
box()

# Add consensus sequence
for(i in 1:length(con$seq)) {
  text(i, which(aa==con$seq[i]),con$seq[i],col="white")
}

# Add lines for residue type separation
abline(h=c(2.5,3.5, 4.5, 5.5, 3.5, 7.5, 9.5,
         12.5, 14.5, 16.5, 19.5), col="gray")


}

\keyword{ utilities }

\name{write.mol2}
\alias{write.mol2}
\title{ Write MOL2 Format Coordinate File }
\description{
  Write a Sybyl MOL2 file
}
\usage{
write.mol2(mol, file = "R.mol2",  append = FALSE)
}
\arguments{
  \item{mol}{ a MOL2 structure object obtained from
    \code{\link{read.mol2}}. }
  \item{file}{ the output file name. }
  \item{append}{ logical, if TRUE output is appended to the bottom of an
    existing file (used primarly for writing multi-model files). }
}
\details{
  See examples for further details.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{
  Lars Skjaerven
}
\examples{
\donttest{
# Read MOL2 file
mol <- read.mol2( system.file("examples/aspirin.mol2", package="bio3d") )

# Trim away H-atoms
mol <- trim(mol, "noh")

# Write new MOL2 file
#write.mol2(mol)
}
}
\keyword{ IO }

\name{chain.pdb}
\alias{chain.pdb}
\title{ Find Possible PDB Chain Breaks }
\description{
  Find possible chain breaks based on connective Calpha or peptide
  bond (C-N) atom separation.
}
\usage{
chain.pdb(pdb, ca.dist = 4, bond=TRUE, bond.dist=1.5, blank = "X", rtn.vec = TRUE)
}
\arguments{
  \item{pdb}{ a PDB structure object obtained from
    \code{\link{read.pdb}}. }
  \item{ca.dist}{ the maximum distance that separates Calpha atoms
    considered to be in the same chain. }
  \item{bond}{ logical, if TRUE inspect peptide bond (C-N) instead
    of Calpha-Calpha distances whenever possible.}
  \item{bond.dist}{ cutoff value for C-N distance separation. }
  \item{blank}{ a character to assign non-protein atoms. }
  \item{rtn.vec}{ logical, if TRUE then the one-letter chain vector
    consisting of the 26 upper-case letters of the Roman alphabet is
    returned. }
}
\details{
  This is a basic function for finding possible chain breaks in PDB
  structure files, i.e. connective Calpha atoms that are further than
  \code{ca.dist} apart or peptide bond (C-N) atoms separated by at 
  least \code{bond.dist}.
}
\value{
  Prints basic chain information and if \code{rtn.vec} is TRUE returns a
  character vector of chain ids consisting of the 26 upper-case letters of the
  Roman alphabet plus possible \code{blank} entries for non-protein atoms.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}  
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}}, \code{\link{trim.pdb}},
  \code{\link{write.pdb}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

full.pdb <- read.pdb( get.pdb("5p21", URLonly=TRUE) )
inds <- atom.select(full.pdb, resno=c(10:20,30:33))
cut.pdb <- trim.pdb(full.pdb, inds)
chain.pdb(cut.pdb)
}
}
\keyword{ utilities }

\name{filter.identity}
\alias{filter.identity}
\title{ Percent Identity Filter }
\description{
  Identify and filter subsets of sequences at a given sequence identity cutoff.
}
\usage{
filter.identity(aln = NULL, ide = NULL, cutoff = 0.6, verbose = TRUE, \dots)
}
\arguments{
  \item{aln}{ sequence alignment list, obtained from
    \code{\link{seqaln}} or \code{\link{read.fasta}}, or an alignment
    character matrix. Not used if \sQuote{ide} is given.}
  \item{ide}{ an optional identity matrix obtained from
    \code{\link{seqidentity}}. }
  \item{cutoff}{ a numeric identity cutoff value ranging between 0 and 1. }
  \item{verbose}{ logical, if TRUE print details of the clustering
    process. }
  \item{\dots}{ additional arguments passed to and from functions. } 
}
\details{
  This function performs hierarchical cluster analysis of a given sequence
  identity matrix \sQuote{ide}, or the identity matrix calculated from a given
  alignment \sQuote{aln}, to identify sequences that fall below a given
  identity cutoff value \sQuote{cutoff}.  
}
\value{
  Returns a list object with components:
  \item{ind}{indices of the sequences below the cutoff value.}
  \item{tree}{an object of class \code{"hclust"}, which describes the
    tree produced by the clustering process. }
  \item{ide}{a numeric matrix with all pairwise identity values.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.fasta}}, \code{\link{seqaln}},
  \code{\link{seqidentity}}, \code{\link{entropy}}, \code{\link{consensus}} }
\examples{
attach(kinesin)

ide.mat <- seqidentity(pdbs)

# Histogram of pairwise identity values
op <- par(no.readonly=TRUE)
par(mfrow=c(2,1))
hist(ide.mat[upper.tri(ide.mat)], breaks=30,xlim=c(0,1),
     main="Sequence Identity", xlab="Identity")

k <- filter.identity(ide=ide.mat, cutoff=0.6)
ide.cut <- seqidentity(pdbs$ali[k$ind,])
hist(ide.cut[upper.tri(ide.cut)], breaks=10, xlim=c(0,1),
     main="Sequence Identity", xlab="Identity")

#plot(k$tree, axes = FALSE, ylab="Sequence Identity")
#print(k$ind) # selected
par(op)
detach(kinesin)
}
\keyword{ utilities }

\name{aa.table}
\alias{aa.table}
\docType{data}
\title{ Table of Relevant Amino Acids }
\description{
  This data set provides the atomic masses of a selection of amino
  acids regularly occuring in proteins. 
}
\usage{
aa.table
}
\format{
  A data frame with the following components.
  \describe{
    \item{\code{aa3}}{a character vector containing three-letter amino
      acid code.}
    \item{\code{aa1}}{a character vector containing one-letter amino
      acid code.}
    \item{\code{mass}}{a numeric vector containing the mass of the
      respective amino acids. }
    \item{\code{formula}}{a character vector containing the formula of
      the amino acid in which the mass calculat was based. }
    \item{\code{name}}{a character vector containing the full names of
      the respective amino acids. }
  }
}
\seealso{
  \code{\link{aa2mass}}, \code{\link{aa.index}},
  \code{\link{atom.index}}, \code{\link{elements}}, 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\examples{
data(aa.table)
aa.table

## table look up
aa.table["HIS", ]

## read PDB, and fetch residue masses
pdb <- read.pdb(system.file("examples/1hel.pdb", package="bio3d"))
aa2mass(pdb)
}
\keyword{datasets}

\name{aln2html}
\alias{aln2html}
\title{ Create a HTML Page For a Given Alignment }
\description{
  Renders a sequence alignment as coloured HTML suitable for viewing
  with a web browser.
}
\usage{
aln2html(aln, file="alignment.html", Entropy=0.5, append=TRUE,
         caption.css="color: gray; font-size: 9pt",
         caption="Produced by <a href=http://thegrantlab.org/bio3d/>Bio3D</a>",
         fontsize="11pt", bgcolor=TRUE, colorscheme="clustal")
}
\arguments{
  \item{aln}{  an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}}. }
  \item{file}{  name of output html file.  }
  \item{Entropy}{ conservation \sQuote{cuttoff} value below which
    alignment columns are not coloured. }
  \item{append}{ logical, if TRUE output will be appended to
    \code{file}; otherwise, it will overwrite the contents of
    \code{file}. }
  \item{caption.css}{ a character string of css options for rendering
    \sQuote{caption} text. }
  \item{caption}{ a character string of text to act as a caption. }
  \item{fontsize}{ the font size for alignment characters. }
  \item{bgcolor}{ background colour. }
  \item{colorscheme}{ conservation colouring scheme, currently only
    \dQuote{clustal} is supported with alternative arguments resulting
    in an entropy shaded alignment.}
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
 }
\author{ Barry Grant }
\note{
  Your web browser should support style sheets.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{write.fasta}}, \code{\link{seqaln}} }
\examples{
\dontrun{
## Read an example alignment
aln <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))

## Produce a HTML file for this alignment
aln2html(aln, append=FALSE, file=file.path("eg.html"))
aln2html(aln, colorscheme="ent", file="eg.html")
## View/open the file in your web browser
#browseURL("eg.html")
}
}
\keyword{ IO }

\name{plot.core}
\alias{plot.core}
\title{ Plot Core Fitting Progress }
\description{
  Plots the total ellipsoid volume of core positions versus core size at
  each iteration of the core finding process.
}
\usage{
\method{plot}{core}(x, y = NULL, type = "h", main = "", sub = "", 
   xlim = NULL, ylim = NULL, xlab = "Core Size (Number of Residues)", 
   ylab = "Total Ellipsoid Volume (Angstrom^3)", axes = TRUE, 
   ann = par("ann"), col = par("col"), ...)
}
\arguments{
  \item{x}{  a list object obtained with the function
    \code{\link{core.find}} from which the \sQuote{volume}
    component is taken as the x coordinates for the plot. }
  \item{y}{ the y coordinates for the plot. }
  \item{type}{ one-character string giving the type of plot desired. }
  \item{main}{ a main title for the plot, see also \sQuote{title}. }
  \item{sub}{ a sub-title for the plot. }
  \item{xlim}{ the x limits of the plot. }
  \item{ylim}{ the y limits of the plot. }
  \item{xlab}{ a label for the x axis. }
  \item{ylab}{ a label for the y axis. }
  \item{axes}{ a logical value indicating whether both axes should be drawn. }
  \item{ann}{ a logical value indicating whether the default annotation
    (title and x and y axis labels) should appear on the plot. }
  \item{col}{ The colors for lines and points.  Multiple colours can be
    specified so that each point is given its own color.  If there are
    fewer colors than points they are recycled in the standard fashion. }
  \item{\dots}{ extra plotting arguments. }
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  The produced plot can be useful for deciding on the core/non-core boundary.
}
\seealso{ \code{\link{core.find}}, \code{\link{print.core}}}
\examples{
\dontrun{

##-- Generate a small kinesin alignment and read corresponding structures
pdbfiles <- get.pdb(c("1bg2","2ncd","1i6i","1i5s"), URLonly=TRUE)
pdbs <- pdbaln(pdbfiles)

##-- Find 'core' positions
core <- core.find(pdbs)
plot(core)

##-- Fit on these relatively invarient subset of positions 
core.inds <- print(core)
xyz <- pdbfit(pdbs, core.inds, outpath="corefit_structures")

##-- Compare to fitting on all equivalent positions
xyz2 <- pdbfit(pdbs)

## Note that overall RMSD will be higher but RMSF will
##  be lower in core regions, which may equate to a
##  'better fit' for certain applications
gaps <- gap.inspect(pdbs$xyz)
rmsd(xyz[,gaps$f.inds])
rmsd(xyz2[,gaps$f.inds])

plot(rmsf(xyz[,gaps$f.inds]), typ="l", col="blue", ylim=c(0,9))
points(rmsf(xyz2[,gaps$f.inds]), typ="l", col="red")

}

}
\keyword{ hplot }

\name{write.pqr}
\alias{write.pqr}
\title{ Write PQR Format Coordinate File }
\description{
  Write a PQR file for a given \sQuote{xyz} Cartesian coordinate vector
  or matrix.
}
\usage{
write.pqr(pdb = NULL, xyz = pdb$xyz, resno = NULL, resid = NULL, eleno =
NULL, elety = NULL, chain = NULL, o = NULL, b = NULL,
append = FALSE, verbose = FALSE, chainter = FALSE, file = "R.pdb")
}
\arguments{
  \item{pdb}{ a PDB structure object obtained from
    \code{\link{read.pdb}} or \code{\link{read.pqr}}. }
  \item{xyz}{ Cartesian coordinates as a vector or 3xN matrix. }
  \item{resno}{ vector of residue numbers of length equal to
    length(xyz)/3. }
  \item{resid}{ vector of residue types/ids of length equal to
    length(xyz)/3. }
  \item{eleno}{ vector of element/atom numbers of length equal to
    length(xyz)/3. }
  \item{elety}{ vector of element/atom types of length equal to
    length(xyz)/3. }
  \item{chain}{ vector of chain identifiers with length equal to
    length(xyz)/3. }
  \item{o}{ atomic partial charge values of length equal to
    length(xyz)/3. }
  \item{b}{ atomic radii values of length equal to length(xyz)/3. }
  \item{append}{ logical, if TRUE output is appended to the bottom of an
    existing file (used primarly for writing multi-model files). }
  \item{verbose}{ logical, if TRUE progress details are printed. }
  \item{chainter}{ logical, if TRUE a TER line is inserted between
    chains. }
  \item{file}{ the output file name. }
}
\details{
  PQR file format is basically the same as PDB format except for the fields of 
  \code{o} and \code{b}. In PDB, these two fields are filled with \sQuote{Occupancy}
  and \sQuote{B-factor} values, respectively, with each field 6-column long. 
  In PQR, they are atomic \sQuote{partial charge} and \sQuote{radii} 
  values, respectively, with each field 8-column long.

  Only the \code{xyz} argument is strictly required.  Other arguments
  assume a default poly-ALA C-alpha structure with a blank chain id,
  atomic charge values of 0.00 and atomic radii equal to 1.00.
  
  If the input argument \code{xyz} is a matrix then each row is assumed
  to be a different structure/frame to be written to a
  \dQuote{multimodel} PDB file, with frames separated by \dQuote{END}
  records.
  
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{
  Barry Grant
  with contributions from Joao Martins.

}
\note{
  Check that:
  (1) \code{chain} is one character long e.g. \dQuote{A}, and 
  (2) \code{resno} and \code{eleno} do not exceed \dQuote{9999}.
}
\seealso{ \code{\link{read.pqr}}, \code{\link{read.pdb}}, 
  \code{\link{write.pdb}}, \code{\link{read.dcd}},
  \code{\link{read.fasta.pdb}}, \code{\link{read.fasta}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

# Read a PDB file
pdb <- read.pdb( "1bg2" )

# Write out in PQR format 
outfile = file.path(tempdir(), "eg.pqr")
write.pqr(pdb=pdb, file = outfile)

invisible( cat("\nSee the output file:", outfile, sep = "\n") )

}
}
\keyword{ IO }

\name{pca.tor}
\alias{pca.tor}
\title{ Principal Component Analysis }
\description{
   Performs principal components analysis (PCA) on torsion angle \code{data}.
 }
\usage{
\method{pca}{tor}(data, \dots)
}
\arguments{
  \item{data}{ numeric matrix of torsion angles with a row per structure. }
  \item{\dots}{ additional arguments passed to the method \code{pca.xyz}. }
}
\value{
  Returns a list with the following components:
  \item{L }{eigenvalues.}
  \item{U }{eigenvectors (i.e. the variable loadings).}
  \item{z.u }{scores of the supplied \code{data} on the pcs.}
  \item{sdev }{the standard deviations of the pcs.}
  \item{mean }{the means that were subtracted.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{  Barry Grant and Karim ElSawy }
\seealso{ \code{\link{torsion.xyz}}, \code{\link{plot.pca}},
  \code{\link{plot.pca.loadings}}, \code{\link{pca.xyz}} }
\examples{
##-- PCA on torsion data for multiple PDBs 
attach(kinesin)

gaps.pos <- gap.inspect(pdbs$xyz)
tor <- t(apply( pdbs$xyz[, gaps.pos$f.inds], 1, torsion.xyz, atm.inc=1))
pc.tor <- pca.tor(tor[,-c(1,233,234,235)])
#plot(pc.tor)
plot.pca.loadings(pc.tor)

detach(kinesin)

\dontrun{
##-- PCA on torsion data from an MD trajectory
trj <- read.dcd( system.file("examples/hivp.dcd", package="bio3d") )
tor <- t(apply(trj, 1, torsion.xyz, atm.inc=1))
gaps <- gap.inspect(tor)
pc.tor <- pca.tor(tor[,gaps$f.inds])
plot.pca.loadings(pc.tor)
}
}
\keyword{ utilities }
\keyword{ multivariate }

\name{vmd_colors}
\alias{vmd_colors}
\title{ VMD Color Palette }
\description{
  This function creates a character vector of the colors used by the VMD
  molecular graphics program.
}
\usage{
vmd_colors(n=33, picker=FALSE, ...)
}
\arguments{
  \item{n}{ The number of desired colors chosen in sequence
    from the VMD color palette (>=1) }
  \item{picker}{ Logical, if TRUE a color wheel plot will be produced to
    aid with color choice. }
  \item{\dots}{ Extra arguments passed to the \code{rgb} function, including
    alpha transparency. }
}
\details{
  The function uses the underlying 33 RGB color codes from VMD, See
  \url{http://www.ks.uiuc.edu/Research/vmd/}. Note that colors will be
  recycled if \dQuote{n} > 33 with a warning issued. When \sQuote{picker} is
  set to \dQuote{TRUE} a color wheel of the requested colors will be
  plotted to the currently active device.
}
\value{
  Returns a character vector with color names.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  \url{http://www.ks.uiuc.edu/Research/vmd/}
}
\author{
  Barry Grant
}
\seealso{
  \code{\link{bwr.colors}}
}
\examples{
## Generate a vector of 10 colors
clrs <- vmd_colors(10)
vmd_colors(4, picker=TRUE)
}
\keyword{utility}

\name{cov.nma}
\alias{cov.nma}
\alias{cov.enma}
\title{ Calculate Covariance Matrix from Normal Modes }
\description{
  Calculate the covariance matrix from a normal mode object.
}
\usage{
\method{cov}{nma}(nma)
\method{cov}{enma}(enma, ncore=NULL)
}
\arguments{
  \item{nma}{ an \code{nma} object as obtained from function
    \code{nma.pdb}. }
  \item{enma}{ an \code{enma} object as obtained from function
    \code{nma.pdbs}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
}
\details{
  This function calculates the covariance matrix from a \code{nma}
  object as obtained from function \code{nma.pdb} or covariance matrices
  from a \code{enma} object as obtain from function \code{nma.pdbs}. 
}
\value{
  Returns the calculated covariance matrix (function \code{cov.nma}), or
  covariance matrices (function \code{cov.enma}). 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  Fuglebakk, E. et al. (2013) \emph{JCTC} \bold{9}, 5618--5628.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma}} }
\keyword{ utilities }

\name{pairwise}
\alias{pairwise}
\title{ Pair Indices }
\description{
  A utility function to determine indices for pairwise comparisons.
}
\usage{
pairwise(N)
}
\arguments{
  \item{N}{ a single numeric value representing the total number of
    things to undergo pairwise comparison. }
}
\value{
  Returns a two column numeric matrix giving the indices for all
  pairs.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{seqidentity}} }
\examples{
  pairwise(3)
  pairwise(20)
}
\keyword{ utilities }

\name{dccm.pca}
\alias{dccm.pca}
\title{ Dynamical Cross-Correlation Matrix from Principal Component Analysis }
\description{
  Calculate the cross-correlation matrix from principal component analysis (PCA).
}
\usage{
\method{dccm}{pca}(x, pc = NULL, method = c("pearson", "lmi"), ncore = NULL, \dots)
}
\arguments{
  \item{x}{ an object of class \code{pca} as obtained from
    function \code{pca.xyz}. }
  \item{pc}{ numerical, indices of PCs to be included in the calculation.
    If all negative, PCs complementary to \code{abs(pc)} are included. }
  \item{method}{ method to calculate the cross-correlation. Currently supports
    Pearson and linear mutual information (LMI). }
  \item{ncore}{ number of CPU cores used to do the calculation.
    By default (\code{ncore = NULL}), use all available cores detected. }
  \item{\dots}{ Additional arguments to be passed (currently ignored). }
}
\details{
  This function calculates the cross-correlation matrix from principal 
  component analysis (PCA) obtained from \code{pca.xyz} of a set of protein
  structures. It is an alternative way to calculate correlation in addition
  to the conventional way from xyz coordinates directly. But, in this new 
  way one can freely chooses the PCs to be included in the 
  calculation (e.g. for filtering out PCs with small eigenvalues).
}
\value{
  Returns a cross-correlation matrix with values in a range from -1 to 1 (Pearson)
  or from 0 to 1 (LMI).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Xin-Qiu Yao}
\seealso{ \code{\link{pca.xyz}}, \code{\link{plot.dccm}}, \code{\link{dccm}}, 
  \code{\link{dccm.xyz}}, \code{\link{dccm.nma}}, \code{\link{dccm.enma}}.
}
\examples{
\donttest{

##-- Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## Select residues 24 to 27 and 85 to 90 in both chains
inds <- atom.select(pdb, resno=c(24:27,85:90), elety='CA')

## lsq fit of trj on pdb
xyz <- fit.xyz(pdb$xyz, trj, fixed.inds=inds$xyz, mobile.inds=inds$xyz)

## Do PCA
pca <- pca.xyz(xyz)

## DCCM: only use first 10 PCs
cij <- dccm(pca, pc = c(1:10))

## Plot DCCM
plot(cij)

## DCCM: remove first 10 PCs
cij <- dccm(pca, pc = -c(1:10))

## Plot DCCM
plot(cij)

}
}
\keyword{ analysis }

\name{overlap}
\alias{overlap}
\title{ Overlap analysis }
\description{
  Calculate the squared overlap between sets of vectors.
}
\usage{
overlap(modes, dv, nmodes=20)
}
\arguments{
  \item{modes}{ an object of class \code{"pca"} or \code{"nma"} as obtained from
    function \code{pca.xyz} or \code{nma}. Alternatively a 3NxM matrix
    of eigenvectors can be provided. } 
  \item{dv}{ a displacement vector of length 3N. } 
  \item{nmodes}{ the number of modes in which the calculation should be based. }
}
\details{
  Squared overlap (or dot product) is used to measure the similiarity 
  between a displacement vector (e.g. a difference vector between two 
  conformational states) and mode vectors obtained from principal component 
  or normal modes analysis. 

  By definition the cumulative sum of the overlap values equals to one. 

  Structure \code{modes$U} (or alternatively, the 3NxM matrix of eigenvectors)
  should be of same length (3N) as \code{dv}. 
}
\value{
  Returns a list with the following components:
  \item{overlap}{ a numeric vector of the squared dot products (overlap values)
    between the (normalized) vector (\code{dv}) and each mode in \code{mode}. }
  \item{overlap.cum}{ a numeric vector of the cumulative squared overlap values. }
}
\references{
  Skjaerven, L. et al. (2011) \emph{Proteins} \bold{79}, 232--243.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{rmsip}}, \code{\link{pca.xyz}}, \code{\link{nma}},
  \code{\link{difference.vector}} }
\examples{
attach(kinesin)
     
# Ignore gap containing positions
##gaps.res <- gap.inspect(pdbs$ali)
gaps.pos <- gap.inspect(pdbs$xyz)
     
#-- Do PCA
pc.xray <- pca.xyz(pdbs$xyz[, gaps.pos$f.inds])
    
# Define a difference vector between two structural states
diff.inds <- c(grep("d1v8ka", pdbs$id), 
               grep("d1goja", pdbs$id))

dv <- difference.vector( pdbs$xyz[diff.inds,], gaps.pos$f.inds )

# Calculate the squared overlap between the PCs and the difference vector  
o <- overlap(pc.xray, dv)
o <- overlap(pc.xray$U, dv)

# Plot results
plot(o$overlap, type='h', ylim=c(0,1))
points(o$overlap)
lines(o$overlap.cum, type='b', col='red')


detach(kinesin)

\dontrun{
## Calculate overlap from NMA
pdb.a <- read.pdb("1cmk")
pdb.b <- read.pdb("3dnd")

## Fetch CA coordinates
sele.a <- atom.select(pdb.a, chain='E', resno=c(15:350), elety='CA')
sele.b <- atom.select(pdb.b, chain='A', resno=c(1:350), elety='CA')

xyz <- rbind(pdb.a$xyz[sele.a$xyz],
             pdb.b$xyz[sele.b$xyz])

## Superimpose
xyz[2,] <- fit.xyz(xyz[1,], xyz[2,], 1:ncol(xyz))

## The difference between the two conformations
dv <- difference.vector( xyz )

## Calculate normal modes
modes <- nma(pdb.a, inds=sele.a)

# Calculate the squared overlap between the normal modes 
# and the difference vector  
o <- overlap(modes, dv)
}
}
\keyword{ utilities }

\name{trim}
\alias{trim}
\alias{trim.pdb}
\title{ Trim a PDB Object To A Subset of Atoms. }
\description{
  Produce a new smaller PDB object, containing a subset of atoms, from a
  given larger PDB object. 
}
\usage{
trim(\dots)

\method{trim}{pdb}(pdb, \dots, inds = NULL, sse = TRUE)
}
\arguments{
  \item{pdb}{ a PDB structure object obtained from
    \code{\link{read.pdb}}. }
  \item{\dots}{ additional arguments passed to \code{\link{atom.select}}. If
     \code{inds} is also provided, these arguments will be ignored. }
  \item{inds}{ a list object of ATOM and XYZ indices as obtained from
    \code{\link{atom.select}}. If NULL, atom selection will be obtained
    from calling \code{atom.select(pdb, \dots)}. }
  \item{sse}{ logical, if \sQuote{FALSE} helix and sheet components are
    omitted from output. }
}
\details{
  This is a basic utility function for creating a new PDB object based
  on a selection of atoms.
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a character matrix containing all atomic coordinate ATOM data, 
  with a row per ATOM and a column per record type.  See below for details
  of the record type naming convention (useful for accessing columns). }
  \item{het }{ a character matrix containing atomic coordinate records
    for atoms within \dQuote{non-standard} HET groups (see \code{atom}). }
  \item{helix }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of H
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{sheet }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{seqres }{ sequence from SEQRES field. }
  \item{xyz }{ a numeric vector of ATOM coordinate data. }
  \item{xyz.models }{ a numeric matrix of ATOM coordinate data for
    multi-model PDB files. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
.
}
\author{ Barry Grant, Lars Skjaerven }
\note{
  \code{het} and \code{seqres} list components are returned unmodified.
  
  For both \code{atom} and \code{het} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno},
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Chain identifier \dQuote{chain},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Occupancy \dQuote{o}, and
  Temperature factor \dQuote{b}.
  See examples for further details.
}
\seealso{
  \code{\link{trim.pdbs}}, \code{\link{trim.xyz}},
  \code{\link{read.pdb}}, \code{\link{atom.select}}
}
\examples{
\dontrun{
## Read a PDB file from the RCSB online database
pdb <- read.pdb("1bg2")

## Select calpha atoms
sele <- atom.select(pdb, "calpha")

## Trim PDB
new.pdb <- trim.pdb(pdb, inds=sele)

## Or, simply
#new.pdb <- trim.pdb(pdb, "calpha")

## Write to file
write.pdb(new.pdb, file="calpha.pdb")
}
}
\keyword{ utilities }

\name{com}
\alias{com}
\alias{com.pdb}
\alias{com.xyz}
\title{ Center of Mass }
\description{
  Calculate the center of mass of a PDB object.
}
\usage{
com(...)

\method{com}{pdb}(pdb, inds=NULL, use.mass=TRUE, ...)

\method{com}{xyz}(xyz, mass=NULL, ...)
}
\arguments{
  \item{pdb}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb}. }
  \item{inds}{ atom and xyz coordinate indices obtained from \code{atom.select}
    that selects the elements of \code{pdb} upon which the calculation
    should be based.}
  \item{use.mass}{ logical, if TRUE the calculation will be mass
    weighted (center of mass). }
  \item{...}{ additional arguments to \code{atom2mass}. }
  \item{xyz}{ a numeric vector or matrix of Cartesian coordinates
    (e.g. an object of type \code{xyz}). }
  \item{mass}{ a numeric vector containing the masses of each atom in
    \code{xyz}. }
}
\details{
  This function calculates the center of mass of the provided PDB
  structure / Cartesian coordiantes. Atom names found in standard amino
  acids in the PDB are mapped to atom elements and their corresponding
  relative atomic masses.  

  In the case of an unknown atom name \code{elety.custom} and
  \code{mass.custom} can be used to map an atom to the correct
  atomic mass. See examples for more details.

  Alternatively, the atom name will be mapped automatically to the
  element corresponding to the first character of the atom name. Atom
  names starting with character \code{H} will be mapped to hydrogen
  atoms.
}
\value{
  Returns the Cartesian coordinates at the center of mass.
}
\references{
   Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{read.pdb}}, \code{\link{atom2mass}}
}
\examples{
\donttest{
# PDB server connection required - testing excluded

## Stucture of PKA:
pdb <- read.pdb("3dnd")

## Center of mass:
com(pdb)

## Center of mass of a selection
inds <- atom.select(pdb, chain="I")
com(pdb, inds)

## using XYZ Cartesian coordinates
xyz <- pdb$xyz[, inds$xyz]
com.xyz(xyz)

## with mass weighting
com.xyz(xyz, mass=atom2mass(pdb$atom[inds$atom, "elety"]) )

}

\dontrun{
## Unknown atom names
pdb <- read.pdb("3dnd")
inds <- atom.select(pdb, resid="LL2")
mycom <- com(pdb, inds, rescue=TRUE)
#warnings()


## Map atom names manually
pdb <- read.pdb("3RE0")
inds <- atom.select(pdb, resno=201)

myelety  <- data.frame(name = c("CL2","PT1","N1","N2"), symb = c("Cl","Pt","N","N"))
mymasses <- data.frame(symb = c("Cl","Pt"), mass = c(35.45, 195.08))
mycom    <- com(pdb, inds, elety.custom=myelety, mass.custom=mymasses)
}
}
\keyword{ utilities }

\name{nma}
\alias{nma}
\title{ Normal Mode Analysis }
\description{
  Perform normal mode analysis (NMA) on either a single or an ensemble
  of protein structures.
}
\usage{
nma(...)
}
\arguments{
  \item{\dots}{ arguments passed to the methods
    \code{\link{nma.pdb}}, or \code{\link{nma.pdbs}}.
    
    For function \code{\link{nma.pdb}} this will include an object of
    class \code{pdb} as obtained from function \code{\link{read.pdb}}.
    
    For function \code{\link{nma.pdbs}} an object of class \code{pdbs} as
    obtained from function \code{\link{pdbaln}} or
    \code{\link{read.fasta.pdb}}. } 
}
\details{
  Normal mode analysis (NMA) is a computational approach for studying and
  characterizing protein flexibility. Current functionality entails normal
  modes calculation on either a single protein structure or an ensemble
  of aligned protein structures. 

  This generic \code{\link{nma}} function calls the corresponding
  methods for the actual calculation, which is determined by the class
  of the input argument:

  Function \code{\link{nma.pdb}} will be used when the input argument is
  of class \code{pdb}. The function calculates the normal modes of a
  C-alpha model of a protein structure.

  Function \code{\link{nma.pdbs}} will be used when the input argument is
  of class \code{pdbs}. The function will perform normal mode analysis
  of each PDB structure stored in the \code{pdbs} object
  (\sQuote{ensemble NMA}).
  
  See documentation and examples for each corresponding function for
  more details. 
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{nma.pdb}}, \code{\link{nma.pdbs}},
  \code{\link{pca}}.
}
\examples{

##- Singe structure NMA
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate normal modes
modes <- nma(pdb)

## Print modes
print(modes)

## Plot modes
plot(modes)

## Visualize modes
#m7 <- mktrj.nma(modes, mode=7, file="mode_7.pdb")

\donttest{
## Needs MUSCLE installed - testing excluded

##- Ensemble NMA
if(check.utility("muscle")) {

## Fetch PDB files and split to chain A only PDB files
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
files <- get.pdb(ids, split = TRUE, path = tempdir())

## Sequence Alignement
pdbs <- pdbaln(files, outfile = tempfile())

## Normal mode analysis on aligned data
modes <- nma(pdbs, rm.gaps=FALSE)

## Plot fluctuation data
plot(modes, pdbs=pdbs)

}
}
}
\keyword{ analysis }

\name{trim.xyz}
\alias{trim.xyz}
\title{ Trim a XYZ Object of Cartesian Coordinates. }
\description{
  Produce a new smaller XYZ object, containing a subset of atoms.
}
\usage{
\method{trim}{xyz}(xyz, row.inds = NULL, col.inds = NULL, \dots)
}
\arguments{
  \item{xyz}{ a XYZ object containing Cartesian coordinates,
    e.g. obtained from \code{\link{read.pdb}}, \code{\link{read.ncdf}}. }    
  \item{row.inds}{ a numeric vector specifying which rows of the xyz
    matrix to return. }
  \item{col.inds}{ a numeric vector specifying which columns of the xyz
    matrix to return. }
  \item{\dots}{ additional arguments passed to and from functions. } 
}
\details{
  This function provides basic functionality for subsetting a
  matrix of class \sQuote{xyz} while also maintaining the class
  attribute. 
}
\value{
  Returns an object of class \code{xyz} with the Cartesian coordinates
  stored in a matrix object with dimensions M x 3N, where N is the
  number of atoms, and M number of frames. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{read.pdb}}, \code{\link{as.xyz}}.
}
\examples{
\dontrun{
## Read a PDB file from the RCSB online database
pdb <- read.pdb("1bg2")

## Select calpha atoms
sele <- atom.select(pdb, "calpha")

## Trim XYZ
trim(pdb$xyz, col.inds=sele$xyz)

## Equals to
pdb$xyz[, sele$xyz, drop=FALSE]
}
}
\keyword{ utilities }

\name{is.gap}
\alias{is.gap}
\title{ Gap Characters }
\description{
  Test for the presence of gap characters.
}
\usage{
is.gap(x, gap.char = c("-", "."))
}
\arguments{
  \item{x}{ an R object to be tested. Typically a sequence vector or 
  sequence/structure alignment object as returned from \code{seqaln}, 
  \code{pdbaln} etc. }
  \item{gap.char}{ a character vector containing the gap character types
    to test for. }
}
\value{
  Returns a logical vector with the same length as the input vector, or 
  the same length as the number of columns present in an alignment input 
  object \sQuote{x}. In the later case TRUE elements corresponding to 
  \sQuote{gap.char} matches in any alignment column (i.e. gap containing 
  columns).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  During alignment, gaps are introduced into sequences that are believed
  to have undergone deletions or insertions with respect to other
  sequences in the alignment.  These gaps, often referred to as
  indels, can be represented with \sQuote{NA}, \sQuote{-} or
  \sQuote{.} characters.

  This function provides a simple test for the presence of such
  characters, or indeed any set of user defined characters set by
  the \sQuote{gap.char} argument.
}
\seealso{ \code{\link{gap.inspect}}, \code{\link{read.fasta}},
  \code{\link{read.fasta.pdb}}, \code{\link{seqaln}}, \code{\link{pdbaln}} }
\examples{

is.gap( c("G",".","X","-","G","K","S","T") )

\dontrun{
aln <- read.fasta( system.file("examples/kif1a.fa",
                   package = "bio3d") )

##- Print only non-gap positions (i.e. no gaps in any sequence)
aln$ali[, !is.gap(aln) ]

##- Mask any existing gaps with an "X"
xaln <- aln
xaln$ali[ is.gap(xaln$ali) ]="X"

##- Read a new PDB and align its sequence to the existing masked alignment
pdb <- read.pdb( "1mkj" )
seq2aln(pdbseq(pdb), xaln, id = "1mkj")
}
}
\keyword{ utilities }

\name{difference.vector}
\alias{difference.vector}
\title{ Difference Vector }
\description{
  Define a difference vector between two conformational states.
}
\usage{
difference.vector(xyz, xyz.inds=NULL, normalize=FALSE)
}
\arguments{
  \item{xyz}{ numeric matrix of Cartesian coordinates with a row per
      structure. } 
  \item{xyz.inds}{ a vector of indices that selects the elements of columns upon
    which the calculation should be based. }
  \item{normalize}{ logical, if TRUE the difference vector is
    normalized. }
}
\details{
  Squared overlap (or dot product) is used to measure the similiarity 
  between a displacement vector (e.g. a difference vector between two 
  conformational states) and mode vectors obtained from principal component 
  or normal modes analysis. 
}
\value{
  Returns a numeric vector of the structural difference (normalized if desired).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{overlap}} }
\examples{
attach(kinesin)
     
# Ignore gap containing positions
gaps.pos <- gap.inspect(pdbs$xyz)
     
#-- Do PCA
pc.xray <- pca.xyz(pdbs$xyz[, gaps.pos$f.inds])
     
# Define a difference vector between two structural states
diff.inds <- c(grep("d1v8ka", pdbs$id), 
               grep("d1goja", pdbs$id))

## Calculate the difference vector
dv <- difference.vector( pdbs$xyz[diff.inds,], gaps.pos$f.inds )

# Calculate the squared overlap between the PCs and the difference vector  
o <- overlap(pc.xray, dv)

detach(kinesin)

}
\keyword{ utilities }

\name{write.ncdf}
\alias{write.ncdf}
\title{ Write AMBER Binary netCDF files }
\description{
  Write coordinate data to a binary netCDF trajectory file.
}
\usage{
write.ncdf(x, trjfile = "R.ncdf", cell = NULL)
}
\arguments{
  \item{x}{ A numeric matrix of xyz coordinates with a frame/structure
    per row and a Cartesian coordinate per column. }
  \item{trjfile}{ name of the output trajectory file. }
  \item{cell}{ A numeric matrix of cell information with a frame/structure
    per row and a cell length or angle per column. If NULL cell will not
    be written. }
}
\details{
  Writes an AMBER netCDF (Network Common Data Form) format trajectory
  file with the help of David W. Pierce's (UCSD) ncdf4 package available
  from CRAN.
}
\value{
  Called for its effect.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  \url{https://www.unidata.ucar.edu/software/netcdf/}
  \url{https://cirrus.ucsd.edu/~pierce/ncdf/}
  \url{https://ambermd.org/FileFormats.php#netcdf}
}
\author{ Barry Grant }
\note{ 
  See AMBER documentation for netCDF format description.

  NetCDF binary trajectory files are supported by the AMBER modules
  sander, pmemd and ptraj. Compared to formatted trajectory files, the
  binary trajectory files are smaller, higher precision and
  significantly faster to read and write.

  NetCDF provides for file portability across architectures, allows for
  backwards compatible extensibility of the format and enables the files
  to be self-describing. Support for this format is available in VMD.
}
\seealso{ \code{\link{read.dcd}}, \code{\link{read.ncdf}},
  \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{atom.select}} }
\examples{
\dontrun{
##-- Read example trajectory file
trtfile <- system.file("examples/hivp.dcd", package="bio3d")
trj <- read.dcd(trtfile)

## Write to netCDF format
write.ncdf(trj, "newtrj.nc")

## Read trj
trj <- read.ncdf("newtrj.nc")
}
}
\keyword{ IO }

\name{fluct.nma}
\alias{fluct.nma}
\title{ NMA Fluctuations }
\description{
  Calculates the atomic fluctuations from normal modes analysis.
}
\usage{
fluct.nma(nma, mode.inds=NULL)
}
\arguments{
  \item{nma}{ a list object of class \code{"nma"} (obtained with
    \code{\link{nma}}).}
  \item{mode.inds}{ a numeric vector containing the the mode numbers in
    which the calculation should be based. }
}
\details{
  Atomic fluctuations are calculated based on the \code{nma} object. By
  default all modes are included in the calculation.

  See examples for more details.
}
\value{
  Returns a numeric vector of atomic fluctuations.
}
\references{
  Hinsen, K. et al. (2000) \emph{Chemical Physics} \bold{261}, 25--37.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma} } }
\examples{
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Fluctuations
f <- fluct.nma(modes)

## Fluctuations of first non-trivial mode
f <- fluct.nma(modes, mode.inds=c(7,8))
}
\keyword{ analysis }

\name{fit.xyz}
\alias{fit.xyz}
\alias{rot.lsq}
\title{ Coordinate Superposition }
\description{
  Coordinate superposition with the Kabsch algorithm.
}
\usage{
fit.xyz(fixed, mobile,
        fixed.inds  = NULL,
        mobile.inds = NULL,
        verbose=FALSE,
        prefix= "", pdbext = "",
        outpath = "fitlsq", full.pdbs=FALSE, 
        ncore = 1, nseg.scale = 1, ...)

rot.lsq(xx, yy,
        xfit = rep(TRUE, length(xx)), yfit = xfit,
        verbose = FALSE)
}
\arguments{
  \item{fixed }{ numeric vector of xyz coordinates.}
  \item{mobile}{ numeric vector, numeric matrix, or an object with an
    \code{xyz} component containing one or more coordinate sets. }
  \item{fixed.inds}{ a vector of indices that selects the elements of
    \code{fixed} upon which fitting should be based.}
  \item{mobile.inds}{  a vector of indices that selects the elements
    of \code{mobile} upon which fitting should be based.}
  \item{full.pdbs}{ logical, if TRUE \dQuote{full} coordinate files
    (i.e. all atoms) are written to the location specified by
    \code{outpath}. }
  \item{prefix}{ prefix to mobile$id to locate \dQuote{full} input PDB files.  Only
        required if \code{full.pdbs} is TRUE. }
  \item{pdbext}{ the file name extension of the input PDB files. }
  \item{outpath}{ character string specifing the output directory when
    \code{full.pdbs} is TRUE. }
  \item{xx}{ numeric vector corresponding to the moving \sQuote{subject}
    coordinate set. }
  \item{yy}{ numeric vector corresponding to the fixed \sQuote{target}
    coordinate set. }
  \item{xfit}{ logical vector with the same length as \code{xx},  with
    TRUE elements corresponding to the subset of positions upon which
    fitting is to be performed. }
  \item{yfit}{ logical vector with the same length as \code{yy},  with
    TRUE elements corresponding to the subset of positions upon which
    fitting is to be performed. }
  \item{verbose}{ logical, if TRUE more details are printed. }
   \item{\dots}{ other parameters for \code{\link{read.pdb}}. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. }
  
}
\details{
  The function \code{fit.xyz} is a wrapper for the function
  \code{rot.lsq}, which performs the actual coordinate superposition.
  The function \code{rot.lsq} is an implementation of the Kabsch
  algorithm (Kabsch, 1978) and evaluates the optimal rotation matrix
  to minimize the RMSD between two structures.

  Since the Kabsch algorithm assumes that the number of points are the
  same in the two input structures, care should be taken to ensure that
  consistent atom sets are selected with \code{fixed.inds} and
  \code{mobile.inds}.

  Optionally, \dQuote{full} PDB file superposition and output can be
  accomplished by setting \cr \code{full.pdbs=TRUE}.  In that case, the
  input (\code{mobile}) passed to \code{fit.xyz} should be a list object
  obtained with the function \code{\link{read.fasta.pdb}}, since the
  components \code{id}, \code{resno} and \code{xyz} are required to
  establish correspondences.  See the examples below.

  In dealing with large vector and matrix, running on multiple
  cores, especially when \code{ncore>>1}, may ask for a large portion
  of system memory. To avoid the overuse of memory, input data is first
  split into segments (for xyz matrix, the splitting is along the row). 
  The number of data segments is equal to \code{nseg.scale*nseg.base}, where
  \code{nseg.base } is an integer determined by the dimension of the data.
}
\value{
  Returns moved coordinates.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Kabsch \emph{Acta Cryst} (1978) \bold{A34}, 827--828.
}
\author{ Barry Grant with \code{rot.lsq} contributions from Leo Caves }
\seealso{ \code{\link{rmsd}}, \code{\link{read.pdb}},
  \code{\link{read.fasta.pdb}}, \code{\link{read.dcd}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

##--- Read an alignment & Fit aligned structures
aln  <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
pdbs <- read.fasta.pdb(aln)

gaps <- gap.inspect(pdbs$xyz)

xyz <- fit.xyz( fixed  = pdbs$xyz[1,],
               mobile = pdbs$xyz,
               fixed.inds  = gaps$f.inds,
               mobile.inds = gaps$f.inds )

#rmsd( xyz[, gaps$f.inds] )
#rmsd( pdbs$xyz[, gaps$f.inds] )
}
\dontrun{
##-- Superpose again this time outputing PDBs
xyz <- fit.xyz( fixed = pdbs$xyz[1,],
               mobile = pdbs,
               fixed.inds  = gaps$f.inds,
               mobile.inds = gaps$f.inds,
               outpath = "rough_fit",
               full.pdbs = TRUE)
}
\donttest{
##--- Fit two PDBs
A <- read.pdb("1bg2")
A.ind <- atom.select(A, resno=c(256:269), elety='CA')

B <- read.pdb("2kin")
B.ind <- atom.select(B, resno=c(257:270), elety='CA')

xyz <- fit.xyz(fixed=A$xyz, mobile=B$xyz,
               fixed.inds=A.ind$xyz,
               mobile.inds=B.ind$xyz)
}
\dontrun{
# Write out moved PDB
C <- B; C$xyz = xyz
write.pdb(pdb=C, file = "moved.pdb")
}
}
\keyword{ utilities }

\name{orient.pdb}
\alias{orient.pdb}
\title{ Orient a PDB Structure }
\description{
   Center, to the coordinate origin, and orient, by principal axes, the
   coordinates of a given PDB structure or xyz vector.
 }
\usage{
orient.pdb(pdb, atom.subset = NULL, verbose = TRUE)
}
\arguments{
  \item{pdb}{ a pdb data structure obtained from \code{\link{read.pdb}}
    or a vector of \sQuote{xyz} coordinates. }
  \item{atom.subset}{ a subset of atom positions to base orientation on. }
  \item{verbose}{ print dimension details. }
}
\value{
  Returns a numeric vector of re-oriented coordinates.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  Centering and orientation can be restricted to a \code{atom.subset} of atoms.
}
\seealso{ \code{\link{read.pdb}}, \code{\link{write.pdb}},
\code{\link{fit.xyz}}, \code{\link{rot.lsq}} , \code{\link{atom.select}}}
\examples{
\donttest{
# PDB server connection required - testing excluded

pdb <- read.pdb( "1bg2" )
xyz <- orient.pdb(pdb)
#write.pdb(pdb, xyz = xyz, file = "mov1.pdb")


# Based on C-alphas
inds <- atom.select(pdb, "calpha")
xyz  <- orient.pdb(pdb, atom.subset=inds$atom)
#write.pdb(pdb, xyz = xyz, file = "mov2.pdb")


# Based on a central Beta-strand
inds <- atom.select(pdb, resno=c(224:232), elety='CA')
xyz  <- orient.pdb(pdb, atom.subset=inds$atom)
#write.pdb(pdb, xyz = xyz, file = "mov3.pdb")
}
}
\keyword{ manip }

\name{pdbseq}
\alias{pdbseq}
\title{ Extract The Aminoacid Sequence From A PDB Object }
\description{
  Return a vector of the one-letter IUPAC or three-letter PDB
  style aminoacid codes from a given PDB object.
}
\usage{
pdbseq(pdb, inds = NULL, aa1 = TRUE)
}
\arguments{
  \item{pdb}{a PDB structure object obtained from
    \code{\link{read.pdb}}. }
  \item{inds}{ a list object of ATOM and XYZ indices as obtained from
    \code{\link{atom.select}}. }
  \item{aa1}{ logical, if TRUE then the one-letter IUPAC sequence is
    returned. IF FALSE then the three-letter PDB style sequence is
    returned.}
}
\details{
  See the examples below and the functions \code{\link{atom.select}} and \code{\link{aa321}}
  for further details.
}
\value{
   A character vector of aminoacid codes.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of IUPAC one-letter codes see:\cr
  \url{https://www.insdc.org/documents/feature_table.html#7.4.3}

  For more information on PDB residue codes see:\cr
  \url{http://ligand-expo.rcsb.org/ld-search.html}

}
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{atom.select}},
  \code{\link{aa321}}, \code{\link{read.fasta}} }
\examples{
\dontrun{
pdb <- read.pdb( "5p21" )
pdbseq(pdb)

#pdbseq(pdb, inds=atom.select(pdb, resno=5:15, elety="CA"), aa1=FALSE)
}
}
\keyword{ utilities }

\name{read.crd.charmm}
\alias{read.crd.charmm}
\title{ Read CRD File }
\description{
  Read a CHARMM CARD (CRD) coordinate file.
}
\usage{
\method{read.crd}{charmm}(file, ext = TRUE, verbose = TRUE, ...)
}
\arguments{
  \item{file}{ the name of the CRD file to be read.  }
  \item{ext}{logical, if TRUE assume expanded CRD format. }
  \item{verbose}{ print details of the reading process. }
  \item{\dots}{ arguments going nowhere. }
}
\details{
  See the function \code{\link{read.pdb}} for more details.
}
\value{
  Returns a list with the following components:
  \item{atom}{ a character matrix containing all atomic coordinate data,
  with a row per atom and a column per record type.  See below for details
  of the record type naming convention (useful for accessing columns). }
  \item{xyz }{ a numeric vector of coordinate data. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  For a description of CHARMM CARD (CRD) format see:\cr
  \url{https://www.charmm.org/wiki//index.php/CHARMM:The_Basics}.
}
\author{ Barry Grant }
\note{
  Similar to the output of \code{\link{read.pdb}}, the column names of
  \code{atom} can be used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno},
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Weighting factor \dQuote{b}.
  See examples for further details.
}
\seealso{ \code{\link{write.crd}}, \code{\link{read.pdb}},
  \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}} }
\examples{
\dontrun{
 pdb <- read.pdb("1bg2")
 crdfile <- paste(tempfile(), '.crd', sep='')
 write.crd(pdb, file=crdfile)
 crd <- read.crd(crdfile, ext=FALSE)
 ca.inds <- which(crd$calpha)
 crd$atom[ca.inds[1:20],c("x","y","z")]
# write.pdb(crd, file=tempfile())
}
}
\keyword{ IO }

\name{gap.inspect}
\alias{gap.inspect}
\title{ Alignment Gap Summary }
\description{
  Report the number of gaps per sequence and per position for a given alignment.
}
\usage{
gap.inspect(x)
}
\arguments{
  \item{x}{ a matrix or an alignment data structure obtained from
    \code{\link{read.fasta}} or \code{\link{read.fasta.pdb}}.}
}
\details{
  Reports the number of gap characters per row (i.e. sequence) and
  per column (i.e. position) for a given \code{alignment}. In addition,
  the indices for gap and non-gap containing coloums are returned along
  with a binary matrix indicating the location of gap positions. 
}
\value{
  Returns a list object with the following components:
  \item{row }{a numeric vector detailing the number of gaps per row
    (i.e. sequence).}
  \item{col }{a numeric vector detailing the number of gaps per column
    (i.e. position).}
  \item{t.inds }{ indices for gap containing coloums }
  \item{f.inds }{ indices for non-gap containing coloums}  
  \item{bin }{a binary numeric matrix with the same dimensions as the
    \code{alignment}, with 0 at non-gap positions and 1 at gap
    positions.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{
  During alignment, gaps are introduced into sequences that are believed
  to have undergone deletions or insertions with respect to other
  sequences in the alignment.  These gaps, often referred to as
  indels, can be represented with \sQuote{NA}, a \sQuote{-} or
  \sQuote{.} character.

  This function gives an overview of gap occurrence and may be useful
  when considering positions or sequences that could/should be excluded
  from further analysis.
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}}}
\examples{
aln <- read.fasta( system.file("examples/hivp_xray.fa",
                   package = "bio3d") )

gap.stats <- gap.inspect(aln$ali)
gap.stats$row # Gaps per sequence
gap.stats$col # Gaps per position
##gap.stats$bin # Binary matrix (1 for gap, 0 for aminoacid)
##aln[,gap.stats$f.inds] # Alignment without gap positions 

plot(gap.stats$col, typ="h", ylab="No. of Gaps") 
}
\keyword{ utilities }

\name{pca.array}
\alias{pca.array}
\title{ Principal Component Analysis of an array of matrices }
\description{
  Calculate the principal components of an array of correlation or
  covariance matrices.
}
\usage{
\method{pca}{array}(x, use.svd = TRUE, rm.gaps=TRUE, ...)
}
\arguments{
  \item{x}{ an array of matrices, e.g. correlation or covariance
    matrices as obtained from functions \code{dccm} or \code{enma2covs}. }
  \item{use.svd}{ logical, if TRUE singular value decomposition (SVD) is 
    called instead of eigenvalue decomposition. }
  \item{rm.gaps}{ logical, if TRUE gap cells (with missing
    coordinate data in any input matrix) are removed before
    calculation. This is equivalent to removing NA cells from x. }
  \item{\dots}{ . }
}
\details{
  This function performs PCA of symmetric matrices, such as distance 
  matrices from an ensemble of crystallographic structures, residue-residue 
  cross-correlations or covariance matrices derived from ensemble NMA 
  or MD simulation replicates, and so on. The \sQuote{upper triangular} 
  region of the matrix is regarded as a long vector of random variables. 
  The function returns M eigenvalues and eigenvectors with each eigenvector 
  having the dimension N(N-1)/2, where M is the number of matrices and N 
  the number of rows/columns of matrices.
}
\value{
  Returns a list with components equivalent to the output from
  \code{pca.xyz}. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
}
\author{ Xin-Qiu Yao, Lars Skjaerven }
\seealso{ \code{\link{pca.xyz}} }
\keyword{ utilities }

\name{geostas}
\alias{geostas}
\alias{geostas.default}
\alias{geostas.xyz}
\alias{geostas.nma}
\alias{geostas.enma}
\alias{geostas.pdb}
\alias{geostas.pdbs}
\alias{amsm.xyz}
\alias{print.geostas}
\title{ GeoStaS Domain Finder }
\description{
  Identifies geometrically stable domains in biomolecules
}
\usage{
geostas(\dots)

\method{geostas}{default}(\dots)

\method{geostas}{xyz}(xyz, amsm = NULL, k = 3, pairwise = TRUE,
      clustalg = "kmeans", fit = TRUE, ncore = NULL, verbose=TRUE, \dots)

\method{geostas}{nma}(nma, m.inds = 7:11, verbose=TRUE, \dots)

\method{geostas}{enma}(enma, pdbs = NULL, m.inds = 1:5, verbose=TRUE, \dots)

\method{geostas}{pdb}(pdb, inds = NULL, verbose=TRUE, \dots)

\method{geostas}{pdbs}(pdbs, verbose=TRUE, \dots)

amsm.xyz(xyz, ncore = NULL)

\method{print}{geostas}(x, \dots)
}
\arguments{
  \item{...}{ arguments passed to and from functions, such as
    \code{\link{kmeans}}, and \code{\link{hclust}} which are called
    internally in \code{geostas.xyz}. }
  \item{xyz}{ numeric matrix of xyz coordinates as obtained e.g. by
    \code{\link{read.ncdf}}, \code{\link{read.dcd}}, or
    \code{\link{mktrj}}. }
  \item{amsm}{ a numeric matrix as obtained by
    \code{\link{amsm.xyz}} (convenient e.g. for re-doing only the
    clustering analysis of the \sQuote{AMSM} matrix). }
  \item{k }{ an integer scalar or vector with the desired number of
    groups. }
  \item{pairwise }{ logical, if TRUE use pairwise clustering of the atomic
    movement similarity matrix (AMSM), else columnwise. }
  \item{clustalg}{ a character string specifing the clustering
    algorithm. Allowed values are \sQuote{kmeans} and \sQuote{hclust}. }
  \item{fit}{ logical, if TRUE coordinate superposition on identified
    core atoms is performed prior to the calculation of the AMS
    matrix. } 
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{verbose}{ logical, if TRUE details of the geostas calculations
    are printed to screen. }
  \item{nma}{ an \sQuote{nma} object as obtained from function
    \code{\link{nma}}. Function \code{\link{mktrj}} is used internally
    to generate a trajectory based on the normal modes. }
  \item{m.inds}{ the mode number(s) along which trajectory should be
    made (see function \code{\link{mktrj}}). }
  \item{enma}{ an \sQuote{enma} object as obtained from function
    \code{\link{nma.pdbs}}. Function \code{\link{mktrj}} is used internally
    to generate a trajectory based on the normal modes. }
  \item{pdbs}{ a \sQuote{pdbs} object as obtained from function
    \code{\link{pdbaln}} or \code{\link{read.fasta.pdb}}. }
  \item{pdb}{ a \sQuote{pdb} object as obtained from function
    \code{\link{read.pdb}}. }
  \item{inds}{ a \sQuote{select} object as obtained from function
    \code{\link{atom.select}} giving the atomic indices at which the
    calculation should be based. By default the function will attempt to
    locate C-alpha atoms using function \code{\link{atom.select}}. }
  \item{x}{ a \sQuote{geostas} object as obtained from function
    \code{\link{geostas}}. }
}
\details{
  This function attempts to identify rigid domains in a protein (or
  nucleic acid) structure based on an structural ensemble, e.g. obtained
  from NMR experiments, molecular dynamics simulations, or normal mode
  analysis.
  
  The algorithm is based on a geometric approach for comparing pairwise
  traces of atomic motion and the search for their best superposition
  using a quaternion representation of rotation. The result is stored in
  a NxN atomic movement similarity matrix (AMSM) describing the
  correspondence between all pairs of atom motion. Rigid domains are
  obtained by clustering the elements of the AMS matrix
  (\code{pairwise=TRUE}), or alternatively, the columns similarity
  (\code{pairwise=FALSE}), using either K-means (\code{\link{kmeans}})
  or hierarchical (\code{\link{hclust}}) clustering.

  Compared to the conventional cross-correlation matrix (see function
  \code{\link{dccm}}) the \dQuote{geostas} approach provide
  functionality to also detect domains involved in rotational
  motions (i.e. two  atoms located on opposite sides of a rotating
  domain will appear as anti-correlated in the cross-correlation matrix,
  but should obtain a high similarity coefficient in the AMS matrix).

  See examples for more details.
}
\note{
  The current implementation in Bio3D uses a different fitting and
  clustering approach than the original Java implementation. The results
  will therefore differ.
}
\value{
  Returns a list object of type \sQuote{geostas} with the following components:
  \item{amsm }{ a numeric matrix of atomic movement similarity (AMSM). }
  \item{fit.inds }{ a numeric vector of xyz indices used for fitting. }
  \item{grps }{ a numeric vector containing the domain assignment per
    residue. }
  \item{atomgrps }{ a numeric vector containing the domain assignment per
    atom (only provided for \code{geostas.pdb}). }
  \item{inds }{ a list of atom \sQuote{select} objects with indices to
    corresponding to the identified domains. }
}
\references{
  Romanowska, J. et al. (2012) \emph{JCTC} \bold{8}, 2588--2599.
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Julia Romanowska and Lars Skjaerven }
\seealso{
  \code{\link{plot.geostas}}, 
  \code{\link{read.pdb}}, \code{\link{mktrj}},
  \code{\link{read.ncdf}}, \code{\link{read.dcd}},
  \code{\link{nma}}, \code{\link{dccm}}.
}
\examples{
\donttest{
# PDB server connection required - testing excluded

#### NMR-ensemble example
## Read a multi-model PDB file 
pdb <- read.pdb("1d1d", multi=TRUE)

## Find domains and write PDB
gs  <- geostas(pdb, fit=TRUE)

## Plot a atomic movement similarity matrix
plot.geostas(gs, contour=FALSE)

## Fit all frames to the 'first' domain
domain.inds <- gs$inds[[1]]

xyz <- pdbfit(pdb, inds=domain.inds)

#write.pdb(pdb, xyz=xyz, chain=gs$atomgrps)

}

\dontrun{
#### NMA example
## Fetch stucture
pdb <- read.pdb("1crn")

## Calculate (vibrational) normal modes
modes <- nma(pdb)

## Find domains
gs <- geostas(modes, k=2)

## Write NMA trajectory with domain assignment
mktrj(modes, mode=7, chain=gs$grps)

## Redo geostas domain clustering 
gs <- geostas(modes, amsm=gs$amsm, k=5)




#### Trajectory example
## Read inn DCD trajectory file, fit coordinates
dcdfile <- system.file("examples/hivp.dcd", package = "bio3d")
trj <- read.dcd(dcdfile)
xyz <- fit.xyz(trj[1,], trj)

## Find domains
gs <- geostas(xyz, k=3, fit=FALSE)

## Principal component analysis 
pc.md <- pca.xyz(xyz)

## Visualize PCs with colored domains (chain ID)
mktrj(pc.md, pc=1, chain=gs$grps)




#### X-ray ensemble GroEL subunits
# Define the ensemble PDB-ids
ids <- c("1sx4_[A,B,H,I]", "1xck_[A-B]", "1sx3_[A-B]", "4ab3_[A-B]")

# Download and split PDBs by chain ID
raw.files <- get.pdb(ids, path = "raw_pdbs", gzip = TRUE)
files <- pdbsplit(raw.files, ids, path = "raw_pdbs/split_chain/")

# Align structures
pdbs <- pdbaln(files)

# Find domains
gs <- geostas(pdbs, k=4, fit=TRUE)

# Superimpose to core region
pdbs$xyz <- pdbfit(pdbs, inds=gs$fit.inds)

# Principal component analysis 
pc.xray <- pca(pdbs)

# Visualize PCs with colored domains (chain ID)
mktrj(pc.xray, pc=1, chain=gs$grps)


##- Same, but more manual approach 
gaps.pos <- gap.inspect(pdbs$xyz)

# Find core region
core <- core.find(pdbs)

# Fit to core region
xyz <- fit.xyz(pdbs$xyz[1, gaps.pos$f.inds],
               pdbs$xyz[, gaps.pos$f.inds],
               fixed.inds=core$xyz,
               mobile.inds=core$xyz)

# Find domains
gs <- geostas(xyz, k=4, fit=FALSE)

# Perform PCA
pc.xray <- pca.xyz(xyz)

# Make trajectory
mktrj(pc.xray, pc=1, chain=gs$grps)

}
}
\keyword{ analysis }

\name{atom2ele}
\alias{atom2ele}
\alias{atom2ele.default}
\alias{atom2ele.pdb}
\title{ Atom Names/Types to Atomic Symbols Converter }
\description{
  Convert atom names/types into atomic symbols
}
\usage{
atom2ele(\dots)

\method{atom2ele}{default}(x, elety.custom=NULL, rescue=TRUE, \dots)

\method{atom2ele}{pdb}(pdb, inds=NULL, \dots)
}
\arguments{
  \item{x}{a character vector containing atom names/types to be converted.}
  \item{elety.custom}{a customized data.frame containing atom
    names/types and corresponding atomic symbols.} 
  \item{rescue}{logical, if TRUE the atomic symbols will be converted 
    based on matching with \code{bio3d::elements$symb}. }
  \item{pdb}{an object of class \sQuote{pdb} for which \code{elety} will
    be converted.} 
  \item{inds}{an object of class \sQuote{select} indicating a subset of
    the \code{pdb} object to be used (see \code{\link{atom.select}} and
    \code{\link{trim.pdb}}).} 
  \item{\dots}{further arguments passed to or from other methods.} 
}
\details{
  The default method searchs for the atom names/types in the
  \code{\link{atom.index}} data set and returns their corresponding atomic
  symbols. If \code{elety.custom} is specified it is combined with
  \code{\link{atom.index}} (using \code{rbind}) before
  searching. Therefore, \code{elety.custom} must contains columns named
  \code{name} and \code{symb}. 
  
  The S3 method for object of class \sQuote{pdb}, pass
  \code{pdb$atom[,"elety"]} to the default method. 
}
\value{Return a character vector of atomic symbols}
\author{Julien Ide, Lars Skjaerven}
\seealso{
  \code{\link{atom.index}},  \code{\link{elements}},
  \code{\link{read.pdb}},
  \code{\link{atom2mass}}, \code{\link{formula2mass}}
}
\examples{
atom.names <- c("CA", "O", "N", "OXT")
atom2ele(atom.names)

\donttest{
# PDB server connection required - testing excluded

## Get atomic symbols from a PDB object with a customized data set
pdb <- read.pdb("3RE0",verbose=FALSE)
lig <- trim(pdb, "ligand")

## maps PT1 to Pt, CL2 to Cl, C4A to C
atom2ele(lig)

## map atom name to element manually
myelety <- data.frame(name = "CL2", symb = "Cl")
atom2ele(lig, elety.custom = myelety)

}
}
\keyword{ utilities }

\name{read.pqr}
\alias{read.pqr}
\title{ Read PQR File }
\description{
  Read a PQR coordinate file.
}
\usage{
read.pqr(file, maxlines = -1, multi = FALSE, rm.insert = FALSE,
         rm.alt = TRUE, verbose = TRUE)
}
\arguments{
  \item{file}{ the name of the PQR file to be read. }
  \item{maxlines}{ the maximum number of lines to read before giving up
    with large files. By default if will read up to the end of input on
    the connection. }
  \item{multi}{ logical, if TRUE multiple ATOM records are read for all
    models in multi-model files. }
  \item{rm.insert}{ logical, if TRUE PDB insert records are ignored. }
  \item{rm.alt}{ logical, if TRUE PDB alternate records are ignored. }
  \item{verbose}{ print details of the reading process. }
}
\details{
  PQR file format is basically the same as PDB format except for the fields of
  \code{o} and \code{b}. In PDB, these two fields are filled with \sQuote{Occupancy}
  and \sQuote{B-factor} values, respectively, with each field 6-column long.
  In PQR, they are atomic \sQuote{partial charge} and \sQuote{radii}
  values, respectively, with each field 8-column long.

  \code{maxlines} may require increasing for some large multi-model files.
  The preferred means of reading such data is via binary DCD format 
  trajectory files (see the \code{\link{read.dcd}} function).
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a data.frame containing all atomic coordinate ATOM and
    HETATM data, with a row per ATOM/HETATM and a column per record type.
    See below for details of the record type naming convention (useful for
    accessing columns). }
  \item{helix }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of H
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{sheet }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{seqres }{ sequence from SEQRES field. }
  \item{xyz }{ a numeric matrix of class \code{"xyz"} containing the
    ATOM and HETATM coordinate data. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\note{ 
  For both \code{atom} and \code{het} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno} ,
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Chain identifier \dQuote{chain},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Occupancy \dQuote{o}, and
  Temperature factor \dQuote{b}.
  See examples for further details.
}
\seealso{ \code{\link{atom.select}}, \code{\link{write.pqr}}, 
  \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

# Read a PDB file and write it as a PQR file
pdb <- read.pdb( "4q21" )
outfile = file.path(tempdir(), "eg.pqr")
write.pqr(pdb=pdb, file = outfile)

# Read the PQR file
pqr <- read.pqr(outfile)

## Print a brief composition summary
pqr

## Examine the storage format (or internal *str*ucture)
str(pqr)

## Print data for the first four atom
pqr$atom[1:4,]

## Print some coordinate data
head(pqr$atom[, c("x","y","z")])

## Print C-alpha coordinates (can also use 'atom.select' function)
head(pqr$atom[pqr$calpha, c("resid","elety","x","y","z")])
inds <- atom.select(pqr, elety="CA")
head( pqr$atom[inds$atom, ] )

## The atom.select() function returns 'indices' (row numbers)
## that can be used for accessing subsets of PDB objects, e.g.
inds <- atom.select(pqr,"ligand")
pqr$atom[inds$atom,]
pqr$xyz[inds$xyz]

## See the help page for atom.select() function for more details.

}
}
\keyword{ IO }

\name{pymol}
\alias{pymol}
\alias{pymol.pdbs}
\alias{pymol.nma}
\alias{pymol.pca}
\alias{pymol.modes}
\alias{pymol.dccm}
\title{ Biomolecular Visualization with PyMOL }
\description{
  Visualize Bio3D structure objects in PyMOL
}
\usage{
pymol(\dots)

\method{pymol}{pdbs}(pdbs, col=NULL, as="ribbon", file=NULL, type="script",
                     exefile="pymol", user.vec=NULL, \dots)

\method{pymol}{nma}(\dots)

\method{pymol}{pca}(\dots)

\method{pymol}{modes}(modes, mode=NULL, file=NULL, scale=5, dual=FALSE,
                     type="script", exefile="pymol", \dots)

\method{pymol}{dccm}(dccm, pdb, file=NULL,
                     step=0.2, omit=0.2, radius = 0.15,
                     type="script", exefile="pymol", \dots)


}
\arguments{
  \item{pdbs}{ aligned C-alpha Cartesian coordinates as obtained with 
    \code{\link{read.fasta.pdb}} or \code{\link{pdbaln}}. }
  \item{col}{ a single element character vector specifying the coloring
    of the structures. Options are: \sQuote{index}, \sQuote{index2},
    \sQuote{gaps}, \sQuote{rmsf}, \sQuote{user}.

    Special cases: Provide a \sQuote{core} object as obtained by
    \code{core.find} to color on the invariant core. Alternatively,
    provide a vector containing the color code for each structure in the
    \sQuote{pdbs} object. }
  \item{user.vec}{ User defined vector for coloring. Only used if \code{col="user"}. }
  \item{as}{ show as \sQuote{ribbon}, \sQuote{cartoon}, \sQuote{lines}, \sQuote{putty}. }
  \item{file}{ a single element character vector specifying the file name
    of the PyMOL session/script file. }
  \item{type}{ a single element character vector specifying the output
    type: \sQuote{script} generates a .pml script; \sQuote{session}
    generates a .pse session file; \sQuote{launch} launches pymol. }
  \item{exefile}{ file path to the \sQuote{PYMOL} program on your system (i.e.
    how is \sQuote{PYMOL} invoked). If \code{NULL}, use OS-dependent 
    default path to the program. }
  \item{modes}{ an object of class \code{nma} or \code{pca} as obtained
    from functions \code{nma} or \code{pca.xyz}. }
  \item{mode}{ the mode number for which the vector field should be
    made. } 
  \item{scale}{ global scaling factor. }
  \item{dual}{ logical, if TRUE mode vectors are also drawn in both
    direction. }
  \item{dccm}{ an object of class \code{dccm} as obtained from
    function \code{\link{dccm}}. }
  \item{pdb}{ an object of class \code{pdb} as obtained from
    function \code{read.pdb} or a numerical vector of Cartesian
    coordinates. }
  \item{step}{ binning interval of cross-correlation coefficents. }
  \item{omit}{ correlation coefficents with values (0-omit, 0+omit) will
    be omitted from visualization. }
  \item{radius}{ numeric, radius of visualized correlation cylinders in
    PyMol. Alternatively, a matrix with the same dimesions as
    \code{dccm} can be provided, e.g. to draw cylinders with radii
    associated to the pairwise correlation value. }
  \item{\dots}{ arguments passed to function \code{pymol.modes} for
    \sQuote{nma} and \sQuote{pca} objects. }
}
\details{
  These functions provides a convenient approach for the visualization of
  Bio3D objects in PyMOL. See examples for more details.

  DCCM PyMOL visualization:
  This function generates a PyMOL (python) script that will draw colored
  lines between (anti)correlated residues. The PyMOL script file is
  stored in the working directory with filename \dQuote{R.py}.
  PyMOL will only be launched (and opened)  when using argument
  \sQuote{type='launch'}. Alternatively a PDB file with CONECT records
  will be generated (when argument \code{type='pdb'}). 
   
  For the PyMOL version, PyMOL CGO objects are generated - each object
  representing a range of correlation values (corresponding to the
  actual correlation values as found in the correlation
  matrix). E.g. the PyMOL object with name \dQuote{cor_-1_-08} would
  display all pairs of correlations with values between -1 and -0.8.

  NMA / PCA PyMOL vector field visualization:
  This function generates a PyMOL (python) script for drawing
  mode vectors on a PDB structure. The PyMOL script file is stored in
  the working directory with filename \dQuote{R.py}. 

}
\value{
  Called for its action
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{view}
}
\examples{
\dontrun{

##- pymol with a 'pdbs' object
attach(transducin)

# build a pymol session containing all structures in the PDBs object
pymol(pdbs)

# color by invariant core (
# core <- core.find(pdbs)
pymol(pdbs, col=core)

# color by RMSF
pymol(pdbs, col="rmsf")

# color by a user defined vector
# For example, colored by averaged contact density around each residue
cm <- cmap(pdbs, binary=FALSE)
vec <- rowSums(cm, na.rm=TRUE)
pymol(pdbs, col="user", user.vec=vec)

# color by clustering
rd <- rmsd(pdbs$xyz)
hc <- hclust(as.dist(rd))
grps <- cutree(hc, k=3)
pymol(pdbs, col=grps)



##- pymol with a 'dccm' object
## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate normal modes
modes <- nma(pdb)

## Calculate correlation matrix
cm <- dccm.nma(modes)

pymol(cm, modes$xyz)



##- pymol with a 'nma' or 'pca' object
pymol(modes, mode=7)

detach(transducin)
}
}

\name{get.pdb}
\alias{get.pdb}
\title{ Download PDB Coordinate Files }
\description{
  Downloads PDB coordinate files from the RCSB Protein Data Bank.
}
\usage{
get.pdb(ids, path = ".", URLonly=FALSE, overwrite = FALSE, gzip = FALSE, 
     split = FALSE, format = "pdb", verbose = TRUE, ncore = 1, ...)
}
\arguments{
  \item{ids}{ A character vector of one or more 4-letter PDB
    codes/identifiers or 6-letter PDB-ID_Chain-ID of the files to be downloaded, or a \sQuote{blast}
    object containing \sQuote{pdb.id}. }
  \item{path}{ The destination path/directory where files are to be
    written. }
  \item{URLonly}{ logical, if TRUE a character vector containing the URL
    path to the online file is returned and files are not downloaded. If
    FALSE the files are downloaded. }
  \item{overwrite}{ logical, if FALSE the file will not be downloaded if
    it alread exist. }
  \item{gzip}{ logical, if TRUE the gzipped PDB will be downloaded and
    extracted locally. }
  \item{split}{ logical, if TRUE \code{\link{pdbsplit}} funciton will be called to split pdb files
    into separated chains. }
  \item{format}{ format of the data file: \sQuote{pdb} or
    \sQuote{cif} for PDB and mmCIF file formats, respectively. }
  \item{verbose}{ print details of the reading process. }
  \item{ncore}{ number of CPU cores used to do the calculation.
     \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{\dots}{ extra arguments passed to \code{\link{pdbsplit}} function. }
}
\details{
  This is a basic function to automate file download from the PDB.
}
\value{
  Returns a list of successfully downloaded files. Or optionally if URLonly
  is TRUE a list of URLs for said files.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{write.pdb}},
  \code{\link{atom.select}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}}, \code{\link{pdbsplit}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

## PDB file paths
get.pdb( c("1poo", "1moo"), URLonly=TRUE )

## These URLs can be used by 'read.pdb'
pdb <- read.pdb( get.pdb("5p21", URL=TRUE) )
summary(pdb)

## Download PDB file
## get.pdb("5p21")
}
}
\keyword{utilities}

\name{entropy}
\alias{entropy}
\title{ Shannon Entropy Score }
\description{
  Calculate the sequence entropy score for every position in an alignment.
}
\usage{
entropy(alignment)
}
\arguments{
  \item{alignment}{ sequence alignment returned from
    \code{\link{read.fasta}} or an alignment character matrix. }
}
\details{
  Shannon's information theoretic entropy (Shannon, 1948) is an
  often-used measure of residue diversity and hence residue conservation.
}
\value{
  Returns a list with five components:
  \item{H }{standard entropy score for a 22-letter alphabet.}
  \item{H.10 }{entropy score for a 10-letter alphabet (see below).}
  \item{H.norm }{ normalized entropy score (for 22-letter alphabet), so that 
    conserved (low entropy) columns (or positions) score 1, and diverse
    (high entropy) columns score 0.}
  \item{H.10.norm }{ normalized entropy score (for 10-letter alphabet),
    so that conserved (low entropy) columns score 1 and diverse
    (high entropy) columns score 0.}  
  \item{freq }{residue frequency matrix containing percent occurrence
    values for each residue type.}
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.

  Shannon (1948) \emph{The System Technical J.} \bold{27}, 379--422.
  
  Mirny and Shakhnovich (1999) \emph{J. Mol. Biol.} \bold{291}, 177--196.
}
\author{ Barry Grant }
\note{ 
  In addition to the standard entropy score (based on a 22-letter
  alphabet of the 20 standard amino-acids, plus a gap character \sQuote{-}
  and a mask character \sQuote{X}), an entropy score, \code{H.10}, based on
  a 10-letter alphabet is also returned.

  For \code{H.10}, residues from the 22-letter alphabet are classified
  into one of 10 types, loosely following the convention of Mirny and
  Shakhnovich (1999):
  Hydrophobic/Aliphatic [V,I,L,M],
  Aromatic [F,W,Y],
  Ser/Thr [S,T],
  Polar [N,Q],
  Positive [H,K,R],
  Negative [D,E],
  Tiny [A,G],
  Proline [P],
  Cysteine [C], and
  Gaps [-,X].

  The residue code \sQuote{X} is useful for handling non-standard aminoacids.
}
\seealso{ \code{\link{consensus}}, \code{\link{read.fasta}} }
\examples{

# Read HIV protease alignment 
aln <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))

# Entropy and consensus
h   <- entropy(aln)
con <- consensus(aln)

names(h$H)=con$seq
print(h$H)

# Entropy for sub-alignment (positions 1 to 20) 
h.sub <- entropy(aln$ali[,1:20])

# Plot entropy and residue frequencies (excluding positions >=60 percent gaps)
H <- h$H.norm
H[ apply(h$freq[21:22,],2,sum)>=0.6 ] = 0

col <- mono.colors(32)
aa  <- rev(rownames(h$freq))
oldpar <- par(no.readonly=TRUE)
layout(matrix(c(1,2),2,1,byrow = TRUE), widths = 7, 
       heights = c(2, 8), respect = FALSE)

# Plot 1: entropy
par(mar = c(0, 4, 2, 2))
barplot(H, border="white", ylab = "Entropy",
        space=0, xlim=c(3.7, 97.3),yaxt="n" )
axis(side=2, at=c(0.2,0.4, 0.6, 0.8))
axis(side=3, at=(seq(0,length(con$seq),by=5)-0.5),
     labels=seq(0,length(con$seq),by=5))
box()

# Plot2: residue frequencies 
par(mar = c(5, 4, 0, 2))
image(x=1:ncol(con$freq),
      y=1:nrow(con$freq),
      z=as.matrix(rev(as.data.frame(t(con$freq)))),
      col=col, yaxt="n", xaxt="n",
      xlab="Alignment Position", ylab="Residue Type")
axis(side=1, at=seq(0,length(con$seq),by=5))
axis(side=2, at=c(1:22), labels=aa)
axis(side=3, at=c(1:length(con$seq)), labels =con$seq)
axis(side=4, at=c(1:22), labels=aa)
grid(length(con$seq), length(aa))
box()

for(i in 1:length(con$seq)) {
  text(i, which(aa==con$seq[i]),con$seq[i],col="white")
}
abline(h=c(3.5, 4.5, 5.5, 3.5, 7.5, 9.5,
         12.5, 14.5, 16.5, 19.5), col="gray")

par(oldpar)
}
\keyword{ utilities }

\name{as.pdb}
\alias{as.pdb}
\alias{as.pdb.mol2}
\alias{as.pdb.prmtop}
\alias{as.pdb.default}
\title{ Convert to PDB format }
\description{
  Convert Tripos Mol2 format, or Amber parameter/topology and coordinate data to PDB format.
}
\usage{
as.pdb(\dots)

\method{as.pdb}{mol2}(mol, \dots)

\method{as.pdb}{prmtop}(prmtop, crd=NULL, inds=NULL, inds.crd=inds, ncore=NULL, \dots)

\method{as.pdb}{default}(pdb=NULL, xyz=NULL, type=NULL, resno=NULL,
                   resid=NULL, eleno=NULL, elety=NULL, chain=NULL, 
                   insert=NULL, alt=NULL, o=NULL, b=NULL, segid=NULL, 
                   elesy=NULL, charge=NULL, verbose=TRUE, \dots)
}
\arguments{
  \item{\dots}{ arguments passed to and from functions. }
  \item{mol}{ a list object of type \code{"mol2"} (obtained with
    \code{\link{read.mol2}}). }
  \item{prmtop}{ a list object of type \code{"prmtop"} (obtained with
    \code{\link{read.prmtop}}). }
  \item{crd}{ a list object of type \code{"crd"} (obtained with
    \code{\link{read.crd.amber}}). }
  \item{inds}{ a list object of type \code{"select"} as obtained from
    \code{\link{atom.select}}. The indices points to which atoms in the
    PRMTOP object to convert. }
  \item{inds.crd}{ same as the \sQuote{inds} argument, but pointing to
    the atoms in CRD object to convert. By default, this argument equals
    to \sQuote{inds}, assuming the same number and sequence of atoms in the
    PRMTOP and CRD objects. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }

  \item{pdb}{ an object of class \sQuote{pdb} as obtained from
    \code{\link{read.pdb}}. }
  \item{xyz}{ a numeric vector/matrix of Cartesian coordinates. If
    provided, the number of atoms in the new PDB object will be set to
    \code{ncol(as.xyz(xyz))/3} (see \code{\link{as.xyz}}).

    If \code{xyz} is not provided the number of atoms will be based on
    the length of \code{eleno}, \code{resno}, or \code{resid} (in that
    order). }
  \item{type}{ a character vector of record types, i.e. "ATOM" or "HETATM",
    with length equal to \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element
    character vector can be provided which will be repeated to match
    the number of atoms. }
  \item{resno}{ a numeric vector of residue numbers of length equal to
    \code{ncol(as.xyz(xyz))/3}. }
  \item{resid}{ a character vector of residue types/ids of length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element
    character vector can be provided which will be repeated to match
    the number of atoms. }
  \item{eleno}{ a numeric vector of element/atom numbers of length equal to
    \code{ncol(as.xyz(xyz))/3}. }
  \item{elety}{ a character vector of element/atom types of length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element
    character vector can be provided which will be repeated to match
    the number of atoms. }
  \item{chain}{ a character vector of chain identifiers with length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element
    character vector can be provided which will be repeated to match
    the number of atoms. }
  \item{insert}{ a character vector of insertion code with length equal to
    \code{ncol(as.xyz(xyz))/3}. }
  \item{alt}{ a character vector of alternate record with length equal to
    \code{ncol(as.xyz(xyz))/3}. }
  \item{o}{ a numeric vector of occupancy values of length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element
    numeric vector can be provided which will be repeated for to match
    the number of atoms. }
  \item{b}{ a numeric vector of B-factors of length equal to \code{ncol(as.xyz(xyz))/3}.
    Alternatively, a single element numeric vector can be provided
    which will be repeated to match the number of atoms.}
  \item{segid}{ a character vector of segment id of length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element character vector can
    be provided which will be repeated to match the number of
    atoms. }
  \item{elesy}{ a character vector of element symbol of length equal to
    \code{ncol(as.xyz(xyz))/3}. Alternatively, a single element character vector can
    be provided which will be repeated to match the number of
    atoms. }
  \item{charge}{ a numeric vector of atomic charge of length equal to
    \code{ncol(as.xyz(xyz))/3}. }
  \item{verbose}{ logical, if TRUE details of the PDB generation process
    is printed to screen. }
}
\details{
  This function converts Tripos Mol2 format, Amber formatted parameter/topology
  (PRMTOP) and coordinate objects, and vector data to a PDB object.

  While \code{as.pdb.mol2} and \code{as.pdb.prmtop} converts specific
  objects to a PDB object, \code{as.pdb.default} provides basic
  functionality to convert raw data such as vectors of e.g. residue numbers,
  residue identifiers, Cartesian coordinates, etc to a PDB object. When
  \code{pdb} is provided the returned PDB object is built from the input
  object with fields replaced by any input vector arguments.
  e.g. \code{as.pdb(pdb, xyz=crd)} will return the same PDB object, with
  only the Cartesian coordinates changed to \code{crd}.
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a data.frame containing all atomic coordinate ATOM data,
    with a row per ATOM and a column per record type.  See below for details
    of the record type naming convention (useful for accessing columns). }
  \item{xyz }{ a numeric matrix of ATOM coordinate data of class \code{xyz}. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
  \item{call }{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  \url{http://ambermd.org/FileFormats.php}
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{read.crd}}, \code{\link{read.ncdf}},
  \code{\link{atom.select}}, \code{\link{read.pdb}}
}
\examples{
## Vector(s) to PDB object
pdb <- as.pdb(resno=1:6, elety="CA", resid="ALA", chain="A")
pdb

\dontrun{
## Read a PRMTOP file
prmtop <- read.prmtop(system.file("examples/crambin.prmtop", package="bio3d"))

## Read Amber coordinates
crds <- read.crd(system.file("examples/crambin.inpcrd", package="bio3d"))

## Atom selection
ca.inds <- atom.select(prmtop, "calpha")

## Convert to PDB format
pdb <- as.pdb(prmtop, crds, inds=ca.inds)


## Read a single entry MOL2 file
## (returns a single object)
mol <- read.mol2( system.file("examples/aspirin.mol2", package="bio3d") )

## Convert to PDB
pdb <- as.pdb(mol)
}
}
\keyword{ IO }

\name{plot.enma}
\alias{plot.enma}
\title{ Plot eNMA Results }
\description{
  Produces a plot of atomic fluctuations of aligned normal modes.
}
\usage{
\method{plot}{enma}(x,
        pdbs = NULL,
        xlab = NULL,
        ylab="Fluctuations", ...)
}
\arguments{
  \item{x}{ the results of ensemble NMA obtained with
    \code{\link{nma.pdbs}}. Alternatively, a matrix in the similar
    format as \code{enma$fluctuations} can be provided. }
  \item{pdbs}{ an object of class \sQuote{pdbs} in which the
    \sQuote{enma} object \code{x} was obtained from. If provided SSE
    data of the first structure of \code{pdbs} will drawn. }
  \item{xlab}{ a label for the x axis. }
  \item{ylab}{ labels for the y axes. }
  \item{\dots}{ extra plotting arguments passed to \code{plot.fluct}
    that effect the atomic fluctuations plot only. }
}
\details{
  \code{plot.enma} produces a fluctuation plot of aligned \code{nma}
  objects. If corresponding \code{pdbs} object is provided the plot
  contains SSE annotation and appropriate resiude index numbering.
}
\value{
  Called for its effect.
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven, Barry Grant }
\seealso{ \code{\link{nma}},
  \code{\link{plotb3}}, \code{\link{plot.fluct}} }
\examples{
\dontrun{
ids <- c("1a70_A", "1czp_A", "1frd_A", "1fxi_A", "1iue_A", "1pfd_A")
raw.files <- get.pdb(ids, path = "raw_pdbs")
files <- pdbsplit(raw.files, ids, path = "raw_pdbs/split_chain")

## Sequence/structure alignement
pdbs <- pdbaln(files)

## Normal mode analysis on aligned data
modes <- nma(pdbs)

## Plot fluctuations
plot(modes, pdbs=pdbs)

## Group and spread fluctuation profiles
hc <- hclust(as.dist(1-modes$rmsip))
col <- cutree(hc, k=2)
plot(modes, pdbs=pdbs, col=col, spread=TRUE)
}
}
\keyword{ hplot }

\name{aa123}
\alias{aa123}
\alias{aa321}
\title{ Convert Between 1-letter and 3-letter Aminoacid Codes }
\description{
  Convert between one-letter IUPAC aminoacid codes and three-letter PDB
  style aminoacid codes.
}
\usage{
aa123(aa)
aa321(aa)
}
\arguments{
  \item{aa}{ a character vector of individual aminoacid codes. }
}
\details{
  Standard conversions will map \sQuote{A} to \sQuote{ALA}, \sQuote{G} to
  \sQuote{GLY}, etc.
  Non-standard codes in \code{aa} will generate a warning and return
  \sQuote{UNK} or \sQuote{X}.
}

\value{
  A character vector of aminoacid codes.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of IUPAC one-letter codes see:\cr
  \url{https://www.insdc.org/documents/feature_table.html#7.4.3}
  
  For more information on PDB residue codes see:\cr
  \url{http://ligand-expo.rcsb.org/ld-search.html}

}
\author{ Barry Grant }
\seealso{ \code{\link{read.pdb}}, \code{\link{read.fasta}}, \code{\link{pdbseq}} }
\examples{
# Simple conversion
aa123(c("D","L","A","G","S","H"))
aa321(c("ASP", "LEU", "ALA", "GLY", "SER", "HIS"))

\dontrun{
# Extract sequence from a PDB file's ATOM and SEQRES cards
pdb <- read.pdb("1BG2") 
s <- aa321(pdb$seqres)                   # SEQRES
a <- aa321(pdb$atom[pdb$calpha,"resid"]) # ATOM

# Write both sequences to a fasta file
write.fasta(alignment=seqbind(s,a), id=c("seqres","atom"), file="eg2.fa")

# Alternative approach for ATOM sequence extraction
pdbseq(pdb)
pdbseq(pdb, aa1=FALSE )
}
}
\keyword{ utilities }

\name{network.amendment}
\alias{network.amendment}
\title{ Amendment of a CNA Network According To A Input Community Membership Vector.  }
\description{
  This function changes the \sQuote{communities} attribute of a 
  \sQuote{cna} class object to match a given membership vector.
}
\usage{
  network.amendment(x, membership, minus.log=TRUE)
}
\arguments{
  \item{x}{  A protein network graph object as obtained from the
    \sQuote{cna} function. }
  \item{membership}{ A numeric vector containing the new community
    membership. } 
  \item{minus.log}{ Logical. Whether to use the minus.log on the cij
    values. }
}
\value{
  Returns a \sQuote{cna} class object with the attributes changed
  according to the membership vector provided.
}
\details{
  This function is useful, in combination with \sQuote{community.tree}, 
  for inspecting different community partitioning options of a input 
  \sQuote{cna} object. See examples.
} 
\author{ Guido Scarabelli }  
\seealso{
   \code{\link{cna}}, \code{\link{community.tree}}, \code{\link{summary.cna}} 
}
\examples{
\donttest{
# PDB server connection required - testing excluded

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

##-- Build a CNA object
pdb <- read.pdb("4Q21")
modes <- nma(pdb)
cij <- dccm(modes)
net <- cna(cij, cutoff.cij=0.2)

##-- Community membership vector for each clustering step
tree <- community.tree(net, rescale=TRUE)

## Produce a new k=7 membership vector and CNA network
memb.k7 <- tree$tree[ tree$num.of.comms == 7, ]
net.7 <- network.amendment(net, memb.k7)

plot(net.7, pdb)

print(net)
print(net.7)

}
}
}
\keyword{utility}

\name{bhattacharyya}
\alias{bhattacharyya}
\alias{bhattacharyya.nma}
\alias{bhattacharyya.pca}
\alias{bhattacharyya.enma}
\alias{bhattacharyya.array}
\alias{bhattacharyya.matrix}
\title{ Bhattacharyya Coefficient }
\description{
  Calculate the Bhattacharyya Coefficient as a similarity between two
  modes objects.
}
\usage{
bhattacharyya(...)

\method{bhattacharyya}{enma}(enma, covs=NULL, ncore=NULL, ...)

\method{bhattacharyya}{array}(covs, ncore=NULL, ...)

\method{bhattacharyya}{matrix}(a, b, q=90, n=NULL, ...)

\method{bhattacharyya}{nma}(...)

\method{bhattacharyya}{pca}(...)
}
\arguments{
  \item{enma}{ an object of class \code{"enma"} obtained from function
    \code{nma.pdbs}. }
  \item{covs}{ an array of covariance matrices of equal dimensions. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{a}{ covariance matrix to be compared with \code{b}. }
  \item{b}{ covariance matrix to be compared with \code{a}. }
  \item{q}{ a numeric value (in percent) determining the number of modes
    to be compared. }
  \item{n}{ the number of modes to be compared. }
  \item{\dots}{ arguments passed to associated functions. }
}
\details{
  Bhattacharyya coefficient provides a means to compare two covariance
  matrices derived from NMA or an ensemble of conformers
  (e.g. simulation or X-ray conformers).  
}
\value{
  Returns the similarity coefficient(s).
}
\references{
  Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
  Fuglebakk, E. et al. (2013) \emph{JCTC} \bold{9}, 5618--5628.
}
\author{ Lars Skjaerven }
\seealso{Other similarity measures:
  \code{\link{sip}}, \code{\link{covsoverlap}}, \code{\link{rmsip}}.
}
\keyword{ utilities }

\name{conserv}
\alias{conserv}
\title{ Score Residue Conservation At Each Position in an Alignment }
\description{
  Quantifies residue conservation in a given protein sequence alignment
  by calculating the degree of amino acid variability in each column of
  the alignment.
}
\usage{
conserv(x, method = c("similarity","identity","entropy22","entropy10"),
        sub.matrix = c("bio3d", "blosum62", "pam30", "other"),
        matrix.file = NULL, normalize.matrix = TRUE)
}
\arguments{
  \item{x}{ an alignment list object with \code{id} and \code{ali}
    components, similar to that generated by \code{\link{read.fasta}}. }
  \item{method}{ the conservation assesment method. }
  \item{sub.matrix}{ a matrix to score conservation. }
  \item{matrix.file}{ a file name of an arbitary user matrix. }
  \item{normalize.matrix}{ logical, if TRUE the matrix is normalized
    pior to assesing conservation. }
}
\details{
  To assess the level of sequence conservation at each position in an
alignment, the \dQuote{similarity}, \dQuote{identity}, and
\dQuote{entropy} per position can be calculated.

The \dQuote{similarity} is defined as the average of the similarity
scores of all pairwise residue comparisons for that position in the
alignment, where the similarity score between any two residues is the
score value between those residues in the chosen substitution matrix
\dQuote{sub.matrix}.

The \dQuote{identity} i.e. the preference for a specific amino acid to
be found at a certain position, is assessed by averaging the identity
scores resulting from all possible pairwise comparisons at that position
in the alignment, where all identical residue comparisons are given a
score of 1 and all other comparisons are given a value of 0.

\dQuote{Entropy} is based on Shannons information entropy. See the
\code{\link{entropy}} function for further details.

Note that the returned scores are normalized so that conserved columns
score 1 and diverse columns score 0.
}
\value{
  Returns a numeric vector of scores
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  Grant, B.J. et al. (2007) \emph{J. Mol. Biol.} \bold{368}, 1231--1248.
  
}
\author{ Barry Grant }
\note{
  Each of these conservation scores has particular strengths and
  weaknesses.  For example, entropy elegantly captures amino acid
  diversity but fails to account for stereochemical similarities. By
  employing a combination of scores and taking the union of their
  respective conservation signals we expect to achieve a more
  comprehensive analysis of sequence conservation (Grant, 2007).
}
\seealso{ \code{\link{read.fasta}}, \code{\link{read.fasta.pdb}} }
\examples{
## Read an example alignment
aln <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))

## Score conservation
conserv(x=aln$ali, method="similarity", sub.matrix="bio3d")
##conserv(x=aln$ali,method="entropy22", sub.matrix="other")

}
\keyword{ utilities }

\name{dccm.nma}
\alias{dccm.nma}
\title{ Dynamic Cross-Correlation from Normal Modes Analysis }
\description{
  Calculate the cross-correlation matrix from Normal Modes Analysis.
}
\usage{
\method{dccm}{nma}(x, nmodes = NULL, ncore = NULL, progress = NULL, \dots)
}
\arguments{
  \item{x}{ an object of class \code{nma} as obtained from
    function \code{nma}. }
  \item{nmodes}{ numerical, number of modes to consider. }
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. }
  \item{progress}{ progress bar for use with shiny web app. }
  \item{\dots}{ additional arguments ? }
}
\details{
  This function calculates the cross-correlation matrix from Normal
  Modes Analysis (NMA) obtained from \code{nma} of a protein
  structure.  It returns a matrix of residue-wise cross-correlations
  whose elements, Cij, may be displayed in a graphical
  representation frequently termed a dynamical cross-correlation
  map, or DCCM.

  If Cij = 1 the fluctuations of residues i and j are completely
  correlated (same period and same phase), if Cij = -1 the
  fluctuations of residues i and j are completely anticorrelated (same
  period and opposite phase), and if Cij = 0 the fluctuations of i
  and j are not correlated.
}
\value{
  Returns a cross-correlation matrix.
}
\references{
  Wynsberghe. A.W.V, Cui, Q. \emph{Structure} \bold{14}, 1647--1653.
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma}}, \code{\link{plot.dccm}} }
\examples{

## Fetch stucture
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

## Calculate normal modes
modes <- nma(pdb)

## Calculate correlation matrix
cm <- dccm.nma(modes)

## Plot correlation map
plot(cm, sse = pdb, contour = FALSE, col.regions = bwr.colors(20),
     at = seq(-1, 1, 0.1))
}
\keyword{ analysis }

\name{var.xyz}
\alias{var.xyz}
\alias{var.pdbs}
\title{ Pairwise Distance Variance in Cartesian Coordinates }
\description{
  Calculate the variance of all pairwise distances in an ensemble of
  Cartesian coordinates.
}
\usage{
var.xyz(xyz, weights=TRUE)
var.pdbs(pdbs, ...)
}
\arguments{
  \item{xyz}{ an object of class \code{"xyz"} containing Cartesian
    coordinates in a matrix. }
  \item{weights }{ logical, if TRUE weights are calculated based on the
    pairwise distance variance. }
  \item{pdbs}{ a \sQuote{pdbs} object as object from function
    \code{pdbaln}. }
  \item{\dots}{ arguments passed to associated functions. }
}
\details{
  This function calculates the variance of all pairwise distances in an
  ensemble of Cartesian coordinates. The primary use of this function is
  to calculate weights to scale the pair force constant for NMA. 
}
\value{
  Returns the a matrix of the pairwise distance variance, formated as
  weights if \sQuote{weights=TRUE}. 
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.   
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{nma.pdbs}} }
\keyword{ utilities }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aanma.R, R/aanma.pdb.R, R/rtb.R
\name{aanma}
\alias{aanma}
\alias{aanma.pdb}
\alias{rtb}
\title{All Atom Normal Mode Analysis}
\usage{
aanma(...)

\method{aanma}{pdb}(pdb, pfc.fun = NULL, mass = TRUE, temp = 300,
  keep = NULL, hessian = NULL, outmodes = "calpha", rm.wat = TRUE,
  reduced = FALSE, rtb = FALSE, nmer = 1, ...)

rtb(hessian, pdb, mass = TRUE, nmer = 1, verbose = TRUE)
}
\arguments{
\item{...}{additional arguments to \code{\link{build.hessian}} and
\code{\link{aa2mass}}. One useful option here for dealing with
unconventional residues is \sQuote{mass.custom}, see the
\code{\link{aa2mass}} function for details.}

\item{pdb}{an object of class \code{pdb} as obtained from function
\code{\link{read.pdb}}.}

\item{pfc.fun}{customized pair force constant (\sQuote{pfc}) function. The
provided function should take a vector of distances as an argument to
return a vector of force constants. If NULL, the default function
\sQuote{aaenm2} will be employed. (See details below).}

\item{mass}{logical, if TRUE the Hessian will be mass-weighted.}

\item{temp}{numerical, temperature for which the amplitudes for scaling the
atomic displacement vectors are calculated. Set \sQuote{temp=NULL} to
avoid scaling.}

\item{keep}{numerical, final number of modes to be stored. Note that all
subsequent analyses are limited to this subset of modes. This option is
useful for very large structures and cases where memory may be limited.}

\item{hessian}{hessian matrix as obtained from \code{\link{build.hessian}}.
For internal purposes and generally not intended for public use.}

\item{outmodes}{either a character (\sQuote{calpha} or \sQuote{noh}) or atom
indices as obtained from \code{\link{atom.select}} specifying the atoms to
include in the resulting mode object. (See details below).}

\item{rm.wat}{logical, if TRUE water molecules will be removed before
calculation.}

\item{reduced}{logical, if TRUE the coarse-grained (\sQuote{4-bead}) ENM will
be employed. (See details below).}

\item{rtb}{logical, if TRUE the rotation-translation block based
approximate modes will be calculated. (See details below).}

\item{nmer}{numerical, defines the number of residues per block (used only
when \code{rtb=TRUE}).}

\item{verbose}{logical, if TRUE print detailed processing message}
}
\value{
Returns an object of class \sQuote{nma} with the following
   components:
   \item{modes}{ numeric matrix with columns containing the normal mode
      vectors. Mode vectors are converted to unweighted Cartesian
      coordinates  when \code{mass=TRUE}. Note that the 6 first trivial
      eigenvectos appear in columns one to six. }
   \item{frequencies}{ numeric vector containing the vibrational
      frequencies corresponding to each mode (for \code{mass=TRUE}). }
   \item{force.constants}{ numeric vector containing the force constants
      corresponding to each mode (for \code{mass=FALSE)}). }
   \item{fluctuations}{ numeric vector of atomic fluctuations. }
   \item{U}{ numeric matrix with columns containing the raw
      eigenvectors. Equals to the \code{modes} component when
     \code{mass=FALSE} and \code{temp=NULL}. }
   \item{L}{ numeric vector containing the raw eigenvalues. }
   \item{xyz}{ numeric matrix of class \code{xyz} containing the
     Cartesian coordinates in which the calculation was performed. }
   \item{mass}{ numeric vector containing the residue masses used for the
     mass-weighting. }
   \item{temp}{ numerical, temperature for which the amplitudes for
     scaling the atomic displacement vectors are calculated. }
   \item{triv.modes}{ number of trivial modes. }
   \item{natoms}{ number of C-alpha atoms. }
   \item{call}{ the matched call. }
}
\description{
Perform all-atom elastic network model normal modes calculation of a protein
structure.
}
\details{
This function builds an elastic network model (ENM) based on all
heavy atoms of input \code{pdb}, and performs subsequent normal mode
analysis (NMA) in various manners. By default, the \sQuote{aaenm2} force
field (defining of the spring constants between atoms) is used, which was
obtained by fitting to a local energy minimum of a crambin model
derived from the AMBER99SB force field. It employs a pair force constant
function which falls as r^-6, and specific force constants for
covalent and intra-residue atom pairs. See also \code{\link{load.enmff}}
for other force field options.

The \code{outmodes} argument controls the type of output modes. There are
two standard types of output modes: \sQuote{noh} and \sQuote{calpha}.
\code{outmodes='noh'} invokes regular all-atom based ENM-NMA. When
\code{outmodes='calpha'}, an effective Hessian with respect to all C-alpha
atoms will be first calculated using the same formula as in Hinsen et al.
NMA is then performed on this effective C-alpha based Hessian. In addition,
users can provide their own atom selection (see \code{\link{atom.select}})
as the value of \code{outmodes} for customized output modes generation.

When \code{reduced=TRUE}, only a selection of all heavy atoms is used
to build the ENM. More specifically, three to five atoms per residue
constitute the model. Here the N, CA, C atoms represent the protein
backbone, and zero to two selected side chain atoms represent the side chain
(selected based on side chain size and the distance to CA). This
coarse-grained ENM has significantly improved computational efficiency and
similar prediction accuracy with respect to the all-atom ENM.

When \code{rtb=TRUE}, rotation-translation block (RTB) based approximate
modes will be calculated. In this method, each residue is assumed to be a
rigid body (or \sQuote{block}) that has only rotational and translational
degrees of freedom. Intra-residue deformation is thus ignored.
(See Durand et al 1994 and Tama et al. 2000 for more details). N residues per
block is also supported, where N=1, 2, 3, etc. (See argument \code{nmer}).
The RTB method has significantly improved computational efficiency and
similar prediction accuracy with respect to the all-atom ENM.

By default the function will diagonalize the mass-weighted Hessian matrix.
The resulting mode vectors are moreover scaled by the thermal fluctuation
amplitudes.
}
\examples{
\dontrun{
   # All-atom NMA takes relatively long time - Don't run by default.

   ## Fetch stucture
   pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )

   ## Calculate all-atom normal modes
   modes.aa <- aanma(pdb, outmodes='noh')

   ## Calculate all-atom normal modes with RTB approximation
   modes.aa.rtb <- aanma(pdb, outmodes='noh', rtb=TRUE)

   ## Compare the two modes
   rmsip(modes.aa, modes.aa.rtb)

   ## Calculate C-alpha normal modes.
   modes <- aanma(pdb)

   ## Calculate C-alpha normal modes with reduced ENM.
   modes.cg <- aanma(pdb, reduced=TRUE)

   ## Calculate C-alpha normal modes with RTB approximation
   modes.rtb <- aanma(pdb, rtb=TRUE)

   ## Compare modes
   rmsip(modes, modes.cg)
   rmsip(modes, modes.rtb)

   ## Print modes
   print(modes)

   ## Plot modes
   plot(modes)

   ## Visualize modes
   #m7 <- mktrj.nma(modes, mode=7, file="mode_7.pdb", pdb=pdb)
}
}
\author{
Lars Skjaerven & Xin-Qiu Yao
}
\references{
Hinsen, K. et al. (2000) \emph{Chem. Phys.} \bold{261}, 25.
   Durand, P. et al. (1994) \emph{Biopolymers} \bold{34}, 759.
   Tama, F. et al. (2000) \emph{Proteins} \bold{41}, 1.
}
\seealso{
\code{\link{nma.pdb}} for C-alpha based NMA, \code{\link{aanma.pdbs}} for
   ensemble all-atom NMA, \code{\link{load.enmff}} for available ENM force
   fields, and \code{\link{fluct.nma}}, \code{\link{mktrj.nma}}, and
   \code{\link{dccm.nma}} for various post-NMA calculations.
}

\name{sse.bridges}
\alias{sse.bridges}
\title{ SSE Backbone Hydrogen Bonding }
\description{
  Determine backbone C=O to N-H hydrogen bonding in secondary
  structure elements.
}
\usage{
sse.bridges(sse, type="helix", hbond=TRUE, energy.cut=-1.0)
}
\arguments{
  \item{sse}{ an sse object as obtained with \code{dssp}. }
  \item{type}{ character string specifying \sQuote{helix} or \sQuote{sheet}. }
  \item{hbond}{ use hbond records in the dssp output. }
  \item{energy.cut}{ cutoff for the dssp hbond energy. }
}
\details{
  Simple functionality to parse the \sQuote{BP} and \sQuote{hbond}
  records of the DSSP output.

  Requires input from function \code{dssp} with arguments
  \code{resno=FALSE} and \code{full=TRUE}. 
}
\value{
  Returns a numeric matrix of two columns containing the residue ids
  of the paired residues.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{read.pdb}}, \code{\link{dssp}} }
\examples{
\dontrun{
# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
sse <- dssp(pdb, resno=FALSE, full=TRUE)

sse.bridges(sse, type="helix")
}
}
\keyword{ utilities }

\name{mask}
\alias{mask}
\alias{mask.dccm}
\title{ Mask a Subset of Atoms in a DCCM Object. }
\description{
  Produce a new DCCM object with selected atoms masked.
}
\usage{
mask(\dots)

\method{mask}{dccm}(dccm, pdb = NULL, a.inds = NULL, b.inds = NULL, \dots)
}
\arguments{
  \item{dccm}{ a DCCM structure object obtained from function
    \code{\link{dccm}}. }
  \item{pdb}{ a PDB structure object obtained from
    \code{\link{read.pdb}}. Must match the dimensions of \code{dccm}. }
  \item{a.inds}{ a numeric vector containing the indices of the elements
    of the DCCM matrix in which should not be masked. Alternatively, if
    \code{pdb} is provided a selection object (as
    obtained from \code{\link{atom.select}}) can be provided. }
  \item{b.inds}{ a numeric vector containing the indices of the elements
    of the DCCM matrix in which should not be masked. }
  \item{\dots}{ arguments not passed anywhere. }
}
\details{
  This is a basic utility function for masking a DCCM object matrix to
  highlight user-selected regions in the correlation network.

  When both \code{a.inds} and \code{b.inds} are provided only their
  intersection is retained. When only \code{a.inds} is provided then
  the corresponding region to everything else is retained.

  Note: The current version assumes that the input PDB corresponds to
  the input DCCM. In many cases this will correspond to a PDB
  object containing only CA atoms.
}
\value{
  Returns a matrix list of class \code{"dccm"} with the indices/atoms
  not corresponding to the selection masked.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{
  \code{\link{dccm}}, \code{\link{atom.select}}
}
\examples{
## Calculate DCCM
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
cij <- dccm(nma(pdb))

## Mask DCCM matrix according to matrix indices
cijm <- mask(cij, a.inds=40:50, b.inds=80:90)
plot(cijm)

## Retain only 40:50 to everything else
cijm <- mask(cij, a.inds=40:50)
plot(cijm)


## Mask DCCM matrix according PDB selection
pdb.ca <- trim(pdb, "calpha")
a.inds <- atom.select(pdb.ca, resno=40:50)
b.inds <- atom.select(pdb.ca, resno=80:90)

# Provide pdb object correspoding to input dccm
cijm <- mask(cij, pdb.ca, a.inds, b.inds)
plot(cijm)
}
\keyword{ utilities }

\name{print.cna}
\alias{print.cna}
\alias{summary.cna}
\title{ Summarize and Print Features of a cna Network Graph }
\description{
  These functions attempt to summarize and print a cna network graph to
  the terminal in a human readable form.
}
\usage{
  \method{print}{cna}(x, ...)
  \method{summary}{cna}(object, verbose=TRUE, ...)
}
\arguments{
  \item{x}{ A cna network and community object as obtained from the
    function \sQuote{cna}.}
  \item{object}{ A cna network and community object as obtained from the
    function \sQuote{cna}.}
  \item{verbose}{ Logical, if TRUE a community summary table is prited 
    to screen.} 
  \item{\dots}{ Extra arguments passed to the \sQuote{write.table}
    function. }
}
\details{
  Simple summary and print methods for protein dynamic networks.
}
\value{
  The function summary.cna returns a list with the following components:
  \item{id}{ A community number/identifier vector with an element for
    each community. }
  \item{size}{ A numeric community size vector, with elements giving
    the number of nodes within each community. }
  \item{members}{ A lst detailing the nodes within each community. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{
    Guido Scarabelli and Barry Grant
}
\seealso{
  \code{\link{cna}}, \code{\link[igraph:print.igraph]{print.igraph}},
  \code{\link[igraph:print.igraph]{str.igraph}}, 
  \code{\link[igraph:plot.common]{igraph.plotting}}
}
\examples{

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

## Load the correlation network
attach(hivp)

## Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

## Examine network composition
print(net)
x<- summary(net)
x$members[[2]]

detach(hivp)

}
}
\keyword{ utilities }

\name{read.fasta}
\alias{read.fasta}
\title{ Read FASTA formated Sequences }
\description{
  Read aligned or un-aligned sequences from a FASTA format file.
}
\usage{
read.fasta(file, rm.dup = TRUE, to.upper = FALSE, to.dash=TRUE)
}
\arguments{
  \item{file}{ input sequence file. }
  \item{rm.dup}{ logical, if TRUE duplicate sequences (with the same
    names/ids) will be removed. }
  \item{to.upper}{ logical, if TRUE residues are forced to uppercase. }
  \item{to.dash}{ logical, if TRUE \sQuote{.} gap characters are
    converted to \sQuote{-} gap characters. }  
}
\value{
  A list with two components:
  \item{ali }{ an alignment character matrix with a row per sequence and
    a column per equivalent aminoacid/nucleotide. }
  \item{ids }{ sequence names as identifers.}
  \item{call}{ the matched call. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\note{  
  For a description of FASTA format see:
  \url{https://www.ncbi.nlm.nih.gov/BLAST/blastcgihelp.shtml}.
  When reading alignment files, the dash \sQuote{-} is interpreted as
  the gap character.
}
\seealso{ \code{\link{read.fasta.pdb}} }
\examples{
# Read alignment
aln <- read.fasta(system.file("examples/hivp_xray.fa",package="bio3d"))

# Print alignment overview
aln

# Sequence names/ids
head( aln$id )

# Alignment positions 335 to 339
head( aln$ali[,33:39] )

# Sequence d2a4f_b
aa123( aln$ali["d2a4f_b",] )

# Write out positions 33 to 45 only
#aln$ali=aln$ali[,30:45]
#write.fasta(aln, file="eg2.fa")

}
\keyword{ IO }

\name{uniprot}
\alias{uniprot}
\title{ Fetch UniProt Entry Data. }
\description{
  Fetch protein sequence and functional information from the UniProt
  database. 
}
\usage{
uniprot(accid)
}
\arguments{
  \item{accid}{ UniProt accession id. }
}
\details{
  This is a basic utility function for downloading information from the
  UniProt database. UniProt contains protein sequence and functional
  information.
}
\value{
  Returns a list object with the following components:
  \item{accession}{ a character vector with UniProt accession id's. }
  \item{name}{ abbreviated name. }
  \item{fullName}{ full recommended protein name. }
  \item{shortName }{ short protein name. }
  \item{sequence}{ protein sequence. }
  \item{gene}{ gene names. }
  \item{organism}{ organism. }
  \item{taxon}{ taxonomic lineage. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  See also the UniProt web-site for more information:\cr
  \url{https://www.uniprot.org/}.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{blast.pdb}}, \code{\link{get.seq}} }
\examples{
\dontrun{
# UNIPROT server connection required - testing excluded

prot <- uniprot('PH4H_HUMAN')
prot$fullName
prot$sequence
}
}
\keyword{ utilities }

\name{read.pdcBD}
\alias{read.pdcBD}
\title{ Read PQR output from pdcBD File }
\description{
  Read a pdcBD PQR coordinate file.
}
\usage{
read.pdcBD(file, maxlines = 50000, multi = FALSE, rm.insert = FALSE,
         rm.alt = TRUE, verbose = TRUE)
}
\arguments{
  \item{file}{ the name of the pdcBD PQR file to be read. }
  \item{maxlines}{ the maximum number of lines to read before giving up
    with large files. Default is 50,000 lines. }
  \item{multi}{ logical, if TRUE multiple ATOM records are read for all
    models in multi-model files. }
  \item{rm.insert}{ logical, if TRUE PDB insert records are ignored. }
  \item{rm.alt}{ logical, if TRUE PDB alternate records are ignored. }
  \item{verbose}{ print details of the reading process. }
}
\details{
  \code{maxlines} may require increasing for some large multi-model files.
  The preferred means of reading such data is via binary DCD format 
  trajectory files (see the \code{\link{read.dcd}} function).
}
\value{
  Returns a list of class \code{"pdb"} with the following components:
  \item{atom}{ a character matrix containing all atomic coordinate ATOM data, 
  with a row per ATOM and a column per record type.  See below for details
  of the record type naming convention (useful for accessing columns). }
  \item{het }{ a character matrix containing atomic coordinate records
    for atoms within \dQuote{non-standard} HET groups (see \code{atom}). }
  \item{helix }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of H
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{sheet }{ \sQuote{start}, \sQuote{end} and \sQuote{length} of E
    type sse, where start and end are residue numbers \dQuote{resno}. }
  \item{seqres }{ sequence from SEQRES field. }
  \item{xyz }{ a numeric vector of ATOM coordinate data. }
  \item{calpha }{ logical vector with length equal to \code{nrow(atom)}
    with TRUE values indicating a C-alpha \dQuote{elety}. }
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
  
  For a description of PDB format (version3.3) see:\cr
  \url{http://www.wwpdb.org/documentation/format33/v3.3.html}.
}
\author{ Barry Grant }
\note{ 
  For both \code{atom} and \code{het} list components the column names can be
  used as a convenient means of data access, namely:
  Atom serial number \dQuote{eleno} ,
  Atom type \dQuote{elety},
  Alternate location indicator \dQuote{alt},
  Residue name \dQuote{resid},
  Chain identifier \dQuote{chain},
  Residue sequence number \dQuote{resno},
  Code for insertion of residues \dQuote{insert},
  Orthogonal coordinates \dQuote{x},
  Orthogonal coordinates \dQuote{y},
  Orthogonal coordinates \dQuote{z},
  Occupancy \dQuote{o}, and
  Temperature factor \dQuote{b}.
  See examples for further details.
}
\seealso{ \code{\link{atom.select}}, \code{\link{write.pdb}},
  \code{\link{read.dcd}}, \code{\link{read.fasta.pdb}},
  \code{\link{read.fasta}} }
\examples{
\donttest{
# PDB server connection required - testing excluded

# Read a PDB file
pdb <- read.pdb( "1bg2" )
  
# Print data for the first atom
pdb$atom[1,]
# Look at the first het atom
pdb$het[1,]
# Print some coordinate data
pdb$atom[1:20, c("x","y","z")]

# Print C-alpha coordinates (can also use 'atom.select')
##pdb$xyz[pdb$calpha, c("resid","x","y","z")]

# Print SSE data (for helix and sheet)
pdb$helix
pdb$sheet$start
  
# Print SEQRES data
pdb$seqres

# Renumber residues 
nums <- as.numeric(pdb$atom[,"resno"])
pdb$atom[,"resno"] <- nums - (nums[1] - 1)

# Write out renumbered PDB file
#write.pdb(pdb=pdb,file="eg.pdb")
}
}
\keyword{ IO }

\name{prune.cna}
\alias{prune.cna}
\title{ Prune A cna Network Object }
\description{
Remove nodes and their associated edges from a cna network graph.
}
\usage{
prune.cna(x, edges.min = 1, size.min = 1)
}
\arguments{
  \item{x}{ A protein network graph object as obtained from the
    \sQuote{cna} function.}
  \item{edges.min}{ A single element numeric vector specifying the 
     minimum number of edges that retained nodes should have. Nodes 
     with less than \sQuote{edges.min} will be pruned. }
  \item{size.min}{ A single element numeric vector specifying the 
     minimum node size that retained nodes should have. Nodes 
     with less composite residues than \sQuote{size.min} will be 
     pruned. }
}
\details{
 This function is useful for cleaning up cna network plots by removing, 
for example, small isolated nodes. The output is a new cna object minus 
the pruned nodes and their associated edges. Node naming is preserved.
}
\value{
A cna class object, see function \code{\link{cna}} for details.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{
Barry Grant
}
\note{
Some improvements to this function are required, including a better effort 
to preserve the original community structure rather than calculating a 
new one. Also may consider removing nodes form the raw.network object 
that is returned also.
}
\seealso{
   \code{\link{cna}},  \code{\link{summary.cna}},
   \code{\link{vmd.cna}}, \code{\link{plot.cna}}
}
\examples{

if (!requireNamespace("igraph", quietly = TRUE)) {
   message('Need igraph installed to run this example')
} else {

# Load the correlation network
attach(hivp)

# Read the starting PDB file to determine atom correspondence
pdbfile <- system.file("examples/hivp.pdb", package="bio3d")
pdb <- read.pdb(pdbfile)

# Plot coarse grain network based on dynamically coupled communities
par(mfcol=c(1,2), mar=c(0,0,0,0))
plot.cna(net)

# Prune network
dnet <- prune.cna(net, edges.min = 1)
plot(dnet)

detach(hivp)

}
}
\keyword{ utility }

\name{pdbs2pdb}
\alias{pdbs2pdb}
\title{ PDBs to PDB Converter }
\description{
  Convert a list of PDBs from an \code{"pdbs"} object to a list of
  \code{pdb} objects. 
}
\usage{
pdbs2pdb(pdbs, inds = NULL, rm.gaps = FALSE, all.atom=FALSE, ncore=NULL)
}
\arguments{
  \item{pdbs}{ a list of class \code{"pdbs"} containing PDB file
    data, as obtained from \code{read.fasta.pdb},
    \code{pdbaln}, or \code{read.all}. }
  \item{inds}{ a vector of indices that selects the PDB structures to
    convert. }
  \item{rm.gaps}{ logical, if TRUE atoms in gap containing columns are
    removed in the output \code{pdb} objects. }
  \item{all.atom}{ logical, if TRUE all atom data are converted (the 
    \sQuote{pdbs} object must be obtained from \code{read.all} or 
    \code{pdbs$id} refers to existing PDB files). }
  \item{ncore}{ number of CPU cores used to do the calculation. }
}
\details{
  This function will generate a list of \code{pdb} objects from a
  \code{"pdbs"} class.

  See examples for more details/
}
\value{
  Returns a list of \code{pdb} objects.
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Lars Skjaerven }
\seealso{ \code{\link{read.pdb}}, \code{\link{pdbaln}},
  \code{\link{read.fasta.pdb}}. }
\examples{
\dontrun{
## Fetch PDBs
pdb.ids <- c("1YX5_B", "3NOB", "1P3Q_U")
#outdir <- paste(tempdir(), "/raw_pdbs", sep="")
outdir = "raw_pdbs"
raw.files <- get.pdb(pdb.ids, path = outdir)

## Split PDBs by chain ID and multi-model records
all.files <- pdbsplit(raw.files, pdb.ids, 
                path =paste(outdir, "/split_chain", sep=""))

## Align and fit
pdbs     <- pdbaln(all.files, fit=TRUE)

## Convert back to PDB objects
all.pdbs <- pdbs2pdb(pdbs)

## Access the first PDB object
## all.pdbs[[1]]

## Return PDB objects consisting of only
## atoms in non-gap positions
all.pdbs <- pdbs2pdb(pdbs, rm.gaps=TRUE)

}
}
\keyword{ utilities }

\name{is.pdb}
\alias{is.pdb}
\alias{is.pdbs}
\title{ Is an Object of Class \sQuote{pdb(s)}?  }
\description{
  Checks whether its argument is an object of class \sQuote{pdb} or \sQuote{pdbs}.
}
\usage{
  is.pdb(x)
  is.pdbs(x)
}
\arguments{
  \item{x}{ an R object. }
}
\details{
  Tests if the object \sQuote{x} is of class \sQuote{pdb}
  (\code{is.pdb}) or \sQuote{pdbs} (\code{is.pdbs}), i.e. if \sQuote{x} has a
  \dQuote{class} attribute equal to \code{pdb} or \code{pdbs}.
}
\value{
  TRUE if x is an object of class \sQuote{pdb(s)} and FALSE otherwise
}

\seealso{
  \code{\link{read.pdb}}, \code{\link{read.fasta.pdb}},
  \code{\link{pdbaln}}
}
\examples{
# Read a PDB file
pdb <- read.pdb( system.file("examples/1hel.pdb", package="bio3d") )
is.pdb(pdb)
}
\keyword{ classes }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.matrix.loadings.R
\name{plot.matrix.loadings}
\alias{plot.matrix.loadings}
\title{Plot Residue-Residue Matrix Loadings}
\usage{
\method{plot}{matrix.loadings}(x, pc = 1, resno = NULL, sse = NULL,
  mask.n = 0, plot = TRUE, ...)
}
\arguments{
\item{x}{the results of PCA as obtained from \code{\link{pca.array}}.}

\item{pc}{the principal component along which the loadings will be shown.}

\item{resno}{numerical vector or \sQuote{pdb} object as obtained from \code{\link{read.pdb}}
to show residue number on the x- and y-axis.}

\item{sse}{a \sQuote{sse} object as obtained from \code{\link{dssp}} or \code{\link{stride}}, 
or a \sQuote{pdb} object as obtained from \code{\link{read.pdb}} to show secondary
structural elements along x- and y-axis.}

\item{mask.n}{the number of elements from the diagonal to be masked from output.}

\item{plot}{logical, if FALSE no plot will be shown.}

\item{...}{additional arguments passed to \code{\link{plot.dccm}}.}
}
\value{
Plot and also returns a numeric matrix containing the loadings.
}
\description{
Plot residue-residue matrix loadings of a particular PC that is obtained from a 
principal component analysis (PCA) of cross-correlation or distance matrices.
}
\details{
The function plots loadings (the eigenvectors) of PCA performed on a set of matrices 
such as distance matrices from an ensemble of crystallographic structures 
and residue-residue cross-correlations or covariance matrices derived from 
ensemble NMA or MD simulation replicates (See \code{\link{pca.array}} for detail). 
Loadings are displayed as a matrix with dimension the same as the input matrices 
of the PCA. Each element of loadings represents the proportion that the corresponding 
residue pair contributes to the variance in a particular PC. The plot can be used 
to identify key regions that best explain the variance of underlying matrices.
}
\examples{
\dontrun{
   attach(transducin)
   gaps.res <- gap.inspect(pdbs$ali)
   sse <- pdbs$sse[1, gaps.res$f.inds]

   # calculate modes
   modes <- nma(pdbs, ncore=NULL)

   # calculate cross-correlation matrices from the modes
   cijs <- dccm(modes, ncore=NULL)$all.dccm

   # do PCA on cross-correlation matrices
   pc <- pca.array(cijs)

   # plot loadings
   l <- plot.matrix.loadings(pc, sse=sse)
   l[1:10, 1:10]

   # plot loadings with elements 10-residue separated from diagonal masked
   plot.matrix.loadings(pc, sse=sse, mask.n=10)

}
}
\author{
Xin-Qiu Yao
}
\references{
Skjaerven, L. et al. (2014) \emph{BMC Bioinformatics} \bold{15}, 399.
   Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\seealso{
\code{\link{plot.dccm}}, \code{\link{pca.array}}
}

\name{rmsd}
\alias{rmsd}
\title{ Root Mean Square Deviation }
\description{
  Calculate the RMSD between coordinate sets.
}
\usage{
rmsd(a, b=NULL, a.inds=NULL, b.inds=NULL, fit=FALSE, ncore=1, nseg.scale=1)
}
\arguments{
  \item{a}{ a numeric vector containing the reference coordinate set for
    comparison with the coordinates in \code{b}.  Alternatively, if
    \code{b=NULL} then \code{a} can be a matrix or list object
    containing multiple coordinates for pairwise comparison. }
  \item{b}{ a numeric vector, matrix or list object with an \code{xyz}
    component, containing one or more coordinate sets to be compared with
    \code{a}. }
  \item{a.inds }{ a vector of indices that selects the elements of
    \code{a} upon which the calculation should be based. }
  \item{b.inds }{ a vector of indices that selects the elements of
    \code{b} upon which the calculation should be based. }
  \item{fit }{logical, if TRUE coordinate superposition is performed
    prior to RMSD calculation. }  
  \item{ncore }{ number of CPU cores used to do the calculation.
    \code{ncore>1} requires package \sQuote{parallel} installed. } 
  \item{nseg.scale }{ split input data into specified number of segments
    prior to running multiple core calculation. See \code{\link{fit.xyz}}. }
}
\details{
  RMSD is a standard measure of structural distance between
  coordinate sets.

  Structure \code{a[a.inds]} and \code{b[b.inds]} should have the
  same length.

  A least-squares fit is performed prior to RMSD calculation by setting
  \code{fit=TRUE}.  See the function \code{fit.xyz} for more
  details of the fitting process. 
}
\value{
  Returns a numeric vector of RMSD value(s).
}
\references{
  Grant, B.J. et al. (2006) \emph{Bioinformatics} \bold{22}, 2695--2696.
}
\author{ Barry Grant }
\seealso{ \code{\link{fit.xyz}}, \code{\link{rot.lsq}},
  \code{\link{read.pdb}}, \code{\link{read.fasta.pdb}} }
\examples{
\donttest{
# Redundant testing excluded

# -- Calculate RMSD between two or more structures
aln <- read.fasta(system.file("examples/kif1a.fa",package="bio3d"))
pdbs <- read.fasta.pdb(aln)

# Gap positions
inds <- gap.inspect(pdbs$xyz)

# Superposition before pairwise RMSD 
rmsd(pdbs$xyz, fit=TRUE)

# RMSD between structure 1 and structures 2 and 3
rmsd(a=pdbs$xyz[1,], b=pdbs$xyz[2:3,], a.inds=inds$f.inds, b.inds=inds$f.inds, fit=TRUE)

# RMSD between structure 1 and all structures in alignment
rmsd(a=pdbs$xyz[1,], b=pdbs, a.inds=inds$f.inds, b.inds=inds$f.inds, fit=TRUE)

# RMSD without superposition
rmsd(pdbs$xyz)

}

}
\keyword{ utilities }
